# CrawlerApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getIpsAfterTimestamp**](CrawlerApi.md#getIpsAfterTimestamp) | **POST** /get_ips_after_timestamp | Retrieves ip addresses of peers that have connected after a given time. |
| [**getPeerCounts**](CrawlerApi.md#getPeerCounts) | **POST** /get_peer_counts | Retrieves aggregate information about peers. |


<a name="getIpsAfterTimestamp"></a>
# **getIpsAfterTimestamp**
> GetIpsAfterTimestamp200Response getIpsAfterTimestamp(getIpsAfterTimestampRequest)

Retrieves ip addresses of peers that have connected after a given time.

Retrieves ip addresses of peers that have connected after a given time.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CrawlerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    CrawlerApi apiInstance = new CrawlerApi(defaultClient);
    GetIpsAfterTimestampRequest getIpsAfterTimestampRequest = new GetIpsAfterTimestampRequest(); // GetIpsAfterTimestampRequest | Search criteria
    try {
      GetIpsAfterTimestamp200Response result = apiInstance.getIpsAfterTimestamp(getIpsAfterTimestampRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CrawlerApi#getIpsAfterTimestamp");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getIpsAfterTimestampRequest** | [**GetIpsAfterTimestampRequest**](GetIpsAfterTimestampRequest.md)| Search criteria | |

### Return type

[**GetIpsAfterTimestamp200Response**](GetIpsAfterTimestamp200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getPeerCounts"></a>
# **getPeerCounts**
> GetPeerCounts200Response getPeerCounts(body)

Retrieves aggregate information about peers.

Retrieves aggregate information about peers.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CrawlerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    CrawlerApi apiInstance = new CrawlerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetPeerCounts200Response result = apiInstance.getPeerCounts(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CrawlerApi#getPeerCounts");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetPeerCounts200Response**](GetPeerCounts200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

