/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The crawler uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetPeerCounts200ResponseAllOfPeerCounts
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:33:44.305253200-04:00[America/New_York]")
public class GetPeerCounts200ResponseAllOfPeerCounts {
  public static final String SERIALIZED_NAME_TOTAL_LAST5_DAYS = "total_last_5_days";
  @SerializedName(SERIALIZED_NAME_TOTAL_LAST5_DAYS)
  private Integer totalLast5Days;

  public static final String SERIALIZED_NAME_RELIABLE_NODES = "reliable_nodes";
  @SerializedName(SERIALIZED_NAME_RELIABLE_NODES)
  private Integer reliableNodes;

  public static final String SERIALIZED_NAME_IPV4_LAST5_DAYS = "ipv4_last_5_days";
  @SerializedName(SERIALIZED_NAME_IPV4_LAST5_DAYS)
  private Integer ipv4Last5Days;

  public static final String SERIALIZED_NAME_IPV6_LAST5_DAYS = "ipv6_last_5_days";
  @SerializedName(SERIALIZED_NAME_IPV6_LAST5_DAYS)
  private Integer ipv6Last5Days;

  public static final String SERIALIZED_NAME_VERSIONS = "versions";
  @SerializedName(SERIALIZED_NAME_VERSIONS)
  private Map<String, Integer> versions = new HashMap<>();

  public GetPeerCounts200ResponseAllOfPeerCounts() {
  }

  public GetPeerCounts200ResponseAllOfPeerCounts totalLast5Days(Integer totalLast5Days) {
    
    this.totalLast5Days = totalLast5Days;
    return this;
  }

   /**
   * Get totalLast5Days
   * @return totalLast5Days
  **/
  @javax.annotation.Nullable

  public Integer getTotalLast5Days() {
    return totalLast5Days;
  }


  public void setTotalLast5Days(Integer totalLast5Days) {
    this.totalLast5Days = totalLast5Days;
  }


  public GetPeerCounts200ResponseAllOfPeerCounts reliableNodes(Integer reliableNodes) {
    
    this.reliableNodes = reliableNodes;
    return this;
  }

   /**
   * Get reliableNodes
   * @return reliableNodes
  **/
  @javax.annotation.Nullable

  public Integer getReliableNodes() {
    return reliableNodes;
  }


  public void setReliableNodes(Integer reliableNodes) {
    this.reliableNodes = reliableNodes;
  }


  public GetPeerCounts200ResponseAllOfPeerCounts ipv4Last5Days(Integer ipv4Last5Days) {
    
    this.ipv4Last5Days = ipv4Last5Days;
    return this;
  }

   /**
   * Get ipv4Last5Days
   * @return ipv4Last5Days
  **/
  @javax.annotation.Nullable

  public Integer getIpv4Last5Days() {
    return ipv4Last5Days;
  }


  public void setIpv4Last5Days(Integer ipv4Last5Days) {
    this.ipv4Last5Days = ipv4Last5Days;
  }


  public GetPeerCounts200ResponseAllOfPeerCounts ipv6Last5Days(Integer ipv6Last5Days) {
    
    this.ipv6Last5Days = ipv6Last5Days;
    return this;
  }

   /**
   * Get ipv6Last5Days
   * @return ipv6Last5Days
  **/
  @javax.annotation.Nullable

  public Integer getIpv6Last5Days() {
    return ipv6Last5Days;
  }


  public void setIpv6Last5Days(Integer ipv6Last5Days) {
    this.ipv6Last5Days = ipv6Last5Days;
  }


  public GetPeerCounts200ResponseAllOfPeerCounts versions(Map<String, Integer> versions) {
    
    this.versions = versions;
    return this;
  }

  public GetPeerCounts200ResponseAllOfPeerCounts putVersionsItem(String key, Integer versionsItem) {
    if (this.versions == null) {
      this.versions = new HashMap<>();
    }
    this.versions.put(key, versionsItem);
    return this;
  }

   /**
   * Get versions
   * @return versions
  **/
  @javax.annotation.Nullable

  public Map<String, Integer> getVersions() {
    return versions;
  }


  public void setVersions(Map<String, Integer> versions) {
    this.versions = versions;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetPeerCounts200ResponseAllOfPeerCounts getPeerCounts200ResponseAllOfPeerCounts = (GetPeerCounts200ResponseAllOfPeerCounts) o;
    return Objects.equals(this.totalLast5Days, getPeerCounts200ResponseAllOfPeerCounts.totalLast5Days) &&
        Objects.equals(this.reliableNodes, getPeerCounts200ResponseAllOfPeerCounts.reliableNodes) &&
        Objects.equals(this.ipv4Last5Days, getPeerCounts200ResponseAllOfPeerCounts.ipv4Last5Days) &&
        Objects.equals(this.ipv6Last5Days, getPeerCounts200ResponseAllOfPeerCounts.ipv6Last5Days) &&
        Objects.equals(this.versions, getPeerCounts200ResponseAllOfPeerCounts.versions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalLast5Days, reliableNodes, ipv4Last5Days, ipv6Last5Days, versions);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetPeerCounts200ResponseAllOfPeerCounts {\n");
    sb.append("    totalLast5Days: ").append(toIndentedString(totalLast5Days)).append("\n");
    sb.append("    reliableNodes: ").append(toIndentedString(reliableNodes)).append("\n");
    sb.append("    ipv4Last5Days: ").append(toIndentedString(ipv4Last5Days)).append("\n");
    sb.append("    ipv6Last5Days: ").append(toIndentedString(ipv6Last5Days)).append("\n");
    sb.append("    versions: ").append(toIndentedString(versions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("total_last_5_days");
    openapiFields.add("reliable_nodes");
    openapiFields.add("ipv4_last_5_days");
    openapiFields.add("ipv6_last_5_days");
    openapiFields.add("versions");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetPeerCounts200ResponseAllOfPeerCounts
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetPeerCounts200ResponseAllOfPeerCounts.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetPeerCounts200ResponseAllOfPeerCounts is not found in the empty JSON string", GetPeerCounts200ResponseAllOfPeerCounts.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetPeerCounts200ResponseAllOfPeerCounts.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetPeerCounts200ResponseAllOfPeerCounts` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetPeerCounts200ResponseAllOfPeerCounts.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetPeerCounts200ResponseAllOfPeerCounts' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetPeerCounts200ResponseAllOfPeerCounts> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetPeerCounts200ResponseAllOfPeerCounts.class));

       return (TypeAdapter<T>) new TypeAdapter<GetPeerCounts200ResponseAllOfPeerCounts>() {
           @Override
           public void write(JsonWriter out, GetPeerCounts200ResponseAllOfPeerCounts value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetPeerCounts200ResponseAllOfPeerCounts read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetPeerCounts200ResponseAllOfPeerCounts given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetPeerCounts200ResponseAllOfPeerCounts
  * @throws IOException if the JSON string is invalid with respect to GetPeerCounts200ResponseAllOfPeerCounts
  */
  public static GetPeerCounts200ResponseAllOfPeerCounts fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetPeerCounts200ResponseAllOfPeerCounts.class);
  }

 /**
  * Convert an instance of GetPeerCounts200ResponseAllOfPeerCounts to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

