# DaemonApi

All URIs are relative to *http://localhost*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**exit**](DaemonApi.md#exit) | **POST** /exit | Tells the daemon at the RPC endpoint to exit. |
| [**getStatus**](DaemonApi.md#getStatus) | **POST** /get_status | Indicator if the genesis block is intialized. |
| [**getVersion**](DaemonApi.md#getVersion) | **POST** /get_version | Get the installed version of chia at the endpoint. |
| [**isRunning**](DaemonApi.md#isRunning) | **POST** /is_running | Determines if the named service is running. |
| [**ping**](DaemonApi.md#ping) | **POST** /ping | Ping the daemon. |
| [**registerService**](DaemonApi.md#registerService) | **POST** /register_service | Registers this daemon to receive messages. |
| [**startService**](DaemonApi.md#startService) | **POST** /start_service | Starts the named service. |
| [**stopService**](DaemonApi.md#stopService) | **POST** /stop_service | Stops the named service. |


<a name="exit"></a>
# **exit**
> ModelApiResponse exit(body)

Tells the daemon at the RPC endpoint to exit.

Tells the daemon at the RPC endpoint to exit. There isn&#39;t a way to start the daemon remotely via RPC, so take care that you have access to the RPC host if needed.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.exit(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#exit");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="getStatus"></a>
# **getStatus**
> GetStatus200Response getStatus(body)

Indicator if the genesis block is intialized.

Indicator if the genesis block is intialized.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetStatus200Response result = apiInstance.getStatus(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#getStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetStatus200Response**](GetStatus200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getVersion"></a>
# **getVersion**
> GetVersion200Response getVersion(body)

Get the installed version of chia at the endpoint.

Get the installed version of chia at the endpoint.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetVersion200Response result = apiInstance.getVersion(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#getVersion");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetVersion200Response**](GetVersion200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="isRunning"></a>
# **isRunning**
> IsRunning200Response isRunning(registerServiceRequest)

Determines if the named service is running.

Determines if the named service is running.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    RegisterServiceRequest registerServiceRequest = new RegisterServiceRequest(); // RegisterServiceRequest | Request body with the name of a service
    try {
      IsRunning200Response result = apiInstance.isRunning(registerServiceRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#isRunning");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **registerServiceRequest** | [**RegisterServiceRequest**](RegisterServiceRequest.md)| Request body with the name of a service | |

### Return type

[**IsRunning200Response**](IsRunning200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="ping"></a>
# **ping**
> ModelApiResponse ping(body)

Ping the daemon.

Ping the daemon.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.ping(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#ping");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="registerService"></a>
# **registerService**
> RegisterService200Response registerService(registerServiceRequest)

Registers this daemon to receive messages.

Registers this daemon to receive messages. This is needed to receive responses from services other than the daemon.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    RegisterServiceRequest registerServiceRequest = new RegisterServiceRequest(); // RegisterServiceRequest | Request body with the name of a service
    try {
      RegisterService200Response result = apiInstance.registerService(registerServiceRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#registerService");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **registerServiceRequest** | [**RegisterServiceRequest**](RegisterServiceRequest.md)| Request body with the name of a service | |

### Return type

[**RegisterService200Response**](RegisterService200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="startService"></a>
# **startService**
> ModelApiResponse startService(registerServiceRequest)

Starts the named service.

Starts the named service.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    RegisterServiceRequest registerServiceRequest = new RegisterServiceRequest(); // RegisterServiceRequest | Request body with the name of a service
    try {
      ModelApiResponse result = apiInstance.startService(registerServiceRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#startService");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **registerServiceRequest** | [**RegisterServiceRequest**](RegisterServiceRequest.md)| Request body with the name of a service | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="stopService"></a>
# **stopService**
> ModelApiResponse stopService(registerServiceRequest)

Stops the named service.

Stops the named service.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DaemonApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    DaemonApi apiInstance = new DaemonApi(defaultClient);
    RegisterServiceRequest registerServiceRequest = new RegisterServiceRequest(); // RegisterServiceRequest | Request body with the name of a service
    try {
      ModelApiResponse result = apiInstance.stopService(registerServiceRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DaemonApi#stopService");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **registerServiceRequest** | [**RegisterServiceRequest**](RegisterServiceRequest.md)| Request body with the name of a service | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

