# KeyRingApi

All URIs are relative to *http://localhost*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**addPrivateKey**](KeyRingApi.md#addPrivateKey) | **POST** /add_private_key | Adds a private key to the keychain. |
| [**checkKeys**](KeyRingApi.md#checkKeys) | **POST** /check_keys | Check the keys. |
| [**daemonDeleteAllKeys**](KeyRingApi.md#daemonDeleteAllKeys) | **POST** /delete_all_keys | Deletes all keys from the keychain. |
| [**deleteKeyByFingerprint**](KeyRingApi.md#deleteKeyByFingerprint) | **POST** /delete_key_by_fingerprint | Deletes all keys which have the given public key fingerprint. |
| [**getAllPrivateKeys**](KeyRingApi.md#getAllPrivateKeys) | **POST** /get_all_private_keys | Returns all private keys which can be retrieved, with the given passphrases. |
| [**getFirstPrivateKey**](KeyRingApi.md#getFirstPrivateKey) | **POST** /get_first_private_key | Returns the first key in the keychain. |
| [**getKeyForFingerprint**](KeyRingApi.md#getKeyForFingerprint) | **POST** /get_key_for_fingerprint | Locates and returns a private key matching the provided fingerprint. |
| [**isKeyringLocked**](KeyRingApi.md#isKeyringLocked) | **POST** /is_keyring_locked | Returns whether the keyring is in a locked state. |
| [**keyringStatus**](KeyRingApi.md#keyringStatus) | **POST** /keyring_status | Get detailed status of the key ring. |
| [**migrateKeyring**](KeyRingApi.md#migrateKeyring) | **POST** /migrate_keyring | Migrate from key phrase to key ring. |
| [**removeKeyringPassphrase**](KeyRingApi.md#removeKeyringPassphrase) | **POST** /remove_keyring_passphrase | Remove the key ring passphrase. |
| [**setKeyringPassphrase**](KeyRingApi.md#setKeyringPassphrase) | **POST** /set_keyring_passphrase | Update the key ring passphrase. |
| [**unlockKeyring**](KeyRingApi.md#unlockKeyring) | **POST** /unlock_keyring | Unlock the keyring. |
| [**validateKeyringPassphrase**](KeyRingApi.md#validateKeyringPassphrase) | **POST** /validate_keyring_passphrase | Test the validity of a passphrase. |


<a name="addPrivateKey"></a>
# **addPrivateKey**
> AddPrivateKey200Response addPrivateKey(addPrivateKeyRequest)

Adds a private key to the keychain.

Adds a private key to the keychain, with the given entropy and passphrase. The keychain itself will store the public key, and the entropy bytes, but not the passphrase.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    AddPrivateKeyRequest addPrivateKeyRequest = new AddPrivateKeyRequest(); // AddPrivateKeyRequest | The private key
    try {
      AddPrivateKey200Response result = apiInstance.addPrivateKey(addPrivateKeyRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#addPrivateKey");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **addPrivateKeyRequest** | [**AddPrivateKeyRequest**](AddPrivateKeyRequest.md)| The private key | |

### Return type

[**AddPrivateKey200Response**](AddPrivateKey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="checkKeys"></a>
# **checkKeys**
> AddPrivateKey200Response checkKeys(checkKeysRequest)

Check the keys.

Check the keys.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    CheckKeysRequest checkKeysRequest = new CheckKeysRequest(); // CheckKeysRequest | The config root path
    try {
      AddPrivateKey200Response result = apiInstance.checkKeys(checkKeysRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#checkKeys");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **checkKeysRequest** | [**CheckKeysRequest**](CheckKeysRequest.md)| The config root path | |

### Return type

[**AddPrivateKey200Response**](AddPrivateKey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="daemonDeleteAllKeys"></a>
# **daemonDeleteAllKeys**
> ModelApiResponse daemonDeleteAllKeys(body)

Deletes all keys from the keychain.

Deletes all keys from the keychain.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.daemonDeleteAllKeys(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#daemonDeleteAllKeys");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="deleteKeyByFingerprint"></a>
# **deleteKeyByFingerprint**
> AddPrivateKey200Response deleteKeyByFingerprint(deleteKeyByFingerprintRequest)

Deletes all keys which have the given public key fingerprint.

Deletes all keys which have the given public key fingerprint.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest = new DeleteKeyByFingerprintRequest(); // DeleteKeyByFingerprintRequest | The fingerprint
    try {
      AddPrivateKey200Response result = apiInstance.deleteKeyByFingerprint(deleteKeyByFingerprintRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#deleteKeyByFingerprint");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deleteKeyByFingerprintRequest** | [**DeleteKeyByFingerprintRequest**](DeleteKeyByFingerprintRequest.md)| The fingerprint | |

### Return type

[**AddPrivateKey200Response**](AddPrivateKey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="getAllPrivateKeys"></a>
# **getAllPrivateKeys**
> GetAllPrivateKeys200Response getAllPrivateKeys(body)

Returns all private keys which can be retrieved, with the given passphrases.

Returns all private keys which can be retrieved, with the given passphrases. A tuple of key, and entropy bytes (i.e. mnemonic) is returned for each key.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetAllPrivateKeys200Response result = apiInstance.getAllPrivateKeys(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#getAllPrivateKeys");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetAllPrivateKeys200Response**](GetAllPrivateKeys200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getFirstPrivateKey"></a>
# **getFirstPrivateKey**
> GetFirstPrivateKey200Response getFirstPrivateKey(body)

Returns the first key in the keychain.

Returns the first key in the keychain.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetFirstPrivateKey200Response result = apiInstance.getFirstPrivateKey(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#getFirstPrivateKey");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetFirstPrivateKey200Response**](GetFirstPrivateKey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getKeyForFingerprint"></a>
# **getKeyForFingerprint**
> GetFirstPrivateKey200Response getKeyForFingerprint(deleteKeyByFingerprintRequest)

Locates and returns a private key matching the provided fingerprint.

Locates and returns a private key matching the provided fingerprint.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest = new DeleteKeyByFingerprintRequest(); // DeleteKeyByFingerprintRequest | The fingerprint
    try {
      GetFirstPrivateKey200Response result = apiInstance.getKeyForFingerprint(deleteKeyByFingerprintRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#getKeyForFingerprint");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deleteKeyByFingerprintRequest** | [**DeleteKeyByFingerprintRequest**](DeleteKeyByFingerprintRequest.md)| The fingerprint | |

### Return type

[**GetFirstPrivateKey200Response**](GetFirstPrivateKey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="isKeyringLocked"></a>
# **isKeyringLocked**
> IsKeyringLocked200Response isKeyringLocked(body)

Returns whether the keyring is in a locked state.

Returns whether the keyring is in a locked state. If the keyring doesn&#39;t have a master passphrase set, or if a master passphrase is set and the cached passphrase is valid, the keyring is \&quot;unlocked\&quot;.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      IsKeyringLocked200Response result = apiInstance.isKeyringLocked(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#isKeyringLocked");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**IsKeyringLocked200Response**](IsKeyringLocked200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="keyringStatus"></a>
# **keyringStatus**
> KeyringStatus200Response keyringStatus(body)

Get detailed status of the key ring.

Get detailed status of the key ring.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      KeyringStatus200Response result = apiInstance.keyringStatus(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#keyringStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**KeyringStatus200Response**](KeyringStatus200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="migrateKeyring"></a>
# **migrateKeyring**
> ModelApiResponse migrateKeyring(migrateKeyringRequest)

Migrate from key phrase to key ring.

Migrate from key phrase to key ring.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    MigrateKeyringRequest migrateKeyringRequest = new MigrateKeyringRequest(); // MigrateKeyringRequest | The migration options
    try {
      ModelApiResponse result = apiInstance.migrateKeyring(migrateKeyringRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#migrateKeyring");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **migrateKeyringRequest** | [**MigrateKeyringRequest**](MigrateKeyringRequest.md)| The migration options | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="removeKeyringPassphrase"></a>
# **removeKeyringPassphrase**
> ModelApiResponse removeKeyringPassphrase(removeKeyringPassphraseRequest)

Remove the key ring passphrase.

Remove the key ring passphrase.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest = new RemoveKeyringPassphraseRequest(); // RemoveKeyringPassphraseRequest | The passphrase
    try {
      ModelApiResponse result = apiInstance.removeKeyringPassphrase(removeKeyringPassphraseRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#removeKeyringPassphrase");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **removeKeyringPassphraseRequest** | [**RemoveKeyringPassphraseRequest**](RemoveKeyringPassphraseRequest.md)| The passphrase | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="setKeyringPassphrase"></a>
# **setKeyringPassphrase**
> ModelApiResponse setKeyringPassphrase(setKeyringPassphraseRequest)

Update the key ring passphrase.

Update the key ring passphrase.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    SetKeyringPassphraseRequest setKeyringPassphraseRequest = new SetKeyringPassphraseRequest(); // SetKeyringPassphraseRequest | The passphrase options
    try {
      ModelApiResponse result = apiInstance.setKeyringPassphrase(setKeyringPassphraseRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#setKeyringPassphrase");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **setKeyringPassphraseRequest** | [**SetKeyringPassphraseRequest**](SetKeyringPassphraseRequest.md)| The passphrase options | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="unlockKeyring"></a>
# **unlockKeyring**
> ModelApiResponse unlockKeyring(unlockKeyringRequest)

Unlock the keyring.

Unlock the keyring.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    UnlockKeyringRequest unlockKeyringRequest = new UnlockKeyringRequest(); // UnlockKeyringRequest | Key ring key
    try {
      ModelApiResponse result = apiInstance.unlockKeyring(unlockKeyringRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#unlockKeyring");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **unlockKeyringRequest** | [**UnlockKeyringRequest**](UnlockKeyringRequest.md)| Key ring key | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="validateKeyringPassphrase"></a>
# **validateKeyringPassphrase**
> ModelApiResponse validateKeyringPassphrase(unlockKeyringRequest)

Test the validity of a passphrase.

Test the validity of a passphrase.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.KeyRingApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    KeyRingApi apiInstance = new KeyRingApi(defaultClient);
    UnlockKeyringRequest unlockKeyringRequest = new UnlockKeyringRequest(); // UnlockKeyringRequest | The passphrase
    try {
      ModelApiResponse result = apiInstance.validateKeyringPassphrase(unlockKeyringRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling KeyRingApi#validateKeyringPassphrase");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **unlockKeyringRequest** | [**UnlockKeyringRequest**](UnlockKeyringRequest.md)| The passphrase | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

