# PlotterApi

All URIs are relative to *http://localhost*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getPlotters**](PlotterApi.md#getPlotters) | **POST** /get_plotters | Get info about installed and installable plotters. |
| [**startPlotting**](PlotterApi.md#startPlotting) | **POST** /start_plotting | Starts plotting. |
| [**stopPlotting**](PlotterApi.md#stopPlotting) | **POST** /stop_plotting | Stops the plot with the given id. |


<a name="getPlotters"></a>
# **getPlotters**
> GetPlotters200Response getPlotters(body)

Get info about installed and installable plotters.

Get info about installed and installable plotters.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PlotterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    PlotterApi apiInstance = new PlotterApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetPlotters200Response result = apiInstance.getPlotters(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PlotterApi#getPlotters");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetPlotters200Response**](GetPlotters200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="startPlotting"></a>
# **startPlotting**
> StartPlotting200Response startPlotting(plotterConfig)

Starts plotting.

Starts plotting. Returns after request is added to the plotting queue. Does not wait for plotting to finish.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PlotterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    PlotterApi apiInstance = new PlotterApi(defaultClient);
    PlotterConfig plotterConfig = new PlotterConfig(); // PlotterConfig | Options for creating the plots
    try {
      StartPlotting200Response result = apiInstance.startPlotting(plotterConfig);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PlotterApi#startPlotting");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **plotterConfig** | [**PlotterConfig**](PlotterConfig.md)| Options for creating the plots | |

### Return type

[**StartPlotting200Response**](StartPlotting200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="stopPlotting"></a>
# **stopPlotting**
> ModelApiResponse stopPlotting(stopPlottingRequest)

Stops the plot with the given id.

Stops the plot with the given id.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PlotterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("http://localhost");
    

    PlotterApi apiInstance = new PlotterApi(defaultClient);
    StopPlottingRequest stopPlottingRequest = new StopPlottingRequest(); // StopPlottingRequest | The id of the plot to stop
    try {
      ModelApiResponse result = apiInstance.stopPlotting(stopPlottingRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PlotterApi#stopPlotting");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **stopPlottingRequest** | [**StopPlottingRequest**](StopPlottingRequest.md)| The id of the plot to stop | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

