

# PlotterConfig


## Properties

| Name | Type | Description | Notes |
|------------ | ------------- | ------------- | -------------|
|**delay** | **Integer** | The number of seconds to delay before beginning the plotting. |  [optional] |
|**parallel** | **Boolean** |  |  [optional] |
|**n** | **Integer** | The number of plots that will be made, in sequence. |  [optional] |
|**k** | **KSize** |  |  [optional] |
|**queue** | **String** |  |  [optional] |
|**t** | **String** | Define the temporary directory for plot creation. This is where Plotting  Phase 1 (Forward Propagation) and Phase 2 (Backpropagation) both occur.  The -t dir requires the largest working space: normally about 2.5 times the size of the final plot.  |  [optional] |
|**t2** | **String** | Define a secondary temporary directory for plot creation. This is where Plotting Phase 3 (Compression) and Phase 4 (Checkpoints) occur. |  [optional] |
|**d** | **String** | Define the final location for plot(s). Of course, -d should have enough free space as the final size of the plot. This directory is automatically added to your ~/.chia/VERSION/config/config.yaml file. |  [optional] |
|**b** | **Integer** | Define memory/RAM usage. Default is 4608 (4.6 GiB). More RAM will marginally increase speed of plot creation. Please bear in mind that this is what is allocated to the plotting algorithm alone. Code, container, libraries etc. will require additional RAM from your system. |  [optional] |
|**u** | **Integer** | More buckets require less RAM but more random seeks to disk. With spinning disks you want less buckets and with NVMe more buckets. There is no significant benefit from using smaller buckets - just use 128 |  [optional] |
|**a** | **Integer** | This is the key Fingerprint used to select both the Farmer and Pool Public Keys to use. Utilize this when you want to select one key out of several in your keychain. |  [optional] |
|**c** | **String** | The pool contract address. |  [optional] |
|**p** | **String** | This is your \&quot;Pool Public Key\&quot;. Utilise this when you want to create plots on other machines for which you do not want to give full chia account access. |  [optional] |
|**f** | **String** | This is your \&quot;Farmer Public Key\&quot;. Utilise this when you want to create plots on other machines for which you do not want to give full chia account access |  [optional] |
|**memo** | **String** |  |  [optional] |
|**e** | **Boolean** | Setting to true will disable the bitfield plotting algorithm, and revert back to the older b17 plotting style. After 1.0.4 it&#39;s better to use bitfield for most cases |  [optional] |
|**r** | **Integer** | The number of threads to devote to each plot. |  [optional] |
|**x** | **Boolean** | Skips adding [final dir] to harvester for farming. |  [optional] |
|**overrideK** | **Boolean** | Only needed when k is set to 25 |  [optional] |
|**w** | **Boolean** | BladeBit Only - warm start |  [optional] |
|**m** | **Boolean** | BladeBit Only - disable NUMA |  [optional] |
|**K** | **Boolean** | MadMax Only - note upper case - Thread multiplier for phase 2 |  [optional] |
|**G** | **Boolean** | MadMax Only - note upper case - Alternate tmpdir/tmp2dir |  [optional] |



