/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.AddPrivateKey200Response;
import org.openapitools.client.model.AddPrivateKeyRequest;
import org.openapitools.client.model.CheckKeysRequest;
import org.openapitools.client.model.DeleteKeyByFingerprintRequest;
import org.openapitools.client.model.GetAllPrivateKeys200Response;
import org.openapitools.client.model.GetFirstPrivateKey200Response;
import org.openapitools.client.model.IsKeyringLocked200Response;
import org.openapitools.client.model.KeyringStatus200Response;
import org.openapitools.client.model.MigrateKeyringRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.RemoveKeyringPassphraseRequest;
import org.openapitools.client.model.SetKeyringPassphraseRequest;
import org.openapitools.client.model.UnlockKeyringRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class KeyRingApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public KeyRingApi() {
        this(Configuration.getDefaultApiClient());
    }

    public KeyRingApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for addPrivateKey
     * @param addPrivateKeyRequest The private key (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addPrivateKeyCall(AddPrivateKeyRequest addPrivateKeyRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = addPrivateKeyRequest;

        // create path and map variables
        String localVarPath = "/add_private_key";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call addPrivateKeyValidateBeforeCall(AddPrivateKeyRequest addPrivateKeyRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'addPrivateKeyRequest' is set
        if (addPrivateKeyRequest == null) {
            throw new ApiException("Missing the required parameter 'addPrivateKeyRequest' when calling addPrivateKey(Async)");
        }

        return addPrivateKeyCall(addPrivateKeyRequest, _callback);

    }

    /**
     * Adds a private key to the keychain.
     * Adds a private key to the keychain, with the given entropy and passphrase. The keychain itself will store the public key, and the entropy bytes, but not the passphrase.
     * @param addPrivateKeyRequest The private key (required)
     * @return AddPrivateKey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public AddPrivateKey200Response addPrivateKey(AddPrivateKeyRequest addPrivateKeyRequest) throws ApiException {
        ApiResponse<AddPrivateKey200Response> localVarResp = addPrivateKeyWithHttpInfo(addPrivateKeyRequest);
        return localVarResp.getData();
    }

    /**
     * Adds a private key to the keychain.
     * Adds a private key to the keychain, with the given entropy and passphrase. The keychain itself will store the public key, and the entropy bytes, but not the passphrase.
     * @param addPrivateKeyRequest The private key (required)
     * @return ApiResponse&lt;AddPrivateKey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<AddPrivateKey200Response> addPrivateKeyWithHttpInfo(AddPrivateKeyRequest addPrivateKeyRequest) throws ApiException {
        okhttp3.Call localVarCall = addPrivateKeyValidateBeforeCall(addPrivateKeyRequest, null);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Adds a private key to the keychain. (asynchronously)
     * Adds a private key to the keychain, with the given entropy and passphrase. The keychain itself will store the public key, and the entropy bytes, but not the passphrase.
     * @param addPrivateKeyRequest The private key (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addPrivateKeyAsync(AddPrivateKeyRequest addPrivateKeyRequest, final ApiCallback<AddPrivateKey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = addPrivateKeyValidateBeforeCall(addPrivateKeyRequest, _callback);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for checkKeys
     * @param checkKeysRequest The config root path (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call checkKeysCall(CheckKeysRequest checkKeysRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = checkKeysRequest;

        // create path and map variables
        String localVarPath = "/check_keys";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call checkKeysValidateBeforeCall(CheckKeysRequest checkKeysRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'checkKeysRequest' is set
        if (checkKeysRequest == null) {
            throw new ApiException("Missing the required parameter 'checkKeysRequest' when calling checkKeys(Async)");
        }

        return checkKeysCall(checkKeysRequest, _callback);

    }

    /**
     * Check the keys.
     * Check the keys.
     * @param checkKeysRequest The config root path (required)
     * @return AddPrivateKey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public AddPrivateKey200Response checkKeys(CheckKeysRequest checkKeysRequest) throws ApiException {
        ApiResponse<AddPrivateKey200Response> localVarResp = checkKeysWithHttpInfo(checkKeysRequest);
        return localVarResp.getData();
    }

    /**
     * Check the keys.
     * Check the keys.
     * @param checkKeysRequest The config root path (required)
     * @return ApiResponse&lt;AddPrivateKey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<AddPrivateKey200Response> checkKeysWithHttpInfo(CheckKeysRequest checkKeysRequest) throws ApiException {
        okhttp3.Call localVarCall = checkKeysValidateBeforeCall(checkKeysRequest, null);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Check the keys. (asynchronously)
     * Check the keys.
     * @param checkKeysRequest The config root path (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call checkKeysAsync(CheckKeysRequest checkKeysRequest, final ApiCallback<AddPrivateKey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = checkKeysValidateBeforeCall(checkKeysRequest, _callback);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for daemonDeleteAllKeys
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call daemonDeleteAllKeysCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/delete_all_keys";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call daemonDeleteAllKeysValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling daemonDeleteAllKeys(Async)");
        }

        return daemonDeleteAllKeysCall(body, _callback);

    }

    /**
     * Deletes all keys from the keychain.
     * Deletes all keys from the keychain.
     * @param body Empty request body (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse daemonDeleteAllKeys(Object body) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = daemonDeleteAllKeysWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Deletes all keys from the keychain.
     * Deletes all keys from the keychain.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> daemonDeleteAllKeysWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = daemonDeleteAllKeysValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Deletes all keys from the keychain. (asynchronously)
     * Deletes all keys from the keychain.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call daemonDeleteAllKeysAsync(Object body, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = daemonDeleteAllKeysValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteKeyByFingerprint
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteKeyByFingerprintCall(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = deleteKeyByFingerprintRequest;

        // create path and map variables
        String localVarPath = "/delete_key_by_fingerprint";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteKeyByFingerprintValidateBeforeCall(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'deleteKeyByFingerprintRequest' is set
        if (deleteKeyByFingerprintRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteKeyByFingerprintRequest' when calling deleteKeyByFingerprint(Async)");
        }

        return deleteKeyByFingerprintCall(deleteKeyByFingerprintRequest, _callback);

    }

    /**
     * Deletes all keys which have the given public key fingerprint.
     * Deletes all keys which have the given public key fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @return AddPrivateKey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public AddPrivateKey200Response deleteKeyByFingerprint(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest) throws ApiException {
        ApiResponse<AddPrivateKey200Response> localVarResp = deleteKeyByFingerprintWithHttpInfo(deleteKeyByFingerprintRequest);
        return localVarResp.getData();
    }

    /**
     * Deletes all keys which have the given public key fingerprint.
     * Deletes all keys which have the given public key fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @return ApiResponse&lt;AddPrivateKey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<AddPrivateKey200Response> deleteKeyByFingerprintWithHttpInfo(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest) throws ApiException {
        okhttp3.Call localVarCall = deleteKeyByFingerprintValidateBeforeCall(deleteKeyByFingerprintRequest, null);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Deletes all keys which have the given public key fingerprint. (asynchronously)
     * Deletes all keys which have the given public key fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteKeyByFingerprintAsync(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback<AddPrivateKey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteKeyByFingerprintValidateBeforeCall(deleteKeyByFingerprintRequest, _callback);
        Type localVarReturnType = new TypeToken<AddPrivateKey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getAllPrivateKeys
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAllPrivateKeysCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_all_private_keys";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getAllPrivateKeysValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getAllPrivateKeys(Async)");
        }

        return getAllPrivateKeysCall(body, _callback);

    }

    /**
     * Returns all private keys which can be retrieved, with the given passphrases.
     * Returns all private keys which can be retrieved, with the given passphrases. A tuple of key, and entropy bytes (i.e. mnemonic) is returned for each key.
     * @param body Empty request body (required)
     * @return GetAllPrivateKeys200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetAllPrivateKeys200Response getAllPrivateKeys(Object body) throws ApiException {
        ApiResponse<GetAllPrivateKeys200Response> localVarResp = getAllPrivateKeysWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Returns all private keys which can be retrieved, with the given passphrases.
     * Returns all private keys which can be retrieved, with the given passphrases. A tuple of key, and entropy bytes (i.e. mnemonic) is returned for each key.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetAllPrivateKeys200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetAllPrivateKeys200Response> getAllPrivateKeysWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getAllPrivateKeysValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetAllPrivateKeys200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Returns all private keys which can be retrieved, with the given passphrases. (asynchronously)
     * Returns all private keys which can be retrieved, with the given passphrases. A tuple of key, and entropy bytes (i.e. mnemonic) is returned for each key.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAllPrivateKeysAsync(Object body, final ApiCallback<GetAllPrivateKeys200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getAllPrivateKeysValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetAllPrivateKeys200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getFirstPrivateKey
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getFirstPrivateKeyCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_first_private_key";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getFirstPrivateKeyValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getFirstPrivateKey(Async)");
        }

        return getFirstPrivateKeyCall(body, _callback);

    }

    /**
     * Returns the first key in the keychain.
     * Returns the first key in the keychain.
     * @param body Empty request body (required)
     * @return GetFirstPrivateKey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetFirstPrivateKey200Response getFirstPrivateKey(Object body) throws ApiException {
        ApiResponse<GetFirstPrivateKey200Response> localVarResp = getFirstPrivateKeyWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Returns the first key in the keychain.
     * Returns the first key in the keychain.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetFirstPrivateKey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetFirstPrivateKey200Response> getFirstPrivateKeyWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getFirstPrivateKeyValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetFirstPrivateKey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Returns the first key in the keychain. (asynchronously)
     * Returns the first key in the keychain.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getFirstPrivateKeyAsync(Object body, final ApiCallback<GetFirstPrivateKey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getFirstPrivateKeyValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetFirstPrivateKey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getKeyForFingerprint
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeyForFingerprintCall(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = deleteKeyByFingerprintRequest;

        // create path and map variables
        String localVarPath = "/get_key_for_fingerprint";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getKeyForFingerprintValidateBeforeCall(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'deleteKeyByFingerprintRequest' is set
        if (deleteKeyByFingerprintRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteKeyByFingerprintRequest' when calling getKeyForFingerprint(Async)");
        }

        return getKeyForFingerprintCall(deleteKeyByFingerprintRequest, _callback);

    }

    /**
     * Locates and returns a private key matching the provided fingerprint.
     * Locates and returns a private key matching the provided fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @return GetFirstPrivateKey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetFirstPrivateKey200Response getKeyForFingerprint(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest) throws ApiException {
        ApiResponse<GetFirstPrivateKey200Response> localVarResp = getKeyForFingerprintWithHttpInfo(deleteKeyByFingerprintRequest);
        return localVarResp.getData();
    }

    /**
     * Locates and returns a private key matching the provided fingerprint.
     * Locates and returns a private key matching the provided fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @return ApiResponse&lt;GetFirstPrivateKey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetFirstPrivateKey200Response> getKeyForFingerprintWithHttpInfo(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest) throws ApiException {
        okhttp3.Call localVarCall = getKeyForFingerprintValidateBeforeCall(deleteKeyByFingerprintRequest, null);
        Type localVarReturnType = new TypeToken<GetFirstPrivateKey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Locates and returns a private key matching the provided fingerprint. (asynchronously)
     * Locates and returns a private key matching the provided fingerprint.
     * @param deleteKeyByFingerprintRequest The fingerprint (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeyForFingerprintAsync(DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest, final ApiCallback<GetFirstPrivateKey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getKeyForFingerprintValidateBeforeCall(deleteKeyByFingerprintRequest, _callback);
        Type localVarReturnType = new TypeToken<GetFirstPrivateKey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for isKeyringLocked
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call isKeyringLockedCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/is_keyring_locked";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call isKeyringLockedValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling isKeyringLocked(Async)");
        }

        return isKeyringLockedCall(body, _callback);

    }

    /**
     * Returns whether the keyring is in a locked state.
     * Returns whether the keyring is in a locked state. If the keyring doesn&#39;t have a master passphrase set, or if a master passphrase is set and the cached passphrase is valid, the keyring is \&quot;unlocked\&quot;.
     * @param body Empty request body (required)
     * @return IsKeyringLocked200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public IsKeyringLocked200Response isKeyringLocked(Object body) throws ApiException {
        ApiResponse<IsKeyringLocked200Response> localVarResp = isKeyringLockedWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Returns whether the keyring is in a locked state.
     * Returns whether the keyring is in a locked state. If the keyring doesn&#39;t have a master passphrase set, or if a master passphrase is set and the cached passphrase is valid, the keyring is \&quot;unlocked\&quot;.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;IsKeyringLocked200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<IsKeyringLocked200Response> isKeyringLockedWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = isKeyringLockedValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<IsKeyringLocked200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Returns whether the keyring is in a locked state. (asynchronously)
     * Returns whether the keyring is in a locked state. If the keyring doesn&#39;t have a master passphrase set, or if a master passphrase is set and the cached passphrase is valid, the keyring is \&quot;unlocked\&quot;.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call isKeyringLockedAsync(Object body, final ApiCallback<IsKeyringLocked200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = isKeyringLockedValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<IsKeyringLocked200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for keyringStatus
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call keyringStatusCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/keyring_status";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call keyringStatusValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling keyringStatus(Async)");
        }

        return keyringStatusCall(body, _callback);

    }

    /**
     * Get detailed status of the key ring.
     * Get detailed status of the key ring.
     * @param body Empty request body (required)
     * @return KeyringStatus200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public KeyringStatus200Response keyringStatus(Object body) throws ApiException {
        ApiResponse<KeyringStatus200Response> localVarResp = keyringStatusWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get detailed status of the key ring.
     * Get detailed status of the key ring.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;KeyringStatus200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<KeyringStatus200Response> keyringStatusWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = keyringStatusValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<KeyringStatus200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get detailed status of the key ring. (asynchronously)
     * Get detailed status of the key ring.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call keyringStatusAsync(Object body, final ApiCallback<KeyringStatus200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = keyringStatusValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<KeyringStatus200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for migrateKeyring
     * @param migrateKeyringRequest The migration options (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call migrateKeyringCall(MigrateKeyringRequest migrateKeyringRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = migrateKeyringRequest;

        // create path and map variables
        String localVarPath = "/migrate_keyring";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call migrateKeyringValidateBeforeCall(MigrateKeyringRequest migrateKeyringRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'migrateKeyringRequest' is set
        if (migrateKeyringRequest == null) {
            throw new ApiException("Missing the required parameter 'migrateKeyringRequest' when calling migrateKeyring(Async)");
        }

        return migrateKeyringCall(migrateKeyringRequest, _callback);

    }

    /**
     * Migrate from key phrase to key ring.
     * Migrate from key phrase to key ring.
     * @param migrateKeyringRequest The migration options (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse migrateKeyring(MigrateKeyringRequest migrateKeyringRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = migrateKeyringWithHttpInfo(migrateKeyringRequest);
        return localVarResp.getData();
    }

    /**
     * Migrate from key phrase to key ring.
     * Migrate from key phrase to key ring.
     * @param migrateKeyringRequest The migration options (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> migrateKeyringWithHttpInfo(MigrateKeyringRequest migrateKeyringRequest) throws ApiException {
        okhttp3.Call localVarCall = migrateKeyringValidateBeforeCall(migrateKeyringRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Migrate from key phrase to key ring. (asynchronously)
     * Migrate from key phrase to key ring.
     * @param migrateKeyringRequest The migration options (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call migrateKeyringAsync(MigrateKeyringRequest migrateKeyringRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = migrateKeyringValidateBeforeCall(migrateKeyringRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for removeKeyringPassphrase
     * @param removeKeyringPassphraseRequest The passphrase (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call removeKeyringPassphraseCall(RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = removeKeyringPassphraseRequest;

        // create path and map variables
        String localVarPath = "/remove_keyring_passphrase";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call removeKeyringPassphraseValidateBeforeCall(RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'removeKeyringPassphraseRequest' is set
        if (removeKeyringPassphraseRequest == null) {
            throw new ApiException("Missing the required parameter 'removeKeyringPassphraseRequest' when calling removeKeyringPassphrase(Async)");
        }

        return removeKeyringPassphraseCall(removeKeyringPassphraseRequest, _callback);

    }

    /**
     * Remove the key ring passphrase.
     * Remove the key ring passphrase.
     * @param removeKeyringPassphraseRequest The passphrase (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse removeKeyringPassphrase(RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = removeKeyringPassphraseWithHttpInfo(removeKeyringPassphraseRequest);
        return localVarResp.getData();
    }

    /**
     * Remove the key ring passphrase.
     * Remove the key ring passphrase.
     * @param removeKeyringPassphraseRequest The passphrase (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> removeKeyringPassphraseWithHttpInfo(RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest) throws ApiException {
        okhttp3.Call localVarCall = removeKeyringPassphraseValidateBeforeCall(removeKeyringPassphraseRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Remove the key ring passphrase. (asynchronously)
     * Remove the key ring passphrase.
     * @param removeKeyringPassphraseRequest The passphrase (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call removeKeyringPassphraseAsync(RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = removeKeyringPassphraseValidateBeforeCall(removeKeyringPassphraseRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for setKeyringPassphrase
     * @param setKeyringPassphraseRequest The passphrase options (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setKeyringPassphraseCall(SetKeyringPassphraseRequest setKeyringPassphraseRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = setKeyringPassphraseRequest;

        // create path and map variables
        String localVarPath = "/set_keyring_passphrase";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call setKeyringPassphraseValidateBeforeCall(SetKeyringPassphraseRequest setKeyringPassphraseRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'setKeyringPassphraseRequest' is set
        if (setKeyringPassphraseRequest == null) {
            throw new ApiException("Missing the required parameter 'setKeyringPassphraseRequest' when calling setKeyringPassphrase(Async)");
        }

        return setKeyringPassphraseCall(setKeyringPassphraseRequest, _callback);

    }

    /**
     * Update the key ring passphrase.
     * Update the key ring passphrase.
     * @param setKeyringPassphraseRequest The passphrase options (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse setKeyringPassphrase(SetKeyringPassphraseRequest setKeyringPassphraseRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = setKeyringPassphraseWithHttpInfo(setKeyringPassphraseRequest);
        return localVarResp.getData();
    }

    /**
     * Update the key ring passphrase.
     * Update the key ring passphrase.
     * @param setKeyringPassphraseRequest The passphrase options (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> setKeyringPassphraseWithHttpInfo(SetKeyringPassphraseRequest setKeyringPassphraseRequest) throws ApiException {
        okhttp3.Call localVarCall = setKeyringPassphraseValidateBeforeCall(setKeyringPassphraseRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update the key ring passphrase. (asynchronously)
     * Update the key ring passphrase.
     * @param setKeyringPassphraseRequest The passphrase options (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setKeyringPassphraseAsync(SetKeyringPassphraseRequest setKeyringPassphraseRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = setKeyringPassphraseValidateBeforeCall(setKeyringPassphraseRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for unlockKeyring
     * @param unlockKeyringRequest Key ring key (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call unlockKeyringCall(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = unlockKeyringRequest;

        // create path and map variables
        String localVarPath = "/unlock_keyring";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call unlockKeyringValidateBeforeCall(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'unlockKeyringRequest' is set
        if (unlockKeyringRequest == null) {
            throw new ApiException("Missing the required parameter 'unlockKeyringRequest' when calling unlockKeyring(Async)");
        }

        return unlockKeyringCall(unlockKeyringRequest, _callback);

    }

    /**
     * Unlock the keyring.
     * Unlock the keyring.
     * @param unlockKeyringRequest Key ring key (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse unlockKeyring(UnlockKeyringRequest unlockKeyringRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = unlockKeyringWithHttpInfo(unlockKeyringRequest);
        return localVarResp.getData();
    }

    /**
     * Unlock the keyring.
     * Unlock the keyring.
     * @param unlockKeyringRequest Key ring key (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> unlockKeyringWithHttpInfo(UnlockKeyringRequest unlockKeyringRequest) throws ApiException {
        okhttp3.Call localVarCall = unlockKeyringValidateBeforeCall(unlockKeyringRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Unlock the keyring. (asynchronously)
     * Unlock the keyring.
     * @param unlockKeyringRequest Key ring key (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call unlockKeyringAsync(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = unlockKeyringValidateBeforeCall(unlockKeyringRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for validateKeyringPassphrase
     * @param unlockKeyringRequest The passphrase (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call validateKeyringPassphraseCall(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = unlockKeyringRequest;

        // create path and map variables
        String localVarPath = "/validate_keyring_passphrase";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call validateKeyringPassphraseValidateBeforeCall(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'unlockKeyringRequest' is set
        if (unlockKeyringRequest == null) {
            throw new ApiException("Missing the required parameter 'unlockKeyringRequest' when calling validateKeyringPassphrase(Async)");
        }

        return validateKeyringPassphraseCall(unlockKeyringRequest, _callback);

    }

    /**
     * Test the validity of a passphrase.
     * Test the validity of a passphrase.
     * @param unlockKeyringRequest The passphrase (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse validateKeyringPassphrase(UnlockKeyringRequest unlockKeyringRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = validateKeyringPassphraseWithHttpInfo(unlockKeyringRequest);
        return localVarResp.getData();
    }

    /**
     * Test the validity of a passphrase.
     * Test the validity of a passphrase.
     * @param unlockKeyringRequest The passphrase (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> validateKeyringPassphraseWithHttpInfo(UnlockKeyringRequest unlockKeyringRequest) throws ApiException {
        okhttp3.Call localVarCall = validateKeyringPassphraseValidateBeforeCall(unlockKeyringRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Test the validity of a passphrase. (asynchronously)
     * Test the validity of a passphrase.
     * @param unlockKeyringRequest The passphrase (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call validateKeyringPassphraseAsync(UnlockKeyringRequest unlockKeyringRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = validateKeyringPassphraseValidateBeforeCall(unlockKeyringRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
