/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.PrivateKey;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetAllPrivateKeys200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:22:47.336438900-04:00[America/New_York]")
public class GetAllPrivateKeys200Response {
  public static final String SERIALIZED_NAME_PRIVATE_KEYS = "private_keys";
  @SerializedName(SERIALIZED_NAME_PRIVATE_KEYS)
  private List<PrivateKey> privateKeys;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetAllPrivateKeys200Response() {
  }

  public GetAllPrivateKeys200Response privateKeys(List<PrivateKey> privateKeys) {
    
    this.privateKeys = privateKeys;
    return this;
  }

  public GetAllPrivateKeys200Response addPrivateKeysItem(PrivateKey privateKeysItem) {
    if (this.privateKeys == null) {
      this.privateKeys = new ArrayList<>();
    }
    this.privateKeys.add(privateKeysItem);
    return this;
  }

   /**
   * Get privateKeys
   * @return privateKeys
  **/
  @javax.annotation.Nullable

  public List<PrivateKey> getPrivateKeys() {
    return privateKeys;
  }


  public void setPrivateKeys(List<PrivateKey> privateKeys) {
    this.privateKeys = privateKeys;
  }


  public GetAllPrivateKeys200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetAllPrivateKeys200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAllPrivateKeys200Response getAllPrivateKeys200Response = (GetAllPrivateKeys200Response) o;
    return Objects.equals(this.privateKeys, getAllPrivateKeys200Response.privateKeys) &&
        Objects.equals(this.success, getAllPrivateKeys200Response.success) &&
        Objects.equals(this.error, getAllPrivateKeys200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(privateKeys, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAllPrivateKeys200Response {\n");
    sb.append("    privateKeys: ").append(toIndentedString(privateKeys)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("private_keys");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetAllPrivateKeys200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetAllPrivateKeys200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetAllPrivateKeys200Response is not found in the empty JSON string", GetAllPrivateKeys200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetAllPrivateKeys200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetAllPrivateKeys200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetAllPrivateKeys200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (jsonObj.get("private_keys") != null && !jsonObj.get("private_keys").isJsonNull()) {
        JsonArray jsonArrayprivateKeys = jsonObj.getAsJsonArray("private_keys");
        if (jsonArrayprivateKeys != null) {
          // ensure the json data is an array
          if (!jsonObj.get("private_keys").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `private_keys` to be an array in the JSON string but got `%s`", jsonObj.get("private_keys").toString()));
          }

          // validate the optional field `private_keys` (array)
          for (int i = 0; i < jsonArrayprivateKeys.size(); i++) {
            PrivateKey.validateJsonObject(jsonArrayprivateKeys.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetAllPrivateKeys200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetAllPrivateKeys200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetAllPrivateKeys200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetAllPrivateKeys200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetAllPrivateKeys200Response>() {
           @Override
           public void write(JsonWriter out, GetAllPrivateKeys200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetAllPrivateKeys200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetAllPrivateKeys200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetAllPrivateKeys200Response
  * @throws IOException if the JSON string is invalid with respect to GetAllPrivateKeys200Response
  */
  public static GetAllPrivateKeys200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetAllPrivateKeys200Response.class);
  }

 /**
  * Convert an instance of GetAllPrivateKeys200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

