/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.KeyringStatusPassphraseRequirements;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * KeyringStatus200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:22:47.336438900-04:00[America/New_York]")
public class KeyringStatus200Response {
  public static final String SERIALIZED_NAME_IS_KEYRING_LOCKED = "is_keyring_locked";
  @SerializedName(SERIALIZED_NAME_IS_KEYRING_LOCKED)
  private Boolean isKeyringLocked;

  public static final String SERIALIZED_NAME_PASSPHRASE_SUPPORT_ENABLED = "passphrase_support_enabled";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE_SUPPORT_ENABLED)
  private Boolean passphraseSupportEnabled;

  public static final String SERIALIZED_NAME_CAN_SAVE_PASSPHRASE = "can_save_passphrase";
  @SerializedName(SERIALIZED_NAME_CAN_SAVE_PASSPHRASE)
  private Boolean canSavePassphrase;

  public static final String SERIALIZED_NAME_USER_PASSPHRASE_IS_SET = "user_passphrase_is_set";
  @SerializedName(SERIALIZED_NAME_USER_PASSPHRASE_IS_SET)
  private Boolean userPassphraseIsSet;

  public static final String SERIALIZED_NAME_NEEDS_MIGRATION = "needs_migration";
  @SerializedName(SERIALIZED_NAME_NEEDS_MIGRATION)
  private Boolean needsMigration;

  public static final String SERIALIZED_NAME_CAN_REMOVE_LEGACY_KEYS = "can_remove_legacy_keys";
  @SerializedName(SERIALIZED_NAME_CAN_REMOVE_LEGACY_KEYS)
  private Boolean canRemoveLegacyKeys;

  public static final String SERIALIZED_NAME_CAN_SET_PASSPHRASE_HINT = "can_set_passphrase_hint";
  @SerializedName(SERIALIZED_NAME_CAN_SET_PASSPHRASE_HINT)
  private Boolean canSetPassphraseHint;

  public static final String SERIALIZED_NAME_PASSPHRASE_HINT = "passphrase_hint";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE_HINT)
  private String passphraseHint;

  public static final String SERIALIZED_NAME_PASSPHRASE_REQUIREMENTS = "passphrase_requirements";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE_REQUIREMENTS)
  private KeyringStatusPassphraseRequirements passphraseRequirements;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public KeyringStatus200Response() {
  }

  public KeyringStatus200Response isKeyringLocked(Boolean isKeyringLocked) {
    
    this.isKeyringLocked = isKeyringLocked;
    return this;
  }

   /**
   * Get isKeyringLocked
   * @return isKeyringLocked
  **/
  @javax.annotation.Nullable

  public Boolean getIsKeyringLocked() {
    return isKeyringLocked;
  }


  public void setIsKeyringLocked(Boolean isKeyringLocked) {
    this.isKeyringLocked = isKeyringLocked;
  }


  public KeyringStatus200Response passphraseSupportEnabled(Boolean passphraseSupportEnabled) {
    
    this.passphraseSupportEnabled = passphraseSupportEnabled;
    return this;
  }

   /**
   * Get passphraseSupportEnabled
   * @return passphraseSupportEnabled
  **/
  @javax.annotation.Nullable

  public Boolean getPassphraseSupportEnabled() {
    return passphraseSupportEnabled;
  }


  public void setPassphraseSupportEnabled(Boolean passphraseSupportEnabled) {
    this.passphraseSupportEnabled = passphraseSupportEnabled;
  }


  public KeyringStatus200Response canSavePassphrase(Boolean canSavePassphrase) {
    
    this.canSavePassphrase = canSavePassphrase;
    return this;
  }

   /**
   * Get canSavePassphrase
   * @return canSavePassphrase
  **/
  @javax.annotation.Nullable

  public Boolean getCanSavePassphrase() {
    return canSavePassphrase;
  }


  public void setCanSavePassphrase(Boolean canSavePassphrase) {
    this.canSavePassphrase = canSavePassphrase;
  }


  public KeyringStatus200Response userPassphraseIsSet(Boolean userPassphraseIsSet) {
    
    this.userPassphraseIsSet = userPassphraseIsSet;
    return this;
  }

   /**
   * Get userPassphraseIsSet
   * @return userPassphraseIsSet
  **/
  @javax.annotation.Nullable

  public Boolean getUserPassphraseIsSet() {
    return userPassphraseIsSet;
  }


  public void setUserPassphraseIsSet(Boolean userPassphraseIsSet) {
    this.userPassphraseIsSet = userPassphraseIsSet;
  }


  public KeyringStatus200Response needsMigration(Boolean needsMigration) {
    
    this.needsMigration = needsMigration;
    return this;
  }

   /**
   * Get needsMigration
   * @return needsMigration
  **/
  @javax.annotation.Nullable

  public Boolean getNeedsMigration() {
    return needsMigration;
  }


  public void setNeedsMigration(Boolean needsMigration) {
    this.needsMigration = needsMigration;
  }


  public KeyringStatus200Response canRemoveLegacyKeys(Boolean canRemoveLegacyKeys) {
    
    this.canRemoveLegacyKeys = canRemoveLegacyKeys;
    return this;
  }

   /**
   * Get canRemoveLegacyKeys
   * @return canRemoveLegacyKeys
  **/
  @javax.annotation.Nullable

  public Boolean getCanRemoveLegacyKeys() {
    return canRemoveLegacyKeys;
  }


  public void setCanRemoveLegacyKeys(Boolean canRemoveLegacyKeys) {
    this.canRemoveLegacyKeys = canRemoveLegacyKeys;
  }


  public KeyringStatus200Response canSetPassphraseHint(Boolean canSetPassphraseHint) {
    
    this.canSetPassphraseHint = canSetPassphraseHint;
    return this;
  }

   /**
   * Get canSetPassphraseHint
   * @return canSetPassphraseHint
  **/
  @javax.annotation.Nullable

  public Boolean getCanSetPassphraseHint() {
    return canSetPassphraseHint;
  }


  public void setCanSetPassphraseHint(Boolean canSetPassphraseHint) {
    this.canSetPassphraseHint = canSetPassphraseHint;
  }


  public KeyringStatus200Response passphraseHint(String passphraseHint) {
    
    this.passphraseHint = passphraseHint;
    return this;
  }

   /**
   * Get passphraseHint
   * @return passphraseHint
  **/
  @javax.annotation.Nullable

  public String getPassphraseHint() {
    return passphraseHint;
  }


  public void setPassphraseHint(String passphraseHint) {
    this.passphraseHint = passphraseHint;
  }


  public KeyringStatus200Response passphraseRequirements(KeyringStatusPassphraseRequirements passphraseRequirements) {
    
    this.passphraseRequirements = passphraseRequirements;
    return this;
  }

   /**
   * Get passphraseRequirements
   * @return passphraseRequirements
  **/
  @javax.annotation.Nullable

  public KeyringStatusPassphraseRequirements getPassphraseRequirements() {
    return passphraseRequirements;
  }


  public void setPassphraseRequirements(KeyringStatusPassphraseRequirements passphraseRequirements) {
    this.passphraseRequirements = passphraseRequirements;
  }


  public KeyringStatus200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public KeyringStatus200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    KeyringStatus200Response keyringStatus200Response = (KeyringStatus200Response) o;
    return Objects.equals(this.isKeyringLocked, keyringStatus200Response.isKeyringLocked) &&
        Objects.equals(this.passphraseSupportEnabled, keyringStatus200Response.passphraseSupportEnabled) &&
        Objects.equals(this.canSavePassphrase, keyringStatus200Response.canSavePassphrase) &&
        Objects.equals(this.userPassphraseIsSet, keyringStatus200Response.userPassphraseIsSet) &&
        Objects.equals(this.needsMigration, keyringStatus200Response.needsMigration) &&
        Objects.equals(this.canRemoveLegacyKeys, keyringStatus200Response.canRemoveLegacyKeys) &&
        Objects.equals(this.canSetPassphraseHint, keyringStatus200Response.canSetPassphraseHint) &&
        Objects.equals(this.passphraseHint, keyringStatus200Response.passphraseHint) &&
        Objects.equals(this.passphraseRequirements, keyringStatus200Response.passphraseRequirements) &&
        Objects.equals(this.success, keyringStatus200Response.success) &&
        Objects.equals(this.error, keyringStatus200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(isKeyringLocked, passphraseSupportEnabled, canSavePassphrase, userPassphraseIsSet, needsMigration, canRemoveLegacyKeys, canSetPassphraseHint, passphraseHint, passphraseRequirements, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class KeyringStatus200Response {\n");
    sb.append("    isKeyringLocked: ").append(toIndentedString(isKeyringLocked)).append("\n");
    sb.append("    passphraseSupportEnabled: ").append(toIndentedString(passphraseSupportEnabled)).append("\n");
    sb.append("    canSavePassphrase: ").append(toIndentedString(canSavePassphrase)).append("\n");
    sb.append("    userPassphraseIsSet: ").append(toIndentedString(userPassphraseIsSet)).append("\n");
    sb.append("    needsMigration: ").append(toIndentedString(needsMigration)).append("\n");
    sb.append("    canRemoveLegacyKeys: ").append(toIndentedString(canRemoveLegacyKeys)).append("\n");
    sb.append("    canSetPassphraseHint: ").append(toIndentedString(canSetPassphraseHint)).append("\n");
    sb.append("    passphraseHint: ").append(toIndentedString(passphraseHint)).append("\n");
    sb.append("    passphraseRequirements: ").append(toIndentedString(passphraseRequirements)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("is_keyring_locked");
    openapiFields.add("passphrase_support_enabled");
    openapiFields.add("can_save_passphrase");
    openapiFields.add("user_passphrase_is_set");
    openapiFields.add("needs_migration");
    openapiFields.add("can_remove_legacy_keys");
    openapiFields.add("can_set_passphrase_hint");
    openapiFields.add("passphrase_hint");
    openapiFields.add("passphrase_requirements");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to KeyringStatus200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!KeyringStatus200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in KeyringStatus200Response is not found in the empty JSON string", KeyringStatus200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!KeyringStatus200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `KeyringStatus200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : KeyringStatus200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("passphrase_hint") != null && !jsonObj.get("passphrase_hint").isJsonNull()) && !jsonObj.get("passphrase_hint").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `passphrase_hint` to be a primitive type in the JSON string but got `%s`", jsonObj.get("passphrase_hint").toString()));
      }
      // validate the optional field `passphrase_requirements`
      if (jsonObj.get("passphrase_requirements") != null && !jsonObj.get("passphrase_requirements").isJsonNull()) {
        KeyringStatusPassphraseRequirements.validateJsonObject(jsonObj.getAsJsonObject("passphrase_requirements"));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!KeyringStatus200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'KeyringStatus200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<KeyringStatus200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(KeyringStatus200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<KeyringStatus200Response>() {
           @Override
           public void write(JsonWriter out, KeyringStatus200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public KeyringStatus200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of KeyringStatus200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of KeyringStatus200Response
  * @throws IOException if the JSON string is invalid with respect to KeyringStatus200Response
  */
  public static KeyringStatus200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, KeyringStatus200Response.class);
  }

 /**
  * Convert an instance of KeyringStatus200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

