/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * MigrateKeyringRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:22:47.336438900-04:00[America/New_York]")
public class MigrateKeyringRequest {
  public static final String SERIALIZED_NAME_PASSPHRASE = "passphrase";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE)
  private String passphrase;

  public static final String SERIALIZED_NAME_PASSPHRASE_HINT = "passphrase_hint";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE_HINT)
  private String passphraseHint;

  public static final String SERIALIZED_NAME_SAVE_PASSPHRASE = "save_passphrase";
  @SerializedName(SERIALIZED_NAME_SAVE_PASSPHRASE)
  private Boolean savePassphrase = false;

  public static final String SERIALIZED_NAME_CLEANUP_LEGACY_KEYRING = "cleanup_legacy_keyring";
  @SerializedName(SERIALIZED_NAME_CLEANUP_LEGACY_KEYRING)
  private Boolean cleanupLegacyKeyring = false;

  public MigrateKeyringRequest() {
  }

  public MigrateKeyringRequest passphrase(String passphrase) {
    
    this.passphrase = passphrase;
    return this;
  }

   /**
   * Get passphrase
   * @return passphrase
  **/
  @javax.annotation.Nonnull

  public String getPassphrase() {
    return passphrase;
  }


  public void setPassphrase(String passphrase) {
    this.passphrase = passphrase;
  }


  public MigrateKeyringRequest passphraseHint(String passphraseHint) {
    
    this.passphraseHint = passphraseHint;
    return this;
  }

   /**
   * Get passphraseHint
   * @return passphraseHint
  **/
  @javax.annotation.Nonnull

  public String getPassphraseHint() {
    return passphraseHint;
  }


  public void setPassphraseHint(String passphraseHint) {
    this.passphraseHint = passphraseHint;
  }


  public MigrateKeyringRequest savePassphrase(Boolean savePassphrase) {
    
    this.savePassphrase = savePassphrase;
    return this;
  }

   /**
   * Get savePassphrase
   * @return savePassphrase
  **/
  @javax.annotation.Nullable

  public Boolean getSavePassphrase() {
    return savePassphrase;
  }


  public void setSavePassphrase(Boolean savePassphrase) {
    this.savePassphrase = savePassphrase;
  }


  public MigrateKeyringRequest cleanupLegacyKeyring(Boolean cleanupLegacyKeyring) {
    
    this.cleanupLegacyKeyring = cleanupLegacyKeyring;
    return this;
  }

   /**
   * Get cleanupLegacyKeyring
   * @return cleanupLegacyKeyring
  **/
  @javax.annotation.Nullable

  public Boolean getCleanupLegacyKeyring() {
    return cleanupLegacyKeyring;
  }


  public void setCleanupLegacyKeyring(Boolean cleanupLegacyKeyring) {
    this.cleanupLegacyKeyring = cleanupLegacyKeyring;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MigrateKeyringRequest migrateKeyringRequest = (MigrateKeyringRequest) o;
    return Objects.equals(this.passphrase, migrateKeyringRequest.passphrase) &&
        Objects.equals(this.passphraseHint, migrateKeyringRequest.passphraseHint) &&
        Objects.equals(this.savePassphrase, migrateKeyringRequest.savePassphrase) &&
        Objects.equals(this.cleanupLegacyKeyring, migrateKeyringRequest.cleanupLegacyKeyring);
  }

  @Override
  public int hashCode() {
    return Objects.hash(passphrase, passphraseHint, savePassphrase, cleanupLegacyKeyring);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MigrateKeyringRequest {\n");
    sb.append("    passphrase: ").append(toIndentedString(passphrase)).append("\n");
    sb.append("    passphraseHint: ").append(toIndentedString(passphraseHint)).append("\n");
    sb.append("    savePassphrase: ").append(toIndentedString(savePassphrase)).append("\n");
    sb.append("    cleanupLegacyKeyring: ").append(toIndentedString(cleanupLegacyKeyring)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("passphrase");
    openapiFields.add("passphrase_hint");
    openapiFields.add("save_passphrase");
    openapiFields.add("cleanup_legacy_keyring");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("passphrase");
    openapiRequiredFields.add("passphrase_hint");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to MigrateKeyringRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!MigrateKeyringRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in MigrateKeyringRequest is not found in the empty JSON string", MigrateKeyringRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!MigrateKeyringRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `MigrateKeyringRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : MigrateKeyringRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("passphrase").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `passphrase` to be a primitive type in the JSON string but got `%s`", jsonObj.get("passphrase").toString()));
      }
      if (!jsonObj.get("passphrase_hint").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `passphrase_hint` to be a primitive type in the JSON string but got `%s`", jsonObj.get("passphrase_hint").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!MigrateKeyringRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'MigrateKeyringRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<MigrateKeyringRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(MigrateKeyringRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<MigrateKeyringRequest>() {
           @Override
           public void write(JsonWriter out, MigrateKeyringRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public MigrateKeyringRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of MigrateKeyringRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of MigrateKeyringRequest
  * @throws IOException if the JSON string is invalid with respect to MigrateKeyringRequest
  */
  public static MigrateKeyringRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, MigrateKeyringRequest.class);
  }

 /**
  * Convert an instance of MigrateKeyringRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

