/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.KSize;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PlotterConfig
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:22:47.336438900-04:00[America/New_York]")
public class PlotterConfig {
  public static final String SERIALIZED_NAME_DELAY = "delay";
  @SerializedName(SERIALIZED_NAME_DELAY)
  private Integer delay;

  public static final String SERIALIZED_NAME_PARALLEL = "parallel";
  @SerializedName(SERIALIZED_NAME_PARALLEL)
  private Boolean parallel = false;

  public static final String SERIALIZED_NAME_N = "n";
  @SerializedName(SERIALIZED_NAME_N)
  private Integer n = 1;

  public static final String SERIALIZED_NAME_k = "k";
  @SerializedName(SERIALIZED_NAME_k)
  private KSize k = KSize.NUMBER_32;

  public static final String SERIALIZED_NAME_QUEUE = "queue";
  @SerializedName(SERIALIZED_NAME_QUEUE)
  private String queue = "default";

  public static final String SERIALIZED_NAME_T = "t";
  @SerializedName(SERIALIZED_NAME_T)
  private String t;

  public static final String SERIALIZED_NAME_T2 = "t2";
  @SerializedName(SERIALIZED_NAME_T2)
  private String t2;

  public static final String SERIALIZED_NAME_D = "d";
  @SerializedName(SERIALIZED_NAME_D)
  private String d;

  public static final String SERIALIZED_NAME_B = "b";
  @SerializedName(SERIALIZED_NAME_B)
  private Integer b = 4608;

  public static final String SERIALIZED_NAME_U = "u";
  @SerializedName(SERIALIZED_NAME_U)
  private Integer u = 128;

  public static final String SERIALIZED_NAME_A = "a";
  @SerializedName(SERIALIZED_NAME_A)
  private Integer a;

  public static final String SERIALIZED_NAME_C = "c";
  @SerializedName(SERIALIZED_NAME_C)
  private String c;

  public static final String SERIALIZED_NAME_P = "p";
  @SerializedName(SERIALIZED_NAME_P)
  private String p;

  public static final String SERIALIZED_NAME_F = "f";
  @SerializedName(SERIALIZED_NAME_F)
  private String f;

  public static final String SERIALIZED_NAME_MEMO = "memo";
  @SerializedName(SERIALIZED_NAME_MEMO)
  private String memo;

  public static final String SERIALIZED_NAME_E = "e";
  @SerializedName(SERIALIZED_NAME_E)
  private Boolean e = false;

  public static final String SERIALIZED_NAME_R = "r";
  @SerializedName(SERIALIZED_NAME_R)
  private Integer r = 2;

  public static final String SERIALIZED_NAME_X = "x";
  @SerializedName(SERIALIZED_NAME_X)
  private Boolean x = false;

  public static final String SERIALIZED_NAME_OVERRIDE_K = "overrideK";
  @SerializedName(SERIALIZED_NAME_OVERRIDE_K)
  private Boolean overrideK = false;

  public static final String SERIALIZED_NAME_W = "w";
  @SerializedName(SERIALIZED_NAME_W)
  private Boolean w = false;

  public static final String SERIALIZED_NAME_M = "m";
  @SerializedName(SERIALIZED_NAME_M)
  private Boolean m = false;

  public static final String SERIALIZED_NAME_K = "K";
  @SerializedName(SERIALIZED_NAME_K)
  private Boolean K = false;

  public static final String SERIALIZED_NAME_G = "G";
  @SerializedName(SERIALIZED_NAME_G)
  private Boolean G = false;

  public PlotterConfig() {
  }

  public PlotterConfig delay(Integer delay) {
    
    this.delay = delay;
    return this;
  }

   /**
   * The number of seconds to delay before beginning the plotting.
   * @return delay
  **/
  @javax.annotation.Nullable

  public Integer getDelay() {
    return delay;
  }


  public void setDelay(Integer delay) {
    this.delay = delay;
  }


  public PlotterConfig parallel(Boolean parallel) {
    
    this.parallel = parallel;
    return this;
  }

   /**
   * Get parallel
   * @return parallel
  **/
  @javax.annotation.Nullable

  public Boolean getParallel() {
    return parallel;
  }


  public void setParallel(Boolean parallel) {
    this.parallel = parallel;
  }


  public PlotterConfig n(Integer n) {
    
    this.n = n;
    return this;
  }

   /**
   * The number of plots that will be made, in sequence.
   * @return n
  **/
  @javax.annotation.Nullable

  public Integer getN() {
    return n;
  }


  public void setN(Integer n) {
    this.n = n;
  }


  public PlotterConfig k(KSize k) {
    
    this.k = k;
    return this;
  }

   /**
   * Get k
   * @return k
  **/
  @javax.annotation.Nullable

  public KSize getk() {
    return k;
  }


  public void setK(KSize k) {
    this.k = k;
  }


  public PlotterConfig queue(String queue) {
    
    this.queue = queue;
    return this;
  }

   /**
   * Get queue
   * @return queue
  **/
  @javax.annotation.Nullable

  public String getQueue() {
    return queue;
  }


  public void setQueue(String queue) {
    this.queue = queue;
  }


  public PlotterConfig t(String t) {
    
    this.t = t;
    return this;
  }

   /**
   * Define the temporary directory for plot creation. This is where Plotting  Phase 1 (Forward Propagation) and Phase 2 (Backpropagation) both occur.  The -t dir requires the largest working space: normally about 2.5 times the size of the final plot. 
   * @return t
  **/
  @javax.annotation.Nullable

  public String getT() {
    return t;
  }


  public void setT(String t) {
    this.t = t;
  }


  public PlotterConfig t2(String t2) {
    
    this.t2 = t2;
    return this;
  }

   /**
   * Define a secondary temporary directory for plot creation. This is where Plotting Phase 3 (Compression) and Phase 4 (Checkpoints) occur.
   * @return t2
  **/
  @javax.annotation.Nullable

  public String getT2() {
    return t2;
  }


  public void setT2(String t2) {
    this.t2 = t2;
  }


  public PlotterConfig d(String d) {
    
    this.d = d;
    return this;
  }

   /**
   * Define the final location for plot(s). Of course, -d should have enough free space as the final size of the plot. This directory is automatically added to your ~/.chia/VERSION/config/config.yaml file.
   * @return d
  **/
  @javax.annotation.Nullable

  public String getD() {
    return d;
  }


  public void setD(String d) {
    this.d = d;
  }


  public PlotterConfig b(Integer b) {
    
    this.b = b;
    return this;
  }

   /**
   * Define memory/RAM usage. Default is 4608 (4.6 GiB). More RAM will marginally increase speed of plot creation. Please bear in mind that this is what is allocated to the plotting algorithm alone. Code, container, libraries etc. will require additional RAM from your system.
   * @return b
  **/
  @javax.annotation.Nullable

  public Integer getB() {
    return b;
  }


  public void setB(Integer b) {
    this.b = b;
  }


  public PlotterConfig u(Integer u) {
    
    this.u = u;
    return this;
  }

   /**
   * More buckets require less RAM but more random seeks to disk. With spinning disks you want less buckets and with NVMe more buckets. There is no significant benefit from using smaller buckets - just use 128
   * @return u
  **/
  @javax.annotation.Nullable

  public Integer getU() {
    return u;
  }


  public void setU(Integer u) {
    this.u = u;
  }


  public PlotterConfig a(Integer a) {
    
    this.a = a;
    return this;
  }

   /**
   * This is the key Fingerprint used to select both the Farmer and Pool Public Keys to use. Utilize this when you want to select one key out of several in your keychain.
   * @return a
  **/
  @javax.annotation.Nullable

  public Integer getA() {
    return a;
  }


  public void setA(Integer a) {
    this.a = a;
  }


  public PlotterConfig c(String c) {
    
    this.c = c;
    return this;
  }

   /**
   * The pool contract address.
   * @return c
  **/
  @javax.annotation.Nullable

  public String getC() {
    return c;
  }


  public void setC(String c) {
    this.c = c;
  }


  public PlotterConfig p(String p) {
    
    this.p = p;
    return this;
  }

   /**
   * This is your \&quot;Pool Public Key\&quot;. Utilise this when you want to create plots on other machines for which you do not want to give full chia account access.
   * @return p
  **/
  @javax.annotation.Nullable

  public String getP() {
    return p;
  }


  public void setP(String p) {
    this.p = p;
  }


  public PlotterConfig f(String f) {
    
    this.f = f;
    return this;
  }

   /**
   * This is your \&quot;Farmer Public Key\&quot;. Utilise this when you want to create plots on other machines for which you do not want to give full chia account access
   * @return f
  **/
  @javax.annotation.Nullable

  public String getF() {
    return f;
  }


  public void setF(String f) {
    this.f = f;
  }


  public PlotterConfig memo(String memo) {
    
    this.memo = memo;
    return this;
  }

   /**
   * Get memo
   * @return memo
  **/
  @javax.annotation.Nullable

  public String getMemo() {
    return memo;
  }


  public void setMemo(String memo) {
    this.memo = memo;
  }


  public PlotterConfig e(Boolean e) {
    
    this.e = e;
    return this;
  }

   /**
   * Setting to true will disable the bitfield plotting algorithm, and revert back to the older b17 plotting style. After 1.0.4 it&#39;s better to use bitfield for most cases
   * @return e
  **/
  @javax.annotation.Nullable

  public Boolean getE() {
    return e;
  }


  public void setE(Boolean e) {
    this.e = e;
  }


  public PlotterConfig r(Integer r) {
    
    this.r = r;
    return this;
  }

   /**
   * The number of threads to devote to each plot.
   * @return r
  **/
  @javax.annotation.Nullable

  public Integer getR() {
    return r;
  }


  public void setR(Integer r) {
    this.r = r;
  }


  public PlotterConfig x(Boolean x) {
    
    this.x = x;
    return this;
  }

   /**
   * Skips adding [final dir] to harvester for farming.
   * @return x
  **/
  @javax.annotation.Nullable

  public Boolean getX() {
    return x;
  }


  public void setX(Boolean x) {
    this.x = x;
  }


  public PlotterConfig overrideK(Boolean overrideK) {
    
    this.overrideK = overrideK;
    return this;
  }

   /**
   * Only needed when k is set to 25
   * @return overrideK
  **/
  @javax.annotation.Nullable

  public Boolean getOverrideK() {
    return overrideK;
  }


  public void setOverrideK(Boolean overrideK) {
    this.overrideK = overrideK;
  }


  public PlotterConfig w(Boolean w) {
    
    this.w = w;
    return this;
  }

   /**
   * BladeBit Only - warm start
   * @return w
  **/
  @javax.annotation.Nullable

  public Boolean getW() {
    return w;
  }


  public void setW(Boolean w) {
    this.w = w;
  }


  public PlotterConfig m(Boolean m) {
    
    this.m = m;
    return this;
  }

   /**
   * BladeBit Only - disable NUMA
   * @return m
  **/
  @javax.annotation.Nullable

  public Boolean getM() {
    return m;
  }


  public void setM(Boolean m) {
    this.m = m;
  }


  public PlotterConfig K(Boolean K) {
    
    this.K = K;
    return this;
  }

   /**
   * MadMax Only - note upper case - Thread multiplier for phase 2
   * @return K
  **/
  @javax.annotation.Nullable

  public Boolean getK() {
    return K;
  }


  public void setK(Boolean K) {
    this.K = K;
  }


  public PlotterConfig G(Boolean G) {
    
    this.G = G;
    return this;
  }

   /**
   * MadMax Only - note upper case - Alternate tmpdir/tmp2dir
   * @return G
  **/
  @javax.annotation.Nullable

  public Boolean getG() {
    return G;
  }


  public void setG(Boolean G) {
    this.G = G;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PlotterConfig plotterConfig = (PlotterConfig) o;
    return Objects.equals(this.delay, plotterConfig.delay) &&
        Objects.equals(this.parallel, plotterConfig.parallel) &&
        Objects.equals(this.n, plotterConfig.n) &&
        Objects.equals(this.k, plotterConfig.k) &&
        Objects.equals(this.queue, plotterConfig.queue) &&
        Objects.equals(this.t, plotterConfig.t) &&
        Objects.equals(this.t2, plotterConfig.t2) &&
        Objects.equals(this.d, plotterConfig.d) &&
        Objects.equals(this.b, plotterConfig.b) &&
        Objects.equals(this.u, plotterConfig.u) &&
        Objects.equals(this.a, plotterConfig.a) &&
        Objects.equals(this.c, plotterConfig.c) &&
        Objects.equals(this.p, plotterConfig.p) &&
        Objects.equals(this.f, plotterConfig.f) &&
        Objects.equals(this.memo, plotterConfig.memo) &&
        Objects.equals(this.e, plotterConfig.e) &&
        Objects.equals(this.r, plotterConfig.r) &&
        Objects.equals(this.x, plotterConfig.x) &&
        Objects.equals(this.overrideK, plotterConfig.overrideK) &&
        Objects.equals(this.w, plotterConfig.w) &&
        Objects.equals(this.m, plotterConfig.m) &&
        Objects.equals(this.K, plotterConfig.K) &&
        Objects.equals(this.G, plotterConfig.G);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(delay, parallel, n, k, queue, t, t2, d, b, u, a, c, p, f, memo, e, r, x, overrideK, w, m, K, G);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PlotterConfig {\n");
    sb.append("    delay: ").append(toIndentedString(delay)).append("\n");
    sb.append("    parallel: ").append(toIndentedString(parallel)).append("\n");
    sb.append("    n: ").append(toIndentedString(n)).append("\n");
    sb.append("    k: ").append(toIndentedString(k)).append("\n");
    sb.append("    queue: ").append(toIndentedString(queue)).append("\n");
    sb.append("    t: ").append(toIndentedString(t)).append("\n");
    sb.append("    t2: ").append(toIndentedString(t2)).append("\n");
    sb.append("    d: ").append(toIndentedString(d)).append("\n");
    sb.append("    b: ").append(toIndentedString(b)).append("\n");
    sb.append("    u: ").append(toIndentedString(u)).append("\n");
    sb.append("    a: ").append(toIndentedString(a)).append("\n");
    sb.append("    c: ").append(toIndentedString(c)).append("\n");
    sb.append("    p: ").append(toIndentedString(p)).append("\n");
    sb.append("    f: ").append(toIndentedString(f)).append("\n");
    sb.append("    memo: ").append(toIndentedString(memo)).append("\n");
    sb.append("    e: ").append(toIndentedString(e)).append("\n");
    sb.append("    r: ").append(toIndentedString(r)).append("\n");
    sb.append("    x: ").append(toIndentedString(x)).append("\n");
    sb.append("    overrideK: ").append(toIndentedString(overrideK)).append("\n");
    sb.append("    w: ").append(toIndentedString(w)).append("\n");
    sb.append("    m: ").append(toIndentedString(m)).append("\n");
    sb.append("    K: ").append(toIndentedString(K)).append("\n");
    sb.append("    G: ").append(toIndentedString(G)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("delay");
    openapiFields.add("parallel");
    openapiFields.add("n");
    openapiFields.add("k");
    openapiFields.add("queue");
    openapiFields.add("t");
    openapiFields.add("t2");
    openapiFields.add("d");
    openapiFields.add("b");
    openapiFields.add("u");
    openapiFields.add("a");
    openapiFields.add("c");
    openapiFields.add("p");
    openapiFields.add("f");
    openapiFields.add("memo");
    openapiFields.add("e");
    openapiFields.add("r");
    openapiFields.add("x");
    openapiFields.add("overrideK");
    openapiFields.add("w");
    openapiFields.add("m");
    openapiFields.add("K");
    openapiFields.add("G");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PlotterConfig
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PlotterConfig.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PlotterConfig is not found in the empty JSON string", PlotterConfig.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PlotterConfig.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PlotterConfig` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("queue") != null && !jsonObj.get("queue").isJsonNull()) && !jsonObj.get("queue").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `queue` to be a primitive type in the JSON string but got `%s`", jsonObj.get("queue").toString()));
      }
      if ((jsonObj.get("t") != null && !jsonObj.get("t").isJsonNull()) && !jsonObj.get("t").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `t` to be a primitive type in the JSON string but got `%s`", jsonObj.get("t").toString()));
      }
      if ((jsonObj.get("t2") != null && !jsonObj.get("t2").isJsonNull()) && !jsonObj.get("t2").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `t2` to be a primitive type in the JSON string but got `%s`", jsonObj.get("t2").toString()));
      }
      if ((jsonObj.get("d") != null && !jsonObj.get("d").isJsonNull()) && !jsonObj.get("d").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `d` to be a primitive type in the JSON string but got `%s`", jsonObj.get("d").toString()));
      }
      if ((jsonObj.get("c") != null && !jsonObj.get("c").isJsonNull()) && !jsonObj.get("c").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `c` to be a primitive type in the JSON string but got `%s`", jsonObj.get("c").toString()));
      }
      if ((jsonObj.get("p") != null && !jsonObj.get("p").isJsonNull()) && !jsonObj.get("p").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p").toString()));
      }
      if ((jsonObj.get("f") != null && !jsonObj.get("f").isJsonNull()) && !jsonObj.get("f").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `f` to be a primitive type in the JSON string but got `%s`", jsonObj.get("f").toString()));
      }
      if ((jsonObj.get("memo") != null && !jsonObj.get("memo").isJsonNull()) && !jsonObj.get("memo").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `memo` to be a primitive type in the JSON string but got `%s`", jsonObj.get("memo").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PlotterConfig.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PlotterConfig' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PlotterConfig> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PlotterConfig.class));

       return (TypeAdapter<T>) new TypeAdapter<PlotterConfig>() {
           @Override
           public void write(JsonWriter out, PlotterConfig value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PlotterConfig read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PlotterConfig given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PlotterConfig
  * @throws IOException if the JSON string is invalid with respect to PlotterConfig
  */
  public static PlotterConfig fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PlotterConfig.class);
  }

 /**
  * Convert an instance of PlotterConfig to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

