/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SetKeyringPassphraseRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:22:47.336438900-04:00[America/New_York]")
public class SetKeyringPassphraseRequest {
  public static final String SERIALIZED_NAME_CURRENT_PASSPHRASE = "current_passphrase";
  @SerializedName(SERIALIZED_NAME_CURRENT_PASSPHRASE)
  private String currentPassphrase;

  public static final String SERIALIZED_NAME_NEW_PASSPHRASE = "new_passphrase";
  @SerializedName(SERIALIZED_NAME_NEW_PASSPHRASE)
  private String newPassphrase;

  public static final String SERIALIZED_NAME_PASSPHRASE_HINT = "passphrase_hint";
  @SerializedName(SERIALIZED_NAME_PASSPHRASE_HINT)
  private String passphraseHint;

  public static final String SERIALIZED_NAME_SAVE_PASSPHRASE = "save_passphrase";
  @SerializedName(SERIALIZED_NAME_SAVE_PASSPHRASE)
  private Boolean savePassphrase = false;

  public SetKeyringPassphraseRequest() {
  }

  public SetKeyringPassphraseRequest currentPassphrase(String currentPassphrase) {
    
    this.currentPassphrase = currentPassphrase;
    return this;
  }

   /**
   * Get currentPassphrase
   * @return currentPassphrase
  **/
  @javax.annotation.Nullable

  public String getCurrentPassphrase() {
    return currentPassphrase;
  }


  public void setCurrentPassphrase(String currentPassphrase) {
    this.currentPassphrase = currentPassphrase;
  }


  public SetKeyringPassphraseRequest newPassphrase(String newPassphrase) {
    
    this.newPassphrase = newPassphrase;
    return this;
  }

   /**
   * Get newPassphrase
   * @return newPassphrase
  **/
  @javax.annotation.Nonnull

  public String getNewPassphrase() {
    return newPassphrase;
  }


  public void setNewPassphrase(String newPassphrase) {
    this.newPassphrase = newPassphrase;
  }


  public SetKeyringPassphraseRequest passphraseHint(String passphraseHint) {
    
    this.passphraseHint = passphraseHint;
    return this;
  }

   /**
   * Get passphraseHint
   * @return passphraseHint
  **/
  @javax.annotation.Nullable

  public String getPassphraseHint() {
    return passphraseHint;
  }


  public void setPassphraseHint(String passphraseHint) {
    this.passphraseHint = passphraseHint;
  }


  public SetKeyringPassphraseRequest savePassphrase(Boolean savePassphrase) {
    
    this.savePassphrase = savePassphrase;
    return this;
  }

   /**
   * Get savePassphrase
   * @return savePassphrase
  **/
  @javax.annotation.Nullable

  public Boolean getSavePassphrase() {
    return savePassphrase;
  }


  public void setSavePassphrase(Boolean savePassphrase) {
    this.savePassphrase = savePassphrase;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SetKeyringPassphraseRequest setKeyringPassphraseRequest = (SetKeyringPassphraseRequest) o;
    return Objects.equals(this.currentPassphrase, setKeyringPassphraseRequest.currentPassphrase) &&
        Objects.equals(this.newPassphrase, setKeyringPassphraseRequest.newPassphrase) &&
        Objects.equals(this.passphraseHint, setKeyringPassphraseRequest.passphraseHint) &&
        Objects.equals(this.savePassphrase, setKeyringPassphraseRequest.savePassphrase);
  }

  @Override
  public int hashCode() {
    return Objects.hash(currentPassphrase, newPassphrase, passphraseHint, savePassphrase);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SetKeyringPassphraseRequest {\n");
    sb.append("    currentPassphrase: ").append(toIndentedString(currentPassphrase)).append("\n");
    sb.append("    newPassphrase: ").append(toIndentedString(newPassphrase)).append("\n");
    sb.append("    passphraseHint: ").append(toIndentedString(passphraseHint)).append("\n");
    sb.append("    savePassphrase: ").append(toIndentedString(savePassphrase)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("current_passphrase");
    openapiFields.add("new_passphrase");
    openapiFields.add("passphrase_hint");
    openapiFields.add("save_passphrase");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("new_passphrase");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SetKeyringPassphraseRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SetKeyringPassphraseRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SetKeyringPassphraseRequest is not found in the empty JSON string", SetKeyringPassphraseRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SetKeyringPassphraseRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SetKeyringPassphraseRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : SetKeyringPassphraseRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("current_passphrase") != null && !jsonObj.get("current_passphrase").isJsonNull()) && !jsonObj.get("current_passphrase").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `current_passphrase` to be a primitive type in the JSON string but got `%s`", jsonObj.get("current_passphrase").toString()));
      }
      if (!jsonObj.get("new_passphrase").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `new_passphrase` to be a primitive type in the JSON string but got `%s`", jsonObj.get("new_passphrase").toString()));
      }
      if ((jsonObj.get("passphrase_hint") != null && !jsonObj.get("passphrase_hint").isJsonNull()) && !jsonObj.get("passphrase_hint").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `passphrase_hint` to be a primitive type in the JSON string but got `%s`", jsonObj.get("passphrase_hint").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SetKeyringPassphraseRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SetKeyringPassphraseRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SetKeyringPassphraseRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SetKeyringPassphraseRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<SetKeyringPassphraseRequest>() {
           @Override
           public void write(JsonWriter out, SetKeyringPassphraseRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SetKeyringPassphraseRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SetKeyringPassphraseRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SetKeyringPassphraseRequest
  * @throws IOException if the JSON string is invalid with respect to SetKeyringPassphraseRequest
  */
  public static SetKeyringPassphraseRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SetKeyringPassphraseRequest.class);
  }

 /**
  * Convert an instance of SetKeyringPassphraseRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

