/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetStatus200Response;
import org.openapitools.client.model.GetVersion200Response;
import org.openapitools.client.model.IsRunning200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.RegisterService200Response;
import org.openapitools.client.model.RegisterServiceRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for DaemonApi
 */
@Disabled
public class DaemonApiTest {

    private final DaemonApi api = new DaemonApi();

    /**
     * Tells the daemon at the RPC endpoint to exit.
     *
     * Tells the daemon at the RPC endpoint to exit. There isn&#39;t a way to start the daemon remotely via RPC, so take care that you have access to the RPC host if needed.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void exitTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.exit(body);
        // TODO: test validations
    }

    /**
     * Indicator if the genesis block is intialized.
     *
     * Indicator if the genesis block is intialized.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getStatusTest() throws ApiException {
        Object body = null;
        GetStatus200Response response = api.getStatus(body);
        // TODO: test validations
    }

    /**
     * Get the installed version of chia at the endpoint.
     *
     * Get the installed version of chia at the endpoint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getVersionTest() throws ApiException {
        Object body = null;
        GetVersion200Response response = api.getVersion(body);
        // TODO: test validations
    }

    /**
     * Determines if the named service is running.
     *
     * Determines if the named service is running.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void isRunningTest() throws ApiException {
        RegisterServiceRequest registerServiceRequest = null;
        IsRunning200Response response = api.isRunning(registerServiceRequest);
        // TODO: test validations
    }

    /**
     * Ping the daemon.
     *
     * Ping the daemon.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pingTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.ping(body);
        // TODO: test validations
    }

    /**
     * Registers this daemon to receive messages.
     *
     * Registers this daemon to receive messages. This is needed to receive responses from services other than the daemon.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void registerServiceTest() throws ApiException {
        RegisterServiceRequest registerServiceRequest = null;
        RegisterService200Response response = api.registerService(registerServiceRequest);
        // TODO: test validations
    }

    /**
     * Starts the named service.
     *
     * Starts the named service.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void startServiceTest() throws ApiException {
        RegisterServiceRequest registerServiceRequest = null;
        ModelApiResponse response = api.startService(registerServiceRequest);
        // TODO: test validations
    }

    /**
     * Stops the named service.
     *
     * Stops the named service.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void stopServiceTest() throws ApiException {
        RegisterServiceRequest registerServiceRequest = null;
        ModelApiResponse response = api.stopService(registerServiceRequest);
        // TODO: test validations
    }

}
