/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.AddPrivateKey200Response;
import org.openapitools.client.model.AddPrivateKeyRequest;
import org.openapitools.client.model.CheckKeysRequest;
import org.openapitools.client.model.DeleteKeyByFingerprintRequest;
import org.openapitools.client.model.GetAllPrivateKeys200Response;
import org.openapitools.client.model.GetFirstPrivateKey200Response;
import org.openapitools.client.model.IsKeyringLocked200Response;
import org.openapitools.client.model.KeyringStatus200Response;
import org.openapitools.client.model.MigrateKeyringRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.RemoveKeyringPassphraseRequest;
import org.openapitools.client.model.SetKeyringPassphraseRequest;
import org.openapitools.client.model.UnlockKeyringRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for KeyRingApi
 */
@Disabled
public class KeyRingApiTest {

    private final KeyRingApi api = new KeyRingApi();

    /**
     * Adds a private key to the keychain.
     *
     * Adds a private key to the keychain, with the given entropy and passphrase. The keychain itself will store the public key, and the entropy bytes, but not the passphrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addPrivateKeyTest() throws ApiException {
        AddPrivateKeyRequest addPrivateKeyRequest = null;
        AddPrivateKey200Response response = api.addPrivateKey(addPrivateKeyRequest);
        // TODO: test validations
    }

    /**
     * Check the keys.
     *
     * Check the keys.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void checkKeysTest() throws ApiException {
        CheckKeysRequest checkKeysRequest = null;
        AddPrivateKey200Response response = api.checkKeys(checkKeysRequest);
        // TODO: test validations
    }

    /**
     * Deletes all keys from the keychain.
     *
     * Deletes all keys from the keychain.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void daemonDeleteAllKeysTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.daemonDeleteAllKeys(body);
        // TODO: test validations
    }

    /**
     * Deletes all keys which have the given public key fingerprint.
     *
     * Deletes all keys which have the given public key fingerprint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteKeyByFingerprintTest() throws ApiException {
        DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest = null;
        AddPrivateKey200Response response = api.deleteKeyByFingerprint(deleteKeyByFingerprintRequest);
        // TODO: test validations
    }

    /**
     * Returns all private keys which can be retrieved, with the given passphrases.
     *
     * Returns all private keys which can be retrieved, with the given passphrases. A tuple of key, and entropy bytes (i.e. mnemonic) is returned for each key.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getAllPrivateKeysTest() throws ApiException {
        Object body = null;
        GetAllPrivateKeys200Response response = api.getAllPrivateKeys(body);
        // TODO: test validations
    }

    /**
     * Returns the first key in the keychain.
     *
     * Returns the first key in the keychain.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getFirstPrivateKeyTest() throws ApiException {
        Object body = null;
        GetFirstPrivateKey200Response response = api.getFirstPrivateKey(body);
        // TODO: test validations
    }

    /**
     * Locates and returns a private key matching the provided fingerprint.
     *
     * Locates and returns a private key matching the provided fingerprint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getKeyForFingerprintTest() throws ApiException {
        DeleteKeyByFingerprintRequest deleteKeyByFingerprintRequest = null;
        GetFirstPrivateKey200Response response = api.getKeyForFingerprint(deleteKeyByFingerprintRequest);
        // TODO: test validations
    }

    /**
     * Returns whether the keyring is in a locked state.
     *
     * Returns whether the keyring is in a locked state. If the keyring doesn&#39;t have a master passphrase set, or if a master passphrase is set and the cached passphrase is valid, the keyring is \&quot;unlocked\&quot;.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void isKeyringLockedTest() throws ApiException {
        Object body = null;
        IsKeyringLocked200Response response = api.isKeyringLocked(body);
        // TODO: test validations
    }

    /**
     * Get detailed status of the key ring.
     *
     * Get detailed status of the key ring.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void keyringStatusTest() throws ApiException {
        Object body = null;
        KeyringStatus200Response response = api.keyringStatus(body);
        // TODO: test validations
    }

    /**
     * Migrate from key phrase to key ring.
     *
     * Migrate from key phrase to key ring.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void migrateKeyringTest() throws ApiException {
        MigrateKeyringRequest migrateKeyringRequest = null;
        ModelApiResponse response = api.migrateKeyring(migrateKeyringRequest);
        // TODO: test validations
    }

    /**
     * Remove the key ring passphrase.
     *
     * Remove the key ring passphrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void removeKeyringPassphraseTest() throws ApiException {
        RemoveKeyringPassphraseRequest removeKeyringPassphraseRequest = null;
        ModelApiResponse response = api.removeKeyringPassphrase(removeKeyringPassphraseRequest);
        // TODO: test validations
    }

    /**
     * Update the key ring passphrase.
     *
     * Update the key ring passphrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void setKeyringPassphraseTest() throws ApiException {
        SetKeyringPassphraseRequest setKeyringPassphraseRequest = null;
        ModelApiResponse response = api.setKeyringPassphrase(setKeyringPassphraseRequest);
        // TODO: test validations
    }

    /**
     * Unlock the keyring.
     *
     * Unlock the keyring.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void unlockKeyringTest() throws ApiException {
        UnlockKeyringRequest unlockKeyringRequest = null;
        ModelApiResponse response = api.unlockKeyring(unlockKeyringRequest);
        // TODO: test validations
    }

    /**
     * Test the validity of a passphrase.
     *
     * Test the validity of a passphrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void validateKeyringPassphraseTest() throws ApiException {
        UnlockKeyringRequest unlockKeyringRequest = null;
        ModelApiResponse response = api.validateKeyringPassphrase(unlockKeyringRequest);
        // TODO: test validations
    }

}
