/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The daemon uses port 55400 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetPlotters200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.PlotterConfig;
import org.openapitools.client.model.StartPlotting200Response;
import org.openapitools.client.model.StopPlottingRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for PlotterApi
 */
@Disabled
public class PlotterApiTest {

    private final PlotterApi api = new PlotterApi();

    /**
     * Get info about installed and installable plotters.
     *
     * Get info about installed and installable plotters.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPlottersTest() throws ApiException {
        Object body = null;
        GetPlotters200Response response = api.getPlotters(body);
        // TODO: test validations
    }

    /**
     * Starts plotting.
     *
     * Starts plotting. Returns after request is added to the plotting queue. Does not wait for plotting to finish.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void startPlottingTest() throws ApiException {
        PlotterConfig plotterConfig = null;
        StartPlotting200Response response = api.startPlotting(plotterConfig);
        // TODO: test validations
    }

    /**
     * Stops the plot with the given id.
     *
     * Stops the plot with the given id.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void stopPlottingTest() throws ApiException {
        StopPlottingRequest stopPlottingRequest = null;
        ModelApiResponse response = api.stopPlotting(stopPlottingRequest);
        // TODO: test validations
    }

}
