# DataLayerApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**addMissingFiles**](DataLayerApi.md#addMissingFiles) | **POST** /add_missing_files | Complete the data server files. |
| [**batchUpdate**](DataLayerApi.md#batchUpdate) | **POST** /batch_update | Applies a batch of updates. |
| [**createDataStore**](DataLayerApi.md#createDataStore) | **POST** /create_data_store | Creates a data store. |
| [**deleteKey**](DataLayerApi.md#deleteKey) | **POST** /delete_key | Removes a list of rows. |
| [**getAncestors**](DataLayerApi.md#getAncestors) | **POST** /get_ancestors | Gets the list of ancestors for a given id/hash pair. |
| [**getKeys**](DataLayerApi.md#getKeys) | **POST** /get_keys | Get the keys for a given id/root_hash pair. |
| [**getKeysValues**](DataLayerApi.md#getKeysValues) | **POST** /get_keys_values | Get the keys and values for a given id/root_hash pair. |
| [**getKvDiff**](DataLayerApi.md#getKvDiff) | **POST** /get_kv_diff | Get kv diff between two root hashes. |
| [**getLocalRoot**](DataLayerApi.md#getLocalRoot) | **POST** /get_local_root | Gets hash of latest tree root saved in our local datastore. |
| [**getOwnedStores**](DataLayerApi.md#getOwnedStores) | **POST** /get_owned_stores | Gets the list of owned store ids. |
| [**getRoot**](DataLayerApi.md#getRoot) | **POST** /get_root | Gets hash of latest tree root. |
| [**getRootHistory**](DataLayerApi.md#getRootHistory) | **POST** /get_root_history | Get history of state hashes for a store. |
| [**getRoots**](DataLayerApi.md#getRoots) | **POST** /get_roots | Gets state hashes for a list of roots |
| [**getSyncStatus**](DataLayerApi.md#getSyncStatus) | **POST** /get_sync_status | Gets the sync status of a store. |
| [**getValue**](DataLayerApi.md#getValue) | **POST** /get_value | Get the value for a given id/key pair. |
| [**insert**](DataLayerApi.md#insert) | **POST** /insert | Adds a list of clvm objects as bytes to add to table. |


<a name="addMissingFiles"></a>
# **addMissingFiles**
> ModelApiResponse addMissingFiles(addMissingFilesRequest)

Complete the data server files.

Complete the data server files.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    AddMissingFilesRequest addMissingFilesRequest = new AddMissingFilesRequest(); // AddMissingFilesRequest | 
    try {
      ModelApiResponse result = apiInstance.addMissingFiles(addMissingFilesRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#addMissingFiles");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **addMissingFilesRequest** | [**AddMissingFilesRequest**](AddMissingFilesRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="batchUpdate"></a>
# **batchUpdate**
> BatchUpdate200Response batchUpdate(batchUpdateRequest)

Applies a batch of updates.

Applies a batch of updates.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    BatchUpdateRequest batchUpdateRequest = new BatchUpdateRequest(); // BatchUpdateRequest | 
    try {
      BatchUpdate200Response result = apiInstance.batchUpdate(batchUpdateRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#batchUpdate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **batchUpdateRequest** | [**BatchUpdateRequest**](BatchUpdateRequest.md)|  | |

### Return type

[**BatchUpdate200Response**](BatchUpdate200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="createDataStore"></a>
# **createDataStore**
> CreateDataStore200Response createDataStore(createDataStoreRequest)

Creates a data store.

Creates a data store.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    CreateDataStoreRequest createDataStoreRequest = new CreateDataStoreRequest(); // CreateDataStoreRequest | 
    try {
      CreateDataStore200Response result = apiInstance.createDataStore(createDataStoreRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#createDataStore");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **createDataStoreRequest** | [**CreateDataStoreRequest**](CreateDataStoreRequest.md)|  | |

### Return type

[**CreateDataStore200Response**](CreateDataStore200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="deleteKey"></a>
# **deleteKey**
> BatchUpdate200Response deleteKey(deleteKeyRequest)

Removes a list of rows.

Removes a list of rows.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    DeleteKeyRequest deleteKeyRequest = new DeleteKeyRequest(); // DeleteKeyRequest | 
    try {
      BatchUpdate200Response result = apiInstance.deleteKey(deleteKeyRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#deleteKey");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deleteKeyRequest** | [**DeleteKeyRequest**](DeleteKeyRequest.md)|  | |

### Return type

[**BatchUpdate200Response**](BatchUpdate200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getAncestors"></a>
# **getAncestors**
> GetAncestors200Response getAncestors(getAncestorsRequest)

Gets the list of ancestors for a given id/hash pair.

Gets the list of ancestors for a given id/hash pair.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetAncestorsRequest getAncestorsRequest = new GetAncestorsRequest(); // GetAncestorsRequest | 
    try {
      GetAncestors200Response result = apiInstance.getAncestors(getAncestorsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getAncestors");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getAncestorsRequest** | [**GetAncestorsRequest**](GetAncestorsRequest.md)|  | |

### Return type

[**GetAncestors200Response**](GetAncestors200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getKeys"></a>
# **getKeys**
> GetKeys200Response getKeys(getKeysRequest)

Get the keys for a given id/root_hash pair.

Get the keys for a given id/root_hash pair.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetKeysRequest getKeysRequest = new GetKeysRequest(); // GetKeysRequest | 
    try {
      GetKeys200Response result = apiInstance.getKeys(getKeysRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getKeys");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getKeysRequest** | [**GetKeysRequest**](GetKeysRequest.md)|  | |

### Return type

[**GetKeys200Response**](GetKeys200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getKeysValues"></a>
# **getKeysValues**
> GetKeysValues200Response getKeysValues(getKeysRequest)

Get the keys and values for a given id/root_hash pair.

Get the keys and values for a given id/root_hash pair.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetKeysRequest getKeysRequest = new GetKeysRequest(); // GetKeysRequest | 
    try {
      GetKeysValues200Response result = apiInstance.getKeysValues(getKeysRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getKeysValues");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getKeysRequest** | [**GetKeysRequest**](GetKeysRequest.md)|  | |

### Return type

[**GetKeysValues200Response**](GetKeysValues200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getKvDiff"></a>
# **getKvDiff**
> GetKvDiff200Response getKvDiff(getKvDiffRequest)

Get kv diff between two root hashes.

Get kv diff between two root hashes.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetKvDiffRequest getKvDiffRequest = new GetKvDiffRequest(); // GetKvDiffRequest | 
    try {
      GetKvDiff200Response result = apiInstance.getKvDiff(getKvDiffRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getKvDiff");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getKvDiffRequest** | [**GetKvDiffRequest**](GetKvDiffRequest.md)|  | |

### Return type

[**GetKvDiff200Response**](GetKvDiff200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getLocalRoot"></a>
# **getLocalRoot**
> GetLocalRoot200Response getLocalRoot(getSyncStatusRequest)

Gets hash of latest tree root saved in our local datastore.

Gets hash of latest tree root saved in our local datastore.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      GetLocalRoot200Response result = apiInstance.getLocalRoot(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getLocalRoot");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**GetLocalRoot200Response**](GetLocalRoot200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getOwnedStores"></a>
# **getOwnedStores**
> GetOwnedStores200Response getOwnedStores(body)

Gets the list of owned store ids.

Gets the list of owned store ids.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetOwnedStores200Response result = apiInstance.getOwnedStores(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getOwnedStores");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetOwnedStores200Response**](GetOwnedStores200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRoot"></a>
# **getRoot**
> GetRoot200Response getRoot(getSyncStatusRequest)

Gets hash of latest tree root.

Gets hash of latest tree root.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      GetRoot200Response result = apiInstance.getRoot(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getRoot");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**GetRoot200Response**](GetRoot200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRootHistory"></a>
# **getRootHistory**
> GetRootHistory200Response getRootHistory(getSyncStatusRequest)

Get history of state hashes for a store.

Get history of state hashes for a store.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      GetRootHistory200Response result = apiInstance.getRootHistory(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getRootHistory");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**GetRootHistory200Response**](GetRootHistory200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRoots"></a>
# **getRoots**
> GetRoots200Response getRoots(getRootsRequest)

Gets state hashes for a list of roots

Gets state hashes for a list of roots.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetRootsRequest getRootsRequest = new GetRootsRequest(); // GetRootsRequest | 
    try {
      GetRoots200Response result = apiInstance.getRoots(getRootsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getRoots");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getRootsRequest** | [**GetRootsRequest**](GetRootsRequest.md)|  | |

### Return type

[**GetRoots200Response**](GetRoots200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getSyncStatus"></a>
# **getSyncStatus**
> GetSyncStatus200Response getSyncStatus(getSyncStatusRequest)

Gets the sync status of a store.

Gets the sync status of a store.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      GetSyncStatus200Response result = apiInstance.getSyncStatus(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getSyncStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**GetSyncStatus200Response**](GetSyncStatus200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getValue"></a>
# **getValue**
> GetValue200Response getValue(getValueRequest)

Get the value for a given id/key pair.

Get the value for a given id/key pair.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    GetValueRequest getValueRequest = new GetValueRequest(); // GetValueRequest | 
    try {
      GetValue200Response result = apiInstance.getValue(getValueRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#getValue");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getValueRequest** | [**GetValueRequest**](GetValueRequest.md)|  | |

### Return type

[**GetValue200Response**](GetValue200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="insert"></a>
# **insert**
> BatchUpdate200Response insert(insertRequest)

Adds a list of clvm objects as bytes to add to table.

Adds a list of clvm objects as bytes to add to table.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    DataLayerApi apiInstance = new DataLayerApi(defaultClient);
    InsertRequest insertRequest = new InsertRequest(); // InsertRequest | 
    try {
      BatchUpdate200Response result = apiInstance.insert(insertRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerApi#insert");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **insertRequest** | [**InsertRequest**](InsertRequest.md)|  | |

### Return type

[**BatchUpdate200Response**](BatchUpdate200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

