# MirrorsApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**addMirror**](MirrorsApi.md#addMirror) | **POST** /add_mirror | Adds a mirror. |
| [**deleteMirror**](MirrorsApi.md#deleteMirror) | **POST** /delete_mirror | Deletes a mirror. |
| [**getMirrors**](MirrorsApi.md#getMirrors) | **POST** /get_mirrors | Gets the mirrors for a given store id. |


<a name="addMirror"></a>
# **addMirror**
> ModelApiResponse addMirror(addMirrorRequest)

Adds a mirror.

Adds a mirror.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MirrorsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    MirrorsApi apiInstance = new MirrorsApi(defaultClient);
    AddMirrorRequest addMirrorRequest = new AddMirrorRequest(); // AddMirrorRequest | 
    try {
      ModelApiResponse result = apiInstance.addMirror(addMirrorRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MirrorsApi#addMirror");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **addMirrorRequest** | [**AddMirrorRequest**](AddMirrorRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="deleteMirror"></a>
# **deleteMirror**
> ModelApiResponse deleteMirror(deleteMirrorRequest)

Deletes a mirror.

Deletes a mirror.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MirrorsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    MirrorsApi apiInstance = new MirrorsApi(defaultClient);
    DeleteMirrorRequest deleteMirrorRequest = new DeleteMirrorRequest(); // DeleteMirrorRequest | 
    try {
      ModelApiResponse result = apiInstance.deleteMirror(deleteMirrorRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MirrorsApi#deleteMirror");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deleteMirrorRequest** | [**DeleteMirrorRequest**](DeleteMirrorRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="getMirrors"></a>
# **getMirrors**
> GetMirrors200Response getMirrors(getSyncStatusRequest)

Gets the mirrors for a given store id.

Gets the mirrors for a given store id.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MirrorsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    MirrorsApi apiInstance = new MirrorsApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      GetMirrors200Response result = apiInstance.getMirrors(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MirrorsApi#getMirrors");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**GetMirrors200Response**](GetMirrors200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

