# OffersApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**cancelOffer**](OffersApi.md#cancelOffer) | **POST** /cancel_offer | Cancels an offer. |
| [**makeOffer**](OffersApi.md#makeOffer) | **POST** /make_offer | Makes an offer. |
| [**takeOffer**](OffersApi.md#takeOffer) | **POST** /take_offer | Takes an offer. |
| [**verifyOffer**](OffersApi.md#verifyOffer) | **POST** /verify_offer | Verifies an offer. |


<a name="cancelOffer"></a>
# **cancelOffer**
> ModelApiResponse cancelOffer(cancelOfferRequest)

Cancels an offer.

Cancels an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.OffersApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    OffersApi apiInstance = new OffersApi(defaultClient);
    CancelOfferRequest cancelOfferRequest = new CancelOfferRequest(); // CancelOfferRequest | 
    try {
      ModelApiResponse result = apiInstance.cancelOffer(cancelOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OffersApi#cancelOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **cancelOfferRequest** | [**CancelOfferRequest**](CancelOfferRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="makeOffer"></a>
# **makeOffer**
> MakeOffer200Response makeOffer(makeOfferRequest)

Makes an offer.

Makes an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.OffersApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    OffersApi apiInstance = new OffersApi(defaultClient);
    MakeOfferRequest makeOfferRequest = new MakeOfferRequest(); // MakeOfferRequest | 
    try {
      MakeOffer200Response result = apiInstance.makeOffer(makeOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OffersApi#makeOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **makeOfferRequest** | [**MakeOfferRequest**](MakeOfferRequest.md)|  | |

### Return type

[**MakeOffer200Response**](MakeOffer200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="takeOffer"></a>
# **takeOffer**
> TakeOffer200Response takeOffer(takeOfferRequest)

Takes an offer.

Takes an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.OffersApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    OffersApi apiInstance = new OffersApi(defaultClient);
    TakeOfferRequest takeOfferRequest = new TakeOfferRequest(); // TakeOfferRequest | 
    try {
      TakeOffer200Response result = apiInstance.takeOffer(takeOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OffersApi#takeOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **takeOfferRequest** | [**TakeOfferRequest**](TakeOfferRequest.md)|  | |

### Return type

[**TakeOffer200Response**](TakeOffer200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="verifyOffer"></a>
# **verifyOffer**
> VerifyOffer200Response verifyOffer(takeOfferRequest)

Verifies an offer.

Verifies an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.OffersApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    OffersApi apiInstance = new OffersApi(defaultClient);
    TakeOfferRequest takeOfferRequest = new TakeOfferRequest(); // TakeOfferRequest | 
    try {
      VerifyOffer200Response result = apiInstance.verifyOffer(takeOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OffersApi#verifyOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **takeOfferRequest** | [**TakeOfferRequest**](TakeOfferRequest.md)|  | |

### Return type

[**VerifyOffer200Response**](VerifyOffer200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

