# SharedApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**closeConnection**](SharedApi.md#closeConnection) | **POST** /close_connection | Removes a connection. |
| [**getConnections**](SharedApi.md#getConnections) | **POST** /get_connections | Retrieve the list of connections. |
| [**getRoutes**](SharedApi.md#getRoutes) | **POST** /get_routes | Retrieve the list of routes exposed by the service. |
| [**healthz**](SharedApi.md#healthz) | **POST** /healthz | Heartbeat. |
| [**openConnection**](SharedApi.md#openConnection) | **POST** /open_connection | Add a connection to another node. |
| [**stopNode**](SharedApi.md#stopNode) | **POST** /stop_node | Stop the node. |


<a name="closeConnection"></a>
# **closeConnection**
> ModelApiResponse closeConnection(closeConnectionRequest)

Removes a connection.

Removes a connection.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    CloseConnectionRequest closeConnectionRequest = new CloseConnectionRequest(); // CloseConnectionRequest | the node id of the connection
    try {
      ModelApiResponse result = apiInstance.closeConnection(closeConnectionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#closeConnection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **closeConnectionRequest** | [**CloseConnectionRequest**](CloseConnectionRequest.md)| the node id of the connection | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="getConnections"></a>
# **getConnections**
> GetConnections200Response getConnections(body)

Retrieve the list of connections.

Retrieve the list of connections.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetConnections200Response result = apiInstance.getConnections(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#getConnections");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetConnections200Response**](GetConnections200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRoutes"></a>
# **getRoutes**
> GetRoutes200Response getRoutes(body)

Retrieve the list of routes exposed by the service.

Retrieve the list of routes/endpoints exposed by the service.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetRoutes200Response result = apiInstance.getRoutes(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#getRoutes");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetRoutes200Response**](GetRoutes200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="healthz"></a>
# **healthz**
> ModelApiResponse healthz(body)

Heartbeat.

Heartbeat.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.healthz(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#healthz");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="openConnection"></a>
# **openConnection**
> ModelApiResponse openConnection(openConnectionRequest)

Add a connection to another node.

Add a connection to another node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    OpenConnectionRequest openConnectionRequest = new OpenConnectionRequest(); // OpenConnectionRequest | the address of the connection
    try {
      ModelApiResponse result = apiInstance.openConnection(openConnectionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#openConnection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **openConnectionRequest** | [**OpenConnectionRequest**](OpenConnectionRequest.md)| the address of the connection | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="stopNode"></a>
# **stopNode**
> ModelApiResponse stopNode(body)

Stop the node.

Stop the node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SharedApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SharedApi apiInstance = new SharedApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.stopNode(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SharedApi#stopNode");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

