# SubscriptionsApi

All URIs are relative to *https://localhost:8561*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**removeSubscriptions**](SubscriptionsApi.md#removeSubscriptions) | **POST** /remove_subscriptions | Removes subscriptions for the given id. |
| [**subscribe**](SubscriptionsApi.md#subscribe) | **POST** /subscribe | Subscribe to singleton. |
| [**subscriptions**](SubscriptionsApi.md#subscriptions) | **POST** /subscriptions | List current subscriptions. |
| [**unsubscribe**](SubscriptionsApi.md#unsubscribe) | **POST** /unsubscribe | Unsubscribe from singleton. |


<a name="removeSubscriptions"></a>
# **removeSubscriptions**
> ModelApiResponse removeSubscriptions(subscribeRequest)

Removes subscriptions for the given id.

Removes subscriptions for the given id.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SubscriptionsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SubscriptionsApi apiInstance = new SubscriptionsApi(defaultClient);
    SubscribeRequest subscribeRequest = new SubscribeRequest(); // SubscribeRequest | 
    try {
      ModelApiResponse result = apiInstance.removeSubscriptions(subscribeRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SubscriptionsApi#removeSubscriptions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **subscribeRequest** | [**SubscribeRequest**](SubscribeRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="subscribe"></a>
# **subscribe**
> ModelApiResponse subscribe(subscribeRequest)

Subscribe to singleton.

Subscribe to singleton.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SubscriptionsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SubscriptionsApi apiInstance = new SubscriptionsApi(defaultClient);
    SubscribeRequest subscribeRequest = new SubscribeRequest(); // SubscribeRequest | 
    try {
      ModelApiResponse result = apiInstance.subscribe(subscribeRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SubscriptionsApi#subscribe");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **subscribeRequest** | [**SubscribeRequest**](SubscribeRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="subscriptions"></a>
# **subscriptions**
> GetOwnedStores200Response subscriptions(body)

List current subscriptions.

List current subscriptions.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SubscriptionsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SubscriptionsApi apiInstance = new SubscriptionsApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetOwnedStores200Response result = apiInstance.subscriptions(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SubscriptionsApi#subscriptions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetOwnedStores200Response**](GetOwnedStores200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="unsubscribe"></a>
# **unsubscribe**
> ModelApiResponse unsubscribe(getSyncStatusRequest)

Unsubscribe from singleton.

Unsubscribe from singleton.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.SubscriptionsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8561");
    

    SubscriptionsApi apiInstance = new SubscriptionsApi(defaultClient);
    GetSyncStatusRequest getSyncStatusRequest = new GetSyncStatusRequest(); // GetSyncStatusRequest | 
    try {
      ModelApiResponse result = apiInstance.unsubscribe(getSyncStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling SubscriptionsApi#unsubscribe");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSyncStatusRequest** | [**GetSyncStatusRequest**](GetSyncStatusRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

