/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.AddMissingFilesRequest;
import org.openapitools.client.model.BatchUpdate200Response;
import org.openapitools.client.model.BatchUpdateRequest;
import org.openapitools.client.model.CreateDataStore200Response;
import org.openapitools.client.model.CreateDataStoreRequest;
import org.openapitools.client.model.DeleteKeyRequest;
import org.openapitools.client.model.GetAncestors200Response;
import org.openapitools.client.model.GetAncestorsRequest;
import org.openapitools.client.model.GetKeys200Response;
import org.openapitools.client.model.GetKeysRequest;
import org.openapitools.client.model.GetKeysValues200Response;
import org.openapitools.client.model.GetKvDiff200Response;
import org.openapitools.client.model.GetKvDiffRequest;
import org.openapitools.client.model.GetLocalRoot200Response;
import org.openapitools.client.model.GetOwnedStores200Response;
import org.openapitools.client.model.GetRoot200Response;
import org.openapitools.client.model.GetRootHistory200Response;
import org.openapitools.client.model.GetRoots200Response;
import org.openapitools.client.model.GetRootsRequest;
import org.openapitools.client.model.GetSyncStatus200Response;
import org.openapitools.client.model.GetSyncStatusRequest;
import org.openapitools.client.model.GetValue200Response;
import org.openapitools.client.model.GetValueRequest;
import org.openapitools.client.model.InsertRequest;
import org.openapitools.client.model.ModelApiResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class DataLayerApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public DataLayerApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DataLayerApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for addMissingFiles
     * @param addMissingFilesRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addMissingFilesCall(AddMissingFilesRequest addMissingFilesRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = addMissingFilesRequest;

        // create path and map variables
        String localVarPath = "/add_missing_files";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call addMissingFilesValidateBeforeCall(AddMissingFilesRequest addMissingFilesRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'addMissingFilesRequest' is set
        if (addMissingFilesRequest == null) {
            throw new ApiException("Missing the required parameter 'addMissingFilesRequest' when calling addMissingFiles(Async)");
        }

        return addMissingFilesCall(addMissingFilesRequest, _callback);

    }

    /**
     * Complete the data server files.
     * Complete the data server files.
     * @param addMissingFilesRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse addMissingFiles(AddMissingFilesRequest addMissingFilesRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = addMissingFilesWithHttpInfo(addMissingFilesRequest);
        return localVarResp.getData();
    }

    /**
     * Complete the data server files.
     * Complete the data server files.
     * @param addMissingFilesRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> addMissingFilesWithHttpInfo(AddMissingFilesRequest addMissingFilesRequest) throws ApiException {
        okhttp3.Call localVarCall = addMissingFilesValidateBeforeCall(addMissingFilesRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Complete the data server files. (asynchronously)
     * Complete the data server files.
     * @param addMissingFilesRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addMissingFilesAsync(AddMissingFilesRequest addMissingFilesRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = addMissingFilesValidateBeforeCall(addMissingFilesRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for batchUpdate
     * @param batchUpdateRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call batchUpdateCall(BatchUpdateRequest batchUpdateRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = batchUpdateRequest;

        // create path and map variables
        String localVarPath = "/batch_update";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call batchUpdateValidateBeforeCall(BatchUpdateRequest batchUpdateRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'batchUpdateRequest' is set
        if (batchUpdateRequest == null) {
            throw new ApiException("Missing the required parameter 'batchUpdateRequest' when calling batchUpdate(Async)");
        }

        return batchUpdateCall(batchUpdateRequest, _callback);

    }

    /**
     * Applies a batch of updates.
     * Applies a batch of updates.
     * @param batchUpdateRequest  (required)
     * @return BatchUpdate200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public BatchUpdate200Response batchUpdate(BatchUpdateRequest batchUpdateRequest) throws ApiException {
        ApiResponse<BatchUpdate200Response> localVarResp = batchUpdateWithHttpInfo(batchUpdateRequest);
        return localVarResp.getData();
    }

    /**
     * Applies a batch of updates.
     * Applies a batch of updates.
     * @param batchUpdateRequest  (required)
     * @return ApiResponse&lt;BatchUpdate200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<BatchUpdate200Response> batchUpdateWithHttpInfo(BatchUpdateRequest batchUpdateRequest) throws ApiException {
        okhttp3.Call localVarCall = batchUpdateValidateBeforeCall(batchUpdateRequest, null);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Applies a batch of updates. (asynchronously)
     * Applies a batch of updates.
     * @param batchUpdateRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call batchUpdateAsync(BatchUpdateRequest batchUpdateRequest, final ApiCallback<BatchUpdate200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = batchUpdateValidateBeforeCall(batchUpdateRequest, _callback);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for createDataStore
     * @param createDataStoreRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createDataStoreCall(CreateDataStoreRequest createDataStoreRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = createDataStoreRequest;

        // create path and map variables
        String localVarPath = "/create_data_store";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createDataStoreValidateBeforeCall(CreateDataStoreRequest createDataStoreRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'createDataStoreRequest' is set
        if (createDataStoreRequest == null) {
            throw new ApiException("Missing the required parameter 'createDataStoreRequest' when calling createDataStore(Async)");
        }

        return createDataStoreCall(createDataStoreRequest, _callback);

    }

    /**
     * Creates a data store.
     * Creates a data store.
     * @param createDataStoreRequest  (required)
     * @return CreateDataStore200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CreateDataStore200Response createDataStore(CreateDataStoreRequest createDataStoreRequest) throws ApiException {
        ApiResponse<CreateDataStore200Response> localVarResp = createDataStoreWithHttpInfo(createDataStoreRequest);
        return localVarResp.getData();
    }

    /**
     * Creates a data store.
     * Creates a data store.
     * @param createDataStoreRequest  (required)
     * @return ApiResponse&lt;CreateDataStore200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateDataStore200Response> createDataStoreWithHttpInfo(CreateDataStoreRequest createDataStoreRequest) throws ApiException {
        okhttp3.Call localVarCall = createDataStoreValidateBeforeCall(createDataStoreRequest, null);
        Type localVarReturnType = new TypeToken<CreateDataStore200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Creates a data store. (asynchronously)
     * Creates a data store.
     * @param createDataStoreRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createDataStoreAsync(CreateDataStoreRequest createDataStoreRequest, final ApiCallback<CreateDataStore200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = createDataStoreValidateBeforeCall(createDataStoreRequest, _callback);
        Type localVarReturnType = new TypeToken<CreateDataStore200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteKey
     * @param deleteKeyRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteKeyCall(DeleteKeyRequest deleteKeyRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = deleteKeyRequest;

        // create path and map variables
        String localVarPath = "/delete_key";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteKeyValidateBeforeCall(DeleteKeyRequest deleteKeyRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'deleteKeyRequest' is set
        if (deleteKeyRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteKeyRequest' when calling deleteKey(Async)");
        }

        return deleteKeyCall(deleteKeyRequest, _callback);

    }

    /**
     * Removes a list of rows.
     * Removes a list of rows.
     * @param deleteKeyRequest  (required)
     * @return BatchUpdate200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public BatchUpdate200Response deleteKey(DeleteKeyRequest deleteKeyRequest) throws ApiException {
        ApiResponse<BatchUpdate200Response> localVarResp = deleteKeyWithHttpInfo(deleteKeyRequest);
        return localVarResp.getData();
    }

    /**
     * Removes a list of rows.
     * Removes a list of rows.
     * @param deleteKeyRequest  (required)
     * @return ApiResponse&lt;BatchUpdate200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<BatchUpdate200Response> deleteKeyWithHttpInfo(DeleteKeyRequest deleteKeyRequest) throws ApiException {
        okhttp3.Call localVarCall = deleteKeyValidateBeforeCall(deleteKeyRequest, null);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Removes a list of rows. (asynchronously)
     * Removes a list of rows.
     * @param deleteKeyRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteKeyAsync(DeleteKeyRequest deleteKeyRequest, final ApiCallback<BatchUpdate200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteKeyValidateBeforeCall(deleteKeyRequest, _callback);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getAncestors
     * @param getAncestorsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAncestorsCall(GetAncestorsRequest getAncestorsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getAncestorsRequest;

        // create path and map variables
        String localVarPath = "/get_ancestors";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getAncestorsValidateBeforeCall(GetAncestorsRequest getAncestorsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getAncestorsRequest' is set
        if (getAncestorsRequest == null) {
            throw new ApiException("Missing the required parameter 'getAncestorsRequest' when calling getAncestors(Async)");
        }

        return getAncestorsCall(getAncestorsRequest, _callback);

    }

    /**
     * Gets the list of ancestors for a given id/hash pair.
     * Gets the list of ancestors for a given id/hash pair.
     * @param getAncestorsRequest  (required)
     * @return GetAncestors200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetAncestors200Response getAncestors(GetAncestorsRequest getAncestorsRequest) throws ApiException {
        ApiResponse<GetAncestors200Response> localVarResp = getAncestorsWithHttpInfo(getAncestorsRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the list of ancestors for a given id/hash pair.
     * Gets the list of ancestors for a given id/hash pair.
     * @param getAncestorsRequest  (required)
     * @return ApiResponse&lt;GetAncestors200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetAncestors200Response> getAncestorsWithHttpInfo(GetAncestorsRequest getAncestorsRequest) throws ApiException {
        okhttp3.Call localVarCall = getAncestorsValidateBeforeCall(getAncestorsRequest, null);
        Type localVarReturnType = new TypeToken<GetAncestors200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the list of ancestors for a given id/hash pair. (asynchronously)
     * Gets the list of ancestors for a given id/hash pair.
     * @param getAncestorsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAncestorsAsync(GetAncestorsRequest getAncestorsRequest, final ApiCallback<GetAncestors200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getAncestorsValidateBeforeCall(getAncestorsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetAncestors200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getKeys
     * @param getKeysRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeysCall(GetKeysRequest getKeysRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getKeysRequest;

        // create path and map variables
        String localVarPath = "/get_keys";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getKeysValidateBeforeCall(GetKeysRequest getKeysRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getKeysRequest' is set
        if (getKeysRequest == null) {
            throw new ApiException("Missing the required parameter 'getKeysRequest' when calling getKeys(Async)");
        }

        return getKeysCall(getKeysRequest, _callback);

    }

    /**
     * Get the keys for a given id/root_hash pair.
     * Get the keys for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @return GetKeys200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetKeys200Response getKeys(GetKeysRequest getKeysRequest) throws ApiException {
        ApiResponse<GetKeys200Response> localVarResp = getKeysWithHttpInfo(getKeysRequest);
        return localVarResp.getData();
    }

    /**
     * Get the keys for a given id/root_hash pair.
     * Get the keys for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @return ApiResponse&lt;GetKeys200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetKeys200Response> getKeysWithHttpInfo(GetKeysRequest getKeysRequest) throws ApiException {
        okhttp3.Call localVarCall = getKeysValidateBeforeCall(getKeysRequest, null);
        Type localVarReturnType = new TypeToken<GetKeys200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the keys for a given id/root_hash pair. (asynchronously)
     * Get the keys for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeysAsync(GetKeysRequest getKeysRequest, final ApiCallback<GetKeys200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getKeysValidateBeforeCall(getKeysRequest, _callback);
        Type localVarReturnType = new TypeToken<GetKeys200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getKeysValues
     * @param getKeysRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeysValuesCall(GetKeysRequest getKeysRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getKeysRequest;

        // create path and map variables
        String localVarPath = "/get_keys_values";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getKeysValuesValidateBeforeCall(GetKeysRequest getKeysRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getKeysRequest' is set
        if (getKeysRequest == null) {
            throw new ApiException("Missing the required parameter 'getKeysRequest' when calling getKeysValues(Async)");
        }

        return getKeysValuesCall(getKeysRequest, _callback);

    }

    /**
     * Get the keys and values for a given id/root_hash pair.
     * Get the keys and values for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @return GetKeysValues200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetKeysValues200Response getKeysValues(GetKeysRequest getKeysRequest) throws ApiException {
        ApiResponse<GetKeysValues200Response> localVarResp = getKeysValuesWithHttpInfo(getKeysRequest);
        return localVarResp.getData();
    }

    /**
     * Get the keys and values for a given id/root_hash pair.
     * Get the keys and values for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @return ApiResponse&lt;GetKeysValues200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetKeysValues200Response> getKeysValuesWithHttpInfo(GetKeysRequest getKeysRequest) throws ApiException {
        okhttp3.Call localVarCall = getKeysValuesValidateBeforeCall(getKeysRequest, null);
        Type localVarReturnType = new TypeToken<GetKeysValues200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the keys and values for a given id/root_hash pair. (asynchronously)
     * Get the keys and values for a given id/root_hash pair.
     * @param getKeysRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKeysValuesAsync(GetKeysRequest getKeysRequest, final ApiCallback<GetKeysValues200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getKeysValuesValidateBeforeCall(getKeysRequest, _callback);
        Type localVarReturnType = new TypeToken<GetKeysValues200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getKvDiff
     * @param getKvDiffRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKvDiffCall(GetKvDiffRequest getKvDiffRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getKvDiffRequest;

        // create path and map variables
        String localVarPath = "/get_kv_diff";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getKvDiffValidateBeforeCall(GetKvDiffRequest getKvDiffRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getKvDiffRequest' is set
        if (getKvDiffRequest == null) {
            throw new ApiException("Missing the required parameter 'getKvDiffRequest' when calling getKvDiff(Async)");
        }

        return getKvDiffCall(getKvDiffRequest, _callback);

    }

    /**
     * Get kv diff between two root hashes.
     * Get kv diff between two root hashes.
     * @param getKvDiffRequest  (required)
     * @return GetKvDiff200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetKvDiff200Response getKvDiff(GetKvDiffRequest getKvDiffRequest) throws ApiException {
        ApiResponse<GetKvDiff200Response> localVarResp = getKvDiffWithHttpInfo(getKvDiffRequest);
        return localVarResp.getData();
    }

    /**
     * Get kv diff between two root hashes.
     * Get kv diff between two root hashes.
     * @param getKvDiffRequest  (required)
     * @return ApiResponse&lt;GetKvDiff200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetKvDiff200Response> getKvDiffWithHttpInfo(GetKvDiffRequest getKvDiffRequest) throws ApiException {
        okhttp3.Call localVarCall = getKvDiffValidateBeforeCall(getKvDiffRequest, null);
        Type localVarReturnType = new TypeToken<GetKvDiff200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get kv diff between two root hashes. (asynchronously)
     * Get kv diff between two root hashes.
     * @param getKvDiffRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getKvDiffAsync(GetKvDiffRequest getKvDiffRequest, final ApiCallback<GetKvDiff200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getKvDiffValidateBeforeCall(getKvDiffRequest, _callback);
        Type localVarReturnType = new TypeToken<GetKvDiff200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getLocalRoot
     * @param getSyncStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getLocalRootCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSyncStatusRequest;

        // create path and map variables
        String localVarPath = "/get_local_root";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getLocalRootValidateBeforeCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSyncStatusRequest' is set
        if (getSyncStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'getSyncStatusRequest' when calling getLocalRoot(Async)");
        }

        return getLocalRootCall(getSyncStatusRequest, _callback);

    }

    /**
     * Gets hash of latest tree root saved in our local datastore.
     * Gets hash of latest tree root saved in our local datastore.
     * @param getSyncStatusRequest  (required)
     * @return GetLocalRoot200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetLocalRoot200Response getLocalRoot(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        ApiResponse<GetLocalRoot200Response> localVarResp = getLocalRootWithHttpInfo(getSyncStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Gets hash of latest tree root saved in our local datastore.
     * Gets hash of latest tree root saved in our local datastore.
     * @param getSyncStatusRequest  (required)
     * @return ApiResponse&lt;GetLocalRoot200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetLocalRoot200Response> getLocalRootWithHttpInfo(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = getLocalRootValidateBeforeCall(getSyncStatusRequest, null);
        Type localVarReturnType = new TypeToken<GetLocalRoot200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets hash of latest tree root saved in our local datastore. (asynchronously)
     * Gets hash of latest tree root saved in our local datastore.
     * @param getSyncStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getLocalRootAsync(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback<GetLocalRoot200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getLocalRootValidateBeforeCall(getSyncStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<GetLocalRoot200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getOwnedStores
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOwnedStoresCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_owned_stores";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getOwnedStoresValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getOwnedStores(Async)");
        }

        return getOwnedStoresCall(body, _callback);

    }

    /**
     * Gets the list of owned store ids.
     * Gets the list of owned store ids.
     * @param body Empty request body (required)
     * @return GetOwnedStores200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetOwnedStores200Response getOwnedStores(Object body) throws ApiException {
        ApiResponse<GetOwnedStores200Response> localVarResp = getOwnedStoresWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Gets the list of owned store ids.
     * Gets the list of owned store ids.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetOwnedStores200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetOwnedStores200Response> getOwnedStoresWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getOwnedStoresValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetOwnedStores200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the list of owned store ids. (asynchronously)
     * Gets the list of owned store ids.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOwnedStoresAsync(Object body, final ApiCallback<GetOwnedStores200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getOwnedStoresValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetOwnedStores200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getRoot
     * @param getSyncStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSyncStatusRequest;

        // create path and map variables
        String localVarPath = "/get_root";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getRootValidateBeforeCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSyncStatusRequest' is set
        if (getSyncStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'getSyncStatusRequest' when calling getRoot(Async)");
        }

        return getRootCall(getSyncStatusRequest, _callback);

    }

    /**
     * Gets hash of latest tree root.
     * Gets hash of latest tree root.
     * @param getSyncStatusRequest  (required)
     * @return GetRoot200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetRoot200Response getRoot(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        ApiResponse<GetRoot200Response> localVarResp = getRootWithHttpInfo(getSyncStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Gets hash of latest tree root.
     * Gets hash of latest tree root.
     * @param getSyncStatusRequest  (required)
     * @return ApiResponse&lt;GetRoot200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetRoot200Response> getRootWithHttpInfo(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = getRootValidateBeforeCall(getSyncStatusRequest, null);
        Type localVarReturnType = new TypeToken<GetRoot200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets hash of latest tree root. (asynchronously)
     * Gets hash of latest tree root.
     * @param getSyncStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootAsync(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback<GetRoot200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getRootValidateBeforeCall(getSyncStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<GetRoot200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getRootHistory
     * @param getSyncStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootHistoryCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSyncStatusRequest;

        // create path and map variables
        String localVarPath = "/get_root_history";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getRootHistoryValidateBeforeCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSyncStatusRequest' is set
        if (getSyncStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'getSyncStatusRequest' when calling getRootHistory(Async)");
        }

        return getRootHistoryCall(getSyncStatusRequest, _callback);

    }

    /**
     * Get history of state hashes for a store.
     * Get history of state hashes for a store.
     * @param getSyncStatusRequest  (required)
     * @return GetRootHistory200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetRootHistory200Response getRootHistory(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        ApiResponse<GetRootHistory200Response> localVarResp = getRootHistoryWithHttpInfo(getSyncStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Get history of state hashes for a store.
     * Get history of state hashes for a store.
     * @param getSyncStatusRequest  (required)
     * @return ApiResponse&lt;GetRootHistory200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetRootHistory200Response> getRootHistoryWithHttpInfo(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = getRootHistoryValidateBeforeCall(getSyncStatusRequest, null);
        Type localVarReturnType = new TypeToken<GetRootHistory200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get history of state hashes for a store. (asynchronously)
     * Get history of state hashes for a store.
     * @param getSyncStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootHistoryAsync(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback<GetRootHistory200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getRootHistoryValidateBeforeCall(getSyncStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<GetRootHistory200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getRoots
     * @param getRootsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootsCall(GetRootsRequest getRootsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getRootsRequest;

        // create path and map variables
        String localVarPath = "/get_roots";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getRootsValidateBeforeCall(GetRootsRequest getRootsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getRootsRequest' is set
        if (getRootsRequest == null) {
            throw new ApiException("Missing the required parameter 'getRootsRequest' when calling getRoots(Async)");
        }

        return getRootsCall(getRootsRequest, _callback);

    }

    /**
     * Gets state hashes for a list of roots
     * Gets state hashes for a list of roots.
     * @param getRootsRequest  (required)
     * @return GetRoots200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetRoots200Response getRoots(GetRootsRequest getRootsRequest) throws ApiException {
        ApiResponse<GetRoots200Response> localVarResp = getRootsWithHttpInfo(getRootsRequest);
        return localVarResp.getData();
    }

    /**
     * Gets state hashes for a list of roots
     * Gets state hashes for a list of roots.
     * @param getRootsRequest  (required)
     * @return ApiResponse&lt;GetRoots200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetRoots200Response> getRootsWithHttpInfo(GetRootsRequest getRootsRequest) throws ApiException {
        okhttp3.Call localVarCall = getRootsValidateBeforeCall(getRootsRequest, null);
        Type localVarReturnType = new TypeToken<GetRoots200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets state hashes for a list of roots (asynchronously)
     * Gets state hashes for a list of roots.
     * @param getRootsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRootsAsync(GetRootsRequest getRootsRequest, final ApiCallback<GetRoots200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getRootsValidateBeforeCall(getRootsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetRoots200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getSyncStatus
     * @param getSyncStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSyncStatusCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSyncStatusRequest;

        // create path and map variables
        String localVarPath = "/get_sync_status";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getSyncStatusValidateBeforeCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSyncStatusRequest' is set
        if (getSyncStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'getSyncStatusRequest' when calling getSyncStatus(Async)");
        }

        return getSyncStatusCall(getSyncStatusRequest, _callback);

    }

    /**
     * Gets the sync status of a store.
     * Gets the sync status of a store.
     * @param getSyncStatusRequest  (required)
     * @return GetSyncStatus200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetSyncStatus200Response getSyncStatus(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        ApiResponse<GetSyncStatus200Response> localVarResp = getSyncStatusWithHttpInfo(getSyncStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the sync status of a store.
     * Gets the sync status of a store.
     * @param getSyncStatusRequest  (required)
     * @return ApiResponse&lt;GetSyncStatus200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetSyncStatus200Response> getSyncStatusWithHttpInfo(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = getSyncStatusValidateBeforeCall(getSyncStatusRequest, null);
        Type localVarReturnType = new TypeToken<GetSyncStatus200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the sync status of a store. (asynchronously)
     * Gets the sync status of a store.
     * @param getSyncStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSyncStatusAsync(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback<GetSyncStatus200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getSyncStatusValidateBeforeCall(getSyncStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<GetSyncStatus200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getValue
     * @param getValueRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getValueCall(GetValueRequest getValueRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getValueRequest;

        // create path and map variables
        String localVarPath = "/get_value";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getValueValidateBeforeCall(GetValueRequest getValueRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getValueRequest' is set
        if (getValueRequest == null) {
            throw new ApiException("Missing the required parameter 'getValueRequest' when calling getValue(Async)");
        }

        return getValueCall(getValueRequest, _callback);

    }

    /**
     * Get the value for a given id/key pair.
     * Get the value for a given id/key pair.
     * @param getValueRequest  (required)
     * @return GetValue200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetValue200Response getValue(GetValueRequest getValueRequest) throws ApiException {
        ApiResponse<GetValue200Response> localVarResp = getValueWithHttpInfo(getValueRequest);
        return localVarResp.getData();
    }

    /**
     * Get the value for a given id/key pair.
     * Get the value for a given id/key pair.
     * @param getValueRequest  (required)
     * @return ApiResponse&lt;GetValue200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetValue200Response> getValueWithHttpInfo(GetValueRequest getValueRequest) throws ApiException {
        okhttp3.Call localVarCall = getValueValidateBeforeCall(getValueRequest, null);
        Type localVarReturnType = new TypeToken<GetValue200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the value for a given id/key pair. (asynchronously)
     * Get the value for a given id/key pair.
     * @param getValueRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getValueAsync(GetValueRequest getValueRequest, final ApiCallback<GetValue200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getValueValidateBeforeCall(getValueRequest, _callback);
        Type localVarReturnType = new TypeToken<GetValue200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for insert
     * @param insertRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call insertCall(InsertRequest insertRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = insertRequest;

        // create path and map variables
        String localVarPath = "/insert";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call insertValidateBeforeCall(InsertRequest insertRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'insertRequest' is set
        if (insertRequest == null) {
            throw new ApiException("Missing the required parameter 'insertRequest' when calling insert(Async)");
        }

        return insertCall(insertRequest, _callback);

    }

    /**
     * Adds a list of clvm objects as bytes to add to table.
     * Adds a list of clvm objects as bytes to add to table.
     * @param insertRequest  (required)
     * @return BatchUpdate200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public BatchUpdate200Response insert(InsertRequest insertRequest) throws ApiException {
        ApiResponse<BatchUpdate200Response> localVarResp = insertWithHttpInfo(insertRequest);
        return localVarResp.getData();
    }

    /**
     * Adds a list of clvm objects as bytes to add to table.
     * Adds a list of clvm objects as bytes to add to table.
     * @param insertRequest  (required)
     * @return ApiResponse&lt;BatchUpdate200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<BatchUpdate200Response> insertWithHttpInfo(InsertRequest insertRequest) throws ApiException {
        okhttp3.Call localVarCall = insertValidateBeforeCall(insertRequest, null);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Adds a list of clvm objects as bytes to add to table. (asynchronously)
     * Adds a list of clvm objects as bytes to add to table.
     * @param insertRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call insertAsync(InsertRequest insertRequest, final ApiCallback<BatchUpdate200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = insertValidateBeforeCall(insertRequest, _callback);
        Type localVarReturnType = new TypeToken<BatchUpdate200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
