/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.AddMirrorRequest;
import org.openapitools.client.model.DeleteMirrorRequest;
import org.openapitools.client.model.GetMirrors200Response;
import org.openapitools.client.model.GetSyncStatusRequest;
import org.openapitools.client.model.ModelApiResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class MirrorsApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public MirrorsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public MirrorsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for addMirror
     * @param addMirrorRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addMirrorCall(AddMirrorRequest addMirrorRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = addMirrorRequest;

        // create path and map variables
        String localVarPath = "/add_mirror";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call addMirrorValidateBeforeCall(AddMirrorRequest addMirrorRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'addMirrorRequest' is set
        if (addMirrorRequest == null) {
            throw new ApiException("Missing the required parameter 'addMirrorRequest' when calling addMirror(Async)");
        }

        return addMirrorCall(addMirrorRequest, _callback);

    }

    /**
     * Adds a mirror.
     * Adds a mirror.
     * @param addMirrorRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse addMirror(AddMirrorRequest addMirrorRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = addMirrorWithHttpInfo(addMirrorRequest);
        return localVarResp.getData();
    }

    /**
     * Adds a mirror.
     * Adds a mirror.
     * @param addMirrorRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> addMirrorWithHttpInfo(AddMirrorRequest addMirrorRequest) throws ApiException {
        okhttp3.Call localVarCall = addMirrorValidateBeforeCall(addMirrorRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Adds a mirror. (asynchronously)
     * Adds a mirror.
     * @param addMirrorRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call addMirrorAsync(AddMirrorRequest addMirrorRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = addMirrorValidateBeforeCall(addMirrorRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteMirror
     * @param deleteMirrorRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteMirrorCall(DeleteMirrorRequest deleteMirrorRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = deleteMirrorRequest;

        // create path and map variables
        String localVarPath = "/delete_mirror";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteMirrorValidateBeforeCall(DeleteMirrorRequest deleteMirrorRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'deleteMirrorRequest' is set
        if (deleteMirrorRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteMirrorRequest' when calling deleteMirror(Async)");
        }

        return deleteMirrorCall(deleteMirrorRequest, _callback);

    }

    /**
     * Deletes a mirror.
     * Deletes a mirror.
     * @param deleteMirrorRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse deleteMirror(DeleteMirrorRequest deleteMirrorRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = deleteMirrorWithHttpInfo(deleteMirrorRequest);
        return localVarResp.getData();
    }

    /**
     * Deletes a mirror.
     * Deletes a mirror.
     * @param deleteMirrorRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> deleteMirrorWithHttpInfo(DeleteMirrorRequest deleteMirrorRequest) throws ApiException {
        okhttp3.Call localVarCall = deleteMirrorValidateBeforeCall(deleteMirrorRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Deletes a mirror. (asynchronously)
     * Deletes a mirror.
     * @param deleteMirrorRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteMirrorAsync(DeleteMirrorRequest deleteMirrorRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteMirrorValidateBeforeCall(deleteMirrorRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getMirrors
     * @param getSyncStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getMirrorsCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSyncStatusRequest;

        // create path and map variables
        String localVarPath = "/get_mirrors";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getMirrorsValidateBeforeCall(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSyncStatusRequest' is set
        if (getSyncStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'getSyncStatusRequest' when calling getMirrors(Async)");
        }

        return getMirrorsCall(getSyncStatusRequest, _callback);

    }

    /**
     * Gets the mirrors for a given store id.
     * Gets the mirrors for a given store id.
     * @param getSyncStatusRequest  (required)
     * @return GetMirrors200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetMirrors200Response getMirrors(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        ApiResponse<GetMirrors200Response> localVarResp = getMirrorsWithHttpInfo(getSyncStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the mirrors for a given store id.
     * Gets the mirrors for a given store id.
     * @param getSyncStatusRequest  (required)
     * @return ApiResponse&lt;GetMirrors200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetMirrors200Response> getMirrorsWithHttpInfo(GetSyncStatusRequest getSyncStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = getMirrorsValidateBeforeCall(getSyncStatusRequest, null);
        Type localVarReturnType = new TypeToken<GetMirrors200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the mirrors for a given store id. (asynchronously)
     * Gets the mirrors for a given store id.
     * @param getSyncStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getMirrorsAsync(GetSyncStatusRequest getSyncStatusRequest, final ApiCallback<GetMirrors200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getMirrorsValidateBeforeCall(getSyncStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<GetMirrors200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
