/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Coin
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class Coin {
  public static final String SERIALIZED_NAME_PARENT_COIN_INFO = "parent_coin_info";
  @SerializedName(SERIALIZED_NAME_PARENT_COIN_INFO)
  private String parentCoinInfo;

  public static final String SERIALIZED_NAME_PUZZLE_HASH = "puzzle_hash";
  @SerializedName(SERIALIZED_NAME_PUZZLE_HASH)
  private String puzzleHash;

  public static final String SERIALIZED_NAME_AMOUNT = "amount";
  @SerializedName(SERIALIZED_NAME_AMOUNT)
  private Integer amount;

  public Coin() {
  }

  public Coin parentCoinInfo(String parentCoinInfo) {
    
    this.parentCoinInfo = parentCoinInfo;
    return this;
  }

   /**
   * Get parentCoinInfo
   * @return parentCoinInfo
  **/
  @javax.annotation.Nullable

  public String getParentCoinInfo() {
    return parentCoinInfo;
  }


  public void setParentCoinInfo(String parentCoinInfo) {
    this.parentCoinInfo = parentCoinInfo;
  }


  public Coin puzzleHash(String puzzleHash) {
    
    this.puzzleHash = puzzleHash;
    return this;
  }

   /**
   * Get puzzleHash
   * @return puzzleHash
  **/
  @javax.annotation.Nullable

  public String getPuzzleHash() {
    return puzzleHash;
  }


  public void setPuzzleHash(String puzzleHash) {
    this.puzzleHash = puzzleHash;
  }


  public Coin amount(Integer amount) {
    
    this.amount = amount;
    return this;
  }

   /**
   * Get amount
   * @return amount
  **/
  @javax.annotation.Nullable

  public Integer getAmount() {
    return amount;
  }


  public void setAmount(Integer amount) {
    this.amount = amount;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Coin coin = (Coin) o;
    return Objects.equals(this.parentCoinInfo, coin.parentCoinInfo) &&
        Objects.equals(this.puzzleHash, coin.puzzleHash) &&
        Objects.equals(this.amount, coin.amount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(parentCoinInfo, puzzleHash, amount);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Coin {\n");
    sb.append("    parentCoinInfo: ").append(toIndentedString(parentCoinInfo)).append("\n");
    sb.append("    puzzleHash: ").append(toIndentedString(puzzleHash)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("parent_coin_info");
    openapiFields.add("puzzle_hash");
    openapiFields.add("amount");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to Coin
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!Coin.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in Coin is not found in the empty JSON string", Coin.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!Coin.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `Coin` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("parent_coin_info") != null && !jsonObj.get("parent_coin_info").isJsonNull()) && !jsonObj.get("parent_coin_info").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `parent_coin_info` to be a primitive type in the JSON string but got `%s`", jsonObj.get("parent_coin_info").toString()));
      }
      if ((jsonObj.get("puzzle_hash") != null && !jsonObj.get("puzzle_hash").isJsonNull()) && !jsonObj.get("puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("puzzle_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!Coin.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'Coin' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<Coin> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(Coin.class));

       return (TypeAdapter<T>) new TypeAdapter<Coin>() {
           @Override
           public void write(JsonWriter out, Coin value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public Coin read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of Coin given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of Coin
  * @throws IOException if the JSON string is invalid with respect to Coin
  */
  public static Coin fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, Coin.class);
  }

 /**
  * Convert an instance of Coin to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

