/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.GetKvDiff200ResponseAllOfDiffInner;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetKvDiff200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class GetKvDiff200ResponseAllOf {
  public static final String SERIALIZED_NAME_DIFF = "diff";
  @SerializedName(SERIALIZED_NAME_DIFF)
  private List<GetKvDiff200ResponseAllOfDiffInner> diff;

  public GetKvDiff200ResponseAllOf() {
  }

  public GetKvDiff200ResponseAllOf diff(List<GetKvDiff200ResponseAllOfDiffInner> diff) {
    
    this.diff = diff;
    return this;
  }

  public GetKvDiff200ResponseAllOf addDiffItem(GetKvDiff200ResponseAllOfDiffInner diffItem) {
    if (this.diff == null) {
      this.diff = new ArrayList<>();
    }
    this.diff.add(diffItem);
    return this;
  }

   /**
   * Get diff
   * @return diff
  **/
  @javax.annotation.Nullable

  public List<GetKvDiff200ResponseAllOfDiffInner> getDiff() {
    return diff;
  }


  public void setDiff(List<GetKvDiff200ResponseAllOfDiffInner> diff) {
    this.diff = diff;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetKvDiff200ResponseAllOf getKvDiff200ResponseAllOf = (GetKvDiff200ResponseAllOf) o;
    return Objects.equals(this.diff, getKvDiff200ResponseAllOf.diff);
  }

  @Override
  public int hashCode() {
    return Objects.hash(diff);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetKvDiff200ResponseAllOf {\n");
    sb.append("    diff: ").append(toIndentedString(diff)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("diff");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetKvDiff200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetKvDiff200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetKvDiff200ResponseAllOf is not found in the empty JSON string", GetKvDiff200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetKvDiff200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetKvDiff200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("diff") != null && !jsonObj.get("diff").isJsonNull()) {
        JsonArray jsonArraydiff = jsonObj.getAsJsonArray("diff");
        if (jsonArraydiff != null) {
          // ensure the json data is an array
          if (!jsonObj.get("diff").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `diff` to be an array in the JSON string but got `%s`", jsonObj.get("diff").toString()));
          }

          // validate the optional field `diff` (array)
          for (int i = 0; i < jsonArraydiff.size(); i++) {
            GetKvDiff200ResponseAllOfDiffInner.validateJsonObject(jsonArraydiff.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetKvDiff200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetKvDiff200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetKvDiff200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetKvDiff200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetKvDiff200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetKvDiff200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetKvDiff200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetKvDiff200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetKvDiff200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetKvDiff200ResponseAllOf
  */
  public static GetKvDiff200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetKvDiff200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetKvDiff200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

