/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetSyncStatus200ResponseAllOfSyncStatus
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class GetSyncStatus200ResponseAllOfSyncStatus {
  public static final String SERIALIZED_NAME_ROOT_HASH = "root_hash";
  @SerializedName(SERIALIZED_NAME_ROOT_HASH)
  private String rootHash;

  public static final String SERIALIZED_NAME_GENERATION = "generation";
  @SerializedName(SERIALIZED_NAME_GENERATION)
  private Integer generation;

  public static final String SERIALIZED_NAME_TARGET_ROOT_HASH = "target_root_hash";
  @SerializedName(SERIALIZED_NAME_TARGET_ROOT_HASH)
  private String targetRootHash;

  public static final String SERIALIZED_NAME_TARGET_GENERATION = "target_generation";
  @SerializedName(SERIALIZED_NAME_TARGET_GENERATION)
  private Integer targetGeneration;

  public GetSyncStatus200ResponseAllOfSyncStatus() {
  }

  public GetSyncStatus200ResponseAllOfSyncStatus rootHash(String rootHash) {
    
    this.rootHash = rootHash;
    return this;
  }

   /**
   * Get rootHash
   * @return rootHash
  **/
  @javax.annotation.Nullable

  public String getRootHash() {
    return rootHash;
  }


  public void setRootHash(String rootHash) {
    this.rootHash = rootHash;
  }


  public GetSyncStatus200ResponseAllOfSyncStatus generation(Integer generation) {
    
    this.generation = generation;
    return this;
  }

   /**
   * Get generation
   * @return generation
  **/
  @javax.annotation.Nullable

  public Integer getGeneration() {
    return generation;
  }


  public void setGeneration(Integer generation) {
    this.generation = generation;
  }


  public GetSyncStatus200ResponseAllOfSyncStatus targetRootHash(String targetRootHash) {
    
    this.targetRootHash = targetRootHash;
    return this;
  }

   /**
   * Get targetRootHash
   * @return targetRootHash
  **/
  @javax.annotation.Nullable

  public String getTargetRootHash() {
    return targetRootHash;
  }


  public void setTargetRootHash(String targetRootHash) {
    this.targetRootHash = targetRootHash;
  }


  public GetSyncStatus200ResponseAllOfSyncStatus targetGeneration(Integer targetGeneration) {
    
    this.targetGeneration = targetGeneration;
    return this;
  }

   /**
   * Get targetGeneration
   * @return targetGeneration
  **/
  @javax.annotation.Nullable

  public Integer getTargetGeneration() {
    return targetGeneration;
  }


  public void setTargetGeneration(Integer targetGeneration) {
    this.targetGeneration = targetGeneration;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetSyncStatus200ResponseAllOfSyncStatus getSyncStatus200ResponseAllOfSyncStatus = (GetSyncStatus200ResponseAllOfSyncStatus) o;
    return Objects.equals(this.rootHash, getSyncStatus200ResponseAllOfSyncStatus.rootHash) &&
        Objects.equals(this.generation, getSyncStatus200ResponseAllOfSyncStatus.generation) &&
        Objects.equals(this.targetRootHash, getSyncStatus200ResponseAllOfSyncStatus.targetRootHash) &&
        Objects.equals(this.targetGeneration, getSyncStatus200ResponseAllOfSyncStatus.targetGeneration);
  }

  @Override
  public int hashCode() {
    return Objects.hash(rootHash, generation, targetRootHash, targetGeneration);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetSyncStatus200ResponseAllOfSyncStatus {\n");
    sb.append("    rootHash: ").append(toIndentedString(rootHash)).append("\n");
    sb.append("    generation: ").append(toIndentedString(generation)).append("\n");
    sb.append("    targetRootHash: ").append(toIndentedString(targetRootHash)).append("\n");
    sb.append("    targetGeneration: ").append(toIndentedString(targetGeneration)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("root_hash");
    openapiFields.add("generation");
    openapiFields.add("target_root_hash");
    openapiFields.add("target_generation");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetSyncStatus200ResponseAllOfSyncStatus
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetSyncStatus200ResponseAllOfSyncStatus.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetSyncStatus200ResponseAllOfSyncStatus is not found in the empty JSON string", GetSyncStatus200ResponseAllOfSyncStatus.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetSyncStatus200ResponseAllOfSyncStatus.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetSyncStatus200ResponseAllOfSyncStatus` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("root_hash") != null && !jsonObj.get("root_hash").isJsonNull()) && !jsonObj.get("root_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `root_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("root_hash").toString()));
      }
      if ((jsonObj.get("target_root_hash") != null && !jsonObj.get("target_root_hash").isJsonNull()) && !jsonObj.get("target_root_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_root_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("target_root_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetSyncStatus200ResponseAllOfSyncStatus.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetSyncStatus200ResponseAllOfSyncStatus' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetSyncStatus200ResponseAllOfSyncStatus> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetSyncStatus200ResponseAllOfSyncStatus.class));

       return (TypeAdapter<T>) new TypeAdapter<GetSyncStatus200ResponseAllOfSyncStatus>() {
           @Override
           public void write(JsonWriter out, GetSyncStatus200ResponseAllOfSyncStatus value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetSyncStatus200ResponseAllOfSyncStatus read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetSyncStatus200ResponseAllOfSyncStatus given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetSyncStatus200ResponseAllOfSyncStatus
  * @throws IOException if the JSON string is invalid with respect to GetSyncStatus200ResponseAllOfSyncStatus
  */
  public static GetSyncStatus200ResponseAllOfSyncStatus fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetSyncStatus200ResponseAllOfSyncStatus.class);
  }

 /**
  * Convert an instance of GetSyncStatus200ResponseAllOfSyncStatus to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

