/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * InternalNode
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class InternalNode {
  public static final String SERIALIZED_NAME_HASH = "hash";
  @SerializedName(SERIALIZED_NAME_HASH)
  private String hash;

  public static final String SERIALIZED_NAME_LEFT_HASH = "left_hash";
  @SerializedName(SERIALIZED_NAME_LEFT_HASH)
  private String leftHash;

  public static final String SERIALIZED_NAME_RIGHT_HASH = "right_hash";
  @SerializedName(SERIALIZED_NAME_RIGHT_HASH)
  private String rightHash;

  public static final String SERIALIZED_NAME_PAIR = "pair";
  @SerializedName(SERIALIZED_NAME_PAIR)
  private List<Object> pair;

  public static final String SERIALIZED_NAME_ATOM = "atom";
  @SerializedName(SERIALIZED_NAME_ATOM)
  private String atom;

  public InternalNode() {
  }

  public InternalNode hash(String hash) {
    
    this.hash = hash;
    return this;
  }

   /**
   * Get hash
   * @return hash
  **/
  @javax.annotation.Nullable

  public String getHash() {
    return hash;
  }


  public void setHash(String hash) {
    this.hash = hash;
  }


  public InternalNode leftHash(String leftHash) {
    
    this.leftHash = leftHash;
    return this;
  }

   /**
   * Get leftHash
   * @return leftHash
  **/
  @javax.annotation.Nullable

  public String getLeftHash() {
    return leftHash;
  }


  public void setLeftHash(String leftHash) {
    this.leftHash = leftHash;
  }


  public InternalNode rightHash(String rightHash) {
    
    this.rightHash = rightHash;
    return this;
  }

   /**
   * Get rightHash
   * @return rightHash
  **/
  @javax.annotation.Nullable

  public String getRightHash() {
    return rightHash;
  }


  public void setRightHash(String rightHash) {
    this.rightHash = rightHash;
  }


  public InternalNode pair(List<Object> pair) {
    
    this.pair = pair;
    return this;
  }

  public InternalNode addPairItem(Object pairItem) {
    if (this.pair == null) {
      this.pair = new ArrayList<>();
    }
    this.pair.add(pairItem);
    return this;
  }

   /**
   * Get pair
   * @return pair
  **/
  @javax.annotation.Nullable

  public List<Object> getPair() {
    return pair;
  }


  public void setPair(List<Object> pair) {
    this.pair = pair;
  }


  public InternalNode atom(String atom) {
    
    this.atom = atom;
    return this;
  }

   /**
   * Get atom
   * @return atom
  **/
  @javax.annotation.Nullable

  public String getAtom() {
    return atom;
  }


  public void setAtom(String atom) {
    this.atom = atom;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InternalNode internalNode = (InternalNode) o;
    return Objects.equals(this.hash, internalNode.hash) &&
        Objects.equals(this.leftHash, internalNode.leftHash) &&
        Objects.equals(this.rightHash, internalNode.rightHash) &&
        Objects.equals(this.pair, internalNode.pair) &&
        Objects.equals(this.atom, internalNode.atom);
  }

  @Override
  public int hashCode() {
    return Objects.hash(hash, leftHash, rightHash, pair, atom);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InternalNode {\n");
    sb.append("    hash: ").append(toIndentedString(hash)).append("\n");
    sb.append("    leftHash: ").append(toIndentedString(leftHash)).append("\n");
    sb.append("    rightHash: ").append(toIndentedString(rightHash)).append("\n");
    sb.append("    pair: ").append(toIndentedString(pair)).append("\n");
    sb.append("    atom: ").append(toIndentedString(atom)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("hash");
    openapiFields.add("left_hash");
    openapiFields.add("right_hash");
    openapiFields.add("pair");
    openapiFields.add("atom");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to InternalNode
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!InternalNode.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in InternalNode is not found in the empty JSON string", InternalNode.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!InternalNode.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `InternalNode` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("hash") != null && !jsonObj.get("hash").isJsonNull()) && !jsonObj.get("hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("hash").toString()));
      }
      if ((jsonObj.get("left_hash") != null && !jsonObj.get("left_hash").isJsonNull()) && !jsonObj.get("left_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `left_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("left_hash").toString()));
      }
      if ((jsonObj.get("right_hash") != null && !jsonObj.get("right_hash").isJsonNull()) && !jsonObj.get("right_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `right_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("right_hash").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("pair") != null && !jsonObj.get("pair").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `pair` to be an array in the JSON string but got `%s`", jsonObj.get("pair").toString()));
      }
      if ((jsonObj.get("atom") != null && !jsonObj.get("atom").isJsonNull()) && !jsonObj.get("atom").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `atom` to be a primitive type in the JSON string but got `%s`", jsonObj.get("atom").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!InternalNode.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'InternalNode' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<InternalNode> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(InternalNode.class));

       return (TypeAdapter<T>) new TypeAdapter<InternalNode>() {
           @Override
           public void write(JsonWriter out, InternalNode value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public InternalNode read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of InternalNode given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of InternalNode
  * @throws IOException if the JSON string is invalid with respect to InternalNode
  */
  public static InternalNode fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, InternalNode.class);
  }

 /**
  * Convert an instance of InternalNode to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

