/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.KeyValue;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Layer
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class Layer {
  public static final String SERIALIZED_NAME_OTHER_HASH_SIDE = "other_hash_side";
  @SerializedName(SERIALIZED_NAME_OTHER_HASH_SIDE)
  private String otherHashSide;

  public static final String SERIALIZED_NAME_OTHER_HASH = "other_hash";
  @SerializedName(SERIALIZED_NAME_OTHER_HASH)
  private String otherHash;

  public static final String SERIALIZED_NAME_COMBINED_HASH = "combined_hash";
  @SerializedName(SERIALIZED_NAME_COMBINED_HASH)
  private List<KeyValue> combinedHash;

  public Layer() {
  }

  public Layer otherHashSide(String otherHashSide) {
    
    this.otherHashSide = otherHashSide;
    return this;
  }

   /**
   * Get otherHashSide
   * @return otherHashSide
  **/
  @javax.annotation.Nullable

  public String getOtherHashSide() {
    return otherHashSide;
  }


  public void setOtherHashSide(String otherHashSide) {
    this.otherHashSide = otherHashSide;
  }


  public Layer otherHash(String otherHash) {
    
    this.otherHash = otherHash;
    return this;
  }

   /**
   * Get otherHash
   * @return otherHash
  **/
  @javax.annotation.Nullable

  public String getOtherHash() {
    return otherHash;
  }


  public void setOtherHash(String otherHash) {
    this.otherHash = otherHash;
  }


  public Layer combinedHash(List<KeyValue> combinedHash) {
    
    this.combinedHash = combinedHash;
    return this;
  }

  public Layer addCombinedHashItem(KeyValue combinedHashItem) {
    if (this.combinedHash == null) {
      this.combinedHash = new ArrayList<>();
    }
    this.combinedHash.add(combinedHashItem);
    return this;
  }

   /**
   * Get combinedHash
   * @return combinedHash
  **/
  @javax.annotation.Nullable

  public List<KeyValue> getCombinedHash() {
    return combinedHash;
  }


  public void setCombinedHash(List<KeyValue> combinedHash) {
    this.combinedHash = combinedHash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Layer layer = (Layer) o;
    return Objects.equals(this.otherHashSide, layer.otherHashSide) &&
        Objects.equals(this.otherHash, layer.otherHash) &&
        Objects.equals(this.combinedHash, layer.combinedHash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(otherHashSide, otherHash, combinedHash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Layer {\n");
    sb.append("    otherHashSide: ").append(toIndentedString(otherHashSide)).append("\n");
    sb.append("    otherHash: ").append(toIndentedString(otherHash)).append("\n");
    sb.append("    combinedHash: ").append(toIndentedString(combinedHash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("other_hash_side");
    openapiFields.add("other_hash");
    openapiFields.add("combined_hash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to Layer
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!Layer.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in Layer is not found in the empty JSON string", Layer.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!Layer.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `Layer` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("other_hash_side") != null && !jsonObj.get("other_hash_side").isJsonNull()) && !jsonObj.get("other_hash_side").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `other_hash_side` to be a primitive type in the JSON string but got `%s`", jsonObj.get("other_hash_side").toString()));
      }
      if ((jsonObj.get("other_hash") != null && !jsonObj.get("other_hash").isJsonNull()) && !jsonObj.get("other_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `other_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("other_hash").toString()));
      }
      if (jsonObj.get("combined_hash") != null && !jsonObj.get("combined_hash").isJsonNull()) {
        JsonArray jsonArraycombinedHash = jsonObj.getAsJsonArray("combined_hash");
        if (jsonArraycombinedHash != null) {
          // ensure the json data is an array
          if (!jsonObj.get("combined_hash").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `combined_hash` to be an array in the JSON string but got `%s`", jsonObj.get("combined_hash").toString()));
          }

          // validate the optional field `combined_hash` (array)
          for (int i = 0; i < jsonArraycombinedHash.size(); i++) {
            KeyValue.validateJsonObject(jsonArraycombinedHash.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!Layer.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'Layer' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<Layer> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(Layer.class));

       return (TypeAdapter<T>) new TypeAdapter<Layer>() {
           @Override
           public void write(JsonWriter out, Layer value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public Layer read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of Layer given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of Layer
  * @throws IOException if the JSON string is invalid with respect to Layer
  */
  public static Layer fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, Layer.class);
  }

 /**
  * Convert an instance of Layer to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

