/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.SpendBundle;
import org.openapitools.client.model.TransactionType;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Used for storing transaction data and status in wallets.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:59:57.894897700-04:00[America/New_York]")
public class TransactionRecord {
  public static final String SERIALIZED_NAME_CONFIRMED_AT_HEIGHT = "confirmed_at_height";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_AT_HEIGHT)
  private Integer confirmedAtHeight;

  public static final String SERIALIZED_NAME_CREATED_AT_TIME = "created_at_time";
  @SerializedName(SERIALIZED_NAME_CREATED_AT_TIME)
  private Integer createdAtTime;

  public static final String SERIALIZED_NAME_TO_PUZZLE_HASH = "to_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_TO_PUZZLE_HASH)
  private String toPuzzleHash;

  public static final String SERIALIZED_NAME_AMOUNT = "amount";
  @SerializedName(SERIALIZED_NAME_AMOUNT)
  private Integer amount;

  public static final String SERIALIZED_NAME_FEE_AMOUNT = "fee_amount";
  @SerializedName(SERIALIZED_NAME_FEE_AMOUNT)
  private Integer feeAmount;

  public static final String SERIALIZED_NAME_CONFIRMED = "confirmed";
  @SerializedName(SERIALIZED_NAME_CONFIRMED)
  private Boolean confirmed;

  public static final String SERIALIZED_NAME_SENT = "sent";
  @SerializedName(SERIALIZED_NAME_SENT)
  private Integer sent;

  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public static final String SERIALIZED_NAME_ADDITIONS = "additions";
  @SerializedName(SERIALIZED_NAME_ADDITIONS)
  private List<Coin> additions;

  public static final String SERIALIZED_NAME_REMOVALS = "removals";
  @SerializedName(SERIALIZED_NAME_REMOVALS)
  private List<Coin> removals;

  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_SENT_TO = "sent_to";
  @SerializedName(SERIALIZED_NAME_SENT_TO)
  private List<List<String>> sentTo;

  public static final String SERIALIZED_NAME_TRADE_ID = "trade_id";
  @SerializedName(SERIALIZED_NAME_TRADE_ID)
  private String tradeId;

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private TransactionType type;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_MEMOS = "memos";
  @SerializedName(SERIALIZED_NAME_MEMOS)
  private List<List<String>> memos;

  public TransactionRecord() {
  }

  public TransactionRecord confirmedAtHeight(Integer confirmedAtHeight) {
    
    this.confirmedAtHeight = confirmedAtHeight;
    return this;
  }

   /**
   * Get confirmedAtHeight
   * @return confirmedAtHeight
  **/
  @javax.annotation.Nullable

  public Integer getConfirmedAtHeight() {
    return confirmedAtHeight;
  }


  public void setConfirmedAtHeight(Integer confirmedAtHeight) {
    this.confirmedAtHeight = confirmedAtHeight;
  }


  public TransactionRecord createdAtTime(Integer createdAtTime) {
    
    this.createdAtTime = createdAtTime;
    return this;
  }

   /**
   * Get createdAtTime
   * @return createdAtTime
  **/
  @javax.annotation.Nullable

  public Integer getCreatedAtTime() {
    return createdAtTime;
  }


  public void setCreatedAtTime(Integer createdAtTime) {
    this.createdAtTime = createdAtTime;
  }


  public TransactionRecord toPuzzleHash(String toPuzzleHash) {
    
    this.toPuzzleHash = toPuzzleHash;
    return this;
  }

   /**
   * Get toPuzzleHash
   * @return toPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getToPuzzleHash() {
    return toPuzzleHash;
  }


  public void setToPuzzleHash(String toPuzzleHash) {
    this.toPuzzleHash = toPuzzleHash;
  }


  public TransactionRecord amount(Integer amount) {
    
    this.amount = amount;
    return this;
  }

   /**
   * Get amount
   * @return amount
  **/
  @javax.annotation.Nullable

  public Integer getAmount() {
    return amount;
  }


  public void setAmount(Integer amount) {
    this.amount = amount;
  }


  public TransactionRecord feeAmount(Integer feeAmount) {
    
    this.feeAmount = feeAmount;
    return this;
  }

   /**
   * Get feeAmount
   * @return feeAmount
  **/
  @javax.annotation.Nullable

  public Integer getFeeAmount() {
    return feeAmount;
  }


  public void setFeeAmount(Integer feeAmount) {
    this.feeAmount = feeAmount;
  }


  public TransactionRecord confirmed(Boolean confirmed) {
    
    this.confirmed = confirmed;
    return this;
  }

   /**
   * Get confirmed
   * @return confirmed
  **/
  @javax.annotation.Nullable

  public Boolean getConfirmed() {
    return confirmed;
  }


  public void setConfirmed(Boolean confirmed) {
    this.confirmed = confirmed;
  }


  public TransactionRecord sent(Integer sent) {
    
    this.sent = sent;
    return this;
  }

   /**
   * Get sent
   * @return sent
  **/
  @javax.annotation.Nullable

  public Integer getSent() {
    return sent;
  }


  public void setSent(Integer sent) {
    this.sent = sent;
  }


  public TransactionRecord spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }


  public TransactionRecord additions(List<Coin> additions) {
    
    this.additions = additions;
    return this;
  }

  public TransactionRecord addAdditionsItem(Coin additionsItem) {
    if (this.additions == null) {
      this.additions = new ArrayList<>();
    }
    this.additions.add(additionsItem);
    return this;
  }

   /**
   * Get additions
   * @return additions
  **/
  @javax.annotation.Nullable

  public List<Coin> getAdditions() {
    return additions;
  }


  public void setAdditions(List<Coin> additions) {
    this.additions = additions;
  }


  public TransactionRecord removals(List<Coin> removals) {
    
    this.removals = removals;
    return this;
  }

  public TransactionRecord addRemovalsItem(Coin removalsItem) {
    if (this.removals == null) {
      this.removals = new ArrayList<>();
    }
    this.removals.add(removalsItem);
    return this;
  }

   /**
   * Get removals
   * @return removals
  **/
  @javax.annotation.Nullable

  public List<Coin> getRemovals() {
    return removals;
  }


  public void setRemovals(List<Coin> removals) {
    this.removals = removals;
  }


  public TransactionRecord walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public TransactionRecord sentTo(List<List<String>> sentTo) {
    
    this.sentTo = sentTo;
    return this;
  }

  public TransactionRecord addSentToItem(List<String> sentToItem) {
    if (this.sentTo == null) {
      this.sentTo = new ArrayList<>();
    }
    this.sentTo.add(sentToItem);
    return this;
  }

   /**
   * Represents the list of peers that we sent the transaction to, whether each one included it in the mempool, and what the error message (if any) was. List[Tuple[str, uint8, Optional[str]]]
   * @return sentTo
  **/
  @javax.annotation.Nullable

  public List<List<String>> getSentTo() {
    return sentTo;
  }


  public void setSentTo(List<List<String>> sentTo) {
    this.sentTo = sentTo;
  }


  public TransactionRecord tradeId(String tradeId) {
    
    this.tradeId = tradeId;
    return this;
  }

   /**
   * Get tradeId
   * @return tradeId
  **/
  @javax.annotation.Nullable

  public String getTradeId() {
    return tradeId;
  }


  public void setTradeId(String tradeId) {
    this.tradeId = tradeId;
  }


  public TransactionRecord type(TransactionType type) {
    
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @javax.annotation.Nullable

  public TransactionType getType() {
    return type;
  }


  public void setType(TransactionType type) {
    this.type = type;
  }


  public TransactionRecord name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @javax.annotation.Nullable

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public TransactionRecord memos(List<List<String>> memos) {
    
    this.memos = memos;
    return this;
  }

  public TransactionRecord addMemosItem(List<String> memosItem) {
    if (this.memos == null) {
      this.memos = new ArrayList<>();
    }
    this.memos.add(memosItem);
    return this;
  }

   /**
   * List[Tuple[bytes32, List[bytes]]]
   * @return memos
  **/
  @javax.annotation.Nullable

  public List<List<String>> getMemos() {
    return memos;
  }


  public void setMemos(List<List<String>> memos) {
    this.memos = memos;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TransactionRecord transactionRecord = (TransactionRecord) o;
    return Objects.equals(this.confirmedAtHeight, transactionRecord.confirmedAtHeight) &&
        Objects.equals(this.createdAtTime, transactionRecord.createdAtTime) &&
        Objects.equals(this.toPuzzleHash, transactionRecord.toPuzzleHash) &&
        Objects.equals(this.amount, transactionRecord.amount) &&
        Objects.equals(this.feeAmount, transactionRecord.feeAmount) &&
        Objects.equals(this.confirmed, transactionRecord.confirmed) &&
        Objects.equals(this.sent, transactionRecord.sent) &&
        Objects.equals(this.spendBundle, transactionRecord.spendBundle) &&
        Objects.equals(this.additions, transactionRecord.additions) &&
        Objects.equals(this.removals, transactionRecord.removals) &&
        Objects.equals(this.walletId, transactionRecord.walletId) &&
        Objects.equals(this.sentTo, transactionRecord.sentTo) &&
        Objects.equals(this.tradeId, transactionRecord.tradeId) &&
        Objects.equals(this.type, transactionRecord.type) &&
        Objects.equals(this.name, transactionRecord.name) &&
        Objects.equals(this.memos, transactionRecord.memos);
  }

  @Override
  public int hashCode() {
    return Objects.hash(confirmedAtHeight, createdAtTime, toPuzzleHash, amount, feeAmount, confirmed, sent, spendBundle, additions, removals, walletId, sentTo, tradeId, type, name, memos);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TransactionRecord {\n");
    sb.append("    confirmedAtHeight: ").append(toIndentedString(confirmedAtHeight)).append("\n");
    sb.append("    createdAtTime: ").append(toIndentedString(createdAtTime)).append("\n");
    sb.append("    toPuzzleHash: ").append(toIndentedString(toPuzzleHash)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    feeAmount: ").append(toIndentedString(feeAmount)).append("\n");
    sb.append("    confirmed: ").append(toIndentedString(confirmed)).append("\n");
    sb.append("    sent: ").append(toIndentedString(sent)).append("\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("    additions: ").append(toIndentedString(additions)).append("\n");
    sb.append("    removals: ").append(toIndentedString(removals)).append("\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    sentTo: ").append(toIndentedString(sentTo)).append("\n");
    sb.append("    tradeId: ").append(toIndentedString(tradeId)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    memos: ").append(toIndentedString(memos)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("confirmed_at_height");
    openapiFields.add("created_at_time");
    openapiFields.add("to_puzzle_hash");
    openapiFields.add("amount");
    openapiFields.add("fee_amount");
    openapiFields.add("confirmed");
    openapiFields.add("sent");
    openapiFields.add("spend_bundle");
    openapiFields.add("additions");
    openapiFields.add("removals");
    openapiFields.add("wallet_id");
    openapiFields.add("sent_to");
    openapiFields.add("trade_id");
    openapiFields.add("type");
    openapiFields.add("name");
    openapiFields.add("memos");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to TransactionRecord
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!TransactionRecord.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in TransactionRecord is not found in the empty JSON string", TransactionRecord.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!TransactionRecord.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `TransactionRecord` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("to_puzzle_hash") != null && !jsonObj.get("to_puzzle_hash").isJsonNull()) && !jsonObj.get("to_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `to_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("to_puzzle_hash").toString()));
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
      if (jsonObj.get("additions") != null && !jsonObj.get("additions").isJsonNull()) {
        JsonArray jsonArrayadditions = jsonObj.getAsJsonArray("additions");
        if (jsonArrayadditions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("additions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `additions` to be an array in the JSON string but got `%s`", jsonObj.get("additions").toString()));
          }

          // validate the optional field `additions` (array)
          for (int i = 0; i < jsonArrayadditions.size(); i++) {
            Coin.validateJsonObject(jsonArrayadditions.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("removals") != null && !jsonObj.get("removals").isJsonNull()) {
        JsonArray jsonArrayremovals = jsonObj.getAsJsonArray("removals");
        if (jsonArrayremovals != null) {
          // ensure the json data is an array
          if (!jsonObj.get("removals").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `removals` to be an array in the JSON string but got `%s`", jsonObj.get("removals").toString()));
          }

          // validate the optional field `removals` (array)
          for (int i = 0; i < jsonArrayremovals.size(); i++) {
            Coin.validateJsonObject(jsonArrayremovals.get(i).getAsJsonObject());
          };
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("sent_to") != null && !jsonObj.get("sent_to").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `sent_to` to be an array in the JSON string but got `%s`", jsonObj.get("sent_to").toString()));
      }
      if ((jsonObj.get("trade_id") != null && !jsonObj.get("trade_id").isJsonNull()) && !jsonObj.get("trade_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `trade_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("trade_id").toString()));
      }
      if ((jsonObj.get("name") != null && !jsonObj.get("name").isJsonNull()) && !jsonObj.get("name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("name").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("memos") != null && !jsonObj.get("memos").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `memos` to be an array in the JSON string but got `%s`", jsonObj.get("memos").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!TransactionRecord.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'TransactionRecord' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<TransactionRecord> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(TransactionRecord.class));

       return (TypeAdapter<T>) new TypeAdapter<TransactionRecord>() {
           @Override
           public void write(JsonWriter out, TransactionRecord value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public TransactionRecord read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of TransactionRecord given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of TransactionRecord
  * @throws IOException if the JSON string is invalid with respect to TransactionRecord
  */
  public static TransactionRecord fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, TransactionRecord.class);
  }

 /**
  * Convert an instance of TransactionRecord to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

