/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The data layer uses port 8561 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.AddMissingFilesRequest;
import org.openapitools.client.model.BatchUpdate200Response;
import org.openapitools.client.model.BatchUpdateRequest;
import org.openapitools.client.model.CreateDataStore200Response;
import org.openapitools.client.model.CreateDataStoreRequest;
import org.openapitools.client.model.DeleteKeyRequest;
import org.openapitools.client.model.GetAncestors200Response;
import org.openapitools.client.model.GetAncestorsRequest;
import org.openapitools.client.model.GetKeys200Response;
import org.openapitools.client.model.GetKeysRequest;
import org.openapitools.client.model.GetKeysValues200Response;
import org.openapitools.client.model.GetKvDiff200Response;
import org.openapitools.client.model.GetKvDiffRequest;
import org.openapitools.client.model.GetLocalRoot200Response;
import org.openapitools.client.model.GetOwnedStores200Response;
import org.openapitools.client.model.GetRoot200Response;
import org.openapitools.client.model.GetRootHistory200Response;
import org.openapitools.client.model.GetRoots200Response;
import org.openapitools.client.model.GetRootsRequest;
import org.openapitools.client.model.GetSyncStatus200Response;
import org.openapitools.client.model.GetSyncStatusRequest;
import org.openapitools.client.model.GetValue200Response;
import org.openapitools.client.model.GetValueRequest;
import org.openapitools.client.model.InsertRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for DataLayerApi
 */
@Disabled
public class DataLayerApiTest {

    private final DataLayerApi api = new DataLayerApi();

    /**
     * Complete the data server files.
     *
     * Complete the data server files.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addMissingFilesTest() throws ApiException {
        AddMissingFilesRequest addMissingFilesRequest = null;
        ModelApiResponse response = api.addMissingFiles(addMissingFilesRequest);
        // TODO: test validations
    }

    /**
     * Applies a batch of updates.
     *
     * Applies a batch of updates.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void batchUpdateTest() throws ApiException {
        BatchUpdateRequest batchUpdateRequest = null;
        BatchUpdate200Response response = api.batchUpdate(batchUpdateRequest);
        // TODO: test validations
    }

    /**
     * Creates a data store.
     *
     * Creates a data store.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void createDataStoreTest() throws ApiException {
        CreateDataStoreRequest createDataStoreRequest = null;
        CreateDataStore200Response response = api.createDataStore(createDataStoreRequest);
        // TODO: test validations
    }

    /**
     * Removes a list of rows.
     *
     * Removes a list of rows.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteKeyTest() throws ApiException {
        DeleteKeyRequest deleteKeyRequest = null;
        BatchUpdate200Response response = api.deleteKey(deleteKeyRequest);
        // TODO: test validations
    }

    /**
     * Gets the list of ancestors for a given id/hash pair.
     *
     * Gets the list of ancestors for a given id/hash pair.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getAncestorsTest() throws ApiException {
        GetAncestorsRequest getAncestorsRequest = null;
        GetAncestors200Response response = api.getAncestors(getAncestorsRequest);
        // TODO: test validations
    }

    /**
     * Get the keys for a given id/root_hash pair.
     *
     * Get the keys for a given id/root_hash pair.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getKeysTest() throws ApiException {
        GetKeysRequest getKeysRequest = null;
        GetKeys200Response response = api.getKeys(getKeysRequest);
        // TODO: test validations
    }

    /**
     * Get the keys and values for a given id/root_hash pair.
     *
     * Get the keys and values for a given id/root_hash pair.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getKeysValuesTest() throws ApiException {
        GetKeysRequest getKeysRequest = null;
        GetKeysValues200Response response = api.getKeysValues(getKeysRequest);
        // TODO: test validations
    }

    /**
     * Get kv diff between two root hashes.
     *
     * Get kv diff between two root hashes.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getKvDiffTest() throws ApiException {
        GetKvDiffRequest getKvDiffRequest = null;
        GetKvDiff200Response response = api.getKvDiff(getKvDiffRequest);
        // TODO: test validations
    }

    /**
     * Gets hash of latest tree root saved in our local datastore.
     *
     * Gets hash of latest tree root saved in our local datastore.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getLocalRootTest() throws ApiException {
        GetSyncStatusRequest getSyncStatusRequest = null;
        GetLocalRoot200Response response = api.getLocalRoot(getSyncStatusRequest);
        // TODO: test validations
    }

    /**
     * Gets the list of owned store ids.
     *
     * Gets the list of owned store ids.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getOwnedStoresTest() throws ApiException {
        Object body = null;
        GetOwnedStores200Response response = api.getOwnedStores(body);
        // TODO: test validations
    }

    /**
     * Gets hash of latest tree root.
     *
     * Gets hash of latest tree root.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRootTest() throws ApiException {
        GetSyncStatusRequest getSyncStatusRequest = null;
        GetRoot200Response response = api.getRoot(getSyncStatusRequest);
        // TODO: test validations
    }

    /**
     * Get history of state hashes for a store.
     *
     * Get history of state hashes for a store.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRootHistoryTest() throws ApiException {
        GetSyncStatusRequest getSyncStatusRequest = null;
        GetRootHistory200Response response = api.getRootHistory(getSyncStatusRequest);
        // TODO: test validations
    }

    /**
     * Gets state hashes for a list of roots
     *
     * Gets state hashes for a list of roots.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRootsTest() throws ApiException {
        GetRootsRequest getRootsRequest = null;
        GetRoots200Response response = api.getRoots(getRootsRequest);
        // TODO: test validations
    }

    /**
     * Gets the sync status of a store.
     *
     * Gets the sync status of a store.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getSyncStatusTest() throws ApiException {
        GetSyncStatusRequest getSyncStatusRequest = null;
        GetSyncStatus200Response response = api.getSyncStatus(getSyncStatusRequest);
        // TODO: test validations
    }

    /**
     * Get the value for a given id/key pair.
     *
     * Get the value for a given id/key pair.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getValueTest() throws ApiException {
        GetValueRequest getValueRequest = null;
        GetValue200Response response = api.getValue(getValueRequest);
        // TODO: test validations
    }

    /**
     * Adds a list of clvm objects as bytes to add to table.
     *
     * Adds a list of clvm objects as bytes to add to table.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void insertTest() throws ApiException {
        InsertRequest insertRequest = null;
        BatchUpdate200Response response = api.insert(insertRequest);
        // TODO: test validations
    }

}
