# FarmerApi

All URIs are relative to *https://localhost:8559*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getHarvesterPlotsDuplicates**](FarmerApi.md#getHarvesterPlotsDuplicates) | **POST** /get_harvester_plots_duplicates | Get a paginated list of duplicate plots. |
| [**getHarvesterPlotsInvalid**](FarmerApi.md#getHarvesterPlotsInvalid) | **POST** /get_harvester_plots_invalid | Get a paginated list of invalid plots. |
| [**getHarvesterPlotsKeysMissing**](FarmerApi.md#getHarvesterPlotsKeysMissing) | **POST** /get_harvester_plots_keys_missing | Get a paginated list of plots with missing keys. |
| [**getHarvesterPlotsValid**](FarmerApi.md#getHarvesterPlotsValid) | **POST** /get_harvester_plots_valid | Get a paginated list of valid plots. |
| [**getHarvesters**](FarmerApi.md#getHarvesters) | **POST** /get_harvesters | Get the list of harvesters. |
| [**getHarvestersSummary**](FarmerApi.md#getHarvestersSummary) | **POST** /get_harvesters_summary | Get a summary of harvesters. |
| [**getPoolLoginLink**](FarmerApi.md#getPoolLoginLink) | **POST** /get_pool_login_link | Get&#39;s the pool login link, if any. |
| [**getPoolState**](FarmerApi.md#getPoolState) | **POST** /get_pool_state | Get&#39;s the state of the pool. |
| [**getRewardTargets**](FarmerApi.md#getRewardTargets) | **POST** /get_reward_targets | Get the farm and pool reward targets. |
| [**getSignagePoint**](FarmerApi.md#getSignagePoint) | **POST** /get_signage_point | Get&#39;s a signage point by hash. |
| [**getSignagePoints**](FarmerApi.md#getSignagePoints) | **POST** /get_signage_points | Get signage points. |
| [**setPayoutInstructions**](FarmerApi.md#setPayoutInstructions) | **POST** /set_payout_instructions | Set&#39;s a pool&#39;s payout instructions. |
| [**setRewardTargets**](FarmerApi.md#setRewardTargets) | **POST** /set_reward_targets | Set the farm and pool reward targets. |


<a name="getHarvesterPlotsDuplicates"></a>
# **getHarvesterPlotsDuplicates**
> GetHarvesterPlotsValid200Response getHarvesterPlotsDuplicates(plotPathRequestData)

Get a paginated list of duplicate plots.

Get a paginated list of dupliacte plots.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    PlotPathRequestData plotPathRequestData = new PlotPathRequestData(); // PlotPathRequestData | Search filter parameters
    try {
      GetHarvesterPlotsValid200Response result = apiInstance.getHarvesterPlotsDuplicates(plotPathRequestData);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvesterPlotsDuplicates");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **plotPathRequestData** | [**PlotPathRequestData**](PlotPathRequestData.md)| Search filter parameters | |

### Return type

[**GetHarvesterPlotsValid200Response**](GetHarvesterPlotsValid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getHarvesterPlotsInvalid"></a>
# **getHarvesterPlotsInvalid**
> GetHarvesterPlotsValid200Response getHarvesterPlotsInvalid(plotPathRequestData)

Get a paginated list of invalid plots.

Get a paginated list of invalid plots.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    PlotPathRequestData plotPathRequestData = new PlotPathRequestData(); // PlotPathRequestData | Search filter parameters
    try {
      GetHarvesterPlotsValid200Response result = apiInstance.getHarvesterPlotsInvalid(plotPathRequestData);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvesterPlotsInvalid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **plotPathRequestData** | [**PlotPathRequestData**](PlotPathRequestData.md)| Search filter parameters | |

### Return type

[**GetHarvesterPlotsValid200Response**](GetHarvesterPlotsValid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getHarvesterPlotsKeysMissing"></a>
# **getHarvesterPlotsKeysMissing**
> GetHarvesterPlotsValid200Response getHarvesterPlotsKeysMissing(plotPathRequestData)

Get a paginated list of plots with missing keys.

Get a paginated list of invalid plots with missing keys.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    PlotPathRequestData plotPathRequestData = new PlotPathRequestData(); // PlotPathRequestData | Search filter parameters
    try {
      GetHarvesterPlotsValid200Response result = apiInstance.getHarvesterPlotsKeysMissing(plotPathRequestData);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvesterPlotsKeysMissing");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **plotPathRequestData** | [**PlotPathRequestData**](PlotPathRequestData.md)| Search filter parameters | |

### Return type

[**GetHarvesterPlotsValid200Response**](GetHarvesterPlotsValid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getHarvesterPlotsValid"></a>
# **getHarvesterPlotsValid**
> GetHarvesterPlotsValid200Response getHarvesterPlotsValid(plotInfoRequestData)

Get a paginated list of valid plots.

Get a paginated list of valid plots.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    PlotInfoRequestData plotInfoRequestData = new PlotInfoRequestData(); // PlotInfoRequestData | Search filter parameters
    try {
      GetHarvesterPlotsValid200Response result = apiInstance.getHarvesterPlotsValid(plotInfoRequestData);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvesterPlotsValid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **plotInfoRequestData** | [**PlotInfoRequestData**](PlotInfoRequestData.md)| Search filter parameters | |

### Return type

[**GetHarvesterPlotsValid200Response**](GetHarvesterPlotsValid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getHarvesters"></a>
# **getHarvesters**
> GetHarvesters200Response getHarvesters(body)

Get the list of harvesters.

Get the list of harvesters.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetHarvesters200Response result = apiInstance.getHarvesters(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvesters");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetHarvesters200Response**](GetHarvesters200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getHarvestersSummary"></a>
# **getHarvestersSummary**
> GetHarvestersSummary200Response getHarvestersSummary(body)

Get a summary of harvesters.

Get a summary of harvesters, similar to get_harvests but with plot counts only.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetHarvestersSummary200Response result = apiInstance.getHarvestersSummary(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getHarvestersSummary");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetHarvestersSummary200Response**](GetHarvestersSummary200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getPoolLoginLink"></a>
# **getPoolLoginLink**
> GetPoolLoginLink200Response getPoolLoginLink(getPoolLoginLinkRequest)

Get&#39;s the pool login link, if any.

Get&#39;s the pool login link, if any.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    GetPoolLoginLinkRequest getPoolLoginLinkRequest = new GetPoolLoginLinkRequest(); // GetPoolLoginLinkRequest | The id of the pool launcher
    try {
      GetPoolLoginLink200Response result = apiInstance.getPoolLoginLink(getPoolLoginLinkRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getPoolLoginLink");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getPoolLoginLinkRequest** | [**GetPoolLoginLinkRequest**](GetPoolLoginLinkRequest.md)| The id of the pool launcher | |

### Return type

[**GetPoolLoginLink200Response**](GetPoolLoginLink200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getPoolState"></a>
# **getPoolState**
> GetPoolState200Response getPoolState(body)

Get&#39;s the state of the pool.

Get&#39;s the state of the pool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetPoolState200Response result = apiInstance.getPoolState(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getPoolState");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetPoolState200Response**](GetPoolState200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRewardTargets"></a>
# **getRewardTargets**
> GetRewardTargets200Response getRewardTargets(getRewardTargetsRequest)

Get the farm and pool reward targets.

Get the farm and pool reward targets.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    GetRewardTargetsRequest getRewardTargetsRequest = new GetRewardTargetsRequest(); // GetRewardTargetsRequest | indicator of whether to include private keys in the search
    try {
      GetRewardTargets200Response result = apiInstance.getRewardTargets(getRewardTargetsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getRewardTargets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getRewardTargetsRequest** | [**GetRewardTargetsRequest**](GetRewardTargetsRequest.md)| indicator of whether to include private keys in the search | |

### Return type

[**GetRewardTargets200Response**](GetRewardTargets200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getSignagePoint"></a>
# **getSignagePoint**
> GetSignagePoint200Response getSignagePoint(getSignagePointRequest)

Get&#39;s a signage point by hash.

Get&#39;s a signage point by hash.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    GetSignagePointRequest getSignagePointRequest = new GetSignagePointRequest(); // GetSignagePointRequest | The signage point hash
    try {
      GetSignagePoint200Response result = apiInstance.getSignagePoint(getSignagePointRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getSignagePoint");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSignagePointRequest** | [**GetSignagePointRequest**](GetSignagePointRequest.md)| The signage point hash | |

### Return type

[**GetSignagePoint200Response**](GetSignagePoint200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getSignagePoints"></a>
# **getSignagePoints**
> GetSignagePoints200Response getSignagePoints(body)

Get signage points.

Get signage points.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetSignagePoints200Response result = apiInstance.getSignagePoints(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#getSignagePoints");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetSignagePoints200Response**](GetSignagePoints200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="setPayoutInstructions"></a>
# **setPayoutInstructions**
> ModelApiResponse setPayoutInstructions(setPayoutInstructionsRequest)

Set&#39;s a pool&#39;s payout instructions.

Set&#39;s a pool&#39;s payout instructions.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    SetPayoutInstructionsRequest setPayoutInstructionsRequest = new SetPayoutInstructionsRequest(); // SetPayoutInstructionsRequest | The id of the pool launcher and payout instructions
    try {
      ModelApiResponse result = apiInstance.setPayoutInstructions(setPayoutInstructionsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#setPayoutInstructions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **setPayoutInstructionsRequest** | [**SetPayoutInstructionsRequest**](SetPayoutInstructionsRequest.md)| The id of the pool launcher and payout instructions | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="setRewardTargets"></a>
# **setRewardTargets**
> ModelApiResponse setRewardTargets(setRewardTargetsRequest)

Set the farm and pool reward targets.

Set the farm and pool reward targets.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FarmerApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8559");
    

    FarmerApi apiInstance = new FarmerApi(defaultClient);
    SetRewardTargetsRequest setRewardTargetsRequest = new SetRewardTargetsRequest(); // SetRewardTargetsRequest | The updated targets
    try {
      ModelApiResponse result = apiInstance.setRewardTargets(setRewardTargetsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FarmerApi#setRewardTargets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **setRewardTargetsRequest** | [**SetRewardTargetsRequest**](SetRewardTargetsRequest.md)| The updated targets | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

