/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.GetHarvesterPlotsValid200Response;
import org.openapitools.client.model.GetHarvesters200Response;
import org.openapitools.client.model.GetHarvestersSummary200Response;
import org.openapitools.client.model.GetPoolLoginLink200Response;
import org.openapitools.client.model.GetPoolLoginLinkRequest;
import org.openapitools.client.model.GetPoolState200Response;
import org.openapitools.client.model.GetRewardTargets200Response;
import org.openapitools.client.model.GetRewardTargetsRequest;
import org.openapitools.client.model.GetSignagePoint200Response;
import org.openapitools.client.model.GetSignagePointRequest;
import org.openapitools.client.model.GetSignagePoints200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.PlotInfoRequestData;
import org.openapitools.client.model.PlotPathRequestData;
import org.openapitools.client.model.SetPayoutInstructionsRequest;
import org.openapitools.client.model.SetRewardTargetsRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class FarmerApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public FarmerApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FarmerApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for getHarvesterPlotsDuplicates
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsDuplicatesCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = plotPathRequestData;

        // create path and map variables
        String localVarPath = "/get_harvester_plots_duplicates";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvesterPlotsDuplicatesValidateBeforeCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'plotPathRequestData' is set
        if (plotPathRequestData == null) {
            throw new ApiException("Missing the required parameter 'plotPathRequestData' when calling getHarvesterPlotsDuplicates(Async)");
        }

        return getHarvesterPlotsDuplicatesCall(plotPathRequestData, _callback);

    }

    /**
     * Get a paginated list of duplicate plots.
     * Get a paginated list of dupliacte plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @return GetHarvesterPlotsValid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvesterPlotsValid200Response getHarvesterPlotsDuplicates(PlotPathRequestData plotPathRequestData) throws ApiException {
        ApiResponse<GetHarvesterPlotsValid200Response> localVarResp = getHarvesterPlotsDuplicatesWithHttpInfo(plotPathRequestData);
        return localVarResp.getData();
    }

    /**
     * Get a paginated list of duplicate plots.
     * Get a paginated list of dupliacte plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @return ApiResponse&lt;GetHarvesterPlotsValid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvesterPlotsValid200Response> getHarvesterPlotsDuplicatesWithHttpInfo(PlotPathRequestData plotPathRequestData) throws ApiException {
        okhttp3.Call localVarCall = getHarvesterPlotsDuplicatesValidateBeforeCall(plotPathRequestData, null);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a paginated list of duplicate plots. (asynchronously)
     * Get a paginated list of dupliacte plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsDuplicatesAsync(PlotPathRequestData plotPathRequestData, final ApiCallback<GetHarvesterPlotsValid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvesterPlotsDuplicatesValidateBeforeCall(plotPathRequestData, _callback);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHarvesterPlotsInvalid
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsInvalidCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = plotPathRequestData;

        // create path and map variables
        String localVarPath = "/get_harvester_plots_invalid";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvesterPlotsInvalidValidateBeforeCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'plotPathRequestData' is set
        if (plotPathRequestData == null) {
            throw new ApiException("Missing the required parameter 'plotPathRequestData' when calling getHarvesterPlotsInvalid(Async)");
        }

        return getHarvesterPlotsInvalidCall(plotPathRequestData, _callback);

    }

    /**
     * Get a paginated list of invalid plots.
     * Get a paginated list of invalid plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @return GetHarvesterPlotsValid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvesterPlotsValid200Response getHarvesterPlotsInvalid(PlotPathRequestData plotPathRequestData) throws ApiException {
        ApiResponse<GetHarvesterPlotsValid200Response> localVarResp = getHarvesterPlotsInvalidWithHttpInfo(plotPathRequestData);
        return localVarResp.getData();
    }

    /**
     * Get a paginated list of invalid plots.
     * Get a paginated list of invalid plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @return ApiResponse&lt;GetHarvesterPlotsValid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvesterPlotsValid200Response> getHarvesterPlotsInvalidWithHttpInfo(PlotPathRequestData plotPathRequestData) throws ApiException {
        okhttp3.Call localVarCall = getHarvesterPlotsInvalidValidateBeforeCall(plotPathRequestData, null);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a paginated list of invalid plots. (asynchronously)
     * Get a paginated list of invalid plots.
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsInvalidAsync(PlotPathRequestData plotPathRequestData, final ApiCallback<GetHarvesterPlotsValid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvesterPlotsInvalidValidateBeforeCall(plotPathRequestData, _callback);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHarvesterPlotsKeysMissing
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsKeysMissingCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = plotPathRequestData;

        // create path and map variables
        String localVarPath = "/get_harvester_plots_keys_missing";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvesterPlotsKeysMissingValidateBeforeCall(PlotPathRequestData plotPathRequestData, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'plotPathRequestData' is set
        if (plotPathRequestData == null) {
            throw new ApiException("Missing the required parameter 'plotPathRequestData' when calling getHarvesterPlotsKeysMissing(Async)");
        }

        return getHarvesterPlotsKeysMissingCall(plotPathRequestData, _callback);

    }

    /**
     * Get a paginated list of plots with missing keys.
     * Get a paginated list of invalid plots with missing keys.
     * @param plotPathRequestData Search filter parameters (required)
     * @return GetHarvesterPlotsValid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvesterPlotsValid200Response getHarvesterPlotsKeysMissing(PlotPathRequestData plotPathRequestData) throws ApiException {
        ApiResponse<GetHarvesterPlotsValid200Response> localVarResp = getHarvesterPlotsKeysMissingWithHttpInfo(plotPathRequestData);
        return localVarResp.getData();
    }

    /**
     * Get a paginated list of plots with missing keys.
     * Get a paginated list of invalid plots with missing keys.
     * @param plotPathRequestData Search filter parameters (required)
     * @return ApiResponse&lt;GetHarvesterPlotsValid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvesterPlotsValid200Response> getHarvesterPlotsKeysMissingWithHttpInfo(PlotPathRequestData plotPathRequestData) throws ApiException {
        okhttp3.Call localVarCall = getHarvesterPlotsKeysMissingValidateBeforeCall(plotPathRequestData, null);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a paginated list of plots with missing keys. (asynchronously)
     * Get a paginated list of invalid plots with missing keys.
     * @param plotPathRequestData Search filter parameters (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsKeysMissingAsync(PlotPathRequestData plotPathRequestData, final ApiCallback<GetHarvesterPlotsValid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvesterPlotsKeysMissingValidateBeforeCall(plotPathRequestData, _callback);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHarvesterPlotsValid
     * @param plotInfoRequestData Search filter parameters (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsValidCall(PlotInfoRequestData plotInfoRequestData, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = plotInfoRequestData;

        // create path and map variables
        String localVarPath = "/get_harvester_plots_valid";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvesterPlotsValidValidateBeforeCall(PlotInfoRequestData plotInfoRequestData, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'plotInfoRequestData' is set
        if (plotInfoRequestData == null) {
            throw new ApiException("Missing the required parameter 'plotInfoRequestData' when calling getHarvesterPlotsValid(Async)");
        }

        return getHarvesterPlotsValidCall(plotInfoRequestData, _callback);

    }

    /**
     * Get a paginated list of valid plots.
     * Get a paginated list of valid plots.
     * @param plotInfoRequestData Search filter parameters (required)
     * @return GetHarvesterPlotsValid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvesterPlotsValid200Response getHarvesterPlotsValid(PlotInfoRequestData plotInfoRequestData) throws ApiException {
        ApiResponse<GetHarvesterPlotsValid200Response> localVarResp = getHarvesterPlotsValidWithHttpInfo(plotInfoRequestData);
        return localVarResp.getData();
    }

    /**
     * Get a paginated list of valid plots.
     * Get a paginated list of valid plots.
     * @param plotInfoRequestData Search filter parameters (required)
     * @return ApiResponse&lt;GetHarvesterPlotsValid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvesterPlotsValid200Response> getHarvesterPlotsValidWithHttpInfo(PlotInfoRequestData plotInfoRequestData) throws ApiException {
        okhttp3.Call localVarCall = getHarvesterPlotsValidValidateBeforeCall(plotInfoRequestData, null);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a paginated list of valid plots. (asynchronously)
     * Get a paginated list of valid plots.
     * @param plotInfoRequestData Search filter parameters (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvesterPlotsValidAsync(PlotInfoRequestData plotInfoRequestData, final ApiCallback<GetHarvesterPlotsValid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvesterPlotsValidValidateBeforeCall(plotInfoRequestData, _callback);
        Type localVarReturnType = new TypeToken<GetHarvesterPlotsValid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHarvesters
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvestersCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_harvesters";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvestersValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getHarvesters(Async)");
        }

        return getHarvestersCall(body, _callback);

    }

    /**
     * Get the list of harvesters.
     * Get the list of harvesters.
     * @param body Empty request body (required)
     * @return GetHarvesters200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvesters200Response getHarvesters(Object body) throws ApiException {
        ApiResponse<GetHarvesters200Response> localVarResp = getHarvestersWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get the list of harvesters.
     * Get the list of harvesters.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetHarvesters200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvesters200Response> getHarvestersWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getHarvestersValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetHarvesters200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the list of harvesters. (asynchronously)
     * Get the list of harvesters.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvestersAsync(Object body, final ApiCallback<GetHarvesters200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvestersValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetHarvesters200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHarvestersSummary
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvestersSummaryCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_harvesters_summary";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHarvestersSummaryValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getHarvestersSummary(Async)");
        }

        return getHarvestersSummaryCall(body, _callback);

    }

    /**
     * Get a summary of harvesters.
     * Get a summary of harvesters, similar to get_harvests but with plot counts only.
     * @param body Empty request body (required)
     * @return GetHarvestersSummary200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetHarvestersSummary200Response getHarvestersSummary(Object body) throws ApiException {
        ApiResponse<GetHarvestersSummary200Response> localVarResp = getHarvestersSummaryWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get a summary of harvesters.
     * Get a summary of harvesters, similar to get_harvests but with plot counts only.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetHarvestersSummary200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetHarvestersSummary200Response> getHarvestersSummaryWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getHarvestersSummaryValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetHarvestersSummary200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a summary of harvesters. (asynchronously)
     * Get a summary of harvesters, similar to get_harvests but with plot counts only.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHarvestersSummaryAsync(Object body, final ApiCallback<GetHarvestersSummary200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHarvestersSummaryValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetHarvestersSummary200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getPoolLoginLink
     * @param getPoolLoginLinkRequest The id of the pool launcher (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPoolLoginLinkCall(GetPoolLoginLinkRequest getPoolLoginLinkRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getPoolLoginLinkRequest;

        // create path and map variables
        String localVarPath = "/get_pool_login_link";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getPoolLoginLinkValidateBeforeCall(GetPoolLoginLinkRequest getPoolLoginLinkRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getPoolLoginLinkRequest' is set
        if (getPoolLoginLinkRequest == null) {
            throw new ApiException("Missing the required parameter 'getPoolLoginLinkRequest' when calling getPoolLoginLink(Async)");
        }

        return getPoolLoginLinkCall(getPoolLoginLinkRequest, _callback);

    }

    /**
     * Get&#39;s the pool login link, if any.
     * Get&#39;s the pool login link, if any.
     * @param getPoolLoginLinkRequest The id of the pool launcher (required)
     * @return GetPoolLoginLink200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetPoolLoginLink200Response getPoolLoginLink(GetPoolLoginLinkRequest getPoolLoginLinkRequest) throws ApiException {
        ApiResponse<GetPoolLoginLink200Response> localVarResp = getPoolLoginLinkWithHttpInfo(getPoolLoginLinkRequest);
        return localVarResp.getData();
    }

    /**
     * Get&#39;s the pool login link, if any.
     * Get&#39;s the pool login link, if any.
     * @param getPoolLoginLinkRequest The id of the pool launcher (required)
     * @return ApiResponse&lt;GetPoolLoginLink200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetPoolLoginLink200Response> getPoolLoginLinkWithHttpInfo(GetPoolLoginLinkRequest getPoolLoginLinkRequest) throws ApiException {
        okhttp3.Call localVarCall = getPoolLoginLinkValidateBeforeCall(getPoolLoginLinkRequest, null);
        Type localVarReturnType = new TypeToken<GetPoolLoginLink200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get&#39;s the pool login link, if any. (asynchronously)
     * Get&#39;s the pool login link, if any.
     * @param getPoolLoginLinkRequest The id of the pool launcher (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPoolLoginLinkAsync(GetPoolLoginLinkRequest getPoolLoginLinkRequest, final ApiCallback<GetPoolLoginLink200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getPoolLoginLinkValidateBeforeCall(getPoolLoginLinkRequest, _callback);
        Type localVarReturnType = new TypeToken<GetPoolLoginLink200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getPoolState
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPoolStateCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_pool_state";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getPoolStateValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getPoolState(Async)");
        }

        return getPoolStateCall(body, _callback);

    }

    /**
     * Get&#39;s the state of the pool.
     * Get&#39;s the state of the pool.
     * @param body Empty request body (required)
     * @return GetPoolState200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetPoolState200Response getPoolState(Object body) throws ApiException {
        ApiResponse<GetPoolState200Response> localVarResp = getPoolStateWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get&#39;s the state of the pool.
     * Get&#39;s the state of the pool.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetPoolState200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetPoolState200Response> getPoolStateWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getPoolStateValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetPoolState200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get&#39;s the state of the pool. (asynchronously)
     * Get&#39;s the state of the pool.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPoolStateAsync(Object body, final ApiCallback<GetPoolState200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getPoolStateValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetPoolState200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getRewardTargets
     * @param getRewardTargetsRequest indicator of whether to include private keys in the search (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRewardTargetsCall(GetRewardTargetsRequest getRewardTargetsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getRewardTargetsRequest;

        // create path and map variables
        String localVarPath = "/get_reward_targets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getRewardTargetsValidateBeforeCall(GetRewardTargetsRequest getRewardTargetsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getRewardTargetsRequest' is set
        if (getRewardTargetsRequest == null) {
            throw new ApiException("Missing the required parameter 'getRewardTargetsRequest' when calling getRewardTargets(Async)");
        }

        return getRewardTargetsCall(getRewardTargetsRequest, _callback);

    }

    /**
     * Get the farm and pool reward targets.
     * Get the farm and pool reward targets.
     * @param getRewardTargetsRequest indicator of whether to include private keys in the search (required)
     * @return GetRewardTargets200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetRewardTargets200Response getRewardTargets(GetRewardTargetsRequest getRewardTargetsRequest) throws ApiException {
        ApiResponse<GetRewardTargets200Response> localVarResp = getRewardTargetsWithHttpInfo(getRewardTargetsRequest);
        return localVarResp.getData();
    }

    /**
     * Get the farm and pool reward targets.
     * Get the farm and pool reward targets.
     * @param getRewardTargetsRequest indicator of whether to include private keys in the search (required)
     * @return ApiResponse&lt;GetRewardTargets200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetRewardTargets200Response> getRewardTargetsWithHttpInfo(GetRewardTargetsRequest getRewardTargetsRequest) throws ApiException {
        okhttp3.Call localVarCall = getRewardTargetsValidateBeforeCall(getRewardTargetsRequest, null);
        Type localVarReturnType = new TypeToken<GetRewardTargets200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the farm and pool reward targets. (asynchronously)
     * Get the farm and pool reward targets.
     * @param getRewardTargetsRequest indicator of whether to include private keys in the search (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRewardTargetsAsync(GetRewardTargetsRequest getRewardTargetsRequest, final ApiCallback<GetRewardTargets200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getRewardTargetsValidateBeforeCall(getRewardTargetsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetRewardTargets200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getSignagePoint
     * @param getSignagePointRequest The signage point hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSignagePointCall(GetSignagePointRequest getSignagePointRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSignagePointRequest;

        // create path and map variables
        String localVarPath = "/get_signage_point";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getSignagePointValidateBeforeCall(GetSignagePointRequest getSignagePointRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSignagePointRequest' is set
        if (getSignagePointRequest == null) {
            throw new ApiException("Missing the required parameter 'getSignagePointRequest' when calling getSignagePoint(Async)");
        }

        return getSignagePointCall(getSignagePointRequest, _callback);

    }

    /**
     * Get&#39;s a signage point by hash.
     * Get&#39;s a signage point by hash.
     * @param getSignagePointRequest The signage point hash (required)
     * @return GetSignagePoint200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetSignagePoint200Response getSignagePoint(GetSignagePointRequest getSignagePointRequest) throws ApiException {
        ApiResponse<GetSignagePoint200Response> localVarResp = getSignagePointWithHttpInfo(getSignagePointRequest);
        return localVarResp.getData();
    }

    /**
     * Get&#39;s a signage point by hash.
     * Get&#39;s a signage point by hash.
     * @param getSignagePointRequest The signage point hash (required)
     * @return ApiResponse&lt;GetSignagePoint200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetSignagePoint200Response> getSignagePointWithHttpInfo(GetSignagePointRequest getSignagePointRequest) throws ApiException {
        okhttp3.Call localVarCall = getSignagePointValidateBeforeCall(getSignagePointRequest, null);
        Type localVarReturnType = new TypeToken<GetSignagePoint200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get&#39;s a signage point by hash. (asynchronously)
     * Get&#39;s a signage point by hash.
     * @param getSignagePointRequest The signage point hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSignagePointAsync(GetSignagePointRequest getSignagePointRequest, final ApiCallback<GetSignagePoint200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getSignagePointValidateBeforeCall(getSignagePointRequest, _callback);
        Type localVarReturnType = new TypeToken<GetSignagePoint200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getSignagePoints
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSignagePointsCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_signage_points";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getSignagePointsValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getSignagePoints(Async)");
        }

        return getSignagePointsCall(body, _callback);

    }

    /**
     * Get signage points.
     * Get signage points.
     * @param body Empty request body (required)
     * @return GetSignagePoints200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetSignagePoints200Response getSignagePoints(Object body) throws ApiException {
        ApiResponse<GetSignagePoints200Response> localVarResp = getSignagePointsWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get signage points.
     * Get signage points.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetSignagePoints200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetSignagePoints200Response> getSignagePointsWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getSignagePointsValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetSignagePoints200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get signage points. (asynchronously)
     * Get signage points.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSignagePointsAsync(Object body, final ApiCallback<GetSignagePoints200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getSignagePointsValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetSignagePoints200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for setPayoutInstructions
     * @param setPayoutInstructionsRequest The id of the pool launcher and payout instructions (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setPayoutInstructionsCall(SetPayoutInstructionsRequest setPayoutInstructionsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = setPayoutInstructionsRequest;

        // create path and map variables
        String localVarPath = "/set_payout_instructions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call setPayoutInstructionsValidateBeforeCall(SetPayoutInstructionsRequest setPayoutInstructionsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'setPayoutInstructionsRequest' is set
        if (setPayoutInstructionsRequest == null) {
            throw new ApiException("Missing the required parameter 'setPayoutInstructionsRequest' when calling setPayoutInstructions(Async)");
        }

        return setPayoutInstructionsCall(setPayoutInstructionsRequest, _callback);

    }

    /**
     * Set&#39;s a pool&#39;s payout instructions.
     * Set&#39;s a pool&#39;s payout instructions.
     * @param setPayoutInstructionsRequest The id of the pool launcher and payout instructions (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse setPayoutInstructions(SetPayoutInstructionsRequest setPayoutInstructionsRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = setPayoutInstructionsWithHttpInfo(setPayoutInstructionsRequest);
        return localVarResp.getData();
    }

    /**
     * Set&#39;s a pool&#39;s payout instructions.
     * Set&#39;s a pool&#39;s payout instructions.
     * @param setPayoutInstructionsRequest The id of the pool launcher and payout instructions (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> setPayoutInstructionsWithHttpInfo(SetPayoutInstructionsRequest setPayoutInstructionsRequest) throws ApiException {
        okhttp3.Call localVarCall = setPayoutInstructionsValidateBeforeCall(setPayoutInstructionsRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Set&#39;s a pool&#39;s payout instructions. (asynchronously)
     * Set&#39;s a pool&#39;s payout instructions.
     * @param setPayoutInstructionsRequest The id of the pool launcher and payout instructions (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setPayoutInstructionsAsync(SetPayoutInstructionsRequest setPayoutInstructionsRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = setPayoutInstructionsValidateBeforeCall(setPayoutInstructionsRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for setRewardTargets
     * @param setRewardTargetsRequest The updated targets (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setRewardTargetsCall(SetRewardTargetsRequest setRewardTargetsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = setRewardTargetsRequest;

        // create path and map variables
        String localVarPath = "/set_reward_targets";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call setRewardTargetsValidateBeforeCall(SetRewardTargetsRequest setRewardTargetsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'setRewardTargetsRequest' is set
        if (setRewardTargetsRequest == null) {
            throw new ApiException("Missing the required parameter 'setRewardTargetsRequest' when calling setRewardTargets(Async)");
        }

        return setRewardTargetsCall(setRewardTargetsRequest, _callback);

    }

    /**
     * Set the farm and pool reward targets.
     * Set the farm and pool reward targets.
     * @param setRewardTargetsRequest The updated targets (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse setRewardTargets(SetRewardTargetsRequest setRewardTargetsRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = setRewardTargetsWithHttpInfo(setRewardTargetsRequest);
        return localVarResp.getData();
    }

    /**
     * Set the farm and pool reward targets.
     * Set the farm and pool reward targets.
     * @param setRewardTargetsRequest The updated targets (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> setRewardTargetsWithHttpInfo(SetRewardTargetsRequest setRewardTargetsRequest) throws ApiException {
        okhttp3.Call localVarCall = setRewardTargetsValidateBeforeCall(setRewardTargetsRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Set the farm and pool reward targets. (asynchronously)
     * Set the farm and pool reward targets.
     * @param setRewardTargetsRequest The updated targets (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call setRewardTargetsAsync(SetRewardTargetsRequest setRewardTargetsRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = setRewardTargetsValidateBeforeCall(setRewardTargetsRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
