/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * The farmer api&#39;s defintion of a signage point. Not the same as signage_point.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class FarmerSignagePoint {
  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP = "challenge_chain_sp";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP)
  private String challengeChainSp;

  public static final String SERIALIZED_NAME_CHALLENGE_HASH = "challenge_hash";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_HASH)
  private String challengeHash;

  public static final String SERIALIZED_NAME_DIFFICULTY = "difficulty";
  @SerializedName(SERIALIZED_NAME_DIFFICULTY)
  private Integer difficulty;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP = "reward_chain_sp";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP)
  private String rewardChainSp;

  public static final String SERIALIZED_NAME_SIGNAGE_POINT_INDEX = "signage_point_index";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT_INDEX)
  private Integer signagePointIndex;

  public static final String SERIALIZED_NAME_SUB_SLOT_ITERS = "sub_slot_iters";
  @SerializedName(SERIALIZED_NAME_SUB_SLOT_ITERS)
  private Integer subSlotIters;

  public FarmerSignagePoint() {
  }

  public FarmerSignagePoint challengeChainSp(String challengeChainSp) {
    
    this.challengeChainSp = challengeChainSp;
    return this;
  }

   /**
   * Get challengeChainSp
   * @return challengeChainSp
  **/
  @javax.annotation.Nullable

  public String getChallengeChainSp() {
    return challengeChainSp;
  }


  public void setChallengeChainSp(String challengeChainSp) {
    this.challengeChainSp = challengeChainSp;
  }


  public FarmerSignagePoint challengeHash(String challengeHash) {
    
    this.challengeHash = challengeHash;
    return this;
  }

   /**
   * Get challengeHash
   * @return challengeHash
  **/
  @javax.annotation.Nullable

  public String getChallengeHash() {
    return challengeHash;
  }


  public void setChallengeHash(String challengeHash) {
    this.challengeHash = challengeHash;
  }


  public FarmerSignagePoint difficulty(Integer difficulty) {
    
    this.difficulty = difficulty;
    return this;
  }

   /**
   * Get difficulty
   * @return difficulty
  **/
  @javax.annotation.Nullable

  public Integer getDifficulty() {
    return difficulty;
  }


  public void setDifficulty(Integer difficulty) {
    this.difficulty = difficulty;
  }


  public FarmerSignagePoint rewardChainSp(String rewardChainSp) {
    
    this.rewardChainSp = rewardChainSp;
    return this;
  }

   /**
   * Get rewardChainSp
   * @return rewardChainSp
  **/
  @javax.annotation.Nullable

  public String getRewardChainSp() {
    return rewardChainSp;
  }


  public void setRewardChainSp(String rewardChainSp) {
    this.rewardChainSp = rewardChainSp;
  }


  public FarmerSignagePoint signagePointIndex(Integer signagePointIndex) {
    
    this.signagePointIndex = signagePointIndex;
    return this;
  }

   /**
   * Get signagePointIndex
   * @return signagePointIndex
  **/
  @javax.annotation.Nullable

  public Integer getSignagePointIndex() {
    return signagePointIndex;
  }


  public void setSignagePointIndex(Integer signagePointIndex) {
    this.signagePointIndex = signagePointIndex;
  }


  public FarmerSignagePoint subSlotIters(Integer subSlotIters) {
    
    this.subSlotIters = subSlotIters;
    return this;
  }

   /**
   * Get subSlotIters
   * @return subSlotIters
  **/
  @javax.annotation.Nullable

  public Integer getSubSlotIters() {
    return subSlotIters;
  }


  public void setSubSlotIters(Integer subSlotIters) {
    this.subSlotIters = subSlotIters;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FarmerSignagePoint farmerSignagePoint = (FarmerSignagePoint) o;
    return Objects.equals(this.challengeChainSp, farmerSignagePoint.challengeChainSp) &&
        Objects.equals(this.challengeHash, farmerSignagePoint.challengeHash) &&
        Objects.equals(this.difficulty, farmerSignagePoint.difficulty) &&
        Objects.equals(this.rewardChainSp, farmerSignagePoint.rewardChainSp) &&
        Objects.equals(this.signagePointIndex, farmerSignagePoint.signagePointIndex) &&
        Objects.equals(this.subSlotIters, farmerSignagePoint.subSlotIters);
  }

  @Override
  public int hashCode() {
    return Objects.hash(challengeChainSp, challengeHash, difficulty, rewardChainSp, signagePointIndex, subSlotIters);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FarmerSignagePoint {\n");
    sb.append("    challengeChainSp: ").append(toIndentedString(challengeChainSp)).append("\n");
    sb.append("    challengeHash: ").append(toIndentedString(challengeHash)).append("\n");
    sb.append("    difficulty: ").append(toIndentedString(difficulty)).append("\n");
    sb.append("    rewardChainSp: ").append(toIndentedString(rewardChainSp)).append("\n");
    sb.append("    signagePointIndex: ").append(toIndentedString(signagePointIndex)).append("\n");
    sb.append("    subSlotIters: ").append(toIndentedString(subSlotIters)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("challenge_chain_sp");
    openapiFields.add("challenge_hash");
    openapiFields.add("difficulty");
    openapiFields.add("reward_chain_sp");
    openapiFields.add("signage_point_index");
    openapiFields.add("sub_slot_iters");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to FarmerSignagePoint
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!FarmerSignagePoint.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in FarmerSignagePoint is not found in the empty JSON string", FarmerSignagePoint.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!FarmerSignagePoint.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `FarmerSignagePoint` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("challenge_chain_sp") != null && !jsonObj.get("challenge_chain_sp").isJsonNull()) && !jsonObj.get("challenge_chain_sp").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_chain_sp` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_chain_sp").toString()));
      }
      if ((jsonObj.get("challenge_hash") != null && !jsonObj.get("challenge_hash").isJsonNull()) && !jsonObj.get("challenge_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_hash").toString()));
      }
      if ((jsonObj.get("reward_chain_sp") != null && !jsonObj.get("reward_chain_sp").isJsonNull()) && !jsonObj.get("reward_chain_sp").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_chain_sp` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_chain_sp").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!FarmerSignagePoint.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'FarmerSignagePoint' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<FarmerSignagePoint> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(FarmerSignagePoint.class));

       return (TypeAdapter<T>) new TypeAdapter<FarmerSignagePoint>() {
           @Override
           public void write(JsonWriter out, FarmerSignagePoint value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public FarmerSignagePoint read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of FarmerSignagePoint given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of FarmerSignagePoint
  * @throws IOException if the JSON string is invalid with respect to FarmerSignagePoint
  */
  public static FarmerSignagePoint fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, FarmerSignagePoint.class);
  }

 /**
  * Convert an instance of FarmerSignagePoint to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

