/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.HarvesterSummary;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetHarvestersSummary200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class GetHarvestersSummary200Response {
  public static final String SERIALIZED_NAME_HARVESTERS = "harvesters";
  @SerializedName(SERIALIZED_NAME_HARVESTERS)
  private List<HarvesterSummary> harvesters;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetHarvestersSummary200Response() {
  }

  public GetHarvestersSummary200Response harvesters(List<HarvesterSummary> harvesters) {
    
    this.harvesters = harvesters;
    return this;
  }

  public GetHarvestersSummary200Response addHarvestersItem(HarvesterSummary harvestersItem) {
    if (this.harvesters == null) {
      this.harvesters = new ArrayList<>();
    }
    this.harvesters.add(harvestersItem);
    return this;
  }

   /**
   * Get harvesters
   * @return harvesters
  **/
  @javax.annotation.Nullable

  public List<HarvesterSummary> getHarvesters() {
    return harvesters;
  }


  public void setHarvesters(List<HarvesterSummary> harvesters) {
    this.harvesters = harvesters;
  }


  public GetHarvestersSummary200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetHarvestersSummary200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetHarvestersSummary200Response getHarvestersSummary200Response = (GetHarvestersSummary200Response) o;
    return Objects.equals(this.harvesters, getHarvestersSummary200Response.harvesters) &&
        Objects.equals(this.success, getHarvestersSummary200Response.success) &&
        Objects.equals(this.error, getHarvestersSummary200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(harvesters, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetHarvestersSummary200Response {\n");
    sb.append("    harvesters: ").append(toIndentedString(harvesters)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("harvesters");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetHarvestersSummary200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetHarvestersSummary200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetHarvestersSummary200Response is not found in the empty JSON string", GetHarvestersSummary200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetHarvestersSummary200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetHarvestersSummary200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetHarvestersSummary200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (jsonObj.get("harvesters") != null && !jsonObj.get("harvesters").isJsonNull()) {
        JsonArray jsonArrayharvesters = jsonObj.getAsJsonArray("harvesters");
        if (jsonArrayharvesters != null) {
          // ensure the json data is an array
          if (!jsonObj.get("harvesters").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `harvesters` to be an array in the JSON string but got `%s`", jsonObj.get("harvesters").toString()));
          }

          // validate the optional field `harvesters` (array)
          for (int i = 0; i < jsonArrayharvesters.size(); i++) {
            HarvesterSummary.validateJsonObject(jsonArrayharvesters.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetHarvestersSummary200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetHarvestersSummary200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetHarvestersSummary200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetHarvestersSummary200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetHarvestersSummary200Response>() {
           @Override
           public void write(JsonWriter out, GetHarvestersSummary200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetHarvestersSummary200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetHarvestersSummary200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetHarvestersSummary200Response
  * @throws IOException if the JSON string is invalid with respect to GetHarvestersSummary200Response
  */
  public static GetHarvestersSummary200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetHarvestersSummary200Response.class);
  }

 /**
  * Convert an instance of GetHarvestersSummary200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

