/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetRewardTargets200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class GetRewardTargets200Response {
  public static final String SERIALIZED_NAME_FARMER_TARGET = "farmer_target";
  @SerializedName(SERIALIZED_NAME_FARMER_TARGET)
  private String farmerTarget;

  public static final String SERIALIZED_NAME_POOL_TARGET = "pool_target";
  @SerializedName(SERIALIZED_NAME_POOL_TARGET)
  private String poolTarget;

  public static final String SERIALIZED_NAME_HAVE_FARMER_SK = "have_farmer_sk";
  @SerializedName(SERIALIZED_NAME_HAVE_FARMER_SK)
  private Boolean haveFarmerSk;

  public static final String SERIALIZED_NAME_HAVE_POOL_SK = "have_pool_sk";
  @SerializedName(SERIALIZED_NAME_HAVE_POOL_SK)
  private Boolean havePoolSk;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetRewardTargets200Response() {
  }

  public GetRewardTargets200Response farmerTarget(String farmerTarget) {
    
    this.farmerTarget = farmerTarget;
    return this;
  }

   /**
   * Get farmerTarget
   * @return farmerTarget
  **/
  @javax.annotation.Nonnull

  public String getFarmerTarget() {
    return farmerTarget;
  }


  public void setFarmerTarget(String farmerTarget) {
    this.farmerTarget = farmerTarget;
  }


  public GetRewardTargets200Response poolTarget(String poolTarget) {
    
    this.poolTarget = poolTarget;
    return this;
  }

   /**
   * Get poolTarget
   * @return poolTarget
  **/
  @javax.annotation.Nonnull

  public String getPoolTarget() {
    return poolTarget;
  }


  public void setPoolTarget(String poolTarget) {
    this.poolTarget = poolTarget;
  }


  public GetRewardTargets200Response haveFarmerSk(Boolean haveFarmerSk) {
    
    this.haveFarmerSk = haveFarmerSk;
    return this;
  }

   /**
   * Get haveFarmerSk
   * @return haveFarmerSk
  **/
  @javax.annotation.Nullable

  public Boolean getHaveFarmerSk() {
    return haveFarmerSk;
  }


  public void setHaveFarmerSk(Boolean haveFarmerSk) {
    this.haveFarmerSk = haveFarmerSk;
  }


  public GetRewardTargets200Response havePoolSk(Boolean havePoolSk) {
    
    this.havePoolSk = havePoolSk;
    return this;
  }

   /**
   * Get havePoolSk
   * @return havePoolSk
  **/
  @javax.annotation.Nullable

  public Boolean getHavePoolSk() {
    return havePoolSk;
  }


  public void setHavePoolSk(Boolean havePoolSk) {
    this.havePoolSk = havePoolSk;
  }


  public GetRewardTargets200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetRewardTargets200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetRewardTargets200Response getRewardTargets200Response = (GetRewardTargets200Response) o;
    return Objects.equals(this.farmerTarget, getRewardTargets200Response.farmerTarget) &&
        Objects.equals(this.poolTarget, getRewardTargets200Response.poolTarget) &&
        Objects.equals(this.haveFarmerSk, getRewardTargets200Response.haveFarmerSk) &&
        Objects.equals(this.havePoolSk, getRewardTargets200Response.havePoolSk) &&
        Objects.equals(this.success, getRewardTargets200Response.success) &&
        Objects.equals(this.error, getRewardTargets200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(farmerTarget, poolTarget, haveFarmerSk, havePoolSk, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetRewardTargets200Response {\n");
    sb.append("    farmerTarget: ").append(toIndentedString(farmerTarget)).append("\n");
    sb.append("    poolTarget: ").append(toIndentedString(poolTarget)).append("\n");
    sb.append("    haveFarmerSk: ").append(toIndentedString(haveFarmerSk)).append("\n");
    sb.append("    havePoolSk: ").append(toIndentedString(havePoolSk)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("farmer_target");
    openapiFields.add("pool_target");
    openapiFields.add("have_farmer_sk");
    openapiFields.add("have_pool_sk");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("farmer_target");
    openapiRequiredFields.add("pool_target");
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetRewardTargets200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetRewardTargets200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetRewardTargets200Response is not found in the empty JSON string", GetRewardTargets200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetRewardTargets200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetRewardTargets200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetRewardTargets200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("farmer_target").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `farmer_target` to be a primitive type in the JSON string but got `%s`", jsonObj.get("farmer_target").toString()));
      }
      if (!jsonObj.get("pool_target").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_target` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_target").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetRewardTargets200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetRewardTargets200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetRewardTargets200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetRewardTargets200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetRewardTargets200Response>() {
           @Override
           public void write(JsonWriter out, GetRewardTargets200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetRewardTargets200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetRewardTargets200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetRewardTargets200Response
  * @throws IOException if the JSON string is invalid with respect to GetRewardTargets200Response
  */
  public static GetRewardTargets200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetRewardTargets200Response.class);
  }

 /**
  * Convert an instance of GetRewardTargets200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

