/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.FarmerSignagePoint;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetSignagePoint200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class GetSignagePoint200Response {
  public static final String SERIALIZED_NAME_SIGNAGE_POINT = "signage_point";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT)
  private FarmerSignagePoint signagePoint;

  public static final String SERIALIZED_NAME_PROOFS = "proofs";
  @SerializedName(SERIALIZED_NAME_PROOFS)
  private List<String> proofs;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetSignagePoint200Response() {
  }

  public GetSignagePoint200Response signagePoint(FarmerSignagePoint signagePoint) {
    
    this.signagePoint = signagePoint;
    return this;
  }

   /**
   * Get signagePoint
   * @return signagePoint
  **/
  @javax.annotation.Nullable

  public FarmerSignagePoint getSignagePoint() {
    return signagePoint;
  }


  public void setSignagePoint(FarmerSignagePoint signagePoint) {
    this.signagePoint = signagePoint;
  }


  public GetSignagePoint200Response proofs(List<String> proofs) {
    
    this.proofs = proofs;
    return this;
  }

  public GetSignagePoint200Response addProofsItem(String proofsItem) {
    if (this.proofs == null) {
      this.proofs = new ArrayList<>();
    }
    this.proofs.add(proofsItem);
    return this;
  }

   /**
   * Get proofs
   * @return proofs
  **/
  @javax.annotation.Nullable

  public List<String> getProofs() {
    return proofs;
  }


  public void setProofs(List<String> proofs) {
    this.proofs = proofs;
  }


  public GetSignagePoint200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetSignagePoint200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetSignagePoint200Response getSignagePoint200Response = (GetSignagePoint200Response) o;
    return Objects.equals(this.signagePoint, getSignagePoint200Response.signagePoint) &&
        Objects.equals(this.proofs, getSignagePoint200Response.proofs) &&
        Objects.equals(this.success, getSignagePoint200Response.success) &&
        Objects.equals(this.error, getSignagePoint200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(signagePoint, proofs, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetSignagePoint200Response {\n");
    sb.append("    signagePoint: ").append(toIndentedString(signagePoint)).append("\n");
    sb.append("    proofs: ").append(toIndentedString(proofs)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("signage_point");
    openapiFields.add("proofs");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetSignagePoint200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetSignagePoint200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetSignagePoint200Response is not found in the empty JSON string", GetSignagePoint200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetSignagePoint200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetSignagePoint200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetSignagePoint200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // validate the optional field `signage_point`
      if (jsonObj.get("signage_point") != null && !jsonObj.get("signage_point").isJsonNull()) {
        FarmerSignagePoint.validateJsonObject(jsonObj.getAsJsonObject("signage_point"));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("proofs") != null && !jsonObj.get("proofs").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `proofs` to be an array in the JSON string but got `%s`", jsonObj.get("proofs").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetSignagePoint200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetSignagePoint200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetSignagePoint200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetSignagePoint200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetSignagePoint200Response>() {
           @Override
           public void write(JsonWriter out, GetSignagePoint200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetSignagePoint200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetSignagePoint200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetSignagePoint200Response
  * @throws IOException if the JSON string is invalid with respect to GetSignagePoint200Response
  */
  public static GetSignagePoint200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetSignagePoint200Response.class);
  }

 /**
  * Convert an instance of GetSignagePoint200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

