/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.HarvesterConnection;
import org.openapitools.client.model.HarvesterInfoSyncing;
import org.openapitools.client.model.PlotInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * HarvesterInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class HarvesterInfo {
  public static final String SERIALIZED_NAME_CONNECTION = "connection";
  @SerializedName(SERIALIZED_NAME_CONNECTION)
  private HarvesterConnection connection;

  public static final String SERIALIZED_NAME_LAST_SYNC_TIME = "last_sync_time";
  @SerializedName(SERIALIZED_NAME_LAST_SYNC_TIME)
  private Double lastSyncTime;

  public static final String SERIALIZED_NAME_TOTAL_PLOT_SIZE = "total_plot_size";
  @SerializedName(SERIALIZED_NAME_TOTAL_PLOT_SIZE)
  private Long totalPlotSize;

  public static final String SERIALIZED_NAME_SYNCING = "syncing";
  @SerializedName(SERIALIZED_NAME_SYNCING)
  private HarvesterInfoSyncing syncing;

  public static final String SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES = "failed_to_open_filenames";
  @SerializedName(SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES)
  private List<String> failedToOpenFilenames;

  public static final String SERIALIZED_NAME_NO_KEY_FILENAMES = "no_key_filenames";
  @SerializedName(SERIALIZED_NAME_NO_KEY_FILENAMES)
  private List<String> noKeyFilenames;

  public static final String SERIALIZED_NAME_PLOTS = "plots";
  @SerializedName(SERIALIZED_NAME_PLOTS)
  private List<PlotInfo> plots;

  public static final String SERIALIZED_NAME_DUPLICATES = "duplicates";
  @SerializedName(SERIALIZED_NAME_DUPLICATES)
  private List<String> duplicates;

  public HarvesterInfo() {
  }

  public HarvesterInfo connection(HarvesterConnection connection) {
    
    this.connection = connection;
    return this;
  }

   /**
   * Get connection
   * @return connection
  **/
  @javax.annotation.Nullable

  public HarvesterConnection getConnection() {
    return connection;
  }


  public void setConnection(HarvesterConnection connection) {
    this.connection = connection;
  }


  public HarvesterInfo lastSyncTime(Double lastSyncTime) {
    
    this.lastSyncTime = lastSyncTime;
    return this;
  }

   /**
   * Get lastSyncTime
   * @return lastSyncTime
  **/
  @javax.annotation.Nullable

  public Double getLastSyncTime() {
    return lastSyncTime;
  }


  public void setLastSyncTime(Double lastSyncTime) {
    this.lastSyncTime = lastSyncTime;
  }


  public HarvesterInfo totalPlotSize(Long totalPlotSize) {
    
    this.totalPlotSize = totalPlotSize;
    return this;
  }

   /**
   * Get totalPlotSize
   * @return totalPlotSize
  **/
  @javax.annotation.Nullable

  public Long getTotalPlotSize() {
    return totalPlotSize;
  }


  public void setTotalPlotSize(Long totalPlotSize) {
    this.totalPlotSize = totalPlotSize;
  }


  public HarvesterInfo syncing(HarvesterInfoSyncing syncing) {
    
    this.syncing = syncing;
    return this;
  }

   /**
   * Get syncing
   * @return syncing
  **/
  @javax.annotation.Nullable

  public HarvesterInfoSyncing getSyncing() {
    return syncing;
  }


  public void setSyncing(HarvesterInfoSyncing syncing) {
    this.syncing = syncing;
  }


  public HarvesterInfo failedToOpenFilenames(List<String> failedToOpenFilenames) {
    
    this.failedToOpenFilenames = failedToOpenFilenames;
    return this;
  }

  public HarvesterInfo addFailedToOpenFilenamesItem(String failedToOpenFilenamesItem) {
    if (this.failedToOpenFilenames == null) {
      this.failedToOpenFilenames = new ArrayList<>();
    }
    this.failedToOpenFilenames.add(failedToOpenFilenamesItem);
    return this;
  }

   /**
   * Get failedToOpenFilenames
   * @return failedToOpenFilenames
  **/
  @javax.annotation.Nullable

  public List<String> getFailedToOpenFilenames() {
    return failedToOpenFilenames;
  }


  public void setFailedToOpenFilenames(List<String> failedToOpenFilenames) {
    this.failedToOpenFilenames = failedToOpenFilenames;
  }


  public HarvesterInfo noKeyFilenames(List<String> noKeyFilenames) {
    
    this.noKeyFilenames = noKeyFilenames;
    return this;
  }

  public HarvesterInfo addNoKeyFilenamesItem(String noKeyFilenamesItem) {
    if (this.noKeyFilenames == null) {
      this.noKeyFilenames = new ArrayList<>();
    }
    this.noKeyFilenames.add(noKeyFilenamesItem);
    return this;
  }

   /**
   * Get noKeyFilenames
   * @return noKeyFilenames
  **/
  @javax.annotation.Nullable

  public List<String> getNoKeyFilenames() {
    return noKeyFilenames;
  }


  public void setNoKeyFilenames(List<String> noKeyFilenames) {
    this.noKeyFilenames = noKeyFilenames;
  }


  public HarvesterInfo plots(List<PlotInfo> plots) {
    
    this.plots = plots;
    return this;
  }

  public HarvesterInfo addPlotsItem(PlotInfo plotsItem) {
    if (this.plots == null) {
      this.plots = new ArrayList<>();
    }
    this.plots.add(plotsItem);
    return this;
  }

   /**
   * Get plots
   * @return plots
  **/
  @javax.annotation.Nullable

  public List<PlotInfo> getPlots() {
    return plots;
  }


  public void setPlots(List<PlotInfo> plots) {
    this.plots = plots;
  }


  public HarvesterInfo duplicates(List<String> duplicates) {
    
    this.duplicates = duplicates;
    return this;
  }

  public HarvesterInfo addDuplicatesItem(String duplicatesItem) {
    if (this.duplicates == null) {
      this.duplicates = new ArrayList<>();
    }
    this.duplicates.add(duplicatesItem);
    return this;
  }

   /**
   * Get duplicates
   * @return duplicates
  **/
  @javax.annotation.Nullable

  public List<String> getDuplicates() {
    return duplicates;
  }


  public void setDuplicates(List<String> duplicates) {
    this.duplicates = duplicates;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvesterInfo harvesterInfo = (HarvesterInfo) o;
    return Objects.equals(this.connection, harvesterInfo.connection) &&
        Objects.equals(this.lastSyncTime, harvesterInfo.lastSyncTime) &&
        Objects.equals(this.totalPlotSize, harvesterInfo.totalPlotSize) &&
        Objects.equals(this.syncing, harvesterInfo.syncing) &&
        Objects.equals(this.failedToOpenFilenames, harvesterInfo.failedToOpenFilenames) &&
        Objects.equals(this.noKeyFilenames, harvesterInfo.noKeyFilenames) &&
        Objects.equals(this.plots, harvesterInfo.plots) &&
        Objects.equals(this.duplicates, harvesterInfo.duplicates);
  }

  @Override
  public int hashCode() {
    return Objects.hash(connection, lastSyncTime, totalPlotSize, syncing, failedToOpenFilenames, noKeyFilenames, plots, duplicates);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvesterInfo {\n");
    sb.append("    connection: ").append(toIndentedString(connection)).append("\n");
    sb.append("    lastSyncTime: ").append(toIndentedString(lastSyncTime)).append("\n");
    sb.append("    totalPlotSize: ").append(toIndentedString(totalPlotSize)).append("\n");
    sb.append("    syncing: ").append(toIndentedString(syncing)).append("\n");
    sb.append("    failedToOpenFilenames: ").append(toIndentedString(failedToOpenFilenames)).append("\n");
    sb.append("    noKeyFilenames: ").append(toIndentedString(noKeyFilenames)).append("\n");
    sb.append("    plots: ").append(toIndentedString(plots)).append("\n");
    sb.append("    duplicates: ").append(toIndentedString(duplicates)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("connection");
    openapiFields.add("last_sync_time");
    openapiFields.add("total_plot_size");
    openapiFields.add("syncing");
    openapiFields.add("failed_to_open_filenames");
    openapiFields.add("no_key_filenames");
    openapiFields.add("plots");
    openapiFields.add("duplicates");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to HarvesterInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!HarvesterInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in HarvesterInfo is not found in the empty JSON string", HarvesterInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!HarvesterInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `HarvesterInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `connection`
      if (jsonObj.get("connection") != null && !jsonObj.get("connection").isJsonNull()) {
        HarvesterConnection.validateJsonObject(jsonObj.getAsJsonObject("connection"));
      }
      // validate the optional field `syncing`
      if (jsonObj.get("syncing") != null && !jsonObj.get("syncing").isJsonNull()) {
        HarvesterInfoSyncing.validateJsonObject(jsonObj.getAsJsonObject("syncing"));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("failed_to_open_filenames") != null && !jsonObj.get("failed_to_open_filenames").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `failed_to_open_filenames` to be an array in the JSON string but got `%s`", jsonObj.get("failed_to_open_filenames").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("no_key_filenames") != null && !jsonObj.get("no_key_filenames").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `no_key_filenames` to be an array in the JSON string but got `%s`", jsonObj.get("no_key_filenames").toString()));
      }
      if (jsonObj.get("plots") != null && !jsonObj.get("plots").isJsonNull()) {
        JsonArray jsonArrayplots = jsonObj.getAsJsonArray("plots");
        if (jsonArrayplots != null) {
          // ensure the json data is an array
          if (!jsonObj.get("plots").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `plots` to be an array in the JSON string but got `%s`", jsonObj.get("plots").toString()));
          }

          // validate the optional field `plots` (array)
          for (int i = 0; i < jsonArrayplots.size(); i++) {
            PlotInfo.validateJsonObject(jsonArrayplots.get(i).getAsJsonObject());
          };
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("duplicates") != null && !jsonObj.get("duplicates").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `duplicates` to be an array in the JSON string but got `%s`", jsonObj.get("duplicates").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!HarvesterInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'HarvesterInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<HarvesterInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(HarvesterInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<HarvesterInfo>() {
           @Override
           public void write(JsonWriter out, HarvesterInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public HarvesterInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of HarvesterInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of HarvesterInfo
  * @throws IOException if the JSON string is invalid with respect to HarvesterInfo
  */
  public static HarvesterInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, HarvesterInfo.class);
  }

 /**
  * Convert an instance of HarvesterInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

