/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * HarvesterInfoSyncing
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class HarvesterInfoSyncing {
  public static final String SERIALIZED_NAME_INITIAL = "initial";
  @SerializedName(SERIALIZED_NAME_INITIAL)
  private Boolean initial;

  public static final String SERIALIZED_NAME_PLOT_FILES_PROCESSED = "plot_files_processed";
  @SerializedName(SERIALIZED_NAME_PLOT_FILES_PROCESSED)
  private Integer plotFilesProcessed;

  public static final String SERIALIZED_NAME_PLOT_FILES_TOTAL = "plot_files_total";
  @SerializedName(SERIALIZED_NAME_PLOT_FILES_TOTAL)
  private Integer plotFilesTotal;

  public HarvesterInfoSyncing() {
  }

  public HarvesterInfoSyncing initial(Boolean initial) {
    
    this.initial = initial;
    return this;
  }

   /**
   * Get initial
   * @return initial
  **/
  @javax.annotation.Nullable

  public Boolean getInitial() {
    return initial;
  }


  public void setInitial(Boolean initial) {
    this.initial = initial;
  }


  public HarvesterInfoSyncing plotFilesProcessed(Integer plotFilesProcessed) {
    
    this.plotFilesProcessed = plotFilesProcessed;
    return this;
  }

   /**
   * Get plotFilesProcessed
   * @return plotFilesProcessed
  **/
  @javax.annotation.Nullable

  public Integer getPlotFilesProcessed() {
    return plotFilesProcessed;
  }


  public void setPlotFilesProcessed(Integer plotFilesProcessed) {
    this.plotFilesProcessed = plotFilesProcessed;
  }


  public HarvesterInfoSyncing plotFilesTotal(Integer plotFilesTotal) {
    
    this.plotFilesTotal = plotFilesTotal;
    return this;
  }

   /**
   * Get plotFilesTotal
   * @return plotFilesTotal
  **/
  @javax.annotation.Nullable

  public Integer getPlotFilesTotal() {
    return plotFilesTotal;
  }


  public void setPlotFilesTotal(Integer plotFilesTotal) {
    this.plotFilesTotal = plotFilesTotal;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvesterInfoSyncing harvesterInfoSyncing = (HarvesterInfoSyncing) o;
    return Objects.equals(this.initial, harvesterInfoSyncing.initial) &&
        Objects.equals(this.plotFilesProcessed, harvesterInfoSyncing.plotFilesProcessed) &&
        Objects.equals(this.plotFilesTotal, harvesterInfoSyncing.plotFilesTotal);
  }

  @Override
  public int hashCode() {
    return Objects.hash(initial, plotFilesProcessed, plotFilesTotal);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvesterInfoSyncing {\n");
    sb.append("    initial: ").append(toIndentedString(initial)).append("\n");
    sb.append("    plotFilesProcessed: ").append(toIndentedString(plotFilesProcessed)).append("\n");
    sb.append("    plotFilesTotal: ").append(toIndentedString(plotFilesTotal)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("initial");
    openapiFields.add("plot_files_processed");
    openapiFields.add("plot_files_total");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to HarvesterInfoSyncing
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!HarvesterInfoSyncing.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in HarvesterInfoSyncing is not found in the empty JSON string", HarvesterInfoSyncing.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!HarvesterInfoSyncing.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `HarvesterInfoSyncing` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!HarvesterInfoSyncing.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'HarvesterInfoSyncing' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<HarvesterInfoSyncing> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(HarvesterInfoSyncing.class));

       return (TypeAdapter<T>) new TypeAdapter<HarvesterInfoSyncing>() {
           @Override
           public void write(JsonWriter out, HarvesterInfoSyncing value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public HarvesterInfoSyncing read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of HarvesterInfoSyncing given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of HarvesterInfoSyncing
  * @throws IOException if the JSON string is invalid with respect to HarvesterInfoSyncing
  */
  public static HarvesterInfoSyncing fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, HarvesterInfoSyncing.class);
  }

 /**
  * Convert an instance of HarvesterInfoSyncing to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

