/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.HarvesterConnection;
import org.openapitools.client.model.HarvesterInfoSyncing;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * HarvesterSummary
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class HarvesterSummary {
  public static final String SERIALIZED_NAME_CONNECTION = "connection";
  @SerializedName(SERIALIZED_NAME_CONNECTION)
  private HarvesterConnection connection;

  public static final String SERIALIZED_NAME_LAST_SYNC_TIME = "last_sync_time";
  @SerializedName(SERIALIZED_NAME_LAST_SYNC_TIME)
  private Double lastSyncTime;

  public static final String SERIALIZED_NAME_TOTAL_PLOT_SIZE = "total_plot_size";
  @SerializedName(SERIALIZED_NAME_TOTAL_PLOT_SIZE)
  private Long totalPlotSize;

  public static final String SERIALIZED_NAME_SYNCING = "syncing";
  @SerializedName(SERIALIZED_NAME_SYNCING)
  private HarvesterInfoSyncing syncing;

  public static final String SERIALIZED_NAME_PLOTS = "plots";
  @SerializedName(SERIALIZED_NAME_PLOTS)
  private Integer plots;

  public static final String SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES = "failed_to_open_filenames";
  @SerializedName(SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES)
  private Integer failedToOpenFilenames;

  public static final String SERIALIZED_NAME_NO_KEYS_FILENAMES = "no_keys_filenames";
  @SerializedName(SERIALIZED_NAME_NO_KEYS_FILENAMES)
  private Integer noKeysFilenames;

  public static final String SERIALIZED_NAME_DUPLICATES = "duplicates";
  @SerializedName(SERIALIZED_NAME_DUPLICATES)
  private Integer duplicates;

  public HarvesterSummary() {
  }

  public HarvesterSummary connection(HarvesterConnection connection) {
    
    this.connection = connection;
    return this;
  }

   /**
   * Get connection
   * @return connection
  **/
  @javax.annotation.Nullable

  public HarvesterConnection getConnection() {
    return connection;
  }


  public void setConnection(HarvesterConnection connection) {
    this.connection = connection;
  }


  public HarvesterSummary lastSyncTime(Double lastSyncTime) {
    
    this.lastSyncTime = lastSyncTime;
    return this;
  }

   /**
   * Get lastSyncTime
   * @return lastSyncTime
  **/
  @javax.annotation.Nullable

  public Double getLastSyncTime() {
    return lastSyncTime;
  }


  public void setLastSyncTime(Double lastSyncTime) {
    this.lastSyncTime = lastSyncTime;
  }


  public HarvesterSummary totalPlotSize(Long totalPlotSize) {
    
    this.totalPlotSize = totalPlotSize;
    return this;
  }

   /**
   * Get totalPlotSize
   * @return totalPlotSize
  **/
  @javax.annotation.Nullable

  public Long getTotalPlotSize() {
    return totalPlotSize;
  }


  public void setTotalPlotSize(Long totalPlotSize) {
    this.totalPlotSize = totalPlotSize;
  }


  public HarvesterSummary syncing(HarvesterInfoSyncing syncing) {
    
    this.syncing = syncing;
    return this;
  }

   /**
   * Get syncing
   * @return syncing
  **/
  @javax.annotation.Nullable

  public HarvesterInfoSyncing getSyncing() {
    return syncing;
  }


  public void setSyncing(HarvesterInfoSyncing syncing) {
    this.syncing = syncing;
  }


  public HarvesterSummary plots(Integer plots) {
    
    this.plots = plots;
    return this;
  }

   /**
   * Get plots
   * @return plots
  **/
  @javax.annotation.Nullable

  public Integer getPlots() {
    return plots;
  }


  public void setPlots(Integer plots) {
    this.plots = plots;
  }


  public HarvesterSummary failedToOpenFilenames(Integer failedToOpenFilenames) {
    
    this.failedToOpenFilenames = failedToOpenFilenames;
    return this;
  }

   /**
   * Get failedToOpenFilenames
   * @return failedToOpenFilenames
  **/
  @javax.annotation.Nullable

  public Integer getFailedToOpenFilenames() {
    return failedToOpenFilenames;
  }


  public void setFailedToOpenFilenames(Integer failedToOpenFilenames) {
    this.failedToOpenFilenames = failedToOpenFilenames;
  }


  public HarvesterSummary noKeysFilenames(Integer noKeysFilenames) {
    
    this.noKeysFilenames = noKeysFilenames;
    return this;
  }

   /**
   * Get noKeysFilenames
   * @return noKeysFilenames
  **/
  @javax.annotation.Nullable

  public Integer getNoKeysFilenames() {
    return noKeysFilenames;
  }


  public void setNoKeysFilenames(Integer noKeysFilenames) {
    this.noKeysFilenames = noKeysFilenames;
  }


  public HarvesterSummary duplicates(Integer duplicates) {
    
    this.duplicates = duplicates;
    return this;
  }

   /**
   * Get duplicates
   * @return duplicates
  **/
  @javax.annotation.Nullable

  public Integer getDuplicates() {
    return duplicates;
  }


  public void setDuplicates(Integer duplicates) {
    this.duplicates = duplicates;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    HarvesterSummary harvesterSummary = (HarvesterSummary) o;
    return Objects.equals(this.connection, harvesterSummary.connection) &&
        Objects.equals(this.lastSyncTime, harvesterSummary.lastSyncTime) &&
        Objects.equals(this.totalPlotSize, harvesterSummary.totalPlotSize) &&
        Objects.equals(this.syncing, harvesterSummary.syncing) &&
        Objects.equals(this.plots, harvesterSummary.plots) &&
        Objects.equals(this.failedToOpenFilenames, harvesterSummary.failedToOpenFilenames) &&
        Objects.equals(this.noKeysFilenames, harvesterSummary.noKeysFilenames) &&
        Objects.equals(this.duplicates, harvesterSummary.duplicates);
  }

  @Override
  public int hashCode() {
    return Objects.hash(connection, lastSyncTime, totalPlotSize, syncing, plots, failedToOpenFilenames, noKeysFilenames, duplicates);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class HarvesterSummary {\n");
    sb.append("    connection: ").append(toIndentedString(connection)).append("\n");
    sb.append("    lastSyncTime: ").append(toIndentedString(lastSyncTime)).append("\n");
    sb.append("    totalPlotSize: ").append(toIndentedString(totalPlotSize)).append("\n");
    sb.append("    syncing: ").append(toIndentedString(syncing)).append("\n");
    sb.append("    plots: ").append(toIndentedString(plots)).append("\n");
    sb.append("    failedToOpenFilenames: ").append(toIndentedString(failedToOpenFilenames)).append("\n");
    sb.append("    noKeysFilenames: ").append(toIndentedString(noKeysFilenames)).append("\n");
    sb.append("    duplicates: ").append(toIndentedString(duplicates)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("connection");
    openapiFields.add("last_sync_time");
    openapiFields.add("total_plot_size");
    openapiFields.add("syncing");
    openapiFields.add("plots");
    openapiFields.add("failed_to_open_filenames");
    openapiFields.add("no_keys_filenames");
    openapiFields.add("duplicates");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to HarvesterSummary
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!HarvesterSummary.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in HarvesterSummary is not found in the empty JSON string", HarvesterSummary.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!HarvesterSummary.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `HarvesterSummary` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `connection`
      if (jsonObj.get("connection") != null && !jsonObj.get("connection").isJsonNull()) {
        HarvesterConnection.validateJsonObject(jsonObj.getAsJsonObject("connection"));
      }
      // validate the optional field `syncing`
      if (jsonObj.get("syncing") != null && !jsonObj.get("syncing").isJsonNull()) {
        HarvesterInfoSyncing.validateJsonObject(jsonObj.getAsJsonObject("syncing"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!HarvesterSummary.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'HarvesterSummary' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<HarvesterSummary> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(HarvesterSummary.class));

       return (TypeAdapter<T>) new TypeAdapter<HarvesterSummary>() {
           @Override
           public void write(JsonWriter out, HarvesterSummary value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public HarvesterSummary read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of HarvesterSummary given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of HarvesterSummary
  * @throws IOException if the JSON string is invalid with respect to HarvesterSummary
  */
  public static HarvesterSummary fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, HarvesterSummary.class);
  }

 /**
  * Convert an instance of HarvesterSummary to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

