/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.KSize;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Info about a plot file
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class PlotInfo {
  public static final String SERIALIZED_NAME_FILE_SIZE = "file_size";
  @SerializedName(SERIALIZED_NAME_FILE_SIZE)
  private Integer fileSize;

  public static final String SERIALIZED_NAME_FILENAME = "filename";
  @SerializedName(SERIALIZED_NAME_FILENAME)
  private String filename;

  public static final String SERIALIZED_NAME_PLOT_ID = "plot_id";
  @SerializedName(SERIALIZED_NAME_PLOT_ID)
  private String plotId;

  public static final String SERIALIZED_NAME_PLOT_PUBLIC_KEY = "plot_public_key";
  @SerializedName(SERIALIZED_NAME_PLOT_PUBLIC_KEY)
  private String plotPublicKey;

  public static final String SERIALIZED_NAME_POOL_CONTRACT_PUZZLE_HASH = "pool_contract_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_POOL_CONTRACT_PUZZLE_HASH)
  private String poolContractPuzzleHash;

  public static final String SERIALIZED_NAME_POOL_PUBLIC_KEY = "pool_public_key";
  @SerializedName(SERIALIZED_NAME_POOL_PUBLIC_KEY)
  private String poolPublicKey;

  public static final String SERIALIZED_NAME_SIZE = "size";
  @SerializedName(SERIALIZED_NAME_SIZE)
  private KSize size = KSize.NUMBER_32;

  public static final String SERIALIZED_NAME_TIME_MODIFIED = "time_modified";
  @SerializedName(SERIALIZED_NAME_TIME_MODIFIED)
  private Double timeModified;

  public PlotInfo() {
  }

  public PlotInfo fileSize(Integer fileSize) {
    
    this.fileSize = fileSize;
    return this;
  }

   /**
   * Get fileSize
   * @return fileSize
  **/
  @javax.annotation.Nullable

  public Integer getFileSize() {
    return fileSize;
  }


  public void setFileSize(Integer fileSize) {
    this.fileSize = fileSize;
  }


  public PlotInfo filename(String filename) {
    
    this.filename = filename;
    return this;
  }

   /**
   * Get filename
   * @return filename
  **/
  @javax.annotation.Nullable

  public String getFilename() {
    return filename;
  }


  public void setFilename(String filename) {
    this.filename = filename;
  }


  public PlotInfo plotId(String plotId) {
    
    this.plotId = plotId;
    return this;
  }

   /**
   * Get plotId
   * @return plotId
  **/
  @javax.annotation.Nullable

  public String getPlotId() {
    return plotId;
  }


  public void setPlotId(String plotId) {
    this.plotId = plotId;
  }


  public PlotInfo plotPublicKey(String plotPublicKey) {
    
    this.plotPublicKey = plotPublicKey;
    return this;
  }

   /**
   * Get plotPublicKey
   * @return plotPublicKey
  **/
  @javax.annotation.Nullable

  public String getPlotPublicKey() {
    return plotPublicKey;
  }


  public void setPlotPublicKey(String plotPublicKey) {
    this.plotPublicKey = plotPublicKey;
  }


  public PlotInfo poolContractPuzzleHash(String poolContractPuzzleHash) {
    
    this.poolContractPuzzleHash = poolContractPuzzleHash;
    return this;
  }

   /**
   * Get poolContractPuzzleHash
   * @return poolContractPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getPoolContractPuzzleHash() {
    return poolContractPuzzleHash;
  }


  public void setPoolContractPuzzleHash(String poolContractPuzzleHash) {
    this.poolContractPuzzleHash = poolContractPuzzleHash;
  }


  public PlotInfo poolPublicKey(String poolPublicKey) {
    
    this.poolPublicKey = poolPublicKey;
    return this;
  }

   /**
   * Get poolPublicKey
   * @return poolPublicKey
  **/
  @javax.annotation.Nullable

  public String getPoolPublicKey() {
    return poolPublicKey;
  }


  public void setPoolPublicKey(String poolPublicKey) {
    this.poolPublicKey = poolPublicKey;
  }


  public PlotInfo size(KSize size) {
    
    this.size = size;
    return this;
  }

   /**
   * Get size
   * @return size
  **/
  @javax.annotation.Nullable

  public KSize getSize() {
    return size;
  }


  public void setSize(KSize size) {
    this.size = size;
  }


  public PlotInfo timeModified(Double timeModified) {
    
    this.timeModified = timeModified;
    return this;
  }

   /**
   * Get timeModified
   * @return timeModified
  **/
  @javax.annotation.Nullable

  public Double getTimeModified() {
    return timeModified;
  }


  public void setTimeModified(Double timeModified) {
    this.timeModified = timeModified;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PlotInfo plotInfo = (PlotInfo) o;
    return Objects.equals(this.fileSize, plotInfo.fileSize) &&
        Objects.equals(this.filename, plotInfo.filename) &&
        Objects.equals(this.plotId, plotInfo.plotId) &&
        Objects.equals(this.plotPublicKey, plotInfo.plotPublicKey) &&
        Objects.equals(this.poolContractPuzzleHash, plotInfo.poolContractPuzzleHash) &&
        Objects.equals(this.poolPublicKey, plotInfo.poolPublicKey) &&
        Objects.equals(this.size, plotInfo.size) &&
        Objects.equals(this.timeModified, plotInfo.timeModified);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(fileSize, filename, plotId, plotPublicKey, poolContractPuzzleHash, poolPublicKey, size, timeModified);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PlotInfo {\n");
    sb.append("    fileSize: ").append(toIndentedString(fileSize)).append("\n");
    sb.append("    filename: ").append(toIndentedString(filename)).append("\n");
    sb.append("    plotId: ").append(toIndentedString(plotId)).append("\n");
    sb.append("    plotPublicKey: ").append(toIndentedString(plotPublicKey)).append("\n");
    sb.append("    poolContractPuzzleHash: ").append(toIndentedString(poolContractPuzzleHash)).append("\n");
    sb.append("    poolPublicKey: ").append(toIndentedString(poolPublicKey)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    timeModified: ").append(toIndentedString(timeModified)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("file_size");
    openapiFields.add("filename");
    openapiFields.add("plot_id");
    openapiFields.add("plot_public_key");
    openapiFields.add("pool_contract_puzzle_hash");
    openapiFields.add("pool_public_key");
    openapiFields.add("size");
    openapiFields.add("time_modified");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PlotInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PlotInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PlotInfo is not found in the empty JSON string", PlotInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PlotInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PlotInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("filename") != null && !jsonObj.get("filename").isJsonNull()) && !jsonObj.get("filename").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `filename` to be a primitive type in the JSON string but got `%s`", jsonObj.get("filename").toString()));
      }
      if ((jsonObj.get("plot_id") != null && !jsonObj.get("plot_id").isJsonNull()) && !jsonObj.get("plot_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `plot_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("plot_id").toString()));
      }
      if ((jsonObj.get("plot_public_key") != null && !jsonObj.get("plot_public_key").isJsonNull()) && !jsonObj.get("plot_public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `plot_public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("plot_public_key").toString()));
      }
      if ((jsonObj.get("pool_contract_puzzle_hash") != null && !jsonObj.get("pool_contract_puzzle_hash").isJsonNull()) && !jsonObj.get("pool_contract_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_contract_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_contract_puzzle_hash").toString()));
      }
      if ((jsonObj.get("pool_public_key") != null && !jsonObj.get("pool_public_key").isJsonNull()) && !jsonObj.get("pool_public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_public_key").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PlotInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PlotInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PlotInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PlotInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<PlotInfo>() {
           @Override
           public void write(JsonWriter out, PlotInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PlotInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PlotInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PlotInfo
  * @throws IOException if the JSON string is invalid with respect to PlotInfo
  */
  public static PlotInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PlotInfo.class);
  }

 /**
  * Convert an instance of PlotInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

