/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.ErrorResponse;
import org.openapitools.client.model.PoolPoint;
import org.openapitools.client.model.PoolWalletConfig;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PoolStateInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class PoolStateInfo {
  public static final String SERIALIZED_NAME_AUTHENTICATION_TOKEN_TIMEOUT = "authentication_token_timeout";
  @SerializedName(SERIALIZED_NAME_AUTHENTICATION_TOKEN_TIMEOUT)
  private Integer authenticationTokenTimeout;

  public static final String SERIALIZED_NAME_CURRENT_DIFFICULTY = "current_difficulty";
  @SerializedName(SERIALIZED_NAME_CURRENT_DIFFICULTY)
  private Integer currentDifficulty;

  public static final String SERIALIZED_NAME_CURRENT_POINTS = "current_points";
  @SerializedName(SERIALIZED_NAME_CURRENT_POINTS)
  private Integer currentPoints;

  public static final String SERIALIZED_NAME_NEXT_FARMER_UPDATE = "next_farmer_update";
  @SerializedName(SERIALIZED_NAME_NEXT_FARMER_UPDATE)
  private Double nextFarmerUpdate;

  public static final String SERIALIZED_NAME_NEXT_POOL_INFO_UPDATE = "next_pool_info_update";
  @SerializedName(SERIALIZED_NAME_NEXT_POOL_INFO_UPDATE)
  private Double nextPoolInfoUpdate;

  public static final String SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH = "p2_singleton_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH)
  private String p2SingletonPuzzleHash;

  public static final String SERIALIZED_NAME_POINTS_ACKNOWLEDGED24H = "points_acknowledged24h";
  @SerializedName(SERIALIZED_NAME_POINTS_ACKNOWLEDGED24H)
  private List<PoolPoint> pointsAcknowledged24h;

  public static final String SERIALIZED_NAME_POINTS_ACKNOWLEDGED_SINCE_START = "points_acknowledged_since_start";
  @SerializedName(SERIALIZED_NAME_POINTS_ACKNOWLEDGED_SINCE_START)
  private Integer pointsAcknowledgedSinceStart;

  public static final String SERIALIZED_NAME_POINTS_FOUND24H = "points_found24h";
  @SerializedName(SERIALIZED_NAME_POINTS_FOUND24H)
  private List<PoolPoint> pointsFound24h;

  public static final String SERIALIZED_NAME_POINTS_FOUND_SINCE_START = "points_found_since_start";
  @SerializedName(SERIALIZED_NAME_POINTS_FOUND_SINCE_START)
  private Integer pointsFoundSinceStart;

  public static final String SERIALIZED_NAME_POOL_CONFIG = "pool_config";
  @SerializedName(SERIALIZED_NAME_POOL_CONFIG)
  private PoolWalletConfig poolConfig;

  public static final String SERIALIZED_NAME_POOL_ERRORS24H = "pool_errors24h";
  @SerializedName(SERIALIZED_NAME_POOL_ERRORS24H)
  private List<ErrorResponse> poolErrors24h;

  public static final String SERIALIZED_NAME_PLOT_COUNT = "plot_count";
  @SerializedName(SERIALIZED_NAME_PLOT_COUNT)
  private Integer plotCount;

  public PoolStateInfo() {
  }

  public PoolStateInfo authenticationTokenTimeout(Integer authenticationTokenTimeout) {
    
    this.authenticationTokenTimeout = authenticationTokenTimeout;
    return this;
  }

   /**
   * Get authenticationTokenTimeout
   * @return authenticationTokenTimeout
  **/
  @javax.annotation.Nullable

  public Integer getAuthenticationTokenTimeout() {
    return authenticationTokenTimeout;
  }


  public void setAuthenticationTokenTimeout(Integer authenticationTokenTimeout) {
    this.authenticationTokenTimeout = authenticationTokenTimeout;
  }


  public PoolStateInfo currentDifficulty(Integer currentDifficulty) {
    
    this.currentDifficulty = currentDifficulty;
    return this;
  }

   /**
   * Get currentDifficulty
   * @return currentDifficulty
  **/
  @javax.annotation.Nullable

  public Integer getCurrentDifficulty() {
    return currentDifficulty;
  }


  public void setCurrentDifficulty(Integer currentDifficulty) {
    this.currentDifficulty = currentDifficulty;
  }


  public PoolStateInfo currentPoints(Integer currentPoints) {
    
    this.currentPoints = currentPoints;
    return this;
  }

   /**
   * Get currentPoints
   * @return currentPoints
  **/
  @javax.annotation.Nullable

  public Integer getCurrentPoints() {
    return currentPoints;
  }


  public void setCurrentPoints(Integer currentPoints) {
    this.currentPoints = currentPoints;
  }


  public PoolStateInfo nextFarmerUpdate(Double nextFarmerUpdate) {
    
    this.nextFarmerUpdate = nextFarmerUpdate;
    return this;
  }

   /**
   * Get nextFarmerUpdate
   * @return nextFarmerUpdate
  **/
  @javax.annotation.Nullable

  public Double getNextFarmerUpdate() {
    return nextFarmerUpdate;
  }


  public void setNextFarmerUpdate(Double nextFarmerUpdate) {
    this.nextFarmerUpdate = nextFarmerUpdate;
  }


  public PoolStateInfo nextPoolInfoUpdate(Double nextPoolInfoUpdate) {
    
    this.nextPoolInfoUpdate = nextPoolInfoUpdate;
    return this;
  }

   /**
   * Get nextPoolInfoUpdate
   * @return nextPoolInfoUpdate
  **/
  @javax.annotation.Nullable

  public Double getNextPoolInfoUpdate() {
    return nextPoolInfoUpdate;
  }


  public void setNextPoolInfoUpdate(Double nextPoolInfoUpdate) {
    this.nextPoolInfoUpdate = nextPoolInfoUpdate;
  }


  public PoolStateInfo p2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
    return this;
  }

   /**
   * Get p2SingletonPuzzleHash
   * @return p2SingletonPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getP2SingletonPuzzleHash() {
    return p2SingletonPuzzleHash;
  }


  public void setP2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
  }


  public PoolStateInfo pointsAcknowledged24h(List<PoolPoint> pointsAcknowledged24h) {
    
    this.pointsAcknowledged24h = pointsAcknowledged24h;
    return this;
  }

  public PoolStateInfo addPointsAcknowledged24hItem(PoolPoint pointsAcknowledged24hItem) {
    if (this.pointsAcknowledged24h == null) {
      this.pointsAcknowledged24h = new ArrayList<>();
    }
    this.pointsAcknowledged24h.add(pointsAcknowledged24hItem);
    return this;
  }

   /**
   * Get pointsAcknowledged24h
   * @return pointsAcknowledged24h
  **/
  @javax.annotation.Nullable

  public List<PoolPoint> getPointsAcknowledged24h() {
    return pointsAcknowledged24h;
  }


  public void setPointsAcknowledged24h(List<PoolPoint> pointsAcknowledged24h) {
    this.pointsAcknowledged24h = pointsAcknowledged24h;
  }


  public PoolStateInfo pointsAcknowledgedSinceStart(Integer pointsAcknowledgedSinceStart) {
    
    this.pointsAcknowledgedSinceStart = pointsAcknowledgedSinceStart;
    return this;
  }

   /**
   * Get pointsAcknowledgedSinceStart
   * @return pointsAcknowledgedSinceStart
  **/
  @javax.annotation.Nullable

  public Integer getPointsAcknowledgedSinceStart() {
    return pointsAcknowledgedSinceStart;
  }


  public void setPointsAcknowledgedSinceStart(Integer pointsAcknowledgedSinceStart) {
    this.pointsAcknowledgedSinceStart = pointsAcknowledgedSinceStart;
  }


  public PoolStateInfo pointsFound24h(List<PoolPoint> pointsFound24h) {
    
    this.pointsFound24h = pointsFound24h;
    return this;
  }

  public PoolStateInfo addPointsFound24hItem(PoolPoint pointsFound24hItem) {
    if (this.pointsFound24h == null) {
      this.pointsFound24h = new ArrayList<>();
    }
    this.pointsFound24h.add(pointsFound24hItem);
    return this;
  }

   /**
   * Get pointsFound24h
   * @return pointsFound24h
  **/
  @javax.annotation.Nullable

  public List<PoolPoint> getPointsFound24h() {
    return pointsFound24h;
  }


  public void setPointsFound24h(List<PoolPoint> pointsFound24h) {
    this.pointsFound24h = pointsFound24h;
  }


  public PoolStateInfo pointsFoundSinceStart(Integer pointsFoundSinceStart) {
    
    this.pointsFoundSinceStart = pointsFoundSinceStart;
    return this;
  }

   /**
   * Get pointsFoundSinceStart
   * @return pointsFoundSinceStart
  **/
  @javax.annotation.Nullable

  public Integer getPointsFoundSinceStart() {
    return pointsFoundSinceStart;
  }


  public void setPointsFoundSinceStart(Integer pointsFoundSinceStart) {
    this.pointsFoundSinceStart = pointsFoundSinceStart;
  }


  public PoolStateInfo poolConfig(PoolWalletConfig poolConfig) {
    
    this.poolConfig = poolConfig;
    return this;
  }

   /**
   * Get poolConfig
   * @return poolConfig
  **/
  @javax.annotation.Nullable

  public PoolWalletConfig getPoolConfig() {
    return poolConfig;
  }


  public void setPoolConfig(PoolWalletConfig poolConfig) {
    this.poolConfig = poolConfig;
  }


  public PoolStateInfo poolErrors24h(List<ErrorResponse> poolErrors24h) {
    
    this.poolErrors24h = poolErrors24h;
    return this;
  }

  public PoolStateInfo addPoolErrors24hItem(ErrorResponse poolErrors24hItem) {
    if (this.poolErrors24h == null) {
      this.poolErrors24h = new ArrayList<>();
    }
    this.poolErrors24h.add(poolErrors24hItem);
    return this;
  }

   /**
   * Get poolErrors24h
   * @return poolErrors24h
  **/
  @javax.annotation.Nullable

  public List<ErrorResponse> getPoolErrors24h() {
    return poolErrors24h;
  }


  public void setPoolErrors24h(List<ErrorResponse> poolErrors24h) {
    this.poolErrors24h = poolErrors24h;
  }


  public PoolStateInfo plotCount(Integer plotCount) {
    
    this.plotCount = plotCount;
    return this;
  }

   /**
   * Get plotCount
   * @return plotCount
  **/
  @javax.annotation.Nullable

  public Integer getPlotCount() {
    return plotCount;
  }


  public void setPlotCount(Integer plotCount) {
    this.plotCount = plotCount;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PoolStateInfo poolStateInfo = (PoolStateInfo) o;
    return Objects.equals(this.authenticationTokenTimeout, poolStateInfo.authenticationTokenTimeout) &&
        Objects.equals(this.currentDifficulty, poolStateInfo.currentDifficulty) &&
        Objects.equals(this.currentPoints, poolStateInfo.currentPoints) &&
        Objects.equals(this.nextFarmerUpdate, poolStateInfo.nextFarmerUpdate) &&
        Objects.equals(this.nextPoolInfoUpdate, poolStateInfo.nextPoolInfoUpdate) &&
        Objects.equals(this.p2SingletonPuzzleHash, poolStateInfo.p2SingletonPuzzleHash) &&
        Objects.equals(this.pointsAcknowledged24h, poolStateInfo.pointsAcknowledged24h) &&
        Objects.equals(this.pointsAcknowledgedSinceStart, poolStateInfo.pointsAcknowledgedSinceStart) &&
        Objects.equals(this.pointsFound24h, poolStateInfo.pointsFound24h) &&
        Objects.equals(this.pointsFoundSinceStart, poolStateInfo.pointsFoundSinceStart) &&
        Objects.equals(this.poolConfig, poolStateInfo.poolConfig) &&
        Objects.equals(this.poolErrors24h, poolStateInfo.poolErrors24h) &&
        Objects.equals(this.plotCount, poolStateInfo.plotCount);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(authenticationTokenTimeout, currentDifficulty, currentPoints, nextFarmerUpdate, nextPoolInfoUpdate, p2SingletonPuzzleHash, pointsAcknowledged24h, pointsAcknowledgedSinceStart, pointsFound24h, pointsFoundSinceStart, poolConfig, poolErrors24h, plotCount);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PoolStateInfo {\n");
    sb.append("    authenticationTokenTimeout: ").append(toIndentedString(authenticationTokenTimeout)).append("\n");
    sb.append("    currentDifficulty: ").append(toIndentedString(currentDifficulty)).append("\n");
    sb.append("    currentPoints: ").append(toIndentedString(currentPoints)).append("\n");
    sb.append("    nextFarmerUpdate: ").append(toIndentedString(nextFarmerUpdate)).append("\n");
    sb.append("    nextPoolInfoUpdate: ").append(toIndentedString(nextPoolInfoUpdate)).append("\n");
    sb.append("    p2SingletonPuzzleHash: ").append(toIndentedString(p2SingletonPuzzleHash)).append("\n");
    sb.append("    pointsAcknowledged24h: ").append(toIndentedString(pointsAcknowledged24h)).append("\n");
    sb.append("    pointsAcknowledgedSinceStart: ").append(toIndentedString(pointsAcknowledgedSinceStart)).append("\n");
    sb.append("    pointsFound24h: ").append(toIndentedString(pointsFound24h)).append("\n");
    sb.append("    pointsFoundSinceStart: ").append(toIndentedString(pointsFoundSinceStart)).append("\n");
    sb.append("    poolConfig: ").append(toIndentedString(poolConfig)).append("\n");
    sb.append("    poolErrors24h: ").append(toIndentedString(poolErrors24h)).append("\n");
    sb.append("    plotCount: ").append(toIndentedString(plotCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("authentication_token_timeout");
    openapiFields.add("current_difficulty");
    openapiFields.add("current_points");
    openapiFields.add("next_farmer_update");
    openapiFields.add("next_pool_info_update");
    openapiFields.add("p2_singleton_puzzle_hash");
    openapiFields.add("points_acknowledged24h");
    openapiFields.add("points_acknowledged_since_start");
    openapiFields.add("points_found24h");
    openapiFields.add("points_found_since_start");
    openapiFields.add("pool_config");
    openapiFields.add("pool_errors24h");
    openapiFields.add("plot_count");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PoolStateInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PoolStateInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PoolStateInfo is not found in the empty JSON string", PoolStateInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PoolStateInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PoolStateInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("p2_singleton_puzzle_hash") != null && !jsonObj.get("p2_singleton_puzzle_hash").isJsonNull()) && !jsonObj.get("p2_singleton_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_singleton_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_singleton_puzzle_hash").toString()));
      }
      if (jsonObj.get("points_acknowledged24h") != null && !jsonObj.get("points_acknowledged24h").isJsonNull()) {
        JsonArray jsonArraypointsAcknowledged24h = jsonObj.getAsJsonArray("points_acknowledged24h");
        if (jsonArraypointsAcknowledged24h != null) {
          // ensure the json data is an array
          if (!jsonObj.get("points_acknowledged24h").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `points_acknowledged24h` to be an array in the JSON string but got `%s`", jsonObj.get("points_acknowledged24h").toString()));
          }

          // validate the optional field `points_acknowledged24h` (array)
          for (int i = 0; i < jsonArraypointsAcknowledged24h.size(); i++) {
            PoolPoint.validateJsonObject(jsonArraypointsAcknowledged24h.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("points_found24h") != null && !jsonObj.get("points_found24h").isJsonNull()) {
        JsonArray jsonArraypointsFound24h = jsonObj.getAsJsonArray("points_found24h");
        if (jsonArraypointsFound24h != null) {
          // ensure the json data is an array
          if (!jsonObj.get("points_found24h").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `points_found24h` to be an array in the JSON string but got `%s`", jsonObj.get("points_found24h").toString()));
          }

          // validate the optional field `points_found24h` (array)
          for (int i = 0; i < jsonArraypointsFound24h.size(); i++) {
            PoolPoint.validateJsonObject(jsonArraypointsFound24h.get(i).getAsJsonObject());
          };
        }
      }
      // validate the optional field `pool_config`
      if (jsonObj.get("pool_config") != null && !jsonObj.get("pool_config").isJsonNull()) {
        PoolWalletConfig.validateJsonObject(jsonObj.getAsJsonObject("pool_config"));
      }
      if (jsonObj.get("pool_errors24h") != null && !jsonObj.get("pool_errors24h").isJsonNull()) {
        JsonArray jsonArraypoolErrors24h = jsonObj.getAsJsonArray("pool_errors24h");
        if (jsonArraypoolErrors24h != null) {
          // ensure the json data is an array
          if (!jsonObj.get("pool_errors24h").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `pool_errors24h` to be an array in the JSON string but got `%s`", jsonObj.get("pool_errors24h").toString()));
          }

          // validate the optional field `pool_errors24h` (array)
          for (int i = 0; i < jsonArraypoolErrors24h.size(); i++) {
            ErrorResponse.validateJsonObject(jsonArraypoolErrors24h.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PoolStateInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PoolStateInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PoolStateInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PoolStateInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<PoolStateInfo>() {
           @Override
           public void write(JsonWriter out, PoolStateInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PoolStateInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PoolStateInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PoolStateInfo
  * @throws IOException if the JSON string is invalid with respect to PoolStateInfo
  */
  public static PoolStateInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PoolStateInfo.class);
  }

 /**
  * Convert an instance of PoolStateInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

