/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * This is what goes into the user&#39;s config file, to communicate between the wallet and the farmer processes.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class PoolWalletConfig {
  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_POOL_URL = "pool_url";
  @SerializedName(SERIALIZED_NAME_POOL_URL)
  private String poolUrl;

  public static final String SERIALIZED_NAME_PAYOUT_INSTRUCTIONS = "payout_instructions";
  @SerializedName(SERIALIZED_NAME_PAYOUT_INSTRUCTIONS)
  private String payoutInstructions;

  public static final String SERIALIZED_NAME_TARGET_PUZZLE_HASH = "target_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_TARGET_PUZZLE_HASH)
  private String targetPuzzleHash;

  public static final String SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH = "p2_singleton_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH)
  private String p2SingletonPuzzleHash;

  public static final String SERIALIZED_NAME_OWNER_PUBLIC_KEY = "owner_public_key";
  @SerializedName(SERIALIZED_NAME_OWNER_PUBLIC_KEY)
  private String ownerPublicKey;

  public static final String SERIALIZED_NAME_AUTHENTICATION_PUBLIC_KEY = "authentication_public_key";
  @SerializedName(SERIALIZED_NAME_AUTHENTICATION_PUBLIC_KEY)
  private String authenticationPublicKey;

  public PoolWalletConfig() {
  }

  public PoolWalletConfig launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public PoolWalletConfig poolUrl(String poolUrl) {
    
    this.poolUrl = poolUrl;
    return this;
  }

   /**
   * Get poolUrl
   * @return poolUrl
  **/
  @javax.annotation.Nullable

  public String getPoolUrl() {
    return poolUrl;
  }


  public void setPoolUrl(String poolUrl) {
    this.poolUrl = poolUrl;
  }


  public PoolWalletConfig payoutInstructions(String payoutInstructions) {
    
    this.payoutInstructions = payoutInstructions;
    return this;
  }

   /**
   * Get payoutInstructions
   * @return payoutInstructions
  **/
  @javax.annotation.Nullable

  public String getPayoutInstructions() {
    return payoutInstructions;
  }


  public void setPayoutInstructions(String payoutInstructions) {
    this.payoutInstructions = payoutInstructions;
  }


  public PoolWalletConfig targetPuzzleHash(String targetPuzzleHash) {
    
    this.targetPuzzleHash = targetPuzzleHash;
    return this;
  }

   /**
   * Get targetPuzzleHash
   * @return targetPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getTargetPuzzleHash() {
    return targetPuzzleHash;
  }


  public void setTargetPuzzleHash(String targetPuzzleHash) {
    this.targetPuzzleHash = targetPuzzleHash;
  }


  public PoolWalletConfig p2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
    return this;
  }

   /**
   * Get p2SingletonPuzzleHash
   * @return p2SingletonPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getP2SingletonPuzzleHash() {
    return p2SingletonPuzzleHash;
  }


  public void setP2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
  }


  public PoolWalletConfig ownerPublicKey(String ownerPublicKey) {
    
    this.ownerPublicKey = ownerPublicKey;
    return this;
  }

   /**
   * Get ownerPublicKey
   * @return ownerPublicKey
  **/
  @javax.annotation.Nullable

  public String getOwnerPublicKey() {
    return ownerPublicKey;
  }


  public void setOwnerPublicKey(String ownerPublicKey) {
    this.ownerPublicKey = ownerPublicKey;
  }


  public PoolWalletConfig authenticationPublicKey(String authenticationPublicKey) {
    
    this.authenticationPublicKey = authenticationPublicKey;
    return this;
  }

   /**
   * Get authenticationPublicKey
   * @return authenticationPublicKey
  **/
  @javax.annotation.Nullable

  public String getAuthenticationPublicKey() {
    return authenticationPublicKey;
  }


  public void setAuthenticationPublicKey(String authenticationPublicKey) {
    this.authenticationPublicKey = authenticationPublicKey;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PoolWalletConfig poolWalletConfig = (PoolWalletConfig) o;
    return Objects.equals(this.launcherId, poolWalletConfig.launcherId) &&
        Objects.equals(this.poolUrl, poolWalletConfig.poolUrl) &&
        Objects.equals(this.payoutInstructions, poolWalletConfig.payoutInstructions) &&
        Objects.equals(this.targetPuzzleHash, poolWalletConfig.targetPuzzleHash) &&
        Objects.equals(this.p2SingletonPuzzleHash, poolWalletConfig.p2SingletonPuzzleHash) &&
        Objects.equals(this.ownerPublicKey, poolWalletConfig.ownerPublicKey) &&
        Objects.equals(this.authenticationPublicKey, poolWalletConfig.authenticationPublicKey);
  }

  @Override
  public int hashCode() {
    return Objects.hash(launcherId, poolUrl, payoutInstructions, targetPuzzleHash, p2SingletonPuzzleHash, ownerPublicKey, authenticationPublicKey);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PoolWalletConfig {\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    poolUrl: ").append(toIndentedString(poolUrl)).append("\n");
    sb.append("    payoutInstructions: ").append(toIndentedString(payoutInstructions)).append("\n");
    sb.append("    targetPuzzleHash: ").append(toIndentedString(targetPuzzleHash)).append("\n");
    sb.append("    p2SingletonPuzzleHash: ").append(toIndentedString(p2SingletonPuzzleHash)).append("\n");
    sb.append("    ownerPublicKey: ").append(toIndentedString(ownerPublicKey)).append("\n");
    sb.append("    authenticationPublicKey: ").append(toIndentedString(authenticationPublicKey)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("launcher_id");
    openapiFields.add("pool_url");
    openapiFields.add("payout_instructions");
    openapiFields.add("target_puzzle_hash");
    openapiFields.add("p2_singleton_puzzle_hash");
    openapiFields.add("owner_public_key");
    openapiFields.add("authentication_public_key");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PoolWalletConfig
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PoolWalletConfig.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PoolWalletConfig is not found in the empty JSON string", PoolWalletConfig.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PoolWalletConfig.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PoolWalletConfig` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("pool_url") != null && !jsonObj.get("pool_url").isJsonNull()) && !jsonObj.get("pool_url").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_url` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_url").toString()));
      }
      if ((jsonObj.get("payout_instructions") != null && !jsonObj.get("payout_instructions").isJsonNull()) && !jsonObj.get("payout_instructions").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `payout_instructions` to be a primitive type in the JSON string but got `%s`", jsonObj.get("payout_instructions").toString()));
      }
      if ((jsonObj.get("target_puzzle_hash") != null && !jsonObj.get("target_puzzle_hash").isJsonNull()) && !jsonObj.get("target_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("target_puzzle_hash").toString()));
      }
      if ((jsonObj.get("p2_singleton_puzzle_hash") != null && !jsonObj.get("p2_singleton_puzzle_hash").isJsonNull()) && !jsonObj.get("p2_singleton_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_singleton_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_singleton_puzzle_hash").toString()));
      }
      if ((jsonObj.get("owner_public_key") != null && !jsonObj.get("owner_public_key").isJsonNull()) && !jsonObj.get("owner_public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `owner_public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("owner_public_key").toString()));
      }
      if ((jsonObj.get("authentication_public_key") != null && !jsonObj.get("authentication_public_key").isJsonNull()) && !jsonObj.get("authentication_public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `authentication_public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("authentication_public_key").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PoolWalletConfig.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PoolWalletConfig' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PoolWalletConfig> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PoolWalletConfig.class));

       return (TypeAdapter<T>) new TypeAdapter<PoolWalletConfig>() {
           @Override
           public void write(JsonWriter out, PoolWalletConfig value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PoolWalletConfig read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PoolWalletConfig given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PoolWalletConfig
  * @throws IOException if the JSON string is invalid with respect to PoolWalletConfig
  */
  public static PoolWalletConfig fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PoolWalletConfig.class);
  }

 /**
  * Convert an instance of PoolWalletConfig to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

