/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SetRewardTargetsRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class SetRewardTargetsRequest {
  public static final String SERIALIZED_NAME_FARMER_TARGET = "farmer_target";
  @SerializedName(SERIALIZED_NAME_FARMER_TARGET)
  private String farmerTarget;

  public static final String SERIALIZED_NAME_POOL_TARGET = "pool_target";
  @SerializedName(SERIALIZED_NAME_POOL_TARGET)
  private String poolTarget;

  public SetRewardTargetsRequest() {
  }

  public SetRewardTargetsRequest farmerTarget(String farmerTarget) {
    
    this.farmerTarget = farmerTarget;
    return this;
  }

   /**
   * Get farmerTarget
   * @return farmerTarget
  **/
  @javax.annotation.Nullable

  public String getFarmerTarget() {
    return farmerTarget;
  }


  public void setFarmerTarget(String farmerTarget) {
    this.farmerTarget = farmerTarget;
  }


  public SetRewardTargetsRequest poolTarget(String poolTarget) {
    
    this.poolTarget = poolTarget;
    return this;
  }

   /**
   * Get poolTarget
   * @return poolTarget
  **/
  @javax.annotation.Nullable

  public String getPoolTarget() {
    return poolTarget;
  }


  public void setPoolTarget(String poolTarget) {
    this.poolTarget = poolTarget;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SetRewardTargetsRequest setRewardTargetsRequest = (SetRewardTargetsRequest) o;
    return Objects.equals(this.farmerTarget, setRewardTargetsRequest.farmerTarget) &&
        Objects.equals(this.poolTarget, setRewardTargetsRequest.poolTarget);
  }

  @Override
  public int hashCode() {
    return Objects.hash(farmerTarget, poolTarget);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SetRewardTargetsRequest {\n");
    sb.append("    farmerTarget: ").append(toIndentedString(farmerTarget)).append("\n");
    sb.append("    poolTarget: ").append(toIndentedString(poolTarget)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("farmer_target");
    openapiFields.add("pool_target");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SetRewardTargetsRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SetRewardTargetsRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SetRewardTargetsRequest is not found in the empty JSON string", SetRewardTargetsRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SetRewardTargetsRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SetRewardTargetsRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("farmer_target") != null && !jsonObj.get("farmer_target").isJsonNull()) && !jsonObj.get("farmer_target").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `farmer_target` to be a primitive type in the JSON string but got `%s`", jsonObj.get("farmer_target").toString()));
      }
      if ((jsonObj.get("pool_target") != null && !jsonObj.get("pool_target").isJsonNull()) && !jsonObj.get("pool_target").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_target` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_target").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SetRewardTargetsRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SetRewardTargetsRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SetRewardTargetsRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SetRewardTargetsRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<SetRewardTargetsRequest>() {
           @Override
           public void write(JsonWriter out, SetRewardTargetsRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SetRewardTargetsRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SetRewardTargetsRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SetRewardTargetsRequest
  * @throws IOException if the JSON string is invalid with respect to SetRewardTargetsRequest
  */
  public static SetRewardTargetsRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SetRewardTargetsRequest.class);
  }

 /**
  * Convert an instance of SetRewardTargetsRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

