/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.FarmerSignagePoint;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SignagePointBundle
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:14:33.026379300-04:00[America/New_York]")
public class SignagePointBundle {
  public static final String SERIALIZED_NAME_SIGNAGE_POINT = "signage_point";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT)
  private FarmerSignagePoint signagePoint;

  public static final String SERIALIZED_NAME_PROOFS = "proofs";
  @SerializedName(SERIALIZED_NAME_PROOFS)
  private List<String> proofs;

  public SignagePointBundle() {
  }

  public SignagePointBundle signagePoint(FarmerSignagePoint signagePoint) {
    
    this.signagePoint = signagePoint;
    return this;
  }

   /**
   * Get signagePoint
   * @return signagePoint
  **/
  @javax.annotation.Nullable

  public FarmerSignagePoint getSignagePoint() {
    return signagePoint;
  }


  public void setSignagePoint(FarmerSignagePoint signagePoint) {
    this.signagePoint = signagePoint;
  }


  public SignagePointBundle proofs(List<String> proofs) {
    
    this.proofs = proofs;
    return this;
  }

  public SignagePointBundle addProofsItem(String proofsItem) {
    if (this.proofs == null) {
      this.proofs = new ArrayList<>();
    }
    this.proofs.add(proofsItem);
    return this;
  }

   /**
   * Get proofs
   * @return proofs
  **/
  @javax.annotation.Nullable

  public List<String> getProofs() {
    return proofs;
  }


  public void setProofs(List<String> proofs) {
    this.proofs = proofs;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SignagePointBundle signagePointBundle = (SignagePointBundle) o;
    return Objects.equals(this.signagePoint, signagePointBundle.signagePoint) &&
        Objects.equals(this.proofs, signagePointBundle.proofs);
  }

  @Override
  public int hashCode() {
    return Objects.hash(signagePoint, proofs);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SignagePointBundle {\n");
    sb.append("    signagePoint: ").append(toIndentedString(signagePoint)).append("\n");
    sb.append("    proofs: ").append(toIndentedString(proofs)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("signage_point");
    openapiFields.add("proofs");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SignagePointBundle
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SignagePointBundle.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SignagePointBundle is not found in the empty JSON string", SignagePointBundle.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SignagePointBundle.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SignagePointBundle` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `signage_point`
      if (jsonObj.get("signage_point") != null && !jsonObj.get("signage_point").isJsonNull()) {
        FarmerSignagePoint.validateJsonObject(jsonObj.getAsJsonObject("signage_point"));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("proofs") != null && !jsonObj.get("proofs").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `proofs` to be an array in the JSON string but got `%s`", jsonObj.get("proofs").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SignagePointBundle.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SignagePointBundle' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SignagePointBundle> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SignagePointBundle.class));

       return (TypeAdapter<T>) new TypeAdapter<SignagePointBundle>() {
           @Override
           public void write(JsonWriter out, SignagePointBundle value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SignagePointBundle read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SignagePointBundle given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SignagePointBundle
  * @throws IOException if the JSON string is invalid with respect to SignagePointBundle
  */
  public static SignagePointBundle fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SignagePointBundle.class);
  }

 /**
  * Convert an instance of SignagePointBundle to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

