/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The farmer uses port 8559 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetHarvesterPlotsValid200Response;
import org.openapitools.client.model.GetHarvesters200Response;
import org.openapitools.client.model.GetHarvestersSummary200Response;
import org.openapitools.client.model.GetPoolLoginLink200Response;
import org.openapitools.client.model.GetPoolLoginLinkRequest;
import org.openapitools.client.model.GetPoolState200Response;
import org.openapitools.client.model.GetRewardTargets200Response;
import org.openapitools.client.model.GetRewardTargetsRequest;
import org.openapitools.client.model.GetSignagePoint200Response;
import org.openapitools.client.model.GetSignagePointRequest;
import org.openapitools.client.model.GetSignagePoints200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.PlotInfoRequestData;
import org.openapitools.client.model.PlotPathRequestData;
import org.openapitools.client.model.SetPayoutInstructionsRequest;
import org.openapitools.client.model.SetRewardTargetsRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for FarmerApi
 */
@Disabled
public class FarmerApiTest {

    private final FarmerApi api = new FarmerApi();

    /**
     * Get a paginated list of duplicate plots.
     *
     * Get a paginated list of dupliacte plots.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvesterPlotsDuplicatesTest() throws ApiException {
        PlotPathRequestData plotPathRequestData = null;
        GetHarvesterPlotsValid200Response response = api.getHarvesterPlotsDuplicates(plotPathRequestData);
        // TODO: test validations
    }

    /**
     * Get a paginated list of invalid plots.
     *
     * Get a paginated list of invalid plots.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvesterPlotsInvalidTest() throws ApiException {
        PlotPathRequestData plotPathRequestData = null;
        GetHarvesterPlotsValid200Response response = api.getHarvesterPlotsInvalid(plotPathRequestData);
        // TODO: test validations
    }

    /**
     * Get a paginated list of plots with missing keys.
     *
     * Get a paginated list of invalid plots with missing keys.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvesterPlotsKeysMissingTest() throws ApiException {
        PlotPathRequestData plotPathRequestData = null;
        GetHarvesterPlotsValid200Response response = api.getHarvesterPlotsKeysMissing(plotPathRequestData);
        // TODO: test validations
    }

    /**
     * Get a paginated list of valid plots.
     *
     * Get a paginated list of valid plots.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvesterPlotsValidTest() throws ApiException {
        PlotInfoRequestData plotInfoRequestData = null;
        GetHarvesterPlotsValid200Response response = api.getHarvesterPlotsValid(plotInfoRequestData);
        // TODO: test validations
    }

    /**
     * Get the list of harvesters.
     *
     * Get the list of harvesters.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvestersTest() throws ApiException {
        Object body = null;
        GetHarvesters200Response response = api.getHarvesters(body);
        // TODO: test validations
    }

    /**
     * Get a summary of harvesters.
     *
     * Get a summary of harvesters, similar to get_harvests but with plot counts only.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHarvestersSummaryTest() throws ApiException {
        Object body = null;
        GetHarvestersSummary200Response response = api.getHarvestersSummary(body);
        // TODO: test validations
    }

    /**
     * Get&#39;s the pool login link, if any.
     *
     * Get&#39;s the pool login link, if any.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPoolLoginLinkTest() throws ApiException {
        GetPoolLoginLinkRequest getPoolLoginLinkRequest = null;
        GetPoolLoginLink200Response response = api.getPoolLoginLink(getPoolLoginLinkRequest);
        // TODO: test validations
    }

    /**
     * Get&#39;s the state of the pool.
     *
     * Get&#39;s the state of the pool.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPoolStateTest() throws ApiException {
        Object body = null;
        GetPoolState200Response response = api.getPoolState(body);
        // TODO: test validations
    }

    /**
     * Get the farm and pool reward targets.
     *
     * Get the farm and pool reward targets.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRewardTargetsTest() throws ApiException {
        GetRewardTargetsRequest getRewardTargetsRequest = null;
        GetRewardTargets200Response response = api.getRewardTargets(getRewardTargetsRequest);
        // TODO: test validations
    }

    /**
     * Get&#39;s a signage point by hash.
     *
     * Get&#39;s a signage point by hash.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getSignagePointTest() throws ApiException {
        GetSignagePointRequest getSignagePointRequest = null;
        GetSignagePoint200Response response = api.getSignagePoint(getSignagePointRequest);
        // TODO: test validations
    }

    /**
     * Get signage points.
     *
     * Get signage points.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getSignagePointsTest() throws ApiException {
        Object body = null;
        GetSignagePoints200Response response = api.getSignagePoints(body);
        // TODO: test validations
    }

    /**
     * Set&#39;s a pool&#39;s payout instructions.
     *
     * Set&#39;s a pool&#39;s payout instructions.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void setPayoutInstructionsTest() throws ApiException {
        SetPayoutInstructionsRequest setPayoutInstructionsRequest = null;
        ModelApiResponse response = api.setPayoutInstructions(setPayoutInstructionsRequest);
        // TODO: test validations
    }

    /**
     * Set the farm and pool reward targets.
     *
     * Set the farm and pool reward targets.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void setRewardTargetsTest() throws ApiException {
        SetRewardTargetsRequest setRewardTargetsRequest = null;
        ModelApiResponse response = api.setRewardTargets(setRewardTargetsRequest);
        // TODO: test validations
    }

}
