

# BlockRecord

This class is not included or hashed into the blockchain, but it is kept in memory as a more efficient way to maintain data about the blockchain. This allows us to validate future blocks, difficulty adjustments, etc, without saving the whole header block in memory.

## Properties

| Name | Type | Description | Notes |
|------------ | ------------- | ------------- | -------------|
|**challengeBlockInfoHash** | **String** | Hash of challenge chain data, used to validate end of slots in the future. |  [optional] |
|**challengeVdfOutput** | [**BlockRecordChallengeVdfOutput**](BlockRecordChallengeVdfOutput.md) |  |  [optional] |
|**deficit** | **Integer** | A deficit of 16 is an overflow block after an infusion. Deficit of 15 is a challenge block. |  [optional] |
|**farmerPuzzleHash** | **String** |  |  [optional] |
|**fees** | **Integer** | Transaction block (present iff is_transaction_block) |  [optional] |
|**finishedChallengeSlotHashes** | **String** | Slot (present iff this is the first SB in sub slot) |  [optional] |
|**finishedInfusedChallengeSlotHashes** | **String** | Slot (present iff this is the first SB in sub slot) |  [optional] |
|**finishedRewardSlotHashes** | **String** | Slot (present iff this is the first SB in sub slot) |  [optional] |
|**headerHash** | **String** |  |  [optional] |
|**height** | **Integer** |  |  [optional] |
|**infusedChallengeVdfOutput** | **String** | This is the intermediary VDF output at ip_iters in infused cc, if deficit less than or equal to 3. |  [optional] |
|**overflow** | **Boolean** |  |  [optional] |
|**poolPuzzleHash** | **String** | Need to keep track of these because Coins are created in a future block. |  [optional] |
|**prevHash** | **String** | Header hash of the previous block. Transaction block (present iff is_transaction_block). |  [optional] |
|**prevTransactionBlockHash** | **String** | Header hash of the previous transaction block |  [optional] |
|**prevTransactionBlockHeight** | **Integer** |  |  [optional] |
|**requiredIters** | **Integer** |  |  [optional] |
|**rewardClaimsIncorporated** | **String** |  |  [optional] |
|**rewardInfusionNewChallenge** | **String** | The reward chain infusion output, input to next VDF |  [optional] |
|**signagePointIndex** | **Integer** |  |  [optional] |
|**subEpochSummaryIncluded** | **String** |  |  [optional] |
|**subSlotIters** | **Integer** |  |  [optional] |
|**timestamp** | **Integer** |  |  [optional] |
|**totalIters** | **Integer** | Total number of VDF iterations since genesis, including this block |  [optional] |
|**weight** | **Integer** | Total cumulative difficulty of all ancestor blocks since genesis |  [optional] |



