# BlocksApi

All URIs are relative to *https://localhost:8555*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getAdditionsAndRemovals**](BlocksApi.md#getAdditionsAndRemovals) | **POST** /get_additions_and_removals | Retrieves the additions and removals for a certain block. |
| [**getBlock**](BlocksApi.md#getBlock) | **POST** /get_block | Retrieves a block by header hash. |
| [**getBlockCountMetrics**](BlocksApi.md#getBlockCountMetrics) | **POST** /get_block_count_metrics | Retrieves aggregate information about blocks. |
| [**getBlockRecord**](BlocksApi.md#getBlockRecord) | **POST** /get_block_record | Retrieves a block record by header hash. |
| [**getBlockRecordByHeight**](BlocksApi.md#getBlockRecordByHeight) | **POST** /get_block_record_by_height | Retrieves a block record by height. |
| [**getBlockRecords**](BlocksApi.md#getBlockRecords) | **POST** /get_block_records | Retrieves block records in a range. |
| [**getBlockSpends**](BlocksApi.md#getBlockSpends) | **POST** /get_block_spends | Retrieves the spends in the given block. |
| [**getBlocks**](BlocksApi.md#getBlocks) | **POST** /get_blocks | Get the blocks between a start and end height. |
| [**getRecentSignagePointOrEos**](BlocksApi.md#getRecentSignagePointOrEos) | **POST** /get_recent_signage_point_or_eos | Retrieves a recent signage point or end of slot. |
| [**getUnfinishedBlockHeaders**](BlocksApi.md#getUnfinishedBlockHeaders) | **POST** /get_unfinished_block_headers | Retrieves unfinished block headers. |


<a name="getAdditionsAndRemovals"></a>
# **getAdditionsAndRemovals**
> GetAdditionsAndRemovals200Response getAdditionsAndRemovals(getBlockRecordRequest)

Retrieves the additions and removals for a certain block.

Retrieves the additions and removals (state transitions) for a certain block. Returns coin records for each addition and removal.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordRequest getBlockRecordRequest = new GetBlockRecordRequest(); // GetBlockRecordRequest | the block's header_hash
    try {
      GetAdditionsAndRemovals200Response result = apiInstance.getAdditionsAndRemovals(getBlockRecordRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getAdditionsAndRemovals");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordRequest** | [**GetBlockRecordRequest**](GetBlockRecordRequest.md)| the block&#39;s header_hash | |

### Return type

[**GetAdditionsAndRemovals200Response**](GetAdditionsAndRemovals200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlock"></a>
# **getBlock**
> GetBlock200Response getBlock(getBlockRecordRequest)

Retrieves a block by header hash.

Retrieves a block by header hash.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordRequest getBlockRecordRequest = new GetBlockRecordRequest(); // GetBlockRecordRequest | the block's header_hash
    try {
      GetBlock200Response result = apiInstance.getBlock(getBlockRecordRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlock");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordRequest** | [**GetBlockRecordRequest**](GetBlockRecordRequest.md)| the block&#39;s header_hash | |

### Return type

[**GetBlock200Response**](GetBlock200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockCountMetrics"></a>
# **getBlockCountMetrics**
> GetBlockCountMetrics200Response getBlockCountMetrics(body)

Retrieves aggregate information about blocks.

Retrieves aggregate information about blocks.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetBlockCountMetrics200Response result = apiInstance.getBlockCountMetrics(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlockCountMetrics");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetBlockCountMetrics200Response**](GetBlockCountMetrics200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockRecord"></a>
# **getBlockRecord**
> GetBlockRecord200Response getBlockRecord(getBlockRecordRequest)

Retrieves a block record by header hash.

Retrieves a block record by header hash.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordRequest getBlockRecordRequest = new GetBlockRecordRequest(); // GetBlockRecordRequest | the block's header_hash
    try {
      GetBlockRecord200Response result = apiInstance.getBlockRecord(getBlockRecordRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlockRecord");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordRequest** | [**GetBlockRecordRequest**](GetBlockRecordRequest.md)| the block&#39;s header_hash | |

### Return type

[**GetBlockRecord200Response**](GetBlockRecord200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockRecordByHeight"></a>
# **getBlockRecordByHeight**
> GetBlockRecord200Response getBlockRecordByHeight(getBlockRecordByHeightRequest)

Retrieves a block record by height.

Retrieves a block record by height (assuming the height &lt;&#x3D; peak height). Note that not all blocks will have all fields set here (depending on transaction block, finishing sub epoch, etc).

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordByHeightRequest getBlockRecordByHeightRequest = new GetBlockRecordByHeightRequest(); // GetBlockRecordByHeightRequest | the block height
    try {
      GetBlockRecord200Response result = apiInstance.getBlockRecordByHeight(getBlockRecordByHeightRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlockRecordByHeight");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordByHeightRequest** | [**GetBlockRecordByHeightRequest**](GetBlockRecordByHeightRequest.md)| the block height | |

### Return type

[**GetBlockRecord200Response**](GetBlockRecord200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockRecords"></a>
# **getBlockRecords**
> GetBlockRecords200Response getBlockRecords(getBlockRecordsRequest)

Retrieves block records in a range.

Retrieves block records in a range

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordsRequest getBlockRecordsRequest = new GetBlockRecordsRequest(); // GetBlockRecordsRequest | Start and end heights
    try {
      GetBlockRecords200Response result = apiInstance.getBlockRecords(getBlockRecordsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlockRecords");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordsRequest** | [**GetBlockRecordsRequest**](GetBlockRecordsRequest.md)| Start and end heights | |

### Return type

[**GetBlockRecords200Response**](GetBlockRecords200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockSpends"></a>
# **getBlockSpends**
> GetBlockSpends200Response getBlockSpends(getBlockRecordRequest)

Retrieves the spends in the given block.

Retrieves the spends in the given block.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlockRecordRequest getBlockRecordRequest = new GetBlockRecordRequest(); // GetBlockRecordRequest | the block's header_hash
    try {
      GetBlockSpends200Response result = apiInstance.getBlockSpends(getBlockRecordRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlockSpends");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlockRecordRequest** | [**GetBlockRecordRequest**](GetBlockRecordRequest.md)| the block&#39;s header_hash | |

### Return type

[**GetBlockSpends200Response**](GetBlockSpends200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlocks"></a>
# **getBlocks**
> GetBlocks200Response getBlocks(getBlocksRequest)

Get the blocks between a start and end height.

Get the blocks between a start and end height

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetBlocksRequest getBlocksRequest = new GetBlocksRequest(); // GetBlocksRequest | Start and end heights
    try {
      GetBlocks200Response result = apiInstance.getBlocks(getBlocksRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getBlocks");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getBlocksRequest** | [**GetBlocksRequest**](GetBlocksRequest.md)| Start and end heights | |

### Return type

[**GetBlocks200Response**](GetBlocks200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getRecentSignagePointOrEos"></a>
# **getRecentSignagePointOrEos**
> GetRecentSignagePointOrEos200Response getRecentSignagePointOrEos(getRecentSignagePointOrEosRequest)

Retrieves a recent signage point or end of slot.

Retrieves a recent signage point or end of slot.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest = new GetRecentSignagePointOrEosRequest(); // GetRecentSignagePointOrEosRequest | The signage point hash or challenge hash. If both are present sp_hash takes precedence.
    try {
      GetRecentSignagePointOrEos200Response result = apiInstance.getRecentSignagePointOrEos(getRecentSignagePointOrEosRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getRecentSignagePointOrEos");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getRecentSignagePointOrEosRequest** | [**GetRecentSignagePointOrEosRequest**](GetRecentSignagePointOrEosRequest.md)| The signage point hash or challenge hash. If both are present sp_hash takes precedence. | |

### Return type

[**GetRecentSignagePointOrEos200Response**](GetRecentSignagePointOrEos200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getUnfinishedBlockHeaders"></a>
# **getUnfinishedBlockHeaders**
> GetUnfinishedBlockHeaders200Response getUnfinishedBlockHeaders(body)

Retrieves unfinished block headers.

Retrieves unfinished block headers.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.BlocksApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    BlocksApi apiInstance = new BlocksApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetUnfinishedBlockHeaders200Response result = apiInstance.getUnfinishedBlockHeaders(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling BlocksApi#getUnfinishedBlockHeaders");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetUnfinishedBlockHeaders200Response**](GetUnfinishedBlockHeaders200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

