# CoinsApi

All URIs are relative to *https://localhost:8555*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getCoinRecordByName**](CoinsApi.md#getCoinRecordByName) | **POST** /get_coin_record_by_name | Retrieves a coin record by it&#39;s name. |
| [**getCoinRecordsByHint**](CoinsApi.md#getCoinRecordsByHint) | **POST** /get_coin_records_by_hint | Retrieves coins by hint. |
| [**getCoinRecordsByNames**](CoinsApi.md#getCoinRecordsByNames) | **POST** /get_coin_records_by_names | Retrieves the coins for given coin IDs. |
| [**getCoinRecordsByParentIds**](CoinsApi.md#getCoinRecordsByParentIds) | **POST** /get_coin_records_by_parent_ids | Retrieves the coins for given parent coin IDs. |
| [**getCoinRecordsByPuzzleHash**](CoinsApi.md#getCoinRecordsByPuzzleHash) | **POST** /get_coin_records_by_puzzle_hash | Retrieves the coins for a given puzzlehash. |
| [**getCoinRecordsByPuzzleHashes**](CoinsApi.md#getCoinRecordsByPuzzleHashes) | **POST** /get_coin_records_by_puzzle_hashes | Retrieves the coins for a given puzzlehashes |
| [**getPuzzleAndSolution**](CoinsApi.md#getPuzzleAndSolution) | **POST** /get_puzzle_and_solution | Retrieves a coin solution. |
| [**pushTx**](CoinsApi.md#pushTx) | **POST** /push_tx | Pushes a transaction/spend bundle to the mempool and blockchain. |


<a name="getCoinRecordByName"></a>
# **getCoinRecordByName**
> GetCoinRecordByName200Response getCoinRecordByName(getCoinRecordByNameRequest)

Retrieves a coin record by it&#39;s name.

Retrieves a coin record by it&#39;s name.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordByNameRequest getCoinRecordByNameRequest = new GetCoinRecordByNameRequest(); // GetCoinRecordByNameRequest | The coin name.
    try {
      GetCoinRecordByName200Response result = apiInstance.getCoinRecordByName(getCoinRecordByNameRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordByName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordByNameRequest** | [**GetCoinRecordByNameRequest**](GetCoinRecordByNameRequest.md)| The coin name. | |

### Return type

[**GetCoinRecordByName200Response**](GetCoinRecordByName200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCoinRecordsByHint"></a>
# **getCoinRecordsByHint**
> GetCoinRecordsByPuzzleHash200Response getCoinRecordsByHint(getCoinRecordsByHintRequest)

Retrieves coins by hint.

Retrieves coins by hint, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByHintRequest getCoinRecordsByHintRequest = new GetCoinRecordsByHintRequest(); // GetCoinRecordsByHintRequest | The hint.
    try {
      GetCoinRecordsByPuzzleHash200Response result = apiInstance.getCoinRecordsByHint(getCoinRecordsByHintRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByHint");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByHintRequest** | [**GetCoinRecordsByHintRequest**](GetCoinRecordsByHintRequest.md)| The hint. | |

### Return type

[**GetCoinRecordsByPuzzleHash200Response**](GetCoinRecordsByPuzzleHash200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCoinRecordsByNames"></a>
# **getCoinRecordsByNames**
> GetCoinRecordsByPuzzleHash200Response getCoinRecordsByNames(getCoinRecordsByNamesRequest)

Retrieves the coins for given coin IDs.

Retrieves the coins for given coin IDs, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest = new GetCoinRecordsByNamesRequest(); // GetCoinRecordsByNamesRequest | The coin names.
    try {
      GetCoinRecordsByPuzzleHash200Response result = apiInstance.getCoinRecordsByNames(getCoinRecordsByNamesRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByNames");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByNamesRequest** | [**GetCoinRecordsByNamesRequest**](GetCoinRecordsByNamesRequest.md)| The coin names. | |

### Return type

[**GetCoinRecordsByPuzzleHash200Response**](GetCoinRecordsByPuzzleHash200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCoinRecordsByParentIds"></a>
# **getCoinRecordsByParentIds**
> GetCoinRecordsByPuzzleHash200Response getCoinRecordsByParentIds(getCoinRecordsByParentIdsRequest)

Retrieves the coins for given parent coin IDs.

Retrieves the coins for given parent coin IDs, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest = new GetCoinRecordsByParentIdsRequest(); // GetCoinRecordsByParentIdsRequest | The parent ids.
    try {
      GetCoinRecordsByPuzzleHash200Response result = apiInstance.getCoinRecordsByParentIds(getCoinRecordsByParentIdsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByParentIds");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByParentIdsRequest** | [**GetCoinRecordsByParentIdsRequest**](GetCoinRecordsByParentIdsRequest.md)| The parent ids. | |

### Return type

[**GetCoinRecordsByPuzzleHash200Response**](GetCoinRecordsByPuzzleHash200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCoinRecordsByPuzzleHash"></a>
# **getCoinRecordsByPuzzleHash**
> GetCoinRecordsByPuzzleHash200Response getCoinRecordsByPuzzleHash(getCoinRecordsByPuzzleHashRequest)

Retrieves the coins for a given puzzlehash.

Retrieves the coins for a given puzzlehash, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest = new GetCoinRecordsByPuzzleHashRequest(); // GetCoinRecordsByPuzzleHashRequest | The puzzle hash.
    try {
      GetCoinRecordsByPuzzleHash200Response result = apiInstance.getCoinRecordsByPuzzleHash(getCoinRecordsByPuzzleHashRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByPuzzleHash");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByPuzzleHashRequest** | [**GetCoinRecordsByPuzzleHashRequest**](GetCoinRecordsByPuzzleHashRequest.md)| The puzzle hash. | |

### Return type

[**GetCoinRecordsByPuzzleHash200Response**](GetCoinRecordsByPuzzleHash200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCoinRecordsByPuzzleHashes"></a>
# **getCoinRecordsByPuzzleHashes**
> GetCoinRecordsByPuzzleHash200Response getCoinRecordsByPuzzleHashes(getCoinRecordsByPuzzleHashesRequest)

Retrieves the coins for a given puzzlehashes

Retrieves the coins for a given puzzlehashes, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest = new GetCoinRecordsByPuzzleHashesRequest(); // GetCoinRecordsByPuzzleHashesRequest | The puzzle hashes.
    try {
      GetCoinRecordsByPuzzleHash200Response result = apiInstance.getCoinRecordsByPuzzleHashes(getCoinRecordsByPuzzleHashesRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByPuzzleHashes");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByPuzzleHashesRequest** | [**GetCoinRecordsByPuzzleHashesRequest**](GetCoinRecordsByPuzzleHashesRequest.md)| The puzzle hashes. | |

### Return type

[**GetCoinRecordsByPuzzleHash200Response**](GetCoinRecordsByPuzzleHash200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getPuzzleAndSolution"></a>
# **getPuzzleAndSolution**
> GetPuzzleAndSolution200Response getPuzzleAndSolution(getPuzzleAndSolutionRequest)

Retrieves a coin solution.

Retrieves a coin solution.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest = new GetPuzzleAndSolutionRequest(); // GetPuzzleAndSolutionRequest | The coin id and height
    try {
      GetPuzzleAndSolution200Response result = apiInstance.getPuzzleAndSolution(getPuzzleAndSolutionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getPuzzleAndSolution");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getPuzzleAndSolutionRequest** | [**GetPuzzleAndSolutionRequest**](GetPuzzleAndSolutionRequest.md)| The coin id and height | |

### Return type

[**GetPuzzleAndSolution200Response**](GetPuzzleAndSolution200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="pushTx"></a>
# **pushTx**
> PushTx200Response pushTx(pushTxRequest)

Pushes a transaction/spend bundle to the mempool and blockchain.

Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    PushTxRequest pushTxRequest = new PushTxRequest(); // PushTxRequest | The spend bundle
    try {
      PushTx200Response result = apiInstance.pushTx(pushTxRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#pushTx");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **pushTxRequest** | [**PushTxRequest**](PushTxRequest.md)| The spend bundle | |

### Return type

[**PushTx200Response**](PushTx200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

