# FullNodeApi

All URIs are relative to *https://localhost:8555*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**fullNodeGetNetworkInfo**](FullNodeApi.md#fullNodeGetNetworkInfo) | **POST** /get_network_info | Retrieves some information about the current network. |
| [**getBlockchainState**](FullNodeApi.md#getBlockchainState) | **POST** /get_blockchain_state | Retrieves a summary of the current state of the blockchain and full node. |
| [**getNetworkSpace**](FullNodeApi.md#getNetworkSpace) | **POST** /get_network_space | Retrieves an estimate of total space. |


<a name="fullNodeGetNetworkInfo"></a>
# **fullNodeGetNetworkInfo**
> FullNodeGetNetworkInfo200Response fullNodeGetNetworkInfo(body)

Retrieves some information about the current network.

Retrieves some information about the current network.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FullNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    FullNodeApi apiInstance = new FullNodeApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      FullNodeGetNetworkInfo200Response result = apiInstance.fullNodeGetNetworkInfo(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FullNodeApi#fullNodeGetNetworkInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**FullNodeGetNetworkInfo200Response**](FullNodeGetNetworkInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getBlockchainState"></a>
# **getBlockchainState**
> GetBlockchainState200Response getBlockchainState(body)

Retrieves a summary of the current state of the blockchain and full node.

Retrieves a summary of the current state of the blockchain and full node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FullNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    FullNodeApi apiInstance = new FullNodeApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetBlockchainState200Response result = apiInstance.getBlockchainState(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FullNodeApi#getBlockchainState");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetBlockchainState200Response**](GetBlockchainState200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getNetworkSpace"></a>
# **getNetworkSpace**
> GetNetworkSpace200Response getNetworkSpace(getNetworkSpaceRequest)

Retrieves an estimate of total space.

Retrieves an estimate of total space validating the chain between two block header hashes.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.FullNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    FullNodeApi apiInstance = new FullNodeApi(defaultClient);
    GetNetworkSpaceRequest getNetworkSpaceRequest = new GetNetworkSpaceRequest(); // GetNetworkSpaceRequest | The block header hashes
    try {
      GetNetworkSpace200Response result = apiInstance.getNetworkSpace(getNetworkSpaceRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FullNodeApi#getNetworkSpace");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getNetworkSpaceRequest** | [**GetNetworkSpaceRequest**](GetNetworkSpaceRequest.md)| The block header hashes | |

### Return type

[**GetNetworkSpace200Response**](GetNetworkSpace200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

