# MempoolApi

All URIs are relative to *https://localhost:8555*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getAllMempoolItems**](MempoolApi.md#getAllMempoolItems) | **POST** /get_all_mempool_items | Returns all items in the mempool. |
| [**getAllMempoolTxIds**](MempoolApi.md#getAllMempoolTxIds) | **POST** /get_all_mempool_tx_ids | Returns a list of all transaction IDs in the mempool. |
| [**getMempoolItemByTxId**](MempoolApi.md#getMempoolItemByTxId) | **POST** /get_mempool_item_by_tx_id | Returns a specific item from the mempool. |


<a name="getAllMempoolItems"></a>
# **getAllMempoolItems**
> GetAllMempoolItems200Response getAllMempoolItems(body)

Returns all items in the mempool.

Returns all items in the mempool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MempoolApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    MempoolApi apiInstance = new MempoolApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetAllMempoolItems200Response result = apiInstance.getAllMempoolItems(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MempoolApi#getAllMempoolItems");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetAllMempoolItems200Response**](GetAllMempoolItems200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getAllMempoolTxIds"></a>
# **getAllMempoolTxIds**
> GetAllMempoolTxIds200Response getAllMempoolTxIds(body)

Returns a list of all transaction IDs in the mempool.

Returns a list of all transaction IDs (spend bundle hashes) in the mempool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MempoolApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    MempoolApi apiInstance = new MempoolApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetAllMempoolTxIds200Response result = apiInstance.getAllMempoolTxIds(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MempoolApi#getAllMempoolTxIds");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetAllMempoolTxIds200Response**](GetAllMempoolTxIds200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getMempoolItemByTxId"></a>
# **getMempoolItemByTxId**
> GetMempoolItemByTxId200Response getMempoolItemByTxId(getMempoolItemByTxIdRequest)

Returns a specific item from the mempool.

Returns a specific item from the mempool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.MempoolApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8555");
    

    MempoolApi apiInstance = new MempoolApi(defaultClient);
    GetMempoolItemByTxIdRequest getMempoolItemByTxIdRequest = new GetMempoolItemByTxIdRequest(); // GetMempoolItemByTxIdRequest | The tx id.
    try {
      GetMempoolItemByTxId200Response result = apiInstance.getMempoolItemByTxId(getMempoolItemByTxIdRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling MempoolApi#getMempoolItemByTxId");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getMempoolItemByTxIdRequest** | [**GetMempoolItemByTxIdRequest**](GetMempoolItemByTxIdRequest.md)| The tx id. | |

### Return type

[**GetMempoolItemByTxId200Response**](GetMempoolItemByTxId200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

