/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.GetAdditionsAndRemovals200Response;
import org.openapitools.client.model.GetBlock200Response;
import org.openapitools.client.model.GetBlockCountMetrics200Response;
import org.openapitools.client.model.GetBlockRecord200Response;
import org.openapitools.client.model.GetBlockRecordByHeightRequest;
import org.openapitools.client.model.GetBlockRecordRequest;
import org.openapitools.client.model.GetBlockRecords200Response;
import org.openapitools.client.model.GetBlockRecordsRequest;
import org.openapitools.client.model.GetBlockSpends200Response;
import org.openapitools.client.model.GetBlocks200Response;
import org.openapitools.client.model.GetBlocksRequest;
import org.openapitools.client.model.GetRecentSignagePointOrEos200Response;
import org.openapitools.client.model.GetRecentSignagePointOrEosRequest;
import org.openapitools.client.model.GetUnfinishedBlockHeaders200Response;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class BlocksApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public BlocksApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BlocksApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for getAdditionsAndRemovals
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAdditionsAndRemovalsCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordRequest;

        // create path and map variables
        String localVarPath = "/get_additions_and_removals";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getAdditionsAndRemovalsValidateBeforeCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordRequest' is set
        if (getBlockRecordRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordRequest' when calling getAdditionsAndRemovals(Async)");
        }

        return getAdditionsAndRemovalsCall(getBlockRecordRequest, _callback);

    }

    /**
     * Retrieves the additions and removals for a certain block.
     * Retrieves the additions and removals (state transitions) for a certain block. Returns coin records for each addition and removal.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return GetAdditionsAndRemovals200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetAdditionsAndRemovals200Response getAdditionsAndRemovals(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        ApiResponse<GetAdditionsAndRemovals200Response> localVarResp = getAdditionsAndRemovalsWithHttpInfo(getBlockRecordRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the additions and removals for a certain block.
     * Retrieves the additions and removals (state transitions) for a certain block. Returns coin records for each addition and removal.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return ApiResponse&lt;GetAdditionsAndRemovals200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetAdditionsAndRemovals200Response> getAdditionsAndRemovalsWithHttpInfo(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        okhttp3.Call localVarCall = getAdditionsAndRemovalsValidateBeforeCall(getBlockRecordRequest, null);
        Type localVarReturnType = new TypeToken<GetAdditionsAndRemovals200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the additions and removals for a certain block. (asynchronously)
     * Retrieves the additions and removals (state transitions) for a certain block. Returns coin records for each addition and removal.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAdditionsAndRemovalsAsync(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback<GetAdditionsAndRemovals200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getAdditionsAndRemovalsValidateBeforeCall(getBlockRecordRequest, _callback);
        Type localVarReturnType = new TypeToken<GetAdditionsAndRemovals200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlock
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordRequest;

        // create path and map variables
        String localVarPath = "/get_block";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockValidateBeforeCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordRequest' is set
        if (getBlockRecordRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordRequest' when calling getBlock(Async)");
        }

        return getBlockCall(getBlockRecordRequest, _callback);

    }

    /**
     * Retrieves a block by header hash.
     * Retrieves a block by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return GetBlock200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlock200Response getBlock(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        ApiResponse<GetBlock200Response> localVarResp = getBlockWithHttpInfo(getBlockRecordRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a block by header hash.
     * Retrieves a block by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return ApiResponse&lt;GetBlock200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlock200Response> getBlockWithHttpInfo(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlockValidateBeforeCall(getBlockRecordRequest, null);
        Type localVarReturnType = new TypeToken<GetBlock200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a block by header hash. (asynchronously)
     * Retrieves a block by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockAsync(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback<GetBlock200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockValidateBeforeCall(getBlockRecordRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlock200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockCountMetrics
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockCountMetricsCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_block_count_metrics";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockCountMetricsValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getBlockCountMetrics(Async)");
        }

        return getBlockCountMetricsCall(body, _callback);

    }

    /**
     * Retrieves aggregate information about blocks.
     * Retrieves aggregate information about blocks.
     * @param body Empty request body (required)
     * @return GetBlockCountMetrics200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlockCountMetrics200Response getBlockCountMetrics(Object body) throws ApiException {
        ApiResponse<GetBlockCountMetrics200Response> localVarResp = getBlockCountMetricsWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Retrieves aggregate information about blocks.
     * Retrieves aggregate information about blocks.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetBlockCountMetrics200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlockCountMetrics200Response> getBlockCountMetricsWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getBlockCountMetricsValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetBlockCountMetrics200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves aggregate information about blocks. (asynchronously)
     * Retrieves aggregate information about blocks.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockCountMetricsAsync(Object body, final ApiCallback<GetBlockCountMetrics200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockCountMetricsValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetBlockCountMetrics200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockRecord
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordRequest;

        // create path and map variables
        String localVarPath = "/get_block_record";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockRecordValidateBeforeCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordRequest' is set
        if (getBlockRecordRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordRequest' when calling getBlockRecord(Async)");
        }

        return getBlockRecordCall(getBlockRecordRequest, _callback);

    }

    /**
     * Retrieves a block record by header hash.
     * Retrieves a block record by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return GetBlockRecord200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlockRecord200Response getBlockRecord(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        ApiResponse<GetBlockRecord200Response> localVarResp = getBlockRecordWithHttpInfo(getBlockRecordRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a block record by header hash.
     * Retrieves a block record by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return ApiResponse&lt;GetBlockRecord200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlockRecord200Response> getBlockRecordWithHttpInfo(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlockRecordValidateBeforeCall(getBlockRecordRequest, null);
        Type localVarReturnType = new TypeToken<GetBlockRecord200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a block record by header hash. (asynchronously)
     * Retrieves a block record by header hash.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordAsync(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback<GetBlockRecord200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockRecordValidateBeforeCall(getBlockRecordRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlockRecord200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockRecordByHeight
     * @param getBlockRecordByHeightRequest the block height (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordByHeightCall(GetBlockRecordByHeightRequest getBlockRecordByHeightRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordByHeightRequest;

        // create path and map variables
        String localVarPath = "/get_block_record_by_height";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockRecordByHeightValidateBeforeCall(GetBlockRecordByHeightRequest getBlockRecordByHeightRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordByHeightRequest' is set
        if (getBlockRecordByHeightRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordByHeightRequest' when calling getBlockRecordByHeight(Async)");
        }

        return getBlockRecordByHeightCall(getBlockRecordByHeightRequest, _callback);

    }

    /**
     * Retrieves a block record by height.
     * Retrieves a block record by height (assuming the height &lt;&#x3D; peak height). Note that not all blocks will have all fields set here (depending on transaction block, finishing sub epoch, etc).
     * @param getBlockRecordByHeightRequest the block height (required)
     * @return GetBlockRecord200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlockRecord200Response getBlockRecordByHeight(GetBlockRecordByHeightRequest getBlockRecordByHeightRequest) throws ApiException {
        ApiResponse<GetBlockRecord200Response> localVarResp = getBlockRecordByHeightWithHttpInfo(getBlockRecordByHeightRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a block record by height.
     * Retrieves a block record by height (assuming the height &lt;&#x3D; peak height). Note that not all blocks will have all fields set here (depending on transaction block, finishing sub epoch, etc).
     * @param getBlockRecordByHeightRequest the block height (required)
     * @return ApiResponse&lt;GetBlockRecord200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlockRecord200Response> getBlockRecordByHeightWithHttpInfo(GetBlockRecordByHeightRequest getBlockRecordByHeightRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlockRecordByHeightValidateBeforeCall(getBlockRecordByHeightRequest, null);
        Type localVarReturnType = new TypeToken<GetBlockRecord200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a block record by height. (asynchronously)
     * Retrieves a block record by height (assuming the height &lt;&#x3D; peak height). Note that not all blocks will have all fields set here (depending on transaction block, finishing sub epoch, etc).
     * @param getBlockRecordByHeightRequest the block height (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordByHeightAsync(GetBlockRecordByHeightRequest getBlockRecordByHeightRequest, final ApiCallback<GetBlockRecord200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockRecordByHeightValidateBeforeCall(getBlockRecordByHeightRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlockRecord200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockRecords
     * @param getBlockRecordsRequest Start and end heights (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordsCall(GetBlockRecordsRequest getBlockRecordsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordsRequest;

        // create path and map variables
        String localVarPath = "/get_block_records";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockRecordsValidateBeforeCall(GetBlockRecordsRequest getBlockRecordsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordsRequest' is set
        if (getBlockRecordsRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordsRequest' when calling getBlockRecords(Async)");
        }

        return getBlockRecordsCall(getBlockRecordsRequest, _callback);

    }

    /**
     * Retrieves block records in a range.
     * Retrieves block records in a range
     * @param getBlockRecordsRequest Start and end heights (required)
     * @return GetBlockRecords200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlockRecords200Response getBlockRecords(GetBlockRecordsRequest getBlockRecordsRequest) throws ApiException {
        ApiResponse<GetBlockRecords200Response> localVarResp = getBlockRecordsWithHttpInfo(getBlockRecordsRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves block records in a range.
     * Retrieves block records in a range
     * @param getBlockRecordsRequest Start and end heights (required)
     * @return ApiResponse&lt;GetBlockRecords200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlockRecords200Response> getBlockRecordsWithHttpInfo(GetBlockRecordsRequest getBlockRecordsRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlockRecordsValidateBeforeCall(getBlockRecordsRequest, null);
        Type localVarReturnType = new TypeToken<GetBlockRecords200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves block records in a range. (asynchronously)
     * Retrieves block records in a range
     * @param getBlockRecordsRequest Start and end heights (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockRecordsAsync(GetBlockRecordsRequest getBlockRecordsRequest, final ApiCallback<GetBlockRecords200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockRecordsValidateBeforeCall(getBlockRecordsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlockRecords200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlockSpends
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockSpendsCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlockRecordRequest;

        // create path and map variables
        String localVarPath = "/get_block_spends";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlockSpendsValidateBeforeCall(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlockRecordRequest' is set
        if (getBlockRecordRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlockRecordRequest' when calling getBlockSpends(Async)");
        }

        return getBlockSpendsCall(getBlockRecordRequest, _callback);

    }

    /**
     * Retrieves the spends in the given block.
     * Retrieves the spends in the given block.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return GetBlockSpends200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlockSpends200Response getBlockSpends(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        ApiResponse<GetBlockSpends200Response> localVarResp = getBlockSpendsWithHttpInfo(getBlockRecordRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the spends in the given block.
     * Retrieves the spends in the given block.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @return ApiResponse&lt;GetBlockSpends200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlockSpends200Response> getBlockSpendsWithHttpInfo(GetBlockRecordRequest getBlockRecordRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlockSpendsValidateBeforeCall(getBlockRecordRequest, null);
        Type localVarReturnType = new TypeToken<GetBlockSpends200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the spends in the given block. (asynchronously)
     * Retrieves the spends in the given block.
     * @param getBlockRecordRequest the block&#39;s header_hash (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlockSpendsAsync(GetBlockRecordRequest getBlockRecordRequest, final ApiCallback<GetBlockSpends200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlockSpendsValidateBeforeCall(getBlockRecordRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlockSpends200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getBlocks
     * @param getBlocksRequest Start and end heights (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlocksCall(GetBlocksRequest getBlocksRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getBlocksRequest;

        // create path and map variables
        String localVarPath = "/get_blocks";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getBlocksValidateBeforeCall(GetBlocksRequest getBlocksRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getBlocksRequest' is set
        if (getBlocksRequest == null) {
            throw new ApiException("Missing the required parameter 'getBlocksRequest' when calling getBlocks(Async)");
        }

        return getBlocksCall(getBlocksRequest, _callback);

    }

    /**
     * Get the blocks between a start and end height.
     * Get the blocks between a start and end height
     * @param getBlocksRequest Start and end heights (required)
     * @return GetBlocks200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetBlocks200Response getBlocks(GetBlocksRequest getBlocksRequest) throws ApiException {
        ApiResponse<GetBlocks200Response> localVarResp = getBlocksWithHttpInfo(getBlocksRequest);
        return localVarResp.getData();
    }

    /**
     * Get the blocks between a start and end height.
     * Get the blocks between a start and end height
     * @param getBlocksRequest Start and end heights (required)
     * @return ApiResponse&lt;GetBlocks200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetBlocks200Response> getBlocksWithHttpInfo(GetBlocksRequest getBlocksRequest) throws ApiException {
        okhttp3.Call localVarCall = getBlocksValidateBeforeCall(getBlocksRequest, null);
        Type localVarReturnType = new TypeToken<GetBlocks200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the blocks between a start and end height. (asynchronously)
     * Get the blocks between a start and end height
     * @param getBlocksRequest Start and end heights (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getBlocksAsync(GetBlocksRequest getBlocksRequest, final ApiCallback<GetBlocks200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getBlocksValidateBeforeCall(getBlocksRequest, _callback);
        Type localVarReturnType = new TypeToken<GetBlocks200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getRecentSignagePointOrEos
     * @param getRecentSignagePointOrEosRequest The signage point hash or challenge hash. If both are present sp_hash takes precedence. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRecentSignagePointOrEosCall(GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getRecentSignagePointOrEosRequest;

        // create path and map variables
        String localVarPath = "/get_recent_signage_point_or_eos";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getRecentSignagePointOrEosValidateBeforeCall(GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getRecentSignagePointOrEosRequest' is set
        if (getRecentSignagePointOrEosRequest == null) {
            throw new ApiException("Missing the required parameter 'getRecentSignagePointOrEosRequest' when calling getRecentSignagePointOrEos(Async)");
        }

        return getRecentSignagePointOrEosCall(getRecentSignagePointOrEosRequest, _callback);

    }

    /**
     * Retrieves a recent signage point or end of slot.
     * Retrieves a recent signage point or end of slot.
     * @param getRecentSignagePointOrEosRequest The signage point hash or challenge hash. If both are present sp_hash takes precedence. (required)
     * @return GetRecentSignagePointOrEos200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetRecentSignagePointOrEos200Response getRecentSignagePointOrEos(GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest) throws ApiException {
        ApiResponse<GetRecentSignagePointOrEos200Response> localVarResp = getRecentSignagePointOrEosWithHttpInfo(getRecentSignagePointOrEosRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a recent signage point or end of slot.
     * Retrieves a recent signage point or end of slot.
     * @param getRecentSignagePointOrEosRequest The signage point hash or challenge hash. If both are present sp_hash takes precedence. (required)
     * @return ApiResponse&lt;GetRecentSignagePointOrEos200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetRecentSignagePointOrEos200Response> getRecentSignagePointOrEosWithHttpInfo(GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest) throws ApiException {
        okhttp3.Call localVarCall = getRecentSignagePointOrEosValidateBeforeCall(getRecentSignagePointOrEosRequest, null);
        Type localVarReturnType = new TypeToken<GetRecentSignagePointOrEos200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a recent signage point or end of slot. (asynchronously)
     * Retrieves a recent signage point or end of slot.
     * @param getRecentSignagePointOrEosRequest The signage point hash or challenge hash. If both are present sp_hash takes precedence. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getRecentSignagePointOrEosAsync(GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest, final ApiCallback<GetRecentSignagePointOrEos200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getRecentSignagePointOrEosValidateBeforeCall(getRecentSignagePointOrEosRequest, _callback);
        Type localVarReturnType = new TypeToken<GetRecentSignagePointOrEos200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getUnfinishedBlockHeaders
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getUnfinishedBlockHeadersCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_unfinished_block_headers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getUnfinishedBlockHeadersValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getUnfinishedBlockHeaders(Async)");
        }

        return getUnfinishedBlockHeadersCall(body, _callback);

    }

    /**
     * Retrieves unfinished block headers.
     * Retrieves unfinished block headers.
     * @param body Empty request body (required)
     * @return GetUnfinishedBlockHeaders200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetUnfinishedBlockHeaders200Response getUnfinishedBlockHeaders(Object body) throws ApiException {
        ApiResponse<GetUnfinishedBlockHeaders200Response> localVarResp = getUnfinishedBlockHeadersWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Retrieves unfinished block headers.
     * Retrieves unfinished block headers.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetUnfinishedBlockHeaders200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetUnfinishedBlockHeaders200Response> getUnfinishedBlockHeadersWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getUnfinishedBlockHeadersValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetUnfinishedBlockHeaders200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves unfinished block headers. (asynchronously)
     * Retrieves unfinished block headers.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getUnfinishedBlockHeadersAsync(Object body, final ApiCallback<GetUnfinishedBlockHeaders200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getUnfinishedBlockHeadersValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetUnfinishedBlockHeaders200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
