/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.GetCoinRecordByName200Response;
import org.openapitools.client.model.GetCoinRecordByNameRequest;
import org.openapitools.client.model.GetCoinRecordsByHintRequest;
import org.openapitools.client.model.GetCoinRecordsByNamesRequest;
import org.openapitools.client.model.GetCoinRecordsByParentIdsRequest;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHash200Response;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHashRequest;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHashesRequest;
import org.openapitools.client.model.GetPuzzleAndSolution200Response;
import org.openapitools.client.model.GetPuzzleAndSolutionRequest;
import org.openapitools.client.model.PushTx200Response;
import org.openapitools.client.model.PushTxRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class CoinsApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public CoinsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CoinsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for getCoinRecordByName
     * @param getCoinRecordByNameRequest The coin name. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordByNameCall(GetCoinRecordByNameRequest getCoinRecordByNameRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordByNameRequest;

        // create path and map variables
        String localVarPath = "/get_coin_record_by_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordByNameValidateBeforeCall(GetCoinRecordByNameRequest getCoinRecordByNameRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordByNameRequest' is set
        if (getCoinRecordByNameRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordByNameRequest' when calling getCoinRecordByName(Async)");
        }

        return getCoinRecordByNameCall(getCoinRecordByNameRequest, _callback);

    }

    /**
     * Retrieves a coin record by it&#39;s name.
     * Retrieves a coin record by it&#39;s name.
     * @param getCoinRecordByNameRequest The coin name. (required)
     * @return GetCoinRecordByName200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordByName200Response getCoinRecordByName(GetCoinRecordByNameRequest getCoinRecordByNameRequest) throws ApiException {
        ApiResponse<GetCoinRecordByName200Response> localVarResp = getCoinRecordByNameWithHttpInfo(getCoinRecordByNameRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a coin record by it&#39;s name.
     * Retrieves a coin record by it&#39;s name.
     * @param getCoinRecordByNameRequest The coin name. (required)
     * @return ApiResponse&lt;GetCoinRecordByName200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordByName200Response> getCoinRecordByNameWithHttpInfo(GetCoinRecordByNameRequest getCoinRecordByNameRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordByNameValidateBeforeCall(getCoinRecordByNameRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordByName200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a coin record by it&#39;s name. (asynchronously)
     * Retrieves a coin record by it&#39;s name.
     * @param getCoinRecordByNameRequest The coin name. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordByNameAsync(GetCoinRecordByNameRequest getCoinRecordByNameRequest, final ApiCallback<GetCoinRecordByName200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordByNameValidateBeforeCall(getCoinRecordByNameRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordByName200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCoinRecordsByHint
     * @param getCoinRecordsByHintRequest The hint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByHintCall(GetCoinRecordsByHintRequest getCoinRecordsByHintRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByHintRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_hint";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByHintValidateBeforeCall(GetCoinRecordsByHintRequest getCoinRecordsByHintRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByHintRequest' is set
        if (getCoinRecordsByHintRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByHintRequest' when calling getCoinRecordsByHint(Async)");
        }

        return getCoinRecordsByHintCall(getCoinRecordsByHintRequest, _callback);

    }

    /**
     * Retrieves coins by hint.
     * Retrieves coins by hint, by default returns unspent coins.
     * @param getCoinRecordsByHintRequest The hint. (required)
     * @return GetCoinRecordsByPuzzleHash200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByPuzzleHash200Response getCoinRecordsByHint(GetCoinRecordsByHintRequest getCoinRecordsByHintRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByPuzzleHash200Response> localVarResp = getCoinRecordsByHintWithHttpInfo(getCoinRecordsByHintRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves coins by hint.
     * Retrieves coins by hint, by default returns unspent coins.
     * @param getCoinRecordsByHintRequest The hint. (required)
     * @return ApiResponse&lt;GetCoinRecordsByPuzzleHash200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByPuzzleHash200Response> getCoinRecordsByHintWithHttpInfo(GetCoinRecordsByHintRequest getCoinRecordsByHintRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByHintValidateBeforeCall(getCoinRecordsByHintRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves coins by hint. (asynchronously)
     * Retrieves coins by hint, by default returns unspent coins.
     * @param getCoinRecordsByHintRequest The hint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByHintAsync(GetCoinRecordsByHintRequest getCoinRecordsByHintRequest, final ApiCallback<GetCoinRecordsByPuzzleHash200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByHintValidateBeforeCall(getCoinRecordsByHintRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCoinRecordsByNames
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByNamesCall(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByNamesRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_names";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByNamesValidateBeforeCall(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByNamesRequest' is set
        if (getCoinRecordsByNamesRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByNamesRequest' when calling getCoinRecordsByNames(Async)");
        }

        return getCoinRecordsByNamesCall(getCoinRecordsByNamesRequest, _callback);

    }

    /**
     * Retrieves the coins for given coin IDs.
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @return GetCoinRecordsByPuzzleHash200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByPuzzleHash200Response getCoinRecordsByNames(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByPuzzleHash200Response> localVarResp = getCoinRecordsByNamesWithHttpInfo(getCoinRecordsByNamesRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the coins for given coin IDs.
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @return ApiResponse&lt;GetCoinRecordsByPuzzleHash200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByPuzzleHash200Response> getCoinRecordsByNamesWithHttpInfo(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByNamesValidateBeforeCall(getCoinRecordsByNamesRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the coins for given coin IDs. (asynchronously)
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByNamesAsync(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback<GetCoinRecordsByPuzzleHash200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByNamesValidateBeforeCall(getCoinRecordsByNamesRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCoinRecordsByParentIds
     * @param getCoinRecordsByParentIdsRequest The parent ids. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByParentIdsCall(GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByParentIdsRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_parent_ids";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByParentIdsValidateBeforeCall(GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByParentIdsRequest' is set
        if (getCoinRecordsByParentIdsRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByParentIdsRequest' when calling getCoinRecordsByParentIds(Async)");
        }

        return getCoinRecordsByParentIdsCall(getCoinRecordsByParentIdsRequest, _callback);

    }

    /**
     * Retrieves the coins for given parent coin IDs.
     * Retrieves the coins for given parent coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByParentIdsRequest The parent ids. (required)
     * @return GetCoinRecordsByPuzzleHash200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByPuzzleHash200Response getCoinRecordsByParentIds(GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByPuzzleHash200Response> localVarResp = getCoinRecordsByParentIdsWithHttpInfo(getCoinRecordsByParentIdsRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the coins for given parent coin IDs.
     * Retrieves the coins for given parent coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByParentIdsRequest The parent ids. (required)
     * @return ApiResponse&lt;GetCoinRecordsByPuzzleHash200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByPuzzleHash200Response> getCoinRecordsByParentIdsWithHttpInfo(GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByParentIdsValidateBeforeCall(getCoinRecordsByParentIdsRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the coins for given parent coin IDs. (asynchronously)
     * Retrieves the coins for given parent coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByParentIdsRequest The parent ids. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByParentIdsAsync(GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest, final ApiCallback<GetCoinRecordsByPuzzleHash200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByParentIdsValidateBeforeCall(getCoinRecordsByParentIdsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCoinRecordsByPuzzleHash
     * @param getCoinRecordsByPuzzleHashRequest The puzzle hash. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByPuzzleHashCall(GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByPuzzleHashRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_puzzle_hash";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByPuzzleHashValidateBeforeCall(GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByPuzzleHashRequest' is set
        if (getCoinRecordsByPuzzleHashRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByPuzzleHashRequest' when calling getCoinRecordsByPuzzleHash(Async)");
        }

        return getCoinRecordsByPuzzleHashCall(getCoinRecordsByPuzzleHashRequest, _callback);

    }

    /**
     * Retrieves the coins for a given puzzlehash.
     * Retrieves the coins for a given puzzlehash, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashRequest The puzzle hash. (required)
     * @return GetCoinRecordsByPuzzleHash200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByPuzzleHash200Response getCoinRecordsByPuzzleHash(GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByPuzzleHash200Response> localVarResp = getCoinRecordsByPuzzleHashWithHttpInfo(getCoinRecordsByPuzzleHashRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the coins for a given puzzlehash.
     * Retrieves the coins for a given puzzlehash, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashRequest The puzzle hash. (required)
     * @return ApiResponse&lt;GetCoinRecordsByPuzzleHash200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByPuzzleHash200Response> getCoinRecordsByPuzzleHashWithHttpInfo(GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByPuzzleHashValidateBeforeCall(getCoinRecordsByPuzzleHashRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the coins for a given puzzlehash. (asynchronously)
     * Retrieves the coins for a given puzzlehash, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashRequest The puzzle hash. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByPuzzleHashAsync(GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest, final ApiCallback<GetCoinRecordsByPuzzleHash200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByPuzzleHashValidateBeforeCall(getCoinRecordsByPuzzleHashRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCoinRecordsByPuzzleHashes
     * @param getCoinRecordsByPuzzleHashesRequest The puzzle hashes. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByPuzzleHashesCall(GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByPuzzleHashesRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_puzzle_hashes";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByPuzzleHashesValidateBeforeCall(GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByPuzzleHashesRequest' is set
        if (getCoinRecordsByPuzzleHashesRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByPuzzleHashesRequest' when calling getCoinRecordsByPuzzleHashes(Async)");
        }

        return getCoinRecordsByPuzzleHashesCall(getCoinRecordsByPuzzleHashesRequest, _callback);

    }

    /**
     * Retrieves the coins for a given puzzlehashes
     * Retrieves the coins for a given puzzlehashes, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashesRequest The puzzle hashes. (required)
     * @return GetCoinRecordsByPuzzleHash200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByPuzzleHash200Response getCoinRecordsByPuzzleHashes(GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByPuzzleHash200Response> localVarResp = getCoinRecordsByPuzzleHashesWithHttpInfo(getCoinRecordsByPuzzleHashesRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the coins for a given puzzlehashes
     * Retrieves the coins for a given puzzlehashes, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashesRequest The puzzle hashes. (required)
     * @return ApiResponse&lt;GetCoinRecordsByPuzzleHash200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByPuzzleHash200Response> getCoinRecordsByPuzzleHashesWithHttpInfo(GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByPuzzleHashesValidateBeforeCall(getCoinRecordsByPuzzleHashesRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the coins for a given puzzlehashes (asynchronously)
     * Retrieves the coins for a given puzzlehashes, by default returns unspent coins.
     * @param getCoinRecordsByPuzzleHashesRequest The puzzle hashes. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByPuzzleHashesAsync(GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest, final ApiCallback<GetCoinRecordsByPuzzleHash200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByPuzzleHashesValidateBeforeCall(getCoinRecordsByPuzzleHashesRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByPuzzleHash200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getPuzzleAndSolution
     * @param getPuzzleAndSolutionRequest The coin id and height (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPuzzleAndSolutionCall(GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getPuzzleAndSolutionRequest;

        // create path and map variables
        String localVarPath = "/get_puzzle_and_solution";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getPuzzleAndSolutionValidateBeforeCall(GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getPuzzleAndSolutionRequest' is set
        if (getPuzzleAndSolutionRequest == null) {
            throw new ApiException("Missing the required parameter 'getPuzzleAndSolutionRequest' when calling getPuzzleAndSolution(Async)");
        }

        return getPuzzleAndSolutionCall(getPuzzleAndSolutionRequest, _callback);

    }

    /**
     * Retrieves a coin solution.
     * Retrieves a coin solution.
     * @param getPuzzleAndSolutionRequest The coin id and height (required)
     * @return GetPuzzleAndSolution200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetPuzzleAndSolution200Response getPuzzleAndSolution(GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest) throws ApiException {
        ApiResponse<GetPuzzleAndSolution200Response> localVarResp = getPuzzleAndSolutionWithHttpInfo(getPuzzleAndSolutionRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a coin solution.
     * Retrieves a coin solution.
     * @param getPuzzleAndSolutionRequest The coin id and height (required)
     * @return ApiResponse&lt;GetPuzzleAndSolution200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetPuzzleAndSolution200Response> getPuzzleAndSolutionWithHttpInfo(GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest) throws ApiException {
        okhttp3.Call localVarCall = getPuzzleAndSolutionValidateBeforeCall(getPuzzleAndSolutionRequest, null);
        Type localVarReturnType = new TypeToken<GetPuzzleAndSolution200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a coin solution. (asynchronously)
     * Retrieves a coin solution.
     * @param getPuzzleAndSolutionRequest The coin id and height (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getPuzzleAndSolutionAsync(GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest, final ApiCallback<GetPuzzleAndSolution200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getPuzzleAndSolutionValidateBeforeCall(getPuzzleAndSolutionRequest, _callback);
        Type localVarReturnType = new TypeToken<GetPuzzleAndSolution200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for pushTx
     * @param pushTxRequest The spend bundle (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pushTxCall(PushTxRequest pushTxRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = pushTxRequest;

        // create path and map variables
        String localVarPath = "/push_tx";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call pushTxValidateBeforeCall(PushTxRequest pushTxRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'pushTxRequest' is set
        if (pushTxRequest == null) {
            throw new ApiException("Missing the required parameter 'pushTxRequest' when calling pushTx(Async)");
        }

        return pushTxCall(pushTxRequest, _callback);

    }

    /**
     * Pushes a transaction/spend bundle to the mempool and blockchain.
     * Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.
     * @param pushTxRequest The spend bundle (required)
     * @return PushTx200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PushTx200Response pushTx(PushTxRequest pushTxRequest) throws ApiException {
        ApiResponse<PushTx200Response> localVarResp = pushTxWithHttpInfo(pushTxRequest);
        return localVarResp.getData();
    }

    /**
     * Pushes a transaction/spend bundle to the mempool and blockchain.
     * Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.
     * @param pushTxRequest The spend bundle (required)
     * @return ApiResponse&lt;PushTx200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PushTx200Response> pushTxWithHttpInfo(PushTxRequest pushTxRequest) throws ApiException {
        okhttp3.Call localVarCall = pushTxValidateBeforeCall(pushTxRequest, null);
        Type localVarReturnType = new TypeToken<PushTx200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Pushes a transaction/spend bundle to the mempool and blockchain. (asynchronously)
     * Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.
     * @param pushTxRequest The spend bundle (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pushTxAsync(PushTxRequest pushTxRequest, final ApiCallback<PushTx200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = pushTxValidateBeforeCall(pushTxRequest, _callback);
        Type localVarReturnType = new TypeToken<PushTx200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
