/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.BlockRecordChallengeVdfOutput;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * This class is not included or hashed into the blockchain, but it is kept in memory as a more efficient way to maintain data about the blockchain. This allows us to validate future blocks, difficulty adjustments, etc, without saving the whole header block in memory.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class BlockRecord {
  public static final String SERIALIZED_NAME_CHALLENGE_BLOCK_INFO_HASH = "challenge_block_info_hash";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_BLOCK_INFO_HASH)
  private String challengeBlockInfoHash;

  public static final String SERIALIZED_NAME_CHALLENGE_VDF_OUTPUT = "challenge_vdf_output";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_VDF_OUTPUT)
  private BlockRecordChallengeVdfOutput challengeVdfOutput;

  public static final String SERIALIZED_NAME_DEFICIT = "deficit";
  @SerializedName(SERIALIZED_NAME_DEFICIT)
  private Integer deficit;

  public static final String SERIALIZED_NAME_FARMER_PUZZLE_HASH = "farmer_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_FARMER_PUZZLE_HASH)
  private String farmerPuzzleHash;

  public static final String SERIALIZED_NAME_FEES = "fees";
  @SerializedName(SERIALIZED_NAME_FEES)
  private Integer fees;

  public static final String SERIALIZED_NAME_FINISHED_CHALLENGE_SLOT_HASHES = "finished_challenge_slot_hashes";
  @SerializedName(SERIALIZED_NAME_FINISHED_CHALLENGE_SLOT_HASHES)
  private String finishedChallengeSlotHashes;

  public static final String SERIALIZED_NAME_FINISHED_INFUSED_CHALLENGE_SLOT_HASHES = "finished_infused_challenge_slot_hashes";
  @SerializedName(SERIALIZED_NAME_FINISHED_INFUSED_CHALLENGE_SLOT_HASHES)
  private String finishedInfusedChallengeSlotHashes;

  public static final String SERIALIZED_NAME_FINISHED_REWARD_SLOT_HASHES = "finished_reward_slot_hashes";
  @SerializedName(SERIALIZED_NAME_FINISHED_REWARD_SLOT_HASHES)
  private String finishedRewardSlotHashes;

  public static final String SERIALIZED_NAME_HEADER_HASH = "header_hash";
  @SerializedName(SERIALIZED_NAME_HEADER_HASH)
  private String headerHash;

  public static final String SERIALIZED_NAME_HEIGHT = "height";
  @SerializedName(SERIALIZED_NAME_HEIGHT)
  private Integer height;

  public static final String SERIALIZED_NAME_INFUSED_CHALLENGE_VDF_OUTPUT = "infused_challenge_vdf_output";
  @SerializedName(SERIALIZED_NAME_INFUSED_CHALLENGE_VDF_OUTPUT)
  private String infusedChallengeVdfOutput;

  public static final String SERIALIZED_NAME_OVERFLOW = "overflow";
  @SerializedName(SERIALIZED_NAME_OVERFLOW)
  private Boolean overflow;

  public static final String SERIALIZED_NAME_POOL_PUZZLE_HASH = "pool_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_POOL_PUZZLE_HASH)
  private String poolPuzzleHash;

  public static final String SERIALIZED_NAME_PREV_HASH = "prev_hash";
  @SerializedName(SERIALIZED_NAME_PREV_HASH)
  private String prevHash;

  public static final String SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HASH = "prev_transaction_block_hash";
  @SerializedName(SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HASH)
  private String prevTransactionBlockHash;

  public static final String SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HEIGHT = "prev_transaction_block_height";
  @SerializedName(SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HEIGHT)
  private Integer prevTransactionBlockHeight;

  public static final String SERIALIZED_NAME_REQUIRED_ITERS = "required_iters";
  @SerializedName(SERIALIZED_NAME_REQUIRED_ITERS)
  private Integer requiredIters;

  public static final String SERIALIZED_NAME_REWARD_CLAIMS_INCORPORATED = "reward_claims_incorporated";
  @SerializedName(SERIALIZED_NAME_REWARD_CLAIMS_INCORPORATED)
  private String rewardClaimsIncorporated;

  public static final String SERIALIZED_NAME_REWARD_INFUSION_NEW_CHALLENGE = "reward_infusion_new_challenge";
  @SerializedName(SERIALIZED_NAME_REWARD_INFUSION_NEW_CHALLENGE)
  private String rewardInfusionNewChallenge;

  public static final String SERIALIZED_NAME_SIGNAGE_POINT_INDEX = "signage_point_index";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT_INDEX)
  private Integer signagePointIndex;

  public static final String SERIALIZED_NAME_SUB_EPOCH_SUMMARY_INCLUDED = "sub_epoch_summary_included";
  @SerializedName(SERIALIZED_NAME_SUB_EPOCH_SUMMARY_INCLUDED)
  private String subEpochSummaryIncluded;

  public static final String SERIALIZED_NAME_SUB_SLOT_ITERS = "sub_slot_iters";
  @SerializedName(SERIALIZED_NAME_SUB_SLOT_ITERS)
  private Integer subSlotIters;

  public static final String SERIALIZED_NAME_TIMESTAMP = "timestamp";
  @SerializedName(SERIALIZED_NAME_TIMESTAMP)
  private Integer timestamp;

  public static final String SERIALIZED_NAME_TOTAL_ITERS = "total_iters";
  @SerializedName(SERIALIZED_NAME_TOTAL_ITERS)
  private Integer totalIters;

  public static final String SERIALIZED_NAME_WEIGHT = "weight";
  @SerializedName(SERIALIZED_NAME_WEIGHT)
  private Integer weight;

  public BlockRecord() {
  }

  public BlockRecord challengeBlockInfoHash(String challengeBlockInfoHash) {
    
    this.challengeBlockInfoHash = challengeBlockInfoHash;
    return this;
  }

   /**
   * Hash of challenge chain data, used to validate end of slots in the future.
   * @return challengeBlockInfoHash
  **/
  @javax.annotation.Nullable

  public String getChallengeBlockInfoHash() {
    return challengeBlockInfoHash;
  }


  public void setChallengeBlockInfoHash(String challengeBlockInfoHash) {
    this.challengeBlockInfoHash = challengeBlockInfoHash;
  }


  public BlockRecord challengeVdfOutput(BlockRecordChallengeVdfOutput challengeVdfOutput) {
    
    this.challengeVdfOutput = challengeVdfOutput;
    return this;
  }

   /**
   * Get challengeVdfOutput
   * @return challengeVdfOutput
  **/
  @javax.annotation.Nullable

  public BlockRecordChallengeVdfOutput getChallengeVdfOutput() {
    return challengeVdfOutput;
  }


  public void setChallengeVdfOutput(BlockRecordChallengeVdfOutput challengeVdfOutput) {
    this.challengeVdfOutput = challengeVdfOutput;
  }


  public BlockRecord deficit(Integer deficit) {
    
    this.deficit = deficit;
    return this;
  }

   /**
   * A deficit of 16 is an overflow block after an infusion. Deficit of 15 is a challenge block.
   * @return deficit
  **/
  @javax.annotation.Nullable

  public Integer getDeficit() {
    return deficit;
  }


  public void setDeficit(Integer deficit) {
    this.deficit = deficit;
  }


  public BlockRecord farmerPuzzleHash(String farmerPuzzleHash) {
    
    this.farmerPuzzleHash = farmerPuzzleHash;
    return this;
  }

   /**
   * Get farmerPuzzleHash
   * @return farmerPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getFarmerPuzzleHash() {
    return farmerPuzzleHash;
  }


  public void setFarmerPuzzleHash(String farmerPuzzleHash) {
    this.farmerPuzzleHash = farmerPuzzleHash;
  }


  public BlockRecord fees(Integer fees) {
    
    this.fees = fees;
    return this;
  }

   /**
   * Transaction block (present iff is_transaction_block)
   * @return fees
  **/
  @javax.annotation.Nullable

  public Integer getFees() {
    return fees;
  }


  public void setFees(Integer fees) {
    this.fees = fees;
  }


  public BlockRecord finishedChallengeSlotHashes(String finishedChallengeSlotHashes) {
    
    this.finishedChallengeSlotHashes = finishedChallengeSlotHashes;
    return this;
  }

   /**
   * Slot (present iff this is the first SB in sub slot)
   * @return finishedChallengeSlotHashes
  **/
  @javax.annotation.Nullable

  public String getFinishedChallengeSlotHashes() {
    return finishedChallengeSlotHashes;
  }


  public void setFinishedChallengeSlotHashes(String finishedChallengeSlotHashes) {
    this.finishedChallengeSlotHashes = finishedChallengeSlotHashes;
  }


  public BlockRecord finishedInfusedChallengeSlotHashes(String finishedInfusedChallengeSlotHashes) {
    
    this.finishedInfusedChallengeSlotHashes = finishedInfusedChallengeSlotHashes;
    return this;
  }

   /**
   * Slot (present iff this is the first SB in sub slot)
   * @return finishedInfusedChallengeSlotHashes
  **/
  @javax.annotation.Nullable

  public String getFinishedInfusedChallengeSlotHashes() {
    return finishedInfusedChallengeSlotHashes;
  }


  public void setFinishedInfusedChallengeSlotHashes(String finishedInfusedChallengeSlotHashes) {
    this.finishedInfusedChallengeSlotHashes = finishedInfusedChallengeSlotHashes;
  }


  public BlockRecord finishedRewardSlotHashes(String finishedRewardSlotHashes) {
    
    this.finishedRewardSlotHashes = finishedRewardSlotHashes;
    return this;
  }

   /**
   * Slot (present iff this is the first SB in sub slot)
   * @return finishedRewardSlotHashes
  **/
  @javax.annotation.Nullable

  public String getFinishedRewardSlotHashes() {
    return finishedRewardSlotHashes;
  }


  public void setFinishedRewardSlotHashes(String finishedRewardSlotHashes) {
    this.finishedRewardSlotHashes = finishedRewardSlotHashes;
  }


  public BlockRecord headerHash(String headerHash) {
    
    this.headerHash = headerHash;
    return this;
  }

   /**
   * Get headerHash
   * @return headerHash
  **/
  @javax.annotation.Nullable

  public String getHeaderHash() {
    return headerHash;
  }


  public void setHeaderHash(String headerHash) {
    this.headerHash = headerHash;
  }


  public BlockRecord height(Integer height) {
    
    this.height = height;
    return this;
  }

   /**
   * Get height
   * @return height
  **/
  @javax.annotation.Nullable

  public Integer getHeight() {
    return height;
  }


  public void setHeight(Integer height) {
    this.height = height;
  }


  public BlockRecord infusedChallengeVdfOutput(String infusedChallengeVdfOutput) {
    
    this.infusedChallengeVdfOutput = infusedChallengeVdfOutput;
    return this;
  }

   /**
   * This is the intermediary VDF output at ip_iters in infused cc, if deficit less than or equal to 3.
   * @return infusedChallengeVdfOutput
  **/
  @javax.annotation.Nullable

  public String getInfusedChallengeVdfOutput() {
    return infusedChallengeVdfOutput;
  }


  public void setInfusedChallengeVdfOutput(String infusedChallengeVdfOutput) {
    this.infusedChallengeVdfOutput = infusedChallengeVdfOutput;
  }


  public BlockRecord overflow(Boolean overflow) {
    
    this.overflow = overflow;
    return this;
  }

   /**
   * Get overflow
   * @return overflow
  **/
  @javax.annotation.Nullable

  public Boolean getOverflow() {
    return overflow;
  }


  public void setOverflow(Boolean overflow) {
    this.overflow = overflow;
  }


  public BlockRecord poolPuzzleHash(String poolPuzzleHash) {
    
    this.poolPuzzleHash = poolPuzzleHash;
    return this;
  }

   /**
   * Need to keep track of these because Coins are created in a future block.
   * @return poolPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getPoolPuzzleHash() {
    return poolPuzzleHash;
  }


  public void setPoolPuzzleHash(String poolPuzzleHash) {
    this.poolPuzzleHash = poolPuzzleHash;
  }


  public BlockRecord prevHash(String prevHash) {
    
    this.prevHash = prevHash;
    return this;
  }

   /**
   * Header hash of the previous block. Transaction block (present iff is_transaction_block).
   * @return prevHash
  **/
  @javax.annotation.Nullable

  public String getPrevHash() {
    return prevHash;
  }


  public void setPrevHash(String prevHash) {
    this.prevHash = prevHash;
  }


  public BlockRecord prevTransactionBlockHash(String prevTransactionBlockHash) {
    
    this.prevTransactionBlockHash = prevTransactionBlockHash;
    return this;
  }

   /**
   * Header hash of the previous transaction block
   * @return prevTransactionBlockHash
  **/
  @javax.annotation.Nullable

  public String getPrevTransactionBlockHash() {
    return prevTransactionBlockHash;
  }


  public void setPrevTransactionBlockHash(String prevTransactionBlockHash) {
    this.prevTransactionBlockHash = prevTransactionBlockHash;
  }


  public BlockRecord prevTransactionBlockHeight(Integer prevTransactionBlockHeight) {
    
    this.prevTransactionBlockHeight = prevTransactionBlockHeight;
    return this;
  }

   /**
   * Get prevTransactionBlockHeight
   * @return prevTransactionBlockHeight
  **/
  @javax.annotation.Nullable

  public Integer getPrevTransactionBlockHeight() {
    return prevTransactionBlockHeight;
  }


  public void setPrevTransactionBlockHeight(Integer prevTransactionBlockHeight) {
    this.prevTransactionBlockHeight = prevTransactionBlockHeight;
  }


  public BlockRecord requiredIters(Integer requiredIters) {
    
    this.requiredIters = requiredIters;
    return this;
  }

   /**
   * Get requiredIters
   * @return requiredIters
  **/
  @javax.annotation.Nullable

  public Integer getRequiredIters() {
    return requiredIters;
  }


  public void setRequiredIters(Integer requiredIters) {
    this.requiredIters = requiredIters;
  }


  public BlockRecord rewardClaimsIncorporated(String rewardClaimsIncorporated) {
    
    this.rewardClaimsIncorporated = rewardClaimsIncorporated;
    return this;
  }

   /**
   * Get rewardClaimsIncorporated
   * @return rewardClaimsIncorporated
  **/
  @javax.annotation.Nullable

  public String getRewardClaimsIncorporated() {
    return rewardClaimsIncorporated;
  }


  public void setRewardClaimsIncorporated(String rewardClaimsIncorporated) {
    this.rewardClaimsIncorporated = rewardClaimsIncorporated;
  }


  public BlockRecord rewardInfusionNewChallenge(String rewardInfusionNewChallenge) {
    
    this.rewardInfusionNewChallenge = rewardInfusionNewChallenge;
    return this;
  }

   /**
   * The reward chain infusion output, input to next VDF
   * @return rewardInfusionNewChallenge
  **/
  @javax.annotation.Nullable

  public String getRewardInfusionNewChallenge() {
    return rewardInfusionNewChallenge;
  }


  public void setRewardInfusionNewChallenge(String rewardInfusionNewChallenge) {
    this.rewardInfusionNewChallenge = rewardInfusionNewChallenge;
  }


  public BlockRecord signagePointIndex(Integer signagePointIndex) {
    
    this.signagePointIndex = signagePointIndex;
    return this;
  }

   /**
   * Get signagePointIndex
   * @return signagePointIndex
  **/
  @javax.annotation.Nullable

  public Integer getSignagePointIndex() {
    return signagePointIndex;
  }


  public void setSignagePointIndex(Integer signagePointIndex) {
    this.signagePointIndex = signagePointIndex;
  }


  public BlockRecord subEpochSummaryIncluded(String subEpochSummaryIncluded) {
    
    this.subEpochSummaryIncluded = subEpochSummaryIncluded;
    return this;
  }

   /**
   * Get subEpochSummaryIncluded
   * @return subEpochSummaryIncluded
  **/
  @javax.annotation.Nullable

  public String getSubEpochSummaryIncluded() {
    return subEpochSummaryIncluded;
  }


  public void setSubEpochSummaryIncluded(String subEpochSummaryIncluded) {
    this.subEpochSummaryIncluded = subEpochSummaryIncluded;
  }


  public BlockRecord subSlotIters(Integer subSlotIters) {
    
    this.subSlotIters = subSlotIters;
    return this;
  }

   /**
   * Get subSlotIters
   * @return subSlotIters
  **/
  @javax.annotation.Nullable

  public Integer getSubSlotIters() {
    return subSlotIters;
  }


  public void setSubSlotIters(Integer subSlotIters) {
    this.subSlotIters = subSlotIters;
  }


  public BlockRecord timestamp(Integer timestamp) {
    
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @javax.annotation.Nullable

  public Integer getTimestamp() {
    return timestamp;
  }


  public void setTimestamp(Integer timestamp) {
    this.timestamp = timestamp;
  }


  public BlockRecord totalIters(Integer totalIters) {
    
    this.totalIters = totalIters;
    return this;
  }

   /**
   * Total number of VDF iterations since genesis, including this block
   * @return totalIters
  **/
  @javax.annotation.Nullable

  public Integer getTotalIters() {
    return totalIters;
  }


  public void setTotalIters(Integer totalIters) {
    this.totalIters = totalIters;
  }


  public BlockRecord weight(Integer weight) {
    
    this.weight = weight;
    return this;
  }

   /**
   * Total cumulative difficulty of all ancestor blocks since genesis
   * @return weight
  **/
  @javax.annotation.Nullable

  public Integer getWeight() {
    return weight;
  }


  public void setWeight(Integer weight) {
    this.weight = weight;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BlockRecord blockRecord = (BlockRecord) o;
    return Objects.equals(this.challengeBlockInfoHash, blockRecord.challengeBlockInfoHash) &&
        Objects.equals(this.challengeVdfOutput, blockRecord.challengeVdfOutput) &&
        Objects.equals(this.deficit, blockRecord.deficit) &&
        Objects.equals(this.farmerPuzzleHash, blockRecord.farmerPuzzleHash) &&
        Objects.equals(this.fees, blockRecord.fees) &&
        Objects.equals(this.finishedChallengeSlotHashes, blockRecord.finishedChallengeSlotHashes) &&
        Objects.equals(this.finishedInfusedChallengeSlotHashes, blockRecord.finishedInfusedChallengeSlotHashes) &&
        Objects.equals(this.finishedRewardSlotHashes, blockRecord.finishedRewardSlotHashes) &&
        Objects.equals(this.headerHash, blockRecord.headerHash) &&
        Objects.equals(this.height, blockRecord.height) &&
        Objects.equals(this.infusedChallengeVdfOutput, blockRecord.infusedChallengeVdfOutput) &&
        Objects.equals(this.overflow, blockRecord.overflow) &&
        Objects.equals(this.poolPuzzleHash, blockRecord.poolPuzzleHash) &&
        Objects.equals(this.prevHash, blockRecord.prevHash) &&
        Objects.equals(this.prevTransactionBlockHash, blockRecord.prevTransactionBlockHash) &&
        Objects.equals(this.prevTransactionBlockHeight, blockRecord.prevTransactionBlockHeight) &&
        Objects.equals(this.requiredIters, blockRecord.requiredIters) &&
        Objects.equals(this.rewardClaimsIncorporated, blockRecord.rewardClaimsIncorporated) &&
        Objects.equals(this.rewardInfusionNewChallenge, blockRecord.rewardInfusionNewChallenge) &&
        Objects.equals(this.signagePointIndex, blockRecord.signagePointIndex) &&
        Objects.equals(this.subEpochSummaryIncluded, blockRecord.subEpochSummaryIncluded) &&
        Objects.equals(this.subSlotIters, blockRecord.subSlotIters) &&
        Objects.equals(this.timestamp, blockRecord.timestamp) &&
        Objects.equals(this.totalIters, blockRecord.totalIters) &&
        Objects.equals(this.weight, blockRecord.weight);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(challengeBlockInfoHash, challengeVdfOutput, deficit, farmerPuzzleHash, fees, finishedChallengeSlotHashes, finishedInfusedChallengeSlotHashes, finishedRewardSlotHashes, headerHash, height, infusedChallengeVdfOutput, overflow, poolPuzzleHash, prevHash, prevTransactionBlockHash, prevTransactionBlockHeight, requiredIters, rewardClaimsIncorporated, rewardInfusionNewChallenge, signagePointIndex, subEpochSummaryIncluded, subSlotIters, timestamp, totalIters, weight);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BlockRecord {\n");
    sb.append("    challengeBlockInfoHash: ").append(toIndentedString(challengeBlockInfoHash)).append("\n");
    sb.append("    challengeVdfOutput: ").append(toIndentedString(challengeVdfOutput)).append("\n");
    sb.append("    deficit: ").append(toIndentedString(deficit)).append("\n");
    sb.append("    farmerPuzzleHash: ").append(toIndentedString(farmerPuzzleHash)).append("\n");
    sb.append("    fees: ").append(toIndentedString(fees)).append("\n");
    sb.append("    finishedChallengeSlotHashes: ").append(toIndentedString(finishedChallengeSlotHashes)).append("\n");
    sb.append("    finishedInfusedChallengeSlotHashes: ").append(toIndentedString(finishedInfusedChallengeSlotHashes)).append("\n");
    sb.append("    finishedRewardSlotHashes: ").append(toIndentedString(finishedRewardSlotHashes)).append("\n");
    sb.append("    headerHash: ").append(toIndentedString(headerHash)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    infusedChallengeVdfOutput: ").append(toIndentedString(infusedChallengeVdfOutput)).append("\n");
    sb.append("    overflow: ").append(toIndentedString(overflow)).append("\n");
    sb.append("    poolPuzzleHash: ").append(toIndentedString(poolPuzzleHash)).append("\n");
    sb.append("    prevHash: ").append(toIndentedString(prevHash)).append("\n");
    sb.append("    prevTransactionBlockHash: ").append(toIndentedString(prevTransactionBlockHash)).append("\n");
    sb.append("    prevTransactionBlockHeight: ").append(toIndentedString(prevTransactionBlockHeight)).append("\n");
    sb.append("    requiredIters: ").append(toIndentedString(requiredIters)).append("\n");
    sb.append("    rewardClaimsIncorporated: ").append(toIndentedString(rewardClaimsIncorporated)).append("\n");
    sb.append("    rewardInfusionNewChallenge: ").append(toIndentedString(rewardInfusionNewChallenge)).append("\n");
    sb.append("    signagePointIndex: ").append(toIndentedString(signagePointIndex)).append("\n");
    sb.append("    subEpochSummaryIncluded: ").append(toIndentedString(subEpochSummaryIncluded)).append("\n");
    sb.append("    subSlotIters: ").append(toIndentedString(subSlotIters)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("    totalIters: ").append(toIndentedString(totalIters)).append("\n");
    sb.append("    weight: ").append(toIndentedString(weight)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("challenge_block_info_hash");
    openapiFields.add("challenge_vdf_output");
    openapiFields.add("deficit");
    openapiFields.add("farmer_puzzle_hash");
    openapiFields.add("fees");
    openapiFields.add("finished_challenge_slot_hashes");
    openapiFields.add("finished_infused_challenge_slot_hashes");
    openapiFields.add("finished_reward_slot_hashes");
    openapiFields.add("header_hash");
    openapiFields.add("height");
    openapiFields.add("infused_challenge_vdf_output");
    openapiFields.add("overflow");
    openapiFields.add("pool_puzzle_hash");
    openapiFields.add("prev_hash");
    openapiFields.add("prev_transaction_block_hash");
    openapiFields.add("prev_transaction_block_height");
    openapiFields.add("required_iters");
    openapiFields.add("reward_claims_incorporated");
    openapiFields.add("reward_infusion_new_challenge");
    openapiFields.add("signage_point_index");
    openapiFields.add("sub_epoch_summary_included");
    openapiFields.add("sub_slot_iters");
    openapiFields.add("timestamp");
    openapiFields.add("total_iters");
    openapiFields.add("weight");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to BlockRecord
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!BlockRecord.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in BlockRecord is not found in the empty JSON string", BlockRecord.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!BlockRecord.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `BlockRecord` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("challenge_block_info_hash") != null && !jsonObj.get("challenge_block_info_hash").isJsonNull()) && !jsonObj.get("challenge_block_info_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_block_info_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_block_info_hash").toString()));
      }
      // validate the optional field `challenge_vdf_output`
      if (jsonObj.get("challenge_vdf_output") != null && !jsonObj.get("challenge_vdf_output").isJsonNull()) {
        BlockRecordChallengeVdfOutput.validateJsonObject(jsonObj.getAsJsonObject("challenge_vdf_output"));
      }
      if ((jsonObj.get("farmer_puzzle_hash") != null && !jsonObj.get("farmer_puzzle_hash").isJsonNull()) && !jsonObj.get("farmer_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `farmer_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("farmer_puzzle_hash").toString()));
      }
      if ((jsonObj.get("finished_challenge_slot_hashes") != null && !jsonObj.get("finished_challenge_slot_hashes").isJsonNull()) && !jsonObj.get("finished_challenge_slot_hashes").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `finished_challenge_slot_hashes` to be a primitive type in the JSON string but got `%s`", jsonObj.get("finished_challenge_slot_hashes").toString()));
      }
      if ((jsonObj.get("finished_infused_challenge_slot_hashes") != null && !jsonObj.get("finished_infused_challenge_slot_hashes").isJsonNull()) && !jsonObj.get("finished_infused_challenge_slot_hashes").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `finished_infused_challenge_slot_hashes` to be a primitive type in the JSON string but got `%s`", jsonObj.get("finished_infused_challenge_slot_hashes").toString()));
      }
      if ((jsonObj.get("finished_reward_slot_hashes") != null && !jsonObj.get("finished_reward_slot_hashes").isJsonNull()) && !jsonObj.get("finished_reward_slot_hashes").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `finished_reward_slot_hashes` to be a primitive type in the JSON string but got `%s`", jsonObj.get("finished_reward_slot_hashes").toString()));
      }
      if ((jsonObj.get("header_hash") != null && !jsonObj.get("header_hash").isJsonNull()) && !jsonObj.get("header_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `header_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("header_hash").toString()));
      }
      if ((jsonObj.get("infused_challenge_vdf_output") != null && !jsonObj.get("infused_challenge_vdf_output").isJsonNull()) && !jsonObj.get("infused_challenge_vdf_output").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `infused_challenge_vdf_output` to be a primitive type in the JSON string but got `%s`", jsonObj.get("infused_challenge_vdf_output").toString()));
      }
      if ((jsonObj.get("pool_puzzle_hash") != null && !jsonObj.get("pool_puzzle_hash").isJsonNull()) && !jsonObj.get("pool_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_puzzle_hash").toString()));
      }
      if ((jsonObj.get("prev_hash") != null && !jsonObj.get("prev_hash").isJsonNull()) && !jsonObj.get("prev_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `prev_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("prev_hash").toString()));
      }
      if ((jsonObj.get("prev_transaction_block_hash") != null && !jsonObj.get("prev_transaction_block_hash").isJsonNull()) && !jsonObj.get("prev_transaction_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `prev_transaction_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("prev_transaction_block_hash").toString()));
      }
      if ((jsonObj.get("reward_claims_incorporated") != null && !jsonObj.get("reward_claims_incorporated").isJsonNull()) && !jsonObj.get("reward_claims_incorporated").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_claims_incorporated` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_claims_incorporated").toString()));
      }
      if ((jsonObj.get("reward_infusion_new_challenge") != null && !jsonObj.get("reward_infusion_new_challenge").isJsonNull()) && !jsonObj.get("reward_infusion_new_challenge").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_infusion_new_challenge` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_infusion_new_challenge").toString()));
      }
      if ((jsonObj.get("sub_epoch_summary_included") != null && !jsonObj.get("sub_epoch_summary_included").isJsonNull()) && !jsonObj.get("sub_epoch_summary_included").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `sub_epoch_summary_included` to be a primitive type in the JSON string but got `%s`", jsonObj.get("sub_epoch_summary_included").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!BlockRecord.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'BlockRecord' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<BlockRecord> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(BlockRecord.class));

       return (TypeAdapter<T>) new TypeAdapter<BlockRecord>() {
           @Override
           public void write(JsonWriter out, BlockRecord value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public BlockRecord read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of BlockRecord given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of BlockRecord
  * @throws IOException if the JSON string is invalid with respect to BlockRecord
  */
  public static BlockRecord fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, BlockRecord.class);
  }

 /**
  * Convert an instance of BlockRecord to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

