/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.BlockRecord;
import org.openapitools.client.model.BlockchainStateMempoolMinFees;
import org.openapitools.client.model.BlockchainStateSync;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * The node&#39;s view of the blockchain.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class BlockchainState {
  public static final String SERIALIZED_NAME_NODE_ID = "node_id";
  @SerializedName(SERIALIZED_NAME_NODE_ID)
  private String nodeId;

  public static final String SERIALIZED_NAME_DIFFICULTY = "difficulty";
  @SerializedName(SERIALIZED_NAME_DIFFICULTY)
  private Integer difficulty;

  public static final String SERIALIZED_NAME_GENESIS_CHALLENGE_INITIALIZED = "genesis_challenge_initialized";
  @SerializedName(SERIALIZED_NAME_GENESIS_CHALLENGE_INITIALIZED)
  private Boolean genesisChallengeInitialized;

  public static final String SERIALIZED_NAME_MEMPOOL_SIZE = "mempool_size";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_SIZE)
  private Integer mempoolSize;

  public static final String SERIALIZED_NAME_MEMPOOL_COST = "mempool_cost";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_COST)
  private Integer mempoolCost;

  public static final String SERIALIZED_NAME_MEMPOOL_FEES = "mempool_fees";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_FEES)
  private Integer mempoolFees;

  public static final String SERIALIZED_NAME_MEMPOOL_MIN_FEES = "mempool_min_fees";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_MIN_FEES)
  private BlockchainStateMempoolMinFees mempoolMinFees;

  public static final String SERIALIZED_NAME_MEMPOOL_MAX_TOTAL_COST = "mempool_max_total_cost";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_MAX_TOTAL_COST)
  private Integer mempoolMaxTotalCost;

  public static final String SERIALIZED_NAME_BLOCK_MAX_COST = "block_max_cost";
  @SerializedName(SERIALIZED_NAME_BLOCK_MAX_COST)
  private Integer blockMaxCost;

  public static final String SERIALIZED_NAME_PEAK = "peak";
  @SerializedName(SERIALIZED_NAME_PEAK)
  private BlockRecord peak;

  public static final String SERIALIZED_NAME_SPACE = "space";
  @SerializedName(SERIALIZED_NAME_SPACE)
  private Integer space;

  public static final String SERIALIZED_NAME_SUB_SLOT_ITERS = "sub_slot_iters";
  @SerializedName(SERIALIZED_NAME_SUB_SLOT_ITERS)
  private Integer subSlotIters;

  public static final String SERIALIZED_NAME_SYNC = "sync";
  @SerializedName(SERIALIZED_NAME_SYNC)
  private BlockchainStateSync sync;

  public BlockchainState() {
  }

  public BlockchainState nodeId(String nodeId) {
    
    this.nodeId = nodeId;
    return this;
  }

   /**
   * Get nodeId
   * @return nodeId
  **/
  @javax.annotation.Nullable

  public String getNodeId() {
    return nodeId;
  }


  public void setNodeId(String nodeId) {
    this.nodeId = nodeId;
  }


  public BlockchainState difficulty(Integer difficulty) {
    
    this.difficulty = difficulty;
    return this;
  }

   /**
   * Get difficulty
   * @return difficulty
  **/
  @javax.annotation.Nullable

  public Integer getDifficulty() {
    return difficulty;
  }


  public void setDifficulty(Integer difficulty) {
    this.difficulty = difficulty;
  }


  public BlockchainState genesisChallengeInitialized(Boolean genesisChallengeInitialized) {
    
    this.genesisChallengeInitialized = genesisChallengeInitialized;
    return this;
  }

   /**
   * Get genesisChallengeInitialized
   * @return genesisChallengeInitialized
  **/
  @javax.annotation.Nullable

  public Boolean getGenesisChallengeInitialized() {
    return genesisChallengeInitialized;
  }


  public void setGenesisChallengeInitialized(Boolean genesisChallengeInitialized) {
    this.genesisChallengeInitialized = genesisChallengeInitialized;
  }


  public BlockchainState mempoolSize(Integer mempoolSize) {
    
    this.mempoolSize = mempoolSize;
    return this;
  }

   /**
   * Get mempoolSize
   * @return mempoolSize
  **/
  @javax.annotation.Nullable

  public Integer getMempoolSize() {
    return mempoolSize;
  }


  public void setMempoolSize(Integer mempoolSize) {
    this.mempoolSize = mempoolSize;
  }


  public BlockchainState mempoolCost(Integer mempoolCost) {
    
    this.mempoolCost = mempoolCost;
    return this;
  }

   /**
   * Get mempoolCost
   * @return mempoolCost
  **/
  @javax.annotation.Nullable

  public Integer getMempoolCost() {
    return mempoolCost;
  }


  public void setMempoolCost(Integer mempoolCost) {
    this.mempoolCost = mempoolCost;
  }


  public BlockchainState mempoolFees(Integer mempoolFees) {
    
    this.mempoolFees = mempoolFees;
    return this;
  }

   /**
   * Get mempoolFees
   * @return mempoolFees
  **/
  @javax.annotation.Nullable

  public Integer getMempoolFees() {
    return mempoolFees;
  }


  public void setMempoolFees(Integer mempoolFees) {
    this.mempoolFees = mempoolFees;
  }


  public BlockchainState mempoolMinFees(BlockchainStateMempoolMinFees mempoolMinFees) {
    
    this.mempoolMinFees = mempoolMinFees;
    return this;
  }

   /**
   * Get mempoolMinFees
   * @return mempoolMinFees
  **/
  @javax.annotation.Nullable

  public BlockchainStateMempoolMinFees getMempoolMinFees() {
    return mempoolMinFees;
  }


  public void setMempoolMinFees(BlockchainStateMempoolMinFees mempoolMinFees) {
    this.mempoolMinFees = mempoolMinFees;
  }


  public BlockchainState mempoolMaxTotalCost(Integer mempoolMaxTotalCost) {
    
    this.mempoolMaxTotalCost = mempoolMaxTotalCost;
    return this;
  }

   /**
   * Get mempoolMaxTotalCost
   * @return mempoolMaxTotalCost
  **/
  @javax.annotation.Nullable

  public Integer getMempoolMaxTotalCost() {
    return mempoolMaxTotalCost;
  }


  public void setMempoolMaxTotalCost(Integer mempoolMaxTotalCost) {
    this.mempoolMaxTotalCost = mempoolMaxTotalCost;
  }


  public BlockchainState blockMaxCost(Integer blockMaxCost) {
    
    this.blockMaxCost = blockMaxCost;
    return this;
  }

   /**
   * Get blockMaxCost
   * @return blockMaxCost
  **/
  @javax.annotation.Nullable

  public Integer getBlockMaxCost() {
    return blockMaxCost;
  }


  public void setBlockMaxCost(Integer blockMaxCost) {
    this.blockMaxCost = blockMaxCost;
  }


  public BlockchainState peak(BlockRecord peak) {
    
    this.peak = peak;
    return this;
  }

   /**
   * Get peak
   * @return peak
  **/
  @javax.annotation.Nullable

  public BlockRecord getPeak() {
    return peak;
  }


  public void setPeak(BlockRecord peak) {
    this.peak = peak;
  }


  public BlockchainState space(Integer space) {
    
    this.space = space;
    return this;
  }

   /**
   * Get space
   * @return space
  **/
  @javax.annotation.Nullable

  public Integer getSpace() {
    return space;
  }


  public void setSpace(Integer space) {
    this.space = space;
  }


  public BlockchainState subSlotIters(Integer subSlotIters) {
    
    this.subSlotIters = subSlotIters;
    return this;
  }

   /**
   * Get subSlotIters
   * @return subSlotIters
  **/
  @javax.annotation.Nullable

  public Integer getSubSlotIters() {
    return subSlotIters;
  }


  public void setSubSlotIters(Integer subSlotIters) {
    this.subSlotIters = subSlotIters;
  }


  public BlockchainState sync(BlockchainStateSync sync) {
    
    this.sync = sync;
    return this;
  }

   /**
   * Get sync
   * @return sync
  **/
  @javax.annotation.Nullable

  public BlockchainStateSync getSync() {
    return sync;
  }


  public void setSync(BlockchainStateSync sync) {
    this.sync = sync;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BlockchainState blockchainState = (BlockchainState) o;
    return Objects.equals(this.nodeId, blockchainState.nodeId) &&
        Objects.equals(this.difficulty, blockchainState.difficulty) &&
        Objects.equals(this.genesisChallengeInitialized, blockchainState.genesisChallengeInitialized) &&
        Objects.equals(this.mempoolSize, blockchainState.mempoolSize) &&
        Objects.equals(this.mempoolCost, blockchainState.mempoolCost) &&
        Objects.equals(this.mempoolFees, blockchainState.mempoolFees) &&
        Objects.equals(this.mempoolMinFees, blockchainState.mempoolMinFees) &&
        Objects.equals(this.mempoolMaxTotalCost, blockchainState.mempoolMaxTotalCost) &&
        Objects.equals(this.blockMaxCost, blockchainState.blockMaxCost) &&
        Objects.equals(this.peak, blockchainState.peak) &&
        Objects.equals(this.space, blockchainState.space) &&
        Objects.equals(this.subSlotIters, blockchainState.subSlotIters) &&
        Objects.equals(this.sync, blockchainState.sync);
  }

  @Override
  public int hashCode() {
    return Objects.hash(nodeId, difficulty, genesisChallengeInitialized, mempoolSize, mempoolCost, mempoolFees, mempoolMinFees, mempoolMaxTotalCost, blockMaxCost, peak, space, subSlotIters, sync);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BlockchainState {\n");
    sb.append("    nodeId: ").append(toIndentedString(nodeId)).append("\n");
    sb.append("    difficulty: ").append(toIndentedString(difficulty)).append("\n");
    sb.append("    genesisChallengeInitialized: ").append(toIndentedString(genesisChallengeInitialized)).append("\n");
    sb.append("    mempoolSize: ").append(toIndentedString(mempoolSize)).append("\n");
    sb.append("    mempoolCost: ").append(toIndentedString(mempoolCost)).append("\n");
    sb.append("    mempoolFees: ").append(toIndentedString(mempoolFees)).append("\n");
    sb.append("    mempoolMinFees: ").append(toIndentedString(mempoolMinFees)).append("\n");
    sb.append("    mempoolMaxTotalCost: ").append(toIndentedString(mempoolMaxTotalCost)).append("\n");
    sb.append("    blockMaxCost: ").append(toIndentedString(blockMaxCost)).append("\n");
    sb.append("    peak: ").append(toIndentedString(peak)).append("\n");
    sb.append("    space: ").append(toIndentedString(space)).append("\n");
    sb.append("    subSlotIters: ").append(toIndentedString(subSlotIters)).append("\n");
    sb.append("    sync: ").append(toIndentedString(sync)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("node_id");
    openapiFields.add("difficulty");
    openapiFields.add("genesis_challenge_initialized");
    openapiFields.add("mempool_size");
    openapiFields.add("mempool_cost");
    openapiFields.add("mempool_fees");
    openapiFields.add("mempool_min_fees");
    openapiFields.add("mempool_max_total_cost");
    openapiFields.add("block_max_cost");
    openapiFields.add("peak");
    openapiFields.add("space");
    openapiFields.add("sub_slot_iters");
    openapiFields.add("sync");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to BlockchainState
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!BlockchainState.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in BlockchainState is not found in the empty JSON string", BlockchainState.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!BlockchainState.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `BlockchainState` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("node_id") != null && !jsonObj.get("node_id").isJsonNull()) && !jsonObj.get("node_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `node_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("node_id").toString()));
      }
      // validate the optional field `mempool_min_fees`
      if (jsonObj.get("mempool_min_fees") != null && !jsonObj.get("mempool_min_fees").isJsonNull()) {
        BlockchainStateMempoolMinFees.validateJsonObject(jsonObj.getAsJsonObject("mempool_min_fees"));
      }
      // validate the optional field `peak`
      if (jsonObj.get("peak") != null && !jsonObj.get("peak").isJsonNull()) {
        BlockRecord.validateJsonObject(jsonObj.getAsJsonObject("peak"));
      }
      // validate the optional field `sync`
      if (jsonObj.get("sync") != null && !jsonObj.get("sync").isJsonNull()) {
        BlockchainStateSync.validateJsonObject(jsonObj.getAsJsonObject("sync"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!BlockchainState.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'BlockchainState' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<BlockchainState> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(BlockchainState.class));

       return (TypeAdapter<T>) new TypeAdapter<BlockchainState>() {
           @Override
           public void write(JsonWriter out, BlockchainState value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public BlockchainState read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of BlockchainState given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of BlockchainState
  * @throws IOException if the JSON string is invalid with respect to BlockchainState
  */
  public static BlockchainState fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, BlockchainState.class);
  }

 /**
  * Convert an instance of BlockchainState to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

