/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * BlockchainStateSync
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class BlockchainStateSync {
  public static final String SERIALIZED_NAME_SYNC_MODE = "sync_mode";
  @SerializedName(SERIALIZED_NAME_SYNC_MODE)
  private Boolean syncMode;

  public static final String SERIALIZED_NAME_SYNC_PROGRESS_HEIGHT = "sync_progress_height";
  @SerializedName(SERIALIZED_NAME_SYNC_PROGRESS_HEIGHT)
  private Integer syncProgressHeight;

  public static final String SERIALIZED_NAME_SYNC_TIP_HEIGHT = "sync_tip_height";
  @SerializedName(SERIALIZED_NAME_SYNC_TIP_HEIGHT)
  private Integer syncTipHeight;

  public static final String SERIALIZED_NAME_SYNCED = "synced";
  @SerializedName(SERIALIZED_NAME_SYNCED)
  private Boolean synced;

  public BlockchainStateSync() {
  }

  public BlockchainStateSync syncMode(Boolean syncMode) {
    
    this.syncMode = syncMode;
    return this;
  }

   /**
   * Get syncMode
   * @return syncMode
  **/
  @javax.annotation.Nullable

  public Boolean getSyncMode() {
    return syncMode;
  }


  public void setSyncMode(Boolean syncMode) {
    this.syncMode = syncMode;
  }


  public BlockchainStateSync syncProgressHeight(Integer syncProgressHeight) {
    
    this.syncProgressHeight = syncProgressHeight;
    return this;
  }

   /**
   * Get syncProgressHeight
   * @return syncProgressHeight
  **/
  @javax.annotation.Nullable

  public Integer getSyncProgressHeight() {
    return syncProgressHeight;
  }


  public void setSyncProgressHeight(Integer syncProgressHeight) {
    this.syncProgressHeight = syncProgressHeight;
  }


  public BlockchainStateSync syncTipHeight(Integer syncTipHeight) {
    
    this.syncTipHeight = syncTipHeight;
    return this;
  }

   /**
   * Get syncTipHeight
   * @return syncTipHeight
  **/
  @javax.annotation.Nullable

  public Integer getSyncTipHeight() {
    return syncTipHeight;
  }


  public void setSyncTipHeight(Integer syncTipHeight) {
    this.syncTipHeight = syncTipHeight;
  }


  public BlockchainStateSync synced(Boolean synced) {
    
    this.synced = synced;
    return this;
  }

   /**
   * Get synced
   * @return synced
  **/
  @javax.annotation.Nullable

  public Boolean getSynced() {
    return synced;
  }


  public void setSynced(Boolean synced) {
    this.synced = synced;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BlockchainStateSync blockchainStateSync = (BlockchainStateSync) o;
    return Objects.equals(this.syncMode, blockchainStateSync.syncMode) &&
        Objects.equals(this.syncProgressHeight, blockchainStateSync.syncProgressHeight) &&
        Objects.equals(this.syncTipHeight, blockchainStateSync.syncTipHeight) &&
        Objects.equals(this.synced, blockchainStateSync.synced);
  }

  @Override
  public int hashCode() {
    return Objects.hash(syncMode, syncProgressHeight, syncTipHeight, synced);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BlockchainStateSync {\n");
    sb.append("    syncMode: ").append(toIndentedString(syncMode)).append("\n");
    sb.append("    syncProgressHeight: ").append(toIndentedString(syncProgressHeight)).append("\n");
    sb.append("    syncTipHeight: ").append(toIndentedString(syncTipHeight)).append("\n");
    sb.append("    synced: ").append(toIndentedString(synced)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("sync_mode");
    openapiFields.add("sync_progress_height");
    openapiFields.add("sync_tip_height");
    openapiFields.add("synced");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to BlockchainStateSync
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!BlockchainStateSync.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in BlockchainStateSync is not found in the empty JSON string", BlockchainStateSync.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!BlockchainStateSync.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `BlockchainStateSync` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!BlockchainStateSync.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'BlockchainStateSync' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<BlockchainStateSync> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(BlockchainStateSync.class));

       return (TypeAdapter<T>) new TypeAdapter<BlockchainStateSync>() {
           @Override
           public void write(JsonWriter out, BlockchainStateSync value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public BlockchainStateSync read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of BlockchainStateSync given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of BlockchainStateSync
  * @throws IOException if the JSON string is invalid with respect to BlockchainStateSync
  */
  public static BlockchainStateSync fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, BlockchainStateSync.class);
  }

 /**
  * Convert an instance of BlockchainStateSync to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

