/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.VdfInfo;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * ChallengeChainSubSlot
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class ChallengeChainSubSlot {
  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_END_OF_SLOT_VDF = "challenge_chain_end_of_slot_vdf";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_END_OF_SLOT_VDF)
  private VdfInfo challengeChainEndOfSlotVdf;

  public static final String SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_SUB_SLOT_HASH = "infused_challenge_chain_sub_slot_hash";
  @SerializedName(SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_SUB_SLOT_HASH)
  private String infusedChallengeChainSubSlotHash;

  public static final String SERIALIZED_NAME_SUBEPOCH_SUMMARY_HASH = "subepoch_summary_hash";
  @SerializedName(SERIALIZED_NAME_SUBEPOCH_SUMMARY_HASH)
  private String subepochSummaryHash;

  public static final String SERIALIZED_NAME_NEW_SUB_SLOT_ITERS = "new_sub_slot_iters";
  @SerializedName(SERIALIZED_NAME_NEW_SUB_SLOT_ITERS)
  private Integer newSubSlotIters;

  public static final String SERIALIZED_NAME_NEW_DIFFICULTY = "new_difficulty";
  @SerializedName(SERIALIZED_NAME_NEW_DIFFICULTY)
  private Integer newDifficulty;

  public ChallengeChainSubSlot() {
  }

  public ChallengeChainSubSlot challengeChainEndOfSlotVdf(VdfInfo challengeChainEndOfSlotVdf) {
    
    this.challengeChainEndOfSlotVdf = challengeChainEndOfSlotVdf;
    return this;
  }

   /**
   * Get challengeChainEndOfSlotVdf
   * @return challengeChainEndOfSlotVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getChallengeChainEndOfSlotVdf() {
    return challengeChainEndOfSlotVdf;
  }


  public void setChallengeChainEndOfSlotVdf(VdfInfo challengeChainEndOfSlotVdf) {
    this.challengeChainEndOfSlotVdf = challengeChainEndOfSlotVdf;
  }


  public ChallengeChainSubSlot infusedChallengeChainSubSlotHash(String infusedChallengeChainSubSlotHash) {
    
    this.infusedChallengeChainSubSlotHash = infusedChallengeChainSubSlotHash;
    return this;
  }

   /**
   * Get infusedChallengeChainSubSlotHash
   * @return infusedChallengeChainSubSlotHash
  **/
  @javax.annotation.Nullable

  public String getInfusedChallengeChainSubSlotHash() {
    return infusedChallengeChainSubSlotHash;
  }


  public void setInfusedChallengeChainSubSlotHash(String infusedChallengeChainSubSlotHash) {
    this.infusedChallengeChainSubSlotHash = infusedChallengeChainSubSlotHash;
  }


  public ChallengeChainSubSlot subepochSummaryHash(String subepochSummaryHash) {
    
    this.subepochSummaryHash = subepochSummaryHash;
    return this;
  }

   /**
   * Get subepochSummaryHash
   * @return subepochSummaryHash
  **/
  @javax.annotation.Nullable

  public String getSubepochSummaryHash() {
    return subepochSummaryHash;
  }


  public void setSubepochSummaryHash(String subepochSummaryHash) {
    this.subepochSummaryHash = subepochSummaryHash;
  }


  public ChallengeChainSubSlot newSubSlotIters(Integer newSubSlotIters) {
    
    this.newSubSlotIters = newSubSlotIters;
    return this;
  }

   /**
   * Get newSubSlotIters
   * @return newSubSlotIters
  **/
  @javax.annotation.Nullable

  public Integer getNewSubSlotIters() {
    return newSubSlotIters;
  }


  public void setNewSubSlotIters(Integer newSubSlotIters) {
    this.newSubSlotIters = newSubSlotIters;
  }


  public ChallengeChainSubSlot newDifficulty(Integer newDifficulty) {
    
    this.newDifficulty = newDifficulty;
    return this;
  }

   /**
   * Get newDifficulty
   * @return newDifficulty
  **/
  @javax.annotation.Nullable

  public Integer getNewDifficulty() {
    return newDifficulty;
  }


  public void setNewDifficulty(Integer newDifficulty) {
    this.newDifficulty = newDifficulty;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ChallengeChainSubSlot challengeChainSubSlot = (ChallengeChainSubSlot) o;
    return Objects.equals(this.challengeChainEndOfSlotVdf, challengeChainSubSlot.challengeChainEndOfSlotVdf) &&
        Objects.equals(this.infusedChallengeChainSubSlotHash, challengeChainSubSlot.infusedChallengeChainSubSlotHash) &&
        Objects.equals(this.subepochSummaryHash, challengeChainSubSlot.subepochSummaryHash) &&
        Objects.equals(this.newSubSlotIters, challengeChainSubSlot.newSubSlotIters) &&
        Objects.equals(this.newDifficulty, challengeChainSubSlot.newDifficulty);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(challengeChainEndOfSlotVdf, infusedChallengeChainSubSlotHash, subepochSummaryHash, newSubSlotIters, newDifficulty);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ChallengeChainSubSlot {\n");
    sb.append("    challengeChainEndOfSlotVdf: ").append(toIndentedString(challengeChainEndOfSlotVdf)).append("\n");
    sb.append("    infusedChallengeChainSubSlotHash: ").append(toIndentedString(infusedChallengeChainSubSlotHash)).append("\n");
    sb.append("    subepochSummaryHash: ").append(toIndentedString(subepochSummaryHash)).append("\n");
    sb.append("    newSubSlotIters: ").append(toIndentedString(newSubSlotIters)).append("\n");
    sb.append("    newDifficulty: ").append(toIndentedString(newDifficulty)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("challenge_chain_end_of_slot_vdf");
    openapiFields.add("infused_challenge_chain_sub_slot_hash");
    openapiFields.add("subepoch_summary_hash");
    openapiFields.add("new_sub_slot_iters");
    openapiFields.add("new_difficulty");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to ChallengeChainSubSlot
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!ChallengeChainSubSlot.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ChallengeChainSubSlot is not found in the empty JSON string", ChallengeChainSubSlot.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!ChallengeChainSubSlot.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ChallengeChainSubSlot` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `challenge_chain_end_of_slot_vdf`
      if (jsonObj.get("challenge_chain_end_of_slot_vdf") != null && !jsonObj.get("challenge_chain_end_of_slot_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_end_of_slot_vdf"));
      }
      if ((jsonObj.get("infused_challenge_chain_sub_slot_hash") != null && !jsonObj.get("infused_challenge_chain_sub_slot_hash").isJsonNull()) && !jsonObj.get("infused_challenge_chain_sub_slot_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `infused_challenge_chain_sub_slot_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("infused_challenge_chain_sub_slot_hash").toString()));
      }
      if ((jsonObj.get("subepoch_summary_hash") != null && !jsonObj.get("subepoch_summary_hash").isJsonNull()) && !jsonObj.get("subepoch_summary_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `subepoch_summary_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("subepoch_summary_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ChallengeChainSubSlot.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ChallengeChainSubSlot' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ChallengeChainSubSlot> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ChallengeChainSubSlot.class));

       return (TypeAdapter<T>) new TypeAdapter<ChallengeChainSubSlot>() {
           @Override
           public void write(JsonWriter out, ChallengeChainSubSlot value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ChallengeChainSubSlot read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ChallengeChainSubSlot given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ChallengeChainSubSlot
  * @throws IOException if the JSON string is invalid with respect to ChallengeChainSubSlot
  */
  public static ChallengeChainSubSlot fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ChallengeChainSubSlot.class);
  }

 /**
  * Convert an instance of ChallengeChainSubSlot to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

