/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.Coin;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * CoinSpend
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class CoinSpend {
  public static final String SERIALIZED_NAME_COIN = "coin";
  @SerializedName(SERIALIZED_NAME_COIN)
  private Coin coin;

  public static final String SERIALIZED_NAME_PUZZLE_REVEAL = "puzzle_reveal";
  @SerializedName(SERIALIZED_NAME_PUZZLE_REVEAL)
  private String puzzleReveal;

  public static final String SERIALIZED_NAME_SOLUTION = "solution";
  @SerializedName(SERIALIZED_NAME_SOLUTION)
  private String solution;

  public CoinSpend() {
  }

  public CoinSpend coin(Coin coin) {
    
    this.coin = coin;
    return this;
  }

   /**
   * Get coin
   * @return coin
  **/
  @javax.annotation.Nullable

  public Coin getCoin() {
    return coin;
  }


  public void setCoin(Coin coin) {
    this.coin = coin;
  }


  public CoinSpend puzzleReveal(String puzzleReveal) {
    
    this.puzzleReveal = puzzleReveal;
    return this;
  }

   /**
   * Get puzzleReveal
   * @return puzzleReveal
  **/
  @javax.annotation.Nullable

  public String getPuzzleReveal() {
    return puzzleReveal;
  }


  public void setPuzzleReveal(String puzzleReveal) {
    this.puzzleReveal = puzzleReveal;
  }


  public CoinSpend solution(String solution) {
    
    this.solution = solution;
    return this;
  }

   /**
   * Get solution
   * @return solution
  **/
  @javax.annotation.Nullable

  public String getSolution() {
    return solution;
  }


  public void setSolution(String solution) {
    this.solution = solution;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CoinSpend coinSpend = (CoinSpend) o;
    return Objects.equals(this.coin, coinSpend.coin) &&
        Objects.equals(this.puzzleReveal, coinSpend.puzzleReveal) &&
        Objects.equals(this.solution, coinSpend.solution);
  }

  @Override
  public int hashCode() {
    return Objects.hash(coin, puzzleReveal, solution);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CoinSpend {\n");
    sb.append("    coin: ").append(toIndentedString(coin)).append("\n");
    sb.append("    puzzleReveal: ").append(toIndentedString(puzzleReveal)).append("\n");
    sb.append("    solution: ").append(toIndentedString(solution)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("coin");
    openapiFields.add("puzzle_reveal");
    openapiFields.add("solution");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CoinSpend
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CoinSpend.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CoinSpend is not found in the empty JSON string", CoinSpend.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CoinSpend.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CoinSpend` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `coin`
      if (jsonObj.get("coin") != null && !jsonObj.get("coin").isJsonNull()) {
        Coin.validateJsonObject(jsonObj.getAsJsonObject("coin"));
      }
      if ((jsonObj.get("puzzle_reveal") != null && !jsonObj.get("puzzle_reveal").isJsonNull()) && !jsonObj.get("puzzle_reveal").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `puzzle_reveal` to be a primitive type in the JSON string but got `%s`", jsonObj.get("puzzle_reveal").toString()));
      }
      if ((jsonObj.get("solution") != null && !jsonObj.get("solution").isJsonNull()) && !jsonObj.get("solution").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `solution` to be a primitive type in the JSON string but got `%s`", jsonObj.get("solution").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CoinSpend.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CoinSpend' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CoinSpend> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CoinSpend.class));

       return (TypeAdapter<T>) new TypeAdapter<CoinSpend>() {
           @Override
           public void write(JsonWriter out, CoinSpend value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CoinSpend read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CoinSpend given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CoinSpend
  * @throws IOException if the JSON string is invalid with respect to CoinSpend
  */
  public static CoinSpend fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CoinSpend.class);
  }

 /**
  * Convert an instance of CoinSpend to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

