/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * ConditionWithArgs
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class ConditionWithArgs {
  public static final String SERIALIZED_NAME_OPCODE = "opcode";
  @SerializedName(SERIALIZED_NAME_OPCODE)
  private String opcode;

  public static final String SERIALIZED_NAME_VARS = "vars";
  @SerializedName(SERIALIZED_NAME_VARS)
  private List<String> vars;

  public ConditionWithArgs() {
  }

  public ConditionWithArgs opcode(String opcode) {
    
    this.opcode = opcode;
    return this;
  }

   /**
   * Get opcode
   * @return opcode
  **/
  @javax.annotation.Nullable

  public String getOpcode() {
    return opcode;
  }


  public void setOpcode(String opcode) {
    this.opcode = opcode;
  }


  public ConditionWithArgs vars(List<String> vars) {
    
    this.vars = vars;
    return this;
  }

  public ConditionWithArgs addVarsItem(String varsItem) {
    if (this.vars == null) {
      this.vars = new ArrayList<>();
    }
    this.vars.add(varsItem);
    return this;
  }

   /**
   * Get vars
   * @return vars
  **/
  @javax.annotation.Nullable

  public List<String> getVars() {
    return vars;
  }


  public void setVars(List<String> vars) {
    this.vars = vars;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConditionWithArgs conditionWithArgs = (ConditionWithArgs) o;
    return Objects.equals(this.opcode, conditionWithArgs.opcode) &&
        Objects.equals(this.vars, conditionWithArgs.vars);
  }

  @Override
  public int hashCode() {
    return Objects.hash(opcode, vars);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConditionWithArgs {\n");
    sb.append("    opcode: ").append(toIndentedString(opcode)).append("\n");
    sb.append("    vars: ").append(toIndentedString(vars)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("opcode");
    openapiFields.add("vars");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to ConditionWithArgs
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!ConditionWithArgs.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ConditionWithArgs is not found in the empty JSON string", ConditionWithArgs.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!ConditionWithArgs.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ConditionWithArgs` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("opcode") != null && !jsonObj.get("opcode").isJsonNull()) && !jsonObj.get("opcode").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `opcode` to be a primitive type in the JSON string but got `%s`", jsonObj.get("opcode").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("vars") != null && !jsonObj.get("vars").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `vars` to be an array in the JSON string but got `%s`", jsonObj.get("vars").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ConditionWithArgs.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ConditionWithArgs' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ConditionWithArgs> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ConditionWithArgs.class));

       return (TypeAdapter<T>) new TypeAdapter<ConditionWithArgs>() {
           @Override
           public void write(JsonWriter out, ConditionWithArgs value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ConditionWithArgs read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ConditionWithArgs given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ConditionWithArgs
  * @throws IOException if the JSON string is invalid with respect to ConditionWithArgs
  */
  public static ConditionWithArgs fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ConditionWithArgs.class);
  }

 /**
  * Convert an instance of ConditionWithArgs to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

