/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.FoliageBlockData;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Foliage
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class Foliage {
  public static final String SERIALIZED_NAME_PREV_BLOCK_HASH = "prev_block_hash";
  @SerializedName(SERIALIZED_NAME_PREV_BLOCK_HASH)
  private String prevBlockHash;

  public static final String SERIALIZED_NAME_REWARD_BLOCK_HASH = "reward_block_hash";
  @SerializedName(SERIALIZED_NAME_REWARD_BLOCK_HASH)
  private String rewardBlockHash;

  public static final String SERIALIZED_NAME_FOLIAGE_BLOCK_DATA = "foliage_block_data";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_BLOCK_DATA)
  private FoliageBlockData foliageBlockData;

  public static final String SERIALIZED_NAME_FOLIAGE_BLOCK_DATA_SIGNATURE = "foliage_block_data_signature";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_BLOCK_DATA_SIGNATURE)
  private String foliageBlockDataSignature;

  public static final String SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK_HASH = "foliage_transaction_block_hash";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK_HASH)
  private String foliageTransactionBlockHash;

  public static final String SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK_SIGNATURE = "foliage_transaction_block_signature";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK_SIGNATURE)
  private String foliageTransactionBlockSignature;

  public Foliage() {
  }

  public Foliage prevBlockHash(String prevBlockHash) {
    
    this.prevBlockHash = prevBlockHash;
    return this;
  }

   /**
   * Get prevBlockHash
   * @return prevBlockHash
  **/
  @javax.annotation.Nullable

  public String getPrevBlockHash() {
    return prevBlockHash;
  }


  public void setPrevBlockHash(String prevBlockHash) {
    this.prevBlockHash = prevBlockHash;
  }


  public Foliage rewardBlockHash(String rewardBlockHash) {
    
    this.rewardBlockHash = rewardBlockHash;
    return this;
  }

   /**
   * Get rewardBlockHash
   * @return rewardBlockHash
  **/
  @javax.annotation.Nullable

  public String getRewardBlockHash() {
    return rewardBlockHash;
  }


  public void setRewardBlockHash(String rewardBlockHash) {
    this.rewardBlockHash = rewardBlockHash;
  }


  public Foliage foliageBlockData(FoliageBlockData foliageBlockData) {
    
    this.foliageBlockData = foliageBlockData;
    return this;
  }

   /**
   * Get foliageBlockData
   * @return foliageBlockData
  **/
  @javax.annotation.Nullable

  public FoliageBlockData getFoliageBlockData() {
    return foliageBlockData;
  }


  public void setFoliageBlockData(FoliageBlockData foliageBlockData) {
    this.foliageBlockData = foliageBlockData;
  }


  public Foliage foliageBlockDataSignature(String foliageBlockDataSignature) {
    
    this.foliageBlockDataSignature = foliageBlockDataSignature;
    return this;
  }

   /**
   * Get foliageBlockDataSignature
   * @return foliageBlockDataSignature
  **/
  @javax.annotation.Nullable

  public String getFoliageBlockDataSignature() {
    return foliageBlockDataSignature;
  }


  public void setFoliageBlockDataSignature(String foliageBlockDataSignature) {
    this.foliageBlockDataSignature = foliageBlockDataSignature;
  }


  public Foliage foliageTransactionBlockHash(String foliageTransactionBlockHash) {
    
    this.foliageTransactionBlockHash = foliageTransactionBlockHash;
    return this;
  }

   /**
   * Get foliageTransactionBlockHash
   * @return foliageTransactionBlockHash
  **/
  @javax.annotation.Nullable

  public String getFoliageTransactionBlockHash() {
    return foliageTransactionBlockHash;
  }


  public void setFoliageTransactionBlockHash(String foliageTransactionBlockHash) {
    this.foliageTransactionBlockHash = foliageTransactionBlockHash;
  }


  public Foliage foliageTransactionBlockSignature(String foliageTransactionBlockSignature) {
    
    this.foliageTransactionBlockSignature = foliageTransactionBlockSignature;
    return this;
  }

   /**
   * Get foliageTransactionBlockSignature
   * @return foliageTransactionBlockSignature
  **/
  @javax.annotation.Nullable

  public String getFoliageTransactionBlockSignature() {
    return foliageTransactionBlockSignature;
  }


  public void setFoliageTransactionBlockSignature(String foliageTransactionBlockSignature) {
    this.foliageTransactionBlockSignature = foliageTransactionBlockSignature;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Foliage foliage = (Foliage) o;
    return Objects.equals(this.prevBlockHash, foliage.prevBlockHash) &&
        Objects.equals(this.rewardBlockHash, foliage.rewardBlockHash) &&
        Objects.equals(this.foliageBlockData, foliage.foliageBlockData) &&
        Objects.equals(this.foliageBlockDataSignature, foliage.foliageBlockDataSignature) &&
        Objects.equals(this.foliageTransactionBlockHash, foliage.foliageTransactionBlockHash) &&
        Objects.equals(this.foliageTransactionBlockSignature, foliage.foliageTransactionBlockSignature);
  }

  @Override
  public int hashCode() {
    return Objects.hash(prevBlockHash, rewardBlockHash, foliageBlockData, foliageBlockDataSignature, foliageTransactionBlockHash, foliageTransactionBlockSignature);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Foliage {\n");
    sb.append("    prevBlockHash: ").append(toIndentedString(prevBlockHash)).append("\n");
    sb.append("    rewardBlockHash: ").append(toIndentedString(rewardBlockHash)).append("\n");
    sb.append("    foliageBlockData: ").append(toIndentedString(foliageBlockData)).append("\n");
    sb.append("    foliageBlockDataSignature: ").append(toIndentedString(foliageBlockDataSignature)).append("\n");
    sb.append("    foliageTransactionBlockHash: ").append(toIndentedString(foliageTransactionBlockHash)).append("\n");
    sb.append("    foliageTransactionBlockSignature: ").append(toIndentedString(foliageTransactionBlockSignature)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("prev_block_hash");
    openapiFields.add("reward_block_hash");
    openapiFields.add("foliage_block_data");
    openapiFields.add("foliage_block_data_signature");
    openapiFields.add("foliage_transaction_block_hash");
    openapiFields.add("foliage_transaction_block_signature");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to Foliage
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!Foliage.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in Foliage is not found in the empty JSON string", Foliage.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!Foliage.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `Foliage` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("prev_block_hash") != null && !jsonObj.get("prev_block_hash").isJsonNull()) && !jsonObj.get("prev_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `prev_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("prev_block_hash").toString()));
      }
      if ((jsonObj.get("reward_block_hash") != null && !jsonObj.get("reward_block_hash").isJsonNull()) && !jsonObj.get("reward_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_block_hash").toString()));
      }
      // validate the optional field `foliage_block_data`
      if (jsonObj.get("foliage_block_data") != null && !jsonObj.get("foliage_block_data").isJsonNull()) {
        FoliageBlockData.validateJsonObject(jsonObj.getAsJsonObject("foliage_block_data"));
      }
      if ((jsonObj.get("foliage_block_data_signature") != null && !jsonObj.get("foliage_block_data_signature").isJsonNull()) && !jsonObj.get("foliage_block_data_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `foliage_block_data_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("foliage_block_data_signature").toString()));
      }
      if ((jsonObj.get("foliage_transaction_block_hash") != null && !jsonObj.get("foliage_transaction_block_hash").isJsonNull()) && !jsonObj.get("foliage_transaction_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `foliage_transaction_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("foliage_transaction_block_hash").toString()));
      }
      if ((jsonObj.get("foliage_transaction_block_signature") != null && !jsonObj.get("foliage_transaction_block_signature").isJsonNull()) && !jsonObj.get("foliage_transaction_block_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `foliage_transaction_block_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("foliage_transaction_block_signature").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!Foliage.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'Foliage' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<Foliage> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(Foliage.class));

       return (TypeAdapter<T>) new TypeAdapter<Foliage>() {
           @Override
           public void write(JsonWriter out, Foliage value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public Foliage read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of Foliage given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of Foliage
  * @throws IOException if the JSON string is invalid with respect to Foliage
  */
  public static Foliage fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, Foliage.class);
  }

 /**
  * Convert an instance of Foliage to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

