/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.PoolTarget;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * FoliageBlockData
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class FoliageBlockData {
  public static final String SERIALIZED_NAME_UNFINISHED_REWARD_BLOCK_HASH = "unfinished_reward_block_hash";
  @SerializedName(SERIALIZED_NAME_UNFINISHED_REWARD_BLOCK_HASH)
  private String unfinishedRewardBlockHash;

  public static final String SERIALIZED_NAME_POOL_TARGET = "pool_target";
  @SerializedName(SERIALIZED_NAME_POOL_TARGET)
  private PoolTarget poolTarget;

  public static final String SERIALIZED_NAME_POOL_SIGNATURE = "pool_signature";
  @SerializedName(SERIALIZED_NAME_POOL_SIGNATURE)
  private String poolSignature;

  public static final String SERIALIZED_NAME_FARMER_REWARD_PUZZLE_HASH = "farmer_reward_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_FARMER_REWARD_PUZZLE_HASH)
  private String farmerRewardPuzzleHash;

  public static final String SERIALIZED_NAME_EXTENSION_DATA = "extension_data";
  @SerializedName(SERIALIZED_NAME_EXTENSION_DATA)
  private String extensionData;

  public FoliageBlockData() {
  }

  public FoliageBlockData unfinishedRewardBlockHash(String unfinishedRewardBlockHash) {
    
    this.unfinishedRewardBlockHash = unfinishedRewardBlockHash;
    return this;
  }

   /**
   * Get unfinishedRewardBlockHash
   * @return unfinishedRewardBlockHash
  **/
  @javax.annotation.Nullable

  public String getUnfinishedRewardBlockHash() {
    return unfinishedRewardBlockHash;
  }


  public void setUnfinishedRewardBlockHash(String unfinishedRewardBlockHash) {
    this.unfinishedRewardBlockHash = unfinishedRewardBlockHash;
  }


  public FoliageBlockData poolTarget(PoolTarget poolTarget) {
    
    this.poolTarget = poolTarget;
    return this;
  }

   /**
   * Get poolTarget
   * @return poolTarget
  **/
  @javax.annotation.Nullable

  public PoolTarget getPoolTarget() {
    return poolTarget;
  }


  public void setPoolTarget(PoolTarget poolTarget) {
    this.poolTarget = poolTarget;
  }


  public FoliageBlockData poolSignature(String poolSignature) {
    
    this.poolSignature = poolSignature;
    return this;
  }

   /**
   * Get poolSignature
   * @return poolSignature
  **/
  @javax.annotation.Nullable

  public String getPoolSignature() {
    return poolSignature;
  }


  public void setPoolSignature(String poolSignature) {
    this.poolSignature = poolSignature;
  }


  public FoliageBlockData farmerRewardPuzzleHash(String farmerRewardPuzzleHash) {
    
    this.farmerRewardPuzzleHash = farmerRewardPuzzleHash;
    return this;
  }

   /**
   * Get farmerRewardPuzzleHash
   * @return farmerRewardPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getFarmerRewardPuzzleHash() {
    return farmerRewardPuzzleHash;
  }


  public void setFarmerRewardPuzzleHash(String farmerRewardPuzzleHash) {
    this.farmerRewardPuzzleHash = farmerRewardPuzzleHash;
  }


  public FoliageBlockData extensionData(String extensionData) {
    
    this.extensionData = extensionData;
    return this;
  }

   /**
   * Get extensionData
   * @return extensionData
  **/
  @javax.annotation.Nullable

  public String getExtensionData() {
    return extensionData;
  }


  public void setExtensionData(String extensionData) {
    this.extensionData = extensionData;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FoliageBlockData foliageBlockData = (FoliageBlockData) o;
    return Objects.equals(this.unfinishedRewardBlockHash, foliageBlockData.unfinishedRewardBlockHash) &&
        Objects.equals(this.poolTarget, foliageBlockData.poolTarget) &&
        Objects.equals(this.poolSignature, foliageBlockData.poolSignature) &&
        Objects.equals(this.farmerRewardPuzzleHash, foliageBlockData.farmerRewardPuzzleHash) &&
        Objects.equals(this.extensionData, foliageBlockData.extensionData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(unfinishedRewardBlockHash, poolTarget, poolSignature, farmerRewardPuzzleHash, extensionData);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FoliageBlockData {\n");
    sb.append("    unfinishedRewardBlockHash: ").append(toIndentedString(unfinishedRewardBlockHash)).append("\n");
    sb.append("    poolTarget: ").append(toIndentedString(poolTarget)).append("\n");
    sb.append("    poolSignature: ").append(toIndentedString(poolSignature)).append("\n");
    sb.append("    farmerRewardPuzzleHash: ").append(toIndentedString(farmerRewardPuzzleHash)).append("\n");
    sb.append("    extensionData: ").append(toIndentedString(extensionData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("unfinished_reward_block_hash");
    openapiFields.add("pool_target");
    openapiFields.add("pool_signature");
    openapiFields.add("farmer_reward_puzzle_hash");
    openapiFields.add("extension_data");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to FoliageBlockData
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!FoliageBlockData.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in FoliageBlockData is not found in the empty JSON string", FoliageBlockData.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!FoliageBlockData.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `FoliageBlockData` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("unfinished_reward_block_hash") != null && !jsonObj.get("unfinished_reward_block_hash").isJsonNull()) && !jsonObj.get("unfinished_reward_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `unfinished_reward_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("unfinished_reward_block_hash").toString()));
      }
      // validate the optional field `pool_target`
      if (jsonObj.get("pool_target") != null && !jsonObj.get("pool_target").isJsonNull()) {
        PoolTarget.validateJsonObject(jsonObj.getAsJsonObject("pool_target"));
      }
      if ((jsonObj.get("pool_signature") != null && !jsonObj.get("pool_signature").isJsonNull()) && !jsonObj.get("pool_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_signature").toString()));
      }
      if ((jsonObj.get("farmer_reward_puzzle_hash") != null && !jsonObj.get("farmer_reward_puzzle_hash").isJsonNull()) && !jsonObj.get("farmer_reward_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `farmer_reward_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("farmer_reward_puzzle_hash").toString()));
      }
      if ((jsonObj.get("extension_data") != null && !jsonObj.get("extension_data").isJsonNull()) && !jsonObj.get("extension_data").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `extension_data` to be a primitive type in the JSON string but got `%s`", jsonObj.get("extension_data").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!FoliageBlockData.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'FoliageBlockData' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<FoliageBlockData> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(FoliageBlockData.class));

       return (TypeAdapter<T>) new TypeAdapter<FoliageBlockData>() {
           @Override
           public void write(JsonWriter out, FoliageBlockData value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public FoliageBlockData read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of FoliageBlockData given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of FoliageBlockData
  * @throws IOException if the JSON string is invalid with respect to FoliageBlockData
  */
  public static FoliageBlockData fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, FoliageBlockData.class);
  }

 /**
  * Convert an instance of FoliageBlockData to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

