/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * FoliageTransactionBlock
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class FoliageTransactionBlock {
  public static final String SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HASH = "prev_transaction_block_hash";
  @SerializedName(SERIALIZED_NAME_PREV_TRANSACTION_BLOCK_HASH)
  private String prevTransactionBlockHash;

  public static final String SERIALIZED_NAME_TIMESTAMP = "timestamp";
  @SerializedName(SERIALIZED_NAME_TIMESTAMP)
  private Integer timestamp;

  public static final String SERIALIZED_NAME_FILTER_HASH = "filter_hash";
  @SerializedName(SERIALIZED_NAME_FILTER_HASH)
  private String filterHash;

  public static final String SERIALIZED_NAME_ADDITIONS_ROOT = "additions_root";
  @SerializedName(SERIALIZED_NAME_ADDITIONS_ROOT)
  private String additionsRoot;

  public static final String SERIALIZED_NAME_REMOVALS_ROOT = "removals_root";
  @SerializedName(SERIALIZED_NAME_REMOVALS_ROOT)
  private String removalsRoot;

  public static final String SERIALIZED_NAME_TRANSACTIONS_INFO_HASH = "transactions_info_hash";
  @SerializedName(SERIALIZED_NAME_TRANSACTIONS_INFO_HASH)
  private String transactionsInfoHash;

  public FoliageTransactionBlock() {
  }

  public FoliageTransactionBlock prevTransactionBlockHash(String prevTransactionBlockHash) {
    
    this.prevTransactionBlockHash = prevTransactionBlockHash;
    return this;
  }

   /**
   * Get prevTransactionBlockHash
   * @return prevTransactionBlockHash
  **/
  @javax.annotation.Nullable

  public String getPrevTransactionBlockHash() {
    return prevTransactionBlockHash;
  }


  public void setPrevTransactionBlockHash(String prevTransactionBlockHash) {
    this.prevTransactionBlockHash = prevTransactionBlockHash;
  }


  public FoliageTransactionBlock timestamp(Integer timestamp) {
    
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @javax.annotation.Nullable

  public Integer getTimestamp() {
    return timestamp;
  }


  public void setTimestamp(Integer timestamp) {
    this.timestamp = timestamp;
  }


  public FoliageTransactionBlock filterHash(String filterHash) {
    
    this.filterHash = filterHash;
    return this;
  }

   /**
   * Get filterHash
   * @return filterHash
  **/
  @javax.annotation.Nullable

  public String getFilterHash() {
    return filterHash;
  }


  public void setFilterHash(String filterHash) {
    this.filterHash = filterHash;
  }


  public FoliageTransactionBlock additionsRoot(String additionsRoot) {
    
    this.additionsRoot = additionsRoot;
    return this;
  }

   /**
   * Get additionsRoot
   * @return additionsRoot
  **/
  @javax.annotation.Nullable

  public String getAdditionsRoot() {
    return additionsRoot;
  }


  public void setAdditionsRoot(String additionsRoot) {
    this.additionsRoot = additionsRoot;
  }


  public FoliageTransactionBlock removalsRoot(String removalsRoot) {
    
    this.removalsRoot = removalsRoot;
    return this;
  }

   /**
   * Get removalsRoot
   * @return removalsRoot
  **/
  @javax.annotation.Nullable

  public String getRemovalsRoot() {
    return removalsRoot;
  }


  public void setRemovalsRoot(String removalsRoot) {
    this.removalsRoot = removalsRoot;
  }


  public FoliageTransactionBlock transactionsInfoHash(String transactionsInfoHash) {
    
    this.transactionsInfoHash = transactionsInfoHash;
    return this;
  }

   /**
   * Get transactionsInfoHash
   * @return transactionsInfoHash
  **/
  @javax.annotation.Nullable

  public String getTransactionsInfoHash() {
    return transactionsInfoHash;
  }


  public void setTransactionsInfoHash(String transactionsInfoHash) {
    this.transactionsInfoHash = transactionsInfoHash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FoliageTransactionBlock foliageTransactionBlock = (FoliageTransactionBlock) o;
    return Objects.equals(this.prevTransactionBlockHash, foliageTransactionBlock.prevTransactionBlockHash) &&
        Objects.equals(this.timestamp, foliageTransactionBlock.timestamp) &&
        Objects.equals(this.filterHash, foliageTransactionBlock.filterHash) &&
        Objects.equals(this.additionsRoot, foliageTransactionBlock.additionsRoot) &&
        Objects.equals(this.removalsRoot, foliageTransactionBlock.removalsRoot) &&
        Objects.equals(this.transactionsInfoHash, foliageTransactionBlock.transactionsInfoHash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(prevTransactionBlockHash, timestamp, filterHash, additionsRoot, removalsRoot, transactionsInfoHash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FoliageTransactionBlock {\n");
    sb.append("    prevTransactionBlockHash: ").append(toIndentedString(prevTransactionBlockHash)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("    filterHash: ").append(toIndentedString(filterHash)).append("\n");
    sb.append("    additionsRoot: ").append(toIndentedString(additionsRoot)).append("\n");
    sb.append("    removalsRoot: ").append(toIndentedString(removalsRoot)).append("\n");
    sb.append("    transactionsInfoHash: ").append(toIndentedString(transactionsInfoHash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("prev_transaction_block_hash");
    openapiFields.add("timestamp");
    openapiFields.add("filter_hash");
    openapiFields.add("additions_root");
    openapiFields.add("removals_root");
    openapiFields.add("transactions_info_hash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to FoliageTransactionBlock
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!FoliageTransactionBlock.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in FoliageTransactionBlock is not found in the empty JSON string", FoliageTransactionBlock.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!FoliageTransactionBlock.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `FoliageTransactionBlock` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("prev_transaction_block_hash") != null && !jsonObj.get("prev_transaction_block_hash").isJsonNull()) && !jsonObj.get("prev_transaction_block_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `prev_transaction_block_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("prev_transaction_block_hash").toString()));
      }
      if ((jsonObj.get("filter_hash") != null && !jsonObj.get("filter_hash").isJsonNull()) && !jsonObj.get("filter_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `filter_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("filter_hash").toString()));
      }
      if ((jsonObj.get("additions_root") != null && !jsonObj.get("additions_root").isJsonNull()) && !jsonObj.get("additions_root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `additions_root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("additions_root").toString()));
      }
      if ((jsonObj.get("removals_root") != null && !jsonObj.get("removals_root").isJsonNull()) && !jsonObj.get("removals_root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `removals_root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("removals_root").toString()));
      }
      if ((jsonObj.get("transactions_info_hash") != null && !jsonObj.get("transactions_info_hash").isJsonNull()) && !jsonObj.get("transactions_info_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `transactions_info_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("transactions_info_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!FoliageTransactionBlock.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'FoliageTransactionBlock' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<FoliageTransactionBlock> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(FoliageTransactionBlock.class));

       return (TypeAdapter<T>) new TypeAdapter<FoliageTransactionBlock>() {
           @Override
           public void write(JsonWriter out, FoliageTransactionBlock value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public FoliageTransactionBlock read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of FoliageTransactionBlock given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of FoliageTransactionBlock
  * @throws IOException if the JSON string is invalid with respect to FoliageTransactionBlock
  */
  public static FoliageTransactionBlock fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, FoliageTransactionBlock.class);
  }

 /**
  * Convert an instance of FoliageTransactionBlock to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

