/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.EndOfSubSlotBundle;
import org.openapitools.client.model.Foliage;
import org.openapitools.client.model.FoliageTransactionBlock;
import org.openapitools.client.model.RewardChainBlock;
import org.openapitools.client.model.TransactionsInfo;
import org.openapitools.client.model.VdfProof;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * FullBlock
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class FullBlock {
  public static final String SERIALIZED_NAME_FINISHED_SUB_SLOTS = "finished_sub_slots";
  @SerializedName(SERIALIZED_NAME_FINISHED_SUB_SLOTS)
  private List<EndOfSubSlotBundle> finishedSubSlots;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_BLOCK = "reward_chain_block";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_BLOCK)
  private RewardChainBlock rewardChainBlock;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_PROOF = "challenge_chain_sp_proof";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_PROOF)
  private VdfProof challengeChainSpProof;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_IP_PROOF = "challenge_chain_ip_proof";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_IP_PROOF)
  private VdfProof challengeChainIpProof;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_PROOF = "reward_chain_sp_proof";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_PROOF)
  private VdfProof rewardChainSpProof;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_IP_PROOF = "reward_chain_ip_proof";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_IP_PROOF)
  private VdfProof rewardChainIpProof;

  public static final String SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_IP_PROOF = "infused_challenge_chain_ip_proof";
  @SerializedName(SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_IP_PROOF)
  private VdfProof infusedChallengeChainIpProof;

  public static final String SERIALIZED_NAME_FOLIAGE = "foliage";
  @SerializedName(SERIALIZED_NAME_FOLIAGE)
  private Foliage foliage;

  public static final String SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK = "foliage_transaction_block";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK)
  private FoliageTransactionBlock foliageTransactionBlock;

  public static final String SERIALIZED_NAME_TRANSACTIONS_INFO = "transactions_info";
  @SerializedName(SERIALIZED_NAME_TRANSACTIONS_INFO)
  private TransactionsInfo transactionsInfo;

  public static final String SERIALIZED_NAME_TRANSACTIONS_GENERATOR = "transactions_generator";
  @SerializedName(SERIALIZED_NAME_TRANSACTIONS_GENERATOR)
  private String transactionsGenerator;

  public static final String SERIALIZED_NAME_TRANSACTIONS_GENERATOR_REF_LIST = "transactions_generator_ref_list";
  @SerializedName(SERIALIZED_NAME_TRANSACTIONS_GENERATOR_REF_LIST)
  private List<Integer> transactionsGeneratorRefList;

  public static final String SERIALIZED_NAME_HEADER_HASH = "header_hash";
  @SerializedName(SERIALIZED_NAME_HEADER_HASH)
  private String headerHash;

  public static final String SERIALIZED_NAME_IS_TRANSACTION_BLOCK = "is_transaction_block";
  @SerializedName(SERIALIZED_NAME_IS_TRANSACTION_BLOCK)
  private Boolean isTransactionBlock;

  public FullBlock() {
  }

  public FullBlock finishedSubSlots(List<EndOfSubSlotBundle> finishedSubSlots) {
    
    this.finishedSubSlots = finishedSubSlots;
    return this;
  }

  public FullBlock addFinishedSubSlotsItem(EndOfSubSlotBundle finishedSubSlotsItem) {
    if (this.finishedSubSlots == null) {
      this.finishedSubSlots = new ArrayList<>();
    }
    this.finishedSubSlots.add(finishedSubSlotsItem);
    return this;
  }

   /**
   * Get finishedSubSlots
   * @return finishedSubSlots
  **/
  @javax.annotation.Nullable

  public List<EndOfSubSlotBundle> getFinishedSubSlots() {
    return finishedSubSlots;
  }


  public void setFinishedSubSlots(List<EndOfSubSlotBundle> finishedSubSlots) {
    this.finishedSubSlots = finishedSubSlots;
  }


  public FullBlock rewardChainBlock(RewardChainBlock rewardChainBlock) {
    
    this.rewardChainBlock = rewardChainBlock;
    return this;
  }

   /**
   * Get rewardChainBlock
   * @return rewardChainBlock
  **/
  @javax.annotation.Nullable

  public RewardChainBlock getRewardChainBlock() {
    return rewardChainBlock;
  }


  public void setRewardChainBlock(RewardChainBlock rewardChainBlock) {
    this.rewardChainBlock = rewardChainBlock;
  }


  public FullBlock challengeChainSpProof(VdfProof challengeChainSpProof) {
    
    this.challengeChainSpProof = challengeChainSpProof;
    return this;
  }

   /**
   * Get challengeChainSpProof
   * @return challengeChainSpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getChallengeChainSpProof() {
    return challengeChainSpProof;
  }


  public void setChallengeChainSpProof(VdfProof challengeChainSpProof) {
    this.challengeChainSpProof = challengeChainSpProof;
  }


  public FullBlock challengeChainIpProof(VdfProof challengeChainIpProof) {
    
    this.challengeChainIpProof = challengeChainIpProof;
    return this;
  }

   /**
   * Get challengeChainIpProof
   * @return challengeChainIpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getChallengeChainIpProof() {
    return challengeChainIpProof;
  }


  public void setChallengeChainIpProof(VdfProof challengeChainIpProof) {
    this.challengeChainIpProof = challengeChainIpProof;
  }


  public FullBlock rewardChainSpProof(VdfProof rewardChainSpProof) {
    
    this.rewardChainSpProof = rewardChainSpProof;
    return this;
  }

   /**
   * Get rewardChainSpProof
   * @return rewardChainSpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getRewardChainSpProof() {
    return rewardChainSpProof;
  }


  public void setRewardChainSpProof(VdfProof rewardChainSpProof) {
    this.rewardChainSpProof = rewardChainSpProof;
  }


  public FullBlock rewardChainIpProof(VdfProof rewardChainIpProof) {
    
    this.rewardChainIpProof = rewardChainIpProof;
    return this;
  }

   /**
   * Get rewardChainIpProof
   * @return rewardChainIpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getRewardChainIpProof() {
    return rewardChainIpProof;
  }


  public void setRewardChainIpProof(VdfProof rewardChainIpProof) {
    this.rewardChainIpProof = rewardChainIpProof;
  }


  public FullBlock infusedChallengeChainIpProof(VdfProof infusedChallengeChainIpProof) {
    
    this.infusedChallengeChainIpProof = infusedChallengeChainIpProof;
    return this;
  }

   /**
   * Get infusedChallengeChainIpProof
   * @return infusedChallengeChainIpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getInfusedChallengeChainIpProof() {
    return infusedChallengeChainIpProof;
  }


  public void setInfusedChallengeChainIpProof(VdfProof infusedChallengeChainIpProof) {
    this.infusedChallengeChainIpProof = infusedChallengeChainIpProof;
  }


  public FullBlock foliage(Foliage foliage) {
    
    this.foliage = foliage;
    return this;
  }

   /**
   * Get foliage
   * @return foliage
  **/
  @javax.annotation.Nullable

  public Foliage getFoliage() {
    return foliage;
  }


  public void setFoliage(Foliage foliage) {
    this.foliage = foliage;
  }


  public FullBlock foliageTransactionBlock(FoliageTransactionBlock foliageTransactionBlock) {
    
    this.foliageTransactionBlock = foliageTransactionBlock;
    return this;
  }

   /**
   * Get foliageTransactionBlock
   * @return foliageTransactionBlock
  **/
  @javax.annotation.Nullable

  public FoliageTransactionBlock getFoliageTransactionBlock() {
    return foliageTransactionBlock;
  }


  public void setFoliageTransactionBlock(FoliageTransactionBlock foliageTransactionBlock) {
    this.foliageTransactionBlock = foliageTransactionBlock;
  }


  public FullBlock transactionsInfo(TransactionsInfo transactionsInfo) {
    
    this.transactionsInfo = transactionsInfo;
    return this;
  }

   /**
   * Get transactionsInfo
   * @return transactionsInfo
  **/
  @javax.annotation.Nullable

  public TransactionsInfo getTransactionsInfo() {
    return transactionsInfo;
  }


  public void setTransactionsInfo(TransactionsInfo transactionsInfo) {
    this.transactionsInfo = transactionsInfo;
  }


  public FullBlock transactionsGenerator(String transactionsGenerator) {
    
    this.transactionsGenerator = transactionsGenerator;
    return this;
  }

   /**
   * Get transactionsGenerator
   * @return transactionsGenerator
  **/
  @javax.annotation.Nullable

  public String getTransactionsGenerator() {
    return transactionsGenerator;
  }


  public void setTransactionsGenerator(String transactionsGenerator) {
    this.transactionsGenerator = transactionsGenerator;
  }


  public FullBlock transactionsGeneratorRefList(List<Integer> transactionsGeneratorRefList) {
    
    this.transactionsGeneratorRefList = transactionsGeneratorRefList;
    return this;
  }

  public FullBlock addTransactionsGeneratorRefListItem(Integer transactionsGeneratorRefListItem) {
    if (this.transactionsGeneratorRefList == null) {
      this.transactionsGeneratorRefList = new ArrayList<>();
    }
    this.transactionsGeneratorRefList.add(transactionsGeneratorRefListItem);
    return this;
  }

   /**
   * Get transactionsGeneratorRefList
   * @return transactionsGeneratorRefList
  **/
  @javax.annotation.Nullable

  public List<Integer> getTransactionsGeneratorRefList() {
    return transactionsGeneratorRefList;
  }


  public void setTransactionsGeneratorRefList(List<Integer> transactionsGeneratorRefList) {
    this.transactionsGeneratorRefList = transactionsGeneratorRefList;
  }


  public FullBlock headerHash(String headerHash) {
    
    this.headerHash = headerHash;
    return this;
  }

   /**
   * Get headerHash
   * @return headerHash
  **/
  @javax.annotation.Nullable

  public String getHeaderHash() {
    return headerHash;
  }


  public void setHeaderHash(String headerHash) {
    this.headerHash = headerHash;
  }


  public FullBlock isTransactionBlock(Boolean isTransactionBlock) {
    
    this.isTransactionBlock = isTransactionBlock;
    return this;
  }

   /**
   * Get isTransactionBlock
   * @return isTransactionBlock
  **/
  @javax.annotation.Nullable

  public Boolean getIsTransactionBlock() {
    return isTransactionBlock;
  }


  public void setIsTransactionBlock(Boolean isTransactionBlock) {
    this.isTransactionBlock = isTransactionBlock;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FullBlock fullBlock = (FullBlock) o;
    return Objects.equals(this.finishedSubSlots, fullBlock.finishedSubSlots) &&
        Objects.equals(this.rewardChainBlock, fullBlock.rewardChainBlock) &&
        Objects.equals(this.challengeChainSpProof, fullBlock.challengeChainSpProof) &&
        Objects.equals(this.challengeChainIpProof, fullBlock.challengeChainIpProof) &&
        Objects.equals(this.rewardChainSpProof, fullBlock.rewardChainSpProof) &&
        Objects.equals(this.rewardChainIpProof, fullBlock.rewardChainIpProof) &&
        Objects.equals(this.infusedChallengeChainIpProof, fullBlock.infusedChallengeChainIpProof) &&
        Objects.equals(this.foliage, fullBlock.foliage) &&
        Objects.equals(this.foliageTransactionBlock, fullBlock.foliageTransactionBlock) &&
        Objects.equals(this.transactionsInfo, fullBlock.transactionsInfo) &&
        Objects.equals(this.transactionsGenerator, fullBlock.transactionsGenerator) &&
        Objects.equals(this.transactionsGeneratorRefList, fullBlock.transactionsGeneratorRefList) &&
        Objects.equals(this.headerHash, fullBlock.headerHash) &&
        Objects.equals(this.isTransactionBlock, fullBlock.isTransactionBlock);
  }

  @Override
  public int hashCode() {
    return Objects.hash(finishedSubSlots, rewardChainBlock, challengeChainSpProof, challengeChainIpProof, rewardChainSpProof, rewardChainIpProof, infusedChallengeChainIpProof, foliage, foliageTransactionBlock, transactionsInfo, transactionsGenerator, transactionsGeneratorRefList, headerHash, isTransactionBlock);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FullBlock {\n");
    sb.append("    finishedSubSlots: ").append(toIndentedString(finishedSubSlots)).append("\n");
    sb.append("    rewardChainBlock: ").append(toIndentedString(rewardChainBlock)).append("\n");
    sb.append("    challengeChainSpProof: ").append(toIndentedString(challengeChainSpProof)).append("\n");
    sb.append("    challengeChainIpProof: ").append(toIndentedString(challengeChainIpProof)).append("\n");
    sb.append("    rewardChainSpProof: ").append(toIndentedString(rewardChainSpProof)).append("\n");
    sb.append("    rewardChainIpProof: ").append(toIndentedString(rewardChainIpProof)).append("\n");
    sb.append("    infusedChallengeChainIpProof: ").append(toIndentedString(infusedChallengeChainIpProof)).append("\n");
    sb.append("    foliage: ").append(toIndentedString(foliage)).append("\n");
    sb.append("    foliageTransactionBlock: ").append(toIndentedString(foliageTransactionBlock)).append("\n");
    sb.append("    transactionsInfo: ").append(toIndentedString(transactionsInfo)).append("\n");
    sb.append("    transactionsGenerator: ").append(toIndentedString(transactionsGenerator)).append("\n");
    sb.append("    transactionsGeneratorRefList: ").append(toIndentedString(transactionsGeneratorRefList)).append("\n");
    sb.append("    headerHash: ").append(toIndentedString(headerHash)).append("\n");
    sb.append("    isTransactionBlock: ").append(toIndentedString(isTransactionBlock)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("finished_sub_slots");
    openapiFields.add("reward_chain_block");
    openapiFields.add("challenge_chain_sp_proof");
    openapiFields.add("challenge_chain_ip_proof");
    openapiFields.add("reward_chain_sp_proof");
    openapiFields.add("reward_chain_ip_proof");
    openapiFields.add("infused_challenge_chain_ip_proof");
    openapiFields.add("foliage");
    openapiFields.add("foliage_transaction_block");
    openapiFields.add("transactions_info");
    openapiFields.add("transactions_generator");
    openapiFields.add("transactions_generator_ref_list");
    openapiFields.add("header_hash");
    openapiFields.add("is_transaction_block");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to FullBlock
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!FullBlock.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in FullBlock is not found in the empty JSON string", FullBlock.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!FullBlock.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `FullBlock` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("finished_sub_slots") != null && !jsonObj.get("finished_sub_slots").isJsonNull()) {
        JsonArray jsonArrayfinishedSubSlots = jsonObj.getAsJsonArray("finished_sub_slots");
        if (jsonArrayfinishedSubSlots != null) {
          // ensure the json data is an array
          if (!jsonObj.get("finished_sub_slots").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `finished_sub_slots` to be an array in the JSON string but got `%s`", jsonObj.get("finished_sub_slots").toString()));
          }

          // validate the optional field `finished_sub_slots` (array)
          for (int i = 0; i < jsonArrayfinishedSubSlots.size(); i++) {
            EndOfSubSlotBundle.validateJsonObject(jsonArrayfinishedSubSlots.get(i).getAsJsonObject());
          };
        }
      }
      // validate the optional field `reward_chain_block`
      if (jsonObj.get("reward_chain_block") != null && !jsonObj.get("reward_chain_block").isJsonNull()) {
        RewardChainBlock.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_block"));
      }
      // validate the optional field `challenge_chain_sp_proof`
      if (jsonObj.get("challenge_chain_sp_proof") != null && !jsonObj.get("challenge_chain_sp_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_sp_proof"));
      }
      // validate the optional field `challenge_chain_ip_proof`
      if (jsonObj.get("challenge_chain_ip_proof") != null && !jsonObj.get("challenge_chain_ip_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_ip_proof"));
      }
      // validate the optional field `reward_chain_sp_proof`
      if (jsonObj.get("reward_chain_sp_proof") != null && !jsonObj.get("reward_chain_sp_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_sp_proof"));
      }
      // validate the optional field `reward_chain_ip_proof`
      if (jsonObj.get("reward_chain_ip_proof") != null && !jsonObj.get("reward_chain_ip_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_ip_proof"));
      }
      // validate the optional field `infused_challenge_chain_ip_proof`
      if (jsonObj.get("infused_challenge_chain_ip_proof") != null && !jsonObj.get("infused_challenge_chain_ip_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("infused_challenge_chain_ip_proof"));
      }
      // validate the optional field `foliage`
      if (jsonObj.get("foliage") != null && !jsonObj.get("foliage").isJsonNull()) {
        Foliage.validateJsonObject(jsonObj.getAsJsonObject("foliage"));
      }
      // validate the optional field `foliage_transaction_block`
      if (jsonObj.get("foliage_transaction_block") != null && !jsonObj.get("foliage_transaction_block").isJsonNull()) {
        FoliageTransactionBlock.validateJsonObject(jsonObj.getAsJsonObject("foliage_transaction_block"));
      }
      // validate the optional field `transactions_info`
      if (jsonObj.get("transactions_info") != null && !jsonObj.get("transactions_info").isJsonNull()) {
        TransactionsInfo.validateJsonObject(jsonObj.getAsJsonObject("transactions_info"));
      }
      if ((jsonObj.get("transactions_generator") != null && !jsonObj.get("transactions_generator").isJsonNull()) && !jsonObj.get("transactions_generator").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `transactions_generator` to be a primitive type in the JSON string but got `%s`", jsonObj.get("transactions_generator").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("transactions_generator_ref_list") != null && !jsonObj.get("transactions_generator_ref_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `transactions_generator_ref_list` to be an array in the JSON string but got `%s`", jsonObj.get("transactions_generator_ref_list").toString()));
      }
      if ((jsonObj.get("header_hash") != null && !jsonObj.get("header_hash").isJsonNull()) && !jsonObj.get("header_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `header_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("header_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!FullBlock.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'FullBlock' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<FullBlock> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(FullBlock.class));

       return (TypeAdapter<T>) new TypeAdapter<FullBlock>() {
           @Override
           public void write(JsonWriter out, FullBlock value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public FullBlock read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of FullBlock given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of FullBlock
  * @throws IOException if the JSON string is invalid with respect to FullBlock
  */
  public static FullBlock fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, FullBlock.class);
  }

 /**
  * Convert an instance of FullBlock to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

