/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.CoinRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetAdditionsAndRemovals200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetAdditionsAndRemovals200Response {
  public static final String SERIALIZED_NAME_ADDITIONS = "additions";
  @SerializedName(SERIALIZED_NAME_ADDITIONS)
  private List<CoinRecord> additions;

  public static final String SERIALIZED_NAME_REMOVALS = "removals";
  @SerializedName(SERIALIZED_NAME_REMOVALS)
  private List<CoinRecord> removals;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetAdditionsAndRemovals200Response() {
  }

  public GetAdditionsAndRemovals200Response additions(List<CoinRecord> additions) {
    
    this.additions = additions;
    return this;
  }

  public GetAdditionsAndRemovals200Response addAdditionsItem(CoinRecord additionsItem) {
    if (this.additions == null) {
      this.additions = new ArrayList<>();
    }
    this.additions.add(additionsItem);
    return this;
  }

   /**
   * Get additions
   * @return additions
  **/
  @javax.annotation.Nullable

  public List<CoinRecord> getAdditions() {
    return additions;
  }


  public void setAdditions(List<CoinRecord> additions) {
    this.additions = additions;
  }


  public GetAdditionsAndRemovals200Response removals(List<CoinRecord> removals) {
    
    this.removals = removals;
    return this;
  }

  public GetAdditionsAndRemovals200Response addRemovalsItem(CoinRecord removalsItem) {
    if (this.removals == null) {
      this.removals = new ArrayList<>();
    }
    this.removals.add(removalsItem);
    return this;
  }

   /**
   * Get removals
   * @return removals
  **/
  @javax.annotation.Nullable

  public List<CoinRecord> getRemovals() {
    return removals;
  }


  public void setRemovals(List<CoinRecord> removals) {
    this.removals = removals;
  }


  public GetAdditionsAndRemovals200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetAdditionsAndRemovals200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAdditionsAndRemovals200Response getAdditionsAndRemovals200Response = (GetAdditionsAndRemovals200Response) o;
    return Objects.equals(this.additions, getAdditionsAndRemovals200Response.additions) &&
        Objects.equals(this.removals, getAdditionsAndRemovals200Response.removals) &&
        Objects.equals(this.success, getAdditionsAndRemovals200Response.success) &&
        Objects.equals(this.error, getAdditionsAndRemovals200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(additions, removals, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAdditionsAndRemovals200Response {\n");
    sb.append("    additions: ").append(toIndentedString(additions)).append("\n");
    sb.append("    removals: ").append(toIndentedString(removals)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("additions");
    openapiFields.add("removals");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetAdditionsAndRemovals200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetAdditionsAndRemovals200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetAdditionsAndRemovals200Response is not found in the empty JSON string", GetAdditionsAndRemovals200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetAdditionsAndRemovals200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetAdditionsAndRemovals200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetAdditionsAndRemovals200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (jsonObj.get("additions") != null && !jsonObj.get("additions").isJsonNull()) {
        JsonArray jsonArrayadditions = jsonObj.getAsJsonArray("additions");
        if (jsonArrayadditions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("additions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `additions` to be an array in the JSON string but got `%s`", jsonObj.get("additions").toString()));
          }

          // validate the optional field `additions` (array)
          for (int i = 0; i < jsonArrayadditions.size(); i++) {
            CoinRecord.validateJsonObject(jsonArrayadditions.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("removals") != null && !jsonObj.get("removals").isJsonNull()) {
        JsonArray jsonArrayremovals = jsonObj.getAsJsonArray("removals");
        if (jsonArrayremovals != null) {
          // ensure the json data is an array
          if (!jsonObj.get("removals").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `removals` to be an array in the JSON string but got `%s`", jsonObj.get("removals").toString()));
          }

          // validate the optional field `removals` (array)
          for (int i = 0; i < jsonArrayremovals.size(); i++) {
            CoinRecord.validateJsonObject(jsonArrayremovals.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetAdditionsAndRemovals200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetAdditionsAndRemovals200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetAdditionsAndRemovals200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetAdditionsAndRemovals200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetAdditionsAndRemovals200Response>() {
           @Override
           public void write(JsonWriter out, GetAdditionsAndRemovals200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetAdditionsAndRemovals200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetAdditionsAndRemovals200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetAdditionsAndRemovals200Response
  * @throws IOException if the JSON string is invalid with respect to GetAdditionsAndRemovals200Response
  */
  public static GetAdditionsAndRemovals200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetAdditionsAndRemovals200Response.class);
  }

 /**
  * Convert an instance of GetAdditionsAndRemovals200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

