/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import org.openapitools.client.model.MempoolItem;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetAllMempoolItems200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetAllMempoolItems200ResponseAllOf {
  public static final String SERIALIZED_NAME_MEMPOOL_ITEMS = "mempool_items";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_ITEMS)
  private Map<String, MempoolItem> mempoolItems = new HashMap<>();

  public GetAllMempoolItems200ResponseAllOf() {
  }

  public GetAllMempoolItems200ResponseAllOf mempoolItems(Map<String, MempoolItem> mempoolItems) {
    
    this.mempoolItems = mempoolItems;
    return this;
  }

  public GetAllMempoolItems200ResponseAllOf putMempoolItemsItem(String key, MempoolItem mempoolItemsItem) {
    if (this.mempoolItems == null) {
      this.mempoolItems = new HashMap<>();
    }
    this.mempoolItems.put(key, mempoolItemsItem);
    return this;
  }

   /**
   * Get mempoolItems
   * @return mempoolItems
  **/
  @javax.annotation.Nullable

  public Map<String, MempoolItem> getMempoolItems() {
    return mempoolItems;
  }


  public void setMempoolItems(Map<String, MempoolItem> mempoolItems) {
    this.mempoolItems = mempoolItems;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAllMempoolItems200ResponseAllOf getAllMempoolItems200ResponseAllOf = (GetAllMempoolItems200ResponseAllOf) o;
    return Objects.equals(this.mempoolItems, getAllMempoolItems200ResponseAllOf.mempoolItems);
  }

  @Override
  public int hashCode() {
    return Objects.hash(mempoolItems);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAllMempoolItems200ResponseAllOf {\n");
    sb.append("    mempoolItems: ").append(toIndentedString(mempoolItems)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("mempool_items");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetAllMempoolItems200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetAllMempoolItems200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetAllMempoolItems200ResponseAllOf is not found in the empty JSON string", GetAllMempoolItems200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetAllMempoolItems200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetAllMempoolItems200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetAllMempoolItems200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetAllMempoolItems200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetAllMempoolItems200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetAllMempoolItems200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetAllMempoolItems200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetAllMempoolItems200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetAllMempoolItems200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetAllMempoolItems200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetAllMempoolItems200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetAllMempoolItems200ResponseAllOf
  */
  public static GetAllMempoolItems200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetAllMempoolItems200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetAllMempoolItems200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

