/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetBlockCountMetrics200ResponseAllOfMetrics
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetBlockCountMetrics200ResponseAllOfMetrics {
  public static final String SERIALIZED_NAME_COMPACT_BLOCKS = "compact_blocks";
  @SerializedName(SERIALIZED_NAME_COMPACT_BLOCKS)
  private Integer compactBlocks;

  public static final String SERIALIZED_NAME_UNCOMPACT_BLOCKS = "uncompact_blocks";
  @SerializedName(SERIALIZED_NAME_UNCOMPACT_BLOCKS)
  private Integer uncompactBlocks;

  public static final String SERIALIZED_NAME_HINT_COUNT = "hint_count";
  @SerializedName(SERIALIZED_NAME_HINT_COUNT)
  private Integer hintCount;

  public GetBlockCountMetrics200ResponseAllOfMetrics() {
  }

  public GetBlockCountMetrics200ResponseAllOfMetrics compactBlocks(Integer compactBlocks) {
    
    this.compactBlocks = compactBlocks;
    return this;
  }

   /**
   * Get compactBlocks
   * @return compactBlocks
  **/
  @javax.annotation.Nullable

  public Integer getCompactBlocks() {
    return compactBlocks;
  }


  public void setCompactBlocks(Integer compactBlocks) {
    this.compactBlocks = compactBlocks;
  }


  public GetBlockCountMetrics200ResponseAllOfMetrics uncompactBlocks(Integer uncompactBlocks) {
    
    this.uncompactBlocks = uncompactBlocks;
    return this;
  }

   /**
   * Get uncompactBlocks
   * @return uncompactBlocks
  **/
  @javax.annotation.Nullable

  public Integer getUncompactBlocks() {
    return uncompactBlocks;
  }


  public void setUncompactBlocks(Integer uncompactBlocks) {
    this.uncompactBlocks = uncompactBlocks;
  }


  public GetBlockCountMetrics200ResponseAllOfMetrics hintCount(Integer hintCount) {
    
    this.hintCount = hintCount;
    return this;
  }

   /**
   * Get hintCount
   * @return hintCount
  **/
  @javax.annotation.Nullable

  public Integer getHintCount() {
    return hintCount;
  }


  public void setHintCount(Integer hintCount) {
    this.hintCount = hintCount;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetBlockCountMetrics200ResponseAllOfMetrics getBlockCountMetrics200ResponseAllOfMetrics = (GetBlockCountMetrics200ResponseAllOfMetrics) o;
    return Objects.equals(this.compactBlocks, getBlockCountMetrics200ResponseAllOfMetrics.compactBlocks) &&
        Objects.equals(this.uncompactBlocks, getBlockCountMetrics200ResponseAllOfMetrics.uncompactBlocks) &&
        Objects.equals(this.hintCount, getBlockCountMetrics200ResponseAllOfMetrics.hintCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(compactBlocks, uncompactBlocks, hintCount);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetBlockCountMetrics200ResponseAllOfMetrics {\n");
    sb.append("    compactBlocks: ").append(toIndentedString(compactBlocks)).append("\n");
    sb.append("    uncompactBlocks: ").append(toIndentedString(uncompactBlocks)).append("\n");
    sb.append("    hintCount: ").append(toIndentedString(hintCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("compact_blocks");
    openapiFields.add("uncompact_blocks");
    openapiFields.add("hint_count");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetBlockCountMetrics200ResponseAllOfMetrics
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetBlockCountMetrics200ResponseAllOfMetrics.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetBlockCountMetrics200ResponseAllOfMetrics is not found in the empty JSON string", GetBlockCountMetrics200ResponseAllOfMetrics.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetBlockCountMetrics200ResponseAllOfMetrics.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetBlockCountMetrics200ResponseAllOfMetrics` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetBlockCountMetrics200ResponseAllOfMetrics.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetBlockCountMetrics200ResponseAllOfMetrics' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetBlockCountMetrics200ResponseAllOfMetrics> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetBlockCountMetrics200ResponseAllOfMetrics.class));

       return (TypeAdapter<T>) new TypeAdapter<GetBlockCountMetrics200ResponseAllOfMetrics>() {
           @Override
           public void write(JsonWriter out, GetBlockCountMetrics200ResponseAllOfMetrics value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetBlockCountMetrics200ResponseAllOfMetrics read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetBlockCountMetrics200ResponseAllOfMetrics given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetBlockCountMetrics200ResponseAllOfMetrics
  * @throws IOException if the JSON string is invalid with respect to GetBlockCountMetrics200ResponseAllOfMetrics
  */
  public static GetBlockCountMetrics200ResponseAllOfMetrics fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetBlockCountMetrics200ResponseAllOfMetrics.class);
  }

 /**
  * Convert an instance of GetBlockCountMetrics200ResponseAllOfMetrics to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

