/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetBlocksRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetBlocksRequest {
  public static final String SERIALIZED_NAME_START = "start";
  @SerializedName(SERIALIZED_NAME_START)
  private Integer start;

  public static final String SERIALIZED_NAME_END = "end";
  @SerializedName(SERIALIZED_NAME_END)
  private Integer end;

  public static final String SERIALIZED_NAME_EXCLUDE_HEADER_HASH = "exclude_header_hash";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_HEADER_HASH)
  private Boolean excludeHeaderHash = false;

  public static final String SERIALIZED_NAME_EXCLUDE_REORGED = "exclude_reorged";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_REORGED)
  private Boolean excludeReorged = false;

  public GetBlocksRequest() {
  }

  public GetBlocksRequest start(Integer start) {
    
    this.start = start;
    return this;
  }

   /**
   * Get start
   * @return start
  **/
  @javax.annotation.Nonnull

  public Integer getStart() {
    return start;
  }


  public void setStart(Integer start) {
    this.start = start;
  }


  public GetBlocksRequest end(Integer end) {
    
    this.end = end;
    return this;
  }

   /**
   * Get end
   * @return end
  **/
  @javax.annotation.Nonnull

  public Integer getEnd() {
    return end;
  }


  public void setEnd(Integer end) {
    this.end = end;
  }


  public GetBlocksRequest excludeHeaderHash(Boolean excludeHeaderHash) {
    
    this.excludeHeaderHash = excludeHeaderHash;
    return this;
  }

   /**
   * Get excludeHeaderHash
   * @return excludeHeaderHash
  **/
  @javax.annotation.Nullable

  public Boolean getExcludeHeaderHash() {
    return excludeHeaderHash;
  }


  public void setExcludeHeaderHash(Boolean excludeHeaderHash) {
    this.excludeHeaderHash = excludeHeaderHash;
  }


  public GetBlocksRequest excludeReorged(Boolean excludeReorged) {
    
    this.excludeReorged = excludeReorged;
    return this;
  }

   /**
   * Get excludeReorged
   * @return excludeReorged
  **/
  @javax.annotation.Nullable

  public Boolean getExcludeReorged() {
    return excludeReorged;
  }


  public void setExcludeReorged(Boolean excludeReorged) {
    this.excludeReorged = excludeReorged;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetBlocksRequest getBlocksRequest = (GetBlocksRequest) o;
    return Objects.equals(this.start, getBlocksRequest.start) &&
        Objects.equals(this.end, getBlocksRequest.end) &&
        Objects.equals(this.excludeHeaderHash, getBlocksRequest.excludeHeaderHash) &&
        Objects.equals(this.excludeReorged, getBlocksRequest.excludeReorged);
  }

  @Override
  public int hashCode() {
    return Objects.hash(start, end, excludeHeaderHash, excludeReorged);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetBlocksRequest {\n");
    sb.append("    start: ").append(toIndentedString(start)).append("\n");
    sb.append("    end: ").append(toIndentedString(end)).append("\n");
    sb.append("    excludeHeaderHash: ").append(toIndentedString(excludeHeaderHash)).append("\n");
    sb.append("    excludeReorged: ").append(toIndentedString(excludeReorged)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("start");
    openapiFields.add("end");
    openapiFields.add("exclude_header_hash");
    openapiFields.add("exclude_reorged");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("start");
    openapiRequiredFields.add("end");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetBlocksRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetBlocksRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetBlocksRequest is not found in the empty JSON string", GetBlocksRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetBlocksRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetBlocksRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetBlocksRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetBlocksRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetBlocksRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetBlocksRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetBlocksRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetBlocksRequest>() {
           @Override
           public void write(JsonWriter out, GetBlocksRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetBlocksRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetBlocksRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetBlocksRequest
  * @throws IOException if the JSON string is invalid with respect to GetBlocksRequest
  */
  public static GetBlocksRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetBlocksRequest.class);
  }

 /**
  * Convert an instance of GetBlocksRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

