/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetCoinRecordsByHintRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetCoinRecordsByHintRequest {
  public static final String SERIALIZED_NAME_HINT = "hint";
  @SerializedName(SERIALIZED_NAME_HINT)
  private String hint;

  public static final String SERIALIZED_NAME_START_HEIGHT = "start_height";
  @SerializedName(SERIALIZED_NAME_START_HEIGHT)
  private Integer startHeight;

  public static final String SERIALIZED_NAME_END_HEIGHT = "end_height";
  @SerializedName(SERIALIZED_NAME_END_HEIGHT)
  private Integer endHeight;

  public static final String SERIALIZED_NAME_INCLUDE_SPENT_COINS = "include_spent_coins";
  @SerializedName(SERIALIZED_NAME_INCLUDE_SPENT_COINS)
  private Boolean includeSpentCoins;

  public GetCoinRecordsByHintRequest() {
  }

  public GetCoinRecordsByHintRequest hint(String hint) {
    
    this.hint = hint;
    return this;
  }

   /**
   * Get hint
   * @return hint
  **/
  @javax.annotation.Nonnull

  public String getHint() {
    return hint;
  }


  public void setHint(String hint) {
    this.hint = hint;
  }


  public GetCoinRecordsByHintRequest startHeight(Integer startHeight) {
    
    this.startHeight = startHeight;
    return this;
  }

   /**
   * Get startHeight
   * @return startHeight
  **/
  @javax.annotation.Nullable

  public Integer getStartHeight() {
    return startHeight;
  }


  public void setStartHeight(Integer startHeight) {
    this.startHeight = startHeight;
  }


  public GetCoinRecordsByHintRequest endHeight(Integer endHeight) {
    
    this.endHeight = endHeight;
    return this;
  }

   /**
   * Get endHeight
   * @return endHeight
  **/
  @javax.annotation.Nullable

  public Integer getEndHeight() {
    return endHeight;
  }


  public void setEndHeight(Integer endHeight) {
    this.endHeight = endHeight;
  }


  public GetCoinRecordsByHintRequest includeSpentCoins(Boolean includeSpentCoins) {
    
    this.includeSpentCoins = includeSpentCoins;
    return this;
  }

   /**
   * Get includeSpentCoins
   * @return includeSpentCoins
  **/
  @javax.annotation.Nullable

  public Boolean getIncludeSpentCoins() {
    return includeSpentCoins;
  }


  public void setIncludeSpentCoins(Boolean includeSpentCoins) {
    this.includeSpentCoins = includeSpentCoins;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetCoinRecordsByHintRequest getCoinRecordsByHintRequest = (GetCoinRecordsByHintRequest) o;
    return Objects.equals(this.hint, getCoinRecordsByHintRequest.hint) &&
        Objects.equals(this.startHeight, getCoinRecordsByHintRequest.startHeight) &&
        Objects.equals(this.endHeight, getCoinRecordsByHintRequest.endHeight) &&
        Objects.equals(this.includeSpentCoins, getCoinRecordsByHintRequest.includeSpentCoins);
  }

  @Override
  public int hashCode() {
    return Objects.hash(hint, startHeight, endHeight, includeSpentCoins);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetCoinRecordsByHintRequest {\n");
    sb.append("    hint: ").append(toIndentedString(hint)).append("\n");
    sb.append("    startHeight: ").append(toIndentedString(startHeight)).append("\n");
    sb.append("    endHeight: ").append(toIndentedString(endHeight)).append("\n");
    sb.append("    includeSpentCoins: ").append(toIndentedString(includeSpentCoins)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("hint");
    openapiFields.add("start_height");
    openapiFields.add("end_height");
    openapiFields.add("include_spent_coins");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("hint");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetCoinRecordsByHintRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetCoinRecordsByHintRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetCoinRecordsByHintRequest is not found in the empty JSON string", GetCoinRecordsByHintRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetCoinRecordsByHintRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetCoinRecordsByHintRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetCoinRecordsByHintRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("hint").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `hint` to be a primitive type in the JSON string but got `%s`", jsonObj.get("hint").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetCoinRecordsByHintRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetCoinRecordsByHintRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetCoinRecordsByHintRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetCoinRecordsByHintRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetCoinRecordsByHintRequest>() {
           @Override
           public void write(JsonWriter out, GetCoinRecordsByHintRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetCoinRecordsByHintRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetCoinRecordsByHintRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetCoinRecordsByHintRequest
  * @throws IOException if the JSON string is invalid with respect to GetCoinRecordsByHintRequest
  */
  public static GetCoinRecordsByHintRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetCoinRecordsByHintRequest.class);
  }

 /**
  * Convert an instance of GetCoinRecordsByHintRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

