/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetCoinRecordsByParentIdsRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetCoinRecordsByParentIdsRequest {
  public static final String SERIALIZED_NAME_PARENT_IDS = "parent_ids";
  @SerializedName(SERIALIZED_NAME_PARENT_IDS)
  private List<String> parentIds = new ArrayList<>();

  public static final String SERIALIZED_NAME_START_HEIGHT = "start_height";
  @SerializedName(SERIALIZED_NAME_START_HEIGHT)
  private Integer startHeight;

  public static final String SERIALIZED_NAME_END_HEIGHT = "end_height";
  @SerializedName(SERIALIZED_NAME_END_HEIGHT)
  private Integer endHeight;

  public static final String SERIALIZED_NAME_INCLUDE_SPENT_COINS = "include_spent_coins";
  @SerializedName(SERIALIZED_NAME_INCLUDE_SPENT_COINS)
  private Boolean includeSpentCoins;

  public GetCoinRecordsByParentIdsRequest() {
  }

  public GetCoinRecordsByParentIdsRequest parentIds(List<String> parentIds) {
    
    this.parentIds = parentIds;
    return this;
  }

  public GetCoinRecordsByParentIdsRequest addParentIdsItem(String parentIdsItem) {
    if (this.parentIds == null) {
      this.parentIds = new ArrayList<>();
    }
    this.parentIds.add(parentIdsItem);
    return this;
  }

   /**
   * Get parentIds
   * @return parentIds
  **/
  @javax.annotation.Nonnull

  public List<String> getParentIds() {
    return parentIds;
  }


  public void setParentIds(List<String> parentIds) {
    this.parentIds = parentIds;
  }


  public GetCoinRecordsByParentIdsRequest startHeight(Integer startHeight) {
    
    this.startHeight = startHeight;
    return this;
  }

   /**
   * Get startHeight
   * @return startHeight
  **/
  @javax.annotation.Nullable

  public Integer getStartHeight() {
    return startHeight;
  }


  public void setStartHeight(Integer startHeight) {
    this.startHeight = startHeight;
  }


  public GetCoinRecordsByParentIdsRequest endHeight(Integer endHeight) {
    
    this.endHeight = endHeight;
    return this;
  }

   /**
   * Get endHeight
   * @return endHeight
  **/
  @javax.annotation.Nullable

  public Integer getEndHeight() {
    return endHeight;
  }


  public void setEndHeight(Integer endHeight) {
    this.endHeight = endHeight;
  }


  public GetCoinRecordsByParentIdsRequest includeSpentCoins(Boolean includeSpentCoins) {
    
    this.includeSpentCoins = includeSpentCoins;
    return this;
  }

   /**
   * Get includeSpentCoins
   * @return includeSpentCoins
  **/
  @javax.annotation.Nullable

  public Boolean getIncludeSpentCoins() {
    return includeSpentCoins;
  }


  public void setIncludeSpentCoins(Boolean includeSpentCoins) {
    this.includeSpentCoins = includeSpentCoins;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest = (GetCoinRecordsByParentIdsRequest) o;
    return Objects.equals(this.parentIds, getCoinRecordsByParentIdsRequest.parentIds) &&
        Objects.equals(this.startHeight, getCoinRecordsByParentIdsRequest.startHeight) &&
        Objects.equals(this.endHeight, getCoinRecordsByParentIdsRequest.endHeight) &&
        Objects.equals(this.includeSpentCoins, getCoinRecordsByParentIdsRequest.includeSpentCoins);
  }

  @Override
  public int hashCode() {
    return Objects.hash(parentIds, startHeight, endHeight, includeSpentCoins);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetCoinRecordsByParentIdsRequest {\n");
    sb.append("    parentIds: ").append(toIndentedString(parentIds)).append("\n");
    sb.append("    startHeight: ").append(toIndentedString(startHeight)).append("\n");
    sb.append("    endHeight: ").append(toIndentedString(endHeight)).append("\n");
    sb.append("    includeSpentCoins: ").append(toIndentedString(includeSpentCoins)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("parent_ids");
    openapiFields.add("start_height");
    openapiFields.add("end_height");
    openapiFields.add("include_spent_coins");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("parent_ids");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetCoinRecordsByParentIdsRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetCoinRecordsByParentIdsRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetCoinRecordsByParentIdsRequest is not found in the empty JSON string", GetCoinRecordsByParentIdsRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetCoinRecordsByParentIdsRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetCoinRecordsByParentIdsRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetCoinRecordsByParentIdsRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the required json array is present
      if (jsonObj.get("parent_ids") == null) {
        throw new IllegalArgumentException("Expected the field `linkedContent` to be an array in the JSON string but got `null`");
      } else if (!jsonObj.get("parent_ids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `parent_ids` to be an array in the JSON string but got `%s`", jsonObj.get("parent_ids").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetCoinRecordsByParentIdsRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetCoinRecordsByParentIdsRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetCoinRecordsByParentIdsRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetCoinRecordsByParentIdsRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetCoinRecordsByParentIdsRequest>() {
           @Override
           public void write(JsonWriter out, GetCoinRecordsByParentIdsRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetCoinRecordsByParentIdsRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetCoinRecordsByParentIdsRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetCoinRecordsByParentIdsRequest
  * @throws IOException if the JSON string is invalid with respect to GetCoinRecordsByParentIdsRequest
  */
  public static GetCoinRecordsByParentIdsRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetCoinRecordsByParentIdsRequest.class);
  }

 /**
  * Convert an instance of GetCoinRecordsByParentIdsRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

