/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetFeeEstimate200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetFeeEstimate200Response {
  public static final String SERIALIZED_NAME_ESTIMATES = "estimates";
  @SerializedName(SERIALIZED_NAME_ESTIMATES)
  private List<Integer> estimates;

  public static final String SERIALIZED_NAME_TARGET_TIMES = "target_times";
  @SerializedName(SERIALIZED_NAME_TARGET_TIMES)
  private List<Integer> targetTimes;

  public static final String SERIALIZED_NAME_CURRENT_FEE_RATE = "current_fee_rate";
  @SerializedName(SERIALIZED_NAME_CURRENT_FEE_RATE)
  private Integer currentFeeRate;

  public static final String SERIALIZED_NAME_MEMPOOL_SIZE = "mempool_size";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_SIZE)
  private Integer mempoolSize;

  public static final String SERIALIZED_NAME_MEMPOOL_FEES = "mempool_fees";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_FEES)
  private Integer mempoolFees;

  public static final String SERIALIZED_NAME_MEMPOOL_MAX_SIZE = "mempool_max_size";
  @SerializedName(SERIALIZED_NAME_MEMPOOL_MAX_SIZE)
  private Integer mempoolMaxSize;

  public static final String SERIALIZED_NAME_NUM_SPENDS = "num_spends";
  @SerializedName(SERIALIZED_NAME_NUM_SPENDS)
  private Integer numSpends;

  public static final String SERIALIZED_NAME_FULL_NODE_SYNCED = "full_node_synced";
  @SerializedName(SERIALIZED_NAME_FULL_NODE_SYNCED)
  private Boolean fullNodeSynced;

  public static final String SERIALIZED_NAME_PEAK_HEIGHT = "peak_height";
  @SerializedName(SERIALIZED_NAME_PEAK_HEIGHT)
  private Integer peakHeight;

  public static final String SERIALIZED_NAME_LAST_PEAK_TIMESTAMP = "last_peak_timestamp";
  @SerializedName(SERIALIZED_NAME_LAST_PEAK_TIMESTAMP)
  private Integer lastPeakTimestamp;

  public static final String SERIALIZED_NAME_LAST_BLOCK_COST = "last_block_cost";
  @SerializedName(SERIALIZED_NAME_LAST_BLOCK_COST)
  private Integer lastBlockCost;

  public static final String SERIALIZED_NAME_FEES_LAST_BLOCK = "fees_last_block";
  @SerializedName(SERIALIZED_NAME_FEES_LAST_BLOCK)
  private Integer feesLastBlock;

  public static final String SERIALIZED_NAME_FEE_RATE_LAST_BLOCK = "fee_rate_last_block";
  @SerializedName(SERIALIZED_NAME_FEE_RATE_LAST_BLOCK)
  private BigDecimal feeRateLastBlock;

  public static final String SERIALIZED_NAME_LAST_TX_BLOCK_HEIGHT = "last_tx_block_height";
  @SerializedName(SERIALIZED_NAME_LAST_TX_BLOCK_HEIGHT)
  private Integer lastTxBlockHeight;

  public static final String SERIALIZED_NAME_NODE_TIME_UTC = "node_time_utc";
  @SerializedName(SERIALIZED_NAME_NODE_TIME_UTC)
  private Integer nodeTimeUtc;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetFeeEstimate200Response() {
  }

  public GetFeeEstimate200Response estimates(List<Integer> estimates) {
    
    this.estimates = estimates;
    return this;
  }

  public GetFeeEstimate200Response addEstimatesItem(Integer estimatesItem) {
    if (this.estimates == null) {
      this.estimates = new ArrayList<>();
    }
    this.estimates.add(estimatesItem);
    return this;
  }

   /**
   * Get estimates
   * @return estimates
  **/
  @javax.annotation.Nullable

  public List<Integer> getEstimates() {
    return estimates;
  }


  public void setEstimates(List<Integer> estimates) {
    this.estimates = estimates;
  }


  public GetFeeEstimate200Response targetTimes(List<Integer> targetTimes) {
    
    this.targetTimes = targetTimes;
    return this;
  }

  public GetFeeEstimate200Response addTargetTimesItem(Integer targetTimesItem) {
    if (this.targetTimes == null) {
      this.targetTimes = new ArrayList<>();
    }
    this.targetTimes.add(targetTimesItem);
    return this;
  }

   /**
   * Get targetTimes
   * @return targetTimes
  **/
  @javax.annotation.Nullable

  public List<Integer> getTargetTimes() {
    return targetTimes;
  }


  public void setTargetTimes(List<Integer> targetTimes) {
    this.targetTimes = targetTimes;
  }


  public GetFeeEstimate200Response currentFeeRate(Integer currentFeeRate) {
    
    this.currentFeeRate = currentFeeRate;
    return this;
  }

   /**
   * Get currentFeeRate
   * @return currentFeeRate
  **/
  @javax.annotation.Nullable

  public Integer getCurrentFeeRate() {
    return currentFeeRate;
  }


  public void setCurrentFeeRate(Integer currentFeeRate) {
    this.currentFeeRate = currentFeeRate;
  }


  public GetFeeEstimate200Response mempoolSize(Integer mempoolSize) {
    
    this.mempoolSize = mempoolSize;
    return this;
  }

   /**
   * Get mempoolSize
   * @return mempoolSize
  **/
  @javax.annotation.Nullable

  public Integer getMempoolSize() {
    return mempoolSize;
  }


  public void setMempoolSize(Integer mempoolSize) {
    this.mempoolSize = mempoolSize;
  }


  public GetFeeEstimate200Response mempoolFees(Integer mempoolFees) {
    
    this.mempoolFees = mempoolFees;
    return this;
  }

   /**
   * Get mempoolFees
   * @return mempoolFees
  **/
  @javax.annotation.Nullable

  public Integer getMempoolFees() {
    return mempoolFees;
  }


  public void setMempoolFees(Integer mempoolFees) {
    this.mempoolFees = mempoolFees;
  }


  public GetFeeEstimate200Response mempoolMaxSize(Integer mempoolMaxSize) {
    
    this.mempoolMaxSize = mempoolMaxSize;
    return this;
  }

   /**
   * Get mempoolMaxSize
   * @return mempoolMaxSize
  **/
  @javax.annotation.Nullable

  public Integer getMempoolMaxSize() {
    return mempoolMaxSize;
  }


  public void setMempoolMaxSize(Integer mempoolMaxSize) {
    this.mempoolMaxSize = mempoolMaxSize;
  }


  public GetFeeEstimate200Response numSpends(Integer numSpends) {
    
    this.numSpends = numSpends;
    return this;
  }

   /**
   * Get numSpends
   * @return numSpends
  **/
  @javax.annotation.Nullable

  public Integer getNumSpends() {
    return numSpends;
  }


  public void setNumSpends(Integer numSpends) {
    this.numSpends = numSpends;
  }


  public GetFeeEstimate200Response fullNodeSynced(Boolean fullNodeSynced) {
    
    this.fullNodeSynced = fullNodeSynced;
    return this;
  }

   /**
   * Get fullNodeSynced
   * @return fullNodeSynced
  **/
  @javax.annotation.Nullable

  public Boolean getFullNodeSynced() {
    return fullNodeSynced;
  }


  public void setFullNodeSynced(Boolean fullNodeSynced) {
    this.fullNodeSynced = fullNodeSynced;
  }


  public GetFeeEstimate200Response peakHeight(Integer peakHeight) {
    
    this.peakHeight = peakHeight;
    return this;
  }

   /**
   * Get peakHeight
   * @return peakHeight
  **/
  @javax.annotation.Nullable

  public Integer getPeakHeight() {
    return peakHeight;
  }


  public void setPeakHeight(Integer peakHeight) {
    this.peakHeight = peakHeight;
  }


  public GetFeeEstimate200Response lastPeakTimestamp(Integer lastPeakTimestamp) {
    
    this.lastPeakTimestamp = lastPeakTimestamp;
    return this;
  }

   /**
   * Get lastPeakTimestamp
   * @return lastPeakTimestamp
  **/
  @javax.annotation.Nullable

  public Integer getLastPeakTimestamp() {
    return lastPeakTimestamp;
  }


  public void setLastPeakTimestamp(Integer lastPeakTimestamp) {
    this.lastPeakTimestamp = lastPeakTimestamp;
  }


  public GetFeeEstimate200Response lastBlockCost(Integer lastBlockCost) {
    
    this.lastBlockCost = lastBlockCost;
    return this;
  }

   /**
   * Get lastBlockCost
   * @return lastBlockCost
  **/
  @javax.annotation.Nullable

  public Integer getLastBlockCost() {
    return lastBlockCost;
  }


  public void setLastBlockCost(Integer lastBlockCost) {
    this.lastBlockCost = lastBlockCost;
  }


  public GetFeeEstimate200Response feesLastBlock(Integer feesLastBlock) {
    
    this.feesLastBlock = feesLastBlock;
    return this;
  }

   /**
   * Get feesLastBlock
   * @return feesLastBlock
  **/
  @javax.annotation.Nullable

  public Integer getFeesLastBlock() {
    return feesLastBlock;
  }


  public void setFeesLastBlock(Integer feesLastBlock) {
    this.feesLastBlock = feesLastBlock;
  }


  public GetFeeEstimate200Response feeRateLastBlock(BigDecimal feeRateLastBlock) {
    
    this.feeRateLastBlock = feeRateLastBlock;
    return this;
  }

   /**
   * Get feeRateLastBlock
   * @return feeRateLastBlock
  **/
  @javax.annotation.Nullable

  public BigDecimal getFeeRateLastBlock() {
    return feeRateLastBlock;
  }


  public void setFeeRateLastBlock(BigDecimal feeRateLastBlock) {
    this.feeRateLastBlock = feeRateLastBlock;
  }


  public GetFeeEstimate200Response lastTxBlockHeight(Integer lastTxBlockHeight) {
    
    this.lastTxBlockHeight = lastTxBlockHeight;
    return this;
  }

   /**
   * Get lastTxBlockHeight
   * @return lastTxBlockHeight
  **/
  @javax.annotation.Nullable

  public Integer getLastTxBlockHeight() {
    return lastTxBlockHeight;
  }


  public void setLastTxBlockHeight(Integer lastTxBlockHeight) {
    this.lastTxBlockHeight = lastTxBlockHeight;
  }


  public GetFeeEstimate200Response nodeTimeUtc(Integer nodeTimeUtc) {
    
    this.nodeTimeUtc = nodeTimeUtc;
    return this;
  }

   /**
   * Get nodeTimeUtc
   * @return nodeTimeUtc
  **/
  @javax.annotation.Nullable

  public Integer getNodeTimeUtc() {
    return nodeTimeUtc;
  }


  public void setNodeTimeUtc(Integer nodeTimeUtc) {
    this.nodeTimeUtc = nodeTimeUtc;
  }


  public GetFeeEstimate200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetFeeEstimate200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetFeeEstimate200Response getFeeEstimate200Response = (GetFeeEstimate200Response) o;
    return Objects.equals(this.estimates, getFeeEstimate200Response.estimates) &&
        Objects.equals(this.targetTimes, getFeeEstimate200Response.targetTimes) &&
        Objects.equals(this.currentFeeRate, getFeeEstimate200Response.currentFeeRate) &&
        Objects.equals(this.mempoolSize, getFeeEstimate200Response.mempoolSize) &&
        Objects.equals(this.mempoolFees, getFeeEstimate200Response.mempoolFees) &&
        Objects.equals(this.mempoolMaxSize, getFeeEstimate200Response.mempoolMaxSize) &&
        Objects.equals(this.numSpends, getFeeEstimate200Response.numSpends) &&
        Objects.equals(this.fullNodeSynced, getFeeEstimate200Response.fullNodeSynced) &&
        Objects.equals(this.peakHeight, getFeeEstimate200Response.peakHeight) &&
        Objects.equals(this.lastPeakTimestamp, getFeeEstimate200Response.lastPeakTimestamp) &&
        Objects.equals(this.lastBlockCost, getFeeEstimate200Response.lastBlockCost) &&
        Objects.equals(this.feesLastBlock, getFeeEstimate200Response.feesLastBlock) &&
        Objects.equals(this.feeRateLastBlock, getFeeEstimate200Response.feeRateLastBlock) &&
        Objects.equals(this.lastTxBlockHeight, getFeeEstimate200Response.lastTxBlockHeight) &&
        Objects.equals(this.nodeTimeUtc, getFeeEstimate200Response.nodeTimeUtc) &&
        Objects.equals(this.success, getFeeEstimate200Response.success) &&
        Objects.equals(this.error, getFeeEstimate200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(estimates, targetTimes, currentFeeRate, mempoolSize, mempoolFees, mempoolMaxSize, numSpends, fullNodeSynced, peakHeight, lastPeakTimestamp, lastBlockCost, feesLastBlock, feeRateLastBlock, lastTxBlockHeight, nodeTimeUtc, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetFeeEstimate200Response {\n");
    sb.append("    estimates: ").append(toIndentedString(estimates)).append("\n");
    sb.append("    targetTimes: ").append(toIndentedString(targetTimes)).append("\n");
    sb.append("    currentFeeRate: ").append(toIndentedString(currentFeeRate)).append("\n");
    sb.append("    mempoolSize: ").append(toIndentedString(mempoolSize)).append("\n");
    sb.append("    mempoolFees: ").append(toIndentedString(mempoolFees)).append("\n");
    sb.append("    mempoolMaxSize: ").append(toIndentedString(mempoolMaxSize)).append("\n");
    sb.append("    numSpends: ").append(toIndentedString(numSpends)).append("\n");
    sb.append("    fullNodeSynced: ").append(toIndentedString(fullNodeSynced)).append("\n");
    sb.append("    peakHeight: ").append(toIndentedString(peakHeight)).append("\n");
    sb.append("    lastPeakTimestamp: ").append(toIndentedString(lastPeakTimestamp)).append("\n");
    sb.append("    lastBlockCost: ").append(toIndentedString(lastBlockCost)).append("\n");
    sb.append("    feesLastBlock: ").append(toIndentedString(feesLastBlock)).append("\n");
    sb.append("    feeRateLastBlock: ").append(toIndentedString(feeRateLastBlock)).append("\n");
    sb.append("    lastTxBlockHeight: ").append(toIndentedString(lastTxBlockHeight)).append("\n");
    sb.append("    nodeTimeUtc: ").append(toIndentedString(nodeTimeUtc)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("estimates");
    openapiFields.add("target_times");
    openapiFields.add("current_fee_rate");
    openapiFields.add("mempool_size");
    openapiFields.add("mempool_fees");
    openapiFields.add("mempool_max_size");
    openapiFields.add("num_spends");
    openapiFields.add("full_node_synced");
    openapiFields.add("peak_height");
    openapiFields.add("last_peak_timestamp");
    openapiFields.add("last_block_cost");
    openapiFields.add("fees_last_block");
    openapiFields.add("fee_rate_last_block");
    openapiFields.add("last_tx_block_height");
    openapiFields.add("node_time_utc");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetFeeEstimate200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetFeeEstimate200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetFeeEstimate200Response is not found in the empty JSON string", GetFeeEstimate200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetFeeEstimate200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetFeeEstimate200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetFeeEstimate200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("estimates") != null && !jsonObj.get("estimates").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `estimates` to be an array in the JSON string but got `%s`", jsonObj.get("estimates").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("target_times") != null && !jsonObj.get("target_times").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_times` to be an array in the JSON string but got `%s`", jsonObj.get("target_times").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetFeeEstimate200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetFeeEstimate200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetFeeEstimate200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetFeeEstimate200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetFeeEstimate200Response>() {
           @Override
           public void write(JsonWriter out, GetFeeEstimate200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetFeeEstimate200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetFeeEstimate200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetFeeEstimate200Response
  * @throws IOException if the JSON string is invalid with respect to GetFeeEstimate200Response
  */
  public static GetFeeEstimate200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetFeeEstimate200Response.class);
  }

 /**
  * Convert an instance of GetFeeEstimate200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

