/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.SpendBundle;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetFeeEstimateRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetFeeEstimateRequest {
  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public static final String SERIALIZED_NAME_COST = "cost";
  @SerializedName(SERIALIZED_NAME_COST)
  private Integer cost;

  public static final String SERIALIZED_NAME_TARGET_TIMES = "target_times";
  @SerializedName(SERIALIZED_NAME_TARGET_TIMES)
  private List<Integer> targetTimes;

  public static final String SERIALIZED_NAME_SPEND_TYPE = "spend_type";
  @SerializedName(SERIALIZED_NAME_SPEND_TYPE)
  private Integer spendType;

  public static final String SERIALIZED_NAME_SPEND_COUNT = "spend_count";
  @SerializedName(SERIALIZED_NAME_SPEND_COUNT)
  private Integer spendCount = 1;

  public GetFeeEstimateRequest() {
  }

  public GetFeeEstimateRequest spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }


  public GetFeeEstimateRequest cost(Integer cost) {
    
    this.cost = cost;
    return this;
  }

   /**
   * Get cost
   * @return cost
  **/
  @javax.annotation.Nullable

  public Integer getCost() {
    return cost;
  }


  public void setCost(Integer cost) {
    this.cost = cost;
  }


  public GetFeeEstimateRequest targetTimes(List<Integer> targetTimes) {
    
    this.targetTimes = targetTimes;
    return this;
  }

  public GetFeeEstimateRequest addTargetTimesItem(Integer targetTimesItem) {
    if (this.targetTimes == null) {
      this.targetTimes = new ArrayList<>();
    }
    this.targetTimes.add(targetTimesItem);
    return this;
  }

   /**
   * Get targetTimes
   * @return targetTimes
  **/
  @javax.annotation.Nullable

  public List<Integer> getTargetTimes() {
    return targetTimes;
  }


  public void setTargetTimes(List<Integer> targetTimes) {
    this.targetTimes = targetTimes;
  }


  public GetFeeEstimateRequest spendType(Integer spendType) {
    
    this.spendType = spendType;
    return this;
  }

   /**
   * Get spendType
   * @return spendType
  **/
  @javax.annotation.Nullable

  public Integer getSpendType() {
    return spendType;
  }


  public void setSpendType(Integer spendType) {
    this.spendType = spendType;
  }


  public GetFeeEstimateRequest spendCount(Integer spendCount) {
    
    this.spendCount = spendCount;
    return this;
  }

   /**
   * Get spendCount
   * @return spendCount
  **/
  @javax.annotation.Nullable

  public Integer getSpendCount() {
    return spendCount;
  }


  public void setSpendCount(Integer spendCount) {
    this.spendCount = spendCount;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetFeeEstimateRequest getFeeEstimateRequest = (GetFeeEstimateRequest) o;
    return Objects.equals(this.spendBundle, getFeeEstimateRequest.spendBundle) &&
        Objects.equals(this.cost, getFeeEstimateRequest.cost) &&
        Objects.equals(this.targetTimes, getFeeEstimateRequest.targetTimes) &&
        Objects.equals(this.spendType, getFeeEstimateRequest.spendType) &&
        Objects.equals(this.spendCount, getFeeEstimateRequest.spendCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(spendBundle, cost, targetTimes, spendType, spendCount);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetFeeEstimateRequest {\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("    targetTimes: ").append(toIndentedString(targetTimes)).append("\n");
    sb.append("    spendType: ").append(toIndentedString(spendType)).append("\n");
    sb.append("    spendCount: ").append(toIndentedString(spendCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("spend_bundle");
    openapiFields.add("cost");
    openapiFields.add("target_times");
    openapiFields.add("spend_type");
    openapiFields.add("spend_count");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetFeeEstimateRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetFeeEstimateRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetFeeEstimateRequest is not found in the empty JSON string", GetFeeEstimateRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetFeeEstimateRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetFeeEstimateRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("target_times") != null && !jsonObj.get("target_times").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_times` to be an array in the JSON string but got `%s`", jsonObj.get("target_times").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetFeeEstimateRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetFeeEstimateRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetFeeEstimateRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetFeeEstimateRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetFeeEstimateRequest>() {
           @Override
           public void write(JsonWriter out, GetFeeEstimateRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetFeeEstimateRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetFeeEstimateRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetFeeEstimateRequest
  * @throws IOException if the JSON string is invalid with respect to GetFeeEstimateRequest
  */
  public static GetFeeEstimateRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetFeeEstimateRequest.class);
  }

 /**
  * Convert an instance of GetFeeEstimateRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

