/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetMempoolItemByTxIdRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetMempoolItemByTxIdRequest {
  public static final String SERIALIZED_NAME_TX_ID = "tx_id";
  @SerializedName(SERIALIZED_NAME_TX_ID)
  private String txId;

  public static final String SERIALIZED_NAME_INCLUDE_PENDING = "include_pending";
  @SerializedName(SERIALIZED_NAME_INCLUDE_PENDING)
  private Boolean includePending = false;

  public GetMempoolItemByTxIdRequest() {
  }

  public GetMempoolItemByTxIdRequest txId(String txId) {
    
    this.txId = txId;
    return this;
  }

   /**
   * Get txId
   * @return txId
  **/
  @javax.annotation.Nonnull

  public String getTxId() {
    return txId;
  }


  public void setTxId(String txId) {
    this.txId = txId;
  }


  public GetMempoolItemByTxIdRequest includePending(Boolean includePending) {
    
    this.includePending = includePending;
    return this;
  }

   /**
   * Get includePending
   * @return includePending
  **/
  @javax.annotation.Nullable

  public Boolean getIncludePending() {
    return includePending;
  }


  public void setIncludePending(Boolean includePending) {
    this.includePending = includePending;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetMempoolItemByTxIdRequest getMempoolItemByTxIdRequest = (GetMempoolItemByTxIdRequest) o;
    return Objects.equals(this.txId, getMempoolItemByTxIdRequest.txId) &&
        Objects.equals(this.includePending, getMempoolItemByTxIdRequest.includePending);
  }

  @Override
  public int hashCode() {
    return Objects.hash(txId, includePending);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetMempoolItemByTxIdRequest {\n");
    sb.append("    txId: ").append(toIndentedString(txId)).append("\n");
    sb.append("    includePending: ").append(toIndentedString(includePending)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("tx_id");
    openapiFields.add("include_pending");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("tx_id");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetMempoolItemByTxIdRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetMempoolItemByTxIdRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetMempoolItemByTxIdRequest is not found in the empty JSON string", GetMempoolItemByTxIdRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetMempoolItemByTxIdRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetMempoolItemByTxIdRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetMempoolItemByTxIdRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("tx_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `tx_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("tx_id").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetMempoolItemByTxIdRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetMempoolItemByTxIdRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetMempoolItemByTxIdRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetMempoolItemByTxIdRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetMempoolItemByTxIdRequest>() {
           @Override
           public void write(JsonWriter out, GetMempoolItemByTxIdRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetMempoolItemByTxIdRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetMempoolItemByTxIdRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetMempoolItemByTxIdRequest
  * @throws IOException if the JSON string is invalid with respect to GetMempoolItemByTxIdRequest
  */
  public static GetMempoolItemByTxIdRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetMempoolItemByTxIdRequest.class);
  }

 /**
  * Convert an instance of GetMempoolItemByTxIdRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

