/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.GetRecentSignagePointOrEosRequestOneOf;
import org.openapitools.client.model.GetRecentSignagePointOrEosRequestOneOf1;

import javax.ws.rs.core.GenericType;

import java.io.IOException;
import java.lang.reflect.Type;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.JsonPrimitive;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

import org.openapitools.client.JSON;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class GetRecentSignagePointOrEosRequest extends AbstractOpenApiSchema {
    private static final Logger log = Logger.getLogger(GetRecentSignagePointOrEosRequest.class.getName());

    public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
        @SuppressWarnings("unchecked")
        @Override
        public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
            if (!GetRecentSignagePointOrEosRequest.class.isAssignableFrom(type.getRawType())) {
                return null; // this class only serializes 'GetRecentSignagePointOrEosRequest' and its subtypes
            }
            final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
            final TypeAdapter<GetRecentSignagePointOrEosRequestOneOf> adapterGetRecentSignagePointOrEosRequestOneOf = gson.getDelegateAdapter(this, TypeToken.get(GetRecentSignagePointOrEosRequestOneOf.class));
            final TypeAdapter<GetRecentSignagePointOrEosRequestOneOf1> adapterGetRecentSignagePointOrEosRequestOneOf1 = gson.getDelegateAdapter(this, TypeToken.get(GetRecentSignagePointOrEosRequestOneOf1.class));

            return (TypeAdapter<T>) new TypeAdapter<GetRecentSignagePointOrEosRequest>() {
                @Override
                public void write(JsonWriter out, GetRecentSignagePointOrEosRequest value) throws IOException {
                    if (value == null || value.getActualInstance() == null) {
                        elementAdapter.write(out, null);
                        return;
                    }

                    // check if the actual instance is of the type `GetRecentSignagePointOrEosRequestOneOf`
                    if (value.getActualInstance() instanceof GetRecentSignagePointOrEosRequestOneOf) {
                        JsonObject obj = adapterGetRecentSignagePointOrEosRequestOneOf.toJsonTree((GetRecentSignagePointOrEosRequestOneOf)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    // check if the actual instance is of the type `GetRecentSignagePointOrEosRequestOneOf1`
                    if (value.getActualInstance() instanceof GetRecentSignagePointOrEosRequestOneOf1) {
                        JsonObject obj = adapterGetRecentSignagePointOrEosRequestOneOf1.toJsonTree((GetRecentSignagePointOrEosRequestOneOf1)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    throw new IOException("Failed to serialize as the type doesn't match oneOf schemas: GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1");
                }

                @Override
                public GetRecentSignagePointOrEosRequest read(JsonReader in) throws IOException {
                    Object deserialized = null;
                    JsonObject jsonObject = elementAdapter.read(in).getAsJsonObject();

                    int match = 0;
                    ArrayList<String> errorMessages = new ArrayList<>();
                    TypeAdapter actualAdapter = elementAdapter;

                    // deserialize GetRecentSignagePointOrEosRequestOneOf
                    try {
                        // validate the JSON object to see if any exception is thrown
                        GetRecentSignagePointOrEosRequestOneOf.validateJsonObject(jsonObject);
                        actualAdapter = adapterGetRecentSignagePointOrEosRequestOneOf;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'GetRecentSignagePointOrEosRequestOneOf'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for GetRecentSignagePointOrEosRequestOneOf failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'GetRecentSignagePointOrEosRequestOneOf'", e);
                    }

                    // deserialize GetRecentSignagePointOrEosRequestOneOf1
                    try {
                        // validate the JSON object to see if any exception is thrown
                        GetRecentSignagePointOrEosRequestOneOf1.validateJsonObject(jsonObject);
                        actualAdapter = adapterGetRecentSignagePointOrEosRequestOneOf1;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'GetRecentSignagePointOrEosRequestOneOf1'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for GetRecentSignagePointOrEosRequestOneOf1 failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'GetRecentSignagePointOrEosRequestOneOf1'", e);
                    }

                    if (match == 1) {
                        GetRecentSignagePointOrEosRequest ret = new GetRecentSignagePointOrEosRequest();
                        ret.setActualInstance(actualAdapter.fromJsonTree(jsonObject));
                        return ret;
                    }

                    throw new IOException(String.format("Failed deserialization for GetRecentSignagePointOrEosRequest: %d classes match result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", match, errorMessages, jsonObject.toString()));
                }
            }.nullSafe();
        }
    }

    // store a list of schema names defined in oneOf
    public static final Map<String, GenericType> schemas = new HashMap<String, GenericType>();

    public GetRecentSignagePointOrEosRequest() {
        super("oneOf", Boolean.FALSE);
    }

    public GetRecentSignagePointOrEosRequest(GetRecentSignagePointOrEosRequestOneOf o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public GetRecentSignagePointOrEosRequest(GetRecentSignagePointOrEosRequestOneOf1 o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    static {
        schemas.put("GetRecentSignagePointOrEosRequestOneOf", new GenericType<GetRecentSignagePointOrEosRequestOneOf>() {
        });
        schemas.put("GetRecentSignagePointOrEosRequestOneOf1", new GenericType<GetRecentSignagePointOrEosRequestOneOf1>() {
        });
    }

    @Override
    public Map<String, GenericType> getSchemas() {
        return GetRecentSignagePointOrEosRequest.schemas;
    }

    /**
     * Set the instance that matches the oneOf child schema, check
     * the instance parameter is valid against the oneOf child schemas:
     * GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1
     *
     * It could be an instance of the 'oneOf' schemas.
     * The oneOf child schemas may themselves be a composed schema (allOf, anyOf, oneOf).
     */
    @Override
    public void setActualInstance(Object instance) {
        if (instance instanceof GetRecentSignagePointOrEosRequestOneOf) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof GetRecentSignagePointOrEosRequestOneOf1) {
            super.setActualInstance(instance);
            return;
        }

        throw new RuntimeException("Invalid instance type. Must be GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1");
    }

    /**
     * Get the actual instance, which can be the following:
     * GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1
     *
     * @return The actual instance (GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1)
     */
    @Override
    public Object getActualInstance() {
        return super.getActualInstance();
    }

    /**
     * Get the actual instance of `GetRecentSignagePointOrEosRequestOneOf`. If the actual instance is not `GetRecentSignagePointOrEosRequestOneOf`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `GetRecentSignagePointOrEosRequestOneOf`
     * @throws ClassCastException if the instance is not `GetRecentSignagePointOrEosRequestOneOf`
     */
    public GetRecentSignagePointOrEosRequestOneOf getGetRecentSignagePointOrEosRequestOneOf() throws ClassCastException {
        return (GetRecentSignagePointOrEosRequestOneOf)super.getActualInstance();
    }

    /**
     * Get the actual instance of `GetRecentSignagePointOrEosRequestOneOf1`. If the actual instance is not `GetRecentSignagePointOrEosRequestOneOf1`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `GetRecentSignagePointOrEosRequestOneOf1`
     * @throws ClassCastException if the instance is not `GetRecentSignagePointOrEosRequestOneOf1`
     */
    public GetRecentSignagePointOrEosRequestOneOf1 getGetRecentSignagePointOrEosRequestOneOf1() throws ClassCastException {
        return (GetRecentSignagePointOrEosRequestOneOf1)super.getActualInstance();
    }


 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetRecentSignagePointOrEosRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
    // validate oneOf schemas one by one
    int validCount = 0;
    ArrayList<String> errorMessages = new ArrayList<>();
    // validate the json string with GetRecentSignagePointOrEosRequestOneOf
    try {
      GetRecentSignagePointOrEosRequestOneOf.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for GetRecentSignagePointOrEosRequestOneOf failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with GetRecentSignagePointOrEosRequestOneOf1
    try {
      GetRecentSignagePointOrEosRequestOneOf1.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for GetRecentSignagePointOrEosRequestOneOf1 failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    if (validCount != 1) {
      throw new IOException(String.format("The JSON string is invalid for GetRecentSignagePointOrEosRequest with oneOf schemas: GetRecentSignagePointOrEosRequestOneOf, GetRecentSignagePointOrEosRequestOneOf1. %d class(es) match the result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", validCount, errorMessages, jsonObj.toString()));
    }
  }

 /**
  * Create an instance of GetRecentSignagePointOrEosRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetRecentSignagePointOrEosRequest
  * @throws IOException if the JSON string is invalid with respect to GetRecentSignagePointOrEosRequest
  */
  public static GetRecentSignagePointOrEosRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetRecentSignagePointOrEosRequest.class);
  }

 /**
  * Convert an instance of GetRecentSignagePointOrEosRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

