/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.NpcResult;
import org.openapitools.client.model.SpendBundle;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * MempoolItem
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class MempoolItem {
  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee;

  public static final String SERIALIZED_NAME_NPC_RESULT = "npc_result";
  @SerializedName(SERIALIZED_NAME_NPC_RESULT)
  private NpcResult npcResult;

  public static final String SERIALIZED_NAME_COST = "cost";
  @SerializedName(SERIALIZED_NAME_COST)
  private Integer cost;

  public static final String SERIALIZED_NAME_SPEND_BUDNDLE_NAME = "spend_budndle_name";
  @SerializedName(SERIALIZED_NAME_SPEND_BUDNDLE_NAME)
  private String spendBudndleName;

  public static final String SERIALIZED_NAME_ADDITIONS = "additions";
  @SerializedName(SERIALIZED_NAME_ADDITIONS)
  private List<Coin> additions;

  public static final String SERIALIZED_NAME_REMOVALS = "removals";
  @SerializedName(SERIALIZED_NAME_REMOVALS)
  private List<Coin> removals;

  public static final String SERIALIZED_NAME_PROGRAM = "program";
  @SerializedName(SERIALIZED_NAME_PROGRAM)
  private String program;

  public MempoolItem() {
  }

  public MempoolItem spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }


  public MempoolItem fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public MempoolItem npcResult(NpcResult npcResult) {
    
    this.npcResult = npcResult;
    return this;
  }

   /**
   * Get npcResult
   * @return npcResult
  **/
  @javax.annotation.Nullable

  public NpcResult getNpcResult() {
    return npcResult;
  }


  public void setNpcResult(NpcResult npcResult) {
    this.npcResult = npcResult;
  }


  public MempoolItem cost(Integer cost) {
    
    this.cost = cost;
    return this;
  }

   /**
   * Get cost
   * @return cost
  **/
  @javax.annotation.Nullable

  public Integer getCost() {
    return cost;
  }


  public void setCost(Integer cost) {
    this.cost = cost;
  }


  public MempoolItem spendBudndleName(String spendBudndleName) {
    
    this.spendBudndleName = spendBudndleName;
    return this;
  }

   /**
   * Get spendBudndleName
   * @return spendBudndleName
  **/
  @javax.annotation.Nullable

  public String getSpendBudndleName() {
    return spendBudndleName;
  }


  public void setSpendBudndleName(String spendBudndleName) {
    this.spendBudndleName = spendBudndleName;
  }


  public MempoolItem additions(List<Coin> additions) {
    
    this.additions = additions;
    return this;
  }

  public MempoolItem addAdditionsItem(Coin additionsItem) {
    if (this.additions == null) {
      this.additions = new ArrayList<>();
    }
    this.additions.add(additionsItem);
    return this;
  }

   /**
   * Get additions
   * @return additions
  **/
  @javax.annotation.Nullable

  public List<Coin> getAdditions() {
    return additions;
  }


  public void setAdditions(List<Coin> additions) {
    this.additions = additions;
  }


  public MempoolItem removals(List<Coin> removals) {
    
    this.removals = removals;
    return this;
  }

  public MempoolItem addRemovalsItem(Coin removalsItem) {
    if (this.removals == null) {
      this.removals = new ArrayList<>();
    }
    this.removals.add(removalsItem);
    return this;
  }

   /**
   * Get removals
   * @return removals
  **/
  @javax.annotation.Nullable

  public List<Coin> getRemovals() {
    return removals;
  }


  public void setRemovals(List<Coin> removals) {
    this.removals = removals;
  }


  public MempoolItem program(String program) {
    
    this.program = program;
    return this;
  }

   /**
   * Get program
   * @return program
  **/
  @javax.annotation.Nullable

  public String getProgram() {
    return program;
  }


  public void setProgram(String program) {
    this.program = program;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MempoolItem mempoolItem = (MempoolItem) o;
    return Objects.equals(this.spendBundle, mempoolItem.spendBundle) &&
        Objects.equals(this.fee, mempoolItem.fee) &&
        Objects.equals(this.npcResult, mempoolItem.npcResult) &&
        Objects.equals(this.cost, mempoolItem.cost) &&
        Objects.equals(this.spendBudndleName, mempoolItem.spendBudndleName) &&
        Objects.equals(this.additions, mempoolItem.additions) &&
        Objects.equals(this.removals, mempoolItem.removals) &&
        Objects.equals(this.program, mempoolItem.program);
  }

  @Override
  public int hashCode() {
    return Objects.hash(spendBundle, fee, npcResult, cost, spendBudndleName, additions, removals, program);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class MempoolItem {\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    npcResult: ").append(toIndentedString(npcResult)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("    spendBudndleName: ").append(toIndentedString(spendBudndleName)).append("\n");
    sb.append("    additions: ").append(toIndentedString(additions)).append("\n");
    sb.append("    removals: ").append(toIndentedString(removals)).append("\n");
    sb.append("    program: ").append(toIndentedString(program)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("spend_bundle");
    openapiFields.add("fee");
    openapiFields.add("npc_result");
    openapiFields.add("cost");
    openapiFields.add("spend_budndle_name");
    openapiFields.add("additions");
    openapiFields.add("removals");
    openapiFields.add("program");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to MempoolItem
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!MempoolItem.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in MempoolItem is not found in the empty JSON string", MempoolItem.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!MempoolItem.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `MempoolItem` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
      // validate the optional field `npc_result`
      if (jsonObj.get("npc_result") != null && !jsonObj.get("npc_result").isJsonNull()) {
        NpcResult.validateJsonObject(jsonObj.getAsJsonObject("npc_result"));
      }
      if ((jsonObj.get("spend_budndle_name") != null && !jsonObj.get("spend_budndle_name").isJsonNull()) && !jsonObj.get("spend_budndle_name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `spend_budndle_name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("spend_budndle_name").toString()));
      }
      if (jsonObj.get("additions") != null && !jsonObj.get("additions").isJsonNull()) {
        JsonArray jsonArrayadditions = jsonObj.getAsJsonArray("additions");
        if (jsonArrayadditions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("additions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `additions` to be an array in the JSON string but got `%s`", jsonObj.get("additions").toString()));
          }

          // validate the optional field `additions` (array)
          for (int i = 0; i < jsonArrayadditions.size(); i++) {
            Coin.validateJsonObject(jsonArrayadditions.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("removals") != null && !jsonObj.get("removals").isJsonNull()) {
        JsonArray jsonArrayremovals = jsonObj.getAsJsonArray("removals");
        if (jsonArrayremovals != null) {
          // ensure the json data is an array
          if (!jsonObj.get("removals").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `removals` to be an array in the JSON string but got `%s`", jsonObj.get("removals").toString()));
          }

          // validate the optional field `removals` (array)
          for (int i = 0; i < jsonArrayremovals.size(); i++) {
            Coin.validateJsonObject(jsonArrayremovals.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("program") != null && !jsonObj.get("program").isJsonNull()) && !jsonObj.get("program").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `program` to be a primitive type in the JSON string but got `%s`", jsonObj.get("program").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!MempoolItem.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'MempoolItem' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<MempoolItem> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(MempoolItem.class));

       return (TypeAdapter<T>) new TypeAdapter<MempoolItem>() {
           @Override
           public void write(JsonWriter out, MempoolItem value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public MempoolItem read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of MempoolItem given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of MempoolItem
  * @throws IOException if the JSON string is invalid with respect to MempoolItem
  */
  public static MempoolItem fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, MempoolItem.class);
  }

 /**
  * Convert an instance of MempoolItem to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

