/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Condition;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Npc
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class Npc {
  public static final String SERIALIZED_NAME_COIN_NAME = "coin_name";
  @SerializedName(SERIALIZED_NAME_COIN_NAME)
  private String coinName;

  public static final String SERIALIZED_NAME_PUZZLE_HASH = "puzzle_hash";
  @SerializedName(SERIALIZED_NAME_PUZZLE_HASH)
  private String puzzleHash;

  public static final String SERIALIZED_NAME_CONDITIONS = "conditions";
  @SerializedName(SERIALIZED_NAME_CONDITIONS)
  private List<Condition> conditions;

  public Npc() {
  }

  public Npc coinName(String coinName) {
    
    this.coinName = coinName;
    return this;
  }

   /**
   * Get coinName
   * @return coinName
  **/
  @javax.annotation.Nullable

  public String getCoinName() {
    return coinName;
  }


  public void setCoinName(String coinName) {
    this.coinName = coinName;
  }


  public Npc puzzleHash(String puzzleHash) {
    
    this.puzzleHash = puzzleHash;
    return this;
  }

   /**
   * Get puzzleHash
   * @return puzzleHash
  **/
  @javax.annotation.Nullable

  public String getPuzzleHash() {
    return puzzleHash;
  }


  public void setPuzzleHash(String puzzleHash) {
    this.puzzleHash = puzzleHash;
  }


  public Npc conditions(List<Condition> conditions) {
    
    this.conditions = conditions;
    return this;
  }

  public Npc addConditionsItem(Condition conditionsItem) {
    if (this.conditions == null) {
      this.conditions = new ArrayList<>();
    }
    this.conditions.add(conditionsItem);
    return this;
  }

   /**
   * Get conditions
   * @return conditions
  **/
  @javax.annotation.Nullable

  public List<Condition> getConditions() {
    return conditions;
  }


  public void setConditions(List<Condition> conditions) {
    this.conditions = conditions;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Npc npc = (Npc) o;
    return Objects.equals(this.coinName, npc.coinName) &&
        Objects.equals(this.puzzleHash, npc.puzzleHash) &&
        Objects.equals(this.conditions, npc.conditions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(coinName, puzzleHash, conditions);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Npc {\n");
    sb.append("    coinName: ").append(toIndentedString(coinName)).append("\n");
    sb.append("    puzzleHash: ").append(toIndentedString(puzzleHash)).append("\n");
    sb.append("    conditions: ").append(toIndentedString(conditions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("coin_name");
    openapiFields.add("puzzle_hash");
    openapiFields.add("conditions");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to Npc
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!Npc.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in Npc is not found in the empty JSON string", Npc.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!Npc.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `Npc` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("coin_name") != null && !jsonObj.get("coin_name").isJsonNull()) && !jsonObj.get("coin_name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `coin_name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("coin_name").toString()));
      }
      if ((jsonObj.get("puzzle_hash") != null && !jsonObj.get("puzzle_hash").isJsonNull()) && !jsonObj.get("puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("puzzle_hash").toString()));
      }
      if (jsonObj.get("conditions") != null && !jsonObj.get("conditions").isJsonNull()) {
        JsonArray jsonArrayconditions = jsonObj.getAsJsonArray("conditions");
        if (jsonArrayconditions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("conditions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `conditions` to be an array in the JSON string but got `%s`", jsonObj.get("conditions").toString()));
          }

          // validate the optional field `conditions` (array)
          for (int i = 0; i < jsonArrayconditions.size(); i++) {
            Condition.validateJsonObject(jsonArrayconditions.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!Npc.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'Npc' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<Npc> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(Npc.class));

       return (TypeAdapter<T>) new TypeAdapter<Npc>() {
           @Override
           public void write(JsonWriter out, Npc value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public Npc read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of Npc given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of Npc
  * @throws IOException if the JSON string is invalid with respect to Npc
  */
  public static Npc fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, Npc.class);
  }

 /**
  * Convert an instance of Npc to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

