/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Npc;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NpcResult
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class NpcResult {
  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private Integer error;

  public static final String SERIALIZED_NAME_NPC_LIST = "npc_list";
  @SerializedName(SERIALIZED_NAME_NPC_LIST)
  private List<Npc> npcList;

  public static final String SERIALIZED_NAME_CLVM_COST = "clvm_cost";
  @SerializedName(SERIALIZED_NAME_CLVM_COST)
  private Integer clvmCost;

  public NpcResult() {
  }

  public NpcResult error(Integer error) {
    
    this.error = error;
    return this;
  }

   /**
   * Get error
   * @return error
  **/
  @javax.annotation.Nullable

  public Integer getError() {
    return error;
  }


  public void setError(Integer error) {
    this.error = error;
  }


  public NpcResult npcList(List<Npc> npcList) {
    
    this.npcList = npcList;
    return this;
  }

  public NpcResult addNpcListItem(Npc npcListItem) {
    if (this.npcList == null) {
      this.npcList = new ArrayList<>();
    }
    this.npcList.add(npcListItem);
    return this;
  }

   /**
   * Get npcList
   * @return npcList
  **/
  @javax.annotation.Nullable

  public List<Npc> getNpcList() {
    return npcList;
  }


  public void setNpcList(List<Npc> npcList) {
    this.npcList = npcList;
  }


  public NpcResult clvmCost(Integer clvmCost) {
    
    this.clvmCost = clvmCost;
    return this;
  }

   /**
   * Get clvmCost
   * @return clvmCost
  **/
  @javax.annotation.Nullable

  public Integer getClvmCost() {
    return clvmCost;
  }


  public void setClvmCost(Integer clvmCost) {
    this.clvmCost = clvmCost;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NpcResult npcResult = (NpcResult) o;
    return Objects.equals(this.error, npcResult.error) &&
        Objects.equals(this.npcList, npcResult.npcList) &&
        Objects.equals(this.clvmCost, npcResult.clvmCost);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(error, npcList, clvmCost);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NpcResult {\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("    npcList: ").append(toIndentedString(npcList)).append("\n");
    sb.append("    clvmCost: ").append(toIndentedString(clvmCost)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("error");
    openapiFields.add("npc_list");
    openapiFields.add("clvm_cost");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NpcResult
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NpcResult.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NpcResult is not found in the empty JSON string", NpcResult.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NpcResult.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NpcResult` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("npc_list") != null && !jsonObj.get("npc_list").isJsonNull()) {
        JsonArray jsonArraynpcList = jsonObj.getAsJsonArray("npc_list");
        if (jsonArraynpcList != null) {
          // ensure the json data is an array
          if (!jsonObj.get("npc_list").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `npc_list` to be an array in the JSON string but got `%s`", jsonObj.get("npc_list").toString()));
          }

          // validate the optional field `npc_list` (array)
          for (int i = 0; i < jsonArraynpcList.size(); i++) {
            Npc.validateJsonObject(jsonArraynpcList.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NpcResult.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NpcResult' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NpcResult> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NpcResult.class));

       return (TypeAdapter<T>) new TypeAdapter<NpcResult>() {
           @Override
           public void write(JsonWriter out, NpcResult value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NpcResult read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NpcResult given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NpcResult
  * @throws IOException if the JSON string is invalid with respect to NpcResult
  */
  public static NpcResult fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NpcResult.class);
  }

 /**
  * Convert an instance of NpcResult to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

