/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PoolTarget
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class PoolTarget {
  public static final String SERIALIZED_NAME_PUZZLE_HASH = "puzzle_hash";
  @SerializedName(SERIALIZED_NAME_PUZZLE_HASH)
  private String puzzleHash;

  public static final String SERIALIZED_NAME_MAX_HEIGHT = "max_height";
  @SerializedName(SERIALIZED_NAME_MAX_HEIGHT)
  private Integer maxHeight;

  public PoolTarget() {
  }

  public PoolTarget puzzleHash(String puzzleHash) {
    
    this.puzzleHash = puzzleHash;
    return this;
  }

   /**
   * Get puzzleHash
   * @return puzzleHash
  **/
  @javax.annotation.Nullable

  public String getPuzzleHash() {
    return puzzleHash;
  }


  public void setPuzzleHash(String puzzleHash) {
    this.puzzleHash = puzzleHash;
  }


  public PoolTarget maxHeight(Integer maxHeight) {
    
    this.maxHeight = maxHeight;
    return this;
  }

   /**
   * Get maxHeight
   * @return maxHeight
  **/
  @javax.annotation.Nullable

  public Integer getMaxHeight() {
    return maxHeight;
  }


  public void setMaxHeight(Integer maxHeight) {
    this.maxHeight = maxHeight;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PoolTarget poolTarget = (PoolTarget) o;
    return Objects.equals(this.puzzleHash, poolTarget.puzzleHash) &&
        Objects.equals(this.maxHeight, poolTarget.maxHeight);
  }

  @Override
  public int hashCode() {
    return Objects.hash(puzzleHash, maxHeight);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PoolTarget {\n");
    sb.append("    puzzleHash: ").append(toIndentedString(puzzleHash)).append("\n");
    sb.append("    maxHeight: ").append(toIndentedString(maxHeight)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("puzzle_hash");
    openapiFields.add("max_height");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PoolTarget
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PoolTarget.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PoolTarget is not found in the empty JSON string", PoolTarget.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PoolTarget.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PoolTarget` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("puzzle_hash") != null && !jsonObj.get("puzzle_hash").isJsonNull()) && !jsonObj.get("puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("puzzle_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PoolTarget.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PoolTarget' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PoolTarget> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PoolTarget.class));

       return (TypeAdapter<T>) new TypeAdapter<PoolTarget>() {
           @Override
           public void write(JsonWriter out, PoolTarget value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PoolTarget read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PoolTarget given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PoolTarget
  * @throws IOException if the JSON string is invalid with respect to PoolTarget
  */
  public static PoolTarget fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PoolTarget.class);
  }

 /**
  * Convert an instance of PoolTarget to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

