/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.KSize;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * ProofOfSpace
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class ProofOfSpace {
  public static final String SERIALIZED_NAME_CHALLENGE = "challenge";
  @SerializedName(SERIALIZED_NAME_CHALLENGE)
  private String challenge;

  public static final String SERIALIZED_NAME_PUBLIC_POOL_KEY = "public_pool_key";
  @SerializedName(SERIALIZED_NAME_PUBLIC_POOL_KEY)
  private String publicPoolKey;

  public static final String SERIALIZED_NAME_POOL_CONTRACT_PUZZLE_HASH = "pool_contract_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_POOL_CONTRACT_PUZZLE_HASH)
  private String poolContractPuzzleHash;

  public static final String SERIALIZED_NAME_PLOT_PUBLIC_KEY = "plot_public_key";
  @SerializedName(SERIALIZED_NAME_PLOT_PUBLIC_KEY)
  private String plotPublicKey;

  public static final String SERIALIZED_NAME_SIZE = "size";
  @SerializedName(SERIALIZED_NAME_SIZE)
  private KSize size = KSize.NUMBER_32;

  public static final String SERIALIZED_NAME_PROOF = "proof";
  @SerializedName(SERIALIZED_NAME_PROOF)
  private String proof;

  public ProofOfSpace() {
  }

  public ProofOfSpace challenge(String challenge) {
    
    this.challenge = challenge;
    return this;
  }

   /**
   * Get challenge
   * @return challenge
  **/
  @javax.annotation.Nullable

  public String getChallenge() {
    return challenge;
  }


  public void setChallenge(String challenge) {
    this.challenge = challenge;
  }


  public ProofOfSpace publicPoolKey(String publicPoolKey) {
    
    this.publicPoolKey = publicPoolKey;
    return this;
  }

   /**
   * Get publicPoolKey
   * @return publicPoolKey
  **/
  @javax.annotation.Nullable

  public String getPublicPoolKey() {
    return publicPoolKey;
  }


  public void setPublicPoolKey(String publicPoolKey) {
    this.publicPoolKey = publicPoolKey;
  }


  public ProofOfSpace poolContractPuzzleHash(String poolContractPuzzleHash) {
    
    this.poolContractPuzzleHash = poolContractPuzzleHash;
    return this;
  }

   /**
   * Get poolContractPuzzleHash
   * @return poolContractPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getPoolContractPuzzleHash() {
    return poolContractPuzzleHash;
  }


  public void setPoolContractPuzzleHash(String poolContractPuzzleHash) {
    this.poolContractPuzzleHash = poolContractPuzzleHash;
  }


  public ProofOfSpace plotPublicKey(String plotPublicKey) {
    
    this.plotPublicKey = plotPublicKey;
    return this;
  }

   /**
   * Get plotPublicKey
   * @return plotPublicKey
  **/
  @javax.annotation.Nullable

  public String getPlotPublicKey() {
    return plotPublicKey;
  }


  public void setPlotPublicKey(String plotPublicKey) {
    this.plotPublicKey = plotPublicKey;
  }


  public ProofOfSpace size(KSize size) {
    
    this.size = size;
    return this;
  }

   /**
   * Get size
   * @return size
  **/
  @javax.annotation.Nullable

  public KSize getSize() {
    return size;
  }


  public void setSize(KSize size) {
    this.size = size;
  }


  public ProofOfSpace proof(String proof) {
    
    this.proof = proof;
    return this;
  }

   /**
   * Get proof
   * @return proof
  **/
  @javax.annotation.Nullable

  public String getProof() {
    return proof;
  }


  public void setProof(String proof) {
    this.proof = proof;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProofOfSpace proofOfSpace = (ProofOfSpace) o;
    return Objects.equals(this.challenge, proofOfSpace.challenge) &&
        Objects.equals(this.publicPoolKey, proofOfSpace.publicPoolKey) &&
        Objects.equals(this.poolContractPuzzleHash, proofOfSpace.poolContractPuzzleHash) &&
        Objects.equals(this.plotPublicKey, proofOfSpace.plotPublicKey) &&
        Objects.equals(this.size, proofOfSpace.size) &&
        Objects.equals(this.proof, proofOfSpace.proof);
  }

  @Override
  public int hashCode() {
    return Objects.hash(challenge, publicPoolKey, poolContractPuzzleHash, plotPublicKey, size, proof);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProofOfSpace {\n");
    sb.append("    challenge: ").append(toIndentedString(challenge)).append("\n");
    sb.append("    publicPoolKey: ").append(toIndentedString(publicPoolKey)).append("\n");
    sb.append("    poolContractPuzzleHash: ").append(toIndentedString(poolContractPuzzleHash)).append("\n");
    sb.append("    plotPublicKey: ").append(toIndentedString(plotPublicKey)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    proof: ").append(toIndentedString(proof)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("challenge");
    openapiFields.add("public_pool_key");
    openapiFields.add("pool_contract_puzzle_hash");
    openapiFields.add("plot_public_key");
    openapiFields.add("size");
    openapiFields.add("proof");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to ProofOfSpace
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!ProofOfSpace.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ProofOfSpace is not found in the empty JSON string", ProofOfSpace.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!ProofOfSpace.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ProofOfSpace` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("challenge") != null && !jsonObj.get("challenge").isJsonNull()) && !jsonObj.get("challenge").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge").toString()));
      }
      if ((jsonObj.get("public_pool_key") != null && !jsonObj.get("public_pool_key").isJsonNull()) && !jsonObj.get("public_pool_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `public_pool_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("public_pool_key").toString()));
      }
      if ((jsonObj.get("pool_contract_puzzle_hash") != null && !jsonObj.get("pool_contract_puzzle_hash").isJsonNull()) && !jsonObj.get("pool_contract_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_contract_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_contract_puzzle_hash").toString()));
      }
      if ((jsonObj.get("plot_public_key") != null && !jsonObj.get("plot_public_key").isJsonNull()) && !jsonObj.get("plot_public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `plot_public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("plot_public_key").toString()));
      }
      if ((jsonObj.get("proof") != null && !jsonObj.get("proof").isJsonNull()) && !jsonObj.get("proof").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `proof` to be a primitive type in the JSON string but got `%s`", jsonObj.get("proof").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ProofOfSpace.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ProofOfSpace' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ProofOfSpace> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ProofOfSpace.class));

       return (TypeAdapter<T>) new TypeAdapter<ProofOfSpace>() {
           @Override
           public void write(JsonWriter out, ProofOfSpace value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ProofOfSpace read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ProofOfSpace given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ProofOfSpace
  * @throws IOException if the JSON string is invalid with respect to ProofOfSpace
  */
  public static ProofOfSpace fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ProofOfSpace.class);
  }

 /**
  * Convert an instance of ProofOfSpace to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

