/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.ProofOfSpace;
import org.openapitools.client.model.VdfInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * RewardChainBlock
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class RewardChainBlock {
  public static final String SERIALIZED_NAME_WEIGHT = "weight";
  @SerializedName(SERIALIZED_NAME_WEIGHT)
  private Integer weight;

  public static final String SERIALIZED_NAME_HEIGHT = "height";
  @SerializedName(SERIALIZED_NAME_HEIGHT)
  private Integer height;

  public static final String SERIALIZED_NAME_TOTAL_ITERS = "total_iters";
  @SerializedName(SERIALIZED_NAME_TOTAL_ITERS)
  private Integer totalIters;

  public static final String SERIALIZED_NAME_SIGNAGE_POINT_INDEX = "signage_point_index";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT_INDEX)
  private Integer signagePointIndex;

  public static final String SERIALIZED_NAME_POS_SS_CC_CHALLENGE_HASH = "pos_ss_cc_challenge_hash";
  @SerializedName(SERIALIZED_NAME_POS_SS_CC_CHALLENGE_HASH)
  private String posSsCcChallengeHash;

  public static final String SERIALIZED_NAME_PROOF_OF_SPACE = "proof_of_space";
  @SerializedName(SERIALIZED_NAME_PROOF_OF_SPACE)
  private ProofOfSpace proofOfSpace;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_VDF = "challenge_chain_sp_vdf";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_VDF)
  private VdfInfo challengeChainSpVdf;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_SIGNATURE = "challenge_chain_sp_signature";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_SIGNATURE)
  private String challengeChainSpSignature;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_IP_VDF = "challenge_chain_ip_vdf";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_IP_VDF)
  private VdfInfo challengeChainIpVdf;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_VDF = "reward_chain_sp_vdf";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_VDF)
  private VdfInfo rewardChainSpVdf;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_SIGNATURE = "reward_chain_sp_signature";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_SIGNATURE)
  private String rewardChainSpSignature;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_IP_VDF = "reward_chain_ip_vdf";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_IP_VDF)
  private VdfInfo rewardChainIpVdf;

  public static final String SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_IP_VDF = "infused_challenge_chain_ip_vdf";
  @SerializedName(SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_IP_VDF)
  private VdfInfo infusedChallengeChainIpVdf;

  public static final String SERIALIZED_NAME_IS_TRANSACTION_BLOCK = "is_transaction_block";
  @SerializedName(SERIALIZED_NAME_IS_TRANSACTION_BLOCK)
  private Boolean isTransactionBlock;

  public RewardChainBlock() {
  }

  public RewardChainBlock weight(Integer weight) {
    
    this.weight = weight;
    return this;
  }

   /**
   * Get weight
   * @return weight
  **/
  @javax.annotation.Nullable

  public Integer getWeight() {
    return weight;
  }


  public void setWeight(Integer weight) {
    this.weight = weight;
  }


  public RewardChainBlock height(Integer height) {
    
    this.height = height;
    return this;
  }

   /**
   * Get height
   * @return height
  **/
  @javax.annotation.Nullable

  public Integer getHeight() {
    return height;
  }


  public void setHeight(Integer height) {
    this.height = height;
  }


  public RewardChainBlock totalIters(Integer totalIters) {
    
    this.totalIters = totalIters;
    return this;
  }

   /**
   * Get totalIters
   * @return totalIters
  **/
  @javax.annotation.Nullable

  public Integer getTotalIters() {
    return totalIters;
  }


  public void setTotalIters(Integer totalIters) {
    this.totalIters = totalIters;
  }


  public RewardChainBlock signagePointIndex(Integer signagePointIndex) {
    
    this.signagePointIndex = signagePointIndex;
    return this;
  }

   /**
   * Get signagePointIndex
   * @return signagePointIndex
  **/
  @javax.annotation.Nullable

  public Integer getSignagePointIndex() {
    return signagePointIndex;
  }


  public void setSignagePointIndex(Integer signagePointIndex) {
    this.signagePointIndex = signagePointIndex;
  }


  public RewardChainBlock posSsCcChallengeHash(String posSsCcChallengeHash) {
    
    this.posSsCcChallengeHash = posSsCcChallengeHash;
    return this;
  }

   /**
   * Get posSsCcChallengeHash
   * @return posSsCcChallengeHash
  **/
  @javax.annotation.Nullable

  public String getPosSsCcChallengeHash() {
    return posSsCcChallengeHash;
  }


  public void setPosSsCcChallengeHash(String posSsCcChallengeHash) {
    this.posSsCcChallengeHash = posSsCcChallengeHash;
  }


  public RewardChainBlock proofOfSpace(ProofOfSpace proofOfSpace) {
    
    this.proofOfSpace = proofOfSpace;
    return this;
  }

   /**
   * Get proofOfSpace
   * @return proofOfSpace
  **/
  @javax.annotation.Nullable

  public ProofOfSpace getProofOfSpace() {
    return proofOfSpace;
  }


  public void setProofOfSpace(ProofOfSpace proofOfSpace) {
    this.proofOfSpace = proofOfSpace;
  }


  public RewardChainBlock challengeChainSpVdf(VdfInfo challengeChainSpVdf) {
    
    this.challengeChainSpVdf = challengeChainSpVdf;
    return this;
  }

   /**
   * Get challengeChainSpVdf
   * @return challengeChainSpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getChallengeChainSpVdf() {
    return challengeChainSpVdf;
  }


  public void setChallengeChainSpVdf(VdfInfo challengeChainSpVdf) {
    this.challengeChainSpVdf = challengeChainSpVdf;
  }


  public RewardChainBlock challengeChainSpSignature(String challengeChainSpSignature) {
    
    this.challengeChainSpSignature = challengeChainSpSignature;
    return this;
  }

   /**
   * Get challengeChainSpSignature
   * @return challengeChainSpSignature
  **/
  @javax.annotation.Nullable

  public String getChallengeChainSpSignature() {
    return challengeChainSpSignature;
  }


  public void setChallengeChainSpSignature(String challengeChainSpSignature) {
    this.challengeChainSpSignature = challengeChainSpSignature;
  }


  public RewardChainBlock challengeChainIpVdf(VdfInfo challengeChainIpVdf) {
    
    this.challengeChainIpVdf = challengeChainIpVdf;
    return this;
  }

   /**
   * Get challengeChainIpVdf
   * @return challengeChainIpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getChallengeChainIpVdf() {
    return challengeChainIpVdf;
  }


  public void setChallengeChainIpVdf(VdfInfo challengeChainIpVdf) {
    this.challengeChainIpVdf = challengeChainIpVdf;
  }


  public RewardChainBlock rewardChainSpVdf(VdfInfo rewardChainSpVdf) {
    
    this.rewardChainSpVdf = rewardChainSpVdf;
    return this;
  }

   /**
   * Get rewardChainSpVdf
   * @return rewardChainSpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getRewardChainSpVdf() {
    return rewardChainSpVdf;
  }


  public void setRewardChainSpVdf(VdfInfo rewardChainSpVdf) {
    this.rewardChainSpVdf = rewardChainSpVdf;
  }


  public RewardChainBlock rewardChainSpSignature(String rewardChainSpSignature) {
    
    this.rewardChainSpSignature = rewardChainSpSignature;
    return this;
  }

   /**
   * Get rewardChainSpSignature
   * @return rewardChainSpSignature
  **/
  @javax.annotation.Nullable

  public String getRewardChainSpSignature() {
    return rewardChainSpSignature;
  }


  public void setRewardChainSpSignature(String rewardChainSpSignature) {
    this.rewardChainSpSignature = rewardChainSpSignature;
  }


  public RewardChainBlock rewardChainIpVdf(VdfInfo rewardChainIpVdf) {
    
    this.rewardChainIpVdf = rewardChainIpVdf;
    return this;
  }

   /**
   * Get rewardChainIpVdf
   * @return rewardChainIpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getRewardChainIpVdf() {
    return rewardChainIpVdf;
  }


  public void setRewardChainIpVdf(VdfInfo rewardChainIpVdf) {
    this.rewardChainIpVdf = rewardChainIpVdf;
  }


  public RewardChainBlock infusedChallengeChainIpVdf(VdfInfo infusedChallengeChainIpVdf) {
    
    this.infusedChallengeChainIpVdf = infusedChallengeChainIpVdf;
    return this;
  }

   /**
   * Get infusedChallengeChainIpVdf
   * @return infusedChallengeChainIpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getInfusedChallengeChainIpVdf() {
    return infusedChallengeChainIpVdf;
  }


  public void setInfusedChallengeChainIpVdf(VdfInfo infusedChallengeChainIpVdf) {
    this.infusedChallengeChainIpVdf = infusedChallengeChainIpVdf;
  }


  public RewardChainBlock isTransactionBlock(Boolean isTransactionBlock) {
    
    this.isTransactionBlock = isTransactionBlock;
    return this;
  }

   /**
   * Get isTransactionBlock
   * @return isTransactionBlock
  **/
  @javax.annotation.Nullable

  public Boolean getIsTransactionBlock() {
    return isTransactionBlock;
  }


  public void setIsTransactionBlock(Boolean isTransactionBlock) {
    this.isTransactionBlock = isTransactionBlock;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RewardChainBlock rewardChainBlock = (RewardChainBlock) o;
    return Objects.equals(this.weight, rewardChainBlock.weight) &&
        Objects.equals(this.height, rewardChainBlock.height) &&
        Objects.equals(this.totalIters, rewardChainBlock.totalIters) &&
        Objects.equals(this.signagePointIndex, rewardChainBlock.signagePointIndex) &&
        Objects.equals(this.posSsCcChallengeHash, rewardChainBlock.posSsCcChallengeHash) &&
        Objects.equals(this.proofOfSpace, rewardChainBlock.proofOfSpace) &&
        Objects.equals(this.challengeChainSpVdf, rewardChainBlock.challengeChainSpVdf) &&
        Objects.equals(this.challengeChainSpSignature, rewardChainBlock.challengeChainSpSignature) &&
        Objects.equals(this.challengeChainIpVdf, rewardChainBlock.challengeChainIpVdf) &&
        Objects.equals(this.rewardChainSpVdf, rewardChainBlock.rewardChainSpVdf) &&
        Objects.equals(this.rewardChainSpSignature, rewardChainBlock.rewardChainSpSignature) &&
        Objects.equals(this.rewardChainIpVdf, rewardChainBlock.rewardChainIpVdf) &&
        Objects.equals(this.infusedChallengeChainIpVdf, rewardChainBlock.infusedChallengeChainIpVdf) &&
        Objects.equals(this.isTransactionBlock, rewardChainBlock.isTransactionBlock);
  }

  @Override
  public int hashCode() {
    return Objects.hash(weight, height, totalIters, signagePointIndex, posSsCcChallengeHash, proofOfSpace, challengeChainSpVdf, challengeChainSpSignature, challengeChainIpVdf, rewardChainSpVdf, rewardChainSpSignature, rewardChainIpVdf, infusedChallengeChainIpVdf, isTransactionBlock);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RewardChainBlock {\n");
    sb.append("    weight: ").append(toIndentedString(weight)).append("\n");
    sb.append("    height: ").append(toIndentedString(height)).append("\n");
    sb.append("    totalIters: ").append(toIndentedString(totalIters)).append("\n");
    sb.append("    signagePointIndex: ").append(toIndentedString(signagePointIndex)).append("\n");
    sb.append("    posSsCcChallengeHash: ").append(toIndentedString(posSsCcChallengeHash)).append("\n");
    sb.append("    proofOfSpace: ").append(toIndentedString(proofOfSpace)).append("\n");
    sb.append("    challengeChainSpVdf: ").append(toIndentedString(challengeChainSpVdf)).append("\n");
    sb.append("    challengeChainSpSignature: ").append(toIndentedString(challengeChainSpSignature)).append("\n");
    sb.append("    challengeChainIpVdf: ").append(toIndentedString(challengeChainIpVdf)).append("\n");
    sb.append("    rewardChainSpVdf: ").append(toIndentedString(rewardChainSpVdf)).append("\n");
    sb.append("    rewardChainSpSignature: ").append(toIndentedString(rewardChainSpSignature)).append("\n");
    sb.append("    rewardChainIpVdf: ").append(toIndentedString(rewardChainIpVdf)).append("\n");
    sb.append("    infusedChallengeChainIpVdf: ").append(toIndentedString(infusedChallengeChainIpVdf)).append("\n");
    sb.append("    isTransactionBlock: ").append(toIndentedString(isTransactionBlock)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("weight");
    openapiFields.add("height");
    openapiFields.add("total_iters");
    openapiFields.add("signage_point_index");
    openapiFields.add("pos_ss_cc_challenge_hash");
    openapiFields.add("proof_of_space");
    openapiFields.add("challenge_chain_sp_vdf");
    openapiFields.add("challenge_chain_sp_signature");
    openapiFields.add("challenge_chain_ip_vdf");
    openapiFields.add("reward_chain_sp_vdf");
    openapiFields.add("reward_chain_sp_signature");
    openapiFields.add("reward_chain_ip_vdf");
    openapiFields.add("infused_challenge_chain_ip_vdf");
    openapiFields.add("is_transaction_block");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to RewardChainBlock
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!RewardChainBlock.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in RewardChainBlock is not found in the empty JSON string", RewardChainBlock.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!RewardChainBlock.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `RewardChainBlock` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("pos_ss_cc_challenge_hash") != null && !jsonObj.get("pos_ss_cc_challenge_hash").isJsonNull()) && !jsonObj.get("pos_ss_cc_challenge_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pos_ss_cc_challenge_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pos_ss_cc_challenge_hash").toString()));
      }
      // validate the optional field `proof_of_space`
      if (jsonObj.get("proof_of_space") != null && !jsonObj.get("proof_of_space").isJsonNull()) {
        ProofOfSpace.validateJsonObject(jsonObj.getAsJsonObject("proof_of_space"));
      }
      // validate the optional field `challenge_chain_sp_vdf`
      if (jsonObj.get("challenge_chain_sp_vdf") != null && !jsonObj.get("challenge_chain_sp_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_sp_vdf"));
      }
      if ((jsonObj.get("challenge_chain_sp_signature") != null && !jsonObj.get("challenge_chain_sp_signature").isJsonNull()) && !jsonObj.get("challenge_chain_sp_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_chain_sp_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_chain_sp_signature").toString()));
      }
      // validate the optional field `challenge_chain_ip_vdf`
      if (jsonObj.get("challenge_chain_ip_vdf") != null && !jsonObj.get("challenge_chain_ip_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_ip_vdf"));
      }
      // validate the optional field `reward_chain_sp_vdf`
      if (jsonObj.get("reward_chain_sp_vdf") != null && !jsonObj.get("reward_chain_sp_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_sp_vdf"));
      }
      if ((jsonObj.get("reward_chain_sp_signature") != null && !jsonObj.get("reward_chain_sp_signature").isJsonNull()) && !jsonObj.get("reward_chain_sp_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_chain_sp_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_chain_sp_signature").toString()));
      }
      // validate the optional field `reward_chain_ip_vdf`
      if (jsonObj.get("reward_chain_ip_vdf") != null && !jsonObj.get("reward_chain_ip_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_ip_vdf"));
      }
      // validate the optional field `infused_challenge_chain_ip_vdf`
      if (jsonObj.get("infused_challenge_chain_ip_vdf") != null && !jsonObj.get("infused_challenge_chain_ip_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("infused_challenge_chain_ip_vdf"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!RewardChainBlock.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'RewardChainBlock' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<RewardChainBlock> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(RewardChainBlock.class));

       return (TypeAdapter<T>) new TypeAdapter<RewardChainBlock>() {
           @Override
           public void write(JsonWriter out, RewardChainBlock value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public RewardChainBlock read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of RewardChainBlock given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of RewardChainBlock
  * @throws IOException if the JSON string is invalid with respect to RewardChainBlock
  */
  public static RewardChainBlock fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, RewardChainBlock.class);
  }

 /**
  * Convert an instance of RewardChainBlock to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

