/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.ProofOfSpace;
import org.openapitools.client.model.VdfInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * RewardChainBlockUnfinished
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class RewardChainBlockUnfinished {
  public static final String SERIALIZED_NAME_TOTAL_ITERS = "total_iters";
  @SerializedName(SERIALIZED_NAME_TOTAL_ITERS)
  private Integer totalIters;

  public static final String SERIALIZED_NAME_SIGNAGE_POINT_INDEX = "signage_point_index";
  @SerializedName(SERIALIZED_NAME_SIGNAGE_POINT_INDEX)
  private Integer signagePointIndex;

  public static final String SERIALIZED_NAME_POS_SS_CC_CHALLENGE_HASH = "pos_ss_cc_challenge_hash";
  @SerializedName(SERIALIZED_NAME_POS_SS_CC_CHALLENGE_HASH)
  private String posSsCcChallengeHash;

  public static final String SERIALIZED_NAME_PROOF_OF_SPACE = "proof_of_space";
  @SerializedName(SERIALIZED_NAME_PROOF_OF_SPACE)
  private ProofOfSpace proofOfSpace;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_VDF = "challenge_chain_sp_vdf";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_VDF)
  private VdfInfo challengeChainSpVdf;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_SIGNATURE = "challenge_chain_sp_signature";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_SIGNATURE)
  private String challengeChainSpSignature;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_VDF = "reward_chain_sp_vdf";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_VDF)
  private VdfInfo rewardChainSpVdf;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_SIGNATURE = "reward_chain_sp_signature";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_SIGNATURE)
  private String rewardChainSpSignature;

  public RewardChainBlockUnfinished() {
  }

  public RewardChainBlockUnfinished totalIters(Integer totalIters) {
    
    this.totalIters = totalIters;
    return this;
  }

   /**
   * Get totalIters
   * @return totalIters
  **/
  @javax.annotation.Nullable

  public Integer getTotalIters() {
    return totalIters;
  }


  public void setTotalIters(Integer totalIters) {
    this.totalIters = totalIters;
  }


  public RewardChainBlockUnfinished signagePointIndex(Integer signagePointIndex) {
    
    this.signagePointIndex = signagePointIndex;
    return this;
  }

   /**
   * Get signagePointIndex
   * @return signagePointIndex
  **/
  @javax.annotation.Nullable

  public Integer getSignagePointIndex() {
    return signagePointIndex;
  }


  public void setSignagePointIndex(Integer signagePointIndex) {
    this.signagePointIndex = signagePointIndex;
  }


  public RewardChainBlockUnfinished posSsCcChallengeHash(String posSsCcChallengeHash) {
    
    this.posSsCcChallengeHash = posSsCcChallengeHash;
    return this;
  }

   /**
   * Get posSsCcChallengeHash
   * @return posSsCcChallengeHash
  **/
  @javax.annotation.Nullable

  public String getPosSsCcChallengeHash() {
    return posSsCcChallengeHash;
  }


  public void setPosSsCcChallengeHash(String posSsCcChallengeHash) {
    this.posSsCcChallengeHash = posSsCcChallengeHash;
  }


  public RewardChainBlockUnfinished proofOfSpace(ProofOfSpace proofOfSpace) {
    
    this.proofOfSpace = proofOfSpace;
    return this;
  }

   /**
   * Get proofOfSpace
   * @return proofOfSpace
  **/
  @javax.annotation.Nullable

  public ProofOfSpace getProofOfSpace() {
    return proofOfSpace;
  }


  public void setProofOfSpace(ProofOfSpace proofOfSpace) {
    this.proofOfSpace = proofOfSpace;
  }


  public RewardChainBlockUnfinished challengeChainSpVdf(VdfInfo challengeChainSpVdf) {
    
    this.challengeChainSpVdf = challengeChainSpVdf;
    return this;
  }

   /**
   * Get challengeChainSpVdf
   * @return challengeChainSpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getChallengeChainSpVdf() {
    return challengeChainSpVdf;
  }


  public void setChallengeChainSpVdf(VdfInfo challengeChainSpVdf) {
    this.challengeChainSpVdf = challengeChainSpVdf;
  }


  public RewardChainBlockUnfinished challengeChainSpSignature(String challengeChainSpSignature) {
    
    this.challengeChainSpSignature = challengeChainSpSignature;
    return this;
  }

   /**
   * Get challengeChainSpSignature
   * @return challengeChainSpSignature
  **/
  @javax.annotation.Nullable

  public String getChallengeChainSpSignature() {
    return challengeChainSpSignature;
  }


  public void setChallengeChainSpSignature(String challengeChainSpSignature) {
    this.challengeChainSpSignature = challengeChainSpSignature;
  }


  public RewardChainBlockUnfinished rewardChainSpVdf(VdfInfo rewardChainSpVdf) {
    
    this.rewardChainSpVdf = rewardChainSpVdf;
    return this;
  }

   /**
   * Get rewardChainSpVdf
   * @return rewardChainSpVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getRewardChainSpVdf() {
    return rewardChainSpVdf;
  }


  public void setRewardChainSpVdf(VdfInfo rewardChainSpVdf) {
    this.rewardChainSpVdf = rewardChainSpVdf;
  }


  public RewardChainBlockUnfinished rewardChainSpSignature(String rewardChainSpSignature) {
    
    this.rewardChainSpSignature = rewardChainSpSignature;
    return this;
  }

   /**
   * Get rewardChainSpSignature
   * @return rewardChainSpSignature
  **/
  @javax.annotation.Nullable

  public String getRewardChainSpSignature() {
    return rewardChainSpSignature;
  }


  public void setRewardChainSpSignature(String rewardChainSpSignature) {
    this.rewardChainSpSignature = rewardChainSpSignature;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RewardChainBlockUnfinished rewardChainBlockUnfinished = (RewardChainBlockUnfinished) o;
    return Objects.equals(this.totalIters, rewardChainBlockUnfinished.totalIters) &&
        Objects.equals(this.signagePointIndex, rewardChainBlockUnfinished.signagePointIndex) &&
        Objects.equals(this.posSsCcChallengeHash, rewardChainBlockUnfinished.posSsCcChallengeHash) &&
        Objects.equals(this.proofOfSpace, rewardChainBlockUnfinished.proofOfSpace) &&
        Objects.equals(this.challengeChainSpVdf, rewardChainBlockUnfinished.challengeChainSpVdf) &&
        Objects.equals(this.challengeChainSpSignature, rewardChainBlockUnfinished.challengeChainSpSignature) &&
        Objects.equals(this.rewardChainSpVdf, rewardChainBlockUnfinished.rewardChainSpVdf) &&
        Objects.equals(this.rewardChainSpSignature, rewardChainBlockUnfinished.rewardChainSpSignature);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalIters, signagePointIndex, posSsCcChallengeHash, proofOfSpace, challengeChainSpVdf, challengeChainSpSignature, rewardChainSpVdf, rewardChainSpSignature);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RewardChainBlockUnfinished {\n");
    sb.append("    totalIters: ").append(toIndentedString(totalIters)).append("\n");
    sb.append("    signagePointIndex: ").append(toIndentedString(signagePointIndex)).append("\n");
    sb.append("    posSsCcChallengeHash: ").append(toIndentedString(posSsCcChallengeHash)).append("\n");
    sb.append("    proofOfSpace: ").append(toIndentedString(proofOfSpace)).append("\n");
    sb.append("    challengeChainSpVdf: ").append(toIndentedString(challengeChainSpVdf)).append("\n");
    sb.append("    challengeChainSpSignature: ").append(toIndentedString(challengeChainSpSignature)).append("\n");
    sb.append("    rewardChainSpVdf: ").append(toIndentedString(rewardChainSpVdf)).append("\n");
    sb.append("    rewardChainSpSignature: ").append(toIndentedString(rewardChainSpSignature)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("total_iters");
    openapiFields.add("signage_point_index");
    openapiFields.add("pos_ss_cc_challenge_hash");
    openapiFields.add("proof_of_space");
    openapiFields.add("challenge_chain_sp_vdf");
    openapiFields.add("challenge_chain_sp_signature");
    openapiFields.add("reward_chain_sp_vdf");
    openapiFields.add("reward_chain_sp_signature");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to RewardChainBlockUnfinished
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!RewardChainBlockUnfinished.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in RewardChainBlockUnfinished is not found in the empty JSON string", RewardChainBlockUnfinished.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!RewardChainBlockUnfinished.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `RewardChainBlockUnfinished` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("pos_ss_cc_challenge_hash") != null && !jsonObj.get("pos_ss_cc_challenge_hash").isJsonNull()) && !jsonObj.get("pos_ss_cc_challenge_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pos_ss_cc_challenge_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pos_ss_cc_challenge_hash").toString()));
      }
      // validate the optional field `proof_of_space`
      if (jsonObj.get("proof_of_space") != null && !jsonObj.get("proof_of_space").isJsonNull()) {
        ProofOfSpace.validateJsonObject(jsonObj.getAsJsonObject("proof_of_space"));
      }
      // validate the optional field `challenge_chain_sp_vdf`
      if (jsonObj.get("challenge_chain_sp_vdf") != null && !jsonObj.get("challenge_chain_sp_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_sp_vdf"));
      }
      if ((jsonObj.get("challenge_chain_sp_signature") != null && !jsonObj.get("challenge_chain_sp_signature").isJsonNull()) && !jsonObj.get("challenge_chain_sp_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_chain_sp_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_chain_sp_signature").toString()));
      }
      // validate the optional field `reward_chain_sp_vdf`
      if (jsonObj.get("reward_chain_sp_vdf") != null && !jsonObj.get("reward_chain_sp_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_sp_vdf"));
      }
      if ((jsonObj.get("reward_chain_sp_signature") != null && !jsonObj.get("reward_chain_sp_signature").isJsonNull()) && !jsonObj.get("reward_chain_sp_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `reward_chain_sp_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("reward_chain_sp_signature").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!RewardChainBlockUnfinished.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'RewardChainBlockUnfinished' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<RewardChainBlockUnfinished> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(RewardChainBlockUnfinished.class));

       return (TypeAdapter<T>) new TypeAdapter<RewardChainBlockUnfinished>() {
           @Override
           public void write(JsonWriter out, RewardChainBlockUnfinished value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public RewardChainBlockUnfinished read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of RewardChainBlockUnfinished given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of RewardChainBlockUnfinished
  * @throws IOException if the JSON string is invalid with respect to RewardChainBlockUnfinished
  */
  public static RewardChainBlockUnfinished fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, RewardChainBlockUnfinished.class);
  }

 /**
  * Convert an instance of RewardChainBlockUnfinished to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

