/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.VdfInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * RewardChainSubSlot
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class RewardChainSubSlot {
  public static final String SERIALIZED_NAME_END_OF_SLOT_VDF = "end_of_slot_vdf";
  @SerializedName(SERIALIZED_NAME_END_OF_SLOT_VDF)
  private VdfInfo endOfSlotVdf;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SUB_SLOT_HASH = "challenge_chain_sub_slot_hash";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SUB_SLOT_HASH)
  private String challengeChainSubSlotHash;

  public static final String SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_SUB_SLOT_HASH = "infused_challenge_chain_sub_slot_hash";
  @SerializedName(SERIALIZED_NAME_INFUSED_CHALLENGE_CHAIN_SUB_SLOT_HASH)
  private String infusedChallengeChainSubSlotHash;

  public static final String SERIALIZED_NAME_DEFICIT = "deficit";
  @SerializedName(SERIALIZED_NAME_DEFICIT)
  private Integer deficit;

  public RewardChainSubSlot() {
  }

  public RewardChainSubSlot endOfSlotVdf(VdfInfo endOfSlotVdf) {
    
    this.endOfSlotVdf = endOfSlotVdf;
    return this;
  }

   /**
   * Get endOfSlotVdf
   * @return endOfSlotVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getEndOfSlotVdf() {
    return endOfSlotVdf;
  }


  public void setEndOfSlotVdf(VdfInfo endOfSlotVdf) {
    this.endOfSlotVdf = endOfSlotVdf;
  }


  public RewardChainSubSlot challengeChainSubSlotHash(String challengeChainSubSlotHash) {
    
    this.challengeChainSubSlotHash = challengeChainSubSlotHash;
    return this;
  }

   /**
   * Get challengeChainSubSlotHash
   * @return challengeChainSubSlotHash
  **/
  @javax.annotation.Nullable

  public String getChallengeChainSubSlotHash() {
    return challengeChainSubSlotHash;
  }


  public void setChallengeChainSubSlotHash(String challengeChainSubSlotHash) {
    this.challengeChainSubSlotHash = challengeChainSubSlotHash;
  }


  public RewardChainSubSlot infusedChallengeChainSubSlotHash(String infusedChallengeChainSubSlotHash) {
    
    this.infusedChallengeChainSubSlotHash = infusedChallengeChainSubSlotHash;
    return this;
  }

   /**
   * Get infusedChallengeChainSubSlotHash
   * @return infusedChallengeChainSubSlotHash
  **/
  @javax.annotation.Nullable

  public String getInfusedChallengeChainSubSlotHash() {
    return infusedChallengeChainSubSlotHash;
  }


  public void setInfusedChallengeChainSubSlotHash(String infusedChallengeChainSubSlotHash) {
    this.infusedChallengeChainSubSlotHash = infusedChallengeChainSubSlotHash;
  }


  public RewardChainSubSlot deficit(Integer deficit) {
    
    this.deficit = deficit;
    return this;
  }

   /**
   * Get deficit
   * @return deficit
  **/
  @javax.annotation.Nullable

  public Integer getDeficit() {
    return deficit;
  }


  public void setDeficit(Integer deficit) {
    this.deficit = deficit;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RewardChainSubSlot rewardChainSubSlot = (RewardChainSubSlot) o;
    return Objects.equals(this.endOfSlotVdf, rewardChainSubSlot.endOfSlotVdf) &&
        Objects.equals(this.challengeChainSubSlotHash, rewardChainSubSlot.challengeChainSubSlotHash) &&
        Objects.equals(this.infusedChallengeChainSubSlotHash, rewardChainSubSlot.infusedChallengeChainSubSlotHash) &&
        Objects.equals(this.deficit, rewardChainSubSlot.deficit);
  }

  @Override
  public int hashCode() {
    return Objects.hash(endOfSlotVdf, challengeChainSubSlotHash, infusedChallengeChainSubSlotHash, deficit);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RewardChainSubSlot {\n");
    sb.append("    endOfSlotVdf: ").append(toIndentedString(endOfSlotVdf)).append("\n");
    sb.append("    challengeChainSubSlotHash: ").append(toIndentedString(challengeChainSubSlotHash)).append("\n");
    sb.append("    infusedChallengeChainSubSlotHash: ").append(toIndentedString(infusedChallengeChainSubSlotHash)).append("\n");
    sb.append("    deficit: ").append(toIndentedString(deficit)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("end_of_slot_vdf");
    openapiFields.add("challenge_chain_sub_slot_hash");
    openapiFields.add("infused_challenge_chain_sub_slot_hash");
    openapiFields.add("deficit");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to RewardChainSubSlot
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!RewardChainSubSlot.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in RewardChainSubSlot is not found in the empty JSON string", RewardChainSubSlot.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!RewardChainSubSlot.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `RewardChainSubSlot` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `end_of_slot_vdf`
      if (jsonObj.get("end_of_slot_vdf") != null && !jsonObj.get("end_of_slot_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("end_of_slot_vdf"));
      }
      if ((jsonObj.get("challenge_chain_sub_slot_hash") != null && !jsonObj.get("challenge_chain_sub_slot_hash").isJsonNull()) && !jsonObj.get("challenge_chain_sub_slot_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `challenge_chain_sub_slot_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("challenge_chain_sub_slot_hash").toString()));
      }
      if ((jsonObj.get("infused_challenge_chain_sub_slot_hash") != null && !jsonObj.get("infused_challenge_chain_sub_slot_hash").isJsonNull()) && !jsonObj.get("infused_challenge_chain_sub_slot_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `infused_challenge_chain_sub_slot_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("infused_challenge_chain_sub_slot_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!RewardChainSubSlot.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'RewardChainSubSlot' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<RewardChainSubSlot> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(RewardChainSubSlot.class));

       return (TypeAdapter<T>) new TypeAdapter<RewardChainSubSlot>() {
           @Override
           public void write(JsonWriter out, RewardChainSubSlot value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public RewardChainSubSlot read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of RewardChainSubSlot given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of RewardChainSubSlot
  * @throws IOException if the JSON string is invalid with respect to RewardChainSubSlot
  */
  public static RewardChainSubSlot fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, RewardChainSubSlot.class);
  }

 /**
  * Convert an instance of RewardChainSubSlot to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

