/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.VdfInfo;
import org.openapitools.client.model.VdfProof;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SignagePoint
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class SignagePoint {
  public static final String SERIALIZED_NAME_CC_VDF = "cc_vdf";
  @SerializedName(SERIALIZED_NAME_CC_VDF)
  private VdfInfo ccVdf;

  public static final String SERIALIZED_NAME_CC_PROOF = "cc_proof";
  @SerializedName(SERIALIZED_NAME_CC_PROOF)
  private VdfProof ccProof;

  public static final String SERIALIZED_NAME_RC_VDF = "rc_vdf";
  @SerializedName(SERIALIZED_NAME_RC_VDF)
  private VdfInfo rcVdf;

  public static final String SERIALIZED_NAME_RC_PROOF = "rc_proof";
  @SerializedName(SERIALIZED_NAME_RC_PROOF)
  private VdfProof rcProof;

  public SignagePoint() {
  }

  public SignagePoint ccVdf(VdfInfo ccVdf) {
    
    this.ccVdf = ccVdf;
    return this;
  }

   /**
   * Get ccVdf
   * @return ccVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getCcVdf() {
    return ccVdf;
  }


  public void setCcVdf(VdfInfo ccVdf) {
    this.ccVdf = ccVdf;
  }


  public SignagePoint ccProof(VdfProof ccProof) {
    
    this.ccProof = ccProof;
    return this;
  }

   /**
   * Get ccProof
   * @return ccProof
  **/
  @javax.annotation.Nullable

  public VdfProof getCcProof() {
    return ccProof;
  }


  public void setCcProof(VdfProof ccProof) {
    this.ccProof = ccProof;
  }


  public SignagePoint rcVdf(VdfInfo rcVdf) {
    
    this.rcVdf = rcVdf;
    return this;
  }

   /**
   * Get rcVdf
   * @return rcVdf
  **/
  @javax.annotation.Nullable

  public VdfInfo getRcVdf() {
    return rcVdf;
  }


  public void setRcVdf(VdfInfo rcVdf) {
    this.rcVdf = rcVdf;
  }


  public SignagePoint rcProof(VdfProof rcProof) {
    
    this.rcProof = rcProof;
    return this;
  }

   /**
   * Get rcProof
   * @return rcProof
  **/
  @javax.annotation.Nullable

  public VdfProof getRcProof() {
    return rcProof;
  }


  public void setRcProof(VdfProof rcProof) {
    this.rcProof = rcProof;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SignagePoint signagePoint = (SignagePoint) o;
    return Objects.equals(this.ccVdf, signagePoint.ccVdf) &&
        Objects.equals(this.ccProof, signagePoint.ccProof) &&
        Objects.equals(this.rcVdf, signagePoint.rcVdf) &&
        Objects.equals(this.rcProof, signagePoint.rcProof);
  }

  @Override
  public int hashCode() {
    return Objects.hash(ccVdf, ccProof, rcVdf, rcProof);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SignagePoint {\n");
    sb.append("    ccVdf: ").append(toIndentedString(ccVdf)).append("\n");
    sb.append("    ccProof: ").append(toIndentedString(ccProof)).append("\n");
    sb.append("    rcVdf: ").append(toIndentedString(rcVdf)).append("\n");
    sb.append("    rcProof: ").append(toIndentedString(rcProof)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("cc_vdf");
    openapiFields.add("cc_proof");
    openapiFields.add("rc_vdf");
    openapiFields.add("rc_proof");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SignagePoint
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SignagePoint.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SignagePoint is not found in the empty JSON string", SignagePoint.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SignagePoint.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SignagePoint` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `cc_vdf`
      if (jsonObj.get("cc_vdf") != null && !jsonObj.get("cc_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("cc_vdf"));
      }
      // validate the optional field `cc_proof`
      if (jsonObj.get("cc_proof") != null && !jsonObj.get("cc_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("cc_proof"));
      }
      // validate the optional field `rc_vdf`
      if (jsonObj.get("rc_vdf") != null && !jsonObj.get("rc_vdf").isJsonNull()) {
        VdfInfo.validateJsonObject(jsonObj.getAsJsonObject("rc_vdf"));
      }
      // validate the optional field `rc_proof`
      if (jsonObj.get("rc_proof") != null && !jsonObj.get("rc_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("rc_proof"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SignagePoint.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SignagePoint' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SignagePoint> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SignagePoint.class));

       return (TypeAdapter<T>) new TypeAdapter<SignagePoint>() {
           @Override
           public void write(JsonWriter out, SignagePoint value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SignagePoint read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SignagePoint given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SignagePoint
  * @throws IOException if the JSON string is invalid with respect to SignagePoint
  */
  public static SignagePoint fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SignagePoint.class);
  }

 /**
  * Convert an instance of SignagePoint to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

