/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * TransactionsInfo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class TransactionsInfo {
  public static final String SERIALIZED_NAME_GENERATOR_ROOT = "generator_root";
  @SerializedName(SERIALIZED_NAME_GENERATOR_ROOT)
  private String generatorRoot;

  public static final String SERIALIZED_NAME_GENERATOR_REFS_ROOT = "generator_refs_root";
  @SerializedName(SERIALIZED_NAME_GENERATOR_REFS_ROOT)
  private String generatorRefsRoot;

  public static final String SERIALIZED_NAME_AGGREGATED_SIGNATURE = "aggregated_signature";
  @SerializedName(SERIALIZED_NAME_AGGREGATED_SIGNATURE)
  private String aggregatedSignature;

  public static final String SERIALIZED_NAME_FEES = "fees";
  @SerializedName(SERIALIZED_NAME_FEES)
  private Integer fees;

  public static final String SERIALIZED_NAME_COST = "cost";
  @SerializedName(SERIALIZED_NAME_COST)
  private Integer cost;

  public static final String SERIALIZED_NAME_REWARD_CLAIMS_INCORPORATED = "reward_claims_incorporated";
  @SerializedName(SERIALIZED_NAME_REWARD_CLAIMS_INCORPORATED)
  private List<Coin> rewardClaimsIncorporated;

  public TransactionsInfo() {
  }

  public TransactionsInfo generatorRoot(String generatorRoot) {
    
    this.generatorRoot = generatorRoot;
    return this;
  }

   /**
   * Get generatorRoot
   * @return generatorRoot
  **/
  @javax.annotation.Nullable

  public String getGeneratorRoot() {
    return generatorRoot;
  }


  public void setGeneratorRoot(String generatorRoot) {
    this.generatorRoot = generatorRoot;
  }


  public TransactionsInfo generatorRefsRoot(String generatorRefsRoot) {
    
    this.generatorRefsRoot = generatorRefsRoot;
    return this;
  }

   /**
   * Get generatorRefsRoot
   * @return generatorRefsRoot
  **/
  @javax.annotation.Nullable

  public String getGeneratorRefsRoot() {
    return generatorRefsRoot;
  }


  public void setGeneratorRefsRoot(String generatorRefsRoot) {
    this.generatorRefsRoot = generatorRefsRoot;
  }


  public TransactionsInfo aggregatedSignature(String aggregatedSignature) {
    
    this.aggregatedSignature = aggregatedSignature;
    return this;
  }

   /**
   * Get aggregatedSignature
   * @return aggregatedSignature
  **/
  @javax.annotation.Nullable

  public String getAggregatedSignature() {
    return aggregatedSignature;
  }


  public void setAggregatedSignature(String aggregatedSignature) {
    this.aggregatedSignature = aggregatedSignature;
  }


  public TransactionsInfo fees(Integer fees) {
    
    this.fees = fees;
    return this;
  }

   /**
   * Get fees
   * @return fees
  **/
  @javax.annotation.Nullable

  public Integer getFees() {
    return fees;
  }


  public void setFees(Integer fees) {
    this.fees = fees;
  }


  public TransactionsInfo cost(Integer cost) {
    
    this.cost = cost;
    return this;
  }

   /**
   * Get cost
   * @return cost
  **/
  @javax.annotation.Nullable

  public Integer getCost() {
    return cost;
  }


  public void setCost(Integer cost) {
    this.cost = cost;
  }


  public TransactionsInfo rewardClaimsIncorporated(List<Coin> rewardClaimsIncorporated) {
    
    this.rewardClaimsIncorporated = rewardClaimsIncorporated;
    return this;
  }

  public TransactionsInfo addRewardClaimsIncorporatedItem(Coin rewardClaimsIncorporatedItem) {
    if (this.rewardClaimsIncorporated == null) {
      this.rewardClaimsIncorporated = new ArrayList<>();
    }
    this.rewardClaimsIncorporated.add(rewardClaimsIncorporatedItem);
    return this;
  }

   /**
   * Get rewardClaimsIncorporated
   * @return rewardClaimsIncorporated
  **/
  @javax.annotation.Nullable

  public List<Coin> getRewardClaimsIncorporated() {
    return rewardClaimsIncorporated;
  }


  public void setRewardClaimsIncorporated(List<Coin> rewardClaimsIncorporated) {
    this.rewardClaimsIncorporated = rewardClaimsIncorporated;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TransactionsInfo transactionsInfo = (TransactionsInfo) o;
    return Objects.equals(this.generatorRoot, transactionsInfo.generatorRoot) &&
        Objects.equals(this.generatorRefsRoot, transactionsInfo.generatorRefsRoot) &&
        Objects.equals(this.aggregatedSignature, transactionsInfo.aggregatedSignature) &&
        Objects.equals(this.fees, transactionsInfo.fees) &&
        Objects.equals(this.cost, transactionsInfo.cost) &&
        Objects.equals(this.rewardClaimsIncorporated, transactionsInfo.rewardClaimsIncorporated);
  }

  @Override
  public int hashCode() {
    return Objects.hash(generatorRoot, generatorRefsRoot, aggregatedSignature, fees, cost, rewardClaimsIncorporated);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TransactionsInfo {\n");
    sb.append("    generatorRoot: ").append(toIndentedString(generatorRoot)).append("\n");
    sb.append("    generatorRefsRoot: ").append(toIndentedString(generatorRefsRoot)).append("\n");
    sb.append("    aggregatedSignature: ").append(toIndentedString(aggregatedSignature)).append("\n");
    sb.append("    fees: ").append(toIndentedString(fees)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("    rewardClaimsIncorporated: ").append(toIndentedString(rewardClaimsIncorporated)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("generator_root");
    openapiFields.add("generator_refs_root");
    openapiFields.add("aggregated_signature");
    openapiFields.add("fees");
    openapiFields.add("cost");
    openapiFields.add("reward_claims_incorporated");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to TransactionsInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!TransactionsInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in TransactionsInfo is not found in the empty JSON string", TransactionsInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!TransactionsInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `TransactionsInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("generator_root") != null && !jsonObj.get("generator_root").isJsonNull()) && !jsonObj.get("generator_root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `generator_root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("generator_root").toString()));
      }
      if ((jsonObj.get("generator_refs_root") != null && !jsonObj.get("generator_refs_root").isJsonNull()) && !jsonObj.get("generator_refs_root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `generator_refs_root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("generator_refs_root").toString()));
      }
      if ((jsonObj.get("aggregated_signature") != null && !jsonObj.get("aggregated_signature").isJsonNull()) && !jsonObj.get("aggregated_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `aggregated_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("aggregated_signature").toString()));
      }
      if (jsonObj.get("reward_claims_incorporated") != null && !jsonObj.get("reward_claims_incorporated").isJsonNull()) {
        JsonArray jsonArrayrewardClaimsIncorporated = jsonObj.getAsJsonArray("reward_claims_incorporated");
        if (jsonArrayrewardClaimsIncorporated != null) {
          // ensure the json data is an array
          if (!jsonObj.get("reward_claims_incorporated").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `reward_claims_incorporated` to be an array in the JSON string but got `%s`", jsonObj.get("reward_claims_incorporated").toString()));
          }

          // validate the optional field `reward_claims_incorporated` (array)
          for (int i = 0; i < jsonArrayrewardClaimsIncorporated.size(); i++) {
            Coin.validateJsonObject(jsonArrayrewardClaimsIncorporated.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!TransactionsInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'TransactionsInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<TransactionsInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(TransactionsInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<TransactionsInfo>() {
           @Override
           public void write(JsonWriter out, TransactionsInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public TransactionsInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of TransactionsInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of TransactionsInfo
  * @throws IOException if the JSON string is invalid with respect to TransactionsInfo
  */
  public static TransactionsInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, TransactionsInfo.class);
  }

 /**
  * Convert an instance of TransactionsInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

