/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.EndOfSubSlotBundle;
import org.openapitools.client.model.Foliage;
import org.openapitools.client.model.FoliageTransactionBlock;
import org.openapitools.client.model.RewardChainBlockUnfinished;
import org.openapitools.client.model.VdfProof;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * UnfinishedHeaderBlock
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class UnfinishedHeaderBlock {
  public static final String SERIALIZED_NAME_FINISHED_SUB_SLOTS = "finished_sub_slots";
  @SerializedName(SERIALIZED_NAME_FINISHED_SUB_SLOTS)
  private List<EndOfSubSlotBundle> finishedSubSlots;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_BLOCK = "reward_chain_block";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_BLOCK)
  private RewardChainBlockUnfinished rewardChainBlock;

  public static final String SERIALIZED_NAME_CHALLENGE_CHAIN_SP_PROOF = "challenge_chain_sp_proof";
  @SerializedName(SERIALIZED_NAME_CHALLENGE_CHAIN_SP_PROOF)
  private VdfProof challengeChainSpProof;

  public static final String SERIALIZED_NAME_REWARD_CHAIN_SP_PROOF = "reward_chain_sp_proof";
  @SerializedName(SERIALIZED_NAME_REWARD_CHAIN_SP_PROOF)
  private VdfProof rewardChainSpProof;

  public static final String SERIALIZED_NAME_FOLIAGE = "foliage";
  @SerializedName(SERIALIZED_NAME_FOLIAGE)
  private Foliage foliage;

  public static final String SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK = "foliage_transaction_block";
  @SerializedName(SERIALIZED_NAME_FOLIAGE_TRANSACTION_BLOCK)
  private FoliageTransactionBlock foliageTransactionBlock;

  public static final String SERIALIZED_NAME_TRANSACTIONS_FILTER = "transactions_filter";
  @SerializedName(SERIALIZED_NAME_TRANSACTIONS_FILTER)
  private String transactionsFilter;

  public UnfinishedHeaderBlock() {
  }

  public UnfinishedHeaderBlock finishedSubSlots(List<EndOfSubSlotBundle> finishedSubSlots) {
    
    this.finishedSubSlots = finishedSubSlots;
    return this;
  }

  public UnfinishedHeaderBlock addFinishedSubSlotsItem(EndOfSubSlotBundle finishedSubSlotsItem) {
    if (this.finishedSubSlots == null) {
      this.finishedSubSlots = new ArrayList<>();
    }
    this.finishedSubSlots.add(finishedSubSlotsItem);
    return this;
  }

   /**
   * Get finishedSubSlots
   * @return finishedSubSlots
  **/
  @javax.annotation.Nullable

  public List<EndOfSubSlotBundle> getFinishedSubSlots() {
    return finishedSubSlots;
  }


  public void setFinishedSubSlots(List<EndOfSubSlotBundle> finishedSubSlots) {
    this.finishedSubSlots = finishedSubSlots;
  }


  public UnfinishedHeaderBlock rewardChainBlock(RewardChainBlockUnfinished rewardChainBlock) {
    
    this.rewardChainBlock = rewardChainBlock;
    return this;
  }

   /**
   * Get rewardChainBlock
   * @return rewardChainBlock
  **/
  @javax.annotation.Nullable

  public RewardChainBlockUnfinished getRewardChainBlock() {
    return rewardChainBlock;
  }


  public void setRewardChainBlock(RewardChainBlockUnfinished rewardChainBlock) {
    this.rewardChainBlock = rewardChainBlock;
  }


  public UnfinishedHeaderBlock challengeChainSpProof(VdfProof challengeChainSpProof) {
    
    this.challengeChainSpProof = challengeChainSpProof;
    return this;
  }

   /**
   * Get challengeChainSpProof
   * @return challengeChainSpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getChallengeChainSpProof() {
    return challengeChainSpProof;
  }


  public void setChallengeChainSpProof(VdfProof challengeChainSpProof) {
    this.challengeChainSpProof = challengeChainSpProof;
  }


  public UnfinishedHeaderBlock rewardChainSpProof(VdfProof rewardChainSpProof) {
    
    this.rewardChainSpProof = rewardChainSpProof;
    return this;
  }

   /**
   * Get rewardChainSpProof
   * @return rewardChainSpProof
  **/
  @javax.annotation.Nullable

  public VdfProof getRewardChainSpProof() {
    return rewardChainSpProof;
  }


  public void setRewardChainSpProof(VdfProof rewardChainSpProof) {
    this.rewardChainSpProof = rewardChainSpProof;
  }


  public UnfinishedHeaderBlock foliage(Foliage foliage) {
    
    this.foliage = foliage;
    return this;
  }

   /**
   * Get foliage
   * @return foliage
  **/
  @javax.annotation.Nullable

  public Foliage getFoliage() {
    return foliage;
  }


  public void setFoliage(Foliage foliage) {
    this.foliage = foliage;
  }


  public UnfinishedHeaderBlock foliageTransactionBlock(FoliageTransactionBlock foliageTransactionBlock) {
    
    this.foliageTransactionBlock = foliageTransactionBlock;
    return this;
  }

   /**
   * Get foliageTransactionBlock
   * @return foliageTransactionBlock
  **/
  @javax.annotation.Nullable

  public FoliageTransactionBlock getFoliageTransactionBlock() {
    return foliageTransactionBlock;
  }


  public void setFoliageTransactionBlock(FoliageTransactionBlock foliageTransactionBlock) {
    this.foliageTransactionBlock = foliageTransactionBlock;
  }


  public UnfinishedHeaderBlock transactionsFilter(String transactionsFilter) {
    
    this.transactionsFilter = transactionsFilter;
    return this;
  }

   /**
   * Get transactionsFilter
   * @return transactionsFilter
  **/
  @javax.annotation.Nullable

  public String getTransactionsFilter() {
    return transactionsFilter;
  }


  public void setTransactionsFilter(String transactionsFilter) {
    this.transactionsFilter = transactionsFilter;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UnfinishedHeaderBlock unfinishedHeaderBlock = (UnfinishedHeaderBlock) o;
    return Objects.equals(this.finishedSubSlots, unfinishedHeaderBlock.finishedSubSlots) &&
        Objects.equals(this.rewardChainBlock, unfinishedHeaderBlock.rewardChainBlock) &&
        Objects.equals(this.challengeChainSpProof, unfinishedHeaderBlock.challengeChainSpProof) &&
        Objects.equals(this.rewardChainSpProof, unfinishedHeaderBlock.rewardChainSpProof) &&
        Objects.equals(this.foliage, unfinishedHeaderBlock.foliage) &&
        Objects.equals(this.foliageTransactionBlock, unfinishedHeaderBlock.foliageTransactionBlock) &&
        Objects.equals(this.transactionsFilter, unfinishedHeaderBlock.transactionsFilter);
  }

  @Override
  public int hashCode() {
    return Objects.hash(finishedSubSlots, rewardChainBlock, challengeChainSpProof, rewardChainSpProof, foliage, foliageTransactionBlock, transactionsFilter);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UnfinishedHeaderBlock {\n");
    sb.append("    finishedSubSlots: ").append(toIndentedString(finishedSubSlots)).append("\n");
    sb.append("    rewardChainBlock: ").append(toIndentedString(rewardChainBlock)).append("\n");
    sb.append("    challengeChainSpProof: ").append(toIndentedString(challengeChainSpProof)).append("\n");
    sb.append("    rewardChainSpProof: ").append(toIndentedString(rewardChainSpProof)).append("\n");
    sb.append("    foliage: ").append(toIndentedString(foliage)).append("\n");
    sb.append("    foliageTransactionBlock: ").append(toIndentedString(foliageTransactionBlock)).append("\n");
    sb.append("    transactionsFilter: ").append(toIndentedString(transactionsFilter)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("finished_sub_slots");
    openapiFields.add("reward_chain_block");
    openapiFields.add("challenge_chain_sp_proof");
    openapiFields.add("reward_chain_sp_proof");
    openapiFields.add("foliage");
    openapiFields.add("foliage_transaction_block");
    openapiFields.add("transactions_filter");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to UnfinishedHeaderBlock
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!UnfinishedHeaderBlock.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in UnfinishedHeaderBlock is not found in the empty JSON string", UnfinishedHeaderBlock.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!UnfinishedHeaderBlock.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `UnfinishedHeaderBlock` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("finished_sub_slots") != null && !jsonObj.get("finished_sub_slots").isJsonNull()) {
        JsonArray jsonArrayfinishedSubSlots = jsonObj.getAsJsonArray("finished_sub_slots");
        if (jsonArrayfinishedSubSlots != null) {
          // ensure the json data is an array
          if (!jsonObj.get("finished_sub_slots").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `finished_sub_slots` to be an array in the JSON string but got `%s`", jsonObj.get("finished_sub_slots").toString()));
          }

          // validate the optional field `finished_sub_slots` (array)
          for (int i = 0; i < jsonArrayfinishedSubSlots.size(); i++) {
            EndOfSubSlotBundle.validateJsonObject(jsonArrayfinishedSubSlots.get(i).getAsJsonObject());
          };
        }
      }
      // validate the optional field `reward_chain_block`
      if (jsonObj.get("reward_chain_block") != null && !jsonObj.get("reward_chain_block").isJsonNull()) {
        RewardChainBlockUnfinished.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_block"));
      }
      // validate the optional field `challenge_chain_sp_proof`
      if (jsonObj.get("challenge_chain_sp_proof") != null && !jsonObj.get("challenge_chain_sp_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("challenge_chain_sp_proof"));
      }
      // validate the optional field `reward_chain_sp_proof`
      if (jsonObj.get("reward_chain_sp_proof") != null && !jsonObj.get("reward_chain_sp_proof").isJsonNull()) {
        VdfProof.validateJsonObject(jsonObj.getAsJsonObject("reward_chain_sp_proof"));
      }
      // validate the optional field `foliage`
      if (jsonObj.get("foliage") != null && !jsonObj.get("foliage").isJsonNull()) {
        Foliage.validateJsonObject(jsonObj.getAsJsonObject("foliage"));
      }
      // validate the optional field `foliage_transaction_block`
      if (jsonObj.get("foliage_transaction_block") != null && !jsonObj.get("foliage_transaction_block").isJsonNull()) {
        FoliageTransactionBlock.validateJsonObject(jsonObj.getAsJsonObject("foliage_transaction_block"));
      }
      if ((jsonObj.get("transactions_filter") != null && !jsonObj.get("transactions_filter").isJsonNull()) && !jsonObj.get("transactions_filter").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `transactions_filter` to be a primitive type in the JSON string but got `%s`", jsonObj.get("transactions_filter").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!UnfinishedHeaderBlock.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'UnfinishedHeaderBlock' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<UnfinishedHeaderBlock> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(UnfinishedHeaderBlock.class));

       return (TypeAdapter<T>) new TypeAdapter<UnfinishedHeaderBlock>() {
           @Override
           public void write(JsonWriter out, UnfinishedHeaderBlock value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public UnfinishedHeaderBlock read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of UnfinishedHeaderBlock given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of UnfinishedHeaderBlock
  * @throws IOException if the JSON string is invalid with respect to UnfinishedHeaderBlock
  */
  public static UnfinishedHeaderBlock fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, UnfinishedHeaderBlock.class);
  }

 /**
  * Convert an instance of UnfinishedHeaderBlock to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

