/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * VdfProof
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:05:15.064688400-04:00[America/New_York]")
public class VdfProof {
  public static final String SERIALIZED_NAME_WITNESS_TYPE = "witness_type";
  @SerializedName(SERIALIZED_NAME_WITNESS_TYPE)
  private Integer witnessType;

  public static final String SERIALIZED_NAME_WITNESS = "witness";
  @SerializedName(SERIALIZED_NAME_WITNESS)
  private String witness;

  public static final String SERIALIZED_NAME_NORMALIZED_TO_IDENTITY = "normalized_to_identity";
  @SerializedName(SERIALIZED_NAME_NORMALIZED_TO_IDENTITY)
  private Boolean normalizedToIdentity;

  public VdfProof() {
  }

  public VdfProof witnessType(Integer witnessType) {
    
    this.witnessType = witnessType;
    return this;
  }

   /**
   * Get witnessType
   * @return witnessType
  **/
  @javax.annotation.Nullable

  public Integer getWitnessType() {
    return witnessType;
  }


  public void setWitnessType(Integer witnessType) {
    this.witnessType = witnessType;
  }


  public VdfProof witness(String witness) {
    
    this.witness = witness;
    return this;
  }

   /**
   * Get witness
   * @return witness
  **/
  @javax.annotation.Nullable

  public String getWitness() {
    return witness;
  }


  public void setWitness(String witness) {
    this.witness = witness;
  }


  public VdfProof normalizedToIdentity(Boolean normalizedToIdentity) {
    
    this.normalizedToIdentity = normalizedToIdentity;
    return this;
  }

   /**
   * Get normalizedToIdentity
   * @return normalizedToIdentity
  **/
  @javax.annotation.Nullable

  public Boolean getNormalizedToIdentity() {
    return normalizedToIdentity;
  }


  public void setNormalizedToIdentity(Boolean normalizedToIdentity) {
    this.normalizedToIdentity = normalizedToIdentity;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VdfProof vdfProof = (VdfProof) o;
    return Objects.equals(this.witnessType, vdfProof.witnessType) &&
        Objects.equals(this.witness, vdfProof.witness) &&
        Objects.equals(this.normalizedToIdentity, vdfProof.normalizedToIdentity);
  }

  @Override
  public int hashCode() {
    return Objects.hash(witnessType, witness, normalizedToIdentity);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VdfProof {\n");
    sb.append("    witnessType: ").append(toIndentedString(witnessType)).append("\n");
    sb.append("    witness: ").append(toIndentedString(witness)).append("\n");
    sb.append("    normalizedToIdentity: ").append(toIndentedString(normalizedToIdentity)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("witness_type");
    openapiFields.add("witness");
    openapiFields.add("normalized_to_identity");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to VdfProof
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!VdfProof.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in VdfProof is not found in the empty JSON string", VdfProof.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!VdfProof.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `VdfProof` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("witness") != null && !jsonObj.get("witness").isJsonNull()) && !jsonObj.get("witness").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `witness` to be a primitive type in the JSON string but got `%s`", jsonObj.get("witness").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!VdfProof.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'VdfProof' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<VdfProof> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(VdfProof.class));

       return (TypeAdapter<T>) new TypeAdapter<VdfProof>() {
           @Override
           public void write(JsonWriter out, VdfProof value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public VdfProof read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of VdfProof given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of VdfProof
  * @throws IOException if the JSON string is invalid with respect to VdfProof
  */
  public static VdfProof fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, VdfProof.class);
  }

 /**
  * Convert an instance of VdfProof to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

