/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetAdditionsAndRemovals200Response;
import org.openapitools.client.model.GetBlock200Response;
import org.openapitools.client.model.GetBlockCountMetrics200Response;
import org.openapitools.client.model.GetBlockRecord200Response;
import org.openapitools.client.model.GetBlockRecordByHeightRequest;
import org.openapitools.client.model.GetBlockRecordRequest;
import org.openapitools.client.model.GetBlockRecords200Response;
import org.openapitools.client.model.GetBlockRecordsRequest;
import org.openapitools.client.model.GetBlockSpends200Response;
import org.openapitools.client.model.GetBlocks200Response;
import org.openapitools.client.model.GetBlocksRequest;
import org.openapitools.client.model.GetRecentSignagePointOrEos200Response;
import org.openapitools.client.model.GetRecentSignagePointOrEosRequest;
import org.openapitools.client.model.GetUnfinishedBlockHeaders200Response;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for BlocksApi
 */
@Disabled
public class BlocksApiTest {

    private final BlocksApi api = new BlocksApi();

    /**
     * Retrieves the additions and removals for a certain block.
     *
     * Retrieves the additions and removals (state transitions) for a certain block. Returns coin records for each addition and removal.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getAdditionsAndRemovalsTest() throws ApiException {
        GetBlockRecordRequest getBlockRecordRequest = null;
        GetAdditionsAndRemovals200Response response = api.getAdditionsAndRemovals(getBlockRecordRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a block by header hash.
     *
     * Retrieves a block by header hash.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockTest() throws ApiException {
        GetBlockRecordRequest getBlockRecordRequest = null;
        GetBlock200Response response = api.getBlock(getBlockRecordRequest);
        // TODO: test validations
    }

    /**
     * Retrieves aggregate information about blocks.
     *
     * Retrieves aggregate information about blocks.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockCountMetricsTest() throws ApiException {
        Object body = null;
        GetBlockCountMetrics200Response response = api.getBlockCountMetrics(body);
        // TODO: test validations
    }

    /**
     * Retrieves a block record by header hash.
     *
     * Retrieves a block record by header hash.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockRecordTest() throws ApiException {
        GetBlockRecordRequest getBlockRecordRequest = null;
        GetBlockRecord200Response response = api.getBlockRecord(getBlockRecordRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a block record by height.
     *
     * Retrieves a block record by height (assuming the height &lt;&#x3D; peak height). Note that not all blocks will have all fields set here (depending on transaction block, finishing sub epoch, etc).
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockRecordByHeightTest() throws ApiException {
        GetBlockRecordByHeightRequest getBlockRecordByHeightRequest = null;
        GetBlockRecord200Response response = api.getBlockRecordByHeight(getBlockRecordByHeightRequest);
        // TODO: test validations
    }

    /**
     * Retrieves block records in a range.
     *
     * Retrieves block records in a range
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockRecordsTest() throws ApiException {
        GetBlockRecordsRequest getBlockRecordsRequest = null;
        GetBlockRecords200Response response = api.getBlockRecords(getBlockRecordsRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the spends in the given block.
     *
     * Retrieves the spends in the given block.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlockSpendsTest() throws ApiException {
        GetBlockRecordRequest getBlockRecordRequest = null;
        GetBlockSpends200Response response = api.getBlockSpends(getBlockRecordRequest);
        // TODO: test validations
    }

    /**
     * Get the blocks between a start and end height.
     *
     * Get the blocks between a start and end height
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getBlocksTest() throws ApiException {
        GetBlocksRequest getBlocksRequest = null;
        GetBlocks200Response response = api.getBlocks(getBlocksRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a recent signage point or end of slot.
     *
     * Retrieves a recent signage point or end of slot.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRecentSignagePointOrEosTest() throws ApiException {
        GetRecentSignagePointOrEosRequest getRecentSignagePointOrEosRequest = null;
        GetRecentSignagePointOrEos200Response response = api.getRecentSignagePointOrEos(getRecentSignagePointOrEosRequest);
        // TODO: test validations
    }

    /**
     * Retrieves unfinished block headers.
     *
     * Retrieves unfinished block headers.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getUnfinishedBlockHeadersTest() throws ApiException {
        Object body = null;
        GetUnfinishedBlockHeaders200Response response = api.getUnfinishedBlockHeaders(body);
        // TODO: test validations
    }

}
