/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetCoinRecordByName200Response;
import org.openapitools.client.model.GetCoinRecordByNameRequest;
import org.openapitools.client.model.GetCoinRecordsByHintRequest;
import org.openapitools.client.model.GetCoinRecordsByNamesRequest;
import org.openapitools.client.model.GetCoinRecordsByParentIdsRequest;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHash200Response;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHashRequest;
import org.openapitools.client.model.GetCoinRecordsByPuzzleHashesRequest;
import org.openapitools.client.model.GetPuzzleAndSolution200Response;
import org.openapitools.client.model.GetPuzzleAndSolutionRequest;
import org.openapitools.client.model.PushTx200Response;
import org.openapitools.client.model.PushTxRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for CoinsApi
 */
@Disabled
public class CoinsApiTest {

    private final CoinsApi api = new CoinsApi();

    /**
     * Retrieves a coin record by it&#39;s name.
     *
     * Retrieves a coin record by it&#39;s name.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordByNameTest() throws ApiException {
        GetCoinRecordByNameRequest getCoinRecordByNameRequest = null;
        GetCoinRecordByName200Response response = api.getCoinRecordByName(getCoinRecordByNameRequest);
        // TODO: test validations
    }

    /**
     * Retrieves coins by hint.
     *
     * Retrieves coins by hint, by default returns unspent coins.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordsByHintTest() throws ApiException {
        GetCoinRecordsByHintRequest getCoinRecordsByHintRequest = null;
        GetCoinRecordsByPuzzleHash200Response response = api.getCoinRecordsByHint(getCoinRecordsByHintRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the coins for given coin IDs.
     *
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordsByNamesTest() throws ApiException {
        GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest = null;
        GetCoinRecordsByPuzzleHash200Response response = api.getCoinRecordsByNames(getCoinRecordsByNamesRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the coins for given parent coin IDs.
     *
     * Retrieves the coins for given parent coin IDs, by default returns unspent coins.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordsByParentIdsTest() throws ApiException {
        GetCoinRecordsByParentIdsRequest getCoinRecordsByParentIdsRequest = null;
        GetCoinRecordsByPuzzleHash200Response response = api.getCoinRecordsByParentIds(getCoinRecordsByParentIdsRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the coins for a given puzzlehash.
     *
     * Retrieves the coins for a given puzzlehash, by default returns unspent coins.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordsByPuzzleHashTest() throws ApiException {
        GetCoinRecordsByPuzzleHashRequest getCoinRecordsByPuzzleHashRequest = null;
        GetCoinRecordsByPuzzleHash200Response response = api.getCoinRecordsByPuzzleHash(getCoinRecordsByPuzzleHashRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the coins for a given puzzlehashes
     *
     * Retrieves the coins for a given puzzlehashes, by default returns unspent coins.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCoinRecordsByPuzzleHashesTest() throws ApiException {
        GetCoinRecordsByPuzzleHashesRequest getCoinRecordsByPuzzleHashesRequest = null;
        GetCoinRecordsByPuzzleHash200Response response = api.getCoinRecordsByPuzzleHashes(getCoinRecordsByPuzzleHashesRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a coin solution.
     *
     * Retrieves a coin solution.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPuzzleAndSolutionTest() throws ApiException {
        GetPuzzleAndSolutionRequest getPuzzleAndSolutionRequest = null;
        GetPuzzleAndSolution200Response response = api.getPuzzleAndSolution(getPuzzleAndSolutionRequest);
        // TODO: test validations
    }

    /**
     * Pushes a transaction/spend bundle to the mempool and blockchain.
     *
     * Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pushTxTest() throws ApiException {
        PushTxRequest pushTxRequest = null;
        PushTx200Response response = api.pushTx(pushTxRequest);
        // TODO: test validations
    }

}
