/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The full node uses port 8555 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CloseConnectionRequest;
import org.openapitools.client.model.GetConnections200Response;
import org.openapitools.client.model.GetRoutes200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.OpenConnectionRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for SharedApi
 */
@Disabled
public class SharedApiTest {

    private final SharedApi api = new SharedApi();

    /**
     * Removes a connection.
     *
     * Removes a connection.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void closeConnectionTest() throws ApiException {
        CloseConnectionRequest closeConnectionRequest = null;
        ModelApiResponse response = api.closeConnection(closeConnectionRequest);
        // TODO: test validations
    }

    /**
     * Retrieve the list of connections.
     *
     * Retrieve the list of connections.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getConnectionsTest() throws ApiException {
        Object body = null;
        GetConnections200Response response = api.getConnections(body);
        // TODO: test validations
    }

    /**
     * Retrieve the list of routes exposed by the service.
     *
     * Retrieve the list of routes/endpoints exposed by the service.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getRoutesTest() throws ApiException {
        Object body = null;
        GetRoutes200Response response = api.getRoutes(body);
        // TODO: test validations
    }

    /**
     * Heartbeat.
     *
     * Heartbeat.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void healthzTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.healthz(body);
        // TODO: test validations
    }

    /**
     * Add a connection to another node.
     *
     * Add a connection to another node.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void openConnectionTest() throws ApiException {
        OpenConnectionRequest openConnectionRequest = null;
        ModelApiResponse response = api.openConnection(openConnectionRequest);
        // TODO: test validations
    }

    /**
     * Stop the node.
     *
     * Stop the node.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void stopNodeTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.stopNode(body);
        // TODO: test validations
    }

}
