# HarvesterApi

All URIs are relative to *https://localhost:8560*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**addPlotDirectory**](HarvesterApi.md#addPlotDirectory) | **POST** /add_plot_directory | Add a plot directory to the harvester configuration. |
| [**deletePlot**](HarvesterApi.md#deletePlot) | **POST** /delete_plot | Permanently delete a plot file. |
| [**getPlotDirectories**](HarvesterApi.md#getPlotDirectories) | **POST** /get_plot_directories | Get the list of plot directories from the harvester configuration. |
| [**getPlots**](HarvesterApi.md#getPlots) | **POST** /get_plots | Get information about the plots the harvester knows about. |
| [**refreshPlots**](HarvesterApi.md#refreshPlots) | **POST** /refresh_plots | Refresh the list of plots. |
| [**removePlotDirectory**](HarvesterApi.md#removePlotDirectory) | **POST** /remove_plot_directory | Removes a plot directory from the harveser configuration. |


<a name="addPlotDirectory"></a>
# **addPlotDirectory**
> ModelApiResponse addPlotDirectory(addPlotDirectoryRequest)

Add a plot directory to the harvester configuration.

Add a plot directory to the harvester configuration.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    AddPlotDirectoryRequest addPlotDirectoryRequest = new AddPlotDirectoryRequest(); // AddPlotDirectoryRequest | The directory name to add
    try {
      ModelApiResponse result = apiInstance.addPlotDirectory(addPlotDirectoryRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#addPlotDirectory");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **addPlotDirectoryRequest** | [**AddPlotDirectoryRequest**](AddPlotDirectoryRequest.md)| The directory name to add | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="deletePlot"></a>
# **deletePlot**
> ModelApiResponse deletePlot(deletePlotRequest)

Permanently delete a plot file.

Permanently delete a plot file.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    DeletePlotRequest deletePlotRequest = new DeletePlotRequest(); // DeletePlotRequest | the file name of the plot
    try {
      ModelApiResponse result = apiInstance.deletePlot(deletePlotRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#deletePlot");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deletePlotRequest** | [**DeletePlotRequest**](DeletePlotRequest.md)| the file name of the plot | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="getPlotDirectories"></a>
# **getPlotDirectories**
> GetPlotDirectories200Response getPlotDirectories(body)

Get the list of plot directories from the harvester configuration.

Get the list of plot directories from the harvester configuration.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetPlotDirectories200Response result = apiInstance.getPlotDirectories(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#getPlotDirectories");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetPlotDirectories200Response**](GetPlotDirectories200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getPlots"></a>
# **getPlots**
> GetPlots200Response getPlots(body)

Get information about the plots the harvester knows about.

Get information about the plots the harvester knows about.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetPlots200Response result = apiInstance.getPlots(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#getPlots");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetPlots200Response**](GetPlots200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="refreshPlots"></a>
# **refreshPlots**
> ModelApiResponse refreshPlots(body)

Refresh the list of plots.

Refresh the list of plots.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      ModelApiResponse result = apiInstance.refreshPlots(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#refreshPlots");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="removePlotDirectory"></a>
# **removePlotDirectory**
> ModelApiResponse removePlotDirectory(addPlotDirectoryRequest)

Removes a plot directory from the harveser configuration.

Removes a plot directory from the harveser configuration.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.HarvesterApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:8560");
    

    HarvesterApi apiInstance = new HarvesterApi(defaultClient);
    AddPlotDirectoryRequest addPlotDirectoryRequest = new AddPlotDirectoryRequest(); // AddPlotDirectoryRequest | The directory name to remove
    try {
      ModelApiResponse result = apiInstance.removePlotDirectory(addPlotDirectoryRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling HarvesterApi#removePlotDirectory");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **addPlotDirectoryRequest** | [**AddPlotDirectoryRequest**](AddPlotDirectoryRequest.md)| The directory name to remove | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

