/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The harvester uses port 8560 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.PlotInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetPlots200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T13:32:18.313735300-04:00[America/New_York]")
public class GetPlots200Response {
  public static final String SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES = "failed_to_open_filenames";
  @SerializedName(SERIALIZED_NAME_FAILED_TO_OPEN_FILENAMES)
  private List<String> failedToOpenFilenames;

  public static final String SERIALIZED_NAME_NOT_FOUND_FILENAMES = "not_found_filenames";
  @SerializedName(SERIALIZED_NAME_NOT_FOUND_FILENAMES)
  private List<String> notFoundFilenames;

  public static final String SERIALIZED_NAME_PLOTS = "plots";
  @SerializedName(SERIALIZED_NAME_PLOTS)
  private List<PlotInfo> plots;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetPlots200Response() {
  }

  public GetPlots200Response failedToOpenFilenames(List<String> failedToOpenFilenames) {
    
    this.failedToOpenFilenames = failedToOpenFilenames;
    return this;
  }

  public GetPlots200Response addFailedToOpenFilenamesItem(String failedToOpenFilenamesItem) {
    if (this.failedToOpenFilenames == null) {
      this.failedToOpenFilenames = new ArrayList<>();
    }
    this.failedToOpenFilenames.add(failedToOpenFilenamesItem);
    return this;
  }

   /**
   * Get failedToOpenFilenames
   * @return failedToOpenFilenames
  **/
  @javax.annotation.Nullable

  public List<String> getFailedToOpenFilenames() {
    return failedToOpenFilenames;
  }


  public void setFailedToOpenFilenames(List<String> failedToOpenFilenames) {
    this.failedToOpenFilenames = failedToOpenFilenames;
  }


  public GetPlots200Response notFoundFilenames(List<String> notFoundFilenames) {
    
    this.notFoundFilenames = notFoundFilenames;
    return this;
  }

  public GetPlots200Response addNotFoundFilenamesItem(String notFoundFilenamesItem) {
    if (this.notFoundFilenames == null) {
      this.notFoundFilenames = new ArrayList<>();
    }
    this.notFoundFilenames.add(notFoundFilenamesItem);
    return this;
  }

   /**
   * Get notFoundFilenames
   * @return notFoundFilenames
  **/
  @javax.annotation.Nullable

  public List<String> getNotFoundFilenames() {
    return notFoundFilenames;
  }


  public void setNotFoundFilenames(List<String> notFoundFilenames) {
    this.notFoundFilenames = notFoundFilenames;
  }


  public GetPlots200Response plots(List<PlotInfo> plots) {
    
    this.plots = plots;
    return this;
  }

  public GetPlots200Response addPlotsItem(PlotInfo plotsItem) {
    if (this.plots == null) {
      this.plots = new ArrayList<>();
    }
    this.plots.add(plotsItem);
    return this;
  }

   /**
   * Get plots
   * @return plots
  **/
  @javax.annotation.Nullable

  public List<PlotInfo> getPlots() {
    return plots;
  }


  public void setPlots(List<PlotInfo> plots) {
    this.plots = plots;
  }


  public GetPlots200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetPlots200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetPlots200Response getPlots200Response = (GetPlots200Response) o;
    return Objects.equals(this.failedToOpenFilenames, getPlots200Response.failedToOpenFilenames) &&
        Objects.equals(this.notFoundFilenames, getPlots200Response.notFoundFilenames) &&
        Objects.equals(this.plots, getPlots200Response.plots) &&
        Objects.equals(this.success, getPlots200Response.success) &&
        Objects.equals(this.error, getPlots200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(failedToOpenFilenames, notFoundFilenames, plots, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetPlots200Response {\n");
    sb.append("    failedToOpenFilenames: ").append(toIndentedString(failedToOpenFilenames)).append("\n");
    sb.append("    notFoundFilenames: ").append(toIndentedString(notFoundFilenames)).append("\n");
    sb.append("    plots: ").append(toIndentedString(plots)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("failed_to_open_filenames");
    openapiFields.add("not_found_filenames");
    openapiFields.add("plots");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetPlots200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetPlots200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetPlots200Response is not found in the empty JSON string", GetPlots200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetPlots200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetPlots200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetPlots200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("failed_to_open_filenames") != null && !jsonObj.get("failed_to_open_filenames").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `failed_to_open_filenames` to be an array in the JSON string but got `%s`", jsonObj.get("failed_to_open_filenames").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("not_found_filenames") != null && !jsonObj.get("not_found_filenames").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `not_found_filenames` to be an array in the JSON string but got `%s`", jsonObj.get("not_found_filenames").toString()));
      }
      if (jsonObj.get("plots") != null && !jsonObj.get("plots").isJsonNull()) {
        JsonArray jsonArrayplots = jsonObj.getAsJsonArray("plots");
        if (jsonArrayplots != null) {
          // ensure the json data is an array
          if (!jsonObj.get("plots").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `plots` to be an array in the JSON string but got `%s`", jsonObj.get("plots").toString()));
          }

          // validate the optional field `plots` (array)
          for (int i = 0; i < jsonArrayplots.size(); i++) {
            PlotInfo.validateJsonObject(jsonArrayplots.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetPlots200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetPlots200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetPlots200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetPlots200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetPlots200Response>() {
           @Override
           public void write(JsonWriter out, GetPlots200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetPlots200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetPlots200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetPlots200Response
  * @throws IOException if the JSON string is invalid with respect to GetPlots200Response
  */
  public static GetPlots200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetPlots200Response.class);
  }

 /**
  * Convert an instance of GetPlots200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

