/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The harvester uses port 8560 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.AddPlotDirectoryRequest;
import org.openapitools.client.model.DeletePlotRequest;
import org.openapitools.client.model.GetPlotDirectories200Response;
import org.openapitools.client.model.GetPlots200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for HarvesterApi
 */
@Disabled
public class HarvesterApiTest {

    private final HarvesterApi api = new HarvesterApi();

    /**
     * Add a plot directory to the harvester configuration.
     *
     * Add a plot directory to the harvester configuration.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addPlotDirectoryTest() throws ApiException {
        AddPlotDirectoryRequest addPlotDirectoryRequest = null;
        ModelApiResponse response = api.addPlotDirectory(addPlotDirectoryRequest);
        // TODO: test validations
    }

    /**
     * Permanently delete a plot file.
     *
     * Permanently delete a plot file.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deletePlotTest() throws ApiException {
        DeletePlotRequest deletePlotRequest = null;
        ModelApiResponse response = api.deletePlot(deletePlotRequest);
        // TODO: test validations
    }

    /**
     * Get the list of plot directories from the harvester configuration.
     *
     * Get the list of plot directories from the harvester configuration.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPlotDirectoriesTest() throws ApiException {
        Object body = null;
        GetPlotDirectories200Response response = api.getPlotDirectories(body);
        // TODO: test validations
    }

    /**
     * Get information about the plots the harvester knows about.
     *
     * Get information about the plots the harvester knows about.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPlotsTest() throws ApiException {
        Object body = null;
        GetPlots200Response response = api.getPlots(body);
        // TODO: test validations
    }

    /**
     * Refresh the list of plots.
     *
     * Refresh the list of plots.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void refreshPlotsTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.refreshPlots(body);
        // TODO: test validations
    }

    /**
     * Removes a plot directory from the harveser configuration.
     *
     * Removes a plot directory from the harveser configuration.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void removePlotDirectoryTest() throws ApiException {
        AddPlotDirectoryRequest addPlotDirectoryRequest = null;
        ModelApiResponse response = api.removePlotDirectory(addPlotDirectoryRequest);
        // TODO: test validations
    }

}
