# CatWalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**cancelOffer**](CatWalletApi.md#cancelOffer) | **POST** /cancel_offer | Cancels an offer. |
| [**cancelOffers**](CatWalletApi.md#cancelOffers) | **POST** /cancel_offers | Cancels multiple offers. |
| [**catAssetIdToName**](CatWalletApi.md#catAssetIdToName) | **POST** /cat_asset_id_to_name | Gets the name and wallet id associated with an asset id. |
| [**catGetAssetId**](CatWalletApi.md#catGetAssetId) | **POST** /cat_get_asset_id | Gets the asset id of the CAT wallet. |
| [**catGetName**](CatWalletApi.md#catGetName) | **POST** /cat_get_name | Gets the name of the CAT wallet. |
| [**catSetName**](CatWalletApi.md#catSetName) | **POST** /cat_set_name | Sets the name of the CAT wallet. |
| [**catSpend**](CatWalletApi.md#catSpend) | **POST** /cat_spend | Spends an amount from the given wallet. |
| [**checkOfferValidity**](CatWalletApi.md#checkOfferValidity) | **POST** /check_offer_validity | Checks the validity of an offer. |
| [**createOfferForIds**](CatWalletApi.md#createOfferForIds) | **POST** /create_offer_for_ids | Creates an offer. |
| [**getAllOffers**](CatWalletApi.md#getAllOffers) | **POST** /get_all_offers | Retrieves offers. |
| [**getCatList**](CatWalletApi.md#getCatList) | **POST** /get_cat_list | Retrieves the list of CATs. |
| [**getOffer**](CatWalletApi.md#getOffer) | **POST** /get_offer | Retrieves an offer. |
| [**getOfferSummary**](CatWalletApi.md#getOfferSummary) | **POST** /get_offer_summary | Get the summary of a given offer. |
| [**getOffersCount**](CatWalletApi.md#getOffersCount) | **POST** /get_offers_count | Retrieves the number of offers. |
| [**getStrayCats**](CatWalletApi.md#getStrayCats) | **POST** /get_stray_cats | Get a list of all unacknowledged CATs. |
| [**selectCoins**](CatWalletApi.md#selectCoins) | **POST** /select_coins | Returns a set of coins that can be used for generating a new transaction. |
| [**takeOffer**](CatWalletApi.md#takeOffer) | **POST** /take_offer | Takes an offer. |


<a name="cancelOffer"></a>
# **cancelOffer**
> ModelApiResponse cancelOffer(cancelOfferRequest)

Cancels an offer.

Cancels an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CancelOfferRequest cancelOfferRequest = new CancelOfferRequest(); // CancelOfferRequest | 
    try {
      ModelApiResponse result = apiInstance.cancelOffer(cancelOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#cancelOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **cancelOfferRequest** | [**CancelOfferRequest**](CancelOfferRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="cancelOffers"></a>
# **cancelOffers**
> ModelApiResponse cancelOffers(cancelOffersRequest)

Cancels multiple offers.

Cancels multiple offers.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CancelOffersRequest cancelOffersRequest = new CancelOffersRequest(); // CancelOffersRequest | 
    try {
      ModelApiResponse result = apiInstance.cancelOffers(cancelOffersRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#cancelOffers");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **cancelOffersRequest** | [**CancelOffersRequest**](CancelOffersRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="catAssetIdToName"></a>
# **catAssetIdToName**
> CatAssetIdToName200Response catAssetIdToName(catAssetIdToNameRequest)

Gets the name and wallet id associated with an asset id.

Gets the name and wallet id associated with an asset id.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CatAssetIdToNameRequest catAssetIdToNameRequest = new CatAssetIdToNameRequest(); // CatAssetIdToNameRequest | 
    try {
      CatAssetIdToName200Response result = apiInstance.catAssetIdToName(catAssetIdToNameRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#catAssetIdToName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **catAssetIdToNameRequest** | [**CatAssetIdToNameRequest**](CatAssetIdToNameRequest.md)|  | |

### Return type

[**CatAssetIdToName200Response**](CatAssetIdToName200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="catGetAssetId"></a>
# **catGetAssetId**
> CatGetAssetId200Response catGetAssetId(nftGetWalletDidRequest)

Gets the asset id of the CAT wallet.

Gets the asset id of the CAT wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      CatGetAssetId200Response result = apiInstance.catGetAssetId(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#catGetAssetId");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**CatGetAssetId200Response**](CatGetAssetId200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="catGetName"></a>
# **catGetName**
> CatAssetIdToName200Response catGetName(nftGetWalletDidRequest)

Gets the name of the CAT wallet.

Gets the name of the CAT wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      CatAssetIdToName200Response result = apiInstance.catGetName(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#catGetName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**CatAssetIdToName200Response**](CatAssetIdToName200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="catSetName"></a>
# **catSetName**
> NftGetByDid200Response catSetName(didSetWalletNameRequest)

Sets the name of the CAT wallet.

Sets the name of the CAT wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    DidSetWalletNameRequest didSetWalletNameRequest = new DidSetWalletNameRequest(); // DidSetWalletNameRequest | Request body with the Id of a wallet
    try {
      NftGetByDid200Response result = apiInstance.catSetName(didSetWalletNameRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#catSetName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didSetWalletNameRequest** | [**DidSetWalletNameRequest**](DidSetWalletNameRequest.md)| Request body with the Id of a wallet | |

### Return type

[**NftGetByDid200Response**](NftGetByDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="catSpend"></a>
# **catSpend**
> DidTransferDid200Response catSpend(catSpendRequest)

Spends an amount from the given wallet.

Spends an amount from the given wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CatSpendRequest catSpendRequest = new CatSpendRequest(); // CatSpendRequest | Request body with the Id of a wallet.
    try {
      DidTransferDid200Response result = apiInstance.catSpend(catSpendRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#catSpend");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **catSpendRequest** | [**CatSpendRequest**](CatSpendRequest.md)| Request body with the Id of a wallet. | |

### Return type

[**DidTransferDid200Response**](DidTransferDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response with a transaction record and a transaction id. |  -  |

<a name="checkOfferValidity"></a>
# **checkOfferValidity**
> CheckOfferValidity200Response checkOfferValidity(checkOfferValidityRequest)

Checks the validity of an offer.

Checks the validity of an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CheckOfferValidityRequest checkOfferValidityRequest = new CheckOfferValidityRequest(); // CheckOfferValidityRequest | 
    try {
      CheckOfferValidity200Response result = apiInstance.checkOfferValidity(checkOfferValidityRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#checkOfferValidity");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **checkOfferValidityRequest** | [**CheckOfferValidityRequest**](CheckOfferValidityRequest.md)|  | |

### Return type

[**CheckOfferValidity200Response**](CheckOfferValidity200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="createOfferForIds"></a>
# **createOfferForIds**
> CreateOfferForIds200Response createOfferForIds(createOfferForIdsRequest)

Creates an offer.

Creates an offer for the given set of wallet id and amount pairs.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    CreateOfferForIdsRequest createOfferForIdsRequest = new CreateOfferForIdsRequest(); // CreateOfferForIdsRequest | 
    try {
      CreateOfferForIds200Response result = apiInstance.createOfferForIds(createOfferForIdsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#createOfferForIds");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **createOfferForIdsRequest** | [**CreateOfferForIdsRequest**](CreateOfferForIdsRequest.md)|  | |

### Return type

[**CreateOfferForIds200Response**](CreateOfferForIds200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getAllOffers"></a>
# **getAllOffers**
> GetAllOffers200Response getAllOffers(getAllOffersRequest)

Retrieves offers.

Retrieves offers.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    GetAllOffersRequest getAllOffersRequest = new GetAllOffersRequest(); // GetAllOffersRequest | 
    try {
      GetAllOffers200Response result = apiInstance.getAllOffers(getAllOffersRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getAllOffers");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getAllOffersRequest** | [**GetAllOffersRequest**](GetAllOffersRequest.md)|  | |

### Return type

[**GetAllOffers200Response**](GetAllOffers200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCatList"></a>
# **getCatList**
> GetCatList200Response getCatList(body)

Retrieves the list of CATs.

Retrieves the list of CATs.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetCatList200Response result = apiInstance.getCatList(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getCatList");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetCatList200Response**](GetCatList200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getOffer"></a>
# **getOffer**
> GetOffer200Response getOffer(getOfferRequest)

Retrieves an offer.

Retrieves an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    GetOfferRequest getOfferRequest = new GetOfferRequest(); // GetOfferRequest | 
    try {
      GetOffer200Response result = apiInstance.getOffer(getOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getOfferRequest** | [**GetOfferRequest**](GetOfferRequest.md)|  | |

### Return type

[**GetOffer200Response**](GetOffer200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getOfferSummary"></a>
# **getOfferSummary**
> GetOfferSummary200Response getOfferSummary(getOfferSummaryRequest)

Get the summary of a given offer.

Get the summary of a given offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    GetOfferSummaryRequest getOfferSummaryRequest = new GetOfferSummaryRequest(); // GetOfferSummaryRequest | 
    try {
      GetOfferSummary200Response result = apiInstance.getOfferSummary(getOfferSummaryRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getOfferSummary");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getOfferSummaryRequest** | [**GetOfferSummaryRequest**](GetOfferSummaryRequest.md)|  | |

### Return type

[**GetOfferSummary200Response**](GetOfferSummary200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getOffersCount"></a>
# **getOffersCount**
> GetOffersCount200Response getOffersCount(body)

Retrieves the number of offers.

Retrieves the number of offers.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetOffersCount200Response result = apiInstance.getOffersCount(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getOffersCount");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetOffersCount200Response**](GetOffersCount200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getStrayCats"></a>
# **getStrayCats**
> GetStrayCats200Response getStrayCats(body)

Get a list of all unacknowledged CATs.

Get a list of all unacknowledged CATs.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetStrayCats200Response result = apiInstance.getStrayCats(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#getStrayCats");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetStrayCats200Response**](GetStrayCats200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="selectCoins"></a>
# **selectCoins**
> SelectCoins200Response selectCoins(selectCoinsRequest)

Returns a set of coins that can be used for generating a new transaction.

Returns a set of coins that can be used for generating a new transaction.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    SelectCoinsRequest selectCoinsRequest = new SelectCoinsRequest(); // SelectCoinsRequest | 
    try {
      SelectCoins200Response result = apiInstance.selectCoins(selectCoinsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#selectCoins");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **selectCoinsRequest** | [**SelectCoinsRequest**](SelectCoinsRequest.md)|  | |

### Return type

[**SelectCoins200Response**](SelectCoins200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="takeOffer"></a>
# **takeOffer**
> TakeOffer200Response takeOffer(takeOfferRequest)

Takes an offer.

Takes an offer.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CatWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CatWalletApi apiInstance = new CatWalletApi(defaultClient);
    TakeOfferRequest takeOfferRequest = new TakeOfferRequest(); // TakeOfferRequest | 
    try {
      TakeOffer200Response result = apiInstance.takeOffer(takeOfferRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CatWalletApi#takeOffer");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **takeOfferRequest** | [**TakeOfferRequest**](TakeOfferRequest.md)|  | |

### Return type

[**TakeOffer200Response**](TakeOffer200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

