# CoinsApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getCoinRecordsByNames**](CoinsApi.md#getCoinRecordsByNames) | **POST** /get_coin_records_by_names | Retrieves the coins for given coin IDs. |


<a name="getCoinRecordsByNames"></a>
# **getCoinRecordsByNames**
> GetCoinRecordsByNames200Response getCoinRecordsByNames(getCoinRecordsByNamesRequest)

Retrieves the coins for given coin IDs.

Retrieves the coins for given coin IDs, by default returns unspent coins.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.CoinsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    CoinsApi apiInstance = new CoinsApi(defaultClient);
    GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest = new GetCoinRecordsByNamesRequest(); // GetCoinRecordsByNamesRequest | The coin names.
    try {
      GetCoinRecordsByNames200Response result = apiInstance.getCoinRecordsByNames(getCoinRecordsByNamesRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CoinsApi#getCoinRecordsByNames");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getCoinRecordsByNamesRequest** | [**GetCoinRecordsByNamesRequest**](GetCoinRecordsByNamesRequest.md)| The coin names. | |

### Return type

[**GetCoinRecordsByNames200Response**](GetCoinRecordsByNames200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

