# DataLayerWalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**createNewDl**](DataLayerWalletApi.md#createNewDl) | **POST** /create_new_dl | Initialize the new data layer wallets. |
| [**dlDeleteMirror**](DataLayerWalletApi.md#dlDeleteMirror) | **POST** /dl_delete_mirror | Remove an existing mirror for a specific singleton. |
| [**dlGetMirrors**](DataLayerWalletApi.md#dlGetMirrors) | **POST** /dl_get_mirrors | Get all of the mirrors for a specific singleton. |
| [**dlHistory**](DataLayerWalletApi.md#dlHistory) | **POST** /dl_history | Get the singleton record for the latest singleton of a launcher ID. |
| [**dlLatestSingleton**](DataLayerWalletApi.md#dlLatestSingleton) | **POST** /dl_latest_singleton | Get the singleton records that contain the specified root. |
| [**dlNewMirror**](DataLayerWalletApi.md#dlNewMirror) | **POST** /dl_new_mirror | Add a new on chain message for a specific singleton. |
| [**dlOwnedSingletons**](DataLayerWalletApi.md#dlOwnedSingletons) | **POST** /dl_owned_singletons | Get all owned singleton records. |
| [**dlSingletonsByRoot**](DataLayerWalletApi.md#dlSingletonsByRoot) | **POST** /dl_singletons_by_root | Get the singleton records that contain the specified root. |
| [**dlStopTracking**](DataLayerWalletApi.md#dlStopTracking) | **POST** /dl_stop_tracking | Stop tracking the data layer wallets. |
| [**dlTrackNew**](DataLayerWalletApi.md#dlTrackNew) | **POST** /dl_track_new | Track the new data layer wallet |
| [**dlUpdateMultiple**](DataLayerWalletApi.md#dlUpdateMultiple) | **POST** /dl_update_multiple | Stop the node. |
| [**dlUpdateRoot**](DataLayerWalletApi.md#dlUpdateRoot) | **POST** /dl_update_root | Stop the node. |


<a name="createNewDl"></a>
# **createNewDl**
> CreateNewDl200Response createNewDl(createNewDlRequest)

Initialize the new data layer wallets.

Initialize the DataLayer Wallet (only one can exist).

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    CreateNewDlRequest createNewDlRequest = new CreateNewDlRequest(); // CreateNewDlRequest | 
    try {
      CreateNewDl200Response result = apiInstance.createNewDl(createNewDlRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#createNewDl");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **createNewDlRequest** | [**CreateNewDlRequest**](CreateNewDlRequest.md)|  | |

### Return type

[**CreateNewDl200Response**](CreateNewDl200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlDeleteMirror"></a>
# **dlDeleteMirror**
> DlNewMirror200Response dlDeleteMirror(dlDeleteMirrorRequest)

Remove an existing mirror for a specific singleton.

Remove an existing mirror for a specific singleton.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlDeleteMirrorRequest dlDeleteMirrorRequest = new DlDeleteMirrorRequest(); // DlDeleteMirrorRequest | 
    try {
      DlNewMirror200Response result = apiInstance.dlDeleteMirror(dlDeleteMirrorRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlDeleteMirror");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlDeleteMirrorRequest** | [**DlDeleteMirrorRequest**](DlDeleteMirrorRequest.md)|  | |

### Return type

[**DlNewMirror200Response**](DlNewMirror200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlGetMirrors"></a>
# **dlGetMirrors**
> DlGetMirrors200Response dlGetMirrors(dlTrackNewRequest)

Get all of the mirrors for a specific singleton.

Get all of the mirrors for a specific singleton.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlTrackNewRequest dlTrackNewRequest = new DlTrackNewRequest(); // DlTrackNewRequest | 
    try {
      DlGetMirrors200Response result = apiInstance.dlGetMirrors(dlTrackNewRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlGetMirrors");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlTrackNewRequest** | [**DlTrackNewRequest**](DlTrackNewRequest.md)|  | |

### Return type

[**DlGetMirrors200Response**](DlGetMirrors200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlHistory"></a>
# **dlHistory**
> DlHistory200Response dlHistory(dlHistoryRequest)

Get the singleton record for the latest singleton of a launcher ID.

Get the singleton record for the latest singleton of a launcher ID.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlHistoryRequest dlHistoryRequest = new DlHistoryRequest(); // DlHistoryRequest | 
    try {
      DlHistory200Response result = apiInstance.dlHistory(dlHistoryRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlHistory");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlHistoryRequest** | [**DlHistoryRequest**](DlHistoryRequest.md)|  | |

### Return type

[**DlHistory200Response**](DlHistory200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlLatestSingleton"></a>
# **dlLatestSingleton**
> DlLatestSingleton200Response dlLatestSingleton(dlLatestSingletonRequest)

Get the singleton records that contain the specified root.

Get the singleton records that contain the specified root.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlLatestSingletonRequest dlLatestSingletonRequest = new DlLatestSingletonRequest(); // DlLatestSingletonRequest | 
    try {
      DlLatestSingleton200Response result = apiInstance.dlLatestSingleton(dlLatestSingletonRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlLatestSingleton");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlLatestSingletonRequest** | [**DlLatestSingletonRequest**](DlLatestSingletonRequest.md)|  | |

### Return type

[**DlLatestSingleton200Response**](DlLatestSingleton200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlNewMirror"></a>
# **dlNewMirror**
> DlNewMirror200Response dlNewMirror(dlNewMirrorRequest)

Add a new on chain message for a specific singleton.

Add a new on chain message for a specific singleton

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlNewMirrorRequest dlNewMirrorRequest = new DlNewMirrorRequest(); // DlNewMirrorRequest | 
    try {
      DlNewMirror200Response result = apiInstance.dlNewMirror(dlNewMirrorRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlNewMirror");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlNewMirrorRequest** | [**DlNewMirrorRequest**](DlNewMirrorRequest.md)|  | |

### Return type

[**DlNewMirror200Response**](DlNewMirror200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlOwnedSingletons"></a>
# **dlOwnedSingletons**
> DlOwnedSingletons200Response dlOwnedSingletons(body)

Get all owned singleton records.

Get all owned singleton records.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      DlOwnedSingletons200Response result = apiInstance.dlOwnedSingletons(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlOwnedSingletons");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**DlOwnedSingletons200Response**](DlOwnedSingletons200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlSingletonsByRoot"></a>
# **dlSingletonsByRoot**
> DlSingletonsByRoot200Response dlSingletonsByRoot(dlLatestSingletonRequest)

Get the singleton records that contain the specified root.

Get the singleton records that contain the specified root.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlLatestSingletonRequest dlLatestSingletonRequest = new DlLatestSingletonRequest(); // DlLatestSingletonRequest | 
    try {
      DlSingletonsByRoot200Response result = apiInstance.dlSingletonsByRoot(dlLatestSingletonRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlSingletonsByRoot");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlLatestSingletonRequest** | [**DlLatestSingletonRequest**](DlLatestSingletonRequest.md)|  | |

### Return type

[**DlSingletonsByRoot200Response**](DlSingletonsByRoot200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlStopTracking"></a>
# **dlStopTracking**
> ModelApiResponse dlStopTracking(dlTrackNewRequest)

Stop tracking the data layer wallets.

Stop tracking the data layer wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlTrackNewRequest dlTrackNewRequest = new DlTrackNewRequest(); // DlTrackNewRequest | 
    try {
      ModelApiResponse result = apiInstance.dlStopTracking(dlTrackNewRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlStopTracking");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlTrackNewRequest** | [**DlTrackNewRequest**](DlTrackNewRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="dlTrackNew"></a>
# **dlTrackNew**
> ModelApiResponse dlTrackNew(dlTrackNewRequest)

Track the new data layer wallet

Track the new data layer wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlTrackNewRequest dlTrackNewRequest = new DlTrackNewRequest(); // DlTrackNewRequest | 
    try {
      ModelApiResponse result = apiInstance.dlTrackNew(dlTrackNewRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlTrackNew");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlTrackNewRequest** | [**DlTrackNewRequest**](DlTrackNewRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="dlUpdateMultiple"></a>
# **dlUpdateMultiple**
> DlUpdateMultiple200Response dlUpdateMultiple(dlUpdateMultipleRequest)

Stop the node.

Stop the node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlUpdateMultipleRequest dlUpdateMultipleRequest = new DlUpdateMultipleRequest(); // DlUpdateMultipleRequest | 
    try {
      DlUpdateMultiple200Response result = apiInstance.dlUpdateMultiple(dlUpdateMultipleRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlUpdateMultiple");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlUpdateMultipleRequest** | [**DlUpdateMultipleRequest**](DlUpdateMultipleRequest.md)|  | |

### Return type

[**DlUpdateMultiple200Response**](DlUpdateMultiple200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="dlUpdateRoot"></a>
# **dlUpdateRoot**
> DlUpdateRoot200Response dlUpdateRoot(dlUpdateRootRequest)

Stop the node.

Stop the node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DataLayerWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DataLayerWalletApi apiInstance = new DataLayerWalletApi(defaultClient);
    DlUpdateRootRequest dlUpdateRootRequest = new DlUpdateRootRequest(); // DlUpdateRootRequest | 
    try {
      DlUpdateRoot200Response result = apiInstance.dlUpdateRoot(dlUpdateRootRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DataLayerWalletApi#dlUpdateRoot");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **dlUpdateRootRequest** | [**DlUpdateRootRequest**](DlUpdateRootRequest.md)|  | |

### Return type

[**DlUpdateRoot200Response**](DlUpdateRoot200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

