# DidWalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**didCreateAttest**](DidWalletApi.md#didCreateAttest) | **POST** /did_create_attest | Creates an attestment for the given DID wallet. |
| [**didCreateBackupFile**](DidWalletApi.md#didCreateBackupFile) | **POST** /did_create_backup_file | Creates a backup file for the given DID wallet. |
| [**didFindLostDid**](DidWalletApi.md#didFindLostDid) | **POST** /did_find_lost_did | Recover a missing or unspendable DID wallet by a coin id of the DID. |
| [**didGetCurrentCoinInfo**](DidWalletApi.md#didGetCurrentCoinInfo) | **POST** /did_get_current_coin_info | Gets information about the DID wallets current coin. |
| [**didGetDid**](DidWalletApi.md#didGetDid) | **POST** /did_get_did | Retrieves the distributed identity for a given wallet. |
| [**didGetInfo**](DidWalletApi.md#didGetInfo) | **POST** /did_get_info | Retreives information about a DID. |
| [**didGetInformationNeededForRecovery**](DidWalletApi.md#didGetInformationNeededForRecovery) | **POST** /did_get_information_needed_for_recovery | Retrieves the recovery information needed for the given DID wallet. |
| [**didGetMetadata**](DidWalletApi.md#didGetMetadata) | **POST** /did_get_metadata | Gets the metadata of a DID wallet. |
| [**didGetPubkey**](DidWalletApi.md#didGetPubkey) | **POST** /did_get_pubkey | Retrieves the public key for the given DID wallet. |
| [**didGetRecoveryList**](DidWalletApi.md#didGetRecoveryList) | **POST** /did_get_recovery_list | Retrieves the recovery list for a given DID wallet. |
| [**didGetWalletName**](DidWalletApi.md#didGetWalletName) | **POST** /did_get_wallet_name | Gets the name of a DID wallet. |
| [**didMessageSpend**](DidWalletApi.md#didMessageSpend) | **POST** /did_message_spend | Spends a DID message. |
| [**didRecoverySpend**](DidWalletApi.md#didRecoverySpend) | **POST** /did_recovery_spend | Spend from the given DID wallet. |
| [**didSetWalletName**](DidWalletApi.md#didSetWalletName) | **POST** /did_set_wallet_name | Sets the name of a DID wallet. |
| [**didTransferDid**](DidWalletApi.md#didTransferDid) | **POST** /did_transfer_did | Transfer a DID to another owner. |
| [**didUpdateMetadata**](DidWalletApi.md#didUpdateMetadata) | **POST** /did_update_metadata | Updates the metadata for a DID wallet. |
| [**didUpdateRecoveryIds**](DidWalletApi.md#didUpdateRecoveryIds) | **POST** /did_update_recovery_ids | Updates the recovery ids for a DID wallet. |


<a name="didCreateAttest"></a>
# **didCreateAttest**
> DidCreateAttest200Response didCreateAttest(didCreateAttestRequest)

Creates an attestment for the given DID wallet.

Creates an attestment for the given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidCreateAttestRequest didCreateAttestRequest = new DidCreateAttestRequest(); // DidCreateAttestRequest | 
    try {
      DidCreateAttest200Response result = apiInstance.didCreateAttest(didCreateAttestRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didCreateAttest");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didCreateAttestRequest** | [**DidCreateAttestRequest**](DidCreateAttestRequest.md)|  | |

### Return type

[**DidCreateAttest200Response**](DidCreateAttest200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didCreateBackupFile"></a>
# **didCreateBackupFile**
> DidCreateBackupFile200Response didCreateBackupFile(nftGetWalletDidRequest)

Creates a backup file for the given DID wallet.

Creates a backup file for the given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidCreateBackupFile200Response result = apiInstance.didCreateBackupFile(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didCreateBackupFile");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidCreateBackupFile200Response**](DidCreateBackupFile200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didFindLostDid"></a>
# **didFindLostDid**
> DidFindLostDid200Response didFindLostDid(didFindLostDidRequest)

Recover a missing or unspendable DID wallet by a coin id of the DID.

Recover a missing or unspendable DID wallet by a coin id of the DID

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidFindLostDidRequest didFindLostDidRequest = new DidFindLostDidRequest(); // DidFindLostDidRequest | 
    try {
      DidFindLostDid200Response result = apiInstance.didFindLostDid(didFindLostDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didFindLostDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didFindLostDidRequest** | [**DidFindLostDidRequest**](DidFindLostDidRequest.md)|  | |

### Return type

[**DidFindLostDid200Response**](DidFindLostDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetCurrentCoinInfo"></a>
# **didGetCurrentCoinInfo**
> DidGetCurrentCoinInfo200Response didGetCurrentCoinInfo(nftGetWalletDidRequest)

Gets information about the DID wallets current coin.

Gets information about the DID wallets current coin.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetCurrentCoinInfo200Response result = apiInstance.didGetCurrentCoinInfo(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetCurrentCoinInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetCurrentCoinInfo200Response**](DidGetCurrentCoinInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetDid"></a>
# **didGetDid**
> DidGetDid200Response didGetDid(nftGetWalletDidRequest)

Retrieves the distributed identity for a given wallet.

Retrieves the distributed identity for a given wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetDid200Response result = apiInstance.didGetDid(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetDid200Response**](DidGetDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetInfo"></a>
# **didGetInfo**
> DidGetInfo200Response didGetInfo(didGetInfoRequest)

Retreives information about a DID.

Retreives information about a DID

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidGetInfoRequest didGetInfoRequest = new DidGetInfoRequest(); // DidGetInfoRequest | 
    try {
      DidGetInfo200Response result = apiInstance.didGetInfo(didGetInfoRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didGetInfoRequest** | [**DidGetInfoRequest**](DidGetInfoRequest.md)|  | |

### Return type

[**DidGetInfo200Response**](DidGetInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetInformationNeededForRecovery"></a>
# **didGetInformationNeededForRecovery**
> DidGetInformationNeededForRecovery200Response didGetInformationNeededForRecovery(nftGetWalletDidRequest)

Retrieves the recovery information needed for the given DID wallet.

Retrieves the recovery information needed for the given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetInformationNeededForRecovery200Response result = apiInstance.didGetInformationNeededForRecovery(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetInformationNeededForRecovery");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetInformationNeededForRecovery200Response**](DidGetInformationNeededForRecovery200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetMetadata"></a>
# **didGetMetadata**
> DidGetMetadata200Response didGetMetadata(nftGetWalletDidRequest)

Gets the metadata of a DID wallet.

Gets the metadata of a DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetMetadata200Response result = apiInstance.didGetMetadata(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetMetadata");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetMetadata200Response**](DidGetMetadata200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetPubkey"></a>
# **didGetPubkey**
> DidGetPubkey200Response didGetPubkey(nftGetWalletDidRequest)

Retrieves the public key for the given DID wallet.

Retrieves the public key for the given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetPubkey200Response result = apiInstance.didGetPubkey(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetPubkey");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetPubkey200Response**](DidGetPubkey200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetRecoveryList"></a>
# **didGetRecoveryList**
> DidGetRecoveryList200Response didGetRecoveryList(nftGetWalletDidRequest)

Retrieves the recovery list for a given DID wallet.

Retrieves the recovery list for a given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetRecoveryList200Response result = apiInstance.didGetRecoveryList(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetRecoveryList");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetRecoveryList200Response**](DidGetRecoveryList200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didGetWalletName"></a>
# **didGetWalletName**
> DidGetWalletName200Response didGetWalletName(nftGetWalletDidRequest)

Gets the name of a DID wallet.

Gets the name of a DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      DidGetWalletName200Response result = apiInstance.didGetWalletName(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didGetWalletName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**DidGetWalletName200Response**](DidGetWalletName200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didMessageSpend"></a>
# **didMessageSpend**
> DidRecoverySpend200Response didMessageSpend(didMessageSpendRequest)

Spends a DID message.

Spends a DID message

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidMessageSpendRequest didMessageSpendRequest = new DidMessageSpendRequest(); // DidMessageSpendRequest | 
    try {
      DidRecoverySpend200Response result = apiInstance.didMessageSpend(didMessageSpendRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didMessageSpend");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didMessageSpendRequest** | [**DidMessageSpendRequest**](DidMessageSpendRequest.md)|  | |

### Return type

[**DidRecoverySpend200Response**](DidRecoverySpend200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didRecoverySpend"></a>
# **didRecoverySpend**
> DidRecoverySpend200Response didRecoverySpend(didRecoverySpendRequest)

Spend from the given DID wallet.

Spend from the given DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidRecoverySpendRequest didRecoverySpendRequest = new DidRecoverySpendRequest(); // DidRecoverySpendRequest | 
    try {
      DidRecoverySpend200Response result = apiInstance.didRecoverySpend(didRecoverySpendRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didRecoverySpend");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didRecoverySpendRequest** | [**DidRecoverySpendRequest**](DidRecoverySpendRequest.md)|  | |

### Return type

[**DidRecoverySpend200Response**](DidRecoverySpend200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didSetWalletName"></a>
# **didSetWalletName**
> DidSetWalletName200Response didSetWalletName(didSetWalletNameRequest)

Sets the name of a DID wallet.

Sets the name of a DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidSetWalletNameRequest didSetWalletNameRequest = new DidSetWalletNameRequest(); // DidSetWalletNameRequest | 
    try {
      DidSetWalletName200Response result = apiInstance.didSetWalletName(didSetWalletNameRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didSetWalletName");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didSetWalletNameRequest** | [**DidSetWalletNameRequest**](DidSetWalletNameRequest.md)|  | |

### Return type

[**DidSetWalletName200Response**](DidSetWalletName200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didTransferDid"></a>
# **didTransferDid**
> DidTransferDid200Response didTransferDid(didTransferDidRequest)

Transfer a DID to another owner.

Transfer the given DID wallet to another owner.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidTransferDidRequest didTransferDidRequest = new DidTransferDidRequest(); // DidTransferDidRequest | 
    try {
      DidTransferDid200Response result = apiInstance.didTransferDid(didTransferDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didTransferDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didTransferDidRequest** | [**DidTransferDidRequest**](DidTransferDidRequest.md)|  | |

### Return type

[**DidTransferDid200Response**](DidTransferDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didUpdateMetadata"></a>
# **didUpdateMetadata**
> DidUpdateMetadata200Response didUpdateMetadata(didUpdateMetadataRequest)

Updates the metadata for a DID wallet.

Updates the metadata for a DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidUpdateMetadataRequest didUpdateMetadataRequest = new DidUpdateMetadataRequest(); // DidUpdateMetadataRequest | 
    try {
      DidUpdateMetadata200Response result = apiInstance.didUpdateMetadata(didUpdateMetadataRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didUpdateMetadata");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didUpdateMetadataRequest** | [**DidUpdateMetadataRequest**](DidUpdateMetadataRequest.md)|  | |

### Return type

[**DidUpdateMetadata200Response**](DidUpdateMetadata200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="didUpdateRecoveryIds"></a>
# **didUpdateRecoveryIds**
> ModelApiResponse didUpdateRecoveryIds(didUpdateRecoveryIdsRequest)

Updates the recovery ids for a DID wallet.

Updates the recovery ids for a DID wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.DidWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    DidWalletApi apiInstance = new DidWalletApi(defaultClient);
    DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest = new DidUpdateRecoveryIdsRequest(); // DidUpdateRecoveryIdsRequest | 
    try {
      ModelApiResponse result = apiInstance.didUpdateRecoveryIds(didUpdateRecoveryIdsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling DidWalletApi#didUpdateRecoveryIds");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **didUpdateRecoveryIdsRequest** | [**DidUpdateRecoveryIdsRequest**](DidUpdateRecoveryIdsRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

