# NftWalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**nftAddUri**](NftWalletApi.md#nftAddUri) | **POST** /nft_add_uri | Adds an Uri to an NFT. |
| [**nftCalculateRoyalties**](NftWalletApi.md#nftCalculateRoyalties) | **POST** /nft_calculate_royalties | Transfers an NFT to another address. |
| [**nftCountNfts**](NftWalletApi.md#nftCountNfts) | **POST** /nft_count_nfts | Retreives the number of NFTs in a wallet. |
| [**nftGetByDid**](NftWalletApi.md#nftGetByDid) | **POST** /nft_get_by_did | Gets an NFT wallet by its DID. |
| [**nftGetInfo**](NftWalletApi.md#nftGetInfo) | **POST** /nft_get_info | Gets info about an NFT. |
| [**nftGetNfts**](NftWalletApi.md#nftGetNfts) | **POST** /nft_get_nfts | Gets NFTs from a wallet. |
| [**nftGetWalletDid**](NftWalletApi.md#nftGetWalletDid) | **POST** /nft_get_wallet_did | Gets the DID for an NFT wallet. |
| [**nftGetWalletsWithDids**](NftWalletApi.md#nftGetWalletsWithDids) | **POST** /nft_get_wallets_with_dids | Gets all the wallets with a DID. |
| [**nftMintBulk**](NftWalletApi.md#nftMintBulk) | **POST** /nft_mint_bulk | Mints NFTs in bulk. |
| [**nftMintNft**](NftWalletApi.md#nftMintNft) | **POST** /nft_mint_nft | Mints an NFT. |
| [**nftSetDidBulk**](NftWalletApi.md#nftSetDidBulk) | **POST** /nft_set_did_bulk | Bulk set DID for NFTs across different wallets. |
| [**nftSetNftDid**](NftWalletApi.md#nftSetNftDid) | **POST** /nft_set_nft_did | Sets the DID of an NFT. |
| [**nftSetNftStatus**](NftWalletApi.md#nftSetNftStatus) | **POST** /nft_set_nft_status | Sets the status of an NFT. |
| [**nftTransferBulk**](NftWalletApi.md#nftTransferBulk) | **POST** /nft_transfer_bulk | Bulk transfer NFTs to an address. |
| [**nftTransferNft**](NftWalletApi.md#nftTransferNft) | **POST** /nft_transfer_nft | Transfers an NFT to another address. |


<a name="nftAddUri"></a>
# **nftAddUri**
> NftSetNftDid200Response nftAddUri(nftAddUriRequest)

Adds an Uri to an NFT.

Adds a Uri to an NFT.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftAddUriRequest nftAddUriRequest = new NftAddUriRequest(); // NftAddUriRequest | 
    try {
      NftSetNftDid200Response result = apiInstance.nftAddUri(nftAddUriRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftAddUri");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftAddUriRequest** | [**NftAddUriRequest**](NftAddUriRequest.md)|  | |

### Return type

[**NftSetNftDid200Response**](NftSetNftDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftCalculateRoyalties"></a>
# **nftCalculateRoyalties**
> NftCalculateRoyalties200Response nftCalculateRoyalties(nftCalculateRoyaltiesRequest)

Transfers an NFT to another address.

Transfers an NFT to another address.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest = new NftCalculateRoyaltiesRequest(); // NftCalculateRoyaltiesRequest | 
    try {
      NftCalculateRoyalties200Response result = apiInstance.nftCalculateRoyalties(nftCalculateRoyaltiesRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftCalculateRoyalties");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftCalculateRoyaltiesRequest** | [**NftCalculateRoyaltiesRequest**](NftCalculateRoyaltiesRequest.md)|  | |

### Return type

[**NftCalculateRoyalties200Response**](NftCalculateRoyalties200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftCountNfts"></a>
# **nftCountNfts**
> NftCountNfts200Response nftCountNfts(nftGetWalletDidRequest)

Retreives the number of NFTs in a wallet.

Retreives the number of NFTs in a wallet

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      NftCountNfts200Response result = apiInstance.nftCountNfts(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftCountNfts");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**NftCountNfts200Response**](NftCountNfts200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftGetByDid"></a>
# **nftGetByDid**
> NftGetByDid200Response nftGetByDid(nftGetByDidRequest)

Gets an NFT wallet by its DID.

Gets an NFT wallet by its DID.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftGetByDidRequest nftGetByDidRequest = new NftGetByDidRequest(); // NftGetByDidRequest | 
    try {
      NftGetByDid200Response result = apiInstance.nftGetByDid(nftGetByDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftGetByDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetByDidRequest** | [**NftGetByDidRequest**](NftGetByDidRequest.md)|  | |

### Return type

[**NftGetByDid200Response**](NftGetByDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftGetInfo"></a>
# **nftGetInfo**
> NftGetInfo200Response nftGetInfo(nftGetInfoRequest)

Gets info about an NFT.

Gets info about an NFT.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftGetInfoRequest nftGetInfoRequest = new NftGetInfoRequest(); // NftGetInfoRequest | 
    try {
      NftGetInfo200Response result = apiInstance.nftGetInfo(nftGetInfoRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftGetInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetInfoRequest** | [**NftGetInfoRequest**](NftGetInfoRequest.md)|  | |

### Return type

[**NftGetInfo200Response**](NftGetInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftGetNfts"></a>
# **nftGetNfts**
> NftGetNfts200Response nftGetNfts(nftGetNftsRequest)

Gets NFTs from a wallet.

Gets NFTs from a wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftGetNftsRequest nftGetNftsRequest = new NftGetNftsRequest(); // NftGetNftsRequest | 
    try {
      NftGetNfts200Response result = apiInstance.nftGetNfts(nftGetNftsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftGetNfts");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetNftsRequest** | [**NftGetNftsRequest**](NftGetNftsRequest.md)|  | |

### Return type

[**NftGetNfts200Response**](NftGetNfts200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftGetWalletDid"></a>
# **nftGetWalletDid**
> NftGetWalletDid200Response nftGetWalletDid(nftGetWalletDidRequest)

Gets the DID for an NFT wallet.

Gets the DID for an NFT wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      NftGetWalletDid200Response result = apiInstance.nftGetWalletDid(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftGetWalletDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**NftGetWalletDid200Response**](NftGetWalletDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftGetWalletsWithDids"></a>
# **nftGetWalletsWithDids**
> NftGetWalletsWithDids200Response nftGetWalletsWithDids(body)

Gets all the wallets with a DID.

Gets all the wallets with a DID.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      NftGetWalletsWithDids200Response result = apiInstance.nftGetWalletsWithDids(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftGetWalletsWithDids");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**NftGetWalletsWithDids200Response**](NftGetWalletsWithDids200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftMintBulk"></a>
# **nftMintBulk**
> NftMintBulk200Response nftMintBulk(nftMintBulkRequest)

Mints NFTs in bulk.

Mints NFTs in bulk.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftMintBulkRequest nftMintBulkRequest = new NftMintBulkRequest(); // NftMintBulkRequest | 
    try {
      NftMintBulk200Response result = apiInstance.nftMintBulk(nftMintBulkRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftMintBulk");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftMintBulkRequest** | [**NftMintBulkRequest**](NftMintBulkRequest.md)|  | |

### Return type

[**NftMintBulk200Response**](NftMintBulk200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftMintNft"></a>
# **nftMintNft**
> NftMintNft200Response nftMintNft(nftMintNftRequest)

Mints an NFT.

Mints an NFT.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftMintNftRequest nftMintNftRequest = new NftMintNftRequest(); // NftMintNftRequest | 
    try {
      NftMintNft200Response result = apiInstance.nftMintNft(nftMintNftRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftMintNft");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftMintNftRequest** | [**NftMintNftRequest**](NftMintNftRequest.md)|  | |

### Return type

[**NftMintNft200Response**](NftMintNft200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftSetDidBulk"></a>
# **nftSetDidBulk**
> NftSetDidBulk200Response nftSetDidBulk(nftSetDidBulkRequest)

Bulk set DID for NFTs across different wallets.

Bulk set DID for NFTs across different wallets

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftSetDidBulkRequest nftSetDidBulkRequest = new NftSetDidBulkRequest(); // NftSetDidBulkRequest | 
    try {
      NftSetDidBulk200Response result = apiInstance.nftSetDidBulk(nftSetDidBulkRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftSetDidBulk");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftSetDidBulkRequest** | [**NftSetDidBulkRequest**](NftSetDidBulkRequest.md)|  | |

### Return type

[**NftSetDidBulk200Response**](NftSetDidBulk200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftSetNftDid"></a>
# **nftSetNftDid**
> NftSetNftDid200Response nftSetNftDid(nftSetNftDidRequest)

Sets the DID of an NFT.

Sets the DID of an NFT.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftSetNftDidRequest nftSetNftDidRequest = new NftSetNftDidRequest(); // NftSetNftDidRequest | 
    try {
      NftSetNftDid200Response result = apiInstance.nftSetNftDid(nftSetNftDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftSetNftDid");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftSetNftDidRequest** | [**NftSetNftDidRequest**](NftSetNftDidRequest.md)|  | |

### Return type

[**NftSetNftDid200Response**](NftSetNftDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftSetNftStatus"></a>
# **nftSetNftStatus**
> ModelApiResponse nftSetNftStatus(nftSetNftStatusRequest)

Sets the status of an NFT.

Sets the status of an NFT.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftSetNftStatusRequest nftSetNftStatusRequest = new NftSetNftStatusRequest(); // NftSetNftStatusRequest | 
    try {
      ModelApiResponse result = apiInstance.nftSetNftStatus(nftSetNftStatusRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftSetNftStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftSetNftStatusRequest** | [**NftSetNftStatusRequest**](NftSetNftStatusRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="nftTransferBulk"></a>
# **nftTransferBulk**
> NftSetDidBulk200Response nftTransferBulk(nftTransferBulkRequest)

Bulk transfer NFTs to an address.

Bulk transfer NFTs to an address

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftTransferBulkRequest nftTransferBulkRequest = new NftTransferBulkRequest(); // NftTransferBulkRequest | 
    try {
      NftSetDidBulk200Response result = apiInstance.nftTransferBulk(nftTransferBulkRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftTransferBulk");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftTransferBulkRequest** | [**NftTransferBulkRequest**](NftTransferBulkRequest.md)|  | |

### Return type

[**NftSetDidBulk200Response**](NftSetDidBulk200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="nftTransferNft"></a>
# **nftTransferNft**
> NftSetNftDid200Response nftTransferNft(nftTransferNftRequest)

Transfers an NFT to another address.

Transfers an NFT to another address.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NftWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NftWalletApi apiInstance = new NftWalletApi(defaultClient);
    NftTransferNftRequest nftTransferNftRequest = new NftTransferNftRequest(); // NftTransferNftRequest | 
    try {
      NftSetNftDid200Response result = apiInstance.nftTransferNft(nftTransferNftRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NftWalletApi#nftTransferNft");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftTransferNftRequest** | [**NftTransferNftRequest**](NftTransferNftRequest.md)|  | |

### Return type

[**NftSetNftDid200Response**](NftSetNftDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

