# NotificationsApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**deleteNotifications**](NotificationsApi.md#deleteNotifications) | **POST** /delete_notifications | Deletes notifications. |
| [**getNotifications**](NotificationsApi.md#getNotifications) | **POST** /get_notifications | Retreives notifications. |
| [**sendNotification**](NotificationsApi.md#sendNotification) | **POST** /send_notification | Sends a notification. |
| [**signMessageByAddress**](NotificationsApi.md#signMessageByAddress) | **POST** /sign_message_by_address | Given a derived P2 address, sign the message by its private key. |
| [**signMessageById**](NotificationsApi.md#signMessageById) | **POST** /sign_message_by_id | Given a NFT/DID ID, sign the message by the P2 private key. |


<a name="deleteNotifications"></a>
# **deleteNotifications**
> ModelApiResponse deleteNotifications(deleteNotificationsRequest)

Deletes notifications.

Deletes notifications.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NotificationsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NotificationsApi apiInstance = new NotificationsApi(defaultClient);
    DeleteNotificationsRequest deleteNotificationsRequest = new DeleteNotificationsRequest(); // DeleteNotificationsRequest | The notifications to delete
    try {
      ModelApiResponse result = apiInstance.deleteNotifications(deleteNotificationsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NotificationsApi#deleteNotifications");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **deleteNotificationsRequest** | [**DeleteNotificationsRequest**](DeleteNotificationsRequest.md)| The notifications to delete | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getNotifications"></a>
# **getNotifications**
> GetNotifications200Response getNotifications(getNotificationsRequest)

Retreives notifications.

Retreives notifications.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NotificationsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NotificationsApi apiInstance = new NotificationsApi(defaultClient);
    GetNotificationsRequest getNotificationsRequest = new GetNotificationsRequest(); // GetNotificationsRequest | Notification query inputs
    try {
      GetNotifications200Response result = apiInstance.getNotifications(getNotificationsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NotificationsApi#getNotifications");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getNotificationsRequest** | [**GetNotificationsRequest**](GetNotificationsRequest.md)| Notification query inputs | |

### Return type

[**GetNotifications200Response**](GetNotifications200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="sendNotification"></a>
# **sendNotification**
> SendNotification200Response sendNotification(sendNotificationRequest)

Sends a notification.

Sends a notification.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NotificationsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NotificationsApi apiInstance = new NotificationsApi(defaultClient);
    SendNotificationRequest sendNotificationRequest = new SendNotificationRequest(); // SendNotificationRequest | The notification to send
    try {
      SendNotification200Response result = apiInstance.sendNotification(sendNotificationRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NotificationsApi#sendNotification");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **sendNotificationRequest** | [**SendNotificationRequest**](SendNotificationRequest.md)| The notification to send | |

### Return type

[**SendNotification200Response**](SendNotification200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="signMessageByAddress"></a>
# **signMessageByAddress**
> SignMessageByAddress200Response signMessageByAddress(signMessageByAddressRequest)

Given a derived P2 address, sign the message by its private key.

Given a derived P2 address, sign the message by its private key.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NotificationsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NotificationsApi apiInstance = new NotificationsApi(defaultClient);
    SignMessageByAddressRequest signMessageByAddressRequest = new SignMessageByAddressRequest(); // SignMessageByAddressRequest | The message
    try {
      SignMessageByAddress200Response result = apiInstance.signMessageByAddress(signMessageByAddressRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NotificationsApi#signMessageByAddress");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **signMessageByAddressRequest** | [**SignMessageByAddressRequest**](SignMessageByAddressRequest.md)| The message | |

### Return type

[**SignMessageByAddress200Response**](SignMessageByAddress200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="signMessageById"></a>
# **signMessageById**
> SignMessageById200Response signMessageById(signMessageByIdRequest)

Given a NFT/DID ID, sign the message by the P2 private key.

Given a NFT/DID ID, sign the message by the P2 private key.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.NotificationsApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    NotificationsApi apiInstance = new NotificationsApi(defaultClient);
    SignMessageByIdRequest signMessageByIdRequest = new SignMessageByIdRequest(); // SignMessageByIdRequest | The message
    try {
      SignMessageById200Response result = apiInstance.signMessageById(signMessageByIdRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling NotificationsApi#signMessageById");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **signMessageByIdRequest** | [**SignMessageByIdRequest**](SignMessageByIdRequest.md)| The message | |

### Return type

[**SignMessageById200Response**](SignMessageById200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

