# PoolWalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**pwAbsorbRewards**](PoolWalletApi.md#pwAbsorbRewards) | **POST** /pw_absorb_rewards | Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton. |
| [**pwJoinPool**](PoolWalletApi.md#pwJoinPool) | **POST** /pw_join_pool | Joins the given wallet to a pool. |
| [**pwSelfPool**](PoolWalletApi.md#pwSelfPool) | **POST** /pw_self_pool | Removes the given wallet to a pool. |
| [**pwStatus**](PoolWalletApi.md#pwStatus) | **POST** /pw_status | Return the complete state of the given Pool wallet. |


<a name="pwAbsorbRewards"></a>
# **pwAbsorbRewards**
> PwAbsorbRewards200Response pwAbsorbRewards(pwSelfPoolRequest)

Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.

Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PoolWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    PoolWalletApi apiInstance = new PoolWalletApi(defaultClient);
    PwSelfPoolRequest pwSelfPoolRequest = new PwSelfPoolRequest(); // PwSelfPoolRequest | 
    try {
      PwAbsorbRewards200Response result = apiInstance.pwAbsorbRewards(pwSelfPoolRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PoolWalletApi#pwAbsorbRewards");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **pwSelfPoolRequest** | [**PwSelfPoolRequest**](PwSelfPoolRequest.md)|  | |

### Return type

[**PwAbsorbRewards200Response**](PwAbsorbRewards200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="pwJoinPool"></a>
# **pwJoinPool**
> PwJoinPool200Response pwJoinPool(pwJoinPoolRequest)

Joins the given wallet to a pool.

Joins the given wallet to a pool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PoolWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    PoolWalletApi apiInstance = new PoolWalletApi(defaultClient);
    PwJoinPoolRequest pwJoinPoolRequest = new PwJoinPoolRequest(); // PwJoinPoolRequest | 
    try {
      PwJoinPool200Response result = apiInstance.pwJoinPool(pwJoinPoolRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PoolWalletApi#pwJoinPool");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **pwJoinPoolRequest** | [**PwJoinPoolRequest**](PwJoinPoolRequest.md)|  | |

### Return type

[**PwJoinPool200Response**](PwJoinPool200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="pwSelfPool"></a>
# **pwSelfPool**
> PwJoinPool200Response pwSelfPool(pwSelfPoolRequest)

Removes the given wallet to a pool.

Removes the given wallet to a pool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PoolWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    PoolWalletApi apiInstance = new PoolWalletApi(defaultClient);
    PwSelfPoolRequest pwSelfPoolRequest = new PwSelfPoolRequest(); // PwSelfPoolRequest | 
    try {
      PwJoinPool200Response result = apiInstance.pwSelfPool(pwSelfPoolRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PoolWalletApi#pwSelfPool");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **pwSelfPoolRequest** | [**PwSelfPoolRequest**](PwSelfPoolRequest.md)|  | |

### Return type

[**PwJoinPool200Response**](PwJoinPool200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="pwStatus"></a>
# **pwStatus**
> PwStatus200Response pwStatus(nftGetWalletDidRequest)

Return the complete state of the given Pool wallet.

Return the complete state of the given Pool wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.PoolWalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    PoolWalletApi apiInstance = new PoolWalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      PwStatus200Response result = apiInstance.pwStatus(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling PoolWalletApi#pwStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**PwStatus200Response**](PwStatus200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

