# WalletApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**createSignedTransaction**](WalletApi.md#createSignedTransaction) | **POST** /create_signed_transaction | Creates and signs a transaction. |
| [**deleteUnconfirmedTransactions**](WalletApi.md#deleteUnconfirmedTransactions) | **POST** /delete_unconfirmed_transactions | Delete all unconfirmed transactions for a given wallet. |
| [**extendDerivationIndex**](WalletApi.md#extendDerivationIndex) | **POST** /extend_derivation_index | Extends the current derivation index. |
| [**getCurrentDerivationIndex**](WalletApi.md#getCurrentDerivationIndex) | **POST** /get_current_derivation_index | Gets the current derivation index. |
| [**getFarmedAmount**](WalletApi.md#getFarmedAmount) | **POST** /get_farmed_amount | Retrieves the amount farmed. |
| [**getNextAddress**](WalletApi.md#getNextAddress) | **POST** /get_next_address | Returns a new address. |
| [**getSpendableCoins**](WalletApi.md#getSpendableCoins) | **POST** /get_spendable_coins | Retrieves all spendable coins in a wallet. |
| [**getTransaction**](WalletApi.md#getTransaction) | **POST** /get_transaction | Retrieves a specific transaction. |
| [**getTransactionCount**](WalletApi.md#getTransactionCount) | **POST** /get_transaction_count | Retrieves the number of transactions for a wallet. |
| [**getTransactionMemo**](WalletApi.md#getTransactionMemo) | **POST** /get_transaction_memo | Retreives the memo from a transaction. |
| [**getTransactions**](WalletApi.md#getTransactions) | **POST** /get_transactions | Retrieves a list of trnsactions from a wallet. |
| [**getWalletBalance**](WalletApi.md#getWalletBalance) | **POST** /get_wallet_balance | Retrieves the balance of a specific wallet. |
| [**sendTransaction**](WalletApi.md#sendTransaction) | **POST** /send_transaction | Sends an amount of mojo from the given wallet to the given address. |
| [**sendTransactionMulti**](WalletApi.md#sendTransactionMulti) | **POST** /send_transaction_multi | Sends multiple transactions from then given wallet. |


<a name="createSignedTransaction"></a>
# **createSignedTransaction**
> CreateSignedTransaction200Response createSignedTransaction(createSignedTransactionRequest)

Creates and signs a transaction.

Creates and signs a transaction.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    CreateSignedTransactionRequest createSignedTransactionRequest = new CreateSignedTransactionRequest(); // CreateSignedTransactionRequest | 
    try {
      CreateSignedTransaction200Response result = apiInstance.createSignedTransaction(createSignedTransactionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#createSignedTransaction");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **createSignedTransactionRequest** | [**CreateSignedTransactionRequest**](CreateSignedTransactionRequest.md)|  | |

### Return type

[**CreateSignedTransaction200Response**](CreateSignedTransaction200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="deleteUnconfirmedTransactions"></a>
# **deleteUnconfirmedTransactions**
> ModelApiResponse deleteUnconfirmedTransactions(nftGetWalletDidRequest)

Delete all unconfirmed transactions for a given wallet.

Delete all unconfirmed transactions for a given wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      ModelApiResponse result = apiInstance.deleteUnconfirmedTransactions(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#deleteUnconfirmedTransactions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="extendDerivationIndex"></a>
# **extendDerivationIndex**
> GetCurrentDerivationIndex200Response extendDerivationIndex(extendDerivationIndexRequest)

Extends the current derivation index.

Extends the current derivation index.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    ExtendDerivationIndexRequest extendDerivationIndexRequest = new ExtendDerivationIndexRequest(); // ExtendDerivationIndexRequest | 
    try {
      GetCurrentDerivationIndex200Response result = apiInstance.extendDerivationIndex(extendDerivationIndexRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#extendDerivationIndex");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **extendDerivationIndexRequest** | [**ExtendDerivationIndexRequest**](ExtendDerivationIndexRequest.md)|  | |

### Return type

[**GetCurrentDerivationIndex200Response**](GetCurrentDerivationIndex200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getCurrentDerivationIndex"></a>
# **getCurrentDerivationIndex**
> GetCurrentDerivationIndex200Response getCurrentDerivationIndex(body)

Gets the current derivation index.

Gets the current derivation index.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetCurrentDerivationIndex200Response result = apiInstance.getCurrentDerivationIndex(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getCurrentDerivationIndex");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetCurrentDerivationIndex200Response**](GetCurrentDerivationIndex200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getFarmedAmount"></a>
# **getFarmedAmount**
> GetFarmedAmount200Response getFarmedAmount(body)

Retrieves the amount farmed.

Retrieves the amount farmed.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetFarmedAmount200Response result = apiInstance.getFarmedAmount(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getFarmedAmount");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetFarmedAmount200Response**](GetFarmedAmount200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getNextAddress"></a>
# **getNextAddress**
> GetNextAddress200Response getNextAddress(getNextAddressRequest)

Returns a new address.

Returns a new address.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    GetNextAddressRequest getNextAddressRequest = new GetNextAddressRequest(); // GetNextAddressRequest | 
    try {
      GetNextAddress200Response result = apiInstance.getNextAddress(getNextAddressRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getNextAddress");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getNextAddressRequest** | [**GetNextAddressRequest**](GetNextAddressRequest.md)|  | |

### Return type

[**GetNextAddress200Response**](GetNextAddress200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getSpendableCoins"></a>
# **getSpendableCoins**
> GetSpendableCoins200Response getSpendableCoins(getSpendableCoinsRequest)

Retrieves all spendable coins in a wallet.

Retrieves all spendable coins in a wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    GetSpendableCoinsRequest getSpendableCoinsRequest = new GetSpendableCoinsRequest(); // GetSpendableCoinsRequest | 
    try {
      GetSpendableCoins200Response result = apiInstance.getSpendableCoins(getSpendableCoinsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getSpendableCoins");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getSpendableCoinsRequest** | [**GetSpendableCoinsRequest**](GetSpendableCoinsRequest.md)|  | |

### Return type

[**GetSpendableCoins200Response**](GetSpendableCoins200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getTransaction"></a>
# **getTransaction**
> DidTransferDid200Response getTransaction(getTransactionRequest)

Retrieves a specific transaction.

Retrieves a specific transaction.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    GetTransactionRequest getTransactionRequest = new GetTransactionRequest(); // GetTransactionRequest | Request body with the Id of a transaction.
    try {
      DidTransferDid200Response result = apiInstance.getTransaction(getTransactionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getTransaction");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getTransactionRequest** | [**GetTransactionRequest**](GetTransactionRequest.md)| Request body with the Id of a transaction. | |

### Return type

[**DidTransferDid200Response**](DidTransferDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response with a transaction record and a transaction id. |  -  |

<a name="getTransactionCount"></a>
# **getTransactionCount**
> GetTransactionCount200Response getTransactionCount(nftGetWalletDidRequest)

Retrieves the number of transactions for a wallet.

Retrieves the number of transactions for a wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      GetTransactionCount200Response result = apiInstance.getTransactionCount(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getTransactionCount");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**GetTransactionCount200Response**](GetTransactionCount200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getTransactionMemo"></a>
# **getTransactionMemo**
> GetTransactionMemo200Response getTransactionMemo(getTransactionRequest)

Retreives the memo from a transaction.

Retreives the memo from a transaction

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    GetTransactionRequest getTransactionRequest = new GetTransactionRequest(); // GetTransactionRequest | 
    try {
      GetTransactionMemo200Response result = apiInstance.getTransactionMemo(getTransactionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getTransactionMemo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getTransactionRequest** | [**GetTransactionRequest**](GetTransactionRequest.md)|  | |

### Return type

[**GetTransactionMemo200Response**](GetTransactionMemo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getTransactions"></a>
# **getTransactions**
> GetTransactions200Response getTransactions(getTransactionsRequest)

Retrieves a list of trnsactions from a wallet.

Retrieves a list of trnsactions from a wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    GetTransactionsRequest getTransactionsRequest = new GetTransactionsRequest(); // GetTransactionsRequest | 
    try {
      GetTransactions200Response result = apiInstance.getTransactions(getTransactionsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getTransactions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getTransactionsRequest** | [**GetTransactionsRequest**](GetTransactionsRequest.md)|  | |

### Return type

[**GetTransactions200Response**](GetTransactions200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getWalletBalance"></a>
# **getWalletBalance**
> GetWalletBalance200Response getWalletBalance(nftGetWalletDidRequest)

Retrieves the balance of a specific wallet.

Retrieves the balance of a specific wallet (in units of mojos).

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    NftGetWalletDidRequest nftGetWalletDidRequest = new NftGetWalletDidRequest(); // NftGetWalletDidRequest | Request body with the Id of a wallet
    try {
      GetWalletBalance200Response result = apiInstance.getWalletBalance(nftGetWalletDidRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#getWalletBalance");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **nftGetWalletDidRequest** | [**NftGetWalletDidRequest**](NftGetWalletDidRequest.md)| Request body with the Id of a wallet | |

### Return type

[**GetWalletBalance200Response**](GetWalletBalance200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="sendTransaction"></a>
# **sendTransaction**
> DidTransferDid200Response sendTransaction(sendTransactionRequest)

Sends an amount of mojo from the given wallet to the given address.

Sends an amount of mojo from the given wallet to the given address.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    SendTransactionRequest sendTransactionRequest = new SendTransactionRequest(); // SendTransactionRequest | 
    try {
      DidTransferDid200Response result = apiInstance.sendTransaction(sendTransactionRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#sendTransaction");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **sendTransactionRequest** | [**SendTransactionRequest**](SendTransactionRequest.md)|  | |

### Return type

[**DidTransferDid200Response**](DidTransferDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response with a transaction record and a transaction id. |  -  |

<a name="sendTransactionMulti"></a>
# **sendTransactionMulti**
> DidTransferDid200Response sendTransactionMulti(sendTransactionMultiRequest)

Sends multiple transactions from then given wallet.

Sends multiple transactions from then given wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletApi apiInstance = new WalletApi(defaultClient);
    SendTransactionMultiRequest sendTransactionMultiRequest = new SendTransactionMultiRequest(); // SendTransactionMultiRequest | 
    try {
      DidTransferDid200Response result = apiInstance.sendTransactionMulti(sendTransactionMultiRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletApi#sendTransactionMulti");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **sendTransactionMultiRequest** | [**SendTransactionMultiRequest**](SendTransactionMultiRequest.md)|  | |

### Return type

[**DidTransferDid200Response**](DidTransferDid200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response with a transaction record and a transaction id. |  -  |

