# WalletManagementApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**createNewWallet**](WalletManagementApi.md#createNewWallet) | **POST** /create_new_wallet | Creates a new wallet. |
| [**getWallets**](WalletManagementApi.md#getWallets) | **POST** /get_wallets | Retrieves all of the wallets on the node. |


<a name="createNewWallet"></a>
# **createNewWallet**
> CreateNewWallet200Response createNewWallet(createNewWalletRequest)

Creates a new wallet.

Creates a new wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletManagementApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletManagementApi apiInstance = new WalletManagementApi(defaultClient);
    CreateNewWalletRequest createNewWalletRequest = new CreateNewWalletRequest(); // CreateNewWalletRequest | Details of the wallet to create.
    try {
      CreateNewWallet200Response result = apiInstance.createNewWallet(createNewWalletRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletManagementApi#createNewWallet");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **createNewWalletRequest** | [**CreateNewWalletRequest**](CreateNewWalletRequest.md)| Details of the wallet to create. | |

### Return type

[**CreateNewWallet200Response**](CreateNewWallet200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getWallets"></a>
# **getWallets**
> GetWallets200Response getWallets(getWalletsRequest)

Retrieves all of the wallets on the node.

Retrieves all of the wallets on the node.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletManagementApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletManagementApi apiInstance = new WalletManagementApi(defaultClient);
    GetWalletsRequest getWalletsRequest = new GetWalletsRequest(); // GetWalletsRequest | Optional wallet type to filter by
    try {
      GetWallets200Response result = apiInstance.getWallets(getWalletsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletManagementApi#getWallets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getWalletsRequest** | [**GetWalletsRequest**](GetWalletsRequest.md)| Optional wallet type to filter by | |

### Return type

[**GetWallets200Response**](GetWallets200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

