# WalletNodeApi

All URIs are relative to *https://localhost:9256*

| Method | HTTP request | Description |
|------------- | ------------- | -------------|
| [**getHeightInfo**](WalletNodeApi.md#getHeightInfo) | **POST** /get_height_info | Retrieves the sync height of the wallet. |
| [**getSyncStatus**](WalletNodeApi.md#getSyncStatus) | **POST** /get_sync_status | Retrieves the sync status of the wallet. |
| [**getTimestampForHeight**](WalletNodeApi.md#getTimestampForHeight) | **POST** /get_timestamp_for_height | Retreive the timestamp for a given block height. |
| [**pushTransactions**](WalletNodeApi.md#pushTransactions) | **POST** /push_transactions | Pushes multiple transactions spend bundle to the mempool and blockchain. |
| [**setWalletResyncOnStartup**](WalletNodeApi.md#setWalletResyncOnStartup) | **POST** /set_wallet_resync_on_startup | Resync the current logged in wallet. The transaction and offer records will be kept. |
| [**walletGetNetworkInfo**](WalletNodeApi.md#walletGetNetworkInfo) | **POST** /get_network_info | Retrieves some information about the current network. |
| [**walletPushTx**](WalletNodeApi.md#walletPushTx) | **POST** /push_tx | Pushes a transaction/spend bundle to the mempool and blockchain. |


<a name="getHeightInfo"></a>
# **getHeightInfo**
> GetHeightInfo200Response getHeightInfo(body)

Retrieves the sync height of the wallet.

Retrieves the sync height of the wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetHeightInfo200Response result = apiInstance.getHeightInfo(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#getHeightInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetHeightInfo200Response**](GetHeightInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getSyncStatus"></a>
# **getSyncStatus**
> GetSyncStatus200Response getSyncStatus(body)

Retrieves the sync status of the wallet.

Retrieves the sync status of the wallet.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      GetSyncStatus200Response result = apiInstance.getSyncStatus(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#getSyncStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**GetSyncStatus200Response**](GetSyncStatus200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="getTimestampForHeight"></a>
# **getTimestampForHeight**
> GetTimestampForHeight200Response getTimestampForHeight(getTimestampForHeightRequest)

Retreive the timestamp for a given block height.

Retreive the timestamp for a given block height

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    GetTimestampForHeightRequest getTimestampForHeightRequest = new GetTimestampForHeightRequest(); // GetTimestampForHeightRequest | 
    try {
      GetTimestampForHeight200Response result = apiInstance.getTimestampForHeight(getTimestampForHeightRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#getTimestampForHeight");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **getTimestampForHeightRequest** | [**GetTimestampForHeightRequest**](GetTimestampForHeightRequest.md)|  | |

### Return type

[**GetTimestampForHeight200Response**](GetTimestampForHeight200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="pushTransactions"></a>
# **pushTransactions**
> ModelApiResponse pushTransactions(pushTransactionsRequest)

Pushes multiple transactions spend bundle to the mempool and blockchain.

Pushes multiple transactions spend bundle to the mempool and blockchain.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    PushTransactionsRequest pushTransactionsRequest = new PushTransactionsRequest(); // PushTransactionsRequest | The transaction list
    try {
      ModelApiResponse result = apiInstance.pushTransactions(pushTransactionsRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#pushTransactions");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **pushTransactionsRequest** | [**PushTransactionsRequest**](PushTransactionsRequest.md)| The transaction list | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="setWalletResyncOnStartup"></a>
# **setWalletResyncOnStartup**
> ModelApiResponse setWalletResyncOnStartup(setWalletResyncOnStartupRequest)

Resync the current logged in wallet. The transaction and offer records will be kept.

Resync the current logged in wallet

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    SetWalletResyncOnStartupRequest setWalletResyncOnStartupRequest = new SetWalletResyncOnStartupRequest(); // SetWalletResyncOnStartupRequest | 
    try {
      ModelApiResponse result = apiInstance.setWalletResyncOnStartup(setWalletResyncOnStartupRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#setWalletResyncOnStartup");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **setWalletResyncOnStartupRequest** | [**SetWalletResyncOnStartupRequest**](SetWalletResyncOnStartupRequest.md)|  | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

<a name="walletGetNetworkInfo"></a>
# **walletGetNetworkInfo**
> WalletGetNetworkInfo200Response walletGetNetworkInfo(body)

Retrieves some information about the current network.

Retrieves some information about the current network.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    Object body = null; // Object | Empty request body
    try {
      WalletGetNetworkInfo200Response result = apiInstance.walletGetNetworkInfo(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#walletGetNetworkInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **body** | **Object**| Empty request body | |

### Return type

[**WalletGetNetworkInfo200Response**](WalletGetNetworkInfo200Response.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK |  -  |

<a name="walletPushTx"></a>
# **walletPushTx**
> ModelApiResponse walletPushTx(walletPushTxRequest)

Pushes a transaction/spend bundle to the mempool and blockchain.

Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.WalletNodeApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://localhost:9256");
    

    WalletNodeApi apiInstance = new WalletNodeApi(defaultClient);
    WalletPushTxRequest walletPushTxRequest = new WalletPushTxRequest(); // WalletPushTxRequest | The spend bundle
    try {
      ModelApiResponse result = apiInstance.walletPushTx(walletPushTxRequest);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling WalletNodeApi#walletPushTx");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

| Name | Type | Description  | Notes |
|------------- | ------------- | ------------- | -------------|
| **walletPushTxRequest** | [**WalletPushTxRequest**](WalletPushTxRequest.md)| The spend bundle | |

### Return type

[**ModelApiResponse**](ModelApiResponse.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
| **200** | OK response without return values |  -  |

