/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CancelOfferRequest;
import org.openapitools.client.model.CancelOffersRequest;
import org.openapitools.client.model.CatAssetIdToName200Response;
import org.openapitools.client.model.CatAssetIdToNameRequest;
import org.openapitools.client.model.CatGetAssetId200Response;
import org.openapitools.client.model.CatSpendRequest;
import org.openapitools.client.model.CheckOfferValidity200Response;
import org.openapitools.client.model.CheckOfferValidityRequest;
import org.openapitools.client.model.CreateOfferForIds200Response;
import org.openapitools.client.model.CreateOfferForIdsRequest;
import org.openapitools.client.model.DidSetWalletNameRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.GetAllOffers200Response;
import org.openapitools.client.model.GetAllOffersRequest;
import org.openapitools.client.model.GetCatList200Response;
import org.openapitools.client.model.GetOffer200Response;
import org.openapitools.client.model.GetOfferRequest;
import org.openapitools.client.model.GetOfferSummary200Response;
import org.openapitools.client.model.GetOfferSummaryRequest;
import org.openapitools.client.model.GetOffersCount200Response;
import org.openapitools.client.model.GetStrayCats200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetByDid200Response;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.SelectCoins200Response;
import org.openapitools.client.model.SelectCoinsRequest;
import org.openapitools.client.model.TakeOffer200Response;
import org.openapitools.client.model.TakeOfferRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class CatWalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public CatWalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CatWalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for cancelOffer
     * @param cancelOfferRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call cancelOfferCall(CancelOfferRequest cancelOfferRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = cancelOfferRequest;

        // create path and map variables
        String localVarPath = "/cancel_offer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call cancelOfferValidateBeforeCall(CancelOfferRequest cancelOfferRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'cancelOfferRequest' is set
        if (cancelOfferRequest == null) {
            throw new ApiException("Missing the required parameter 'cancelOfferRequest' when calling cancelOffer(Async)");
        }

        return cancelOfferCall(cancelOfferRequest, _callback);

    }

    /**
     * Cancels an offer.
     * Cancels an offer.
     * @param cancelOfferRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse cancelOffer(CancelOfferRequest cancelOfferRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = cancelOfferWithHttpInfo(cancelOfferRequest);
        return localVarResp.getData();
    }

    /**
     * Cancels an offer.
     * Cancels an offer.
     * @param cancelOfferRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> cancelOfferWithHttpInfo(CancelOfferRequest cancelOfferRequest) throws ApiException {
        okhttp3.Call localVarCall = cancelOfferValidateBeforeCall(cancelOfferRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Cancels an offer. (asynchronously)
     * Cancels an offer.
     * @param cancelOfferRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call cancelOfferAsync(CancelOfferRequest cancelOfferRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = cancelOfferValidateBeforeCall(cancelOfferRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for cancelOffers
     * @param cancelOffersRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call cancelOffersCall(CancelOffersRequest cancelOffersRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = cancelOffersRequest;

        // create path and map variables
        String localVarPath = "/cancel_offers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call cancelOffersValidateBeforeCall(CancelOffersRequest cancelOffersRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'cancelOffersRequest' is set
        if (cancelOffersRequest == null) {
            throw new ApiException("Missing the required parameter 'cancelOffersRequest' when calling cancelOffers(Async)");
        }

        return cancelOffersCall(cancelOffersRequest, _callback);

    }

    /**
     * Cancels multiple offers.
     * Cancels multiple offers.
     * @param cancelOffersRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse cancelOffers(CancelOffersRequest cancelOffersRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = cancelOffersWithHttpInfo(cancelOffersRequest);
        return localVarResp.getData();
    }

    /**
     * Cancels multiple offers.
     * Cancels multiple offers.
     * @param cancelOffersRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> cancelOffersWithHttpInfo(CancelOffersRequest cancelOffersRequest) throws ApiException {
        okhttp3.Call localVarCall = cancelOffersValidateBeforeCall(cancelOffersRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Cancels multiple offers. (asynchronously)
     * Cancels multiple offers.
     * @param cancelOffersRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call cancelOffersAsync(CancelOffersRequest cancelOffersRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = cancelOffersValidateBeforeCall(cancelOffersRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for catAssetIdToName
     * @param catAssetIdToNameRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catAssetIdToNameCall(CatAssetIdToNameRequest catAssetIdToNameRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = catAssetIdToNameRequest;

        // create path and map variables
        String localVarPath = "/cat_asset_id_to_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call catAssetIdToNameValidateBeforeCall(CatAssetIdToNameRequest catAssetIdToNameRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'catAssetIdToNameRequest' is set
        if (catAssetIdToNameRequest == null) {
            throw new ApiException("Missing the required parameter 'catAssetIdToNameRequest' when calling catAssetIdToName(Async)");
        }

        return catAssetIdToNameCall(catAssetIdToNameRequest, _callback);

    }

    /**
     * Gets the name and wallet id associated with an asset id.
     * Gets the name and wallet id associated with an asset id.
     * @param catAssetIdToNameRequest  (required)
     * @return CatAssetIdToName200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CatAssetIdToName200Response catAssetIdToName(CatAssetIdToNameRequest catAssetIdToNameRequest) throws ApiException {
        ApiResponse<CatAssetIdToName200Response> localVarResp = catAssetIdToNameWithHttpInfo(catAssetIdToNameRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the name and wallet id associated with an asset id.
     * Gets the name and wallet id associated with an asset id.
     * @param catAssetIdToNameRequest  (required)
     * @return ApiResponse&lt;CatAssetIdToName200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CatAssetIdToName200Response> catAssetIdToNameWithHttpInfo(CatAssetIdToNameRequest catAssetIdToNameRequest) throws ApiException {
        okhttp3.Call localVarCall = catAssetIdToNameValidateBeforeCall(catAssetIdToNameRequest, null);
        Type localVarReturnType = new TypeToken<CatAssetIdToName200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the name and wallet id associated with an asset id. (asynchronously)
     * Gets the name and wallet id associated with an asset id.
     * @param catAssetIdToNameRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catAssetIdToNameAsync(CatAssetIdToNameRequest catAssetIdToNameRequest, final ApiCallback<CatAssetIdToName200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = catAssetIdToNameValidateBeforeCall(catAssetIdToNameRequest, _callback);
        Type localVarReturnType = new TypeToken<CatAssetIdToName200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for catGetAssetId
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catGetAssetIdCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/cat_get_asset_id";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call catGetAssetIdValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling catGetAssetId(Async)");
        }

        return catGetAssetIdCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets the asset id of the CAT wallet.
     * Gets the asset id of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return CatGetAssetId200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CatGetAssetId200Response catGetAssetId(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<CatGetAssetId200Response> localVarResp = catGetAssetIdWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the asset id of the CAT wallet.
     * Gets the asset id of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;CatGetAssetId200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CatGetAssetId200Response> catGetAssetIdWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = catGetAssetIdValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<CatGetAssetId200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the asset id of the CAT wallet. (asynchronously)
     * Gets the asset id of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catGetAssetIdAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<CatGetAssetId200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = catGetAssetIdValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<CatGetAssetId200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for catGetName
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catGetNameCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/cat_get_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call catGetNameValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling catGetName(Async)");
        }

        return catGetNameCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets the name of the CAT wallet.
     * Gets the name of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return CatAssetIdToName200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CatAssetIdToName200Response catGetName(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<CatAssetIdToName200Response> localVarResp = catGetNameWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the name of the CAT wallet.
     * Gets the name of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;CatAssetIdToName200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CatAssetIdToName200Response> catGetNameWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = catGetNameValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<CatAssetIdToName200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the name of the CAT wallet. (asynchronously)
     * Gets the name of the CAT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catGetNameAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<CatAssetIdToName200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = catGetNameValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<CatAssetIdToName200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for catSetName
     * @param didSetWalletNameRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catSetNameCall(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didSetWalletNameRequest;

        // create path and map variables
        String localVarPath = "/cat_set_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call catSetNameValidateBeforeCall(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didSetWalletNameRequest' is set
        if (didSetWalletNameRequest == null) {
            throw new ApiException("Missing the required parameter 'didSetWalletNameRequest' when calling catSetName(Async)");
        }

        return catSetNameCall(didSetWalletNameRequest, _callback);

    }

    /**
     * Sets the name of the CAT wallet.
     * Sets the name of the CAT wallet.
     * @param didSetWalletNameRequest Request body with the Id of a wallet (required)
     * @return NftGetByDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetByDid200Response catSetName(DidSetWalletNameRequest didSetWalletNameRequest) throws ApiException {
        ApiResponse<NftGetByDid200Response> localVarResp = catSetNameWithHttpInfo(didSetWalletNameRequest);
        return localVarResp.getData();
    }

    /**
     * Sets the name of the CAT wallet.
     * Sets the name of the CAT wallet.
     * @param didSetWalletNameRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;NftGetByDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetByDid200Response> catSetNameWithHttpInfo(DidSetWalletNameRequest didSetWalletNameRequest) throws ApiException {
        okhttp3.Call localVarCall = catSetNameValidateBeforeCall(didSetWalletNameRequest, null);
        Type localVarReturnType = new TypeToken<NftGetByDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sets the name of the CAT wallet. (asynchronously)
     * Sets the name of the CAT wallet.
     * @param didSetWalletNameRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catSetNameAsync(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback<NftGetByDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = catSetNameValidateBeforeCall(didSetWalletNameRequest, _callback);
        Type localVarReturnType = new TypeToken<NftGetByDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for catSpend
     * @param catSpendRequest Request body with the Id of a wallet. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catSpendCall(CatSpendRequest catSpendRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = catSpendRequest;

        // create path and map variables
        String localVarPath = "/cat_spend";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call catSpendValidateBeforeCall(CatSpendRequest catSpendRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'catSpendRequest' is set
        if (catSpendRequest == null) {
            throw new ApiException("Missing the required parameter 'catSpendRequest' when calling catSpend(Async)");
        }

        return catSpendCall(catSpendRequest, _callback);

    }

    /**
     * Spends an amount from the given wallet.
     * Spends an amount from the given wallet.
     * @param catSpendRequest Request body with the Id of a wallet. (required)
     * @return DidTransferDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public DidTransferDid200Response catSpend(CatSpendRequest catSpendRequest) throws ApiException {
        ApiResponse<DidTransferDid200Response> localVarResp = catSpendWithHttpInfo(catSpendRequest);
        return localVarResp.getData();
    }

    /**
     * Spends an amount from the given wallet.
     * Spends an amount from the given wallet.
     * @param catSpendRequest Request body with the Id of a wallet. (required)
     * @return ApiResponse&lt;DidTransferDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidTransferDid200Response> catSpendWithHttpInfo(CatSpendRequest catSpendRequest) throws ApiException {
        okhttp3.Call localVarCall = catSpendValidateBeforeCall(catSpendRequest, null);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Spends an amount from the given wallet. (asynchronously)
     * Spends an amount from the given wallet.
     * @param catSpendRequest Request body with the Id of a wallet. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call catSpendAsync(CatSpendRequest catSpendRequest, final ApiCallback<DidTransferDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = catSpendValidateBeforeCall(catSpendRequest, _callback);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for checkOfferValidity
     * @param checkOfferValidityRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call checkOfferValidityCall(CheckOfferValidityRequest checkOfferValidityRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = checkOfferValidityRequest;

        // create path and map variables
        String localVarPath = "/check_offer_validity";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call checkOfferValidityValidateBeforeCall(CheckOfferValidityRequest checkOfferValidityRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'checkOfferValidityRequest' is set
        if (checkOfferValidityRequest == null) {
            throw new ApiException("Missing the required parameter 'checkOfferValidityRequest' when calling checkOfferValidity(Async)");
        }

        return checkOfferValidityCall(checkOfferValidityRequest, _callback);

    }

    /**
     * Checks the validity of an offer.
     * Checks the validity of an offer.
     * @param checkOfferValidityRequest  (required)
     * @return CheckOfferValidity200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CheckOfferValidity200Response checkOfferValidity(CheckOfferValidityRequest checkOfferValidityRequest) throws ApiException {
        ApiResponse<CheckOfferValidity200Response> localVarResp = checkOfferValidityWithHttpInfo(checkOfferValidityRequest);
        return localVarResp.getData();
    }

    /**
     * Checks the validity of an offer.
     * Checks the validity of an offer.
     * @param checkOfferValidityRequest  (required)
     * @return ApiResponse&lt;CheckOfferValidity200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CheckOfferValidity200Response> checkOfferValidityWithHttpInfo(CheckOfferValidityRequest checkOfferValidityRequest) throws ApiException {
        okhttp3.Call localVarCall = checkOfferValidityValidateBeforeCall(checkOfferValidityRequest, null);
        Type localVarReturnType = new TypeToken<CheckOfferValidity200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Checks the validity of an offer. (asynchronously)
     * Checks the validity of an offer.
     * @param checkOfferValidityRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call checkOfferValidityAsync(CheckOfferValidityRequest checkOfferValidityRequest, final ApiCallback<CheckOfferValidity200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = checkOfferValidityValidateBeforeCall(checkOfferValidityRequest, _callback);
        Type localVarReturnType = new TypeToken<CheckOfferValidity200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for createOfferForIds
     * @param createOfferForIdsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createOfferForIdsCall(CreateOfferForIdsRequest createOfferForIdsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = createOfferForIdsRequest;

        // create path and map variables
        String localVarPath = "/create_offer_for_ids";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createOfferForIdsValidateBeforeCall(CreateOfferForIdsRequest createOfferForIdsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'createOfferForIdsRequest' is set
        if (createOfferForIdsRequest == null) {
            throw new ApiException("Missing the required parameter 'createOfferForIdsRequest' when calling createOfferForIds(Async)");
        }

        return createOfferForIdsCall(createOfferForIdsRequest, _callback);

    }

    /**
     * Creates an offer.
     * Creates an offer for the given set of wallet id and amount pairs.
     * @param createOfferForIdsRequest  (required)
     * @return CreateOfferForIds200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CreateOfferForIds200Response createOfferForIds(CreateOfferForIdsRequest createOfferForIdsRequest) throws ApiException {
        ApiResponse<CreateOfferForIds200Response> localVarResp = createOfferForIdsWithHttpInfo(createOfferForIdsRequest);
        return localVarResp.getData();
    }

    /**
     * Creates an offer.
     * Creates an offer for the given set of wallet id and amount pairs.
     * @param createOfferForIdsRequest  (required)
     * @return ApiResponse&lt;CreateOfferForIds200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateOfferForIds200Response> createOfferForIdsWithHttpInfo(CreateOfferForIdsRequest createOfferForIdsRequest) throws ApiException {
        okhttp3.Call localVarCall = createOfferForIdsValidateBeforeCall(createOfferForIdsRequest, null);
        Type localVarReturnType = new TypeToken<CreateOfferForIds200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Creates an offer. (asynchronously)
     * Creates an offer for the given set of wallet id and amount pairs.
     * @param createOfferForIdsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createOfferForIdsAsync(CreateOfferForIdsRequest createOfferForIdsRequest, final ApiCallback<CreateOfferForIds200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = createOfferForIdsValidateBeforeCall(createOfferForIdsRequest, _callback);
        Type localVarReturnType = new TypeToken<CreateOfferForIds200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getAllOffers
     * @param getAllOffersRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAllOffersCall(GetAllOffersRequest getAllOffersRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getAllOffersRequest;

        // create path and map variables
        String localVarPath = "/get_all_offers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getAllOffersValidateBeforeCall(GetAllOffersRequest getAllOffersRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getAllOffersRequest' is set
        if (getAllOffersRequest == null) {
            throw new ApiException("Missing the required parameter 'getAllOffersRequest' when calling getAllOffers(Async)");
        }

        return getAllOffersCall(getAllOffersRequest, _callback);

    }

    /**
     * Retrieves offers.
     * Retrieves offers.
     * @param getAllOffersRequest  (required)
     * @return GetAllOffers200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetAllOffers200Response getAllOffers(GetAllOffersRequest getAllOffersRequest) throws ApiException {
        ApiResponse<GetAllOffers200Response> localVarResp = getAllOffersWithHttpInfo(getAllOffersRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves offers.
     * Retrieves offers.
     * @param getAllOffersRequest  (required)
     * @return ApiResponse&lt;GetAllOffers200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetAllOffers200Response> getAllOffersWithHttpInfo(GetAllOffersRequest getAllOffersRequest) throws ApiException {
        okhttp3.Call localVarCall = getAllOffersValidateBeforeCall(getAllOffersRequest, null);
        Type localVarReturnType = new TypeToken<GetAllOffers200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves offers. (asynchronously)
     * Retrieves offers.
     * @param getAllOffersRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getAllOffersAsync(GetAllOffersRequest getAllOffersRequest, final ApiCallback<GetAllOffers200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getAllOffersValidateBeforeCall(getAllOffersRequest, _callback);
        Type localVarReturnType = new TypeToken<GetAllOffers200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCatList
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCatListCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_cat_list";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCatListValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getCatList(Async)");
        }

        return getCatListCall(body, _callback);

    }

    /**
     * Retrieves the list of CATs.
     * Retrieves the list of CATs.
     * @param body Empty request body (required)
     * @return GetCatList200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCatList200Response getCatList(Object body) throws ApiException {
        ApiResponse<GetCatList200Response> localVarResp = getCatListWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Retrieves the list of CATs.
     * Retrieves the list of CATs.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetCatList200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCatList200Response> getCatListWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getCatListValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetCatList200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the list of CATs. (asynchronously)
     * Retrieves the list of CATs.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCatListAsync(Object body, final ApiCallback<GetCatList200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCatListValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetCatList200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getOffer
     * @param getOfferRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOfferCall(GetOfferRequest getOfferRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getOfferRequest;

        // create path and map variables
        String localVarPath = "/get_offer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getOfferValidateBeforeCall(GetOfferRequest getOfferRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getOfferRequest' is set
        if (getOfferRequest == null) {
            throw new ApiException("Missing the required parameter 'getOfferRequest' when calling getOffer(Async)");
        }

        return getOfferCall(getOfferRequest, _callback);

    }

    /**
     * Retrieves an offer.
     * Retrieves an offer.
     * @param getOfferRequest  (required)
     * @return GetOffer200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetOffer200Response getOffer(GetOfferRequest getOfferRequest) throws ApiException {
        ApiResponse<GetOffer200Response> localVarResp = getOfferWithHttpInfo(getOfferRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves an offer.
     * Retrieves an offer.
     * @param getOfferRequest  (required)
     * @return ApiResponse&lt;GetOffer200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetOffer200Response> getOfferWithHttpInfo(GetOfferRequest getOfferRequest) throws ApiException {
        okhttp3.Call localVarCall = getOfferValidateBeforeCall(getOfferRequest, null);
        Type localVarReturnType = new TypeToken<GetOffer200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves an offer. (asynchronously)
     * Retrieves an offer.
     * @param getOfferRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOfferAsync(GetOfferRequest getOfferRequest, final ApiCallback<GetOffer200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getOfferValidateBeforeCall(getOfferRequest, _callback);
        Type localVarReturnType = new TypeToken<GetOffer200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getOfferSummary
     * @param getOfferSummaryRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOfferSummaryCall(GetOfferSummaryRequest getOfferSummaryRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getOfferSummaryRequest;

        // create path and map variables
        String localVarPath = "/get_offer_summary";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getOfferSummaryValidateBeforeCall(GetOfferSummaryRequest getOfferSummaryRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getOfferSummaryRequest' is set
        if (getOfferSummaryRequest == null) {
            throw new ApiException("Missing the required parameter 'getOfferSummaryRequest' when calling getOfferSummary(Async)");
        }

        return getOfferSummaryCall(getOfferSummaryRequest, _callback);

    }

    /**
     * Get the summary of a given offer.
     * Get the summary of a given offer.
     * @param getOfferSummaryRequest  (required)
     * @return GetOfferSummary200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetOfferSummary200Response getOfferSummary(GetOfferSummaryRequest getOfferSummaryRequest) throws ApiException {
        ApiResponse<GetOfferSummary200Response> localVarResp = getOfferSummaryWithHttpInfo(getOfferSummaryRequest);
        return localVarResp.getData();
    }

    /**
     * Get the summary of a given offer.
     * Get the summary of a given offer.
     * @param getOfferSummaryRequest  (required)
     * @return ApiResponse&lt;GetOfferSummary200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetOfferSummary200Response> getOfferSummaryWithHttpInfo(GetOfferSummaryRequest getOfferSummaryRequest) throws ApiException {
        okhttp3.Call localVarCall = getOfferSummaryValidateBeforeCall(getOfferSummaryRequest, null);
        Type localVarReturnType = new TypeToken<GetOfferSummary200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the summary of a given offer. (asynchronously)
     * Get the summary of a given offer.
     * @param getOfferSummaryRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOfferSummaryAsync(GetOfferSummaryRequest getOfferSummaryRequest, final ApiCallback<GetOfferSummary200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getOfferSummaryValidateBeforeCall(getOfferSummaryRequest, _callback);
        Type localVarReturnType = new TypeToken<GetOfferSummary200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getOffersCount
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOffersCountCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_offers_count";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getOffersCountValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getOffersCount(Async)");
        }

        return getOffersCountCall(body, _callback);

    }

    /**
     * Retrieves the number of offers.
     * Retrieves the number of offers.
     * @param body Empty request body (required)
     * @return GetOffersCount200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetOffersCount200Response getOffersCount(Object body) throws ApiException {
        ApiResponse<GetOffersCount200Response> localVarResp = getOffersCountWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Retrieves the number of offers.
     * Retrieves the number of offers.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetOffersCount200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetOffersCount200Response> getOffersCountWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getOffersCountValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetOffersCount200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the number of offers. (asynchronously)
     * Retrieves the number of offers.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getOffersCountAsync(Object body, final ApiCallback<GetOffersCount200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getOffersCountValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetOffersCount200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getStrayCats
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getStrayCatsCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_stray_cats";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getStrayCatsValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getStrayCats(Async)");
        }

        return getStrayCatsCall(body, _callback);

    }

    /**
     * Get a list of all unacknowledged CATs.
     * Get a list of all unacknowledged CATs.
     * @param body Empty request body (required)
     * @return GetStrayCats200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetStrayCats200Response getStrayCats(Object body) throws ApiException {
        ApiResponse<GetStrayCats200Response> localVarResp = getStrayCatsWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get a list of all unacknowledged CATs.
     * Get a list of all unacknowledged CATs.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetStrayCats200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetStrayCats200Response> getStrayCatsWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getStrayCatsValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetStrayCats200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get a list of all unacknowledged CATs. (asynchronously)
     * Get a list of all unacknowledged CATs.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getStrayCatsAsync(Object body, final ApiCallback<GetStrayCats200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getStrayCatsValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetStrayCats200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for selectCoins
     * @param selectCoinsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call selectCoinsCall(SelectCoinsRequest selectCoinsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = selectCoinsRequest;

        // create path and map variables
        String localVarPath = "/select_coins";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call selectCoinsValidateBeforeCall(SelectCoinsRequest selectCoinsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'selectCoinsRequest' is set
        if (selectCoinsRequest == null) {
            throw new ApiException("Missing the required parameter 'selectCoinsRequest' when calling selectCoins(Async)");
        }

        return selectCoinsCall(selectCoinsRequest, _callback);

    }

    /**
     * Returns a set of coins that can be used for generating a new transaction.
     * Returns a set of coins that can be used for generating a new transaction.
     * @param selectCoinsRequest  (required)
     * @return SelectCoins200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public SelectCoins200Response selectCoins(SelectCoinsRequest selectCoinsRequest) throws ApiException {
        ApiResponse<SelectCoins200Response> localVarResp = selectCoinsWithHttpInfo(selectCoinsRequest);
        return localVarResp.getData();
    }

    /**
     * Returns a set of coins that can be used for generating a new transaction.
     * Returns a set of coins that can be used for generating a new transaction.
     * @param selectCoinsRequest  (required)
     * @return ApiResponse&lt;SelectCoins200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SelectCoins200Response> selectCoinsWithHttpInfo(SelectCoinsRequest selectCoinsRequest) throws ApiException {
        okhttp3.Call localVarCall = selectCoinsValidateBeforeCall(selectCoinsRequest, null);
        Type localVarReturnType = new TypeToken<SelectCoins200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Returns a set of coins that can be used for generating a new transaction. (asynchronously)
     * Returns a set of coins that can be used for generating a new transaction.
     * @param selectCoinsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call selectCoinsAsync(SelectCoinsRequest selectCoinsRequest, final ApiCallback<SelectCoins200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = selectCoinsValidateBeforeCall(selectCoinsRequest, _callback);
        Type localVarReturnType = new TypeToken<SelectCoins200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for takeOffer
     * @param takeOfferRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call takeOfferCall(TakeOfferRequest takeOfferRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = takeOfferRequest;

        // create path and map variables
        String localVarPath = "/take_offer";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call takeOfferValidateBeforeCall(TakeOfferRequest takeOfferRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'takeOfferRequest' is set
        if (takeOfferRequest == null) {
            throw new ApiException("Missing the required parameter 'takeOfferRequest' when calling takeOffer(Async)");
        }

        return takeOfferCall(takeOfferRequest, _callback);

    }

    /**
     * Takes an offer.
     * Takes an offer.
     * @param takeOfferRequest  (required)
     * @return TakeOffer200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public TakeOffer200Response takeOffer(TakeOfferRequest takeOfferRequest) throws ApiException {
        ApiResponse<TakeOffer200Response> localVarResp = takeOfferWithHttpInfo(takeOfferRequest);
        return localVarResp.getData();
    }

    /**
     * Takes an offer.
     * Takes an offer.
     * @param takeOfferRequest  (required)
     * @return ApiResponse&lt;TakeOffer200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<TakeOffer200Response> takeOfferWithHttpInfo(TakeOfferRequest takeOfferRequest) throws ApiException {
        okhttp3.Call localVarCall = takeOfferValidateBeforeCall(takeOfferRequest, null);
        Type localVarReturnType = new TypeToken<TakeOffer200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Takes an offer. (asynchronously)
     * Takes an offer.
     * @param takeOfferRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call takeOfferAsync(TakeOfferRequest takeOfferRequest, final ApiCallback<TakeOffer200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = takeOfferValidateBeforeCall(takeOfferRequest, _callback);
        Type localVarReturnType = new TypeToken<TakeOffer200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
