/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.GetCoinRecordsByNames200Response;
import org.openapitools.client.model.GetCoinRecordsByNamesRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class CoinsApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public CoinsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public CoinsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for getCoinRecordsByNames
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByNamesCall(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getCoinRecordsByNamesRequest;

        // create path and map variables
        String localVarPath = "/get_coin_records_by_names";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCoinRecordsByNamesValidateBeforeCall(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getCoinRecordsByNamesRequest' is set
        if (getCoinRecordsByNamesRequest == null) {
            throw new ApiException("Missing the required parameter 'getCoinRecordsByNamesRequest' when calling getCoinRecordsByNames(Async)");
        }

        return getCoinRecordsByNamesCall(getCoinRecordsByNamesRequest, _callback);

    }

    /**
     * Retrieves the coins for given coin IDs.
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @return GetCoinRecordsByNames200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCoinRecordsByNames200Response getCoinRecordsByNames(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest) throws ApiException {
        ApiResponse<GetCoinRecordsByNames200Response> localVarResp = getCoinRecordsByNamesWithHttpInfo(getCoinRecordsByNamesRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the coins for given coin IDs.
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @return ApiResponse&lt;GetCoinRecordsByNames200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCoinRecordsByNames200Response> getCoinRecordsByNamesWithHttpInfo(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest) throws ApiException {
        okhttp3.Call localVarCall = getCoinRecordsByNamesValidateBeforeCall(getCoinRecordsByNamesRequest, null);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByNames200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the coins for given coin IDs. (asynchronously)
     * Retrieves the coins for given coin IDs, by default returns unspent coins.
     * @param getCoinRecordsByNamesRequest The coin names. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCoinRecordsByNamesAsync(GetCoinRecordsByNamesRequest getCoinRecordsByNamesRequest, final ApiCallback<GetCoinRecordsByNames200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCoinRecordsByNamesValidateBeforeCall(getCoinRecordsByNamesRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCoinRecordsByNames200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
