/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CreateNewDl200Response;
import org.openapitools.client.model.CreateNewDlRequest;
import org.openapitools.client.model.DlDeleteMirrorRequest;
import org.openapitools.client.model.DlGetMirrors200Response;
import org.openapitools.client.model.DlHistory200Response;
import org.openapitools.client.model.DlHistoryRequest;
import org.openapitools.client.model.DlLatestSingleton200Response;
import org.openapitools.client.model.DlLatestSingletonRequest;
import org.openapitools.client.model.DlNewMirror200Response;
import org.openapitools.client.model.DlNewMirrorRequest;
import org.openapitools.client.model.DlOwnedSingletons200Response;
import org.openapitools.client.model.DlSingletonsByRoot200Response;
import org.openapitools.client.model.DlTrackNewRequest;
import org.openapitools.client.model.DlUpdateMultiple200Response;
import org.openapitools.client.model.DlUpdateMultipleRequest;
import org.openapitools.client.model.DlUpdateRoot200Response;
import org.openapitools.client.model.DlUpdateRootRequest;
import org.openapitools.client.model.ModelApiResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class DataLayerWalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public DataLayerWalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DataLayerWalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for createNewDl
     * @param createNewDlRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createNewDlCall(CreateNewDlRequest createNewDlRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = createNewDlRequest;

        // create path and map variables
        String localVarPath = "/create_new_dl";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createNewDlValidateBeforeCall(CreateNewDlRequest createNewDlRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'createNewDlRequest' is set
        if (createNewDlRequest == null) {
            throw new ApiException("Missing the required parameter 'createNewDlRequest' when calling createNewDl(Async)");
        }

        return createNewDlCall(createNewDlRequest, _callback);

    }

    /**
     * Initialize the new data layer wallets.
     * Initialize the DataLayer Wallet (only one can exist).
     * @param createNewDlRequest  (required)
     * @return CreateNewDl200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CreateNewDl200Response createNewDl(CreateNewDlRequest createNewDlRequest) throws ApiException {
        ApiResponse<CreateNewDl200Response> localVarResp = createNewDlWithHttpInfo(createNewDlRequest);
        return localVarResp.getData();
    }

    /**
     * Initialize the new data layer wallets.
     * Initialize the DataLayer Wallet (only one can exist).
     * @param createNewDlRequest  (required)
     * @return ApiResponse&lt;CreateNewDl200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateNewDl200Response> createNewDlWithHttpInfo(CreateNewDlRequest createNewDlRequest) throws ApiException {
        okhttp3.Call localVarCall = createNewDlValidateBeforeCall(createNewDlRequest, null);
        Type localVarReturnType = new TypeToken<CreateNewDl200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Initialize the new data layer wallets. (asynchronously)
     * Initialize the DataLayer Wallet (only one can exist).
     * @param createNewDlRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createNewDlAsync(CreateNewDlRequest createNewDlRequest, final ApiCallback<CreateNewDl200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = createNewDlValidateBeforeCall(createNewDlRequest, _callback);
        Type localVarReturnType = new TypeToken<CreateNewDl200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlDeleteMirror
     * @param dlDeleteMirrorRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlDeleteMirrorCall(DlDeleteMirrorRequest dlDeleteMirrorRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlDeleteMirrorRequest;

        // create path and map variables
        String localVarPath = "/dl_delete_mirror";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlDeleteMirrorValidateBeforeCall(DlDeleteMirrorRequest dlDeleteMirrorRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlDeleteMirrorRequest' is set
        if (dlDeleteMirrorRequest == null) {
            throw new ApiException("Missing the required parameter 'dlDeleteMirrorRequest' when calling dlDeleteMirror(Async)");
        }

        return dlDeleteMirrorCall(dlDeleteMirrorRequest, _callback);

    }

    /**
     * Remove an existing mirror for a specific singleton.
     * Remove an existing mirror for a specific singleton.
     * @param dlDeleteMirrorRequest  (required)
     * @return DlNewMirror200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlNewMirror200Response dlDeleteMirror(DlDeleteMirrorRequest dlDeleteMirrorRequest) throws ApiException {
        ApiResponse<DlNewMirror200Response> localVarResp = dlDeleteMirrorWithHttpInfo(dlDeleteMirrorRequest);
        return localVarResp.getData();
    }

    /**
     * Remove an existing mirror for a specific singleton.
     * Remove an existing mirror for a specific singleton.
     * @param dlDeleteMirrorRequest  (required)
     * @return ApiResponse&lt;DlNewMirror200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlNewMirror200Response> dlDeleteMirrorWithHttpInfo(DlDeleteMirrorRequest dlDeleteMirrorRequest) throws ApiException {
        okhttp3.Call localVarCall = dlDeleteMirrorValidateBeforeCall(dlDeleteMirrorRequest, null);
        Type localVarReturnType = new TypeToken<DlNewMirror200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Remove an existing mirror for a specific singleton. (asynchronously)
     * Remove an existing mirror for a specific singleton.
     * @param dlDeleteMirrorRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlDeleteMirrorAsync(DlDeleteMirrorRequest dlDeleteMirrorRequest, final ApiCallback<DlNewMirror200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlDeleteMirrorValidateBeforeCall(dlDeleteMirrorRequest, _callback);
        Type localVarReturnType = new TypeToken<DlNewMirror200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlGetMirrors
     * @param dlTrackNewRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlGetMirrorsCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlTrackNewRequest;

        // create path and map variables
        String localVarPath = "/dl_get_mirrors";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlGetMirrorsValidateBeforeCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlTrackNewRequest' is set
        if (dlTrackNewRequest == null) {
            throw new ApiException("Missing the required parameter 'dlTrackNewRequest' when calling dlGetMirrors(Async)");
        }

        return dlGetMirrorsCall(dlTrackNewRequest, _callback);

    }

    /**
     * Get all of the mirrors for a specific singleton.
     * Get all of the mirrors for a specific singleton.
     * @param dlTrackNewRequest  (required)
     * @return DlGetMirrors200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlGetMirrors200Response dlGetMirrors(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        ApiResponse<DlGetMirrors200Response> localVarResp = dlGetMirrorsWithHttpInfo(dlTrackNewRequest);
        return localVarResp.getData();
    }

    /**
     * Get all of the mirrors for a specific singleton.
     * Get all of the mirrors for a specific singleton.
     * @param dlTrackNewRequest  (required)
     * @return ApiResponse&lt;DlGetMirrors200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlGetMirrors200Response> dlGetMirrorsWithHttpInfo(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        okhttp3.Call localVarCall = dlGetMirrorsValidateBeforeCall(dlTrackNewRequest, null);
        Type localVarReturnType = new TypeToken<DlGetMirrors200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get all of the mirrors for a specific singleton. (asynchronously)
     * Get all of the mirrors for a specific singleton.
     * @param dlTrackNewRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlGetMirrorsAsync(DlTrackNewRequest dlTrackNewRequest, final ApiCallback<DlGetMirrors200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlGetMirrorsValidateBeforeCall(dlTrackNewRequest, _callback);
        Type localVarReturnType = new TypeToken<DlGetMirrors200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlHistory
     * @param dlHistoryRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlHistoryCall(DlHistoryRequest dlHistoryRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlHistoryRequest;

        // create path and map variables
        String localVarPath = "/dl_history";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlHistoryValidateBeforeCall(DlHistoryRequest dlHistoryRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlHistoryRequest' is set
        if (dlHistoryRequest == null) {
            throw new ApiException("Missing the required parameter 'dlHistoryRequest' when calling dlHistory(Async)");
        }

        return dlHistoryCall(dlHistoryRequest, _callback);

    }

    /**
     * Get the singleton record for the latest singleton of a launcher ID.
     * Get the singleton record for the latest singleton of a launcher ID.
     * @param dlHistoryRequest  (required)
     * @return DlHistory200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlHistory200Response dlHistory(DlHistoryRequest dlHistoryRequest) throws ApiException {
        ApiResponse<DlHistory200Response> localVarResp = dlHistoryWithHttpInfo(dlHistoryRequest);
        return localVarResp.getData();
    }

    /**
     * Get the singleton record for the latest singleton of a launcher ID.
     * Get the singleton record for the latest singleton of a launcher ID.
     * @param dlHistoryRequest  (required)
     * @return ApiResponse&lt;DlHistory200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlHistory200Response> dlHistoryWithHttpInfo(DlHistoryRequest dlHistoryRequest) throws ApiException {
        okhttp3.Call localVarCall = dlHistoryValidateBeforeCall(dlHistoryRequest, null);
        Type localVarReturnType = new TypeToken<DlHistory200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the singleton record for the latest singleton of a launcher ID. (asynchronously)
     * Get the singleton record for the latest singleton of a launcher ID.
     * @param dlHistoryRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlHistoryAsync(DlHistoryRequest dlHistoryRequest, final ApiCallback<DlHistory200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlHistoryValidateBeforeCall(dlHistoryRequest, _callback);
        Type localVarReturnType = new TypeToken<DlHistory200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlLatestSingleton
     * @param dlLatestSingletonRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlLatestSingletonCall(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlLatestSingletonRequest;

        // create path and map variables
        String localVarPath = "/dl_latest_singleton";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlLatestSingletonValidateBeforeCall(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlLatestSingletonRequest' is set
        if (dlLatestSingletonRequest == null) {
            throw new ApiException("Missing the required parameter 'dlLatestSingletonRequest' when calling dlLatestSingleton(Async)");
        }

        return dlLatestSingletonCall(dlLatestSingletonRequest, _callback);

    }

    /**
     * Get the singleton records that contain the specified root.
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @return DlLatestSingleton200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlLatestSingleton200Response dlLatestSingleton(DlLatestSingletonRequest dlLatestSingletonRequest) throws ApiException {
        ApiResponse<DlLatestSingleton200Response> localVarResp = dlLatestSingletonWithHttpInfo(dlLatestSingletonRequest);
        return localVarResp.getData();
    }

    /**
     * Get the singleton records that contain the specified root.
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @return ApiResponse&lt;DlLatestSingleton200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlLatestSingleton200Response> dlLatestSingletonWithHttpInfo(DlLatestSingletonRequest dlLatestSingletonRequest) throws ApiException {
        okhttp3.Call localVarCall = dlLatestSingletonValidateBeforeCall(dlLatestSingletonRequest, null);
        Type localVarReturnType = new TypeToken<DlLatestSingleton200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the singleton records that contain the specified root. (asynchronously)
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlLatestSingletonAsync(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback<DlLatestSingleton200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlLatestSingletonValidateBeforeCall(dlLatestSingletonRequest, _callback);
        Type localVarReturnType = new TypeToken<DlLatestSingleton200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlNewMirror
     * @param dlNewMirrorRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlNewMirrorCall(DlNewMirrorRequest dlNewMirrorRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlNewMirrorRequest;

        // create path and map variables
        String localVarPath = "/dl_new_mirror";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlNewMirrorValidateBeforeCall(DlNewMirrorRequest dlNewMirrorRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlNewMirrorRequest' is set
        if (dlNewMirrorRequest == null) {
            throw new ApiException("Missing the required parameter 'dlNewMirrorRequest' when calling dlNewMirror(Async)");
        }

        return dlNewMirrorCall(dlNewMirrorRequest, _callback);

    }

    /**
     * Add a new on chain message for a specific singleton.
     * Add a new on chain message for a specific singleton
     * @param dlNewMirrorRequest  (required)
     * @return DlNewMirror200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlNewMirror200Response dlNewMirror(DlNewMirrorRequest dlNewMirrorRequest) throws ApiException {
        ApiResponse<DlNewMirror200Response> localVarResp = dlNewMirrorWithHttpInfo(dlNewMirrorRequest);
        return localVarResp.getData();
    }

    /**
     * Add a new on chain message for a specific singleton.
     * Add a new on chain message for a specific singleton
     * @param dlNewMirrorRequest  (required)
     * @return ApiResponse&lt;DlNewMirror200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlNewMirror200Response> dlNewMirrorWithHttpInfo(DlNewMirrorRequest dlNewMirrorRequest) throws ApiException {
        okhttp3.Call localVarCall = dlNewMirrorValidateBeforeCall(dlNewMirrorRequest, null);
        Type localVarReturnType = new TypeToken<DlNewMirror200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Add a new on chain message for a specific singleton. (asynchronously)
     * Add a new on chain message for a specific singleton
     * @param dlNewMirrorRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlNewMirrorAsync(DlNewMirrorRequest dlNewMirrorRequest, final ApiCallback<DlNewMirror200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlNewMirrorValidateBeforeCall(dlNewMirrorRequest, _callback);
        Type localVarReturnType = new TypeToken<DlNewMirror200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlOwnedSingletons
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlOwnedSingletonsCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/dl_owned_singletons";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlOwnedSingletonsValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling dlOwnedSingletons(Async)");
        }

        return dlOwnedSingletonsCall(body, _callback);

    }

    /**
     * Get all owned singleton records.
     * Get all owned singleton records.
     * @param body Empty request body (required)
     * @return DlOwnedSingletons200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlOwnedSingletons200Response dlOwnedSingletons(Object body) throws ApiException {
        ApiResponse<DlOwnedSingletons200Response> localVarResp = dlOwnedSingletonsWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Get all owned singleton records.
     * Get all owned singleton records.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;DlOwnedSingletons200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlOwnedSingletons200Response> dlOwnedSingletonsWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = dlOwnedSingletonsValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<DlOwnedSingletons200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get all owned singleton records. (asynchronously)
     * Get all owned singleton records.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlOwnedSingletonsAsync(Object body, final ApiCallback<DlOwnedSingletons200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlOwnedSingletonsValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<DlOwnedSingletons200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlSingletonsByRoot
     * @param dlLatestSingletonRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlSingletonsByRootCall(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlLatestSingletonRequest;

        // create path and map variables
        String localVarPath = "/dl_singletons_by_root";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlSingletonsByRootValidateBeforeCall(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlLatestSingletonRequest' is set
        if (dlLatestSingletonRequest == null) {
            throw new ApiException("Missing the required parameter 'dlLatestSingletonRequest' when calling dlSingletonsByRoot(Async)");
        }

        return dlSingletonsByRootCall(dlLatestSingletonRequest, _callback);

    }

    /**
     * Get the singleton records that contain the specified root.
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @return DlSingletonsByRoot200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlSingletonsByRoot200Response dlSingletonsByRoot(DlLatestSingletonRequest dlLatestSingletonRequest) throws ApiException {
        ApiResponse<DlSingletonsByRoot200Response> localVarResp = dlSingletonsByRootWithHttpInfo(dlLatestSingletonRequest);
        return localVarResp.getData();
    }

    /**
     * Get the singleton records that contain the specified root.
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @return ApiResponse&lt;DlSingletonsByRoot200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlSingletonsByRoot200Response> dlSingletonsByRootWithHttpInfo(DlLatestSingletonRequest dlLatestSingletonRequest) throws ApiException {
        okhttp3.Call localVarCall = dlSingletonsByRootValidateBeforeCall(dlLatestSingletonRequest, null);
        Type localVarReturnType = new TypeToken<DlSingletonsByRoot200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get the singleton records that contain the specified root. (asynchronously)
     * Get the singleton records that contain the specified root.
     * @param dlLatestSingletonRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlSingletonsByRootAsync(DlLatestSingletonRequest dlLatestSingletonRequest, final ApiCallback<DlSingletonsByRoot200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlSingletonsByRootValidateBeforeCall(dlLatestSingletonRequest, _callback);
        Type localVarReturnType = new TypeToken<DlSingletonsByRoot200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlStopTracking
     * @param dlTrackNewRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlStopTrackingCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlTrackNewRequest;

        // create path and map variables
        String localVarPath = "/dl_stop_tracking";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlStopTrackingValidateBeforeCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlTrackNewRequest' is set
        if (dlTrackNewRequest == null) {
            throw new ApiException("Missing the required parameter 'dlTrackNewRequest' when calling dlStopTracking(Async)");
        }

        return dlStopTrackingCall(dlTrackNewRequest, _callback);

    }

    /**
     * Stop tracking the data layer wallets.
     * Stop tracking the data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse dlStopTracking(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = dlStopTrackingWithHttpInfo(dlTrackNewRequest);
        return localVarResp.getData();
    }

    /**
     * Stop tracking the data layer wallets.
     * Stop tracking the data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> dlStopTrackingWithHttpInfo(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        okhttp3.Call localVarCall = dlStopTrackingValidateBeforeCall(dlTrackNewRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Stop tracking the data layer wallets. (asynchronously)
     * Stop tracking the data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlStopTrackingAsync(DlTrackNewRequest dlTrackNewRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlStopTrackingValidateBeforeCall(dlTrackNewRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlTrackNew
     * @param dlTrackNewRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlTrackNewCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlTrackNewRequest;

        // create path and map variables
        String localVarPath = "/dl_track_new";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlTrackNewValidateBeforeCall(DlTrackNewRequest dlTrackNewRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlTrackNewRequest' is set
        if (dlTrackNewRequest == null) {
            throw new ApiException("Missing the required parameter 'dlTrackNewRequest' when calling dlTrackNew(Async)");
        }

        return dlTrackNewCall(dlTrackNewRequest, _callback);

    }

    /**
     * Track the new data layer wallet
     * Track the new data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse dlTrackNew(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = dlTrackNewWithHttpInfo(dlTrackNewRequest);
        return localVarResp.getData();
    }

    /**
     * Track the new data layer wallet
     * Track the new data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> dlTrackNewWithHttpInfo(DlTrackNewRequest dlTrackNewRequest) throws ApiException {
        okhttp3.Call localVarCall = dlTrackNewValidateBeforeCall(dlTrackNewRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Track the new data layer wallet (asynchronously)
     * Track the new data layer wallet.
     * @param dlTrackNewRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlTrackNewAsync(DlTrackNewRequest dlTrackNewRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlTrackNewValidateBeforeCall(dlTrackNewRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlUpdateMultiple
     * @param dlUpdateMultipleRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlUpdateMultipleCall(DlUpdateMultipleRequest dlUpdateMultipleRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlUpdateMultipleRequest;

        // create path and map variables
        String localVarPath = "/dl_update_multiple";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlUpdateMultipleValidateBeforeCall(DlUpdateMultipleRequest dlUpdateMultipleRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlUpdateMultipleRequest' is set
        if (dlUpdateMultipleRequest == null) {
            throw new ApiException("Missing the required parameter 'dlUpdateMultipleRequest' when calling dlUpdateMultiple(Async)");
        }

        return dlUpdateMultipleCall(dlUpdateMultipleRequest, _callback);

    }

    /**
     * Stop the node.
     * Stop the node.
     * @param dlUpdateMultipleRequest  (required)
     * @return DlUpdateMultiple200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlUpdateMultiple200Response dlUpdateMultiple(DlUpdateMultipleRequest dlUpdateMultipleRequest) throws ApiException {
        ApiResponse<DlUpdateMultiple200Response> localVarResp = dlUpdateMultipleWithHttpInfo(dlUpdateMultipleRequest);
        return localVarResp.getData();
    }

    /**
     * Stop the node.
     * Stop the node.
     * @param dlUpdateMultipleRequest  (required)
     * @return ApiResponse&lt;DlUpdateMultiple200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlUpdateMultiple200Response> dlUpdateMultipleWithHttpInfo(DlUpdateMultipleRequest dlUpdateMultipleRequest) throws ApiException {
        okhttp3.Call localVarCall = dlUpdateMultipleValidateBeforeCall(dlUpdateMultipleRequest, null);
        Type localVarReturnType = new TypeToken<DlUpdateMultiple200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Stop the node. (asynchronously)
     * Stop the node.
     * @param dlUpdateMultipleRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlUpdateMultipleAsync(DlUpdateMultipleRequest dlUpdateMultipleRequest, final ApiCallback<DlUpdateMultiple200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlUpdateMultipleValidateBeforeCall(dlUpdateMultipleRequest, _callback);
        Type localVarReturnType = new TypeToken<DlUpdateMultiple200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dlUpdateRoot
     * @param dlUpdateRootRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlUpdateRootCall(DlUpdateRootRequest dlUpdateRootRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = dlUpdateRootRequest;

        // create path and map variables
        String localVarPath = "/dl_update_root";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dlUpdateRootValidateBeforeCall(DlUpdateRootRequest dlUpdateRootRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dlUpdateRootRequest' is set
        if (dlUpdateRootRequest == null) {
            throw new ApiException("Missing the required parameter 'dlUpdateRootRequest' when calling dlUpdateRoot(Async)");
        }

        return dlUpdateRootCall(dlUpdateRootRequest, _callback);

    }

    /**
     * Stop the node.
     * Stop the node.
     * @param dlUpdateRootRequest  (required)
     * @return DlUpdateRoot200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DlUpdateRoot200Response dlUpdateRoot(DlUpdateRootRequest dlUpdateRootRequest) throws ApiException {
        ApiResponse<DlUpdateRoot200Response> localVarResp = dlUpdateRootWithHttpInfo(dlUpdateRootRequest);
        return localVarResp.getData();
    }

    /**
     * Stop the node.
     * Stop the node.
     * @param dlUpdateRootRequest  (required)
     * @return ApiResponse&lt;DlUpdateRoot200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DlUpdateRoot200Response> dlUpdateRootWithHttpInfo(DlUpdateRootRequest dlUpdateRootRequest) throws ApiException {
        okhttp3.Call localVarCall = dlUpdateRootValidateBeforeCall(dlUpdateRootRequest, null);
        Type localVarReturnType = new TypeToken<DlUpdateRoot200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Stop the node. (asynchronously)
     * Stop the node.
     * @param dlUpdateRootRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dlUpdateRootAsync(DlUpdateRootRequest dlUpdateRootRequest, final ApiCallback<DlUpdateRoot200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = dlUpdateRootValidateBeforeCall(dlUpdateRootRequest, _callback);
        Type localVarReturnType = new TypeToken<DlUpdateRoot200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
