/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.DidCreateAttest200Response;
import org.openapitools.client.model.DidCreateAttestRequest;
import org.openapitools.client.model.DidCreateBackupFile200Response;
import org.openapitools.client.model.DidFindLostDid200Response;
import org.openapitools.client.model.DidFindLostDidRequest;
import org.openapitools.client.model.DidGetCurrentCoinInfo200Response;
import org.openapitools.client.model.DidGetDid200Response;
import org.openapitools.client.model.DidGetInfo200Response;
import org.openapitools.client.model.DidGetInfoRequest;
import org.openapitools.client.model.DidGetInformationNeededForRecovery200Response;
import org.openapitools.client.model.DidGetMetadata200Response;
import org.openapitools.client.model.DidGetPubkey200Response;
import org.openapitools.client.model.DidGetRecoveryList200Response;
import org.openapitools.client.model.DidGetWalletName200Response;
import org.openapitools.client.model.DidMessageSpendRequest;
import org.openapitools.client.model.DidRecoverySpend200Response;
import org.openapitools.client.model.DidRecoverySpendRequest;
import org.openapitools.client.model.DidSetWalletName200Response;
import org.openapitools.client.model.DidSetWalletNameRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.DidTransferDidRequest;
import org.openapitools.client.model.DidUpdateMetadata200Response;
import org.openapitools.client.model.DidUpdateMetadataRequest;
import org.openapitools.client.model.DidUpdateRecoveryIdsRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetWalletDidRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class DidWalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public DidWalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public DidWalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for didCreateAttest
     * @param didCreateAttestRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didCreateAttestCall(DidCreateAttestRequest didCreateAttestRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didCreateAttestRequest;

        // create path and map variables
        String localVarPath = "/did_create_attest";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didCreateAttestValidateBeforeCall(DidCreateAttestRequest didCreateAttestRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didCreateAttestRequest' is set
        if (didCreateAttestRequest == null) {
            throw new ApiException("Missing the required parameter 'didCreateAttestRequest' when calling didCreateAttest(Async)");
        }

        return didCreateAttestCall(didCreateAttestRequest, _callback);

    }

    /**
     * Creates an attestment for the given DID wallet.
     * Creates an attestment for the given DID wallet.
     * @param didCreateAttestRequest  (required)
     * @return DidCreateAttest200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidCreateAttest200Response didCreateAttest(DidCreateAttestRequest didCreateAttestRequest) throws ApiException {
        ApiResponse<DidCreateAttest200Response> localVarResp = didCreateAttestWithHttpInfo(didCreateAttestRequest);
        return localVarResp.getData();
    }

    /**
     * Creates an attestment for the given DID wallet.
     * Creates an attestment for the given DID wallet.
     * @param didCreateAttestRequest  (required)
     * @return ApiResponse&lt;DidCreateAttest200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidCreateAttest200Response> didCreateAttestWithHttpInfo(DidCreateAttestRequest didCreateAttestRequest) throws ApiException {
        okhttp3.Call localVarCall = didCreateAttestValidateBeforeCall(didCreateAttestRequest, null);
        Type localVarReturnType = new TypeToken<DidCreateAttest200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Creates an attestment for the given DID wallet. (asynchronously)
     * Creates an attestment for the given DID wallet.
     * @param didCreateAttestRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didCreateAttestAsync(DidCreateAttestRequest didCreateAttestRequest, final ApiCallback<DidCreateAttest200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didCreateAttestValidateBeforeCall(didCreateAttestRequest, _callback);
        Type localVarReturnType = new TypeToken<DidCreateAttest200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didCreateBackupFile
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didCreateBackupFileCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_create_backup_file";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didCreateBackupFileValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didCreateBackupFile(Async)");
        }

        return didCreateBackupFileCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Creates a backup file for the given DID wallet.
     * Creates a backup file for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidCreateBackupFile200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidCreateBackupFile200Response didCreateBackupFile(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidCreateBackupFile200Response> localVarResp = didCreateBackupFileWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Creates a backup file for the given DID wallet.
     * Creates a backup file for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidCreateBackupFile200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidCreateBackupFile200Response> didCreateBackupFileWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didCreateBackupFileValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidCreateBackupFile200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Creates a backup file for the given DID wallet. (asynchronously)
     * Creates a backup file for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didCreateBackupFileAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidCreateBackupFile200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didCreateBackupFileValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidCreateBackupFile200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didFindLostDid
     * @param didFindLostDidRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didFindLostDidCall(DidFindLostDidRequest didFindLostDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didFindLostDidRequest;

        // create path and map variables
        String localVarPath = "/did_find_lost_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didFindLostDidValidateBeforeCall(DidFindLostDidRequest didFindLostDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didFindLostDidRequest' is set
        if (didFindLostDidRequest == null) {
            throw new ApiException("Missing the required parameter 'didFindLostDidRequest' when calling didFindLostDid(Async)");
        }

        return didFindLostDidCall(didFindLostDidRequest, _callback);

    }

    /**
     * Recover a missing or unspendable DID wallet by a coin id of the DID.
     * Recover a missing or unspendable DID wallet by a coin id of the DID
     * @param didFindLostDidRequest  (required)
     * @return DidFindLostDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidFindLostDid200Response didFindLostDid(DidFindLostDidRequest didFindLostDidRequest) throws ApiException {
        ApiResponse<DidFindLostDid200Response> localVarResp = didFindLostDidWithHttpInfo(didFindLostDidRequest);
        return localVarResp.getData();
    }

    /**
     * Recover a missing or unspendable DID wallet by a coin id of the DID.
     * Recover a missing or unspendable DID wallet by a coin id of the DID
     * @param didFindLostDidRequest  (required)
     * @return ApiResponse&lt;DidFindLostDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidFindLostDid200Response> didFindLostDidWithHttpInfo(DidFindLostDidRequest didFindLostDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didFindLostDidValidateBeforeCall(didFindLostDidRequest, null);
        Type localVarReturnType = new TypeToken<DidFindLostDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Recover a missing or unspendable DID wallet by a coin id of the DID. (asynchronously)
     * Recover a missing or unspendable DID wallet by a coin id of the DID
     * @param didFindLostDidRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didFindLostDidAsync(DidFindLostDidRequest didFindLostDidRequest, final ApiCallback<DidFindLostDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didFindLostDidValidateBeforeCall(didFindLostDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidFindLostDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetCurrentCoinInfo
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetCurrentCoinInfoCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_current_coin_info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetCurrentCoinInfoValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetCurrentCoinInfo(Async)");
        }

        return didGetCurrentCoinInfoCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets information about the DID wallets current coin.
     * Gets information about the DID wallets current coin.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetCurrentCoinInfo200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetCurrentCoinInfo200Response didGetCurrentCoinInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetCurrentCoinInfo200Response> localVarResp = didGetCurrentCoinInfoWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets information about the DID wallets current coin.
     * Gets information about the DID wallets current coin.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetCurrentCoinInfo200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetCurrentCoinInfo200Response> didGetCurrentCoinInfoWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetCurrentCoinInfoValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetCurrentCoinInfo200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets information about the DID wallets current coin. (asynchronously)
     * Gets information about the DID wallets current coin.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetCurrentCoinInfoAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetCurrentCoinInfo200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetCurrentCoinInfoValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetCurrentCoinInfo200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetDid
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetDidCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetDidValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetDid(Async)");
        }

        return didGetDidCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the distributed identity for a given wallet.
     * Retrieves the distributed identity for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetDid200Response didGetDid(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetDid200Response> localVarResp = didGetDidWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the distributed identity for a given wallet.
     * Retrieves the distributed identity for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetDid200Response> didGetDidWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetDidValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the distributed identity for a given wallet. (asynchronously)
     * Retrieves the distributed identity for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetDidAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetDidValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetInfo
     * @param didGetInfoRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetInfoCall(DidGetInfoRequest didGetInfoRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didGetInfoRequest;

        // create path and map variables
        String localVarPath = "/did_get_info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetInfoValidateBeforeCall(DidGetInfoRequest didGetInfoRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didGetInfoRequest' is set
        if (didGetInfoRequest == null) {
            throw new ApiException("Missing the required parameter 'didGetInfoRequest' when calling didGetInfo(Async)");
        }

        return didGetInfoCall(didGetInfoRequest, _callback);

    }

    /**
     * Retreives information about a DID.
     * Retreives information about a DID
     * @param didGetInfoRequest  (required)
     * @return DidGetInfo200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetInfo200Response didGetInfo(DidGetInfoRequest didGetInfoRequest) throws ApiException {
        ApiResponse<DidGetInfo200Response> localVarResp = didGetInfoWithHttpInfo(didGetInfoRequest);
        return localVarResp.getData();
    }

    /**
     * Retreives information about a DID.
     * Retreives information about a DID
     * @param didGetInfoRequest  (required)
     * @return ApiResponse&lt;DidGetInfo200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetInfo200Response> didGetInfoWithHttpInfo(DidGetInfoRequest didGetInfoRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetInfoValidateBeforeCall(didGetInfoRequest, null);
        Type localVarReturnType = new TypeToken<DidGetInfo200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retreives information about a DID. (asynchronously)
     * Retreives information about a DID
     * @param didGetInfoRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetInfoAsync(DidGetInfoRequest didGetInfoRequest, final ApiCallback<DidGetInfo200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetInfoValidateBeforeCall(didGetInfoRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetInfo200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetInformationNeededForRecovery
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetInformationNeededForRecoveryCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_information_needed_for_recovery";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetInformationNeededForRecoveryValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetInformationNeededForRecovery(Async)");
        }

        return didGetInformationNeededForRecoveryCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the recovery information needed for the given DID wallet.
     * Retrieves the recovery information needed for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetInformationNeededForRecovery200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetInformationNeededForRecovery200Response didGetInformationNeededForRecovery(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetInformationNeededForRecovery200Response> localVarResp = didGetInformationNeededForRecoveryWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the recovery information needed for the given DID wallet.
     * Retrieves the recovery information needed for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetInformationNeededForRecovery200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetInformationNeededForRecovery200Response> didGetInformationNeededForRecoveryWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetInformationNeededForRecoveryValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetInformationNeededForRecovery200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the recovery information needed for the given DID wallet. (asynchronously)
     * Retrieves the recovery information needed for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetInformationNeededForRecoveryAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetInformationNeededForRecovery200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetInformationNeededForRecoveryValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetInformationNeededForRecovery200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetMetadata
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetMetadataCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_metadata";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetMetadataValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetMetadata(Async)");
        }

        return didGetMetadataCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets the metadata of a DID wallet.
     * Gets the metadata of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetMetadata200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetMetadata200Response didGetMetadata(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetMetadata200Response> localVarResp = didGetMetadataWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the metadata of a DID wallet.
     * Gets the metadata of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetMetadata200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetMetadata200Response> didGetMetadataWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetMetadataValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetMetadata200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the metadata of a DID wallet. (asynchronously)
     * Gets the metadata of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetMetadataAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetMetadata200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetMetadataValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetMetadata200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetPubkey
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetPubkeyCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_pubkey";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetPubkeyValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetPubkey(Async)");
        }

        return didGetPubkeyCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the public key for the given DID wallet.
     * Retrieves the public key for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetPubkey200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetPubkey200Response didGetPubkey(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetPubkey200Response> localVarResp = didGetPubkeyWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the public key for the given DID wallet.
     * Retrieves the public key for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetPubkey200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetPubkey200Response> didGetPubkeyWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetPubkeyValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetPubkey200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the public key for the given DID wallet. (asynchronously)
     * Retrieves the public key for the given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetPubkeyAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetPubkey200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetPubkeyValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetPubkey200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetRecoveryList
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetRecoveryListCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_recovery_list";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetRecoveryListValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetRecoveryList(Async)");
        }

        return didGetRecoveryListCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the recovery list for a given DID wallet.
     * Retrieves the recovery list for a given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetRecoveryList200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetRecoveryList200Response didGetRecoveryList(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetRecoveryList200Response> localVarResp = didGetRecoveryListWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the recovery list for a given DID wallet.
     * Retrieves the recovery list for a given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetRecoveryList200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetRecoveryList200Response> didGetRecoveryListWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetRecoveryListValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetRecoveryList200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the recovery list for a given DID wallet. (asynchronously)
     * Retrieves the recovery list for a given DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetRecoveryListAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetRecoveryList200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetRecoveryListValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetRecoveryList200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didGetWalletName
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetWalletNameCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/did_get_wallet_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didGetWalletNameValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling didGetWalletName(Async)");
        }

        return didGetWalletNameCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets the name of a DID wallet.
     * Gets the name of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return DidGetWalletName200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidGetWalletName200Response didGetWalletName(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<DidGetWalletName200Response> localVarResp = didGetWalletNameWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the name of a DID wallet.
     * Gets the name of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;DidGetWalletName200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidGetWalletName200Response> didGetWalletNameWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didGetWalletNameValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<DidGetWalletName200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the name of a DID wallet. (asynchronously)
     * Gets the name of a DID wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didGetWalletNameAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<DidGetWalletName200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didGetWalletNameValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidGetWalletName200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didMessageSpend
     * @param didMessageSpendRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didMessageSpendCall(DidMessageSpendRequest didMessageSpendRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didMessageSpendRequest;

        // create path and map variables
        String localVarPath = "/did_message_spend";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didMessageSpendValidateBeforeCall(DidMessageSpendRequest didMessageSpendRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didMessageSpendRequest' is set
        if (didMessageSpendRequest == null) {
            throw new ApiException("Missing the required parameter 'didMessageSpendRequest' when calling didMessageSpend(Async)");
        }

        return didMessageSpendCall(didMessageSpendRequest, _callback);

    }

    /**
     * Spends a DID message.
     * Spends a DID message
     * @param didMessageSpendRequest  (required)
     * @return DidRecoverySpend200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidRecoverySpend200Response didMessageSpend(DidMessageSpendRequest didMessageSpendRequest) throws ApiException {
        ApiResponse<DidRecoverySpend200Response> localVarResp = didMessageSpendWithHttpInfo(didMessageSpendRequest);
        return localVarResp.getData();
    }

    /**
     * Spends a DID message.
     * Spends a DID message
     * @param didMessageSpendRequest  (required)
     * @return ApiResponse&lt;DidRecoverySpend200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidRecoverySpend200Response> didMessageSpendWithHttpInfo(DidMessageSpendRequest didMessageSpendRequest) throws ApiException {
        okhttp3.Call localVarCall = didMessageSpendValidateBeforeCall(didMessageSpendRequest, null);
        Type localVarReturnType = new TypeToken<DidRecoverySpend200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Spends a DID message. (asynchronously)
     * Spends a DID message
     * @param didMessageSpendRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didMessageSpendAsync(DidMessageSpendRequest didMessageSpendRequest, final ApiCallback<DidRecoverySpend200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didMessageSpendValidateBeforeCall(didMessageSpendRequest, _callback);
        Type localVarReturnType = new TypeToken<DidRecoverySpend200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didRecoverySpend
     * @param didRecoverySpendRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didRecoverySpendCall(DidRecoverySpendRequest didRecoverySpendRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didRecoverySpendRequest;

        // create path and map variables
        String localVarPath = "/did_recovery_spend";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didRecoverySpendValidateBeforeCall(DidRecoverySpendRequest didRecoverySpendRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didRecoverySpendRequest' is set
        if (didRecoverySpendRequest == null) {
            throw new ApiException("Missing the required parameter 'didRecoverySpendRequest' when calling didRecoverySpend(Async)");
        }

        return didRecoverySpendCall(didRecoverySpendRequest, _callback);

    }

    /**
     * Spend from the given DID wallet.
     * Spend from the given DID wallet.
     * @param didRecoverySpendRequest  (required)
     * @return DidRecoverySpend200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidRecoverySpend200Response didRecoverySpend(DidRecoverySpendRequest didRecoverySpendRequest) throws ApiException {
        ApiResponse<DidRecoverySpend200Response> localVarResp = didRecoverySpendWithHttpInfo(didRecoverySpendRequest);
        return localVarResp.getData();
    }

    /**
     * Spend from the given DID wallet.
     * Spend from the given DID wallet.
     * @param didRecoverySpendRequest  (required)
     * @return ApiResponse&lt;DidRecoverySpend200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidRecoverySpend200Response> didRecoverySpendWithHttpInfo(DidRecoverySpendRequest didRecoverySpendRequest) throws ApiException {
        okhttp3.Call localVarCall = didRecoverySpendValidateBeforeCall(didRecoverySpendRequest, null);
        Type localVarReturnType = new TypeToken<DidRecoverySpend200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Spend from the given DID wallet. (asynchronously)
     * Spend from the given DID wallet.
     * @param didRecoverySpendRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didRecoverySpendAsync(DidRecoverySpendRequest didRecoverySpendRequest, final ApiCallback<DidRecoverySpend200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didRecoverySpendValidateBeforeCall(didRecoverySpendRequest, _callback);
        Type localVarReturnType = new TypeToken<DidRecoverySpend200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didSetWalletName
     * @param didSetWalletNameRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didSetWalletNameCall(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didSetWalletNameRequest;

        // create path and map variables
        String localVarPath = "/did_set_wallet_name";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didSetWalletNameValidateBeforeCall(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didSetWalletNameRequest' is set
        if (didSetWalletNameRequest == null) {
            throw new ApiException("Missing the required parameter 'didSetWalletNameRequest' when calling didSetWalletName(Async)");
        }

        return didSetWalletNameCall(didSetWalletNameRequest, _callback);

    }

    /**
     * Sets the name of a DID wallet.
     * Sets the name of a DID wallet.
     * @param didSetWalletNameRequest  (required)
     * @return DidSetWalletName200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidSetWalletName200Response didSetWalletName(DidSetWalletNameRequest didSetWalletNameRequest) throws ApiException {
        ApiResponse<DidSetWalletName200Response> localVarResp = didSetWalletNameWithHttpInfo(didSetWalletNameRequest);
        return localVarResp.getData();
    }

    /**
     * Sets the name of a DID wallet.
     * Sets the name of a DID wallet.
     * @param didSetWalletNameRequest  (required)
     * @return ApiResponse&lt;DidSetWalletName200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidSetWalletName200Response> didSetWalletNameWithHttpInfo(DidSetWalletNameRequest didSetWalletNameRequest) throws ApiException {
        okhttp3.Call localVarCall = didSetWalletNameValidateBeforeCall(didSetWalletNameRequest, null);
        Type localVarReturnType = new TypeToken<DidSetWalletName200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sets the name of a DID wallet. (asynchronously)
     * Sets the name of a DID wallet.
     * @param didSetWalletNameRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didSetWalletNameAsync(DidSetWalletNameRequest didSetWalletNameRequest, final ApiCallback<DidSetWalletName200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didSetWalletNameValidateBeforeCall(didSetWalletNameRequest, _callback);
        Type localVarReturnType = new TypeToken<DidSetWalletName200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didTransferDid
     * @param didTransferDidRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didTransferDidCall(DidTransferDidRequest didTransferDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didTransferDidRequest;

        // create path and map variables
        String localVarPath = "/did_transfer_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didTransferDidValidateBeforeCall(DidTransferDidRequest didTransferDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didTransferDidRequest' is set
        if (didTransferDidRequest == null) {
            throw new ApiException("Missing the required parameter 'didTransferDidRequest' when calling didTransferDid(Async)");
        }

        return didTransferDidCall(didTransferDidRequest, _callback);

    }

    /**
     * Transfer a DID to another owner.
     * Transfer the given DID wallet to another owner.
     * @param didTransferDidRequest  (required)
     * @return DidTransferDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidTransferDid200Response didTransferDid(DidTransferDidRequest didTransferDidRequest) throws ApiException {
        ApiResponse<DidTransferDid200Response> localVarResp = didTransferDidWithHttpInfo(didTransferDidRequest);
        return localVarResp.getData();
    }

    /**
     * Transfer a DID to another owner.
     * Transfer the given DID wallet to another owner.
     * @param didTransferDidRequest  (required)
     * @return ApiResponse&lt;DidTransferDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidTransferDid200Response> didTransferDidWithHttpInfo(DidTransferDidRequest didTransferDidRequest) throws ApiException {
        okhttp3.Call localVarCall = didTransferDidValidateBeforeCall(didTransferDidRequest, null);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transfer a DID to another owner. (asynchronously)
     * Transfer the given DID wallet to another owner.
     * @param didTransferDidRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didTransferDidAsync(DidTransferDidRequest didTransferDidRequest, final ApiCallback<DidTransferDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didTransferDidValidateBeforeCall(didTransferDidRequest, _callback);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didUpdateMetadata
     * @param didUpdateMetadataRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didUpdateMetadataCall(DidUpdateMetadataRequest didUpdateMetadataRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didUpdateMetadataRequest;

        // create path and map variables
        String localVarPath = "/did_update_metadata";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didUpdateMetadataValidateBeforeCall(DidUpdateMetadataRequest didUpdateMetadataRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didUpdateMetadataRequest' is set
        if (didUpdateMetadataRequest == null) {
            throw new ApiException("Missing the required parameter 'didUpdateMetadataRequest' when calling didUpdateMetadata(Async)");
        }

        return didUpdateMetadataCall(didUpdateMetadataRequest, _callback);

    }

    /**
     * Updates the metadata for a DID wallet.
     * Updates the metadata for a DID wallet.
     * @param didUpdateMetadataRequest  (required)
     * @return DidUpdateMetadata200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public DidUpdateMetadata200Response didUpdateMetadata(DidUpdateMetadataRequest didUpdateMetadataRequest) throws ApiException {
        ApiResponse<DidUpdateMetadata200Response> localVarResp = didUpdateMetadataWithHttpInfo(didUpdateMetadataRequest);
        return localVarResp.getData();
    }

    /**
     * Updates the metadata for a DID wallet.
     * Updates the metadata for a DID wallet.
     * @param didUpdateMetadataRequest  (required)
     * @return ApiResponse&lt;DidUpdateMetadata200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidUpdateMetadata200Response> didUpdateMetadataWithHttpInfo(DidUpdateMetadataRequest didUpdateMetadataRequest) throws ApiException {
        okhttp3.Call localVarCall = didUpdateMetadataValidateBeforeCall(didUpdateMetadataRequest, null);
        Type localVarReturnType = new TypeToken<DidUpdateMetadata200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Updates the metadata for a DID wallet. (asynchronously)
     * Updates the metadata for a DID wallet.
     * @param didUpdateMetadataRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didUpdateMetadataAsync(DidUpdateMetadataRequest didUpdateMetadataRequest, final ApiCallback<DidUpdateMetadata200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = didUpdateMetadataValidateBeforeCall(didUpdateMetadataRequest, _callback);
        Type localVarReturnType = new TypeToken<DidUpdateMetadata200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for didUpdateRecoveryIds
     * @param didUpdateRecoveryIdsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didUpdateRecoveryIdsCall(DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = didUpdateRecoveryIdsRequest;

        // create path and map variables
        String localVarPath = "/did_update_recovery_ids";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call didUpdateRecoveryIdsValidateBeforeCall(DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'didUpdateRecoveryIdsRequest' is set
        if (didUpdateRecoveryIdsRequest == null) {
            throw new ApiException("Missing the required parameter 'didUpdateRecoveryIdsRequest' when calling didUpdateRecoveryIds(Async)");
        }

        return didUpdateRecoveryIdsCall(didUpdateRecoveryIdsRequest, _callback);

    }

    /**
     * Updates the recovery ids for a DID wallet.
     * Updates the recovery ids for a DID wallet.
     * @param didUpdateRecoveryIdsRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse didUpdateRecoveryIds(DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = didUpdateRecoveryIdsWithHttpInfo(didUpdateRecoveryIdsRequest);
        return localVarResp.getData();
    }

    /**
     * Updates the recovery ids for a DID wallet.
     * Updates the recovery ids for a DID wallet.
     * @param didUpdateRecoveryIdsRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> didUpdateRecoveryIdsWithHttpInfo(DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest) throws ApiException {
        okhttp3.Call localVarCall = didUpdateRecoveryIdsValidateBeforeCall(didUpdateRecoveryIdsRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Updates the recovery ids for a DID wallet. (asynchronously)
     * Updates the recovery ids for a DID wallet.
     * @param didUpdateRecoveryIdsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call didUpdateRecoveryIdsAsync(DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = didUpdateRecoveryIdsValidateBeforeCall(didUpdateRecoveryIdsRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
