/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftAddUriRequest;
import org.openapitools.client.model.NftCalculateRoyalties200Response;
import org.openapitools.client.model.NftCalculateRoyaltiesRequest;
import org.openapitools.client.model.NftCountNfts200Response;
import org.openapitools.client.model.NftGetByDid200Response;
import org.openapitools.client.model.NftGetByDidRequest;
import org.openapitools.client.model.NftGetInfo200Response;
import org.openapitools.client.model.NftGetInfoRequest;
import org.openapitools.client.model.NftGetNfts200Response;
import org.openapitools.client.model.NftGetNftsRequest;
import org.openapitools.client.model.NftGetWalletDid200Response;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.NftGetWalletsWithDids200Response;
import org.openapitools.client.model.NftMintBulk200Response;
import org.openapitools.client.model.NftMintBulkRequest;
import org.openapitools.client.model.NftMintNft200Response;
import org.openapitools.client.model.NftMintNftRequest;
import org.openapitools.client.model.NftSetDidBulk200Response;
import org.openapitools.client.model.NftSetDidBulkRequest;
import org.openapitools.client.model.NftSetNftDid200Response;
import org.openapitools.client.model.NftSetNftDidRequest;
import org.openapitools.client.model.NftSetNftStatusRequest;
import org.openapitools.client.model.NftTransferBulkRequest;
import org.openapitools.client.model.NftTransferNftRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class NftWalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public NftWalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public NftWalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for nftAddUri
     * @param nftAddUriRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftAddUriCall(NftAddUriRequest nftAddUriRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftAddUriRequest;

        // create path and map variables
        String localVarPath = "/nft_add_uri";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftAddUriValidateBeforeCall(NftAddUriRequest nftAddUriRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftAddUriRequest' is set
        if (nftAddUriRequest == null) {
            throw new ApiException("Missing the required parameter 'nftAddUriRequest' when calling nftAddUri(Async)");
        }

        return nftAddUriCall(nftAddUriRequest, _callback);

    }

    /**
     * Adds an Uri to an NFT.
     * Adds a Uri to an NFT.
     * @param nftAddUriRequest  (required)
     * @return NftSetNftDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftSetNftDid200Response nftAddUri(NftAddUriRequest nftAddUriRequest) throws ApiException {
        ApiResponse<NftSetNftDid200Response> localVarResp = nftAddUriWithHttpInfo(nftAddUriRequest);
        return localVarResp.getData();
    }

    /**
     * Adds an Uri to an NFT.
     * Adds a Uri to an NFT.
     * @param nftAddUriRequest  (required)
     * @return ApiResponse&lt;NftSetNftDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftSetNftDid200Response> nftAddUriWithHttpInfo(NftAddUriRequest nftAddUriRequest) throws ApiException {
        okhttp3.Call localVarCall = nftAddUriValidateBeforeCall(nftAddUriRequest, null);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Adds an Uri to an NFT. (asynchronously)
     * Adds a Uri to an NFT.
     * @param nftAddUriRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftAddUriAsync(NftAddUriRequest nftAddUriRequest, final ApiCallback<NftSetNftDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftAddUriValidateBeforeCall(nftAddUriRequest, _callback);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftCalculateRoyalties
     * @param nftCalculateRoyaltiesRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftCalculateRoyaltiesCall(NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftCalculateRoyaltiesRequest;

        // create path and map variables
        String localVarPath = "/nft_calculate_royalties";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftCalculateRoyaltiesValidateBeforeCall(NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftCalculateRoyaltiesRequest' is set
        if (nftCalculateRoyaltiesRequest == null) {
            throw new ApiException("Missing the required parameter 'nftCalculateRoyaltiesRequest' when calling nftCalculateRoyalties(Async)");
        }

        return nftCalculateRoyaltiesCall(nftCalculateRoyaltiesRequest, _callback);

    }

    /**
     * Transfers an NFT to another address.
     * Transfers an NFT to another address.
     * @param nftCalculateRoyaltiesRequest  (required)
     * @return NftCalculateRoyalties200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftCalculateRoyalties200Response nftCalculateRoyalties(NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest) throws ApiException {
        ApiResponse<NftCalculateRoyalties200Response> localVarResp = nftCalculateRoyaltiesWithHttpInfo(nftCalculateRoyaltiesRequest);
        return localVarResp.getData();
    }

    /**
     * Transfers an NFT to another address.
     * Transfers an NFT to another address.
     * @param nftCalculateRoyaltiesRequest  (required)
     * @return ApiResponse&lt;NftCalculateRoyalties200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftCalculateRoyalties200Response> nftCalculateRoyaltiesWithHttpInfo(NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest) throws ApiException {
        okhttp3.Call localVarCall = nftCalculateRoyaltiesValidateBeforeCall(nftCalculateRoyaltiesRequest, null);
        Type localVarReturnType = new TypeToken<NftCalculateRoyalties200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transfers an NFT to another address. (asynchronously)
     * Transfers an NFT to another address.
     * @param nftCalculateRoyaltiesRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftCalculateRoyaltiesAsync(NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest, final ApiCallback<NftCalculateRoyalties200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftCalculateRoyaltiesValidateBeforeCall(nftCalculateRoyaltiesRequest, _callback);
        Type localVarReturnType = new TypeToken<NftCalculateRoyalties200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftCountNfts
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftCountNftsCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/nft_count_nfts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftCountNftsValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling nftCountNfts(Async)");
        }

        return nftCountNftsCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retreives the number of NFTs in a wallet.
     * Retreives the number of NFTs in a wallet
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return NftCountNfts200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftCountNfts200Response nftCountNfts(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<NftCountNfts200Response> localVarResp = nftCountNftsWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retreives the number of NFTs in a wallet.
     * Retreives the number of NFTs in a wallet
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;NftCountNfts200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftCountNfts200Response> nftCountNftsWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = nftCountNftsValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<NftCountNfts200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retreives the number of NFTs in a wallet. (asynchronously)
     * Retreives the number of NFTs in a wallet
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftCountNftsAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<NftCountNfts200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftCountNftsValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<NftCountNfts200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftGetByDid
     * @param nftGetByDidRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetByDidCall(NftGetByDidRequest nftGetByDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetByDidRequest;

        // create path and map variables
        String localVarPath = "/nft_get_by_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftGetByDidValidateBeforeCall(NftGetByDidRequest nftGetByDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetByDidRequest' is set
        if (nftGetByDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetByDidRequest' when calling nftGetByDid(Async)");
        }

        return nftGetByDidCall(nftGetByDidRequest, _callback);

    }

    /**
     * Gets an NFT wallet by its DID.
     * Gets an NFT wallet by its DID.
     * @param nftGetByDidRequest  (required)
     * @return NftGetByDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetByDid200Response nftGetByDid(NftGetByDidRequest nftGetByDidRequest) throws ApiException {
        ApiResponse<NftGetByDid200Response> localVarResp = nftGetByDidWithHttpInfo(nftGetByDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets an NFT wallet by its DID.
     * Gets an NFT wallet by its DID.
     * @param nftGetByDidRequest  (required)
     * @return ApiResponse&lt;NftGetByDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetByDid200Response> nftGetByDidWithHttpInfo(NftGetByDidRequest nftGetByDidRequest) throws ApiException {
        okhttp3.Call localVarCall = nftGetByDidValidateBeforeCall(nftGetByDidRequest, null);
        Type localVarReturnType = new TypeToken<NftGetByDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets an NFT wallet by its DID. (asynchronously)
     * Gets an NFT wallet by its DID.
     * @param nftGetByDidRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetByDidAsync(NftGetByDidRequest nftGetByDidRequest, final ApiCallback<NftGetByDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftGetByDidValidateBeforeCall(nftGetByDidRequest, _callback);
        Type localVarReturnType = new TypeToken<NftGetByDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftGetInfo
     * @param nftGetInfoRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetInfoCall(NftGetInfoRequest nftGetInfoRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetInfoRequest;

        // create path and map variables
        String localVarPath = "/nft_get_info";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftGetInfoValidateBeforeCall(NftGetInfoRequest nftGetInfoRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetInfoRequest' is set
        if (nftGetInfoRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetInfoRequest' when calling nftGetInfo(Async)");
        }

        return nftGetInfoCall(nftGetInfoRequest, _callback);

    }

    /**
     * Gets info about an NFT.
     * Gets info about an NFT.
     * @param nftGetInfoRequest  (required)
     * @return NftGetInfo200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetInfo200Response nftGetInfo(NftGetInfoRequest nftGetInfoRequest) throws ApiException {
        ApiResponse<NftGetInfo200Response> localVarResp = nftGetInfoWithHttpInfo(nftGetInfoRequest);
        return localVarResp.getData();
    }

    /**
     * Gets info about an NFT.
     * Gets info about an NFT.
     * @param nftGetInfoRequest  (required)
     * @return ApiResponse&lt;NftGetInfo200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetInfo200Response> nftGetInfoWithHttpInfo(NftGetInfoRequest nftGetInfoRequest) throws ApiException {
        okhttp3.Call localVarCall = nftGetInfoValidateBeforeCall(nftGetInfoRequest, null);
        Type localVarReturnType = new TypeToken<NftGetInfo200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets info about an NFT. (asynchronously)
     * Gets info about an NFT.
     * @param nftGetInfoRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetInfoAsync(NftGetInfoRequest nftGetInfoRequest, final ApiCallback<NftGetInfo200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftGetInfoValidateBeforeCall(nftGetInfoRequest, _callback);
        Type localVarReturnType = new TypeToken<NftGetInfo200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftGetNfts
     * @param nftGetNftsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetNftsCall(NftGetNftsRequest nftGetNftsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetNftsRequest;

        // create path and map variables
        String localVarPath = "/nft_get_nfts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftGetNftsValidateBeforeCall(NftGetNftsRequest nftGetNftsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetNftsRequest' is set
        if (nftGetNftsRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetNftsRequest' when calling nftGetNfts(Async)");
        }

        return nftGetNftsCall(nftGetNftsRequest, _callback);

    }

    /**
     * Gets NFTs from a wallet.
     * Gets NFTs from a wallet.
     * @param nftGetNftsRequest  (required)
     * @return NftGetNfts200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetNfts200Response nftGetNfts(NftGetNftsRequest nftGetNftsRequest) throws ApiException {
        ApiResponse<NftGetNfts200Response> localVarResp = nftGetNftsWithHttpInfo(nftGetNftsRequest);
        return localVarResp.getData();
    }

    /**
     * Gets NFTs from a wallet.
     * Gets NFTs from a wallet.
     * @param nftGetNftsRequest  (required)
     * @return ApiResponse&lt;NftGetNfts200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetNfts200Response> nftGetNftsWithHttpInfo(NftGetNftsRequest nftGetNftsRequest) throws ApiException {
        okhttp3.Call localVarCall = nftGetNftsValidateBeforeCall(nftGetNftsRequest, null);
        Type localVarReturnType = new TypeToken<NftGetNfts200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets NFTs from a wallet. (asynchronously)
     * Gets NFTs from a wallet.
     * @param nftGetNftsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetNftsAsync(NftGetNftsRequest nftGetNftsRequest, final ApiCallback<NftGetNfts200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftGetNftsValidateBeforeCall(nftGetNftsRequest, _callback);
        Type localVarReturnType = new TypeToken<NftGetNfts200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftGetWalletDid
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetWalletDidCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/nft_get_wallet_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftGetWalletDidValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling nftGetWalletDid(Async)");
        }

        return nftGetWalletDidCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Gets the DID for an NFT wallet.
     * Gets the DID for an NFT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return NftGetWalletDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetWalletDid200Response nftGetWalletDid(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<NftGetWalletDid200Response> localVarResp = nftGetWalletDidWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Gets the DID for an NFT wallet.
     * Gets the DID for an NFT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;NftGetWalletDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetWalletDid200Response> nftGetWalletDidWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = nftGetWalletDidValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<NftGetWalletDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the DID for an NFT wallet. (asynchronously)
     * Gets the DID for an NFT wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetWalletDidAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<NftGetWalletDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftGetWalletDidValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<NftGetWalletDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftGetWalletsWithDids
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetWalletsWithDidsCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/nft_get_wallets_with_dids";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftGetWalletsWithDidsValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling nftGetWalletsWithDids(Async)");
        }

        return nftGetWalletsWithDidsCall(body, _callback);

    }

    /**
     * Gets all the wallets with a DID.
     * Gets all the wallets with a DID.
     * @param body Empty request body (required)
     * @return NftGetWalletsWithDids200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftGetWalletsWithDids200Response nftGetWalletsWithDids(Object body) throws ApiException {
        ApiResponse<NftGetWalletsWithDids200Response> localVarResp = nftGetWalletsWithDidsWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Gets all the wallets with a DID.
     * Gets all the wallets with a DID.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;NftGetWalletsWithDids200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftGetWalletsWithDids200Response> nftGetWalletsWithDidsWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = nftGetWalletsWithDidsValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<NftGetWalletsWithDids200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets all the wallets with a DID. (asynchronously)
     * Gets all the wallets with a DID.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftGetWalletsWithDidsAsync(Object body, final ApiCallback<NftGetWalletsWithDids200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftGetWalletsWithDidsValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<NftGetWalletsWithDids200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftMintBulk
     * @param nftMintBulkRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftMintBulkCall(NftMintBulkRequest nftMintBulkRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftMintBulkRequest;

        // create path and map variables
        String localVarPath = "/nft_mint_bulk";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftMintBulkValidateBeforeCall(NftMintBulkRequest nftMintBulkRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftMintBulkRequest' is set
        if (nftMintBulkRequest == null) {
            throw new ApiException("Missing the required parameter 'nftMintBulkRequest' when calling nftMintBulk(Async)");
        }

        return nftMintBulkCall(nftMintBulkRequest, _callback);

    }

    /**
     * Mints NFTs in bulk.
     * Mints NFTs in bulk.
     * @param nftMintBulkRequest  (required)
     * @return NftMintBulk200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftMintBulk200Response nftMintBulk(NftMintBulkRequest nftMintBulkRequest) throws ApiException {
        ApiResponse<NftMintBulk200Response> localVarResp = nftMintBulkWithHttpInfo(nftMintBulkRequest);
        return localVarResp.getData();
    }

    /**
     * Mints NFTs in bulk.
     * Mints NFTs in bulk.
     * @param nftMintBulkRequest  (required)
     * @return ApiResponse&lt;NftMintBulk200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftMintBulk200Response> nftMintBulkWithHttpInfo(NftMintBulkRequest nftMintBulkRequest) throws ApiException {
        okhttp3.Call localVarCall = nftMintBulkValidateBeforeCall(nftMintBulkRequest, null);
        Type localVarReturnType = new TypeToken<NftMintBulk200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Mints NFTs in bulk. (asynchronously)
     * Mints NFTs in bulk.
     * @param nftMintBulkRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftMintBulkAsync(NftMintBulkRequest nftMintBulkRequest, final ApiCallback<NftMintBulk200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftMintBulkValidateBeforeCall(nftMintBulkRequest, _callback);
        Type localVarReturnType = new TypeToken<NftMintBulk200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftMintNft
     * @param nftMintNftRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftMintNftCall(NftMintNftRequest nftMintNftRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftMintNftRequest;

        // create path and map variables
        String localVarPath = "/nft_mint_nft";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftMintNftValidateBeforeCall(NftMintNftRequest nftMintNftRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftMintNftRequest' is set
        if (nftMintNftRequest == null) {
            throw new ApiException("Missing the required parameter 'nftMintNftRequest' when calling nftMintNft(Async)");
        }

        return nftMintNftCall(nftMintNftRequest, _callback);

    }

    /**
     * Mints an NFT.
     * Mints an NFT.
     * @param nftMintNftRequest  (required)
     * @return NftMintNft200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftMintNft200Response nftMintNft(NftMintNftRequest nftMintNftRequest) throws ApiException {
        ApiResponse<NftMintNft200Response> localVarResp = nftMintNftWithHttpInfo(nftMintNftRequest);
        return localVarResp.getData();
    }

    /**
     * Mints an NFT.
     * Mints an NFT.
     * @param nftMintNftRequest  (required)
     * @return ApiResponse&lt;NftMintNft200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftMintNft200Response> nftMintNftWithHttpInfo(NftMintNftRequest nftMintNftRequest) throws ApiException {
        okhttp3.Call localVarCall = nftMintNftValidateBeforeCall(nftMintNftRequest, null);
        Type localVarReturnType = new TypeToken<NftMintNft200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Mints an NFT. (asynchronously)
     * Mints an NFT.
     * @param nftMintNftRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftMintNftAsync(NftMintNftRequest nftMintNftRequest, final ApiCallback<NftMintNft200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftMintNftValidateBeforeCall(nftMintNftRequest, _callback);
        Type localVarReturnType = new TypeToken<NftMintNft200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftSetDidBulk
     * @param nftSetDidBulkRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetDidBulkCall(NftSetDidBulkRequest nftSetDidBulkRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftSetDidBulkRequest;

        // create path and map variables
        String localVarPath = "/nft_set_did_bulk";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftSetDidBulkValidateBeforeCall(NftSetDidBulkRequest nftSetDidBulkRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftSetDidBulkRequest' is set
        if (nftSetDidBulkRequest == null) {
            throw new ApiException("Missing the required parameter 'nftSetDidBulkRequest' when calling nftSetDidBulk(Async)");
        }

        return nftSetDidBulkCall(nftSetDidBulkRequest, _callback);

    }

    /**
     * Bulk set DID for NFTs across different wallets.
     * Bulk set DID for NFTs across different wallets
     * @param nftSetDidBulkRequest  (required)
     * @return NftSetDidBulk200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftSetDidBulk200Response nftSetDidBulk(NftSetDidBulkRequest nftSetDidBulkRequest) throws ApiException {
        ApiResponse<NftSetDidBulk200Response> localVarResp = nftSetDidBulkWithHttpInfo(nftSetDidBulkRequest);
        return localVarResp.getData();
    }

    /**
     * Bulk set DID for NFTs across different wallets.
     * Bulk set DID for NFTs across different wallets
     * @param nftSetDidBulkRequest  (required)
     * @return ApiResponse&lt;NftSetDidBulk200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftSetDidBulk200Response> nftSetDidBulkWithHttpInfo(NftSetDidBulkRequest nftSetDidBulkRequest) throws ApiException {
        okhttp3.Call localVarCall = nftSetDidBulkValidateBeforeCall(nftSetDidBulkRequest, null);
        Type localVarReturnType = new TypeToken<NftSetDidBulk200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Bulk set DID for NFTs across different wallets. (asynchronously)
     * Bulk set DID for NFTs across different wallets
     * @param nftSetDidBulkRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetDidBulkAsync(NftSetDidBulkRequest nftSetDidBulkRequest, final ApiCallback<NftSetDidBulk200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftSetDidBulkValidateBeforeCall(nftSetDidBulkRequest, _callback);
        Type localVarReturnType = new TypeToken<NftSetDidBulk200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftSetNftDid
     * @param nftSetNftDidRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetNftDidCall(NftSetNftDidRequest nftSetNftDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftSetNftDidRequest;

        // create path and map variables
        String localVarPath = "/nft_set_nft_did";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftSetNftDidValidateBeforeCall(NftSetNftDidRequest nftSetNftDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftSetNftDidRequest' is set
        if (nftSetNftDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftSetNftDidRequest' when calling nftSetNftDid(Async)");
        }

        return nftSetNftDidCall(nftSetNftDidRequest, _callback);

    }

    /**
     * Sets the DID of an NFT.
     * Sets the DID of an NFT.
     * @param nftSetNftDidRequest  (required)
     * @return NftSetNftDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftSetNftDid200Response nftSetNftDid(NftSetNftDidRequest nftSetNftDidRequest) throws ApiException {
        ApiResponse<NftSetNftDid200Response> localVarResp = nftSetNftDidWithHttpInfo(nftSetNftDidRequest);
        return localVarResp.getData();
    }

    /**
     * Sets the DID of an NFT.
     * Sets the DID of an NFT.
     * @param nftSetNftDidRequest  (required)
     * @return ApiResponse&lt;NftSetNftDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftSetNftDid200Response> nftSetNftDidWithHttpInfo(NftSetNftDidRequest nftSetNftDidRequest) throws ApiException {
        okhttp3.Call localVarCall = nftSetNftDidValidateBeforeCall(nftSetNftDidRequest, null);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sets the DID of an NFT. (asynchronously)
     * Sets the DID of an NFT.
     * @param nftSetNftDidRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetNftDidAsync(NftSetNftDidRequest nftSetNftDidRequest, final ApiCallback<NftSetNftDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftSetNftDidValidateBeforeCall(nftSetNftDidRequest, _callback);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftSetNftStatus
     * @param nftSetNftStatusRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetNftStatusCall(NftSetNftStatusRequest nftSetNftStatusRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftSetNftStatusRequest;

        // create path and map variables
        String localVarPath = "/nft_set_nft_status";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftSetNftStatusValidateBeforeCall(NftSetNftStatusRequest nftSetNftStatusRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftSetNftStatusRequest' is set
        if (nftSetNftStatusRequest == null) {
            throw new ApiException("Missing the required parameter 'nftSetNftStatusRequest' when calling nftSetNftStatus(Async)");
        }

        return nftSetNftStatusCall(nftSetNftStatusRequest, _callback);

    }

    /**
     * Sets the status of an NFT.
     * Sets the status of an NFT.
     * @param nftSetNftStatusRequest  (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse nftSetNftStatus(NftSetNftStatusRequest nftSetNftStatusRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = nftSetNftStatusWithHttpInfo(nftSetNftStatusRequest);
        return localVarResp.getData();
    }

    /**
     * Sets the status of an NFT.
     * Sets the status of an NFT.
     * @param nftSetNftStatusRequest  (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> nftSetNftStatusWithHttpInfo(NftSetNftStatusRequest nftSetNftStatusRequest) throws ApiException {
        okhttp3.Call localVarCall = nftSetNftStatusValidateBeforeCall(nftSetNftStatusRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sets the status of an NFT. (asynchronously)
     * Sets the status of an NFT.
     * @param nftSetNftStatusRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftSetNftStatusAsync(NftSetNftStatusRequest nftSetNftStatusRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftSetNftStatusValidateBeforeCall(nftSetNftStatusRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftTransferBulk
     * @param nftTransferBulkRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftTransferBulkCall(NftTransferBulkRequest nftTransferBulkRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftTransferBulkRequest;

        // create path and map variables
        String localVarPath = "/nft_transfer_bulk";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftTransferBulkValidateBeforeCall(NftTransferBulkRequest nftTransferBulkRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftTransferBulkRequest' is set
        if (nftTransferBulkRequest == null) {
            throw new ApiException("Missing the required parameter 'nftTransferBulkRequest' when calling nftTransferBulk(Async)");
        }

        return nftTransferBulkCall(nftTransferBulkRequest, _callback);

    }

    /**
     * Bulk transfer NFTs to an address.
     * Bulk transfer NFTs to an address
     * @param nftTransferBulkRequest  (required)
     * @return NftSetDidBulk200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftSetDidBulk200Response nftTransferBulk(NftTransferBulkRequest nftTransferBulkRequest) throws ApiException {
        ApiResponse<NftSetDidBulk200Response> localVarResp = nftTransferBulkWithHttpInfo(nftTransferBulkRequest);
        return localVarResp.getData();
    }

    /**
     * Bulk transfer NFTs to an address.
     * Bulk transfer NFTs to an address
     * @param nftTransferBulkRequest  (required)
     * @return ApiResponse&lt;NftSetDidBulk200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftSetDidBulk200Response> nftTransferBulkWithHttpInfo(NftTransferBulkRequest nftTransferBulkRequest) throws ApiException {
        okhttp3.Call localVarCall = nftTransferBulkValidateBeforeCall(nftTransferBulkRequest, null);
        Type localVarReturnType = new TypeToken<NftSetDidBulk200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Bulk transfer NFTs to an address. (asynchronously)
     * Bulk transfer NFTs to an address
     * @param nftTransferBulkRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftTransferBulkAsync(NftTransferBulkRequest nftTransferBulkRequest, final ApiCallback<NftSetDidBulk200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftTransferBulkValidateBeforeCall(nftTransferBulkRequest, _callback);
        Type localVarReturnType = new TypeToken<NftSetDidBulk200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for nftTransferNft
     * @param nftTransferNftRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftTransferNftCall(NftTransferNftRequest nftTransferNftRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftTransferNftRequest;

        // create path and map variables
        String localVarPath = "/nft_transfer_nft";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call nftTransferNftValidateBeforeCall(NftTransferNftRequest nftTransferNftRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftTransferNftRequest' is set
        if (nftTransferNftRequest == null) {
            throw new ApiException("Missing the required parameter 'nftTransferNftRequest' when calling nftTransferNft(Async)");
        }

        return nftTransferNftCall(nftTransferNftRequest, _callback);

    }

    /**
     * Transfers an NFT to another address.
     * Transfers an NFT to another address.
     * @param nftTransferNftRequest  (required)
     * @return NftSetNftDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public NftSetNftDid200Response nftTransferNft(NftTransferNftRequest nftTransferNftRequest) throws ApiException {
        ApiResponse<NftSetNftDid200Response> localVarResp = nftTransferNftWithHttpInfo(nftTransferNftRequest);
        return localVarResp.getData();
    }

    /**
     * Transfers an NFT to another address.
     * Transfers an NFT to another address.
     * @param nftTransferNftRequest  (required)
     * @return ApiResponse&lt;NftSetNftDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<NftSetNftDid200Response> nftTransferNftWithHttpInfo(NftTransferNftRequest nftTransferNftRequest) throws ApiException {
        okhttp3.Call localVarCall = nftTransferNftValidateBeforeCall(nftTransferNftRequest, null);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Transfers an NFT to another address. (asynchronously)
     * Transfers an NFT to another address.
     * @param nftTransferNftRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call nftTransferNftAsync(NftTransferNftRequest nftTransferNftRequest, final ApiCallback<NftSetNftDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = nftTransferNftValidateBeforeCall(nftTransferNftRequest, _callback);
        Type localVarReturnType = new TypeToken<NftSetNftDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
