/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.DeleteNotificationsRequest;
import org.openapitools.client.model.GetNotifications200Response;
import org.openapitools.client.model.GetNotificationsRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.SendNotification200Response;
import org.openapitools.client.model.SendNotificationRequest;
import org.openapitools.client.model.SignMessageByAddress200Response;
import org.openapitools.client.model.SignMessageByAddressRequest;
import org.openapitools.client.model.SignMessageById200Response;
import org.openapitools.client.model.SignMessageByIdRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class NotificationsApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public NotificationsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public NotificationsApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for deleteNotifications
     * @param deleteNotificationsRequest The notifications to delete (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteNotificationsCall(DeleteNotificationsRequest deleteNotificationsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = deleteNotificationsRequest;

        // create path and map variables
        String localVarPath = "/delete_notifications";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteNotificationsValidateBeforeCall(DeleteNotificationsRequest deleteNotificationsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'deleteNotificationsRequest' is set
        if (deleteNotificationsRequest == null) {
            throw new ApiException("Missing the required parameter 'deleteNotificationsRequest' when calling deleteNotifications(Async)");
        }

        return deleteNotificationsCall(deleteNotificationsRequest, _callback);

    }

    /**
     * Deletes notifications.
     * Deletes notifications.
     * @param deleteNotificationsRequest The notifications to delete (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse deleteNotifications(DeleteNotificationsRequest deleteNotificationsRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = deleteNotificationsWithHttpInfo(deleteNotificationsRequest);
        return localVarResp.getData();
    }

    /**
     * Deletes notifications.
     * Deletes notifications.
     * @param deleteNotificationsRequest The notifications to delete (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> deleteNotificationsWithHttpInfo(DeleteNotificationsRequest deleteNotificationsRequest) throws ApiException {
        okhttp3.Call localVarCall = deleteNotificationsValidateBeforeCall(deleteNotificationsRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Deletes notifications. (asynchronously)
     * Deletes notifications.
     * @param deleteNotificationsRequest The notifications to delete (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteNotificationsAsync(DeleteNotificationsRequest deleteNotificationsRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteNotificationsValidateBeforeCall(deleteNotificationsRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getNotifications
     * @param getNotificationsRequest Notification query inputs (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getNotificationsCall(GetNotificationsRequest getNotificationsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getNotificationsRequest;

        // create path and map variables
        String localVarPath = "/get_notifications";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getNotificationsValidateBeforeCall(GetNotificationsRequest getNotificationsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getNotificationsRequest' is set
        if (getNotificationsRequest == null) {
            throw new ApiException("Missing the required parameter 'getNotificationsRequest' when calling getNotifications(Async)");
        }

        return getNotificationsCall(getNotificationsRequest, _callback);

    }

    /**
     * Retreives notifications.
     * Retreives notifications.
     * @param getNotificationsRequest Notification query inputs (required)
     * @return GetNotifications200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetNotifications200Response getNotifications(GetNotificationsRequest getNotificationsRequest) throws ApiException {
        ApiResponse<GetNotifications200Response> localVarResp = getNotificationsWithHttpInfo(getNotificationsRequest);
        return localVarResp.getData();
    }

    /**
     * Retreives notifications.
     * Retreives notifications.
     * @param getNotificationsRequest Notification query inputs (required)
     * @return ApiResponse&lt;GetNotifications200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetNotifications200Response> getNotificationsWithHttpInfo(GetNotificationsRequest getNotificationsRequest) throws ApiException {
        okhttp3.Call localVarCall = getNotificationsValidateBeforeCall(getNotificationsRequest, null);
        Type localVarReturnType = new TypeToken<GetNotifications200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retreives notifications. (asynchronously)
     * Retreives notifications.
     * @param getNotificationsRequest Notification query inputs (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getNotificationsAsync(GetNotificationsRequest getNotificationsRequest, final ApiCallback<GetNotifications200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getNotificationsValidateBeforeCall(getNotificationsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetNotifications200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for sendNotification
     * @param sendNotificationRequest The notification to send (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendNotificationCall(SendNotificationRequest sendNotificationRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = sendNotificationRequest;

        // create path and map variables
        String localVarPath = "/send_notification";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call sendNotificationValidateBeforeCall(SendNotificationRequest sendNotificationRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'sendNotificationRequest' is set
        if (sendNotificationRequest == null) {
            throw new ApiException("Missing the required parameter 'sendNotificationRequest' when calling sendNotification(Async)");
        }

        return sendNotificationCall(sendNotificationRequest, _callback);

    }

    /**
     * Sends a notification.
     * Sends a notification.
     * @param sendNotificationRequest The notification to send (required)
     * @return SendNotification200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public SendNotification200Response sendNotification(SendNotificationRequest sendNotificationRequest) throws ApiException {
        ApiResponse<SendNotification200Response> localVarResp = sendNotificationWithHttpInfo(sendNotificationRequest);
        return localVarResp.getData();
    }

    /**
     * Sends a notification.
     * Sends a notification.
     * @param sendNotificationRequest The notification to send (required)
     * @return ApiResponse&lt;SendNotification200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SendNotification200Response> sendNotificationWithHttpInfo(SendNotificationRequest sendNotificationRequest) throws ApiException {
        okhttp3.Call localVarCall = sendNotificationValidateBeforeCall(sendNotificationRequest, null);
        Type localVarReturnType = new TypeToken<SendNotification200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sends a notification. (asynchronously)
     * Sends a notification.
     * @param sendNotificationRequest The notification to send (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendNotificationAsync(SendNotificationRequest sendNotificationRequest, final ApiCallback<SendNotification200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = sendNotificationValidateBeforeCall(sendNotificationRequest, _callback);
        Type localVarReturnType = new TypeToken<SendNotification200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for signMessageByAddress
     * @param signMessageByAddressRequest The message (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call signMessageByAddressCall(SignMessageByAddressRequest signMessageByAddressRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = signMessageByAddressRequest;

        // create path and map variables
        String localVarPath = "/sign_message_by_address";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call signMessageByAddressValidateBeforeCall(SignMessageByAddressRequest signMessageByAddressRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'signMessageByAddressRequest' is set
        if (signMessageByAddressRequest == null) {
            throw new ApiException("Missing the required parameter 'signMessageByAddressRequest' when calling signMessageByAddress(Async)");
        }

        return signMessageByAddressCall(signMessageByAddressRequest, _callback);

    }

    /**
     * Given a derived P2 address, sign the message by its private key.
     * Given a derived P2 address, sign the message by its private key.
     * @param signMessageByAddressRequest The message (required)
     * @return SignMessageByAddress200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public SignMessageByAddress200Response signMessageByAddress(SignMessageByAddressRequest signMessageByAddressRequest) throws ApiException {
        ApiResponse<SignMessageByAddress200Response> localVarResp = signMessageByAddressWithHttpInfo(signMessageByAddressRequest);
        return localVarResp.getData();
    }

    /**
     * Given a derived P2 address, sign the message by its private key.
     * Given a derived P2 address, sign the message by its private key.
     * @param signMessageByAddressRequest The message (required)
     * @return ApiResponse&lt;SignMessageByAddress200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SignMessageByAddress200Response> signMessageByAddressWithHttpInfo(SignMessageByAddressRequest signMessageByAddressRequest) throws ApiException {
        okhttp3.Call localVarCall = signMessageByAddressValidateBeforeCall(signMessageByAddressRequest, null);
        Type localVarReturnType = new TypeToken<SignMessageByAddress200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Given a derived P2 address, sign the message by its private key. (asynchronously)
     * Given a derived P2 address, sign the message by its private key.
     * @param signMessageByAddressRequest The message (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call signMessageByAddressAsync(SignMessageByAddressRequest signMessageByAddressRequest, final ApiCallback<SignMessageByAddress200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = signMessageByAddressValidateBeforeCall(signMessageByAddressRequest, _callback);
        Type localVarReturnType = new TypeToken<SignMessageByAddress200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for signMessageById
     * @param signMessageByIdRequest The message (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call signMessageByIdCall(SignMessageByIdRequest signMessageByIdRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = signMessageByIdRequest;

        // create path and map variables
        String localVarPath = "/sign_message_by_id";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call signMessageByIdValidateBeforeCall(SignMessageByIdRequest signMessageByIdRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'signMessageByIdRequest' is set
        if (signMessageByIdRequest == null) {
            throw new ApiException("Missing the required parameter 'signMessageByIdRequest' when calling signMessageById(Async)");
        }

        return signMessageByIdCall(signMessageByIdRequest, _callback);

    }

    /**
     * Given a NFT/DID ID, sign the message by the P2 private key.
     * Given a NFT/DID ID, sign the message by the P2 private key.
     * @param signMessageByIdRequest The message (required)
     * @return SignMessageById200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public SignMessageById200Response signMessageById(SignMessageByIdRequest signMessageByIdRequest) throws ApiException {
        ApiResponse<SignMessageById200Response> localVarResp = signMessageByIdWithHttpInfo(signMessageByIdRequest);
        return localVarResp.getData();
    }

    /**
     * Given a NFT/DID ID, sign the message by the P2 private key.
     * Given a NFT/DID ID, sign the message by the P2 private key.
     * @param signMessageByIdRequest The message (required)
     * @return ApiResponse&lt;SignMessageById200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SignMessageById200Response> signMessageByIdWithHttpInfo(SignMessageByIdRequest signMessageByIdRequest) throws ApiException {
        okhttp3.Call localVarCall = signMessageByIdValidateBeforeCall(signMessageByIdRequest, null);
        Type localVarReturnType = new TypeToken<SignMessageById200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Given a NFT/DID ID, sign the message by the P2 private key. (asynchronously)
     * Given a NFT/DID ID, sign the message by the P2 private key.
     * @param signMessageByIdRequest The message (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call signMessageByIdAsync(SignMessageByIdRequest signMessageByIdRequest, final ApiCallback<SignMessageById200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = signMessageByIdValidateBeforeCall(signMessageByIdRequest, _callback);
        Type localVarReturnType = new TypeToken<SignMessageById200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
