/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.PwAbsorbRewards200Response;
import org.openapitools.client.model.PwJoinPool200Response;
import org.openapitools.client.model.PwJoinPoolRequest;
import org.openapitools.client.model.PwSelfPoolRequest;
import org.openapitools.client.model.PwStatus200Response;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class PoolWalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public PoolWalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public PoolWalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for pwAbsorbRewards
     * @param pwSelfPoolRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwAbsorbRewardsCall(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = pwSelfPoolRequest;

        // create path and map variables
        String localVarPath = "/pw_absorb_rewards";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call pwAbsorbRewardsValidateBeforeCall(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'pwSelfPoolRequest' is set
        if (pwSelfPoolRequest == null) {
            throw new ApiException("Missing the required parameter 'pwSelfPoolRequest' when calling pwAbsorbRewards(Async)");
        }

        return pwAbsorbRewardsCall(pwSelfPoolRequest, _callback);

    }

    /**
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     * @param pwSelfPoolRequest  (required)
     * @return PwAbsorbRewards200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PwAbsorbRewards200Response pwAbsorbRewards(PwSelfPoolRequest pwSelfPoolRequest) throws ApiException {
        ApiResponse<PwAbsorbRewards200Response> localVarResp = pwAbsorbRewardsWithHttpInfo(pwSelfPoolRequest);
        return localVarResp.getData();
    }

    /**
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     * @param pwSelfPoolRequest  (required)
     * @return ApiResponse&lt;PwAbsorbRewards200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PwAbsorbRewards200Response> pwAbsorbRewardsWithHttpInfo(PwSelfPoolRequest pwSelfPoolRequest) throws ApiException {
        okhttp3.Call localVarCall = pwAbsorbRewardsValidateBeforeCall(pwSelfPoolRequest, null);
        Type localVarReturnType = new TypeToken<PwAbsorbRewards200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton. (asynchronously)
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     * @param pwSelfPoolRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwAbsorbRewardsAsync(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback<PwAbsorbRewards200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = pwAbsorbRewardsValidateBeforeCall(pwSelfPoolRequest, _callback);
        Type localVarReturnType = new TypeToken<PwAbsorbRewards200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for pwJoinPool
     * @param pwJoinPoolRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwJoinPoolCall(PwJoinPoolRequest pwJoinPoolRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = pwJoinPoolRequest;

        // create path and map variables
        String localVarPath = "/pw_join_pool";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call pwJoinPoolValidateBeforeCall(PwJoinPoolRequest pwJoinPoolRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'pwJoinPoolRequest' is set
        if (pwJoinPoolRequest == null) {
            throw new ApiException("Missing the required parameter 'pwJoinPoolRequest' when calling pwJoinPool(Async)");
        }

        return pwJoinPoolCall(pwJoinPoolRequest, _callback);

    }

    /**
     * Joins the given wallet to a pool.
     * Joins the given wallet to a pool.
     * @param pwJoinPoolRequest  (required)
     * @return PwJoinPool200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PwJoinPool200Response pwJoinPool(PwJoinPoolRequest pwJoinPoolRequest) throws ApiException {
        ApiResponse<PwJoinPool200Response> localVarResp = pwJoinPoolWithHttpInfo(pwJoinPoolRequest);
        return localVarResp.getData();
    }

    /**
     * Joins the given wallet to a pool.
     * Joins the given wallet to a pool.
     * @param pwJoinPoolRequest  (required)
     * @return ApiResponse&lt;PwJoinPool200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PwJoinPool200Response> pwJoinPoolWithHttpInfo(PwJoinPoolRequest pwJoinPoolRequest) throws ApiException {
        okhttp3.Call localVarCall = pwJoinPoolValidateBeforeCall(pwJoinPoolRequest, null);
        Type localVarReturnType = new TypeToken<PwJoinPool200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Joins the given wallet to a pool. (asynchronously)
     * Joins the given wallet to a pool.
     * @param pwJoinPoolRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwJoinPoolAsync(PwJoinPoolRequest pwJoinPoolRequest, final ApiCallback<PwJoinPool200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = pwJoinPoolValidateBeforeCall(pwJoinPoolRequest, _callback);
        Type localVarReturnType = new TypeToken<PwJoinPool200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for pwSelfPool
     * @param pwSelfPoolRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwSelfPoolCall(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = pwSelfPoolRequest;

        // create path and map variables
        String localVarPath = "/pw_self_pool";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call pwSelfPoolValidateBeforeCall(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'pwSelfPoolRequest' is set
        if (pwSelfPoolRequest == null) {
            throw new ApiException("Missing the required parameter 'pwSelfPoolRequest' when calling pwSelfPool(Async)");
        }

        return pwSelfPoolCall(pwSelfPoolRequest, _callback);

    }

    /**
     * Removes the given wallet to a pool.
     * Removes the given wallet to a pool.
     * @param pwSelfPoolRequest  (required)
     * @return PwJoinPool200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PwJoinPool200Response pwSelfPool(PwSelfPoolRequest pwSelfPoolRequest) throws ApiException {
        ApiResponse<PwJoinPool200Response> localVarResp = pwSelfPoolWithHttpInfo(pwSelfPoolRequest);
        return localVarResp.getData();
    }

    /**
     * Removes the given wallet to a pool.
     * Removes the given wallet to a pool.
     * @param pwSelfPoolRequest  (required)
     * @return ApiResponse&lt;PwJoinPool200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PwJoinPool200Response> pwSelfPoolWithHttpInfo(PwSelfPoolRequest pwSelfPoolRequest) throws ApiException {
        okhttp3.Call localVarCall = pwSelfPoolValidateBeforeCall(pwSelfPoolRequest, null);
        Type localVarReturnType = new TypeToken<PwJoinPool200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Removes the given wallet to a pool. (asynchronously)
     * Removes the given wallet to a pool.
     * @param pwSelfPoolRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwSelfPoolAsync(PwSelfPoolRequest pwSelfPoolRequest, final ApiCallback<PwJoinPool200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = pwSelfPoolValidateBeforeCall(pwSelfPoolRequest, _callback);
        Type localVarReturnType = new TypeToken<PwJoinPool200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for pwStatus
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwStatusCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/pw_status";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call pwStatusValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling pwStatus(Async)");
        }

        return pwStatusCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Return the complete state of the given Pool wallet.
     * Return the complete state of the given Pool wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return PwStatus200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PwStatus200Response pwStatus(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<PwStatus200Response> localVarResp = pwStatusWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Return the complete state of the given Pool wallet.
     * Return the complete state of the given Pool wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;PwStatus200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PwStatus200Response> pwStatusWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = pwStatusValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<PwStatus200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Return the complete state of the given Pool wallet. (asynchronously)
     * Return the complete state of the given Pool wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call pwStatusAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<PwStatus200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = pwStatusValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<PwStatus200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
