/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CreateSignedTransaction200Response;
import org.openapitools.client.model.CreateSignedTransactionRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.ExtendDerivationIndexRequest;
import org.openapitools.client.model.GetCurrentDerivationIndex200Response;
import org.openapitools.client.model.GetFarmedAmount200Response;
import org.openapitools.client.model.GetNextAddress200Response;
import org.openapitools.client.model.GetNextAddressRequest;
import org.openapitools.client.model.GetSpendableCoins200Response;
import org.openapitools.client.model.GetSpendableCoinsRequest;
import org.openapitools.client.model.GetTransactionCount200Response;
import org.openapitools.client.model.GetTransactionMemo200Response;
import org.openapitools.client.model.GetTransactionRequest;
import org.openapitools.client.model.GetTransactions200Response;
import org.openapitools.client.model.GetTransactionsRequest;
import org.openapitools.client.model.GetWalletBalance200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.SendTransactionMultiRequest;
import org.openapitools.client.model.SendTransactionRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.ws.rs.core.GenericType;

public class WalletApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public WalletApi() {
        this(Configuration.getDefaultApiClient());
    }

    public WalletApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for createSignedTransaction
     * @param createSignedTransactionRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createSignedTransactionCall(CreateSignedTransactionRequest createSignedTransactionRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = createSignedTransactionRequest;

        // create path and map variables
        String localVarPath = "/create_signed_transaction";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createSignedTransactionValidateBeforeCall(CreateSignedTransactionRequest createSignedTransactionRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'createSignedTransactionRequest' is set
        if (createSignedTransactionRequest == null) {
            throw new ApiException("Missing the required parameter 'createSignedTransactionRequest' when calling createSignedTransaction(Async)");
        }

        return createSignedTransactionCall(createSignedTransactionRequest, _callback);

    }

    /**
     * Creates and signs a transaction.
     * Creates and signs a transaction.
     * @param createSignedTransactionRequest  (required)
     * @return CreateSignedTransaction200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public CreateSignedTransaction200Response createSignedTransaction(CreateSignedTransactionRequest createSignedTransactionRequest) throws ApiException {
        ApiResponse<CreateSignedTransaction200Response> localVarResp = createSignedTransactionWithHttpInfo(createSignedTransactionRequest);
        return localVarResp.getData();
    }

    /**
     * Creates and signs a transaction.
     * Creates and signs a transaction.
     * @param createSignedTransactionRequest  (required)
     * @return ApiResponse&lt;CreateSignedTransaction200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateSignedTransaction200Response> createSignedTransactionWithHttpInfo(CreateSignedTransactionRequest createSignedTransactionRequest) throws ApiException {
        okhttp3.Call localVarCall = createSignedTransactionValidateBeforeCall(createSignedTransactionRequest, null);
        Type localVarReturnType = new TypeToken<CreateSignedTransaction200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Creates and signs a transaction. (asynchronously)
     * Creates and signs a transaction.
     * @param createSignedTransactionRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createSignedTransactionAsync(CreateSignedTransactionRequest createSignedTransactionRequest, final ApiCallback<CreateSignedTransaction200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = createSignedTransactionValidateBeforeCall(createSignedTransactionRequest, _callback);
        Type localVarReturnType = new TypeToken<CreateSignedTransaction200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteUnconfirmedTransactions
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteUnconfirmedTransactionsCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/delete_unconfirmed_transactions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteUnconfirmedTransactionsValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling deleteUnconfirmedTransactions(Async)");
        }

        return deleteUnconfirmedTransactionsCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Delete all unconfirmed transactions for a given wallet.
     * Delete all unconfirmed transactions for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ModelApiResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ModelApiResponse deleteUnconfirmedTransactions(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<ModelApiResponse> localVarResp = deleteUnconfirmedTransactionsWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Delete all unconfirmed transactions for a given wallet.
     * Delete all unconfirmed transactions for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;ModelApiResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ModelApiResponse> deleteUnconfirmedTransactionsWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = deleteUnconfirmedTransactionsValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Delete all unconfirmed transactions for a given wallet. (asynchronously)
     * Delete all unconfirmed transactions for a given wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response without return values </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteUnconfirmedTransactionsAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<ModelApiResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteUnconfirmedTransactionsValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<ModelApiResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for extendDerivationIndex
     * @param extendDerivationIndexRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call extendDerivationIndexCall(ExtendDerivationIndexRequest extendDerivationIndexRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = extendDerivationIndexRequest;

        // create path and map variables
        String localVarPath = "/extend_derivation_index";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call extendDerivationIndexValidateBeforeCall(ExtendDerivationIndexRequest extendDerivationIndexRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'extendDerivationIndexRequest' is set
        if (extendDerivationIndexRequest == null) {
            throw new ApiException("Missing the required parameter 'extendDerivationIndexRequest' when calling extendDerivationIndex(Async)");
        }

        return extendDerivationIndexCall(extendDerivationIndexRequest, _callback);

    }

    /**
     * Extends the current derivation index.
     * Extends the current derivation index.
     * @param extendDerivationIndexRequest  (required)
     * @return GetCurrentDerivationIndex200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCurrentDerivationIndex200Response extendDerivationIndex(ExtendDerivationIndexRequest extendDerivationIndexRequest) throws ApiException {
        ApiResponse<GetCurrentDerivationIndex200Response> localVarResp = extendDerivationIndexWithHttpInfo(extendDerivationIndexRequest);
        return localVarResp.getData();
    }

    /**
     * Extends the current derivation index.
     * Extends the current derivation index.
     * @param extendDerivationIndexRequest  (required)
     * @return ApiResponse&lt;GetCurrentDerivationIndex200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCurrentDerivationIndex200Response> extendDerivationIndexWithHttpInfo(ExtendDerivationIndexRequest extendDerivationIndexRequest) throws ApiException {
        okhttp3.Call localVarCall = extendDerivationIndexValidateBeforeCall(extendDerivationIndexRequest, null);
        Type localVarReturnType = new TypeToken<GetCurrentDerivationIndex200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Extends the current derivation index. (asynchronously)
     * Extends the current derivation index.
     * @param extendDerivationIndexRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call extendDerivationIndexAsync(ExtendDerivationIndexRequest extendDerivationIndexRequest, final ApiCallback<GetCurrentDerivationIndex200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = extendDerivationIndexValidateBeforeCall(extendDerivationIndexRequest, _callback);
        Type localVarReturnType = new TypeToken<GetCurrentDerivationIndex200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCurrentDerivationIndex
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCurrentDerivationIndexCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_current_derivation_index";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCurrentDerivationIndexValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getCurrentDerivationIndex(Async)");
        }

        return getCurrentDerivationIndexCall(body, _callback);

    }

    /**
     * Gets the current derivation index.
     * Gets the current derivation index.
     * @param body Empty request body (required)
     * @return GetCurrentDerivationIndex200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetCurrentDerivationIndex200Response getCurrentDerivationIndex(Object body) throws ApiException {
        ApiResponse<GetCurrentDerivationIndex200Response> localVarResp = getCurrentDerivationIndexWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Gets the current derivation index.
     * Gets the current derivation index.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetCurrentDerivationIndex200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetCurrentDerivationIndex200Response> getCurrentDerivationIndexWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getCurrentDerivationIndexValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetCurrentDerivationIndex200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Gets the current derivation index. (asynchronously)
     * Gets the current derivation index.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCurrentDerivationIndexAsync(Object body, final ApiCallback<GetCurrentDerivationIndex200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCurrentDerivationIndexValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetCurrentDerivationIndex200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getFarmedAmount
     * @param body Empty request body (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getFarmedAmountCall(Object body, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = body;

        // create path and map variables
        String localVarPath = "/get_farmed_amount";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getFarmedAmountValidateBeforeCall(Object body, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling getFarmedAmount(Async)");
        }

        return getFarmedAmountCall(body, _callback);

    }

    /**
     * Retrieves the amount farmed.
     * Retrieves the amount farmed.
     * @param body Empty request body (required)
     * @return GetFarmedAmount200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetFarmedAmount200Response getFarmedAmount(Object body) throws ApiException {
        ApiResponse<GetFarmedAmount200Response> localVarResp = getFarmedAmountWithHttpInfo(body);
        return localVarResp.getData();
    }

    /**
     * Retrieves the amount farmed.
     * Retrieves the amount farmed.
     * @param body Empty request body (required)
     * @return ApiResponse&lt;GetFarmedAmount200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetFarmedAmount200Response> getFarmedAmountWithHttpInfo(Object body) throws ApiException {
        okhttp3.Call localVarCall = getFarmedAmountValidateBeforeCall(body, null);
        Type localVarReturnType = new TypeToken<GetFarmedAmount200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the amount farmed. (asynchronously)
     * Retrieves the amount farmed.
     * @param body Empty request body (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getFarmedAmountAsync(Object body, final ApiCallback<GetFarmedAmount200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getFarmedAmountValidateBeforeCall(body, _callback);
        Type localVarReturnType = new TypeToken<GetFarmedAmount200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getNextAddress
     * @param getNextAddressRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getNextAddressCall(GetNextAddressRequest getNextAddressRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getNextAddressRequest;

        // create path and map variables
        String localVarPath = "/get_next_address";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getNextAddressValidateBeforeCall(GetNextAddressRequest getNextAddressRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getNextAddressRequest' is set
        if (getNextAddressRequest == null) {
            throw new ApiException("Missing the required parameter 'getNextAddressRequest' when calling getNextAddress(Async)");
        }

        return getNextAddressCall(getNextAddressRequest, _callback);

    }

    /**
     * Returns a new address.
     * Returns a new address.
     * @param getNextAddressRequest  (required)
     * @return GetNextAddress200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetNextAddress200Response getNextAddress(GetNextAddressRequest getNextAddressRequest) throws ApiException {
        ApiResponse<GetNextAddress200Response> localVarResp = getNextAddressWithHttpInfo(getNextAddressRequest);
        return localVarResp.getData();
    }

    /**
     * Returns a new address.
     * Returns a new address.
     * @param getNextAddressRequest  (required)
     * @return ApiResponse&lt;GetNextAddress200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetNextAddress200Response> getNextAddressWithHttpInfo(GetNextAddressRequest getNextAddressRequest) throws ApiException {
        okhttp3.Call localVarCall = getNextAddressValidateBeforeCall(getNextAddressRequest, null);
        Type localVarReturnType = new TypeToken<GetNextAddress200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Returns a new address. (asynchronously)
     * Returns a new address.
     * @param getNextAddressRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getNextAddressAsync(GetNextAddressRequest getNextAddressRequest, final ApiCallback<GetNextAddress200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getNextAddressValidateBeforeCall(getNextAddressRequest, _callback);
        Type localVarReturnType = new TypeToken<GetNextAddress200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getSpendableCoins
     * @param getSpendableCoinsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSpendableCoinsCall(GetSpendableCoinsRequest getSpendableCoinsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getSpendableCoinsRequest;

        // create path and map variables
        String localVarPath = "/get_spendable_coins";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getSpendableCoinsValidateBeforeCall(GetSpendableCoinsRequest getSpendableCoinsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getSpendableCoinsRequest' is set
        if (getSpendableCoinsRequest == null) {
            throw new ApiException("Missing the required parameter 'getSpendableCoinsRequest' when calling getSpendableCoins(Async)");
        }

        return getSpendableCoinsCall(getSpendableCoinsRequest, _callback);

    }

    /**
     * Retrieves all spendable coins in a wallet.
     * Retrieves all spendable coins in a wallet.
     * @param getSpendableCoinsRequest  (required)
     * @return GetSpendableCoins200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetSpendableCoins200Response getSpendableCoins(GetSpendableCoinsRequest getSpendableCoinsRequest) throws ApiException {
        ApiResponse<GetSpendableCoins200Response> localVarResp = getSpendableCoinsWithHttpInfo(getSpendableCoinsRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves all spendable coins in a wallet.
     * Retrieves all spendable coins in a wallet.
     * @param getSpendableCoinsRequest  (required)
     * @return ApiResponse&lt;GetSpendableCoins200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetSpendableCoins200Response> getSpendableCoinsWithHttpInfo(GetSpendableCoinsRequest getSpendableCoinsRequest) throws ApiException {
        okhttp3.Call localVarCall = getSpendableCoinsValidateBeforeCall(getSpendableCoinsRequest, null);
        Type localVarReturnType = new TypeToken<GetSpendableCoins200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves all spendable coins in a wallet. (asynchronously)
     * Retrieves all spendable coins in a wallet.
     * @param getSpendableCoinsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSpendableCoinsAsync(GetSpendableCoinsRequest getSpendableCoinsRequest, final ApiCallback<GetSpendableCoins200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getSpendableCoinsValidateBeforeCall(getSpendableCoinsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetSpendableCoins200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTransaction
     * @param getTransactionRequest Request body with the Id of a transaction. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionCall(GetTransactionRequest getTransactionRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getTransactionRequest;

        // create path and map variables
        String localVarPath = "/get_transaction";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTransactionValidateBeforeCall(GetTransactionRequest getTransactionRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getTransactionRequest' is set
        if (getTransactionRequest == null) {
            throw new ApiException("Missing the required parameter 'getTransactionRequest' when calling getTransaction(Async)");
        }

        return getTransactionCall(getTransactionRequest, _callback);

    }

    /**
     * Retrieves a specific transaction.
     * Retrieves a specific transaction.
     * @param getTransactionRequest Request body with the Id of a transaction. (required)
     * @return DidTransferDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public DidTransferDid200Response getTransaction(GetTransactionRequest getTransactionRequest) throws ApiException {
        ApiResponse<DidTransferDid200Response> localVarResp = getTransactionWithHttpInfo(getTransactionRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a specific transaction.
     * Retrieves a specific transaction.
     * @param getTransactionRequest Request body with the Id of a transaction. (required)
     * @return ApiResponse&lt;DidTransferDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidTransferDid200Response> getTransactionWithHttpInfo(GetTransactionRequest getTransactionRequest) throws ApiException {
        okhttp3.Call localVarCall = getTransactionValidateBeforeCall(getTransactionRequest, null);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a specific transaction. (asynchronously)
     * Retrieves a specific transaction.
     * @param getTransactionRequest Request body with the Id of a transaction. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionAsync(GetTransactionRequest getTransactionRequest, final ApiCallback<DidTransferDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTransactionValidateBeforeCall(getTransactionRequest, _callback);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTransactionCount
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionCountCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/get_transaction_count";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTransactionCountValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling getTransactionCount(Async)");
        }

        return getTransactionCountCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the number of transactions for a wallet.
     * Retrieves the number of transactions for a wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return GetTransactionCount200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetTransactionCount200Response getTransactionCount(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<GetTransactionCount200Response> localVarResp = getTransactionCountWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the number of transactions for a wallet.
     * Retrieves the number of transactions for a wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;GetTransactionCount200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetTransactionCount200Response> getTransactionCountWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = getTransactionCountValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<GetTransactionCount200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the number of transactions for a wallet. (asynchronously)
     * Retrieves the number of transactions for a wallet.
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionCountAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<GetTransactionCount200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTransactionCountValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<GetTransactionCount200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTransactionMemo
     * @param getTransactionRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionMemoCall(GetTransactionRequest getTransactionRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getTransactionRequest;

        // create path and map variables
        String localVarPath = "/get_transaction_memo";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTransactionMemoValidateBeforeCall(GetTransactionRequest getTransactionRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getTransactionRequest' is set
        if (getTransactionRequest == null) {
            throw new ApiException("Missing the required parameter 'getTransactionRequest' when calling getTransactionMemo(Async)");
        }

        return getTransactionMemoCall(getTransactionRequest, _callback);

    }

    /**
     * Retreives the memo from a transaction.
     * Retreives the memo from a transaction
     * @param getTransactionRequest  (required)
     * @return GetTransactionMemo200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetTransactionMemo200Response getTransactionMemo(GetTransactionRequest getTransactionRequest) throws ApiException {
        ApiResponse<GetTransactionMemo200Response> localVarResp = getTransactionMemoWithHttpInfo(getTransactionRequest);
        return localVarResp.getData();
    }

    /**
     * Retreives the memo from a transaction.
     * Retreives the memo from a transaction
     * @param getTransactionRequest  (required)
     * @return ApiResponse&lt;GetTransactionMemo200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetTransactionMemo200Response> getTransactionMemoWithHttpInfo(GetTransactionRequest getTransactionRequest) throws ApiException {
        okhttp3.Call localVarCall = getTransactionMemoValidateBeforeCall(getTransactionRequest, null);
        Type localVarReturnType = new TypeToken<GetTransactionMemo200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retreives the memo from a transaction. (asynchronously)
     * Retreives the memo from a transaction
     * @param getTransactionRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionMemoAsync(GetTransactionRequest getTransactionRequest, final ApiCallback<GetTransactionMemo200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTransactionMemoValidateBeforeCall(getTransactionRequest, _callback);
        Type localVarReturnType = new TypeToken<GetTransactionMemo200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getTransactions
     * @param getTransactionsRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionsCall(GetTransactionsRequest getTransactionsRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = getTransactionsRequest;

        // create path and map variables
        String localVarPath = "/get_transactions";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getTransactionsValidateBeforeCall(GetTransactionsRequest getTransactionsRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'getTransactionsRequest' is set
        if (getTransactionsRequest == null) {
            throw new ApiException("Missing the required parameter 'getTransactionsRequest' when calling getTransactions(Async)");
        }

        return getTransactionsCall(getTransactionsRequest, _callback);

    }

    /**
     * Retrieves a list of trnsactions from a wallet.
     * Retrieves a list of trnsactions from a wallet.
     * @param getTransactionsRequest  (required)
     * @return GetTransactions200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetTransactions200Response getTransactions(GetTransactionsRequest getTransactionsRequest) throws ApiException {
        ApiResponse<GetTransactions200Response> localVarResp = getTransactionsWithHttpInfo(getTransactionsRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves a list of trnsactions from a wallet.
     * Retrieves a list of trnsactions from a wallet.
     * @param getTransactionsRequest  (required)
     * @return ApiResponse&lt;GetTransactions200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetTransactions200Response> getTransactionsWithHttpInfo(GetTransactionsRequest getTransactionsRequest) throws ApiException {
        okhttp3.Call localVarCall = getTransactionsValidateBeforeCall(getTransactionsRequest, null);
        Type localVarReturnType = new TypeToken<GetTransactions200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves a list of trnsactions from a wallet. (asynchronously)
     * Retrieves a list of trnsactions from a wallet.
     * @param getTransactionsRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getTransactionsAsync(GetTransactionsRequest getTransactionsRequest, final ApiCallback<GetTransactions200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getTransactionsValidateBeforeCall(getTransactionsRequest, _callback);
        Type localVarReturnType = new TypeToken<GetTransactions200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getWalletBalance
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWalletBalanceCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = nftGetWalletDidRequest;

        // create path and map variables
        String localVarPath = "/get_wallet_balance";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getWalletBalanceValidateBeforeCall(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'nftGetWalletDidRequest' is set
        if (nftGetWalletDidRequest == null) {
            throw new ApiException("Missing the required parameter 'nftGetWalletDidRequest' when calling getWalletBalance(Async)");
        }

        return getWalletBalanceCall(nftGetWalletDidRequest, _callback);

    }

    /**
     * Retrieves the balance of a specific wallet.
     * Retrieves the balance of a specific wallet (in units of mojos).
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return GetWalletBalance200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public GetWalletBalance200Response getWalletBalance(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        ApiResponse<GetWalletBalance200Response> localVarResp = getWalletBalanceWithHttpInfo(nftGetWalletDidRequest);
        return localVarResp.getData();
    }

    /**
     * Retrieves the balance of a specific wallet.
     * Retrieves the balance of a specific wallet (in units of mojos).
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @return ApiResponse&lt;GetWalletBalance200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GetWalletBalance200Response> getWalletBalanceWithHttpInfo(NftGetWalletDidRequest nftGetWalletDidRequest) throws ApiException {
        okhttp3.Call localVarCall = getWalletBalanceValidateBeforeCall(nftGetWalletDidRequest, null);
        Type localVarReturnType = new TypeToken<GetWalletBalance200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Retrieves the balance of a specific wallet. (asynchronously)
     * Retrieves the balance of a specific wallet (in units of mojos).
     * @param nftGetWalletDidRequest Request body with the Id of a wallet (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWalletBalanceAsync(NftGetWalletDidRequest nftGetWalletDidRequest, final ApiCallback<GetWalletBalance200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = getWalletBalanceValidateBeforeCall(nftGetWalletDidRequest, _callback);
        Type localVarReturnType = new TypeToken<GetWalletBalance200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for sendTransaction
     * @param sendTransactionRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendTransactionCall(SendTransactionRequest sendTransactionRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = sendTransactionRequest;

        // create path and map variables
        String localVarPath = "/send_transaction";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call sendTransactionValidateBeforeCall(SendTransactionRequest sendTransactionRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'sendTransactionRequest' is set
        if (sendTransactionRequest == null) {
            throw new ApiException("Missing the required parameter 'sendTransactionRequest' when calling sendTransaction(Async)");
        }

        return sendTransactionCall(sendTransactionRequest, _callback);

    }

    /**
     * Sends an amount of mojo from the given wallet to the given address.
     * Sends an amount of mojo from the given wallet to the given address.
     * @param sendTransactionRequest  (required)
     * @return DidTransferDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public DidTransferDid200Response sendTransaction(SendTransactionRequest sendTransactionRequest) throws ApiException {
        ApiResponse<DidTransferDid200Response> localVarResp = sendTransactionWithHttpInfo(sendTransactionRequest);
        return localVarResp.getData();
    }

    /**
     * Sends an amount of mojo from the given wallet to the given address.
     * Sends an amount of mojo from the given wallet to the given address.
     * @param sendTransactionRequest  (required)
     * @return ApiResponse&lt;DidTransferDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidTransferDid200Response> sendTransactionWithHttpInfo(SendTransactionRequest sendTransactionRequest) throws ApiException {
        okhttp3.Call localVarCall = sendTransactionValidateBeforeCall(sendTransactionRequest, null);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sends an amount of mojo from the given wallet to the given address. (asynchronously)
     * Sends an amount of mojo from the given wallet to the given address.
     * @param sendTransactionRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendTransactionAsync(SendTransactionRequest sendTransactionRequest, final ApiCallback<DidTransferDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = sendTransactionValidateBeforeCall(sendTransactionRequest, _callback);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for sendTransactionMulti
     * @param sendTransactionMultiRequest  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendTransactionMultiCall(SendTransactionMultiRequest sendTransactionMultiRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = sendTransactionMultiRequest;

        // create path and map variables
        String localVarPath = "/send_transaction_multi";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call sendTransactionMultiValidateBeforeCall(SendTransactionMultiRequest sendTransactionMultiRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'sendTransactionMultiRequest' is set
        if (sendTransactionMultiRequest == null) {
            throw new ApiException("Missing the required parameter 'sendTransactionMultiRequest' when calling sendTransactionMulti(Async)");
        }

        return sendTransactionMultiCall(sendTransactionMultiRequest, _callback);

    }

    /**
     * Sends multiple transactions from then given wallet.
     * Sends multiple transactions from then given wallet.
     * @param sendTransactionMultiRequest  (required)
     * @return DidTransferDid200Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public DidTransferDid200Response sendTransactionMulti(SendTransactionMultiRequest sendTransactionMultiRequest) throws ApiException {
        ApiResponse<DidTransferDid200Response> localVarResp = sendTransactionMultiWithHttpInfo(sendTransactionMultiRequest);
        return localVarResp.getData();
    }

    /**
     * Sends multiple transactions from then given wallet.
     * Sends multiple transactions from then given wallet.
     * @param sendTransactionMultiRequest  (required)
     * @return ApiResponse&lt;DidTransferDid200Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<DidTransferDid200Response> sendTransactionMultiWithHttpInfo(SendTransactionMultiRequest sendTransactionMultiRequest) throws ApiException {
        okhttp3.Call localVarCall = sendTransactionMultiValidateBeforeCall(sendTransactionMultiRequest, null);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Sends multiple transactions from then given wallet. (asynchronously)
     * Sends multiple transactions from then given wallet.
     * @param sendTransactionMultiRequest  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK response with a transaction record and a transaction id. </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call sendTransactionMultiAsync(SendTransactionMultiRequest sendTransactionMultiRequest, final ApiCallback<DidTransferDid200Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = sendTransactionMultiValidateBeforeCall(sendTransactionMultiRequest, _callback);
        Type localVarReturnType = new TypeToken<DidTransferDid200Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
