/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * CheckDeleteKey200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CheckDeleteKey200ResponseAllOf {
  public static final String SERIALIZED_NAME_FINGERPRINT = "fingerprint";
  @SerializedName(SERIALIZED_NAME_FINGERPRINT)
  private Integer fingerprint;

  public static final String SERIALIZED_NAME_USED_FOR_FARMER_REWARDS = "used_for_farmer_rewards";
  @SerializedName(SERIALIZED_NAME_USED_FOR_FARMER_REWARDS)
  private Boolean usedForFarmerRewards;

  public static final String SERIALIZED_NAME_USED_FOR_POOL_REWARDS = "used_for_pool_rewards";
  @SerializedName(SERIALIZED_NAME_USED_FOR_POOL_REWARDS)
  private Boolean usedForPoolRewards;

  public static final String SERIALIZED_NAME_WALLET_BALANCE = "wallet_balance";
  @SerializedName(SERIALIZED_NAME_WALLET_BALANCE)
  private Boolean walletBalance;

  public CheckDeleteKey200ResponseAllOf() {
  }

  public CheckDeleteKey200ResponseAllOf fingerprint(Integer fingerprint) {
    
    this.fingerprint = fingerprint;
    return this;
  }

   /**
   * Get fingerprint
   * @return fingerprint
  **/
  @javax.annotation.Nullable

  public Integer getFingerprint() {
    return fingerprint;
  }


  public void setFingerprint(Integer fingerprint) {
    this.fingerprint = fingerprint;
  }


  public CheckDeleteKey200ResponseAllOf usedForFarmerRewards(Boolean usedForFarmerRewards) {
    
    this.usedForFarmerRewards = usedForFarmerRewards;
    return this;
  }

   /**
   * Get usedForFarmerRewards
   * @return usedForFarmerRewards
  **/
  @javax.annotation.Nullable

  public Boolean getUsedForFarmerRewards() {
    return usedForFarmerRewards;
  }


  public void setUsedForFarmerRewards(Boolean usedForFarmerRewards) {
    this.usedForFarmerRewards = usedForFarmerRewards;
  }


  public CheckDeleteKey200ResponseAllOf usedForPoolRewards(Boolean usedForPoolRewards) {
    
    this.usedForPoolRewards = usedForPoolRewards;
    return this;
  }

   /**
   * Get usedForPoolRewards
   * @return usedForPoolRewards
  **/
  @javax.annotation.Nullable

  public Boolean getUsedForPoolRewards() {
    return usedForPoolRewards;
  }


  public void setUsedForPoolRewards(Boolean usedForPoolRewards) {
    this.usedForPoolRewards = usedForPoolRewards;
  }


  public CheckDeleteKey200ResponseAllOf walletBalance(Boolean walletBalance) {
    
    this.walletBalance = walletBalance;
    return this;
  }

   /**
   * Get walletBalance
   * @return walletBalance
  **/
  @javax.annotation.Nullable

  public Boolean getWalletBalance() {
    return walletBalance;
  }


  public void setWalletBalance(Boolean walletBalance) {
    this.walletBalance = walletBalance;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CheckDeleteKey200ResponseAllOf checkDeleteKey200ResponseAllOf = (CheckDeleteKey200ResponseAllOf) o;
    return Objects.equals(this.fingerprint, checkDeleteKey200ResponseAllOf.fingerprint) &&
        Objects.equals(this.usedForFarmerRewards, checkDeleteKey200ResponseAllOf.usedForFarmerRewards) &&
        Objects.equals(this.usedForPoolRewards, checkDeleteKey200ResponseAllOf.usedForPoolRewards) &&
        Objects.equals(this.walletBalance, checkDeleteKey200ResponseAllOf.walletBalance);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fingerprint, usedForFarmerRewards, usedForPoolRewards, walletBalance);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CheckDeleteKey200ResponseAllOf {\n");
    sb.append("    fingerprint: ").append(toIndentedString(fingerprint)).append("\n");
    sb.append("    usedForFarmerRewards: ").append(toIndentedString(usedForFarmerRewards)).append("\n");
    sb.append("    usedForPoolRewards: ").append(toIndentedString(usedForPoolRewards)).append("\n");
    sb.append("    walletBalance: ").append(toIndentedString(walletBalance)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("fingerprint");
    openapiFields.add("used_for_farmer_rewards");
    openapiFields.add("used_for_pool_rewards");
    openapiFields.add("wallet_balance");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CheckDeleteKey200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CheckDeleteKey200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CheckDeleteKey200ResponseAllOf is not found in the empty JSON string", CheckDeleteKey200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CheckDeleteKey200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CheckDeleteKey200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CheckDeleteKey200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CheckDeleteKey200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CheckDeleteKey200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CheckDeleteKey200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<CheckDeleteKey200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, CheckDeleteKey200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CheckDeleteKey200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CheckDeleteKey200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CheckDeleteKey200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to CheckDeleteKey200ResponseAllOf
  */
  public static CheckDeleteKey200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CheckDeleteKey200ResponseAllOf.class);
  }

 /**
  * Convert an instance of CheckDeleteKey200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

