/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * CoinAnnouncement
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CoinAnnouncement {
  public static final String SERIALIZED_NAME_COIN_ID = "coin_id";
  @SerializedName(SERIALIZED_NAME_COIN_ID)
  private String coinId;

  public static final String SERIALIZED_NAME_MESSAGE = "message";
  @SerializedName(SERIALIZED_NAME_MESSAGE)
  private String message;

  public static final String SERIALIZED_NAME_MORPH_BYTES = "morph_bytes";
  @SerializedName(SERIALIZED_NAME_MORPH_BYTES)
  private String morphBytes;

  public CoinAnnouncement() {
  }

  public CoinAnnouncement coinId(String coinId) {
    
    this.coinId = coinId;
    return this;
  }

   /**
   * Get coinId
   * @return coinId
  **/
  @javax.annotation.Nonnull

  public String getCoinId() {
    return coinId;
  }


  public void setCoinId(String coinId) {
    this.coinId = coinId;
  }


  public CoinAnnouncement message(String message) {
    
    this.message = message;
    return this;
  }

   /**
   * Get message
   * @return message
  **/
  @javax.annotation.Nonnull

  public String getMessage() {
    return message;
  }


  public void setMessage(String message) {
    this.message = message;
  }


  public CoinAnnouncement morphBytes(String morphBytes) {
    
    this.morphBytes = morphBytes;
    return this;
  }

   /**
   * Get morphBytes
   * @return morphBytes
  **/
  @javax.annotation.Nullable

  public String getMorphBytes() {
    return morphBytes;
  }


  public void setMorphBytes(String morphBytes) {
    this.morphBytes = morphBytes;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CoinAnnouncement coinAnnouncement = (CoinAnnouncement) o;
    return Objects.equals(this.coinId, coinAnnouncement.coinId) &&
        Objects.equals(this.message, coinAnnouncement.message) &&
        Objects.equals(this.morphBytes, coinAnnouncement.morphBytes);
  }

  @Override
  public int hashCode() {
    return Objects.hash(coinId, message, morphBytes);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CoinAnnouncement {\n");
    sb.append("    coinId: ").append(toIndentedString(coinId)).append("\n");
    sb.append("    message: ").append(toIndentedString(message)).append("\n");
    sb.append("    morphBytes: ").append(toIndentedString(morphBytes)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("coin_id");
    openapiFields.add("message");
    openapiFields.add("morph_bytes");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("coin_id");
    openapiRequiredFields.add("message");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CoinAnnouncement
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CoinAnnouncement.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CoinAnnouncement is not found in the empty JSON string", CoinAnnouncement.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CoinAnnouncement.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CoinAnnouncement` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : CoinAnnouncement.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("coin_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `coin_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("coin_id").toString()));
      }
      if (!jsonObj.get("message").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `message` to be a primitive type in the JSON string but got `%s`", jsonObj.get("message").toString()));
      }
      if ((jsonObj.get("morph_bytes") != null && !jsonObj.get("morph_bytes").isJsonNull()) && !jsonObj.get("morph_bytes").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `morph_bytes` to be a primitive type in the JSON string but got `%s`", jsonObj.get("morph_bytes").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CoinAnnouncement.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CoinAnnouncement' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CoinAnnouncement> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CoinAnnouncement.class));

       return (TypeAdapter<T>) new TypeAdapter<CoinAnnouncement>() {
           @Override
           public void write(JsonWriter out, CoinAnnouncement value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CoinAnnouncement read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CoinAnnouncement given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CoinAnnouncement
  * @throws IOException if the JSON string is invalid with respect to CoinAnnouncement
  */
  public static CoinAnnouncement fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CoinAnnouncement.class);
  }

 /**
  * Convert an instance of CoinAnnouncement to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

