/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.Coin;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * CoinRecord
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CoinRecord {
  public static final String SERIALIZED_NAME_COIN = "coin";
  @SerializedName(SERIALIZED_NAME_COIN)
  private Coin coin;

  public static final String SERIALIZED_NAME_CONFIRMED_BLOCK_INDEX = "confirmed_block_index";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_BLOCK_INDEX)
  private Integer confirmedBlockIndex;

  public static final String SERIALIZED_NAME_SPENT_BLOCK_INDEX = "spent_block_index";
  @SerializedName(SERIALIZED_NAME_SPENT_BLOCK_INDEX)
  private Integer spentBlockIndex;

  public static final String SERIALIZED_NAME_SPENT = "spent";
  @SerializedName(SERIALIZED_NAME_SPENT)
  private Boolean spent;

  public static final String SERIALIZED_NAME_COINBASE = "coinbase";
  @SerializedName(SERIALIZED_NAME_COINBASE)
  private Boolean coinbase;

  public static final String SERIALIZED_NAME_TIMESTAMP = "timestamp";
  @SerializedName(SERIALIZED_NAME_TIMESTAMP)
  private Integer timestamp;

  public CoinRecord() {
  }

  public CoinRecord coin(Coin coin) {
    
    this.coin = coin;
    return this;
  }

   /**
   * Get coin
   * @return coin
  **/
  @javax.annotation.Nullable

  public Coin getCoin() {
    return coin;
  }


  public void setCoin(Coin coin) {
    this.coin = coin;
  }


  public CoinRecord confirmedBlockIndex(Integer confirmedBlockIndex) {
    
    this.confirmedBlockIndex = confirmedBlockIndex;
    return this;
  }

   /**
   * Get confirmedBlockIndex
   * @return confirmedBlockIndex
  **/
  @javax.annotation.Nullable

  public Integer getConfirmedBlockIndex() {
    return confirmedBlockIndex;
  }


  public void setConfirmedBlockIndex(Integer confirmedBlockIndex) {
    this.confirmedBlockIndex = confirmedBlockIndex;
  }


  public CoinRecord spentBlockIndex(Integer spentBlockIndex) {
    
    this.spentBlockIndex = spentBlockIndex;
    return this;
  }

   /**
   * Get spentBlockIndex
   * @return spentBlockIndex
  **/
  @javax.annotation.Nullable

  public Integer getSpentBlockIndex() {
    return spentBlockIndex;
  }


  public void setSpentBlockIndex(Integer spentBlockIndex) {
    this.spentBlockIndex = spentBlockIndex;
  }


  public CoinRecord spent(Boolean spent) {
    
    this.spent = spent;
    return this;
  }

   /**
   * Get spent
   * @return spent
  **/
  @javax.annotation.Nullable

  public Boolean getSpent() {
    return spent;
  }


  public void setSpent(Boolean spent) {
    this.spent = spent;
  }


  public CoinRecord coinbase(Boolean coinbase) {
    
    this.coinbase = coinbase;
    return this;
  }

   /**
   * Get coinbase
   * @return coinbase
  **/
  @javax.annotation.Nullable

  public Boolean getCoinbase() {
    return coinbase;
  }


  public void setCoinbase(Boolean coinbase) {
    this.coinbase = coinbase;
  }


  public CoinRecord timestamp(Integer timestamp) {
    
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @javax.annotation.Nullable

  public Integer getTimestamp() {
    return timestamp;
  }


  public void setTimestamp(Integer timestamp) {
    this.timestamp = timestamp;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CoinRecord coinRecord = (CoinRecord) o;
    return Objects.equals(this.coin, coinRecord.coin) &&
        Objects.equals(this.confirmedBlockIndex, coinRecord.confirmedBlockIndex) &&
        Objects.equals(this.spentBlockIndex, coinRecord.spentBlockIndex) &&
        Objects.equals(this.spent, coinRecord.spent) &&
        Objects.equals(this.coinbase, coinRecord.coinbase) &&
        Objects.equals(this.timestamp, coinRecord.timestamp);
  }

  @Override
  public int hashCode() {
    return Objects.hash(coin, confirmedBlockIndex, spentBlockIndex, spent, coinbase, timestamp);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CoinRecord {\n");
    sb.append("    coin: ").append(toIndentedString(coin)).append("\n");
    sb.append("    confirmedBlockIndex: ").append(toIndentedString(confirmedBlockIndex)).append("\n");
    sb.append("    spentBlockIndex: ").append(toIndentedString(spentBlockIndex)).append("\n");
    sb.append("    spent: ").append(toIndentedString(spent)).append("\n");
    sb.append("    coinbase: ").append(toIndentedString(coinbase)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("coin");
    openapiFields.add("confirmed_block_index");
    openapiFields.add("spent_block_index");
    openapiFields.add("spent");
    openapiFields.add("coinbase");
    openapiFields.add("timestamp");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CoinRecord
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CoinRecord.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CoinRecord is not found in the empty JSON string", CoinRecord.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CoinRecord.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CoinRecord` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `coin`
      if (jsonObj.get("coin") != null && !jsonObj.get("coin").isJsonNull()) {
        Coin.validateJsonObject(jsonObj.getAsJsonObject("coin"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CoinRecord.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CoinRecord' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CoinRecord> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CoinRecord.class));

       return (TypeAdapter<T>) new TypeAdapter<CoinRecord>() {
           @Override
           public void write(JsonWriter out, CoinRecord value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CoinRecord read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CoinRecord given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CoinRecord
  * @throws IOException if the JSON string is invalid with respect to CoinRecord
  */
  public static CoinRecord fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CoinRecord.class);
  }

 /**
  * Convert an instance of CoinRecord to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

