/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.NodeType;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Chia&#39;s representation of a connection from node to node.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class ConnectionInfo {
  public static final String SERIALIZED_NAME_BYTES_READ = "bytes_read";
  @SerializedName(SERIALIZED_NAME_BYTES_READ)
  private Integer bytesRead;

  public static final String SERIALIZED_NAME_BYTES_WRITTEN = "bytes_written";
  @SerializedName(SERIALIZED_NAME_BYTES_WRITTEN)
  private Integer bytesWritten;

  public static final String SERIALIZED_NAME_CREATION_TIME = "creation_time";
  @SerializedName(SERIALIZED_NAME_CREATION_TIME)
  private Double creationTime;

  public static final String SERIALIZED_NAME_LAST_MESSAGE_TIME = "last_message_time";
  @SerializedName(SERIALIZED_NAME_LAST_MESSAGE_TIME)
  private Double lastMessageTime;

  public static final String SERIALIZED_NAME_LOCAL_PORT = "local_port";
  @SerializedName(SERIALIZED_NAME_LOCAL_PORT)
  private Integer localPort;

  public static final String SERIALIZED_NAME_NODE_ID = "node_id";
  @SerializedName(SERIALIZED_NAME_NODE_ID)
  private String nodeId;

  public static final String SERIALIZED_NAME_PEAK_HASH = "peak_hash";
  @SerializedName(SERIALIZED_NAME_PEAK_HASH)
  private String peakHash;

  public static final String SERIALIZED_NAME_PEAK_HEIGHT = "peak_height";
  @SerializedName(SERIALIZED_NAME_PEAK_HEIGHT)
  private Integer peakHeight;

  public static final String SERIALIZED_NAME_PEAK_WEIGHT = "peak_weight";
  @SerializedName(SERIALIZED_NAME_PEAK_WEIGHT)
  private Integer peakWeight;

  public static final String SERIALIZED_NAME_PEER_HOST = "peer_host";
  @SerializedName(SERIALIZED_NAME_PEER_HOST)
  private String peerHost;

  public static final String SERIALIZED_NAME_PEER_PORT = "peer_port";
  @SerializedName(SERIALIZED_NAME_PEER_PORT)
  private Integer peerPort;

  public static final String SERIALIZED_NAME_PEER_SERVER_PORT = "peer_server_port";
  @SerializedName(SERIALIZED_NAME_PEER_SERVER_PORT)
  private Integer peerServerPort;

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private NodeType type;

  public ConnectionInfo() {
  }

  public ConnectionInfo bytesRead(Integer bytesRead) {
    
    this.bytesRead = bytesRead;
    return this;
  }

   /**
   * Get bytesRead
   * @return bytesRead
  **/
  @javax.annotation.Nullable

  public Integer getBytesRead() {
    return bytesRead;
  }


  public void setBytesRead(Integer bytesRead) {
    this.bytesRead = bytesRead;
  }


  public ConnectionInfo bytesWritten(Integer bytesWritten) {
    
    this.bytesWritten = bytesWritten;
    return this;
  }

   /**
   * Get bytesWritten
   * @return bytesWritten
  **/
  @javax.annotation.Nullable

  public Integer getBytesWritten() {
    return bytesWritten;
  }


  public void setBytesWritten(Integer bytesWritten) {
    this.bytesWritten = bytesWritten;
  }


  public ConnectionInfo creationTime(Double creationTime) {
    
    this.creationTime = creationTime;
    return this;
  }

   /**
   * Get creationTime
   * @return creationTime
  **/
  @javax.annotation.Nullable

  public Double getCreationTime() {
    return creationTime;
  }


  public void setCreationTime(Double creationTime) {
    this.creationTime = creationTime;
  }


  public ConnectionInfo lastMessageTime(Double lastMessageTime) {
    
    this.lastMessageTime = lastMessageTime;
    return this;
  }

   /**
   * Get lastMessageTime
   * @return lastMessageTime
  **/
  @javax.annotation.Nullable

  public Double getLastMessageTime() {
    return lastMessageTime;
  }


  public void setLastMessageTime(Double lastMessageTime) {
    this.lastMessageTime = lastMessageTime;
  }


  public ConnectionInfo localPort(Integer localPort) {
    
    this.localPort = localPort;
    return this;
  }

   /**
   * Get localPort
   * @return localPort
  **/
  @javax.annotation.Nullable

  public Integer getLocalPort() {
    return localPort;
  }


  public void setLocalPort(Integer localPort) {
    this.localPort = localPort;
  }


  public ConnectionInfo nodeId(String nodeId) {
    
    this.nodeId = nodeId;
    return this;
  }

   /**
   * Get nodeId
   * @return nodeId
  **/
  @javax.annotation.Nullable

  public String getNodeId() {
    return nodeId;
  }


  public void setNodeId(String nodeId) {
    this.nodeId = nodeId;
  }


  public ConnectionInfo peakHash(String peakHash) {
    
    this.peakHash = peakHash;
    return this;
  }

   /**
   * Get peakHash
   * @return peakHash
  **/
  @javax.annotation.Nullable

  public String getPeakHash() {
    return peakHash;
  }


  public void setPeakHash(String peakHash) {
    this.peakHash = peakHash;
  }


  public ConnectionInfo peakHeight(Integer peakHeight) {
    
    this.peakHeight = peakHeight;
    return this;
  }

   /**
   * Get peakHeight
   * @return peakHeight
  **/
  @javax.annotation.Nullable

  public Integer getPeakHeight() {
    return peakHeight;
  }


  public void setPeakHeight(Integer peakHeight) {
    this.peakHeight = peakHeight;
  }


  public ConnectionInfo peakWeight(Integer peakWeight) {
    
    this.peakWeight = peakWeight;
    return this;
  }

   /**
   * Get peakWeight
   * @return peakWeight
  **/
  @javax.annotation.Nullable

  public Integer getPeakWeight() {
    return peakWeight;
  }


  public void setPeakWeight(Integer peakWeight) {
    this.peakWeight = peakWeight;
  }


  public ConnectionInfo peerHost(String peerHost) {
    
    this.peerHost = peerHost;
    return this;
  }

   /**
   * Get peerHost
   * @return peerHost
  **/
  @javax.annotation.Nullable

  public String getPeerHost() {
    return peerHost;
  }


  public void setPeerHost(String peerHost) {
    this.peerHost = peerHost;
  }


  public ConnectionInfo peerPort(Integer peerPort) {
    
    this.peerPort = peerPort;
    return this;
  }

   /**
   * Get peerPort
   * @return peerPort
  **/
  @javax.annotation.Nullable

  public Integer getPeerPort() {
    return peerPort;
  }


  public void setPeerPort(Integer peerPort) {
    this.peerPort = peerPort;
  }


  public ConnectionInfo peerServerPort(Integer peerServerPort) {
    
    this.peerServerPort = peerServerPort;
    return this;
  }

   /**
   * Get peerServerPort
   * @return peerServerPort
  **/
  @javax.annotation.Nullable

  public Integer getPeerServerPort() {
    return peerServerPort;
  }


  public void setPeerServerPort(Integer peerServerPort) {
    this.peerServerPort = peerServerPort;
  }


  public ConnectionInfo type(NodeType type) {
    
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @javax.annotation.Nullable

  public NodeType getType() {
    return type;
  }


  public void setType(NodeType type) {
    this.type = type;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ConnectionInfo connectionInfo = (ConnectionInfo) o;
    return Objects.equals(this.bytesRead, connectionInfo.bytesRead) &&
        Objects.equals(this.bytesWritten, connectionInfo.bytesWritten) &&
        Objects.equals(this.creationTime, connectionInfo.creationTime) &&
        Objects.equals(this.lastMessageTime, connectionInfo.lastMessageTime) &&
        Objects.equals(this.localPort, connectionInfo.localPort) &&
        Objects.equals(this.nodeId, connectionInfo.nodeId) &&
        Objects.equals(this.peakHash, connectionInfo.peakHash) &&
        Objects.equals(this.peakHeight, connectionInfo.peakHeight) &&
        Objects.equals(this.peakWeight, connectionInfo.peakWeight) &&
        Objects.equals(this.peerHost, connectionInfo.peerHost) &&
        Objects.equals(this.peerPort, connectionInfo.peerPort) &&
        Objects.equals(this.peerServerPort, connectionInfo.peerServerPort) &&
        Objects.equals(this.type, connectionInfo.type);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(bytesRead, bytesWritten, creationTime, lastMessageTime, localPort, nodeId, peakHash, peakHeight, peakWeight, peerHost, peerPort, peerServerPort, type);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ConnectionInfo {\n");
    sb.append("    bytesRead: ").append(toIndentedString(bytesRead)).append("\n");
    sb.append("    bytesWritten: ").append(toIndentedString(bytesWritten)).append("\n");
    sb.append("    creationTime: ").append(toIndentedString(creationTime)).append("\n");
    sb.append("    lastMessageTime: ").append(toIndentedString(lastMessageTime)).append("\n");
    sb.append("    localPort: ").append(toIndentedString(localPort)).append("\n");
    sb.append("    nodeId: ").append(toIndentedString(nodeId)).append("\n");
    sb.append("    peakHash: ").append(toIndentedString(peakHash)).append("\n");
    sb.append("    peakHeight: ").append(toIndentedString(peakHeight)).append("\n");
    sb.append("    peakWeight: ").append(toIndentedString(peakWeight)).append("\n");
    sb.append("    peerHost: ").append(toIndentedString(peerHost)).append("\n");
    sb.append("    peerPort: ").append(toIndentedString(peerPort)).append("\n");
    sb.append("    peerServerPort: ").append(toIndentedString(peerServerPort)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("bytes_read");
    openapiFields.add("bytes_written");
    openapiFields.add("creation_time");
    openapiFields.add("last_message_time");
    openapiFields.add("local_port");
    openapiFields.add("node_id");
    openapiFields.add("peak_hash");
    openapiFields.add("peak_height");
    openapiFields.add("peak_weight");
    openapiFields.add("peer_host");
    openapiFields.add("peer_port");
    openapiFields.add("peer_server_port");
    openapiFields.add("type");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to ConnectionInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!ConnectionInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in ConnectionInfo is not found in the empty JSON string", ConnectionInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!ConnectionInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `ConnectionInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("node_id") != null && !jsonObj.get("node_id").isJsonNull()) && !jsonObj.get("node_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `node_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("node_id").toString()));
      }
      if ((jsonObj.get("peak_hash") != null && !jsonObj.get("peak_hash").isJsonNull()) && !jsonObj.get("peak_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `peak_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("peak_hash").toString()));
      }
      if ((jsonObj.get("peer_host") != null && !jsonObj.get("peer_host").isJsonNull()) && !jsonObj.get("peer_host").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `peer_host` to be a primitive type in the JSON string but got `%s`", jsonObj.get("peer_host").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!ConnectionInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'ConnectionInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<ConnectionInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(ConnectionInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<ConnectionInfo>() {
           @Override
           public void write(JsonWriter out, ConnectionInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public ConnectionInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of ConnectionInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of ConnectionInfo
  * @throws IOException if the JSON string is invalid with respect to ConnectionInfo
  */
  public static ConnectionInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, ConnectionInfo.class);
  }

 /**
  * Convert an instance of ConnectionInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

