/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.WalletType;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Response when a recovery DID wallet is created.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWallet200ResponseOneOf2 {
  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private WalletType type;

  public static final String SERIALIZED_NAME_MY_DID = "my_did";
  @SerializedName(SERIALIZED_NAME_MY_DID)
  private String myDid;

  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_COIN_NAME = "coin_name";
  @SerializedName(SERIALIZED_NAME_COIN_NAME)
  private String coinName;

  public static final String SERIALIZED_NAME_COIN_LIST = "coin_list";
  @SerializedName(SERIALIZED_NAME_COIN_LIST)
  private Coin coinList;

  public static final String SERIALIZED_NAME_NEWPUZHASH = "newpuzhash";
  @SerializedName(SERIALIZED_NAME_NEWPUZHASH)
  private String newpuzhash;

  public static final String SERIALIZED_NAME_PUBKEY = "pubkey";
  @SerializedName(SERIALIZED_NAME_PUBKEY)
  private String pubkey;

  public static final String SERIALIZED_NAME_BACKUP_DIDS = "backup_dids";
  @SerializedName(SERIALIZED_NAME_BACKUP_DIDS)
  private List<String> backupDids;

  public static final String SERIALIZED_NAME_NUM_VERIFICATIONS_REQUIRED = "num_verifications_required";
  @SerializedName(SERIALIZED_NAME_NUM_VERIFICATIONS_REQUIRED)
  private Integer numVerificationsRequired;

  public CreateNewWallet200ResponseOneOf2() {
  }

  public CreateNewWallet200ResponseOneOf2 type(WalletType type) {
    
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @javax.annotation.Nullable

  public WalletType getType() {
    return type;
  }


  public void setType(WalletType type) {
    this.type = type;
  }


  public CreateNewWallet200ResponseOneOf2 myDid(String myDid) {
    
    this.myDid = myDid;
    return this;
  }

   /**
   * Get myDid
   * @return myDid
  **/
  @javax.annotation.Nullable

  public String getMyDid() {
    return myDid;
  }


  public void setMyDid(String myDid) {
    this.myDid = myDid;
  }


  public CreateNewWallet200ResponseOneOf2 walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public CreateNewWallet200ResponseOneOf2 coinName(String coinName) {
    
    this.coinName = coinName;
    return this;
  }

   /**
   * Get coinName
   * @return coinName
  **/
  @javax.annotation.Nullable

  public String getCoinName() {
    return coinName;
  }


  public void setCoinName(String coinName) {
    this.coinName = coinName;
  }


  public CreateNewWallet200ResponseOneOf2 coinList(Coin coinList) {
    
    this.coinList = coinList;
    return this;
  }

   /**
   * Get coinList
   * @return coinList
  **/
  @javax.annotation.Nullable

  public Coin getCoinList() {
    return coinList;
  }


  public void setCoinList(Coin coinList) {
    this.coinList = coinList;
  }


  public CreateNewWallet200ResponseOneOf2 newpuzhash(String newpuzhash) {
    
    this.newpuzhash = newpuzhash;
    return this;
  }

   /**
   * Get newpuzhash
   * @return newpuzhash
  **/
  @javax.annotation.Nullable

  public String getNewpuzhash() {
    return newpuzhash;
  }


  public void setNewpuzhash(String newpuzhash) {
    this.newpuzhash = newpuzhash;
  }


  public CreateNewWallet200ResponseOneOf2 pubkey(String pubkey) {
    
    this.pubkey = pubkey;
    return this;
  }

   /**
   * Get pubkey
   * @return pubkey
  **/
  @javax.annotation.Nullable

  public String getPubkey() {
    return pubkey;
  }


  public void setPubkey(String pubkey) {
    this.pubkey = pubkey;
  }


  public CreateNewWallet200ResponseOneOf2 backupDids(List<String> backupDids) {
    
    this.backupDids = backupDids;
    return this;
  }

  public CreateNewWallet200ResponseOneOf2 addBackupDidsItem(String backupDidsItem) {
    if (this.backupDids == null) {
      this.backupDids = new ArrayList<>();
    }
    this.backupDids.add(backupDidsItem);
    return this;
  }

   /**
   * Get backupDids
   * @return backupDids
  **/
  @javax.annotation.Nullable

  public List<String> getBackupDids() {
    return backupDids;
  }


  public void setBackupDids(List<String> backupDids) {
    this.backupDids = backupDids;
  }


  public CreateNewWallet200ResponseOneOf2 numVerificationsRequired(Integer numVerificationsRequired) {
    
    this.numVerificationsRequired = numVerificationsRequired;
    return this;
  }

   /**
   * Get numVerificationsRequired
   * @return numVerificationsRequired
  **/
  @javax.annotation.Nullable

  public Integer getNumVerificationsRequired() {
    return numVerificationsRequired;
  }


  public void setNumVerificationsRequired(Integer numVerificationsRequired) {
    this.numVerificationsRequired = numVerificationsRequired;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNewWallet200ResponseOneOf2 createNewWallet200ResponseOneOf2 = (CreateNewWallet200ResponseOneOf2) o;
    return Objects.equals(this.type, createNewWallet200ResponseOneOf2.type) &&
        Objects.equals(this.myDid, createNewWallet200ResponseOneOf2.myDid) &&
        Objects.equals(this.walletId, createNewWallet200ResponseOneOf2.walletId) &&
        Objects.equals(this.coinName, createNewWallet200ResponseOneOf2.coinName) &&
        Objects.equals(this.coinList, createNewWallet200ResponseOneOf2.coinList) &&
        Objects.equals(this.newpuzhash, createNewWallet200ResponseOneOf2.newpuzhash) &&
        Objects.equals(this.pubkey, createNewWallet200ResponseOneOf2.pubkey) &&
        Objects.equals(this.backupDids, createNewWallet200ResponseOneOf2.backupDids) &&
        Objects.equals(this.numVerificationsRequired, createNewWallet200ResponseOneOf2.numVerificationsRequired);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, myDid, walletId, coinName, coinList, newpuzhash, pubkey, backupDids, numVerificationsRequired);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNewWallet200ResponseOneOf2 {\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    myDid: ").append(toIndentedString(myDid)).append("\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    coinName: ").append(toIndentedString(coinName)).append("\n");
    sb.append("    coinList: ").append(toIndentedString(coinList)).append("\n");
    sb.append("    newpuzhash: ").append(toIndentedString(newpuzhash)).append("\n");
    sb.append("    pubkey: ").append(toIndentedString(pubkey)).append("\n");
    sb.append("    backupDids: ").append(toIndentedString(backupDids)).append("\n");
    sb.append("    numVerificationsRequired: ").append(toIndentedString(numVerificationsRequired)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("type");
    openapiFields.add("my_did");
    openapiFields.add("wallet_id");
    openapiFields.add("coin_name");
    openapiFields.add("coin_list");
    openapiFields.add("newpuzhash");
    openapiFields.add("pubkey");
    openapiFields.add("backup_dids");
    openapiFields.add("num_verifications_required");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWallet200ResponseOneOf2
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateNewWallet200ResponseOneOf2.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateNewWallet200ResponseOneOf2 is not found in the empty JSON string", CreateNewWallet200ResponseOneOf2.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateNewWallet200ResponseOneOf2.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateNewWallet200ResponseOneOf2` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("my_did") != null && !jsonObj.get("my_did").isJsonNull()) && !jsonObj.get("my_did").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `my_did` to be a primitive type in the JSON string but got `%s`", jsonObj.get("my_did").toString()));
      }
      if ((jsonObj.get("coin_name") != null && !jsonObj.get("coin_name").isJsonNull()) && !jsonObj.get("coin_name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `coin_name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("coin_name").toString()));
      }
      // validate the optional field `coin_list`
      if (jsonObj.get("coin_list") != null && !jsonObj.get("coin_list").isJsonNull()) {
        Coin.validateJsonObject(jsonObj.getAsJsonObject("coin_list"));
      }
      if ((jsonObj.get("newpuzhash") != null && !jsonObj.get("newpuzhash").isJsonNull()) && !jsonObj.get("newpuzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `newpuzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("newpuzhash").toString()));
      }
      if ((jsonObj.get("pubkey") != null && !jsonObj.get("pubkey").isJsonNull()) && !jsonObj.get("pubkey").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pubkey` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pubkey").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("backup_dids") != null && !jsonObj.get("backup_dids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `backup_dids` to be an array in the JSON string but got `%s`", jsonObj.get("backup_dids").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateNewWallet200ResponseOneOf2.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateNewWallet200ResponseOneOf2' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateNewWallet200ResponseOneOf2> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWallet200ResponseOneOf2.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateNewWallet200ResponseOneOf2>() {
           @Override
           public void write(JsonWriter out, CreateNewWallet200ResponseOneOf2 value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateNewWallet200ResponseOneOf2 read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateNewWallet200ResponseOneOf2 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWallet200ResponseOneOf2
  * @throws IOException if the JSON string is invalid with respect to CreateNewWallet200ResponseOneOf2
  */
  public static CreateNewWallet200ResponseOneOf2 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWallet200ResponseOneOf2.class);
  }

 /**
  * Convert an instance of CreateNewWallet200ResponseOneOf2 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

