/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.TransactionRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Response when a new pool wallet is created.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWallet200ResponseOneOf3 {
  public static final String SERIALIZED_NAME_TOTAL_FEE = "total_fee";
  @SerializedName(SERIALIZED_NAME_TOTAL_FEE)
  private Integer totalFee;

  public static final String SERIALIZED_NAME_TRANSACTION = "transaction";
  @SerializedName(SERIALIZED_NAME_TRANSACTION)
  private TransactionRecord transaction;

  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH = "p2_singleton_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH)
  private String p2SingletonPuzzleHash;

  public CreateNewWallet200ResponseOneOf3() {
  }

  public CreateNewWallet200ResponseOneOf3 totalFee(Integer totalFee) {
    
    this.totalFee = totalFee;
    return this;
  }

   /**
   * Get totalFee
   * @return totalFee
  **/
  @javax.annotation.Nullable

  public Integer getTotalFee() {
    return totalFee;
  }


  public void setTotalFee(Integer totalFee) {
    this.totalFee = totalFee;
  }


  public CreateNewWallet200ResponseOneOf3 transaction(TransactionRecord transaction) {
    
    this.transaction = transaction;
    return this;
  }

   /**
   * Get transaction
   * @return transaction
  **/
  @javax.annotation.Nullable

  public TransactionRecord getTransaction() {
    return transaction;
  }


  public void setTransaction(TransactionRecord transaction) {
    this.transaction = transaction;
  }


  public CreateNewWallet200ResponseOneOf3 launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public CreateNewWallet200ResponseOneOf3 p2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
    return this;
  }

   /**
   * Get p2SingletonPuzzleHash
   * @return p2SingletonPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getP2SingletonPuzzleHash() {
    return p2SingletonPuzzleHash;
  }


  public void setP2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNewWallet200ResponseOneOf3 createNewWallet200ResponseOneOf3 = (CreateNewWallet200ResponseOneOf3) o;
    return Objects.equals(this.totalFee, createNewWallet200ResponseOneOf3.totalFee) &&
        Objects.equals(this.transaction, createNewWallet200ResponseOneOf3.transaction) &&
        Objects.equals(this.launcherId, createNewWallet200ResponseOneOf3.launcherId) &&
        Objects.equals(this.p2SingletonPuzzleHash, createNewWallet200ResponseOneOf3.p2SingletonPuzzleHash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalFee, transaction, launcherId, p2SingletonPuzzleHash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNewWallet200ResponseOneOf3 {\n");
    sb.append("    totalFee: ").append(toIndentedString(totalFee)).append("\n");
    sb.append("    transaction: ").append(toIndentedString(transaction)).append("\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    p2SingletonPuzzleHash: ").append(toIndentedString(p2SingletonPuzzleHash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("total_fee");
    openapiFields.add("transaction");
    openapiFields.add("launcher_id");
    openapiFields.add("p2_singleton_puzzle_hash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWallet200ResponseOneOf3
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateNewWallet200ResponseOneOf3.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateNewWallet200ResponseOneOf3 is not found in the empty JSON string", CreateNewWallet200ResponseOneOf3.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateNewWallet200ResponseOneOf3.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateNewWallet200ResponseOneOf3` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `transaction`
      if (jsonObj.get("transaction") != null && !jsonObj.get("transaction").isJsonNull()) {
        TransactionRecord.validateJsonObject(jsonObj.getAsJsonObject("transaction"));
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("p2_singleton_puzzle_hash") != null && !jsonObj.get("p2_singleton_puzzle_hash").isJsonNull()) && !jsonObj.get("p2_singleton_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_singleton_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_singleton_puzzle_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateNewWallet200ResponseOneOf3.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateNewWallet200ResponseOneOf3' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateNewWallet200ResponseOneOf3> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWallet200ResponseOneOf3.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateNewWallet200ResponseOneOf3>() {
           @Override
           public void write(JsonWriter out, CreateNewWallet200ResponseOneOf3 value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateNewWallet200ResponseOneOf3 read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateNewWallet200ResponseOneOf3 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWallet200ResponseOneOf3
  * @throws IOException if the JSON string is invalid with respect to CreateNewWallet200ResponseOneOf3
  */
  public static CreateNewWallet200ResponseOneOf3 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWallet200ResponseOneOf3.class);
  }

 /**
  * Convert an instance of CreateNewWallet200ResponseOneOf3 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

