/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.openapitools.client.model.CreateNewWalletRequestOneOf;
import org.openapitools.client.model.CreateNewWalletRequestOneOf1;
import org.openapitools.client.model.CreateNewWalletRequestOneOf2;
import org.openapitools.client.model.CreateNewWalletRequestOneOf3;
import org.openapitools.client.model.PoolState;

import javax.ws.rs.core.GenericType;

import java.io.IOException;
import java.lang.reflect.Type;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.JsonPrimitive;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

import org.openapitools.client.JSON;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWalletRequest extends AbstractOpenApiSchema {
    private static final Logger log = Logger.getLogger(CreateNewWalletRequest.class.getName());

    public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
        @SuppressWarnings("unchecked")
        @Override
        public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
            if (!CreateNewWalletRequest.class.isAssignableFrom(type.getRawType())) {
                return null; // this class only serializes 'CreateNewWalletRequest' and its subtypes
            }
            final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
            final TypeAdapter<CreateNewWalletRequestOneOf> adapterCreateNewWalletRequestOneOf = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf.class));
            final TypeAdapter<CreateNewWalletRequestOneOf1> adapterCreateNewWalletRequestOneOf1 = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf1.class));
            final TypeAdapter<CreateNewWalletRequestOneOf2> adapterCreateNewWalletRequestOneOf2 = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf2.class));
            final TypeAdapter<CreateNewWalletRequestOneOf3> adapterCreateNewWalletRequestOneOf3 = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf3.class));

            return (TypeAdapter<T>) new TypeAdapter<CreateNewWalletRequest>() {
                @Override
                public void write(JsonWriter out, CreateNewWalletRequest value) throws IOException {
                    if (value == null || value.getActualInstance() == null) {
                        elementAdapter.write(out, null);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf.toJsonTree((CreateNewWalletRequestOneOf)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf1`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf1) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf1.toJsonTree((CreateNewWalletRequestOneOf1)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf2`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf2) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf2.toJsonTree((CreateNewWalletRequestOneOf2)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf3`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf3) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf3.toJsonTree((CreateNewWalletRequestOneOf3)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    throw new IOException("Failed to serialize as the type doesn't match oneOf schemas: CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3");
                }

                @Override
                public CreateNewWalletRequest read(JsonReader in) throws IOException {
                    Object deserialized = null;
                    JsonObject jsonObject = elementAdapter.read(in).getAsJsonObject();

                    int match = 0;
                    ArrayList<String> errorMessages = new ArrayList<>();
                    TypeAdapter actualAdapter = elementAdapter;

                    // deserialize CreateNewWalletRequestOneOf
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf'", e);
                    }

                    // deserialize CreateNewWalletRequestOneOf1
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf1.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf1;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf1'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1 failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf1'", e);
                    }

                    // deserialize CreateNewWalletRequestOneOf2
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf2.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf2;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf2'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf2 failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf2'", e);
                    }

                    // deserialize CreateNewWalletRequestOneOf3
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf3.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf3;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf3'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf3 failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf3'", e);
                    }

                    if (match == 1) {
                        CreateNewWalletRequest ret = new CreateNewWalletRequest();
                        ret.setActualInstance(actualAdapter.fromJsonTree(jsonObject));
                        return ret;
                    }

                    throw new IOException(String.format("Failed deserialization for CreateNewWalletRequest: %d classes match result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", match, errorMessages, jsonObject.toString()));
                }
            }.nullSafe();
        }
    }

    // store a list of schema names defined in oneOf
    public static final Map<String, GenericType> schemas = new HashMap<String, GenericType>();

    public CreateNewWalletRequest() {
        super("oneOf", Boolean.FALSE);
    }

    public CreateNewWalletRequest(CreateNewWalletRequestOneOf o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CreateNewWalletRequest(CreateNewWalletRequestOneOf1 o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CreateNewWalletRequest(CreateNewWalletRequestOneOf2 o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CreateNewWalletRequest(CreateNewWalletRequestOneOf3 o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    static {
        schemas.put("CreateNewWalletRequestOneOf", new GenericType<CreateNewWalletRequestOneOf>() {
        });
        schemas.put("CreateNewWalletRequestOneOf1", new GenericType<CreateNewWalletRequestOneOf1>() {
        });
        schemas.put("CreateNewWalletRequestOneOf2", new GenericType<CreateNewWalletRequestOneOf2>() {
        });
        schemas.put("CreateNewWalletRequestOneOf3", new GenericType<CreateNewWalletRequestOneOf3>() {
        });
    }

    @Override
    public Map<String, GenericType> getSchemas() {
        return CreateNewWalletRequest.schemas;
    }

    /**
     * Set the instance that matches the oneOf child schema, check
     * the instance parameter is valid against the oneOf child schemas:
     * CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3
     *
     * It could be an instance of the 'oneOf' schemas.
     * The oneOf child schemas may themselves be a composed schema (allOf, anyOf, oneOf).
     */
    @Override
    public void setActualInstance(Object instance) {
        if (instance instanceof CreateNewWalletRequestOneOf) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof CreateNewWalletRequestOneOf1) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof CreateNewWalletRequestOneOf2) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof CreateNewWalletRequestOneOf3) {
            super.setActualInstance(instance);
            return;
        }

        throw new RuntimeException("Invalid instance type. Must be CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3");
    }

    /**
     * Get the actual instance, which can be the following:
     * CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3
     *
     * @return The actual instance (CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3)
     */
    @Override
    public Object getActualInstance() {
        return super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf`. If the actual instance is not `CreateNewWalletRequestOneOf`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf`
     */
    public CreateNewWalletRequestOneOf getCreateNewWalletRequestOneOf() throws ClassCastException {
        return (CreateNewWalletRequestOneOf)super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf1`. If the actual instance is not `CreateNewWalletRequestOneOf1`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf1`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf1`
     */
    public CreateNewWalletRequestOneOf1 getCreateNewWalletRequestOneOf1() throws ClassCastException {
        return (CreateNewWalletRequestOneOf1)super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf2`. If the actual instance is not `CreateNewWalletRequestOneOf2`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf2`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf2`
     */
    public CreateNewWalletRequestOneOf2 getCreateNewWalletRequestOneOf2() throws ClassCastException {
        return (CreateNewWalletRequestOneOf2)super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf3`. If the actual instance is not `CreateNewWalletRequestOneOf3`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf3`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf3`
     */
    public CreateNewWalletRequestOneOf3 getCreateNewWalletRequestOneOf3() throws ClassCastException {
        return (CreateNewWalletRequestOneOf3)super.getActualInstance();
    }


 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWalletRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
    // validate oneOf schemas one by one
    int validCount = 0;
    ArrayList<String> errorMessages = new ArrayList<>();
    // validate the json string with CreateNewWalletRequestOneOf
    try {
      CreateNewWalletRequestOneOf.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with CreateNewWalletRequestOneOf1
    try {
      CreateNewWalletRequestOneOf1.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1 failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with CreateNewWalletRequestOneOf2
    try {
      CreateNewWalletRequestOneOf2.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf2 failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with CreateNewWalletRequestOneOf3
    try {
      CreateNewWalletRequestOneOf3.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf3 failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    if (validCount != 1) {
      throw new IOException(String.format("The JSON string is invalid for CreateNewWalletRequest with oneOf schemas: CreateNewWalletRequestOneOf, CreateNewWalletRequestOneOf1, CreateNewWalletRequestOneOf2, CreateNewWalletRequestOneOf3. %d class(es) match the result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", validCount, errorMessages, jsonObj.toString()));
    }
  }

 /**
  * Create an instance of CreateNewWalletRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWalletRequest
  * @throws IOException if the JSON string is invalid with respect to CreateNewWalletRequest
  */
  public static CreateNewWalletRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWalletRequest.class);
  }

 /**
  * Convert an instance of CreateNewWalletRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

