/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.openapitools.client.model.CreateNewWalletRequestOneOf1OneOf;
import org.openapitools.client.model.CreateNewWalletRequestOneOf1OneOf1;

import javax.ws.rs.core.GenericType;

import java.io.IOException;
import java.lang.reflect.Type;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapter;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;
import com.google.gson.JsonPrimitive;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;

import org.openapitools.client.JSON;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWalletRequestOneOf1 extends AbstractOpenApiSchema {
    private static final Logger log = Logger.getLogger(CreateNewWalletRequestOneOf1.class.getName());

    public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
        @SuppressWarnings("unchecked")
        @Override
        public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
            if (!CreateNewWalletRequestOneOf1.class.isAssignableFrom(type.getRawType())) {
                return null; // this class only serializes 'CreateNewWalletRequestOneOf1' and its subtypes
            }
            final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
            final TypeAdapter<CreateNewWalletRequestOneOf1OneOf> adapterCreateNewWalletRequestOneOf1OneOf = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf1OneOf.class));
            final TypeAdapter<CreateNewWalletRequestOneOf1OneOf1> adapterCreateNewWalletRequestOneOf1OneOf1 = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf1OneOf1.class));

            return (TypeAdapter<T>) new TypeAdapter<CreateNewWalletRequestOneOf1>() {
                @Override
                public void write(JsonWriter out, CreateNewWalletRequestOneOf1 value) throws IOException {
                    if (value == null || value.getActualInstance() == null) {
                        elementAdapter.write(out, null);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf1OneOf`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf1OneOf) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf1OneOf.toJsonTree((CreateNewWalletRequestOneOf1OneOf)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    // check if the actual instance is of the type `CreateNewWalletRequestOneOf1OneOf1`
                    if (value.getActualInstance() instanceof CreateNewWalletRequestOneOf1OneOf1) {
                        JsonObject obj = adapterCreateNewWalletRequestOneOf1OneOf1.toJsonTree((CreateNewWalletRequestOneOf1OneOf1)value.getActualInstance()).getAsJsonObject();
                        elementAdapter.write(out, obj);
                        return;
                    }

                    throw new IOException("Failed to serialize as the type doesn't match oneOf schemas: CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1");
                }

                @Override
                public CreateNewWalletRequestOneOf1 read(JsonReader in) throws IOException {
                    Object deserialized = null;
                    JsonObject jsonObject = elementAdapter.read(in).getAsJsonObject();

                    int match = 0;
                    ArrayList<String> errorMessages = new ArrayList<>();
                    TypeAdapter actualAdapter = elementAdapter;

                    // deserialize CreateNewWalletRequestOneOf1OneOf
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf1OneOf.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf1OneOf;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf1OneOf'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1OneOf failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf1OneOf'", e);
                    }

                    // deserialize CreateNewWalletRequestOneOf1OneOf1
                    try {
                        // validate the JSON object to see if any exception is thrown
                        CreateNewWalletRequestOneOf1OneOf1.validateJsonObject(jsonObject);
                        actualAdapter = adapterCreateNewWalletRequestOneOf1OneOf1;
                        match++;
                        log.log(Level.FINER, "Input data matches schema 'CreateNewWalletRequestOneOf1OneOf1'");
                    } catch (Exception e) {
                        // deserialization failed, continue
                        errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1OneOf1 failed with `%s`.", e.getMessage()));
                        log.log(Level.FINER, "Input data does not match schema 'CreateNewWalletRequestOneOf1OneOf1'", e);
                    }

                    if (match == 1) {
                        CreateNewWalletRequestOneOf1 ret = new CreateNewWalletRequestOneOf1();
                        ret.setActualInstance(actualAdapter.fromJsonTree(jsonObject));
                        return ret;
                    }

                    throw new IOException(String.format("Failed deserialization for CreateNewWalletRequestOneOf1: %d classes match result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", match, errorMessages, jsonObject.toString()));
                }
            }.nullSafe();
        }
    }

    // store a list of schema names defined in oneOf
    public static final Map<String, GenericType> schemas = new HashMap<String, GenericType>();

    public CreateNewWalletRequestOneOf1() {
        super("oneOf", Boolean.FALSE);
    }

    public CreateNewWalletRequestOneOf1(CreateNewWalletRequestOneOf1OneOf o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    public CreateNewWalletRequestOneOf1(CreateNewWalletRequestOneOf1OneOf1 o) {
        super("oneOf", Boolean.FALSE);
        setActualInstance(o);
    }

    static {
        schemas.put("CreateNewWalletRequestOneOf1OneOf", new GenericType<CreateNewWalletRequestOneOf1OneOf>() {
        });
        schemas.put("CreateNewWalletRequestOneOf1OneOf1", new GenericType<CreateNewWalletRequestOneOf1OneOf1>() {
        });
    }

    @Override
    public Map<String, GenericType> getSchemas() {
        return CreateNewWalletRequestOneOf1.schemas;
    }

    /**
     * Set the instance that matches the oneOf child schema, check
     * the instance parameter is valid against the oneOf child schemas:
     * CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1
     *
     * It could be an instance of the 'oneOf' schemas.
     * The oneOf child schemas may themselves be a composed schema (allOf, anyOf, oneOf).
     */
    @Override
    public void setActualInstance(Object instance) {
        if (instance instanceof CreateNewWalletRequestOneOf1OneOf) {
            super.setActualInstance(instance);
            return;
        }

        if (instance instanceof CreateNewWalletRequestOneOf1OneOf1) {
            super.setActualInstance(instance);
            return;
        }

        throw new RuntimeException("Invalid instance type. Must be CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1");
    }

    /**
     * Get the actual instance, which can be the following:
     * CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1
     *
     * @return The actual instance (CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1)
     */
    @Override
    public Object getActualInstance() {
        return super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf1OneOf`. If the actual instance is not `CreateNewWalletRequestOneOf1OneOf`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf1OneOf`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf1OneOf`
     */
    public CreateNewWalletRequestOneOf1OneOf getCreateNewWalletRequestOneOf1OneOf() throws ClassCastException {
        return (CreateNewWalletRequestOneOf1OneOf)super.getActualInstance();
    }

    /**
     * Get the actual instance of `CreateNewWalletRequestOneOf1OneOf1`. If the actual instance is not `CreateNewWalletRequestOneOf1OneOf1`,
     * the ClassCastException will be thrown.
     *
     * @return The actual instance of `CreateNewWalletRequestOneOf1OneOf1`
     * @throws ClassCastException if the instance is not `CreateNewWalletRequestOneOf1OneOf1`
     */
    public CreateNewWalletRequestOneOf1OneOf1 getCreateNewWalletRequestOneOf1OneOf1() throws ClassCastException {
        return (CreateNewWalletRequestOneOf1OneOf1)super.getActualInstance();
    }


 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWalletRequestOneOf1
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
    // validate oneOf schemas one by one
    int validCount = 0;
    ArrayList<String> errorMessages = new ArrayList<>();
    // validate the json string with CreateNewWalletRequestOneOf1OneOf
    try {
      CreateNewWalletRequestOneOf1OneOf.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1OneOf failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    // validate the json string with CreateNewWalletRequestOneOf1OneOf1
    try {
      CreateNewWalletRequestOneOf1OneOf1.validateJsonObject(jsonObj);
      validCount++;
    } catch (Exception e) {
      errorMessages.add(String.format("Deserialization for CreateNewWalletRequestOneOf1OneOf1 failed with `%s`.", e.getMessage()));
      // continue to the next one
    }
    if (validCount != 1) {
      throw new IOException(String.format("The JSON string is invalid for CreateNewWalletRequestOneOf1 with oneOf schemas: CreateNewWalletRequestOneOf1OneOf, CreateNewWalletRequestOneOf1OneOf1. %d class(es) match the result, expected 1. Detailed failure message for oneOf schemas: %s. JSON: %s", validCount, errorMessages, jsonObj.toString()));
    }
  }

 /**
  * Create an instance of CreateNewWalletRequestOneOf1 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWalletRequestOneOf1
  * @throws IOException if the JSON string is invalid with respect to CreateNewWalletRequestOneOf1
  */
  public static CreateNewWalletRequestOneOf1 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWalletRequestOneOf1.class);
  }

 /**
  * Convert an instance of CreateNewWalletRequestOneOf1 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

