/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Details needed for creating a new DID wallet.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWalletRequestOneOf1OneOf {
  public static final String SERIALIZED_NAME_BACKUP_DIDS = "backup_dids";
  @SerializedName(SERIALIZED_NAME_BACKUP_DIDS)
  private List<String> backupDids;

  public static final String SERIALIZED_NAME_NUM_OF_BACKUP_IDS_NEEDED = "num_of_backup_ids_needed";
  @SerializedName(SERIALIZED_NAME_NUM_OF_BACKUP_IDS_NEEDED)
  private Integer numOfBackupIdsNeeded;

  public static final String SERIALIZED_NAME_METADATA = "metadata";
  @SerializedName(SERIALIZED_NAME_METADATA)
  private Map<String, String> metadata = new HashMap<>();

  public static final String SERIALIZED_NAME_WALLET_NAME = "wallet_name";
  @SerializedName(SERIALIZED_NAME_WALLET_NAME)
  private String walletName;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public CreateNewWalletRequestOneOf1OneOf() {
  }

  public CreateNewWalletRequestOneOf1OneOf backupDids(List<String> backupDids) {
    
    this.backupDids = backupDids;
    return this;
  }

  public CreateNewWalletRequestOneOf1OneOf addBackupDidsItem(String backupDidsItem) {
    if (this.backupDids == null) {
      this.backupDids = new ArrayList<>();
    }
    this.backupDids.add(backupDidsItem);
    return this;
  }

   /**
   * Get backupDids
   * @return backupDids
  **/
  @javax.annotation.Nullable

  public List<String> getBackupDids() {
    return backupDids;
  }


  public void setBackupDids(List<String> backupDids) {
    this.backupDids = backupDids;
  }


  public CreateNewWalletRequestOneOf1OneOf numOfBackupIdsNeeded(Integer numOfBackupIdsNeeded) {
    
    this.numOfBackupIdsNeeded = numOfBackupIdsNeeded;
    return this;
  }

   /**
   * Get numOfBackupIdsNeeded
   * @return numOfBackupIdsNeeded
  **/
  @javax.annotation.Nullable

  public Integer getNumOfBackupIdsNeeded() {
    return numOfBackupIdsNeeded;
  }


  public void setNumOfBackupIdsNeeded(Integer numOfBackupIdsNeeded) {
    this.numOfBackupIdsNeeded = numOfBackupIdsNeeded;
  }


  public CreateNewWalletRequestOneOf1OneOf metadata(Map<String, String> metadata) {
    
    this.metadata = metadata;
    return this;
  }

  public CreateNewWalletRequestOneOf1OneOf putMetadataItem(String key, String metadataItem) {
    if (this.metadata == null) {
      this.metadata = new HashMap<>();
    }
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * Get metadata
   * @return metadata
  **/
  @javax.annotation.Nullable

  public Map<String, String> getMetadata() {
    return metadata;
  }


  public void setMetadata(Map<String, String> metadata) {
    this.metadata = metadata;
  }


  public CreateNewWalletRequestOneOf1OneOf walletName(String walletName) {
    
    this.walletName = walletName;
    return this;
  }

   /**
   * Get walletName
   * @return walletName
  **/
  @javax.annotation.Nullable

  public String getWalletName() {
    return walletName;
  }


  public void setWalletName(String walletName) {
    this.walletName = walletName;
  }


  public CreateNewWalletRequestOneOf1OneOf fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNewWalletRequestOneOf1OneOf createNewWalletRequestOneOf1OneOf = (CreateNewWalletRequestOneOf1OneOf) o;
    return Objects.equals(this.backupDids, createNewWalletRequestOneOf1OneOf.backupDids) &&
        Objects.equals(this.numOfBackupIdsNeeded, createNewWalletRequestOneOf1OneOf.numOfBackupIdsNeeded) &&
        Objects.equals(this.metadata, createNewWalletRequestOneOf1OneOf.metadata) &&
        Objects.equals(this.walletName, createNewWalletRequestOneOf1OneOf.walletName) &&
        Objects.equals(this.fee, createNewWalletRequestOneOf1OneOf.fee);
  }

  @Override
  public int hashCode() {
    return Objects.hash(backupDids, numOfBackupIdsNeeded, metadata, walletName, fee);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNewWalletRequestOneOf1OneOf {\n");
    sb.append("    backupDids: ").append(toIndentedString(backupDids)).append("\n");
    sb.append("    numOfBackupIdsNeeded: ").append(toIndentedString(numOfBackupIdsNeeded)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    walletName: ").append(toIndentedString(walletName)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("backup_dids");
    openapiFields.add("num_of_backup_ids_needed");
    openapiFields.add("metadata");
    openapiFields.add("wallet_name");
    openapiFields.add("fee");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWalletRequestOneOf1OneOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateNewWalletRequestOneOf1OneOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateNewWalletRequestOneOf1OneOf is not found in the empty JSON string", CreateNewWalletRequestOneOf1OneOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateNewWalletRequestOneOf1OneOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateNewWalletRequestOneOf1OneOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("backup_dids") != null && !jsonObj.get("backup_dids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `backup_dids` to be an array in the JSON string but got `%s`", jsonObj.get("backup_dids").toString()));
      }
      if ((jsonObj.get("wallet_name") != null && !jsonObj.get("wallet_name").isJsonNull()) && !jsonObj.get("wallet_name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `wallet_name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("wallet_name").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateNewWalletRequestOneOf1OneOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateNewWalletRequestOneOf1OneOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateNewWalletRequestOneOf1OneOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf1OneOf.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateNewWalletRequestOneOf1OneOf>() {
           @Override
           public void write(JsonWriter out, CreateNewWalletRequestOneOf1OneOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateNewWalletRequestOneOf1OneOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateNewWalletRequestOneOf1OneOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWalletRequestOneOf1OneOf
  * @throws IOException if the JSON string is invalid with respect to CreateNewWalletRequestOneOf1OneOf
  */
  public static CreateNewWalletRequestOneOf1OneOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWalletRequestOneOf1OneOf.class);
  }

 /**
  * Convert an instance of CreateNewWalletRequestOneOf1OneOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

