/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.PoolState;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Details needed to create a pool wallet.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWalletRequestOneOf2 {
  /**
   * The pooling mode.
   */
  @JsonAdapter(ModeEnum.Adapter.class)
  public enum ModeEnum {
    NEW("new"),
    
    RECOVERY("recovery");

    private String value;

    ModeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static ModeEnum fromValue(String value) {
      for (ModeEnum b : ModeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<ModeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ModeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public ModeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return ModeEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_MODE = "mode";
  @SerializedName(SERIALIZED_NAME_MODE)
  private ModeEnum mode;

  public static final String SERIALIZED_NAME_INITIAL_TARGET_STATE = "initial_target_state";
  @SerializedName(SERIALIZED_NAME_INITIAL_TARGET_STATE)
  private PoolState initialTargetState;

  public static final String SERIALIZED_NAME_P2_SINGLETON_DELAYED_PH = "p2_singleton_delayed_ph";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_DELAYED_PH)
  private String p2SingletonDelayedPh;

  public static final String SERIALIZED_NAME_P2_SINGLETON_DELAY_TIME = "p2_singleton_delay_time";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_DELAY_TIME)
  private Integer p2SingletonDelayTime;

  public CreateNewWalletRequestOneOf2() {
  }

  public CreateNewWalletRequestOneOf2 mode(ModeEnum mode) {
    
    this.mode = mode;
    return this;
  }

   /**
   * The pooling mode.
   * @return mode
  **/
  @javax.annotation.Nonnull

  public ModeEnum getMode() {
    return mode;
  }


  public void setMode(ModeEnum mode) {
    this.mode = mode;
  }


  public CreateNewWalletRequestOneOf2 initialTargetState(PoolState initialTargetState) {
    
    this.initialTargetState = initialTargetState;
    return this;
  }

   /**
   * Get initialTargetState
   * @return initialTargetState
  **/
  @javax.annotation.Nullable

  public PoolState getInitialTargetState() {
    return initialTargetState;
  }


  public void setInitialTargetState(PoolState initialTargetState) {
    this.initialTargetState = initialTargetState;
  }


  public CreateNewWalletRequestOneOf2 p2SingletonDelayedPh(String p2SingletonDelayedPh) {
    
    this.p2SingletonDelayedPh = p2SingletonDelayedPh;
    return this;
  }

   /**
   * Get p2SingletonDelayedPh
   * @return p2SingletonDelayedPh
  **/
  @javax.annotation.Nullable

  public String getP2SingletonDelayedPh() {
    return p2SingletonDelayedPh;
  }


  public void setP2SingletonDelayedPh(String p2SingletonDelayedPh) {
    this.p2SingletonDelayedPh = p2SingletonDelayedPh;
  }


  public CreateNewWalletRequestOneOf2 p2SingletonDelayTime(Integer p2SingletonDelayTime) {
    
    this.p2SingletonDelayTime = p2SingletonDelayTime;
    return this;
  }

   /**
   * Get p2SingletonDelayTime
   * @return p2SingletonDelayTime
  **/
  @javax.annotation.Nullable

  public Integer getP2SingletonDelayTime() {
    return p2SingletonDelayTime;
  }


  public void setP2SingletonDelayTime(Integer p2SingletonDelayTime) {
    this.p2SingletonDelayTime = p2SingletonDelayTime;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNewWalletRequestOneOf2 createNewWalletRequestOneOf2 = (CreateNewWalletRequestOneOf2) o;
    return Objects.equals(this.mode, createNewWalletRequestOneOf2.mode) &&
        Objects.equals(this.initialTargetState, createNewWalletRequestOneOf2.initialTargetState) &&
        Objects.equals(this.p2SingletonDelayedPh, createNewWalletRequestOneOf2.p2SingletonDelayedPh) &&
        Objects.equals(this.p2SingletonDelayTime, createNewWalletRequestOneOf2.p2SingletonDelayTime);
  }

  @Override
  public int hashCode() {
    return Objects.hash(mode, initialTargetState, p2SingletonDelayedPh, p2SingletonDelayTime);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNewWalletRequestOneOf2 {\n");
    sb.append("    mode: ").append(toIndentedString(mode)).append("\n");
    sb.append("    initialTargetState: ").append(toIndentedString(initialTargetState)).append("\n");
    sb.append("    p2SingletonDelayedPh: ").append(toIndentedString(p2SingletonDelayedPh)).append("\n");
    sb.append("    p2SingletonDelayTime: ").append(toIndentedString(p2SingletonDelayTime)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("mode");
    openapiFields.add("initial_target_state");
    openapiFields.add("p2_singleton_delayed_ph");
    openapiFields.add("p2_singleton_delay_time");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("mode");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWalletRequestOneOf2
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateNewWalletRequestOneOf2.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateNewWalletRequestOneOf2 is not found in the empty JSON string", CreateNewWalletRequestOneOf2.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateNewWalletRequestOneOf2.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateNewWalletRequestOneOf2` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : CreateNewWalletRequestOneOf2.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("mode").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `mode` to be a primitive type in the JSON string but got `%s`", jsonObj.get("mode").toString()));
      }
      // validate the optional field `initial_target_state`
      if (jsonObj.get("initial_target_state") != null && !jsonObj.get("initial_target_state").isJsonNull()) {
        PoolState.validateJsonObject(jsonObj.getAsJsonObject("initial_target_state"));
      }
      if ((jsonObj.get("p2_singleton_delayed_ph") != null && !jsonObj.get("p2_singleton_delayed_ph").isJsonNull()) && !jsonObj.get("p2_singleton_delayed_ph").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_singleton_delayed_ph` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_singleton_delayed_ph").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateNewWalletRequestOneOf2.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateNewWalletRequestOneOf2' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateNewWalletRequestOneOf2> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf2.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateNewWalletRequestOneOf2>() {
           @Override
           public void write(JsonWriter out, CreateNewWalletRequestOneOf2 value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateNewWalletRequestOneOf2 read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateNewWalletRequestOneOf2 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWalletRequestOneOf2
  * @throws IOException if the JSON string is invalid with respect to CreateNewWalletRequestOneOf2
  */
  public static CreateNewWalletRequestOneOf2 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWalletRequestOneOf2.class);
  }

 /**
  * Convert an instance of CreateNewWalletRequestOneOf2 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

