/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Details needed to create an NFT wallet.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateNewWalletRequestOneOf3 {
  public static final String SERIALIZED_NAME_DID_ID = "did_id";
  @SerializedName(SERIALIZED_NAME_DID_ID)
  private String didId;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public CreateNewWalletRequestOneOf3() {
  }

  public CreateNewWalletRequestOneOf3 didId(String didId) {
    
    this.didId = didId;
    return this;
  }

   /**
   * Get didId
   * @return didId
  **/
  @javax.annotation.Nullable

  public String getDidId() {
    return didId;
  }


  public void setDidId(String didId) {
    this.didId = didId;
  }


  public CreateNewWalletRequestOneOf3 name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Get name
   * @return name
  **/
  @javax.annotation.Nullable

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNewWalletRequestOneOf3 createNewWalletRequestOneOf3 = (CreateNewWalletRequestOneOf3) o;
    return Objects.equals(this.didId, createNewWalletRequestOneOf3.didId) &&
        Objects.equals(this.name, createNewWalletRequestOneOf3.name);
  }

  @Override
  public int hashCode() {
    return Objects.hash(didId, name);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNewWalletRequestOneOf3 {\n");
    sb.append("    didId: ").append(toIndentedString(didId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("did_id");
    openapiFields.add("name");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateNewWalletRequestOneOf3
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateNewWalletRequestOneOf3.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateNewWalletRequestOneOf3 is not found in the empty JSON string", CreateNewWalletRequestOneOf3.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateNewWalletRequestOneOf3.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateNewWalletRequestOneOf3` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("did_id") != null && !jsonObj.get("did_id").isJsonNull()) && !jsonObj.get("did_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `did_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("did_id").toString()));
      }
      if ((jsonObj.get("name") != null && !jsonObj.get("name").isJsonNull()) && !jsonObj.get("name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("name").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateNewWalletRequestOneOf3.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateNewWalletRequestOneOf3' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateNewWalletRequestOneOf3> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateNewWalletRequestOneOf3.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateNewWalletRequestOneOf3>() {
           @Override
           public void write(JsonWriter out, CreateNewWalletRequestOneOf3 value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateNewWalletRequestOneOf3 read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateNewWalletRequestOneOf3 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateNewWalletRequestOneOf3
  * @throws IOException if the JSON string is invalid with respect to CreateNewWalletRequestOneOf3
  */
  public static CreateNewWalletRequestOneOf3 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateNewWalletRequestOneOf3.class);
  }

 /**
  * Convert an instance of CreateNewWalletRequestOneOf3 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

