/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.AmountWithPuzzlehash;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.CoinAnnouncement;
import org.openapitools.client.model.PuzzleAnnouncement;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * CreateSignedTransactionRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class CreateSignedTransactionRequest {
  public static final String SERIALIZED_NAME_ADDITIONS = "additions";
  @SerializedName(SERIALIZED_NAME_ADDITIONS)
  private List<AmountWithPuzzlehash> additions = new ArrayList<>();

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_COINS = "coins";
  @SerializedName(SERIALIZED_NAME_COINS)
  private List<Coin> coins;

  public static final String SERIALIZED_NAME_COIN_ANNOUNCEMENTS = "coin_announcements";
  @SerializedName(SERIALIZED_NAME_COIN_ANNOUNCEMENTS)
  private List<CoinAnnouncement> coinAnnouncements;

  public static final String SERIALIZED_NAME_PUZZLE_ANNOUNCEMENTS = "puzzle_announcements";
  @SerializedName(SERIALIZED_NAME_PUZZLE_ANNOUNCEMENTS)
  private List<PuzzleAnnouncement> puzzleAnnouncements;

  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_MIN_COIN_AMOUNT = "min_coin_amount";
  @SerializedName(SERIALIZED_NAME_MIN_COIN_AMOUNT)
  private Integer minCoinAmount = 0;

  public static final String SERIALIZED_NAME_MAX_COIN_AMOUNT = "max_coin_amount";
  @SerializedName(SERIALIZED_NAME_MAX_COIN_AMOUNT)
  private Integer maxCoinAmount = 0;

  public static final String SERIALIZED_NAME_EXCLUDED_COINS = "excluded_coins";
  @SerializedName(SERIALIZED_NAME_EXCLUDED_COINS)
  private List<Coin> excludedCoins;

  public static final String SERIALIZED_NAME_EXCLUDED_COIN_AMOUNTS = "excluded_coin_amounts";
  @SerializedName(SERIALIZED_NAME_EXCLUDED_COIN_AMOUNTS)
  private List<Integer> excludedCoinAmounts;

  public CreateSignedTransactionRequest() {
  }

  public CreateSignedTransactionRequest additions(List<AmountWithPuzzlehash> additions) {
    
    this.additions = additions;
    return this;
  }

  public CreateSignedTransactionRequest addAdditionsItem(AmountWithPuzzlehash additionsItem) {
    if (this.additions == null) {
      this.additions = new ArrayList<>();
    }
    this.additions.add(additionsItem);
    return this;
  }

   /**
   * Get additions
   * @return additions
  **/
  @javax.annotation.Nonnull

  public List<AmountWithPuzzlehash> getAdditions() {
    return additions;
  }


  public void setAdditions(List<AmountWithPuzzlehash> additions) {
    this.additions = additions;
  }


  public CreateSignedTransactionRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public CreateSignedTransactionRequest coins(List<Coin> coins) {
    
    this.coins = coins;
    return this;
  }

  public CreateSignedTransactionRequest addCoinsItem(Coin coinsItem) {
    if (this.coins == null) {
      this.coins = new ArrayList<>();
    }
    this.coins.add(coinsItem);
    return this;
  }

   /**
   * Get coins
   * @return coins
  **/
  @javax.annotation.Nullable

  public List<Coin> getCoins() {
    return coins;
  }


  public void setCoins(List<Coin> coins) {
    this.coins = coins;
  }


  public CreateSignedTransactionRequest coinAnnouncements(List<CoinAnnouncement> coinAnnouncements) {
    
    this.coinAnnouncements = coinAnnouncements;
    return this;
  }

  public CreateSignedTransactionRequest addCoinAnnouncementsItem(CoinAnnouncement coinAnnouncementsItem) {
    if (this.coinAnnouncements == null) {
      this.coinAnnouncements = new ArrayList<>();
    }
    this.coinAnnouncements.add(coinAnnouncementsItem);
    return this;
  }

   /**
   * Get coinAnnouncements
   * @return coinAnnouncements
  **/
  @javax.annotation.Nullable

  public List<CoinAnnouncement> getCoinAnnouncements() {
    return coinAnnouncements;
  }


  public void setCoinAnnouncements(List<CoinAnnouncement> coinAnnouncements) {
    this.coinAnnouncements = coinAnnouncements;
  }


  public CreateSignedTransactionRequest puzzleAnnouncements(List<PuzzleAnnouncement> puzzleAnnouncements) {
    
    this.puzzleAnnouncements = puzzleAnnouncements;
    return this;
  }

  public CreateSignedTransactionRequest addPuzzleAnnouncementsItem(PuzzleAnnouncement puzzleAnnouncementsItem) {
    if (this.puzzleAnnouncements == null) {
      this.puzzleAnnouncements = new ArrayList<>();
    }
    this.puzzleAnnouncements.add(puzzleAnnouncementsItem);
    return this;
  }

   /**
   * Get puzzleAnnouncements
   * @return puzzleAnnouncements
  **/
  @javax.annotation.Nullable

  public List<PuzzleAnnouncement> getPuzzleAnnouncements() {
    return puzzleAnnouncements;
  }


  public void setPuzzleAnnouncements(List<PuzzleAnnouncement> puzzleAnnouncements) {
    this.puzzleAnnouncements = puzzleAnnouncements;
  }


  public CreateSignedTransactionRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public CreateSignedTransactionRequest minCoinAmount(Integer minCoinAmount) {
    
    this.minCoinAmount = minCoinAmount;
    return this;
  }

   /**
   * Get minCoinAmount
   * @return minCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMinCoinAmount() {
    return minCoinAmount;
  }


  public void setMinCoinAmount(Integer minCoinAmount) {
    this.minCoinAmount = minCoinAmount;
  }


  public CreateSignedTransactionRequest maxCoinAmount(Integer maxCoinAmount) {
    
    this.maxCoinAmount = maxCoinAmount;
    return this;
  }

   /**
   * Get maxCoinAmount
   * @return maxCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMaxCoinAmount() {
    return maxCoinAmount;
  }


  public void setMaxCoinAmount(Integer maxCoinAmount) {
    this.maxCoinAmount = maxCoinAmount;
  }


  public CreateSignedTransactionRequest excludedCoins(List<Coin> excludedCoins) {
    
    this.excludedCoins = excludedCoins;
    return this;
  }

  public CreateSignedTransactionRequest addExcludedCoinsItem(Coin excludedCoinsItem) {
    if (this.excludedCoins == null) {
      this.excludedCoins = new ArrayList<>();
    }
    this.excludedCoins.add(excludedCoinsItem);
    return this;
  }

   /**
   * Get excludedCoins
   * @return excludedCoins
  **/
  @javax.annotation.Nullable

  public List<Coin> getExcludedCoins() {
    return excludedCoins;
  }


  public void setExcludedCoins(List<Coin> excludedCoins) {
    this.excludedCoins = excludedCoins;
  }


  public CreateSignedTransactionRequest excludedCoinAmounts(List<Integer> excludedCoinAmounts) {
    
    this.excludedCoinAmounts = excludedCoinAmounts;
    return this;
  }

  public CreateSignedTransactionRequest addExcludedCoinAmountsItem(Integer excludedCoinAmountsItem) {
    if (this.excludedCoinAmounts == null) {
      this.excludedCoinAmounts = new ArrayList<>();
    }
    this.excludedCoinAmounts.add(excludedCoinAmountsItem);
    return this;
  }

   /**
   * Get excludedCoinAmounts
   * @return excludedCoinAmounts
  **/
  @javax.annotation.Nullable

  public List<Integer> getExcludedCoinAmounts() {
    return excludedCoinAmounts;
  }


  public void setExcludedCoinAmounts(List<Integer> excludedCoinAmounts) {
    this.excludedCoinAmounts = excludedCoinAmounts;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateSignedTransactionRequest createSignedTransactionRequest = (CreateSignedTransactionRequest) o;
    return Objects.equals(this.additions, createSignedTransactionRequest.additions) &&
        Objects.equals(this.fee, createSignedTransactionRequest.fee) &&
        Objects.equals(this.coins, createSignedTransactionRequest.coins) &&
        Objects.equals(this.coinAnnouncements, createSignedTransactionRequest.coinAnnouncements) &&
        Objects.equals(this.puzzleAnnouncements, createSignedTransactionRequest.puzzleAnnouncements) &&
        Objects.equals(this.walletId, createSignedTransactionRequest.walletId) &&
        Objects.equals(this.minCoinAmount, createSignedTransactionRequest.minCoinAmount) &&
        Objects.equals(this.maxCoinAmount, createSignedTransactionRequest.maxCoinAmount) &&
        Objects.equals(this.excludedCoins, createSignedTransactionRequest.excludedCoins) &&
        Objects.equals(this.excludedCoinAmounts, createSignedTransactionRequest.excludedCoinAmounts);
  }

  @Override
  public int hashCode() {
    return Objects.hash(additions, fee, coins, coinAnnouncements, puzzleAnnouncements, walletId, minCoinAmount, maxCoinAmount, excludedCoins, excludedCoinAmounts);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateSignedTransactionRequest {\n");
    sb.append("    additions: ").append(toIndentedString(additions)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    coins: ").append(toIndentedString(coins)).append("\n");
    sb.append("    coinAnnouncements: ").append(toIndentedString(coinAnnouncements)).append("\n");
    sb.append("    puzzleAnnouncements: ").append(toIndentedString(puzzleAnnouncements)).append("\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    minCoinAmount: ").append(toIndentedString(minCoinAmount)).append("\n");
    sb.append("    maxCoinAmount: ").append(toIndentedString(maxCoinAmount)).append("\n");
    sb.append("    excludedCoins: ").append(toIndentedString(excludedCoins)).append("\n");
    sb.append("    excludedCoinAmounts: ").append(toIndentedString(excludedCoinAmounts)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("additions");
    openapiFields.add("fee");
    openapiFields.add("coins");
    openapiFields.add("coin_announcements");
    openapiFields.add("puzzle_announcements");
    openapiFields.add("wallet_id");
    openapiFields.add("min_coin_amount");
    openapiFields.add("max_coin_amount");
    openapiFields.add("excluded_coins");
    openapiFields.add("excluded_coin_amounts");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("additions");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to CreateSignedTransactionRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!CreateSignedTransactionRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in CreateSignedTransactionRequest is not found in the empty JSON string", CreateSignedTransactionRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!CreateSignedTransactionRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `CreateSignedTransactionRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : CreateSignedTransactionRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the json data is an array
      if (!jsonObj.get("additions").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `additions` to be an array in the JSON string but got `%s`", jsonObj.get("additions").toString()));
      }

      JsonArray jsonArrayadditions = jsonObj.getAsJsonArray("additions");
      // validate the required field `additions` (array)
      for (int i = 0; i < jsonArrayadditions.size(); i++) {
        AmountWithPuzzlehash.validateJsonObject(jsonArrayadditions.get(i).getAsJsonObject());
      };
      if (jsonObj.get("coins") != null && !jsonObj.get("coins").isJsonNull()) {
        JsonArray jsonArraycoins = jsonObj.getAsJsonArray("coins");
        if (jsonArraycoins != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coins").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coins` to be an array in the JSON string but got `%s`", jsonObj.get("coins").toString()));
          }

          // validate the optional field `coins` (array)
          for (int i = 0; i < jsonArraycoins.size(); i++) {
            Coin.validateJsonObject(jsonArraycoins.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("coin_announcements") != null && !jsonObj.get("coin_announcements").isJsonNull()) {
        JsonArray jsonArraycoinAnnouncements = jsonObj.getAsJsonArray("coin_announcements");
        if (jsonArraycoinAnnouncements != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coin_announcements").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coin_announcements` to be an array in the JSON string but got `%s`", jsonObj.get("coin_announcements").toString()));
          }

          // validate the optional field `coin_announcements` (array)
          for (int i = 0; i < jsonArraycoinAnnouncements.size(); i++) {
            CoinAnnouncement.validateJsonObject(jsonArraycoinAnnouncements.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("puzzle_announcements") != null && !jsonObj.get("puzzle_announcements").isJsonNull()) {
        JsonArray jsonArraypuzzleAnnouncements = jsonObj.getAsJsonArray("puzzle_announcements");
        if (jsonArraypuzzleAnnouncements != null) {
          // ensure the json data is an array
          if (!jsonObj.get("puzzle_announcements").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `puzzle_announcements` to be an array in the JSON string but got `%s`", jsonObj.get("puzzle_announcements").toString()));
          }

          // validate the optional field `puzzle_announcements` (array)
          for (int i = 0; i < jsonArraypuzzleAnnouncements.size(); i++) {
            PuzzleAnnouncement.validateJsonObject(jsonArraypuzzleAnnouncements.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("excluded_coins") != null && !jsonObj.get("excluded_coins").isJsonNull()) {
        JsonArray jsonArrayexcludedCoins = jsonObj.getAsJsonArray("excluded_coins");
        if (jsonArrayexcludedCoins != null) {
          // ensure the json data is an array
          if (!jsonObj.get("excluded_coins").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `excluded_coins` to be an array in the JSON string but got `%s`", jsonObj.get("excluded_coins").toString()));
          }

          // validate the optional field `excluded_coins` (array)
          for (int i = 0; i < jsonArrayexcludedCoins.size(); i++) {
            Coin.validateJsonObject(jsonArrayexcludedCoins.get(i).getAsJsonObject());
          };
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("excluded_coin_amounts") != null && !jsonObj.get("excluded_coin_amounts").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `excluded_coin_amounts` to be an array in the JSON string but got `%s`", jsonObj.get("excluded_coin_amounts").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!CreateSignedTransactionRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'CreateSignedTransactionRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<CreateSignedTransactionRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(CreateSignedTransactionRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<CreateSignedTransactionRequest>() {
           @Override
           public void write(JsonWriter out, CreateSignedTransactionRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public CreateSignedTransactionRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of CreateSignedTransactionRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of CreateSignedTransactionRequest
  * @throws IOException if the JSON string is invalid with respect to CreateSignedTransactionRequest
  */
  public static CreateSignedTransactionRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, CreateSignedTransactionRequest.class);
  }

 /**
  * Convert an instance of CreateSignedTransactionRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

