/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidCreateAttest200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidCreateAttest200ResponseAllOf {
  public static final String SERIALIZED_NAME_MESSAGE_SPEND_BUNDLE = "message_spend_bundle";
  @SerializedName(SERIALIZED_NAME_MESSAGE_SPEND_BUNDLE)
  private String messageSpendBundle;

  public static final String SERIALIZED_NAME_INFO = "info";
  @SerializedName(SERIALIZED_NAME_INFO)
  private List<String> info;

  public static final String SERIALIZED_NAME_ATTEST_DATA = "attest_data";
  @SerializedName(SERIALIZED_NAME_ATTEST_DATA)
  private String attestData;

  public DidCreateAttest200ResponseAllOf() {
  }

  public DidCreateAttest200ResponseAllOf messageSpendBundle(String messageSpendBundle) {
    
    this.messageSpendBundle = messageSpendBundle;
    return this;
  }

   /**
   * Get messageSpendBundle
   * @return messageSpendBundle
  **/
  @javax.annotation.Nullable

  public String getMessageSpendBundle() {
    return messageSpendBundle;
  }


  public void setMessageSpendBundle(String messageSpendBundle) {
    this.messageSpendBundle = messageSpendBundle;
  }


  public DidCreateAttest200ResponseAllOf info(List<String> info) {
    
    this.info = info;
    return this;
  }

  public DidCreateAttest200ResponseAllOf addInfoItem(String infoItem) {
    if (this.info == null) {
      this.info = new ArrayList<>();
    }
    this.info.add(infoItem);
    return this;
  }

   /**
   * Get info
   * @return info
  **/
  @javax.annotation.Nullable

  public List<String> getInfo() {
    return info;
  }


  public void setInfo(List<String> info) {
    this.info = info;
  }


  public DidCreateAttest200ResponseAllOf attestData(String attestData) {
    
    this.attestData = attestData;
    return this;
  }

   /**
   * Get attestData
   * @return attestData
  **/
  @javax.annotation.Nullable

  public String getAttestData() {
    return attestData;
  }


  public void setAttestData(String attestData) {
    this.attestData = attestData;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidCreateAttest200ResponseAllOf didCreateAttest200ResponseAllOf = (DidCreateAttest200ResponseAllOf) o;
    return Objects.equals(this.messageSpendBundle, didCreateAttest200ResponseAllOf.messageSpendBundle) &&
        Objects.equals(this.info, didCreateAttest200ResponseAllOf.info) &&
        Objects.equals(this.attestData, didCreateAttest200ResponseAllOf.attestData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(messageSpendBundle, info, attestData);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidCreateAttest200ResponseAllOf {\n");
    sb.append("    messageSpendBundle: ").append(toIndentedString(messageSpendBundle)).append("\n");
    sb.append("    info: ").append(toIndentedString(info)).append("\n");
    sb.append("    attestData: ").append(toIndentedString(attestData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("message_spend_bundle");
    openapiFields.add("info");
    openapiFields.add("attest_data");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidCreateAttest200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidCreateAttest200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidCreateAttest200ResponseAllOf is not found in the empty JSON string", DidCreateAttest200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidCreateAttest200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidCreateAttest200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("message_spend_bundle") != null && !jsonObj.get("message_spend_bundle").isJsonNull()) && !jsonObj.get("message_spend_bundle").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `message_spend_bundle` to be a primitive type in the JSON string but got `%s`", jsonObj.get("message_spend_bundle").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("info") != null && !jsonObj.get("info").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `info` to be an array in the JSON string but got `%s`", jsonObj.get("info").toString()));
      }
      if ((jsonObj.get("attest_data") != null && !jsonObj.get("attest_data").isJsonNull()) && !jsonObj.get("attest_data").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `attest_data` to be a primitive type in the JSON string but got `%s`", jsonObj.get("attest_data").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidCreateAttest200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidCreateAttest200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidCreateAttest200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidCreateAttest200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<DidCreateAttest200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, DidCreateAttest200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidCreateAttest200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidCreateAttest200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidCreateAttest200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to DidCreateAttest200ResponseAllOf
  */
  public static DidCreateAttest200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidCreateAttest200ResponseAllOf.class);
  }

 /**
  * Convert an instance of DidCreateAttest200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

