/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidGetCurrentCoinInfo200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidGetCurrentCoinInfo200Response {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_MY_DID = "my_did";
  @SerializedName(SERIALIZED_NAME_MY_DID)
  private String myDid;

  public static final String SERIALIZED_NAME_DID_PARENT = "did_parent";
  @SerializedName(SERIALIZED_NAME_DID_PARENT)
  private String didParent;

  public static final String SERIALIZED_NAME_DID_INNERPUZ = "did_innerpuz";
  @SerializedName(SERIALIZED_NAME_DID_INNERPUZ)
  private String didInnerpuz;

  public static final String SERIALIZED_NAME_DID_AMOUNT = "did_amount";
  @SerializedName(SERIALIZED_NAME_DID_AMOUNT)
  private Integer didAmount;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public DidGetCurrentCoinInfo200Response() {
  }

  public DidGetCurrentCoinInfo200Response walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public DidGetCurrentCoinInfo200Response myDid(String myDid) {
    
    this.myDid = myDid;
    return this;
  }

   /**
   * Get myDid
   * @return myDid
  **/
  @javax.annotation.Nullable

  public String getMyDid() {
    return myDid;
  }


  public void setMyDid(String myDid) {
    this.myDid = myDid;
  }


  public DidGetCurrentCoinInfo200Response didParent(String didParent) {
    
    this.didParent = didParent;
    return this;
  }

   /**
   * Get didParent
   * @return didParent
  **/
  @javax.annotation.Nullable

  public String getDidParent() {
    return didParent;
  }


  public void setDidParent(String didParent) {
    this.didParent = didParent;
  }


  public DidGetCurrentCoinInfo200Response didInnerpuz(String didInnerpuz) {
    
    this.didInnerpuz = didInnerpuz;
    return this;
  }

   /**
   * Get didInnerpuz
   * @return didInnerpuz
  **/
  @javax.annotation.Nullable

  public String getDidInnerpuz() {
    return didInnerpuz;
  }


  public void setDidInnerpuz(String didInnerpuz) {
    this.didInnerpuz = didInnerpuz;
  }


  public DidGetCurrentCoinInfo200Response didAmount(Integer didAmount) {
    
    this.didAmount = didAmount;
    return this;
  }

   /**
   * Get didAmount
   * @return didAmount
  **/
  @javax.annotation.Nullable

  public Integer getDidAmount() {
    return didAmount;
  }


  public void setDidAmount(Integer didAmount) {
    this.didAmount = didAmount;
  }


  public DidGetCurrentCoinInfo200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public DidGetCurrentCoinInfo200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidGetCurrentCoinInfo200Response didGetCurrentCoinInfo200Response = (DidGetCurrentCoinInfo200Response) o;
    return Objects.equals(this.walletId, didGetCurrentCoinInfo200Response.walletId) &&
        Objects.equals(this.myDid, didGetCurrentCoinInfo200Response.myDid) &&
        Objects.equals(this.didParent, didGetCurrentCoinInfo200Response.didParent) &&
        Objects.equals(this.didInnerpuz, didGetCurrentCoinInfo200Response.didInnerpuz) &&
        Objects.equals(this.didAmount, didGetCurrentCoinInfo200Response.didAmount) &&
        Objects.equals(this.success, didGetCurrentCoinInfo200Response.success) &&
        Objects.equals(this.error, didGetCurrentCoinInfo200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, myDid, didParent, didInnerpuz, didAmount, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidGetCurrentCoinInfo200Response {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    myDid: ").append(toIndentedString(myDid)).append("\n");
    sb.append("    didParent: ").append(toIndentedString(didParent)).append("\n");
    sb.append("    didInnerpuz: ").append(toIndentedString(didInnerpuz)).append("\n");
    sb.append("    didAmount: ").append(toIndentedString(didAmount)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("my_did");
    openapiFields.add("did_parent");
    openapiFields.add("did_innerpuz");
    openapiFields.add("did_amount");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidGetCurrentCoinInfo200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidGetCurrentCoinInfo200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidGetCurrentCoinInfo200Response is not found in the empty JSON string", DidGetCurrentCoinInfo200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidGetCurrentCoinInfo200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidGetCurrentCoinInfo200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DidGetCurrentCoinInfo200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("my_did") != null && !jsonObj.get("my_did").isJsonNull()) && !jsonObj.get("my_did").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `my_did` to be a primitive type in the JSON string but got `%s`", jsonObj.get("my_did").toString()));
      }
      if ((jsonObj.get("did_parent") != null && !jsonObj.get("did_parent").isJsonNull()) && !jsonObj.get("did_parent").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `did_parent` to be a primitive type in the JSON string but got `%s`", jsonObj.get("did_parent").toString()));
      }
      if ((jsonObj.get("did_innerpuz") != null && !jsonObj.get("did_innerpuz").isJsonNull()) && !jsonObj.get("did_innerpuz").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `did_innerpuz` to be a primitive type in the JSON string but got `%s`", jsonObj.get("did_innerpuz").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidGetCurrentCoinInfo200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidGetCurrentCoinInfo200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidGetCurrentCoinInfo200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidGetCurrentCoinInfo200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<DidGetCurrentCoinInfo200Response>() {
           @Override
           public void write(JsonWriter out, DidGetCurrentCoinInfo200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidGetCurrentCoinInfo200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidGetCurrentCoinInfo200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidGetCurrentCoinInfo200Response
  * @throws IOException if the JSON string is invalid with respect to DidGetCurrentCoinInfo200Response
  */
  public static DidGetCurrentCoinInfo200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidGetCurrentCoinInfo200Response.class);
  }

 /**
  * Convert an instance of DidGetCurrentCoinInfo200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

