/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidGetInfo200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidGetInfo200Response {
  public static final String SERIALIZED_NAME_LATEST_COIN = "latest_coin";
  @SerializedName(SERIALIZED_NAME_LATEST_COIN)
  private String latestCoin;

  public static final String SERIALIZED_NAME_P2_ADDRESS = "p2_address";
  @SerializedName(SERIALIZED_NAME_P2_ADDRESS)
  private String p2Address;

  public static final String SERIALIZED_NAME_PUBLIC_KEY = "public_key";
  @SerializedName(SERIALIZED_NAME_PUBLIC_KEY)
  private String publicKey;

  public static final String SERIALIZED_NAME_RECOVERY_LIST_HASH = "recovery_list_hash";
  @SerializedName(SERIALIZED_NAME_RECOVERY_LIST_HASH)
  private String recoveryListHash;

  public static final String SERIALIZED_NAME_NUM_VERIFICATION = "num_verification";
  @SerializedName(SERIALIZED_NAME_NUM_VERIFICATION)
  private Integer numVerification;

  public static final String SERIALIZED_NAME_METADATA = "metadata";
  @SerializedName(SERIALIZED_NAME_METADATA)
  private Map<String, Object> metadata = new HashMap<>();

  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_FULL_PUZZLE = "full_puzzle";
  @SerializedName(SERIALIZED_NAME_FULL_PUZZLE)
  private String fullPuzzle;

  public static final String SERIALIZED_NAME_SOLUTION = "solution";
  @SerializedName(SERIALIZED_NAME_SOLUTION)
  private String solution;

  public static final String SERIALIZED_NAME_HINTS = "hints";
  @SerializedName(SERIALIZED_NAME_HINTS)
  private List<String> hints;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public DidGetInfo200Response() {
  }

  public DidGetInfo200Response latestCoin(String latestCoin) {
    
    this.latestCoin = latestCoin;
    return this;
  }

   /**
   * Get latestCoin
   * @return latestCoin
  **/
  @javax.annotation.Nullable

  public String getLatestCoin() {
    return latestCoin;
  }


  public void setLatestCoin(String latestCoin) {
    this.latestCoin = latestCoin;
  }


  public DidGetInfo200Response p2Address(String p2Address) {
    
    this.p2Address = p2Address;
    return this;
  }

   /**
   * Get p2Address
   * @return p2Address
  **/
  @javax.annotation.Nullable

  public String getP2Address() {
    return p2Address;
  }


  public void setP2Address(String p2Address) {
    this.p2Address = p2Address;
  }


  public DidGetInfo200Response publicKey(String publicKey) {
    
    this.publicKey = publicKey;
    return this;
  }

   /**
   * Get publicKey
   * @return publicKey
  **/
  @javax.annotation.Nullable

  public String getPublicKey() {
    return publicKey;
  }


  public void setPublicKey(String publicKey) {
    this.publicKey = publicKey;
  }


  public DidGetInfo200Response recoveryListHash(String recoveryListHash) {
    
    this.recoveryListHash = recoveryListHash;
    return this;
  }

   /**
   * Get recoveryListHash
   * @return recoveryListHash
  **/
  @javax.annotation.Nullable

  public String getRecoveryListHash() {
    return recoveryListHash;
  }


  public void setRecoveryListHash(String recoveryListHash) {
    this.recoveryListHash = recoveryListHash;
  }


  public DidGetInfo200Response numVerification(Integer numVerification) {
    
    this.numVerification = numVerification;
    return this;
  }

   /**
   * Get numVerification
   * @return numVerification
  **/
  @javax.annotation.Nullable

  public Integer getNumVerification() {
    return numVerification;
  }


  public void setNumVerification(Integer numVerification) {
    this.numVerification = numVerification;
  }


  public DidGetInfo200Response metadata(Map<String, Object> metadata) {
    
    this.metadata = metadata;
    return this;
  }

  public DidGetInfo200Response putMetadataItem(String key, Object metadataItem) {
    if (this.metadata == null) {
      this.metadata = new HashMap<>();
    }
    this.metadata.put(key, metadataItem);
    return this;
  }

   /**
   * Get metadata
   * @return metadata
  **/
  @javax.annotation.Nullable

  public Map<String, Object> getMetadata() {
    return metadata;
  }


  public void setMetadata(Map<String, Object> metadata) {
    this.metadata = metadata;
  }


  public DidGetInfo200Response launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public DidGetInfo200Response fullPuzzle(String fullPuzzle) {
    
    this.fullPuzzle = fullPuzzle;
    return this;
  }

   /**
   * Get fullPuzzle
   * @return fullPuzzle
  **/
  @javax.annotation.Nullable

  public String getFullPuzzle() {
    return fullPuzzle;
  }


  public void setFullPuzzle(String fullPuzzle) {
    this.fullPuzzle = fullPuzzle;
  }


  public DidGetInfo200Response solution(String solution) {
    
    this.solution = solution;
    return this;
  }

   /**
   * Get solution
   * @return solution
  **/
  @javax.annotation.Nullable

  public String getSolution() {
    return solution;
  }


  public void setSolution(String solution) {
    this.solution = solution;
  }


  public DidGetInfo200Response hints(List<String> hints) {
    
    this.hints = hints;
    return this;
  }

  public DidGetInfo200Response addHintsItem(String hintsItem) {
    if (this.hints == null) {
      this.hints = new ArrayList<>();
    }
    this.hints.add(hintsItem);
    return this;
  }

   /**
   * Get hints
   * @return hints
  **/
  @javax.annotation.Nullable

  public List<String> getHints() {
    return hints;
  }


  public void setHints(List<String> hints) {
    this.hints = hints;
  }


  public DidGetInfo200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public DidGetInfo200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidGetInfo200Response didGetInfo200Response = (DidGetInfo200Response) o;
    return Objects.equals(this.latestCoin, didGetInfo200Response.latestCoin) &&
        Objects.equals(this.p2Address, didGetInfo200Response.p2Address) &&
        Objects.equals(this.publicKey, didGetInfo200Response.publicKey) &&
        Objects.equals(this.recoveryListHash, didGetInfo200Response.recoveryListHash) &&
        Objects.equals(this.numVerification, didGetInfo200Response.numVerification) &&
        Objects.equals(this.metadata, didGetInfo200Response.metadata) &&
        Objects.equals(this.launcherId, didGetInfo200Response.launcherId) &&
        Objects.equals(this.fullPuzzle, didGetInfo200Response.fullPuzzle) &&
        Objects.equals(this.solution, didGetInfo200Response.solution) &&
        Objects.equals(this.hints, didGetInfo200Response.hints) &&
        Objects.equals(this.success, didGetInfo200Response.success) &&
        Objects.equals(this.error, didGetInfo200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(latestCoin, p2Address, publicKey, recoveryListHash, numVerification, metadata, launcherId, fullPuzzle, solution, hints, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidGetInfo200Response {\n");
    sb.append("    latestCoin: ").append(toIndentedString(latestCoin)).append("\n");
    sb.append("    p2Address: ").append(toIndentedString(p2Address)).append("\n");
    sb.append("    publicKey: ").append(toIndentedString(publicKey)).append("\n");
    sb.append("    recoveryListHash: ").append(toIndentedString(recoveryListHash)).append("\n");
    sb.append("    numVerification: ").append(toIndentedString(numVerification)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    fullPuzzle: ").append(toIndentedString(fullPuzzle)).append("\n");
    sb.append("    solution: ").append(toIndentedString(solution)).append("\n");
    sb.append("    hints: ").append(toIndentedString(hints)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("latest_coin");
    openapiFields.add("p2_address");
    openapiFields.add("public_key");
    openapiFields.add("recovery_list_hash");
    openapiFields.add("num_verification");
    openapiFields.add("metadata");
    openapiFields.add("launcher_id");
    openapiFields.add("full_puzzle");
    openapiFields.add("solution");
    openapiFields.add("hints");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidGetInfo200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidGetInfo200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidGetInfo200Response is not found in the empty JSON string", DidGetInfo200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidGetInfo200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidGetInfo200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DidGetInfo200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("latest_coin") != null && !jsonObj.get("latest_coin").isJsonNull()) && !jsonObj.get("latest_coin").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `latest_coin` to be a primitive type in the JSON string but got `%s`", jsonObj.get("latest_coin").toString()));
      }
      if ((jsonObj.get("p2_address") != null && !jsonObj.get("p2_address").isJsonNull()) && !jsonObj.get("p2_address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_address").toString()));
      }
      if ((jsonObj.get("public_key") != null && !jsonObj.get("public_key").isJsonNull()) && !jsonObj.get("public_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `public_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("public_key").toString()));
      }
      if ((jsonObj.get("recovery_list_hash") != null && !jsonObj.get("recovery_list_hash").isJsonNull()) && !jsonObj.get("recovery_list_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `recovery_list_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("recovery_list_hash").toString()));
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("full_puzzle") != null && !jsonObj.get("full_puzzle").isJsonNull()) && !jsonObj.get("full_puzzle").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `full_puzzle` to be a primitive type in the JSON string but got `%s`", jsonObj.get("full_puzzle").toString()));
      }
      if ((jsonObj.get("solution") != null && !jsonObj.get("solution").isJsonNull()) && !jsonObj.get("solution").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `solution` to be a primitive type in the JSON string but got `%s`", jsonObj.get("solution").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("hints") != null && !jsonObj.get("hints").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `hints` to be an array in the JSON string but got `%s`", jsonObj.get("hints").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidGetInfo200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidGetInfo200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidGetInfo200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidGetInfo200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<DidGetInfo200Response>() {
           @Override
           public void write(JsonWriter out, DidGetInfo200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidGetInfo200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidGetInfo200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidGetInfo200Response
  * @throws IOException if the JSON string is invalid with respect to DidGetInfo200Response
  */
  public static DidGetInfo200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidGetInfo200Response.class);
  }

 /**
  * Convert an instance of DidGetInfo200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

