/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidGetInformationNeededForRecovery200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidGetInformationNeededForRecovery200Response {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_MY_DID = "my_did";
  @SerializedName(SERIALIZED_NAME_MY_DID)
  private String myDid;

  public static final String SERIALIZED_NAME_COIN_NAME = "coin_name";
  @SerializedName(SERIALIZED_NAME_COIN_NAME)
  private String coinName;

  public static final String SERIALIZED_NAME_NEWPUZHASH = "newpuzhash";
  @SerializedName(SERIALIZED_NAME_NEWPUZHASH)
  private String newpuzhash;

  public static final String SERIALIZED_NAME_PUBKEY = "pubkey";
  @SerializedName(SERIALIZED_NAME_PUBKEY)
  private String pubkey;

  public static final String SERIALIZED_NAME_BACKUP_DIDS = "backup_dids";
  @SerializedName(SERIALIZED_NAME_BACKUP_DIDS)
  private List<String> backupDids;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public DidGetInformationNeededForRecovery200Response() {
  }

  public DidGetInformationNeededForRecovery200Response walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public DidGetInformationNeededForRecovery200Response myDid(String myDid) {
    
    this.myDid = myDid;
    return this;
  }

   /**
   * Get myDid
   * @return myDid
  **/
  @javax.annotation.Nullable

  public String getMyDid() {
    return myDid;
  }


  public void setMyDid(String myDid) {
    this.myDid = myDid;
  }


  public DidGetInformationNeededForRecovery200Response coinName(String coinName) {
    
    this.coinName = coinName;
    return this;
  }

   /**
   * Get coinName
   * @return coinName
  **/
  @javax.annotation.Nullable

  public String getCoinName() {
    return coinName;
  }


  public void setCoinName(String coinName) {
    this.coinName = coinName;
  }


  public DidGetInformationNeededForRecovery200Response newpuzhash(String newpuzhash) {
    
    this.newpuzhash = newpuzhash;
    return this;
  }

   /**
   * Get newpuzhash
   * @return newpuzhash
  **/
  @javax.annotation.Nullable

  public String getNewpuzhash() {
    return newpuzhash;
  }


  public void setNewpuzhash(String newpuzhash) {
    this.newpuzhash = newpuzhash;
  }


  public DidGetInformationNeededForRecovery200Response pubkey(String pubkey) {
    
    this.pubkey = pubkey;
    return this;
  }

   /**
   * Get pubkey
   * @return pubkey
  **/
  @javax.annotation.Nullable

  public String getPubkey() {
    return pubkey;
  }


  public void setPubkey(String pubkey) {
    this.pubkey = pubkey;
  }


  public DidGetInformationNeededForRecovery200Response backupDids(List<String> backupDids) {
    
    this.backupDids = backupDids;
    return this;
  }

  public DidGetInformationNeededForRecovery200Response addBackupDidsItem(String backupDidsItem) {
    if (this.backupDids == null) {
      this.backupDids = new ArrayList<>();
    }
    this.backupDids.add(backupDidsItem);
    return this;
  }

   /**
   * Get backupDids
   * @return backupDids
  **/
  @javax.annotation.Nullable

  public List<String> getBackupDids() {
    return backupDids;
  }


  public void setBackupDids(List<String> backupDids) {
    this.backupDids = backupDids;
  }


  public DidGetInformationNeededForRecovery200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public DidGetInformationNeededForRecovery200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidGetInformationNeededForRecovery200Response didGetInformationNeededForRecovery200Response = (DidGetInformationNeededForRecovery200Response) o;
    return Objects.equals(this.walletId, didGetInformationNeededForRecovery200Response.walletId) &&
        Objects.equals(this.myDid, didGetInformationNeededForRecovery200Response.myDid) &&
        Objects.equals(this.coinName, didGetInformationNeededForRecovery200Response.coinName) &&
        Objects.equals(this.newpuzhash, didGetInformationNeededForRecovery200Response.newpuzhash) &&
        Objects.equals(this.pubkey, didGetInformationNeededForRecovery200Response.pubkey) &&
        Objects.equals(this.backupDids, didGetInformationNeededForRecovery200Response.backupDids) &&
        Objects.equals(this.success, didGetInformationNeededForRecovery200Response.success) &&
        Objects.equals(this.error, didGetInformationNeededForRecovery200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, myDid, coinName, newpuzhash, pubkey, backupDids, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidGetInformationNeededForRecovery200Response {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    myDid: ").append(toIndentedString(myDid)).append("\n");
    sb.append("    coinName: ").append(toIndentedString(coinName)).append("\n");
    sb.append("    newpuzhash: ").append(toIndentedString(newpuzhash)).append("\n");
    sb.append("    pubkey: ").append(toIndentedString(pubkey)).append("\n");
    sb.append("    backupDids: ").append(toIndentedString(backupDids)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("my_did");
    openapiFields.add("coin_name");
    openapiFields.add("newpuzhash");
    openapiFields.add("pubkey");
    openapiFields.add("backup_dids");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidGetInformationNeededForRecovery200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidGetInformationNeededForRecovery200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidGetInformationNeededForRecovery200Response is not found in the empty JSON string", DidGetInformationNeededForRecovery200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidGetInformationNeededForRecovery200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidGetInformationNeededForRecovery200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DidGetInformationNeededForRecovery200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("my_did") != null && !jsonObj.get("my_did").isJsonNull()) && !jsonObj.get("my_did").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `my_did` to be a primitive type in the JSON string but got `%s`", jsonObj.get("my_did").toString()));
      }
      if ((jsonObj.get("coin_name") != null && !jsonObj.get("coin_name").isJsonNull()) && !jsonObj.get("coin_name").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `coin_name` to be a primitive type in the JSON string but got `%s`", jsonObj.get("coin_name").toString()));
      }
      if ((jsonObj.get("newpuzhash") != null && !jsonObj.get("newpuzhash").isJsonNull()) && !jsonObj.get("newpuzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `newpuzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("newpuzhash").toString()));
      }
      if ((jsonObj.get("pubkey") != null && !jsonObj.get("pubkey").isJsonNull()) && !jsonObj.get("pubkey").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pubkey` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pubkey").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("backup_dids") != null && !jsonObj.get("backup_dids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `backup_dids` to be an array in the JSON string but got `%s`", jsonObj.get("backup_dids").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidGetInformationNeededForRecovery200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidGetInformationNeededForRecovery200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidGetInformationNeededForRecovery200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidGetInformationNeededForRecovery200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<DidGetInformationNeededForRecovery200Response>() {
           @Override
           public void write(JsonWriter out, DidGetInformationNeededForRecovery200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidGetInformationNeededForRecovery200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidGetInformationNeededForRecovery200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidGetInformationNeededForRecovery200Response
  * @throws IOException if the JSON string is invalid with respect to DidGetInformationNeededForRecovery200Response
  */
  public static DidGetInformationNeededForRecovery200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidGetInformationNeededForRecovery200Response.class);
  }

 /**
  * Convert an instance of DidGetInformationNeededForRecovery200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

