/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidTransferDidRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidTransferDidRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_INNER_ADDRESS = "inner_address";
  @SerializedName(SERIALIZED_NAME_INNER_ADDRESS)
  private String innerAddress;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_WITH_RECOVERY_INFO = "with_recovery_info";
  @SerializedName(SERIALIZED_NAME_WITH_RECOVERY_INFO)
  private Boolean withRecoveryInfo = true;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public DidTransferDidRequest() {
  }

  public DidTransferDidRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public DidTransferDidRequest innerAddress(String innerAddress) {
    
    this.innerAddress = innerAddress;
    return this;
  }

   /**
   * Get innerAddress
   * @return innerAddress
  **/
  @javax.annotation.Nonnull

  public String getInnerAddress() {
    return innerAddress;
  }


  public void setInnerAddress(String innerAddress) {
    this.innerAddress = innerAddress;
  }


  public DidTransferDidRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public DidTransferDidRequest withRecoveryInfo(Boolean withRecoveryInfo) {
    
    this.withRecoveryInfo = withRecoveryInfo;
    return this;
  }

   /**
   * Get withRecoveryInfo
   * @return withRecoveryInfo
  **/
  @javax.annotation.Nullable

  public Boolean getWithRecoveryInfo() {
    return withRecoveryInfo;
  }


  public void setWithRecoveryInfo(Boolean withRecoveryInfo) {
    this.withRecoveryInfo = withRecoveryInfo;
  }


  public DidTransferDidRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidTransferDidRequest didTransferDidRequest = (DidTransferDidRequest) o;
    return Objects.equals(this.walletId, didTransferDidRequest.walletId) &&
        Objects.equals(this.innerAddress, didTransferDidRequest.innerAddress) &&
        Objects.equals(this.fee, didTransferDidRequest.fee) &&
        Objects.equals(this.withRecoveryInfo, didTransferDidRequest.withRecoveryInfo) &&
        Objects.equals(this.reusePuzhash, didTransferDidRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, innerAddress, fee, withRecoveryInfo, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidTransferDidRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    innerAddress: ").append(toIndentedString(innerAddress)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    withRecoveryInfo: ").append(toIndentedString(withRecoveryInfo)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("inner_address");
    openapiFields.add("fee");
    openapiFields.add("with_recovery_info");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("inner_address");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidTransferDidRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidTransferDidRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidTransferDidRequest is not found in the empty JSON string", DidTransferDidRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidTransferDidRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidTransferDidRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DidTransferDidRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("inner_address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `inner_address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("inner_address").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidTransferDidRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidTransferDidRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidTransferDidRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidTransferDidRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<DidTransferDidRequest>() {
           @Override
           public void write(JsonWriter out, DidTransferDidRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidTransferDidRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidTransferDidRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidTransferDidRequest
  * @throws IOException if the JSON string is invalid with respect to DidTransferDidRequest
  */
  public static DidTransferDidRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidTransferDidRequest.class);
  }

 /**
  * Convert an instance of DidTransferDidRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

