/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DidUpdateRecoveryIdsRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DidUpdateRecoveryIdsRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_NEW_LIST = "new_list";
  @SerializedName(SERIALIZED_NAME_NEW_LIST)
  private List<String> newList = new ArrayList<>();

  public static final String SERIALIZED_NAME_NUM_VERIFICATIONS_REQUIRED = "num_verifications_required";
  @SerializedName(SERIALIZED_NAME_NUM_VERIFICATIONS_REQUIRED)
  private Integer numVerificationsRequired;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public DidUpdateRecoveryIdsRequest() {
  }

  public DidUpdateRecoveryIdsRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public DidUpdateRecoveryIdsRequest newList(List<String> newList) {
    
    this.newList = newList;
    return this;
  }

  public DidUpdateRecoveryIdsRequest addNewListItem(String newListItem) {
    if (this.newList == null) {
      this.newList = new ArrayList<>();
    }
    this.newList.add(newListItem);
    return this;
  }

   /**
   * Get newList
   * @return newList
  **/
  @javax.annotation.Nonnull

  public List<String> getNewList() {
    return newList;
  }


  public void setNewList(List<String> newList) {
    this.newList = newList;
  }


  public DidUpdateRecoveryIdsRequest numVerificationsRequired(Integer numVerificationsRequired) {
    
    this.numVerificationsRequired = numVerificationsRequired;
    return this;
  }

   /**
   * Get numVerificationsRequired
   * @return numVerificationsRequired
  **/
  @javax.annotation.Nullable

  public Integer getNumVerificationsRequired() {
    return numVerificationsRequired;
  }


  public void setNumVerificationsRequired(Integer numVerificationsRequired) {
    this.numVerificationsRequired = numVerificationsRequired;
  }


  public DidUpdateRecoveryIdsRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest = (DidUpdateRecoveryIdsRequest) o;
    return Objects.equals(this.walletId, didUpdateRecoveryIdsRequest.walletId) &&
        Objects.equals(this.newList, didUpdateRecoveryIdsRequest.newList) &&
        Objects.equals(this.numVerificationsRequired, didUpdateRecoveryIdsRequest.numVerificationsRequired) &&
        Objects.equals(this.reusePuzhash, didUpdateRecoveryIdsRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, newList, numVerificationsRequired, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DidUpdateRecoveryIdsRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    newList: ").append(toIndentedString(newList)).append("\n");
    sb.append("    numVerificationsRequired: ").append(toIndentedString(numVerificationsRequired)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("new_list");
    openapiFields.add("num_verifications_required");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("new_list");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DidUpdateRecoveryIdsRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DidUpdateRecoveryIdsRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DidUpdateRecoveryIdsRequest is not found in the empty JSON string", DidUpdateRecoveryIdsRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DidUpdateRecoveryIdsRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DidUpdateRecoveryIdsRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DidUpdateRecoveryIdsRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the required json array is present
      if (jsonObj.get("new_list") == null) {
        throw new IllegalArgumentException("Expected the field `linkedContent` to be an array in the JSON string but got `null`");
      } else if (!jsonObj.get("new_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `new_list` to be an array in the JSON string but got `%s`", jsonObj.get("new_list").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DidUpdateRecoveryIdsRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DidUpdateRecoveryIdsRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DidUpdateRecoveryIdsRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DidUpdateRecoveryIdsRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<DidUpdateRecoveryIdsRequest>() {
           @Override
           public void write(JsonWriter out, DidUpdateRecoveryIdsRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DidUpdateRecoveryIdsRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DidUpdateRecoveryIdsRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DidUpdateRecoveryIdsRequest
  * @throws IOException if the JSON string is invalid with respect to DidUpdateRecoveryIdsRequest
  */
  public static DidUpdateRecoveryIdsRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DidUpdateRecoveryIdsRequest.class);
  }

 /**
  * Convert an instance of DidUpdateRecoveryIdsRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

