/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.SingletonRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DlSingletonsByRoot200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DlSingletonsByRoot200ResponseAllOf {
  public static final String SERIALIZED_NAME_SINGLETON = "singleton";
  @SerializedName(SERIALIZED_NAME_SINGLETON)
  private List<SingletonRecord> singleton;

  public DlSingletonsByRoot200ResponseAllOf() {
  }

  public DlSingletonsByRoot200ResponseAllOf singleton(List<SingletonRecord> singleton) {
    
    this.singleton = singleton;
    return this;
  }

  public DlSingletonsByRoot200ResponseAllOf addSingletonItem(SingletonRecord singletonItem) {
    if (this.singleton == null) {
      this.singleton = new ArrayList<>();
    }
    this.singleton.add(singletonItem);
    return this;
  }

   /**
   * Get singleton
   * @return singleton
  **/
  @javax.annotation.Nullable

  public List<SingletonRecord> getSingleton() {
    return singleton;
  }


  public void setSingleton(List<SingletonRecord> singleton) {
    this.singleton = singleton;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DlSingletonsByRoot200ResponseAllOf dlSingletonsByRoot200ResponseAllOf = (DlSingletonsByRoot200ResponseAllOf) o;
    return Objects.equals(this.singleton, dlSingletonsByRoot200ResponseAllOf.singleton);
  }

  @Override
  public int hashCode() {
    return Objects.hash(singleton);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DlSingletonsByRoot200ResponseAllOf {\n");
    sb.append("    singleton: ").append(toIndentedString(singleton)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("singleton");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DlSingletonsByRoot200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DlSingletonsByRoot200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DlSingletonsByRoot200ResponseAllOf is not found in the empty JSON string", DlSingletonsByRoot200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DlSingletonsByRoot200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DlSingletonsByRoot200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("singleton") != null && !jsonObj.get("singleton").isJsonNull()) {
        JsonArray jsonArraysingleton = jsonObj.getAsJsonArray("singleton");
        if (jsonArraysingleton != null) {
          // ensure the json data is an array
          if (!jsonObj.get("singleton").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `singleton` to be an array in the JSON string but got `%s`", jsonObj.get("singleton").toString()));
          }

          // validate the optional field `singleton` (array)
          for (int i = 0; i < jsonArraysingleton.size(); i++) {
            SingletonRecord.validateJsonObject(jsonArraysingleton.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DlSingletonsByRoot200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DlSingletonsByRoot200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DlSingletonsByRoot200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DlSingletonsByRoot200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<DlSingletonsByRoot200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, DlSingletonsByRoot200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DlSingletonsByRoot200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DlSingletonsByRoot200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DlSingletonsByRoot200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to DlSingletonsByRoot200ResponseAllOf
  */
  public static DlSingletonsByRoot200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DlSingletonsByRoot200ResponseAllOf.class);
  }

 /**
  * Convert an instance of DlSingletonsByRoot200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

