/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DlUpdateMultipleRequestUpdatesInner
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DlUpdateMultipleRequestUpdatesInner {
  public static final String SERIALIZED_NAME_ROOT = "root";
  @SerializedName(SERIALIZED_NAME_ROOT)
  private String root;

  public static final String SERIALIZED_NAME_LAUNCHER = "launcher";
  @SerializedName(SERIALIZED_NAME_LAUNCHER)
  private String launcher;

  public DlUpdateMultipleRequestUpdatesInner() {
  }

  public DlUpdateMultipleRequestUpdatesInner root(String root) {
    
    this.root = root;
    return this;
  }

   /**
   * Get root
   * @return root
  **/
  @javax.annotation.Nonnull

  public String getRoot() {
    return root;
  }


  public void setRoot(String root) {
    this.root = root;
  }


  public DlUpdateMultipleRequestUpdatesInner launcher(String launcher) {
    
    this.launcher = launcher;
    return this;
  }

   /**
   * Get launcher
   * @return launcher
  **/
  @javax.annotation.Nonnull

  public String getLauncher() {
    return launcher;
  }


  public void setLauncher(String launcher) {
    this.launcher = launcher;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DlUpdateMultipleRequestUpdatesInner dlUpdateMultipleRequestUpdatesInner = (DlUpdateMultipleRequestUpdatesInner) o;
    return Objects.equals(this.root, dlUpdateMultipleRequestUpdatesInner.root) &&
        Objects.equals(this.launcher, dlUpdateMultipleRequestUpdatesInner.launcher);
  }

  @Override
  public int hashCode() {
    return Objects.hash(root, launcher);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DlUpdateMultipleRequestUpdatesInner {\n");
    sb.append("    root: ").append(toIndentedString(root)).append("\n");
    sb.append("    launcher: ").append(toIndentedString(launcher)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("root");
    openapiFields.add("launcher");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("root");
    openapiRequiredFields.add("launcher");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DlUpdateMultipleRequestUpdatesInner
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DlUpdateMultipleRequestUpdatesInner.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DlUpdateMultipleRequestUpdatesInner is not found in the empty JSON string", DlUpdateMultipleRequestUpdatesInner.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DlUpdateMultipleRequestUpdatesInner.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DlUpdateMultipleRequestUpdatesInner` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DlUpdateMultipleRequestUpdatesInner.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("root").toString()));
      }
      if (!jsonObj.get("launcher").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DlUpdateMultipleRequestUpdatesInner.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DlUpdateMultipleRequestUpdatesInner' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DlUpdateMultipleRequestUpdatesInner> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DlUpdateMultipleRequestUpdatesInner.class));

       return (TypeAdapter<T>) new TypeAdapter<DlUpdateMultipleRequestUpdatesInner>() {
           @Override
           public void write(JsonWriter out, DlUpdateMultipleRequestUpdatesInner value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DlUpdateMultipleRequestUpdatesInner read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DlUpdateMultipleRequestUpdatesInner given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DlUpdateMultipleRequestUpdatesInner
  * @throws IOException if the JSON string is invalid with respect to DlUpdateMultipleRequestUpdatesInner
  */
  public static DlUpdateMultipleRequestUpdatesInner fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DlUpdateMultipleRequestUpdatesInner.class);
  }

 /**
  * Convert an instance of DlUpdateMultipleRequestUpdatesInner to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

