/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.TransactionRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DlUpdateRoot200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DlUpdateRoot200ResponseAllOf {
  public static final String SERIALIZED_NAME_TX_RECORD = "tx_record";
  @SerializedName(SERIALIZED_NAME_TX_RECORD)
  private TransactionRecord txRecord;

  public DlUpdateRoot200ResponseAllOf() {
  }

  public DlUpdateRoot200ResponseAllOf txRecord(TransactionRecord txRecord) {
    
    this.txRecord = txRecord;
    return this;
  }

   /**
   * Get txRecord
   * @return txRecord
  **/
  @javax.annotation.Nullable

  public TransactionRecord getTxRecord() {
    return txRecord;
  }


  public void setTxRecord(TransactionRecord txRecord) {
    this.txRecord = txRecord;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DlUpdateRoot200ResponseAllOf dlUpdateRoot200ResponseAllOf = (DlUpdateRoot200ResponseAllOf) o;
    return Objects.equals(this.txRecord, dlUpdateRoot200ResponseAllOf.txRecord);
  }

  @Override
  public int hashCode() {
    return Objects.hash(txRecord);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DlUpdateRoot200ResponseAllOf {\n");
    sb.append("    txRecord: ").append(toIndentedString(txRecord)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("tx_record");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DlUpdateRoot200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DlUpdateRoot200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DlUpdateRoot200ResponseAllOf is not found in the empty JSON string", DlUpdateRoot200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DlUpdateRoot200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DlUpdateRoot200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `tx_record`
      if (jsonObj.get("tx_record") != null && !jsonObj.get("tx_record").isJsonNull()) {
        TransactionRecord.validateJsonObject(jsonObj.getAsJsonObject("tx_record"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DlUpdateRoot200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DlUpdateRoot200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DlUpdateRoot200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DlUpdateRoot200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<DlUpdateRoot200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, DlUpdateRoot200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DlUpdateRoot200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DlUpdateRoot200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DlUpdateRoot200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to DlUpdateRoot200ResponseAllOf
  */
  public static DlUpdateRoot200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DlUpdateRoot200ResponseAllOf.class);
  }

 /**
  * Convert an instance of DlUpdateRoot200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

