/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * DlUpdateRootRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class DlUpdateRootRequest {
  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_NEW_ROOT = "new_root";
  @SerializedName(SERIALIZED_NAME_NEW_ROOT)
  private String newRoot;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public DlUpdateRootRequest() {
  }

  public DlUpdateRootRequest launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nonnull

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public DlUpdateRootRequest newRoot(String newRoot) {
    
    this.newRoot = newRoot;
    return this;
  }

   /**
   * Get newRoot
   * @return newRoot
  **/
  @javax.annotation.Nonnull

  public String getNewRoot() {
    return newRoot;
  }


  public void setNewRoot(String newRoot) {
    this.newRoot = newRoot;
  }


  public DlUpdateRootRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DlUpdateRootRequest dlUpdateRootRequest = (DlUpdateRootRequest) o;
    return Objects.equals(this.launcherId, dlUpdateRootRequest.launcherId) &&
        Objects.equals(this.newRoot, dlUpdateRootRequest.newRoot) &&
        Objects.equals(this.fee, dlUpdateRootRequest.fee);
  }

  @Override
  public int hashCode() {
    return Objects.hash(launcherId, newRoot, fee);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DlUpdateRootRequest {\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    newRoot: ").append(toIndentedString(newRoot)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("launcher_id");
    openapiFields.add("new_root");
    openapiFields.add("fee");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("launcher_id");
    openapiRequiredFields.add("new_root");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to DlUpdateRootRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!DlUpdateRootRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in DlUpdateRootRequest is not found in the empty JSON string", DlUpdateRootRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!DlUpdateRootRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `DlUpdateRootRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : DlUpdateRootRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if (!jsonObj.get("new_root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `new_root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("new_root").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!DlUpdateRootRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'DlUpdateRootRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<DlUpdateRootRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(DlUpdateRootRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<DlUpdateRootRequest>() {
           @Override
           public void write(JsonWriter out, DlUpdateRootRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public DlUpdateRootRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of DlUpdateRootRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of DlUpdateRootRequest
  * @throws IOException if the JSON string is invalid with respect to DlUpdateRootRequest
  */
  public static DlUpdateRootRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, DlUpdateRootRequest.class);
  }

 /**
  * Convert an instance of DlUpdateRootRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

