/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * FarmerRewards
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class FarmerRewards {
  public static final String SERIALIZED_NAME_FARMED_AMOUNT = "farmed_amount";
  @SerializedName(SERIALIZED_NAME_FARMED_AMOUNT)
  private Integer farmedAmount;

  public static final String SERIALIZED_NAME_POOL_REWARD_AMOUNT = "pool_reward_amount";
  @SerializedName(SERIALIZED_NAME_POOL_REWARD_AMOUNT)
  private Integer poolRewardAmount;

  public static final String SERIALIZED_NAME_FARMER_REWARD_AMOUNT = "farmer_reward_amount";
  @SerializedName(SERIALIZED_NAME_FARMER_REWARD_AMOUNT)
  private Integer farmerRewardAmount;

  public static final String SERIALIZED_NAME_FEE_AMOUNT = "fee_amount";
  @SerializedName(SERIALIZED_NAME_FEE_AMOUNT)
  private Integer feeAmount;

  public static final String SERIALIZED_NAME_LAST_HEIGHT_FARMED = "last_height_farmed";
  @SerializedName(SERIALIZED_NAME_LAST_HEIGHT_FARMED)
  private Integer lastHeightFarmed;

  public FarmerRewards() {
  }

  public FarmerRewards farmedAmount(Integer farmedAmount) {
    
    this.farmedAmount = farmedAmount;
    return this;
  }

   /**
   * Get farmedAmount
   * @return farmedAmount
  **/
  @javax.annotation.Nullable

  public Integer getFarmedAmount() {
    return farmedAmount;
  }


  public void setFarmedAmount(Integer farmedAmount) {
    this.farmedAmount = farmedAmount;
  }


  public FarmerRewards poolRewardAmount(Integer poolRewardAmount) {
    
    this.poolRewardAmount = poolRewardAmount;
    return this;
  }

   /**
   * Get poolRewardAmount
   * @return poolRewardAmount
  **/
  @javax.annotation.Nullable

  public Integer getPoolRewardAmount() {
    return poolRewardAmount;
  }


  public void setPoolRewardAmount(Integer poolRewardAmount) {
    this.poolRewardAmount = poolRewardAmount;
  }


  public FarmerRewards farmerRewardAmount(Integer farmerRewardAmount) {
    
    this.farmerRewardAmount = farmerRewardAmount;
    return this;
  }

   /**
   * Get farmerRewardAmount
   * @return farmerRewardAmount
  **/
  @javax.annotation.Nullable

  public Integer getFarmerRewardAmount() {
    return farmerRewardAmount;
  }


  public void setFarmerRewardAmount(Integer farmerRewardAmount) {
    this.farmerRewardAmount = farmerRewardAmount;
  }


  public FarmerRewards feeAmount(Integer feeAmount) {
    
    this.feeAmount = feeAmount;
    return this;
  }

   /**
   * Get feeAmount
   * @return feeAmount
  **/
  @javax.annotation.Nullable

  public Integer getFeeAmount() {
    return feeAmount;
  }


  public void setFeeAmount(Integer feeAmount) {
    this.feeAmount = feeAmount;
  }


  public FarmerRewards lastHeightFarmed(Integer lastHeightFarmed) {
    
    this.lastHeightFarmed = lastHeightFarmed;
    return this;
  }

   /**
   * Get lastHeightFarmed
   * @return lastHeightFarmed
  **/
  @javax.annotation.Nullable

  public Integer getLastHeightFarmed() {
    return lastHeightFarmed;
  }


  public void setLastHeightFarmed(Integer lastHeightFarmed) {
    this.lastHeightFarmed = lastHeightFarmed;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FarmerRewards farmerRewards = (FarmerRewards) o;
    return Objects.equals(this.farmedAmount, farmerRewards.farmedAmount) &&
        Objects.equals(this.poolRewardAmount, farmerRewards.poolRewardAmount) &&
        Objects.equals(this.farmerRewardAmount, farmerRewards.farmerRewardAmount) &&
        Objects.equals(this.feeAmount, farmerRewards.feeAmount) &&
        Objects.equals(this.lastHeightFarmed, farmerRewards.lastHeightFarmed);
  }

  @Override
  public int hashCode() {
    return Objects.hash(farmedAmount, poolRewardAmount, farmerRewardAmount, feeAmount, lastHeightFarmed);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FarmerRewards {\n");
    sb.append("    farmedAmount: ").append(toIndentedString(farmedAmount)).append("\n");
    sb.append("    poolRewardAmount: ").append(toIndentedString(poolRewardAmount)).append("\n");
    sb.append("    farmerRewardAmount: ").append(toIndentedString(farmerRewardAmount)).append("\n");
    sb.append("    feeAmount: ").append(toIndentedString(feeAmount)).append("\n");
    sb.append("    lastHeightFarmed: ").append(toIndentedString(lastHeightFarmed)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("farmed_amount");
    openapiFields.add("pool_reward_amount");
    openapiFields.add("farmer_reward_amount");
    openapiFields.add("fee_amount");
    openapiFields.add("last_height_farmed");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to FarmerRewards
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!FarmerRewards.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in FarmerRewards is not found in the empty JSON string", FarmerRewards.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!FarmerRewards.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `FarmerRewards` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!FarmerRewards.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'FarmerRewards' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<FarmerRewards> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(FarmerRewards.class));

       return (TypeAdapter<T>) new TypeAdapter<FarmerRewards>() {
           @Override
           public void write(JsonWriter out, FarmerRewards value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public FarmerRewards read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of FarmerRewards given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of FarmerRewards
  * @throws IOException if the JSON string is invalid with respect to FarmerRewards
  */
  public static FarmerRewards fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, FarmerRewards.class);
  }

 /**
  * Convert an instance of FarmerRewards to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

