/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.TradeRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetAllOffers200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetAllOffers200ResponseAllOf {
  public static final String SERIALIZED_NAME_TRADE_RECORDS = "trade_records";
  @SerializedName(SERIALIZED_NAME_TRADE_RECORDS)
  private List<TradeRecord> tradeRecords;

  public static final String SERIALIZED_NAME_OFFERS = "offers";
  @SerializedName(SERIALIZED_NAME_OFFERS)
  private List<String> offers;

  public GetAllOffers200ResponseAllOf() {
  }

  public GetAllOffers200ResponseAllOf tradeRecords(List<TradeRecord> tradeRecords) {
    
    this.tradeRecords = tradeRecords;
    return this;
  }

  public GetAllOffers200ResponseAllOf addTradeRecordsItem(TradeRecord tradeRecordsItem) {
    if (this.tradeRecords == null) {
      this.tradeRecords = new ArrayList<>();
    }
    this.tradeRecords.add(tradeRecordsItem);
    return this;
  }

   /**
   * Get tradeRecords
   * @return tradeRecords
  **/
  @javax.annotation.Nullable

  public List<TradeRecord> getTradeRecords() {
    return tradeRecords;
  }


  public void setTradeRecords(List<TradeRecord> tradeRecords) {
    this.tradeRecords = tradeRecords;
  }


  public GetAllOffers200ResponseAllOf offers(List<String> offers) {
    
    this.offers = offers;
    return this;
  }

  public GetAllOffers200ResponseAllOf addOffersItem(String offersItem) {
    if (this.offers == null) {
      this.offers = new ArrayList<>();
    }
    this.offers.add(offersItem);
    return this;
  }

   /**
   * Get offers
   * @return offers
  **/
  @javax.annotation.Nullable

  public List<String> getOffers() {
    return offers;
  }


  public void setOffers(List<String> offers) {
    this.offers = offers;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAllOffers200ResponseAllOf getAllOffers200ResponseAllOf = (GetAllOffers200ResponseAllOf) o;
    return Objects.equals(this.tradeRecords, getAllOffers200ResponseAllOf.tradeRecords) &&
        Objects.equals(this.offers, getAllOffers200ResponseAllOf.offers);
  }

  @Override
  public int hashCode() {
    return Objects.hash(tradeRecords, offers);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAllOffers200ResponseAllOf {\n");
    sb.append("    tradeRecords: ").append(toIndentedString(tradeRecords)).append("\n");
    sb.append("    offers: ").append(toIndentedString(offers)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("trade_records");
    openapiFields.add("offers");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetAllOffers200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetAllOffers200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetAllOffers200ResponseAllOf is not found in the empty JSON string", GetAllOffers200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetAllOffers200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetAllOffers200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("trade_records") != null && !jsonObj.get("trade_records").isJsonNull()) {
        JsonArray jsonArraytradeRecords = jsonObj.getAsJsonArray("trade_records");
        if (jsonArraytradeRecords != null) {
          // ensure the json data is an array
          if (!jsonObj.get("trade_records").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `trade_records` to be an array in the JSON string but got `%s`", jsonObj.get("trade_records").toString()));
          }

          // validate the optional field `trade_records` (array)
          for (int i = 0; i < jsonArraytradeRecords.size(); i++) {
            TradeRecord.validateJsonObject(jsonArraytradeRecords.get(i).getAsJsonObject());
          };
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("offers") != null && !jsonObj.get("offers").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `offers` to be an array in the JSON string but got `%s`", jsonObj.get("offers").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetAllOffers200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetAllOffers200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetAllOffers200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetAllOffers200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetAllOffers200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetAllOffers200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetAllOffers200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetAllOffers200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetAllOffers200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetAllOffers200ResponseAllOf
  */
  public static GetAllOffers200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetAllOffers200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetAllOffers200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

