/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetAllOffersRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetAllOffersRequest {
  public static final String SERIALIZED_NAME_START = "start";
  @SerializedName(SERIALIZED_NAME_START)
  private Integer start = 0;

  public static final String SERIALIZED_NAME_END = "end";
  @SerializedName(SERIALIZED_NAME_END)
  private Integer end = 10;

  public static final String SERIALIZED_NAME_EXCLUDE_MY_OFFERS = "exclude_my_offers";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_MY_OFFERS)
  private Boolean excludeMyOffers;

  public static final String SERIALIZED_NAME_EXCLUDE_TAKEN_OFFERS = "exclude_taken_offers";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_TAKEN_OFFERS)
  private Boolean excludeTakenOffers;

  public static final String SERIALIZED_NAME_INCLUDE_COMPLETED = "include_completed";
  @SerializedName(SERIALIZED_NAME_INCLUDE_COMPLETED)
  private Boolean includeCompleted;

  public static final String SERIALIZED_NAME_SORT_KEY = "sort_key";
  @SerializedName(SERIALIZED_NAME_SORT_KEY)
  private String sortKey;

  public static final String SERIALIZED_NAME_REVERSE = "reverse";
  @SerializedName(SERIALIZED_NAME_REVERSE)
  private Boolean reverse;

  public static final String SERIALIZED_NAME_FILE_CONTENTS = "file_contents";
  @SerializedName(SERIALIZED_NAME_FILE_CONTENTS)
  private Boolean fileContents;

  public GetAllOffersRequest() {
  }

  public GetAllOffersRequest start(Integer start) {
    
    this.start = start;
    return this;
  }

   /**
   * Get start
   * @return start
  **/
  @javax.annotation.Nullable

  public Integer getStart() {
    return start;
  }


  public void setStart(Integer start) {
    this.start = start;
  }


  public GetAllOffersRequest end(Integer end) {
    
    this.end = end;
    return this;
  }

   /**
   * Get end
   * @return end
  **/
  @javax.annotation.Nullable

  public Integer getEnd() {
    return end;
  }


  public void setEnd(Integer end) {
    this.end = end;
  }


  public GetAllOffersRequest excludeMyOffers(Boolean excludeMyOffers) {
    
    this.excludeMyOffers = excludeMyOffers;
    return this;
  }

   /**
   * Get excludeMyOffers
   * @return excludeMyOffers
  **/
  @javax.annotation.Nullable

  public Boolean getExcludeMyOffers() {
    return excludeMyOffers;
  }


  public void setExcludeMyOffers(Boolean excludeMyOffers) {
    this.excludeMyOffers = excludeMyOffers;
  }


  public GetAllOffersRequest excludeTakenOffers(Boolean excludeTakenOffers) {
    
    this.excludeTakenOffers = excludeTakenOffers;
    return this;
  }

   /**
   * Get excludeTakenOffers
   * @return excludeTakenOffers
  **/
  @javax.annotation.Nullable

  public Boolean getExcludeTakenOffers() {
    return excludeTakenOffers;
  }


  public void setExcludeTakenOffers(Boolean excludeTakenOffers) {
    this.excludeTakenOffers = excludeTakenOffers;
  }


  public GetAllOffersRequest includeCompleted(Boolean includeCompleted) {
    
    this.includeCompleted = includeCompleted;
    return this;
  }

   /**
   * Get includeCompleted
   * @return includeCompleted
  **/
  @javax.annotation.Nullable

  public Boolean getIncludeCompleted() {
    return includeCompleted;
  }


  public void setIncludeCompleted(Boolean includeCompleted) {
    this.includeCompleted = includeCompleted;
  }


  public GetAllOffersRequest sortKey(String sortKey) {
    
    this.sortKey = sortKey;
    return this;
  }

   /**
   * Get sortKey
   * @return sortKey
  **/
  @javax.annotation.Nullable

  public String getSortKey() {
    return sortKey;
  }


  public void setSortKey(String sortKey) {
    this.sortKey = sortKey;
  }


  public GetAllOffersRequest reverse(Boolean reverse) {
    
    this.reverse = reverse;
    return this;
  }

   /**
   * Get reverse
   * @return reverse
  **/
  @javax.annotation.Nullable

  public Boolean getReverse() {
    return reverse;
  }


  public void setReverse(Boolean reverse) {
    this.reverse = reverse;
  }


  public GetAllOffersRequest fileContents(Boolean fileContents) {
    
    this.fileContents = fileContents;
    return this;
  }

   /**
   * Get fileContents
   * @return fileContents
  **/
  @javax.annotation.Nullable

  public Boolean getFileContents() {
    return fileContents;
  }


  public void setFileContents(Boolean fileContents) {
    this.fileContents = fileContents;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAllOffersRequest getAllOffersRequest = (GetAllOffersRequest) o;
    return Objects.equals(this.start, getAllOffersRequest.start) &&
        Objects.equals(this.end, getAllOffersRequest.end) &&
        Objects.equals(this.excludeMyOffers, getAllOffersRequest.excludeMyOffers) &&
        Objects.equals(this.excludeTakenOffers, getAllOffersRequest.excludeTakenOffers) &&
        Objects.equals(this.includeCompleted, getAllOffersRequest.includeCompleted) &&
        Objects.equals(this.sortKey, getAllOffersRequest.sortKey) &&
        Objects.equals(this.reverse, getAllOffersRequest.reverse) &&
        Objects.equals(this.fileContents, getAllOffersRequest.fileContents);
  }

  @Override
  public int hashCode() {
    return Objects.hash(start, end, excludeMyOffers, excludeTakenOffers, includeCompleted, sortKey, reverse, fileContents);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAllOffersRequest {\n");
    sb.append("    start: ").append(toIndentedString(start)).append("\n");
    sb.append("    end: ").append(toIndentedString(end)).append("\n");
    sb.append("    excludeMyOffers: ").append(toIndentedString(excludeMyOffers)).append("\n");
    sb.append("    excludeTakenOffers: ").append(toIndentedString(excludeTakenOffers)).append("\n");
    sb.append("    includeCompleted: ").append(toIndentedString(includeCompleted)).append("\n");
    sb.append("    sortKey: ").append(toIndentedString(sortKey)).append("\n");
    sb.append("    reverse: ").append(toIndentedString(reverse)).append("\n");
    sb.append("    fileContents: ").append(toIndentedString(fileContents)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("start");
    openapiFields.add("end");
    openapiFields.add("exclude_my_offers");
    openapiFields.add("exclude_taken_offers");
    openapiFields.add("include_completed");
    openapiFields.add("sort_key");
    openapiFields.add("reverse");
    openapiFields.add("file_contents");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetAllOffersRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetAllOffersRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetAllOffersRequest is not found in the empty JSON string", GetAllOffersRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetAllOffersRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetAllOffersRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("sort_key") != null && !jsonObj.get("sort_key").isJsonNull()) && !jsonObj.get("sort_key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `sort_key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("sort_key").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetAllOffersRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetAllOffersRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetAllOffersRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetAllOffersRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetAllOffersRequest>() {
           @Override
           public void write(JsonWriter out, GetAllOffersRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetAllOffersRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetAllOffersRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetAllOffersRequest
  * @throws IOException if the JSON string is invalid with respect to GetAllOffersRequest
  */
  public static GetAllOffersRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetAllOffersRequest.class);
  }

 /**
  * Convert an instance of GetAllOffersRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

