/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetFarmedAmount200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetFarmedAmount200Response {
  public static final String SERIALIZED_NAME_FARMED_AMOUNT = "farmed_amount";
  @SerializedName(SERIALIZED_NAME_FARMED_AMOUNT)
  private Integer farmedAmount;

  public static final String SERIALIZED_NAME_POOL_REWARD_AMOUNT = "pool_reward_amount";
  @SerializedName(SERIALIZED_NAME_POOL_REWARD_AMOUNT)
  private Integer poolRewardAmount;

  public static final String SERIALIZED_NAME_FARMER_REWARD_AMOUNT = "farmer_reward_amount";
  @SerializedName(SERIALIZED_NAME_FARMER_REWARD_AMOUNT)
  private Integer farmerRewardAmount;

  public static final String SERIALIZED_NAME_FEE_AMOUNT = "fee_amount";
  @SerializedName(SERIALIZED_NAME_FEE_AMOUNT)
  private Integer feeAmount;

  public static final String SERIALIZED_NAME_LAST_HEIGHT_FARMED = "last_height_farmed";
  @SerializedName(SERIALIZED_NAME_LAST_HEIGHT_FARMED)
  private Integer lastHeightFarmed;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetFarmedAmount200Response() {
  }

  public GetFarmedAmount200Response farmedAmount(Integer farmedAmount) {
    
    this.farmedAmount = farmedAmount;
    return this;
  }

   /**
   * Get farmedAmount
   * @return farmedAmount
  **/
  @javax.annotation.Nullable

  public Integer getFarmedAmount() {
    return farmedAmount;
  }


  public void setFarmedAmount(Integer farmedAmount) {
    this.farmedAmount = farmedAmount;
  }


  public GetFarmedAmount200Response poolRewardAmount(Integer poolRewardAmount) {
    
    this.poolRewardAmount = poolRewardAmount;
    return this;
  }

   /**
   * Get poolRewardAmount
   * @return poolRewardAmount
  **/
  @javax.annotation.Nullable

  public Integer getPoolRewardAmount() {
    return poolRewardAmount;
  }


  public void setPoolRewardAmount(Integer poolRewardAmount) {
    this.poolRewardAmount = poolRewardAmount;
  }


  public GetFarmedAmount200Response farmerRewardAmount(Integer farmerRewardAmount) {
    
    this.farmerRewardAmount = farmerRewardAmount;
    return this;
  }

   /**
   * Get farmerRewardAmount
   * @return farmerRewardAmount
  **/
  @javax.annotation.Nullable

  public Integer getFarmerRewardAmount() {
    return farmerRewardAmount;
  }


  public void setFarmerRewardAmount(Integer farmerRewardAmount) {
    this.farmerRewardAmount = farmerRewardAmount;
  }


  public GetFarmedAmount200Response feeAmount(Integer feeAmount) {
    
    this.feeAmount = feeAmount;
    return this;
  }

   /**
   * Get feeAmount
   * @return feeAmount
  **/
  @javax.annotation.Nullable

  public Integer getFeeAmount() {
    return feeAmount;
  }


  public void setFeeAmount(Integer feeAmount) {
    this.feeAmount = feeAmount;
  }


  public GetFarmedAmount200Response lastHeightFarmed(Integer lastHeightFarmed) {
    
    this.lastHeightFarmed = lastHeightFarmed;
    return this;
  }

   /**
   * Get lastHeightFarmed
   * @return lastHeightFarmed
  **/
  @javax.annotation.Nullable

  public Integer getLastHeightFarmed() {
    return lastHeightFarmed;
  }


  public void setLastHeightFarmed(Integer lastHeightFarmed) {
    this.lastHeightFarmed = lastHeightFarmed;
  }


  public GetFarmedAmount200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetFarmedAmount200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetFarmedAmount200Response getFarmedAmount200Response = (GetFarmedAmount200Response) o;
    return Objects.equals(this.farmedAmount, getFarmedAmount200Response.farmedAmount) &&
        Objects.equals(this.poolRewardAmount, getFarmedAmount200Response.poolRewardAmount) &&
        Objects.equals(this.farmerRewardAmount, getFarmedAmount200Response.farmerRewardAmount) &&
        Objects.equals(this.feeAmount, getFarmedAmount200Response.feeAmount) &&
        Objects.equals(this.lastHeightFarmed, getFarmedAmount200Response.lastHeightFarmed) &&
        Objects.equals(this.success, getFarmedAmount200Response.success) &&
        Objects.equals(this.error, getFarmedAmount200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(farmedAmount, poolRewardAmount, farmerRewardAmount, feeAmount, lastHeightFarmed, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetFarmedAmount200Response {\n");
    sb.append("    farmedAmount: ").append(toIndentedString(farmedAmount)).append("\n");
    sb.append("    poolRewardAmount: ").append(toIndentedString(poolRewardAmount)).append("\n");
    sb.append("    farmerRewardAmount: ").append(toIndentedString(farmerRewardAmount)).append("\n");
    sb.append("    feeAmount: ").append(toIndentedString(feeAmount)).append("\n");
    sb.append("    lastHeightFarmed: ").append(toIndentedString(lastHeightFarmed)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("farmed_amount");
    openapiFields.add("pool_reward_amount");
    openapiFields.add("farmer_reward_amount");
    openapiFields.add("fee_amount");
    openapiFields.add("last_height_farmed");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetFarmedAmount200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetFarmedAmount200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetFarmedAmount200Response is not found in the empty JSON string", GetFarmedAmount200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetFarmedAmount200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetFarmedAmount200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetFarmedAmount200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetFarmedAmount200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetFarmedAmount200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetFarmedAmount200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetFarmedAmount200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetFarmedAmount200Response>() {
           @Override
           public void write(JsonWriter out, GetFarmedAmount200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetFarmedAmount200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetFarmedAmount200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetFarmedAmount200Response
  * @throws IOException if the JSON string is invalid with respect to GetFarmedAmount200Response
  */
  public static GetFarmedAmount200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetFarmedAmount200Response.class);
  }

 /**
  * Convert an instance of GetFarmedAmount200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

