/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.GetOfferSummary200ResponseAllOfOneOf1Summary;
import org.openapitools.client.model.GetOfferSummary200ResponseAllOfOneOfOfferedInner;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOfferSummary200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOfferSummary200Response {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_OFFERED = "offered";
  @SerializedName(SERIALIZED_NAME_OFFERED)
  private List<GetOfferSummary200ResponseAllOfOneOfOfferedInner> offered;

  public static final String SERIALIZED_NAME_SUMMARY = "summary";
  @SerializedName(SERIALIZED_NAME_SUMMARY)
  private GetOfferSummary200ResponseAllOfOneOf1Summary summary;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetOfferSummary200Response() {
  }

  public GetOfferSummary200Response id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public GetOfferSummary200Response offered(List<GetOfferSummary200ResponseAllOfOneOfOfferedInner> offered) {
    
    this.offered = offered;
    return this;
  }

  public GetOfferSummary200Response addOfferedItem(GetOfferSummary200ResponseAllOfOneOfOfferedInner offeredItem) {
    if (this.offered == null) {
      this.offered = new ArrayList<>();
    }
    this.offered.add(offeredItem);
    return this;
  }

   /**
   * Get offered
   * @return offered
  **/
  @javax.annotation.Nullable

  public List<GetOfferSummary200ResponseAllOfOneOfOfferedInner> getOffered() {
    return offered;
  }


  public void setOffered(List<GetOfferSummary200ResponseAllOfOneOfOfferedInner> offered) {
    this.offered = offered;
  }


  public GetOfferSummary200Response summary(GetOfferSummary200ResponseAllOfOneOf1Summary summary) {
    
    this.summary = summary;
    return this;
  }

   /**
   * Get summary
   * @return summary
  **/
  @javax.annotation.Nullable

  public GetOfferSummary200ResponseAllOfOneOf1Summary getSummary() {
    return summary;
  }


  public void setSummary(GetOfferSummary200ResponseAllOfOneOf1Summary summary) {
    this.summary = summary;
  }


  public GetOfferSummary200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetOfferSummary200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOfferSummary200Response getOfferSummary200Response = (GetOfferSummary200Response) o;
    return Objects.equals(this.id, getOfferSummary200Response.id) &&
        Objects.equals(this.offered, getOfferSummary200Response.offered) &&
        Objects.equals(this.summary, getOfferSummary200Response.summary) &&
        Objects.equals(this.success, getOfferSummary200Response.success) &&
        Objects.equals(this.error, getOfferSummary200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, offered, summary, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOfferSummary200Response {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    offered: ").append(toIndentedString(offered)).append("\n");
    sb.append("    summary: ").append(toIndentedString(summary)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("id");
    openapiFields.add("offered");
    openapiFields.add("summary");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOfferSummary200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOfferSummary200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOfferSummary200Response is not found in the empty JSON string", GetOfferSummary200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOfferSummary200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOfferSummary200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetOfferSummary200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("id") != null && !jsonObj.get("id").isJsonNull()) && !jsonObj.get("id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("id").toString()));
      }
      if (jsonObj.get("offered") != null && !jsonObj.get("offered").isJsonNull()) {
        JsonArray jsonArrayoffered = jsonObj.getAsJsonArray("offered");
        if (jsonArrayoffered != null) {
          // ensure the json data is an array
          if (!jsonObj.get("offered").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `offered` to be an array in the JSON string but got `%s`", jsonObj.get("offered").toString()));
          }

          // validate the optional field `offered` (array)
          for (int i = 0; i < jsonArrayoffered.size(); i++) {
            GetOfferSummary200ResponseAllOfOneOfOfferedInner.validateJsonObject(jsonArrayoffered.get(i).getAsJsonObject());
          };
        }
      }
      // validate the optional field `summary`
      if (jsonObj.get("summary") != null && !jsonObj.get("summary").isJsonNull()) {
        GetOfferSummary200ResponseAllOfOneOf1Summary.validateJsonObject(jsonObj.getAsJsonObject("summary"));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOfferSummary200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOfferSummary200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOfferSummary200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOfferSummary200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOfferSummary200Response>() {
           @Override
           public void write(JsonWriter out, GetOfferSummary200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOfferSummary200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOfferSummary200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOfferSummary200Response
  * @throws IOException if the JSON string is invalid with respect to GetOfferSummary200Response
  */
  public static GetOfferSummary200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOfferSummary200Response.class);
  }

 /**
  * Convert an instance of GetOfferSummary200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

