/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.GetOfferSummary200ResponseAllOfOneOf1Summary;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOfferSummary200ResponseAllOfOneOf1
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOfferSummary200ResponseAllOfOneOf1 {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_SUMMARY = "summary";
  @SerializedName(SERIALIZED_NAME_SUMMARY)
  private GetOfferSummary200ResponseAllOfOneOf1Summary summary;

  public GetOfferSummary200ResponseAllOfOneOf1() {
  }

  public GetOfferSummary200ResponseAllOfOneOf1 id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @javax.annotation.Nullable

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public GetOfferSummary200ResponseAllOfOneOf1 summary(GetOfferSummary200ResponseAllOfOneOf1Summary summary) {
    
    this.summary = summary;
    return this;
  }

   /**
   * Get summary
   * @return summary
  **/
  @javax.annotation.Nullable

  public GetOfferSummary200ResponseAllOfOneOf1Summary getSummary() {
    return summary;
  }


  public void setSummary(GetOfferSummary200ResponseAllOfOneOf1Summary summary) {
    this.summary = summary;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOfferSummary200ResponseAllOfOneOf1 getOfferSummary200ResponseAllOfOneOf1 = (GetOfferSummary200ResponseAllOfOneOf1) o;
    return Objects.equals(this.id, getOfferSummary200ResponseAllOfOneOf1.id) &&
        Objects.equals(this.summary, getOfferSummary200ResponseAllOfOneOf1.summary);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, summary);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOfferSummary200ResponseAllOfOneOf1 {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    summary: ").append(toIndentedString(summary)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("id");
    openapiFields.add("summary");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOfferSummary200ResponseAllOfOneOf1
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOfferSummary200ResponseAllOfOneOf1.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOfferSummary200ResponseAllOfOneOf1 is not found in the empty JSON string", GetOfferSummary200ResponseAllOfOneOf1.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOfferSummary200ResponseAllOfOneOf1.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOfferSummary200ResponseAllOfOneOf1` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("id") != null && !jsonObj.get("id").isJsonNull()) && !jsonObj.get("id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("id").toString()));
      }
      // validate the optional field `summary`
      if (jsonObj.get("summary") != null && !jsonObj.get("summary").isJsonNull()) {
        GetOfferSummary200ResponseAllOfOneOf1Summary.validateJsonObject(jsonObj.getAsJsonObject("summary"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOfferSummary200ResponseAllOfOneOf1.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOfferSummary200ResponseAllOfOneOf1' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOfferSummary200ResponseAllOfOneOf1> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOfferSummary200ResponseAllOfOneOf1.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOfferSummary200ResponseAllOfOneOf1>() {
           @Override
           public void write(JsonWriter out, GetOfferSummary200ResponseAllOfOneOf1 value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOfferSummary200ResponseAllOfOneOf1 read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOfferSummary200ResponseAllOfOneOf1 given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOfferSummary200ResponseAllOfOneOf1
  * @throws IOException if the JSON string is invalid with respect to GetOfferSummary200ResponseAllOfOneOf1
  */
  public static GetOfferSummary200ResponseAllOfOneOf1 fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOfferSummary200ResponseAllOfOneOf1.class);
  }

 /**
  * Convert an instance of GetOfferSummary200ResponseAllOfOneOf1 to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

