/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOfferSummary200ResponseAllOfOneOf1Summary
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOfferSummary200ResponseAllOfOneOf1Summary {
  public static final String SERIALIZED_NAME_OFFERED = "offered";
  @SerializedName(SERIALIZED_NAME_OFFERED)
  private Map<String, Integer> offered = new HashMap<>();

  public static final String SERIALIZED_NAME_REQUESTED = "requested";
  @SerializedName(SERIALIZED_NAME_REQUESTED)
  private Map<String, Integer> requested = new HashMap<>();

  public static final String SERIALIZED_NAME_FEES = "fees";
  @SerializedName(SERIALIZED_NAME_FEES)
  private Integer fees;

  public static final String SERIALIZED_NAME_INFOS = "infos";
  @SerializedName(SERIALIZED_NAME_INFOS)
  private Map<String, Map<String, Object>> infos = new HashMap<>();

  public GetOfferSummary200ResponseAllOfOneOf1Summary() {
  }

  public GetOfferSummary200ResponseAllOfOneOf1Summary offered(Map<String, Integer> offered) {
    
    this.offered = offered;
    return this;
  }

  public GetOfferSummary200ResponseAllOfOneOf1Summary putOfferedItem(String key, Integer offeredItem) {
    if (this.offered == null) {
      this.offered = new HashMap<>();
    }
    this.offered.put(key, offeredItem);
    return this;
  }

   /**
   * Get offered
   * @return offered
  **/
  @javax.annotation.Nullable

  public Map<String, Integer> getOffered() {
    return offered;
  }


  public void setOffered(Map<String, Integer> offered) {
    this.offered = offered;
  }


  public GetOfferSummary200ResponseAllOfOneOf1Summary requested(Map<String, Integer> requested) {
    
    this.requested = requested;
    return this;
  }

  public GetOfferSummary200ResponseAllOfOneOf1Summary putRequestedItem(String key, Integer requestedItem) {
    if (this.requested == null) {
      this.requested = new HashMap<>();
    }
    this.requested.put(key, requestedItem);
    return this;
  }

   /**
   * Get requested
   * @return requested
  **/
  @javax.annotation.Nullable

  public Map<String, Integer> getRequested() {
    return requested;
  }


  public void setRequested(Map<String, Integer> requested) {
    this.requested = requested;
  }


  public GetOfferSummary200ResponseAllOfOneOf1Summary fees(Integer fees) {
    
    this.fees = fees;
    return this;
  }

   /**
   * Get fees
   * @return fees
  **/
  @javax.annotation.Nullable

  public Integer getFees() {
    return fees;
  }


  public void setFees(Integer fees) {
    this.fees = fees;
  }


  public GetOfferSummary200ResponseAllOfOneOf1Summary infos(Map<String, Map<String, Object>> infos) {
    
    this.infos = infos;
    return this;
  }

  public GetOfferSummary200ResponseAllOfOneOf1Summary putInfosItem(String key, Map<String, Object> infosItem) {
    if (this.infos == null) {
      this.infos = new HashMap<>();
    }
    this.infos.put(key, infosItem);
    return this;
  }

   /**
   * Get infos
   * @return infos
  **/
  @javax.annotation.Nullable

  public Map<String, Map<String, Object>> getInfos() {
    return infos;
  }


  public void setInfos(Map<String, Map<String, Object>> infos) {
    this.infos = infos;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOfferSummary200ResponseAllOfOneOf1Summary getOfferSummary200ResponseAllOfOneOf1Summary = (GetOfferSummary200ResponseAllOfOneOf1Summary) o;
    return Objects.equals(this.offered, getOfferSummary200ResponseAllOfOneOf1Summary.offered) &&
        Objects.equals(this.requested, getOfferSummary200ResponseAllOfOneOf1Summary.requested) &&
        Objects.equals(this.fees, getOfferSummary200ResponseAllOfOneOf1Summary.fees) &&
        Objects.equals(this.infos, getOfferSummary200ResponseAllOfOneOf1Summary.infos);
  }

  @Override
  public int hashCode() {
    return Objects.hash(offered, requested, fees, infos);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOfferSummary200ResponseAllOfOneOf1Summary {\n");
    sb.append("    offered: ").append(toIndentedString(offered)).append("\n");
    sb.append("    requested: ").append(toIndentedString(requested)).append("\n");
    sb.append("    fees: ").append(toIndentedString(fees)).append("\n");
    sb.append("    infos: ").append(toIndentedString(infos)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("offered");
    openapiFields.add("requested");
    openapiFields.add("fees");
    openapiFields.add("infos");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOfferSummary200ResponseAllOfOneOf1Summary
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOfferSummary200ResponseAllOfOneOf1Summary.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOfferSummary200ResponseAllOfOneOf1Summary is not found in the empty JSON string", GetOfferSummary200ResponseAllOfOneOf1Summary.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOfferSummary200ResponseAllOfOneOf1Summary.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOfferSummary200ResponseAllOfOneOf1Summary` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOfferSummary200ResponseAllOfOneOf1Summary.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOfferSummary200ResponseAllOfOneOf1Summary' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOfferSummary200ResponseAllOfOneOf1Summary> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOfferSummary200ResponseAllOfOneOf1Summary.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOfferSummary200ResponseAllOfOneOf1Summary>() {
           @Override
           public void write(JsonWriter out, GetOfferSummary200ResponseAllOfOneOf1Summary value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOfferSummary200ResponseAllOfOneOf1Summary read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOfferSummary200ResponseAllOfOneOf1Summary given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOfferSummary200ResponseAllOfOneOf1Summary
  * @throws IOException if the JSON string is invalid with respect to GetOfferSummary200ResponseAllOfOneOf1Summary
  */
  public static GetOfferSummary200ResponseAllOfOneOf1Summary fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOfferSummary200ResponseAllOfOneOf1Summary.class);
  }

 /**
  * Convert an instance of GetOfferSummary200ResponseAllOfOneOf1Summary to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

