/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner {
  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_VALUES_TO_PROVE = "values_to_prove";
  @SerializedName(SERIALIZED_NAME_VALUES_TO_PROVE)
  private List<String> valuesToProve;

  public GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner() {
  }

  public GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner valuesToProve(List<String> valuesToProve) {
    
    this.valuesToProve = valuesToProve;
    return this;
  }

  public GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner addValuesToProveItem(String valuesToProveItem) {
    if (this.valuesToProve == null) {
      this.valuesToProve = new ArrayList<>();
    }
    this.valuesToProve.add(valuesToProveItem);
    return this;
  }

   /**
   * Get valuesToProve
   * @return valuesToProve
  **/
  @javax.annotation.Nullable

  public List<String> getValuesToProve() {
    return valuesToProve;
  }


  public void setValuesToProve(List<String> valuesToProve) {
    this.valuesToProve = valuesToProve;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner getOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner = (GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner) o;
    return Objects.equals(this.launcherId, getOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.launcherId) &&
        Objects.equals(this.valuesToProve, getOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.valuesToProve);
  }

  @Override
  public int hashCode() {
    return Objects.hash(launcherId, valuesToProve);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner {\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    valuesToProve: ").append(toIndentedString(valuesToProve)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("launcher_id");
    openapiFields.add("values_to_prove");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner is not found in the empty JSON string", GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("values_to_prove") != null && !jsonObj.get("values_to_prove").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `values_to_prove` to be an array in the JSON string but got `%s`", jsonObj.get("values_to_prove").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner>() {
           @Override
           public void write(JsonWriter out, GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner
  * @throws IOException if the JSON string is invalid with respect to GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner
  */
  public static GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner.class);
  }

 /**
  * Convert an instance of GetOfferSummary200ResponseAllOfOneOfOfferedInnerDependenciesInner to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

