/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOffersCount200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOffersCount200Response {
  public static final String SERIALIZED_NAME_TOTAL = "total";
  @SerializedName(SERIALIZED_NAME_TOTAL)
  private Integer total;

  public static final String SERIALIZED_NAME_MY_OFFERS_COUNT = "my_offers_count";
  @SerializedName(SERIALIZED_NAME_MY_OFFERS_COUNT)
  private Integer myOffersCount;

  public static final String SERIALIZED_NAME_TAKEN_OFFERS_COUNT = "taken_offers_count";
  @SerializedName(SERIALIZED_NAME_TAKEN_OFFERS_COUNT)
  private Integer takenOffersCount;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public GetOffersCount200Response() {
  }

  public GetOffersCount200Response total(Integer total) {
    
    this.total = total;
    return this;
  }

   /**
   * Get total
   * @return total
  **/
  @javax.annotation.Nullable

  public Integer getTotal() {
    return total;
  }


  public void setTotal(Integer total) {
    this.total = total;
  }


  public GetOffersCount200Response myOffersCount(Integer myOffersCount) {
    
    this.myOffersCount = myOffersCount;
    return this;
  }

   /**
   * Get myOffersCount
   * @return myOffersCount
  **/
  @javax.annotation.Nullable

  public Integer getMyOffersCount() {
    return myOffersCount;
  }


  public void setMyOffersCount(Integer myOffersCount) {
    this.myOffersCount = myOffersCount;
  }


  public GetOffersCount200Response takenOffersCount(Integer takenOffersCount) {
    
    this.takenOffersCount = takenOffersCount;
    return this;
  }

   /**
   * Get takenOffersCount
   * @return takenOffersCount
  **/
  @javax.annotation.Nullable

  public Integer getTakenOffersCount() {
    return takenOffersCount;
  }


  public void setTakenOffersCount(Integer takenOffersCount) {
    this.takenOffersCount = takenOffersCount;
  }


  public GetOffersCount200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public GetOffersCount200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOffersCount200Response getOffersCount200Response = (GetOffersCount200Response) o;
    return Objects.equals(this.total, getOffersCount200Response.total) &&
        Objects.equals(this.myOffersCount, getOffersCount200Response.myOffersCount) &&
        Objects.equals(this.takenOffersCount, getOffersCount200Response.takenOffersCount) &&
        Objects.equals(this.success, getOffersCount200Response.success) &&
        Objects.equals(this.error, getOffersCount200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(total, myOffersCount, takenOffersCount, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOffersCount200Response {\n");
    sb.append("    total: ").append(toIndentedString(total)).append("\n");
    sb.append("    myOffersCount: ").append(toIndentedString(myOffersCount)).append("\n");
    sb.append("    takenOffersCount: ").append(toIndentedString(takenOffersCount)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("total");
    openapiFields.add("my_offers_count");
    openapiFields.add("taken_offers_count");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOffersCount200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOffersCount200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOffersCount200Response is not found in the empty JSON string", GetOffersCount200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOffersCount200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOffersCount200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetOffersCount200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOffersCount200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOffersCount200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOffersCount200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOffersCount200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOffersCount200Response>() {
           @Override
           public void write(JsonWriter out, GetOffersCount200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOffersCount200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOffersCount200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOffersCount200Response
  * @throws IOException if the JSON string is invalid with respect to GetOffersCount200Response
  */
  public static GetOffersCount200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOffersCount200Response.class);
  }

 /**
  * Convert an instance of GetOffersCount200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

