/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetOffersCount200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetOffersCount200ResponseAllOf {
  public static final String SERIALIZED_NAME_TOTAL = "total";
  @SerializedName(SERIALIZED_NAME_TOTAL)
  private Integer total;

  public static final String SERIALIZED_NAME_MY_OFFERS_COUNT = "my_offers_count";
  @SerializedName(SERIALIZED_NAME_MY_OFFERS_COUNT)
  private Integer myOffersCount;

  public static final String SERIALIZED_NAME_TAKEN_OFFERS_COUNT = "taken_offers_count";
  @SerializedName(SERIALIZED_NAME_TAKEN_OFFERS_COUNT)
  private Integer takenOffersCount;

  public GetOffersCount200ResponseAllOf() {
  }

  public GetOffersCount200ResponseAllOf total(Integer total) {
    
    this.total = total;
    return this;
  }

   /**
   * Get total
   * @return total
  **/
  @javax.annotation.Nullable

  public Integer getTotal() {
    return total;
  }


  public void setTotal(Integer total) {
    this.total = total;
  }


  public GetOffersCount200ResponseAllOf myOffersCount(Integer myOffersCount) {
    
    this.myOffersCount = myOffersCount;
    return this;
  }

   /**
   * Get myOffersCount
   * @return myOffersCount
  **/
  @javax.annotation.Nullable

  public Integer getMyOffersCount() {
    return myOffersCount;
  }


  public void setMyOffersCount(Integer myOffersCount) {
    this.myOffersCount = myOffersCount;
  }


  public GetOffersCount200ResponseAllOf takenOffersCount(Integer takenOffersCount) {
    
    this.takenOffersCount = takenOffersCount;
    return this;
  }

   /**
   * Get takenOffersCount
   * @return takenOffersCount
  **/
  @javax.annotation.Nullable

  public Integer getTakenOffersCount() {
    return takenOffersCount;
  }


  public void setTakenOffersCount(Integer takenOffersCount) {
    this.takenOffersCount = takenOffersCount;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetOffersCount200ResponseAllOf getOffersCount200ResponseAllOf = (GetOffersCount200ResponseAllOf) o;
    return Objects.equals(this.total, getOffersCount200ResponseAllOf.total) &&
        Objects.equals(this.myOffersCount, getOffersCount200ResponseAllOf.myOffersCount) &&
        Objects.equals(this.takenOffersCount, getOffersCount200ResponseAllOf.takenOffersCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(total, myOffersCount, takenOffersCount);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetOffersCount200ResponseAllOf {\n");
    sb.append("    total: ").append(toIndentedString(total)).append("\n");
    sb.append("    myOffersCount: ").append(toIndentedString(myOffersCount)).append("\n");
    sb.append("    takenOffersCount: ").append(toIndentedString(takenOffersCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("total");
    openapiFields.add("my_offers_count");
    openapiFields.add("taken_offers_count");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetOffersCount200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetOffersCount200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetOffersCount200ResponseAllOf is not found in the empty JSON string", GetOffersCount200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetOffersCount200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetOffersCount200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetOffersCount200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetOffersCount200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetOffersCount200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetOffersCount200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetOffersCount200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetOffersCount200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetOffersCount200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetOffersCount200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetOffersCount200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetOffersCount200ResponseAllOf
  */
  public static GetOffersCount200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetOffersCount200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetOffersCount200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

