/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.CoinRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetSpendableCoins200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetSpendableCoins200ResponseAllOf {
  public static final String SERIALIZED_NAME_CONFIRMED_RECORDS = "confirmed_records";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_RECORDS)
  private List<CoinRecord> confirmedRecords;

  public static final String SERIALIZED_NAME_UNCONFIRMED_REMOVALS = "unconfirmed_removals";
  @SerializedName(SERIALIZED_NAME_UNCONFIRMED_REMOVALS)
  private List<CoinRecord> unconfirmedRemovals;

  public static final String SERIALIZED_NAME_UNCONFIRMED_ADDITIONS = "unconfirmed_additions";
  @SerializedName(SERIALIZED_NAME_UNCONFIRMED_ADDITIONS)
  private List<Coin> unconfirmedAdditions;

  public GetSpendableCoins200ResponseAllOf() {
  }

  public GetSpendableCoins200ResponseAllOf confirmedRecords(List<CoinRecord> confirmedRecords) {
    
    this.confirmedRecords = confirmedRecords;
    return this;
  }

  public GetSpendableCoins200ResponseAllOf addConfirmedRecordsItem(CoinRecord confirmedRecordsItem) {
    if (this.confirmedRecords == null) {
      this.confirmedRecords = new ArrayList<>();
    }
    this.confirmedRecords.add(confirmedRecordsItem);
    return this;
  }

   /**
   * Get confirmedRecords
   * @return confirmedRecords
  **/
  @javax.annotation.Nullable

  public List<CoinRecord> getConfirmedRecords() {
    return confirmedRecords;
  }


  public void setConfirmedRecords(List<CoinRecord> confirmedRecords) {
    this.confirmedRecords = confirmedRecords;
  }


  public GetSpendableCoins200ResponseAllOf unconfirmedRemovals(List<CoinRecord> unconfirmedRemovals) {
    
    this.unconfirmedRemovals = unconfirmedRemovals;
    return this;
  }

  public GetSpendableCoins200ResponseAllOf addUnconfirmedRemovalsItem(CoinRecord unconfirmedRemovalsItem) {
    if (this.unconfirmedRemovals == null) {
      this.unconfirmedRemovals = new ArrayList<>();
    }
    this.unconfirmedRemovals.add(unconfirmedRemovalsItem);
    return this;
  }

   /**
   * Get unconfirmedRemovals
   * @return unconfirmedRemovals
  **/
  @javax.annotation.Nullable

  public List<CoinRecord> getUnconfirmedRemovals() {
    return unconfirmedRemovals;
  }


  public void setUnconfirmedRemovals(List<CoinRecord> unconfirmedRemovals) {
    this.unconfirmedRemovals = unconfirmedRemovals;
  }


  public GetSpendableCoins200ResponseAllOf unconfirmedAdditions(List<Coin> unconfirmedAdditions) {
    
    this.unconfirmedAdditions = unconfirmedAdditions;
    return this;
  }

  public GetSpendableCoins200ResponseAllOf addUnconfirmedAdditionsItem(Coin unconfirmedAdditionsItem) {
    if (this.unconfirmedAdditions == null) {
      this.unconfirmedAdditions = new ArrayList<>();
    }
    this.unconfirmedAdditions.add(unconfirmedAdditionsItem);
    return this;
  }

   /**
   * Get unconfirmedAdditions
   * @return unconfirmedAdditions
  **/
  @javax.annotation.Nullable

  public List<Coin> getUnconfirmedAdditions() {
    return unconfirmedAdditions;
  }


  public void setUnconfirmedAdditions(List<Coin> unconfirmedAdditions) {
    this.unconfirmedAdditions = unconfirmedAdditions;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetSpendableCoins200ResponseAllOf getSpendableCoins200ResponseAllOf = (GetSpendableCoins200ResponseAllOf) o;
    return Objects.equals(this.confirmedRecords, getSpendableCoins200ResponseAllOf.confirmedRecords) &&
        Objects.equals(this.unconfirmedRemovals, getSpendableCoins200ResponseAllOf.unconfirmedRemovals) &&
        Objects.equals(this.unconfirmedAdditions, getSpendableCoins200ResponseAllOf.unconfirmedAdditions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(confirmedRecords, unconfirmedRemovals, unconfirmedAdditions);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetSpendableCoins200ResponseAllOf {\n");
    sb.append("    confirmedRecords: ").append(toIndentedString(confirmedRecords)).append("\n");
    sb.append("    unconfirmedRemovals: ").append(toIndentedString(unconfirmedRemovals)).append("\n");
    sb.append("    unconfirmedAdditions: ").append(toIndentedString(unconfirmedAdditions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("confirmed_records");
    openapiFields.add("unconfirmed_removals");
    openapiFields.add("unconfirmed_additions");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetSpendableCoins200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetSpendableCoins200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetSpendableCoins200ResponseAllOf is not found in the empty JSON string", GetSpendableCoins200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetSpendableCoins200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetSpendableCoins200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("confirmed_records") != null && !jsonObj.get("confirmed_records").isJsonNull()) {
        JsonArray jsonArrayconfirmedRecords = jsonObj.getAsJsonArray("confirmed_records");
        if (jsonArrayconfirmedRecords != null) {
          // ensure the json data is an array
          if (!jsonObj.get("confirmed_records").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `confirmed_records` to be an array in the JSON string but got `%s`", jsonObj.get("confirmed_records").toString()));
          }

          // validate the optional field `confirmed_records` (array)
          for (int i = 0; i < jsonArrayconfirmedRecords.size(); i++) {
            CoinRecord.validateJsonObject(jsonArrayconfirmedRecords.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("unconfirmed_removals") != null && !jsonObj.get("unconfirmed_removals").isJsonNull()) {
        JsonArray jsonArrayunconfirmedRemovals = jsonObj.getAsJsonArray("unconfirmed_removals");
        if (jsonArrayunconfirmedRemovals != null) {
          // ensure the json data is an array
          if (!jsonObj.get("unconfirmed_removals").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `unconfirmed_removals` to be an array in the JSON string but got `%s`", jsonObj.get("unconfirmed_removals").toString()));
          }

          // validate the optional field `unconfirmed_removals` (array)
          for (int i = 0; i < jsonArrayunconfirmedRemovals.size(); i++) {
            CoinRecord.validateJsonObject(jsonArrayunconfirmedRemovals.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("unconfirmed_additions") != null && !jsonObj.get("unconfirmed_additions").isJsonNull()) {
        JsonArray jsonArrayunconfirmedAdditions = jsonObj.getAsJsonArray("unconfirmed_additions");
        if (jsonArrayunconfirmedAdditions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("unconfirmed_additions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `unconfirmed_additions` to be an array in the JSON string but got `%s`", jsonObj.get("unconfirmed_additions").toString()));
          }

          // validate the optional field `unconfirmed_additions` (array)
          for (int i = 0; i < jsonArrayunconfirmedAdditions.size(); i++) {
            Coin.validateJsonObject(jsonArrayunconfirmedAdditions.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetSpendableCoins200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetSpendableCoins200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetSpendableCoins200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetSpendableCoins200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetSpendableCoins200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetSpendableCoins200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetSpendableCoins200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetSpendableCoins200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetSpendableCoins200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetSpendableCoins200ResponseAllOf
  */
  public static GetSpendableCoins200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetSpendableCoins200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetSpendableCoins200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

