/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetSpendableCoinsRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetSpendableCoinsRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_MIN_COIN_AMOUNT = "min_coin_amount";
  @SerializedName(SERIALIZED_NAME_MIN_COIN_AMOUNT)
  private Integer minCoinAmount = 0;

  public static final String SERIALIZED_NAME_MAX_COIN_AMOUNT = "max_coin_amount";
  @SerializedName(SERIALIZED_NAME_MAX_COIN_AMOUNT)
  private Integer maxCoinAmount = 0;

  public static final String SERIALIZED_NAME_EXCLUDED_COIN_AMOUNTS = "excluded_coin_amounts";
  @SerializedName(SERIALIZED_NAME_EXCLUDED_COIN_AMOUNTS)
  private List<Integer> excludedCoinAmounts;

  public static final String SERIALIZED_NAME_EXCLUDED_COINS = "excluded_coins";
  @SerializedName(SERIALIZED_NAME_EXCLUDED_COINS)
  private List<Coin> excludedCoins;

  public static final String SERIALIZED_NAME_EXCLUDED_COIN_IDS = "excluded_coin_ids";
  @SerializedName(SERIALIZED_NAME_EXCLUDED_COIN_IDS)
  private List<String> excludedCoinIds;

  public GetSpendableCoinsRequest() {
  }

  public GetSpendableCoinsRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public GetSpendableCoinsRequest minCoinAmount(Integer minCoinAmount) {
    
    this.minCoinAmount = minCoinAmount;
    return this;
  }

   /**
   * Get minCoinAmount
   * @return minCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMinCoinAmount() {
    return minCoinAmount;
  }


  public void setMinCoinAmount(Integer minCoinAmount) {
    this.minCoinAmount = minCoinAmount;
  }


  public GetSpendableCoinsRequest maxCoinAmount(Integer maxCoinAmount) {
    
    this.maxCoinAmount = maxCoinAmount;
    return this;
  }

   /**
   * Get maxCoinAmount
   * @return maxCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMaxCoinAmount() {
    return maxCoinAmount;
  }


  public void setMaxCoinAmount(Integer maxCoinAmount) {
    this.maxCoinAmount = maxCoinAmount;
  }


  public GetSpendableCoinsRequest excludedCoinAmounts(List<Integer> excludedCoinAmounts) {
    
    this.excludedCoinAmounts = excludedCoinAmounts;
    return this;
  }

  public GetSpendableCoinsRequest addExcludedCoinAmountsItem(Integer excludedCoinAmountsItem) {
    if (this.excludedCoinAmounts == null) {
      this.excludedCoinAmounts = new ArrayList<>();
    }
    this.excludedCoinAmounts.add(excludedCoinAmountsItem);
    return this;
  }

   /**
   * Get excludedCoinAmounts
   * @return excludedCoinAmounts
  **/
  @javax.annotation.Nullable

  public List<Integer> getExcludedCoinAmounts() {
    return excludedCoinAmounts;
  }


  public void setExcludedCoinAmounts(List<Integer> excludedCoinAmounts) {
    this.excludedCoinAmounts = excludedCoinAmounts;
  }


  public GetSpendableCoinsRequest excludedCoins(List<Coin> excludedCoins) {
    
    this.excludedCoins = excludedCoins;
    return this;
  }

  public GetSpendableCoinsRequest addExcludedCoinsItem(Coin excludedCoinsItem) {
    if (this.excludedCoins == null) {
      this.excludedCoins = new ArrayList<>();
    }
    this.excludedCoins.add(excludedCoinsItem);
    return this;
  }

   /**
   * Get excludedCoins
   * @return excludedCoins
  **/
  @javax.annotation.Nullable

  public List<Coin> getExcludedCoins() {
    return excludedCoins;
  }


  public void setExcludedCoins(List<Coin> excludedCoins) {
    this.excludedCoins = excludedCoins;
  }


  public GetSpendableCoinsRequest excludedCoinIds(List<String> excludedCoinIds) {
    
    this.excludedCoinIds = excludedCoinIds;
    return this;
  }

  public GetSpendableCoinsRequest addExcludedCoinIdsItem(String excludedCoinIdsItem) {
    if (this.excludedCoinIds == null) {
      this.excludedCoinIds = new ArrayList<>();
    }
    this.excludedCoinIds.add(excludedCoinIdsItem);
    return this;
  }

   /**
   * Get excludedCoinIds
   * @return excludedCoinIds
  **/
  @javax.annotation.Nullable

  public List<String> getExcludedCoinIds() {
    return excludedCoinIds;
  }


  public void setExcludedCoinIds(List<String> excludedCoinIds) {
    this.excludedCoinIds = excludedCoinIds;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetSpendableCoinsRequest getSpendableCoinsRequest = (GetSpendableCoinsRequest) o;
    return Objects.equals(this.walletId, getSpendableCoinsRequest.walletId) &&
        Objects.equals(this.minCoinAmount, getSpendableCoinsRequest.minCoinAmount) &&
        Objects.equals(this.maxCoinAmount, getSpendableCoinsRequest.maxCoinAmount) &&
        Objects.equals(this.excludedCoinAmounts, getSpendableCoinsRequest.excludedCoinAmounts) &&
        Objects.equals(this.excludedCoins, getSpendableCoinsRequest.excludedCoins) &&
        Objects.equals(this.excludedCoinIds, getSpendableCoinsRequest.excludedCoinIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, minCoinAmount, maxCoinAmount, excludedCoinAmounts, excludedCoins, excludedCoinIds);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetSpendableCoinsRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    minCoinAmount: ").append(toIndentedString(minCoinAmount)).append("\n");
    sb.append("    maxCoinAmount: ").append(toIndentedString(maxCoinAmount)).append("\n");
    sb.append("    excludedCoinAmounts: ").append(toIndentedString(excludedCoinAmounts)).append("\n");
    sb.append("    excludedCoins: ").append(toIndentedString(excludedCoins)).append("\n");
    sb.append("    excludedCoinIds: ").append(toIndentedString(excludedCoinIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("min_coin_amount");
    openapiFields.add("max_coin_amount");
    openapiFields.add("excluded_coin_amounts");
    openapiFields.add("excluded_coins");
    openapiFields.add("excluded_coin_ids");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetSpendableCoinsRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetSpendableCoinsRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetSpendableCoinsRequest is not found in the empty JSON string", GetSpendableCoinsRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetSpendableCoinsRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetSpendableCoinsRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : GetSpendableCoinsRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("excluded_coin_amounts") != null && !jsonObj.get("excluded_coin_amounts").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `excluded_coin_amounts` to be an array in the JSON string but got `%s`", jsonObj.get("excluded_coin_amounts").toString()));
      }
      if (jsonObj.get("excluded_coins") != null && !jsonObj.get("excluded_coins").isJsonNull()) {
        JsonArray jsonArrayexcludedCoins = jsonObj.getAsJsonArray("excluded_coins");
        if (jsonArrayexcludedCoins != null) {
          // ensure the json data is an array
          if (!jsonObj.get("excluded_coins").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `excluded_coins` to be an array in the JSON string but got `%s`", jsonObj.get("excluded_coins").toString()));
          }

          // validate the optional field `excluded_coins` (array)
          for (int i = 0; i < jsonArrayexcludedCoins.size(); i++) {
            Coin.validateJsonObject(jsonArrayexcludedCoins.get(i).getAsJsonObject());
          };
        }
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("excluded_coin_ids") != null && !jsonObj.get("excluded_coin_ids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `excluded_coin_ids` to be an array in the JSON string but got `%s`", jsonObj.get("excluded_coin_ids").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetSpendableCoinsRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetSpendableCoinsRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetSpendableCoinsRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetSpendableCoinsRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<GetSpendableCoinsRequest>() {
           @Override
           public void write(JsonWriter out, GetSpendableCoinsRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetSpendableCoinsRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetSpendableCoinsRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetSpendableCoinsRequest
  * @throws IOException if the JSON string is invalid with respect to GetSpendableCoinsRequest
  */
  public static GetSpendableCoinsRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetSpendableCoinsRequest.class);
  }

 /**
  * Convert an instance of GetSpendableCoinsRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

