/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * GetSyncStatus200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class GetSyncStatus200ResponseAllOf {
  public static final String SERIALIZED_NAME_SYNCED = "synced";
  @SerializedName(SERIALIZED_NAME_SYNCED)
  private Boolean synced;

  public static final String SERIALIZED_NAME_SYNCING = "syncing";
  @SerializedName(SERIALIZED_NAME_SYNCING)
  private Boolean syncing;

  public static final String SERIALIZED_NAME_GENESIS_INITIALIZED = "genesis_initialized";
  @SerializedName(SERIALIZED_NAME_GENESIS_INITIALIZED)
  private Boolean genesisInitialized;

  public GetSyncStatus200ResponseAllOf() {
  }

  public GetSyncStatus200ResponseAllOf synced(Boolean synced) {
    
    this.synced = synced;
    return this;
  }

   /**
   * Get synced
   * @return synced
  **/
  @javax.annotation.Nullable

  public Boolean getSynced() {
    return synced;
  }


  public void setSynced(Boolean synced) {
    this.synced = synced;
  }


  public GetSyncStatus200ResponseAllOf syncing(Boolean syncing) {
    
    this.syncing = syncing;
    return this;
  }

   /**
   * Get syncing
   * @return syncing
  **/
  @javax.annotation.Nullable

  public Boolean getSyncing() {
    return syncing;
  }


  public void setSyncing(Boolean syncing) {
    this.syncing = syncing;
  }


  public GetSyncStatus200ResponseAllOf genesisInitialized(Boolean genesisInitialized) {
    
    this.genesisInitialized = genesisInitialized;
    return this;
  }

   /**
   * Get genesisInitialized
   * @return genesisInitialized
  **/
  @javax.annotation.Nullable

  public Boolean getGenesisInitialized() {
    return genesisInitialized;
  }


  public void setGenesisInitialized(Boolean genesisInitialized) {
    this.genesisInitialized = genesisInitialized;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetSyncStatus200ResponseAllOf getSyncStatus200ResponseAllOf = (GetSyncStatus200ResponseAllOf) o;
    return Objects.equals(this.synced, getSyncStatus200ResponseAllOf.synced) &&
        Objects.equals(this.syncing, getSyncStatus200ResponseAllOf.syncing) &&
        Objects.equals(this.genesisInitialized, getSyncStatus200ResponseAllOf.genesisInitialized);
  }

  @Override
  public int hashCode() {
    return Objects.hash(synced, syncing, genesisInitialized);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetSyncStatus200ResponseAllOf {\n");
    sb.append("    synced: ").append(toIndentedString(synced)).append("\n");
    sb.append("    syncing: ").append(toIndentedString(syncing)).append("\n");
    sb.append("    genesisInitialized: ").append(toIndentedString(genesisInitialized)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("synced");
    openapiFields.add("syncing");
    openapiFields.add("genesis_initialized");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to GetSyncStatus200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!GetSyncStatus200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in GetSyncStatus200ResponseAllOf is not found in the empty JSON string", GetSyncStatus200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!GetSyncStatus200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `GetSyncStatus200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!GetSyncStatus200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'GetSyncStatus200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<GetSyncStatus200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(GetSyncStatus200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<GetSyncStatus200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, GetSyncStatus200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public GetSyncStatus200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of GetSyncStatus200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of GetSyncStatus200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to GetSyncStatus200ResponseAllOf
  */
  public static GetSyncStatus200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, GetSyncStatus200ResponseAllOf.class);
  }

 /**
  * Convert an instance of GetSyncStatus200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

