/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.net.URI;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftAddUriRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftAddUriRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_URI = "uri";
  @SerializedName(SERIALIZED_NAME_URI)
  private URI uri;

  /**
   * The type of uri:   * u Uri for the NFT data   * mu Uri for NFT metadata   * lu Uri for the NFT license
   */
  @JsonAdapter(KeyEnum.Adapter.class)
  public enum KeyEnum {
    U("u"),
    
    MU("mu"),
    
    LU("lu");

    private String value;

    KeyEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static KeyEnum fromValue(String value) {
      for (KeyEnum b : KeyEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<KeyEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final KeyEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public KeyEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return KeyEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_KEY = "key";
  @SerializedName(SERIALIZED_NAME_KEY)
  private KeyEnum key;

  public static final String SERIALIZED_NAME_NFT_COIN_ID = "nft_coin_id";
  @SerializedName(SERIALIZED_NAME_NFT_COIN_ID)
  private String nftCoinId;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public NftAddUriRequest() {
  }

  public NftAddUriRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftAddUriRequest uri(URI uri) {
    
    this.uri = uri;
    return this;
  }

   /**
   * Get uri
   * @return uri
  **/
  @javax.annotation.Nonnull

  public URI getUri() {
    return uri;
  }


  public void setUri(URI uri) {
    this.uri = uri;
  }


  public NftAddUriRequest key(KeyEnum key) {
    
    this.key = key;
    return this;
  }

   /**
   * The type of uri:   * u Uri for the NFT data   * mu Uri for NFT metadata   * lu Uri for the NFT license
   * @return key
  **/
  @javax.annotation.Nonnull

  public KeyEnum getKey() {
    return key;
  }


  public void setKey(KeyEnum key) {
    this.key = key;
  }


  public NftAddUriRequest nftCoinId(String nftCoinId) {
    
    this.nftCoinId = nftCoinId;
    return this;
  }

   /**
   * Get nftCoinId
   * @return nftCoinId
  **/
  @javax.annotation.Nonnull

  public String getNftCoinId() {
    return nftCoinId;
  }


  public void setNftCoinId(String nftCoinId) {
    this.nftCoinId = nftCoinId;
  }


  public NftAddUriRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public NftAddUriRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftAddUriRequest nftAddUriRequest = (NftAddUriRequest) o;
    return Objects.equals(this.walletId, nftAddUriRequest.walletId) &&
        Objects.equals(this.uri, nftAddUriRequest.uri) &&
        Objects.equals(this.key, nftAddUriRequest.key) &&
        Objects.equals(this.nftCoinId, nftAddUriRequest.nftCoinId) &&
        Objects.equals(this.fee, nftAddUriRequest.fee) &&
        Objects.equals(this.reusePuzhash, nftAddUriRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, uri, key, nftCoinId, fee, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftAddUriRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("    key: ").append(toIndentedString(key)).append("\n");
    sb.append("    nftCoinId: ").append(toIndentedString(nftCoinId)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("uri");
    openapiFields.add("key");
    openapiFields.add("nft_coin_id");
    openapiFields.add("fee");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("uri");
    openapiRequiredFields.add("key");
    openapiRequiredFields.add("nft_coin_id");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftAddUriRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftAddUriRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftAddUriRequest is not found in the empty JSON string", NftAddUriRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftAddUriRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftAddUriRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : NftAddUriRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("uri").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `uri` to be a primitive type in the JSON string but got `%s`", jsonObj.get("uri").toString()));
      }
      if (!jsonObj.get("key").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `key` to be a primitive type in the JSON string but got `%s`", jsonObj.get("key").toString()));
      }
      if (!jsonObj.get("nft_coin_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `nft_coin_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("nft_coin_id").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftAddUriRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftAddUriRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftAddUriRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftAddUriRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<NftAddUriRequest>() {
           @Override
           public void write(JsonWriter out, NftAddUriRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftAddUriRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftAddUriRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftAddUriRequest
  * @throws IOException if the JSON string is invalid with respect to NftAddUriRequest
  */
  public static NftAddUriRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftAddUriRequest.class);
  }

 /**
  * Convert an instance of NftAddUriRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

