/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.NftInfo;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftGetNfts200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftGetNfts200ResponseAllOf {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_NFT_LIST = "nft_list";
  @SerializedName(SERIALIZED_NAME_NFT_LIST)
  private List<NftInfo> nftList;

  public NftGetNfts200ResponseAllOf() {
  }

  public NftGetNfts200ResponseAllOf walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftGetNfts200ResponseAllOf nftList(List<NftInfo> nftList) {
    
    this.nftList = nftList;
    return this;
  }

  public NftGetNfts200ResponseAllOf addNftListItem(NftInfo nftListItem) {
    if (this.nftList == null) {
      this.nftList = new ArrayList<>();
    }
    this.nftList.add(nftListItem);
    return this;
  }

   /**
   * Get nftList
   * @return nftList
  **/
  @javax.annotation.Nullable

  public List<NftInfo> getNftList() {
    return nftList;
  }


  public void setNftList(List<NftInfo> nftList) {
    this.nftList = nftList;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftGetNfts200ResponseAllOf nftGetNfts200ResponseAllOf = (NftGetNfts200ResponseAllOf) o;
    return Objects.equals(this.walletId, nftGetNfts200ResponseAllOf.walletId) &&
        Objects.equals(this.nftList, nftGetNfts200ResponseAllOf.nftList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, nftList);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftGetNfts200ResponseAllOf {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    nftList: ").append(toIndentedString(nftList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("nft_list");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftGetNfts200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftGetNfts200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftGetNfts200ResponseAllOf is not found in the empty JSON string", NftGetNfts200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftGetNfts200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftGetNfts200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("nft_list") != null && !jsonObj.get("nft_list").isJsonNull()) {
        JsonArray jsonArraynftList = jsonObj.getAsJsonArray("nft_list");
        if (jsonArraynftList != null) {
          // ensure the json data is an array
          if (!jsonObj.get("nft_list").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `nft_list` to be an array in the JSON string but got `%s`", jsonObj.get("nft_list").toString()));
          }

          // validate the optional field `nft_list` (array)
          for (int i = 0; i < jsonArraynftList.size(); i++) {
            NftInfo.validateJsonObject(jsonArraynftList.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftGetNfts200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftGetNfts200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftGetNfts200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftGetNfts200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<NftGetNfts200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, NftGetNfts200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftGetNfts200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftGetNfts200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftGetNfts200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to NftGetNfts200ResponseAllOf
  */
  public static NftGetNfts200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftGetNfts200ResponseAllOf.class);
  }

 /**
  * Convert an instance of NftGetNfts200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

