/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftGetWalletsWithDids200ResponseAllOfNftWalletsInner
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftGetWalletsWithDids200ResponseAllOfNftWalletsInner {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_DID_ID = "did_id";
  @SerializedName(SERIALIZED_NAME_DID_ID)
  private String didId;

  public static final String SERIALIZED_NAME_DID_WALLET_ID = "did_wallet_id";
  @SerializedName(SERIALIZED_NAME_DID_WALLET_ID)
  private Integer didWalletId;

  public NftGetWalletsWithDids200ResponseAllOfNftWalletsInner() {
  }

  public NftGetWalletsWithDids200ResponseAllOfNftWalletsInner walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftGetWalletsWithDids200ResponseAllOfNftWalletsInner didId(String didId) {
    
    this.didId = didId;
    return this;
  }

   /**
   * Get didId
   * @return didId
  **/
  @javax.annotation.Nullable

  public String getDidId() {
    return didId;
  }


  public void setDidId(String didId) {
    this.didId = didId;
  }


  public NftGetWalletsWithDids200ResponseAllOfNftWalletsInner didWalletId(Integer didWalletId) {
    
    this.didWalletId = didWalletId;
    return this;
  }

   /**
   * Get didWalletId
   * @return didWalletId
  **/
  @javax.annotation.Nullable

  public Integer getDidWalletId() {
    return didWalletId;
  }


  public void setDidWalletId(Integer didWalletId) {
    this.didWalletId = didWalletId;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftGetWalletsWithDids200ResponseAllOfNftWalletsInner nftGetWalletsWithDids200ResponseAllOfNftWalletsInner = (NftGetWalletsWithDids200ResponseAllOfNftWalletsInner) o;
    return Objects.equals(this.walletId, nftGetWalletsWithDids200ResponseAllOfNftWalletsInner.walletId) &&
        Objects.equals(this.didId, nftGetWalletsWithDids200ResponseAllOfNftWalletsInner.didId) &&
        Objects.equals(this.didWalletId, nftGetWalletsWithDids200ResponseAllOfNftWalletsInner.didWalletId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, didId, didWalletId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftGetWalletsWithDids200ResponseAllOfNftWalletsInner {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    didId: ").append(toIndentedString(didId)).append("\n");
    sb.append("    didWalletId: ").append(toIndentedString(didWalletId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("did_id");
    openapiFields.add("did_wallet_id");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftGetWalletsWithDids200ResponseAllOfNftWalletsInner
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftGetWalletsWithDids200ResponseAllOfNftWalletsInner is not found in the empty JSON string", NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftGetWalletsWithDids200ResponseAllOfNftWalletsInner` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("did_id") != null && !jsonObj.get("did_id").isJsonNull()) && !jsonObj.get("did_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `did_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("did_id").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftGetWalletsWithDids200ResponseAllOfNftWalletsInner' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftGetWalletsWithDids200ResponseAllOfNftWalletsInner> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.class));

       return (TypeAdapter<T>) new TypeAdapter<NftGetWalletsWithDids200ResponseAllOfNftWalletsInner>() {
           @Override
           public void write(JsonWriter out, NftGetWalletsWithDids200ResponseAllOfNftWalletsInner value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftGetWalletsWithDids200ResponseAllOfNftWalletsInner read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftGetWalletsWithDids200ResponseAllOfNftWalletsInner given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftGetWalletsWithDids200ResponseAllOfNftWalletsInner
  * @throws IOException if the JSON string is invalid with respect to NftGetWalletsWithDids200ResponseAllOfNftWalletsInner
  */
  public static NftGetWalletsWithDids200ResponseAllOfNftWalletsInner fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftGetWalletsWithDids200ResponseAllOfNftWalletsInner.class);
  }

 /**
  * Convert an instance of NftGetWalletsWithDids200ResponseAllOfNftWalletsInner to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

