/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NFT Info for displaying NFT on the UI
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftInfo {
  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_NFT_COIN_ID = "nft_coin_id";
  @SerializedName(SERIALIZED_NAME_NFT_COIN_ID)
  private String nftCoinId;

  public static final String SERIALIZED_NAME_OWNER_DID = "owner_did";
  @SerializedName(SERIALIZED_NAME_OWNER_DID)
  private String ownerDid;

  public static final String SERIALIZED_NAME_ROYALTY_PERCENTAGE = "royalty_percentage";
  @SerializedName(SERIALIZED_NAME_ROYALTY_PERCENTAGE)
  private Integer royaltyPercentage;

  public static final String SERIALIZED_NAME_ROYALTY_PUZZLE_HASH = "royalty_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_ROYALTY_PUZZLE_HASH)
  private String royaltyPuzzleHash;

  public static final String SERIALIZED_NAME_DATA_URIS = "data_uris";
  @SerializedName(SERIALIZED_NAME_DATA_URIS)
  private List<URI> dataUris;

  public static final String SERIALIZED_NAME_DATA_HASH = "data_hash";
  @SerializedName(SERIALIZED_NAME_DATA_HASH)
  private String dataHash;

  public static final String SERIALIZED_NAME_METADATA_URIS = "metadata_uris";
  @SerializedName(SERIALIZED_NAME_METADATA_URIS)
  private List<URI> metadataUris;

  public static final String SERIALIZED_NAME_METADATA_HASH = "metadata_hash";
  @SerializedName(SERIALIZED_NAME_METADATA_HASH)
  private String metadataHash;

  public static final String SERIALIZED_NAME_LICENSE_URIS = "license_uris";
  @SerializedName(SERIALIZED_NAME_LICENSE_URIS)
  private List<URI> licenseUris;

  public static final String SERIALIZED_NAME_LICENSE_HASH = "license_hash";
  @SerializedName(SERIALIZED_NAME_LICENSE_HASH)
  private String licenseHash;

  public static final String SERIALIZED_NAME_EDITION_TOTAL = "edition_total";
  @SerializedName(SERIALIZED_NAME_EDITION_TOTAL)
  private Integer editionTotal;

  public static final String SERIALIZED_NAME_EDITION_NUMBER = "edition_number";
  @SerializedName(SERIALIZED_NAME_EDITION_NUMBER)
  private Integer editionNumber;

  public static final String SERIALIZED_NAME_UPDATER_PUZHASH = "updater_puzhash";
  @SerializedName(SERIALIZED_NAME_UPDATER_PUZHASH)
  private String updaterPuzhash;

  public static final String SERIALIZED_NAME_CHAIN_INFO = "chain_info";
  @SerializedName(SERIALIZED_NAME_CHAIN_INFO)
  private String chainInfo;

  public static final String SERIALIZED_NAME_MINT_HEIGHT = "mint_height";
  @SerializedName(SERIALIZED_NAME_MINT_HEIGHT)
  private Integer mintHeight;

  public static final String SERIALIZED_NAME_SUPPORTS_DID = "supports_did";
  @SerializedName(SERIALIZED_NAME_SUPPORTS_DID)
  private Boolean supportsDid;

  public static final String SERIALIZED_NAME_PENDING_TRANSACTION = "pending_transaction";
  @SerializedName(SERIALIZED_NAME_PENDING_TRANSACTION)
  private Boolean pendingTransaction = false;

  public static final String SERIALIZED_NAME_LAUNCHER_PUZHASH = "launcher_puzhash";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_PUZHASH)
  private String launcherPuzhash;

  public static final String SERIALIZED_NAME_MINTER_DID = "minter_did";
  @SerializedName(SERIALIZED_NAME_MINTER_DID)
  private String minterDid;

  public static final String SERIALIZED_NAME_OFF_CHAIN_METADATA = "off_chain_metadata";
  @SerializedName(SERIALIZED_NAME_OFF_CHAIN_METADATA)
  private String offChainMetadata;

  public static final String SERIALIZED_NAME_P2_ADDRESS = "p2_address";
  @SerializedName(SERIALIZED_NAME_P2_ADDRESS)
  private String p2Address;

  public NftInfo() {
  }

  public NftInfo launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public NftInfo nftCoinId(String nftCoinId) {
    
    this.nftCoinId = nftCoinId;
    return this;
  }

   /**
   * Get nftCoinId
   * @return nftCoinId
  **/
  @javax.annotation.Nullable

  public String getNftCoinId() {
    return nftCoinId;
  }


  public void setNftCoinId(String nftCoinId) {
    this.nftCoinId = nftCoinId;
  }


  public NftInfo ownerDid(String ownerDid) {
    
    this.ownerDid = ownerDid;
    return this;
  }

   /**
   * Get ownerDid
   * @return ownerDid
  **/
  @javax.annotation.Nullable

  public String getOwnerDid() {
    return ownerDid;
  }


  public void setOwnerDid(String ownerDid) {
    this.ownerDid = ownerDid;
  }


  public NftInfo royaltyPercentage(Integer royaltyPercentage) {
    
    this.royaltyPercentage = royaltyPercentage;
    return this;
  }

   /**
   * Percentage of the transaction fee paid to the author, e.g. 1000 &#x3D; 1%
   * @return royaltyPercentage
  **/
  @javax.annotation.Nullable

  public Integer getRoyaltyPercentage() {
    return royaltyPercentage;
  }


  public void setRoyaltyPercentage(Integer royaltyPercentage) {
    this.royaltyPercentage = royaltyPercentage;
  }


  public NftInfo royaltyPuzzleHash(String royaltyPuzzleHash) {
    
    this.royaltyPuzzleHash = royaltyPuzzleHash;
    return this;
  }

   /**
   * Get royaltyPuzzleHash
   * @return royaltyPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getRoyaltyPuzzleHash() {
    return royaltyPuzzleHash;
  }


  public void setRoyaltyPuzzleHash(String royaltyPuzzleHash) {
    this.royaltyPuzzleHash = royaltyPuzzleHash;
  }


  public NftInfo dataUris(List<URI> dataUris) {
    
    this.dataUris = dataUris;
    return this;
  }

  public NftInfo addDataUrisItem(URI dataUrisItem) {
    if (this.dataUris == null) {
      this.dataUris = new ArrayList<>();
    }
    this.dataUris.add(dataUrisItem);
    return this;
  }

   /**
   * Get dataUris
   * @return dataUris
  **/
  @javax.annotation.Nullable

  public List<URI> getDataUris() {
    return dataUris;
  }


  public void setDataUris(List<URI> dataUris) {
    this.dataUris = dataUris;
  }


  public NftInfo dataHash(String dataHash) {
    
    this.dataHash = dataHash;
    return this;
  }

   /**
   * Get dataHash
   * @return dataHash
  **/
  @javax.annotation.Nullable

  public String getDataHash() {
    return dataHash;
  }


  public void setDataHash(String dataHash) {
    this.dataHash = dataHash;
  }


  public NftInfo metadataUris(List<URI> metadataUris) {
    
    this.metadataUris = metadataUris;
    return this;
  }

  public NftInfo addMetadataUrisItem(URI metadataUrisItem) {
    if (this.metadataUris == null) {
      this.metadataUris = new ArrayList<>();
    }
    this.metadataUris.add(metadataUrisItem);
    return this;
  }

   /**
   * Get metadataUris
   * @return metadataUris
  **/
  @javax.annotation.Nullable

  public List<URI> getMetadataUris() {
    return metadataUris;
  }


  public void setMetadataUris(List<URI> metadataUris) {
    this.metadataUris = metadataUris;
  }


  public NftInfo metadataHash(String metadataHash) {
    
    this.metadataHash = metadataHash;
    return this;
  }

   /**
   * Get metadataHash
   * @return metadataHash
  **/
  @javax.annotation.Nullable

  public String getMetadataHash() {
    return metadataHash;
  }


  public void setMetadataHash(String metadataHash) {
    this.metadataHash = metadataHash;
  }


  public NftInfo licenseUris(List<URI> licenseUris) {
    
    this.licenseUris = licenseUris;
    return this;
  }

  public NftInfo addLicenseUrisItem(URI licenseUrisItem) {
    if (this.licenseUris == null) {
      this.licenseUris = new ArrayList<>();
    }
    this.licenseUris.add(licenseUrisItem);
    return this;
  }

   /**
   * Get licenseUris
   * @return licenseUris
  **/
  @javax.annotation.Nullable

  public List<URI> getLicenseUris() {
    return licenseUris;
  }


  public void setLicenseUris(List<URI> licenseUris) {
    this.licenseUris = licenseUris;
  }


  public NftInfo licenseHash(String licenseHash) {
    
    this.licenseHash = licenseHash;
    return this;
  }

   /**
   * Get licenseHash
   * @return licenseHash
  **/
  @javax.annotation.Nullable

  public String getLicenseHash() {
    return licenseHash;
  }


  public void setLicenseHash(String licenseHash) {
    this.licenseHash = licenseHash;
  }


  public NftInfo editionTotal(Integer editionTotal) {
    
    this.editionTotal = editionTotal;
    return this;
  }

   /**
   * Get editionTotal
   * @return editionTotal
  **/
  @javax.annotation.Nullable

  public Integer getEditionTotal() {
    return editionTotal;
  }


  public void setEditionTotal(Integer editionTotal) {
    this.editionTotal = editionTotal;
  }


  public NftInfo editionNumber(Integer editionNumber) {
    
    this.editionNumber = editionNumber;
    return this;
  }

   /**
   * Get editionNumber
   * @return editionNumber
  **/
  @javax.annotation.Nullable

  public Integer getEditionNumber() {
    return editionNumber;
  }


  public void setEditionNumber(Integer editionNumber) {
    this.editionNumber = editionNumber;
  }


  public NftInfo updaterPuzhash(String updaterPuzhash) {
    
    this.updaterPuzhash = updaterPuzhash;
    return this;
  }

   /**
   * Get updaterPuzhash
   * @return updaterPuzhash
  **/
  @javax.annotation.Nullable

  public String getUpdaterPuzhash() {
    return updaterPuzhash;
  }


  public void setUpdaterPuzhash(String updaterPuzhash) {
    this.updaterPuzhash = updaterPuzhash;
  }


  public NftInfo chainInfo(String chainInfo) {
    
    this.chainInfo = chainInfo;
    return this;
  }

   /**
   * Get chainInfo
   * @return chainInfo
  **/
  @javax.annotation.Nullable

  public String getChainInfo() {
    return chainInfo;
  }


  public void setChainInfo(String chainInfo) {
    this.chainInfo = chainInfo;
  }


  public NftInfo mintHeight(Integer mintHeight) {
    
    this.mintHeight = mintHeight;
    return this;
  }

   /**
   * Get mintHeight
   * @return mintHeight
  **/
  @javax.annotation.Nullable

  public Integer getMintHeight() {
    return mintHeight;
  }


  public void setMintHeight(Integer mintHeight) {
    this.mintHeight = mintHeight;
  }


  public NftInfo supportsDid(Boolean supportsDid) {
    
    this.supportsDid = supportsDid;
    return this;
  }

   /**
   * Get supportsDid
   * @return supportsDid
  **/
  @javax.annotation.Nullable

  public Boolean getSupportsDid() {
    return supportsDid;
  }


  public void setSupportsDid(Boolean supportsDid) {
    this.supportsDid = supportsDid;
  }


  public NftInfo pendingTransaction(Boolean pendingTransaction) {
    
    this.pendingTransaction = pendingTransaction;
    return this;
  }

   /**
   * Get pendingTransaction
   * @return pendingTransaction
  **/
  @javax.annotation.Nullable

  public Boolean getPendingTransaction() {
    return pendingTransaction;
  }


  public void setPendingTransaction(Boolean pendingTransaction) {
    this.pendingTransaction = pendingTransaction;
  }


  public NftInfo launcherPuzhash(String launcherPuzhash) {
    
    this.launcherPuzhash = launcherPuzhash;
    return this;
  }

   /**
   * Get launcherPuzhash
   * @return launcherPuzhash
  **/
  @javax.annotation.Nullable

  public String getLauncherPuzhash() {
    return launcherPuzhash;
  }


  public void setLauncherPuzhash(String launcherPuzhash) {
    this.launcherPuzhash = launcherPuzhash;
  }


  public NftInfo minterDid(String minterDid) {
    
    this.minterDid = minterDid;
    return this;
  }

   /**
   * Get minterDid
   * @return minterDid
  **/
  @javax.annotation.Nullable

  public String getMinterDid() {
    return minterDid;
  }


  public void setMinterDid(String minterDid) {
    this.minterDid = minterDid;
  }


  public NftInfo offChainMetadata(String offChainMetadata) {
    
    this.offChainMetadata = offChainMetadata;
    return this;
  }

   /**
   * Serialized off-chain metadata
   * @return offChainMetadata
  **/
  @javax.annotation.Nullable

  public String getOffChainMetadata() {
    return offChainMetadata;
  }


  public void setOffChainMetadata(String offChainMetadata) {
    this.offChainMetadata = offChainMetadata;
  }


  public NftInfo p2Address(String p2Address) {
    
    this.p2Address = p2Address;
    return this;
  }

   /**
   * The innermost puzzle hash of the NFT
   * @return p2Address
  **/
  @javax.annotation.Nullable

  public String getP2Address() {
    return p2Address;
  }


  public void setP2Address(String p2Address) {
    this.p2Address = p2Address;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftInfo nftInfo = (NftInfo) o;
    return Objects.equals(this.launcherId, nftInfo.launcherId) &&
        Objects.equals(this.nftCoinId, nftInfo.nftCoinId) &&
        Objects.equals(this.ownerDid, nftInfo.ownerDid) &&
        Objects.equals(this.royaltyPercentage, nftInfo.royaltyPercentage) &&
        Objects.equals(this.royaltyPuzzleHash, nftInfo.royaltyPuzzleHash) &&
        Objects.equals(this.dataUris, nftInfo.dataUris) &&
        Objects.equals(this.dataHash, nftInfo.dataHash) &&
        Objects.equals(this.metadataUris, nftInfo.metadataUris) &&
        Objects.equals(this.metadataHash, nftInfo.metadataHash) &&
        Objects.equals(this.licenseUris, nftInfo.licenseUris) &&
        Objects.equals(this.licenseHash, nftInfo.licenseHash) &&
        Objects.equals(this.editionTotal, nftInfo.editionTotal) &&
        Objects.equals(this.editionNumber, nftInfo.editionNumber) &&
        Objects.equals(this.updaterPuzhash, nftInfo.updaterPuzhash) &&
        Objects.equals(this.chainInfo, nftInfo.chainInfo) &&
        Objects.equals(this.mintHeight, nftInfo.mintHeight) &&
        Objects.equals(this.supportsDid, nftInfo.supportsDid) &&
        Objects.equals(this.pendingTransaction, nftInfo.pendingTransaction) &&
        Objects.equals(this.launcherPuzhash, nftInfo.launcherPuzhash) &&
        Objects.equals(this.minterDid, nftInfo.minterDid) &&
        Objects.equals(this.offChainMetadata, nftInfo.offChainMetadata) &&
        Objects.equals(this.p2Address, nftInfo.p2Address);
  }

  @Override
  public int hashCode() {
    return Objects.hash(launcherId, nftCoinId, ownerDid, royaltyPercentage, royaltyPuzzleHash, dataUris, dataHash, metadataUris, metadataHash, licenseUris, licenseHash, editionTotal, editionNumber, updaterPuzhash, chainInfo, mintHeight, supportsDid, pendingTransaction, launcherPuzhash, minterDid, offChainMetadata, p2Address);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftInfo {\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    nftCoinId: ").append(toIndentedString(nftCoinId)).append("\n");
    sb.append("    ownerDid: ").append(toIndentedString(ownerDid)).append("\n");
    sb.append("    royaltyPercentage: ").append(toIndentedString(royaltyPercentage)).append("\n");
    sb.append("    royaltyPuzzleHash: ").append(toIndentedString(royaltyPuzzleHash)).append("\n");
    sb.append("    dataUris: ").append(toIndentedString(dataUris)).append("\n");
    sb.append("    dataHash: ").append(toIndentedString(dataHash)).append("\n");
    sb.append("    metadataUris: ").append(toIndentedString(metadataUris)).append("\n");
    sb.append("    metadataHash: ").append(toIndentedString(metadataHash)).append("\n");
    sb.append("    licenseUris: ").append(toIndentedString(licenseUris)).append("\n");
    sb.append("    licenseHash: ").append(toIndentedString(licenseHash)).append("\n");
    sb.append("    editionTotal: ").append(toIndentedString(editionTotal)).append("\n");
    sb.append("    editionNumber: ").append(toIndentedString(editionNumber)).append("\n");
    sb.append("    updaterPuzhash: ").append(toIndentedString(updaterPuzhash)).append("\n");
    sb.append("    chainInfo: ").append(toIndentedString(chainInfo)).append("\n");
    sb.append("    mintHeight: ").append(toIndentedString(mintHeight)).append("\n");
    sb.append("    supportsDid: ").append(toIndentedString(supportsDid)).append("\n");
    sb.append("    pendingTransaction: ").append(toIndentedString(pendingTransaction)).append("\n");
    sb.append("    launcherPuzhash: ").append(toIndentedString(launcherPuzhash)).append("\n");
    sb.append("    minterDid: ").append(toIndentedString(minterDid)).append("\n");
    sb.append("    offChainMetadata: ").append(toIndentedString(offChainMetadata)).append("\n");
    sb.append("    p2Address: ").append(toIndentedString(p2Address)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("launcher_id");
    openapiFields.add("nft_coin_id");
    openapiFields.add("owner_did");
    openapiFields.add("royalty_percentage");
    openapiFields.add("royalty_puzzle_hash");
    openapiFields.add("data_uris");
    openapiFields.add("data_hash");
    openapiFields.add("metadata_uris");
    openapiFields.add("metadata_hash");
    openapiFields.add("license_uris");
    openapiFields.add("license_hash");
    openapiFields.add("edition_total");
    openapiFields.add("edition_number");
    openapiFields.add("updater_puzhash");
    openapiFields.add("chain_info");
    openapiFields.add("mint_height");
    openapiFields.add("supports_did");
    openapiFields.add("pending_transaction");
    openapiFields.add("launcher_puzhash");
    openapiFields.add("minter_did");
    openapiFields.add("off_chain_metadata");
    openapiFields.add("p2_address");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftInfo is not found in the empty JSON string", NftInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("nft_coin_id") != null && !jsonObj.get("nft_coin_id").isJsonNull()) && !jsonObj.get("nft_coin_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `nft_coin_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("nft_coin_id").toString()));
      }
      if ((jsonObj.get("owner_did") != null && !jsonObj.get("owner_did").isJsonNull()) && !jsonObj.get("owner_did").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `owner_did` to be a primitive type in the JSON string but got `%s`", jsonObj.get("owner_did").toString()));
      }
      if ((jsonObj.get("royalty_puzzle_hash") != null && !jsonObj.get("royalty_puzzle_hash").isJsonNull()) && !jsonObj.get("royalty_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `royalty_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("royalty_puzzle_hash").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("data_uris") != null && !jsonObj.get("data_uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `data_uris` to be an array in the JSON string but got `%s`", jsonObj.get("data_uris").toString()));
      }
      if ((jsonObj.get("data_hash") != null && !jsonObj.get("data_hash").isJsonNull()) && !jsonObj.get("data_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `data_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("data_hash").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("metadata_uris") != null && !jsonObj.get("metadata_uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `metadata_uris` to be an array in the JSON string but got `%s`", jsonObj.get("metadata_uris").toString()));
      }
      if ((jsonObj.get("metadata_hash") != null && !jsonObj.get("metadata_hash").isJsonNull()) && !jsonObj.get("metadata_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `metadata_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("metadata_hash").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("license_uris") != null && !jsonObj.get("license_uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `license_uris` to be an array in the JSON string but got `%s`", jsonObj.get("license_uris").toString()));
      }
      if ((jsonObj.get("license_hash") != null && !jsonObj.get("license_hash").isJsonNull()) && !jsonObj.get("license_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `license_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("license_hash").toString()));
      }
      if ((jsonObj.get("updater_puzhash") != null && !jsonObj.get("updater_puzhash").isJsonNull()) && !jsonObj.get("updater_puzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `updater_puzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("updater_puzhash").toString()));
      }
      if ((jsonObj.get("chain_info") != null && !jsonObj.get("chain_info").isJsonNull()) && !jsonObj.get("chain_info").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `chain_info` to be a primitive type in the JSON string but got `%s`", jsonObj.get("chain_info").toString()));
      }
      if ((jsonObj.get("launcher_puzhash") != null && !jsonObj.get("launcher_puzhash").isJsonNull()) && !jsonObj.get("launcher_puzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_puzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_puzhash").toString()));
      }
      if ((jsonObj.get("minter_did") != null && !jsonObj.get("minter_did").isJsonNull()) && !jsonObj.get("minter_did").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `minter_did` to be a primitive type in the JSON string but got `%s`", jsonObj.get("minter_did").toString()));
      }
      if ((jsonObj.get("off_chain_metadata") != null && !jsonObj.get("off_chain_metadata").isJsonNull()) && !jsonObj.get("off_chain_metadata").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `off_chain_metadata` to be a primitive type in the JSON string but got `%s`", jsonObj.get("off_chain_metadata").toString()));
      }
      if ((jsonObj.get("p2_address") != null && !jsonObj.get("p2_address").isJsonNull()) && !jsonObj.get("p2_address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_address").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<NftInfo>() {
           @Override
           public void write(JsonWriter out, NftInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftInfo
  * @throws IOException if the JSON string is invalid with respect to NftInfo
  */
  public static NftInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftInfo.class);
  }

 /**
  * Convert an instance of NftInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

