/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.SpendBundle;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftMintBulk200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftMintBulk200ResponseAllOf {
  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public static final String SERIALIZED_NAME_NFT_ID_LIST = "nft_id_list";
  @SerializedName(SERIALIZED_NAME_NFT_ID_LIST)
  private List<String> nftIdList;

  public NftMintBulk200ResponseAllOf() {
  }

  public NftMintBulk200ResponseAllOf spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }


  public NftMintBulk200ResponseAllOf nftIdList(List<String> nftIdList) {
    
    this.nftIdList = nftIdList;
    return this;
  }

  public NftMintBulk200ResponseAllOf addNftIdListItem(String nftIdListItem) {
    if (this.nftIdList == null) {
      this.nftIdList = new ArrayList<>();
    }
    this.nftIdList.add(nftIdListItem);
    return this;
  }

   /**
   * Get nftIdList
   * @return nftIdList
  **/
  @javax.annotation.Nullable

  public List<String> getNftIdList() {
    return nftIdList;
  }


  public void setNftIdList(List<String> nftIdList) {
    this.nftIdList = nftIdList;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftMintBulk200ResponseAllOf nftMintBulk200ResponseAllOf = (NftMintBulk200ResponseAllOf) o;
    return Objects.equals(this.spendBundle, nftMintBulk200ResponseAllOf.spendBundle) &&
        Objects.equals(this.nftIdList, nftMintBulk200ResponseAllOf.nftIdList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(spendBundle, nftIdList);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftMintBulk200ResponseAllOf {\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("    nftIdList: ").append(toIndentedString(nftIdList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("spend_bundle");
    openapiFields.add("nft_id_list");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftMintBulk200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftMintBulk200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftMintBulk200ResponseAllOf is not found in the empty JSON string", NftMintBulk200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftMintBulk200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftMintBulk200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("nft_id_list") != null && !jsonObj.get("nft_id_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `nft_id_list` to be an array in the JSON string but got `%s`", jsonObj.get("nft_id_list").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftMintBulk200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftMintBulk200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftMintBulk200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftMintBulk200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<NftMintBulk200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, NftMintBulk200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftMintBulk200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftMintBulk200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftMintBulk200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to NftMintBulk200ResponseAllOf
  */
  public static NftMintBulk200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftMintBulk200ResponseAllOf.class);
  }

 /**
  * Convert an instance of NftMintBulk200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

