/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.openapitools.client.model.NftMintBulkRequestMetadataListInner;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftMintBulkRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftMintBulkRequest {
  public static final String SERIALIZED_NAME_METADATA_LIST = "metadata_list";
  @SerializedName(SERIALIZED_NAME_METADATA_LIST)
  private List<NftMintBulkRequestMetadataListInner> metadataList = new ArrayList<>();

  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_ROYALTY_ADDRESS = "royalty_address";
  @SerializedName(SERIALIZED_NAME_ROYALTY_ADDRESS)
  private String royaltyAddress;

  public static final String SERIALIZED_NAME_ROYALTY_PERCENTAGE = "royalty_percentage";
  @SerializedName(SERIALIZED_NAME_ROYALTY_PERCENTAGE)
  private Integer royaltyPercentage = 0;

  public static final String SERIALIZED_NAME_TARGET_LIST = "target_list";
  @SerializedName(SERIALIZED_NAME_TARGET_LIST)
  private List<String> targetList;

  public static final String SERIALIZED_NAME_MINT_NUMBER_START = "mint_number_start";
  @SerializedName(SERIALIZED_NAME_MINT_NUMBER_START)
  private Integer mintNumberStart = 1;

  public static final String SERIALIZED_NAME_MINT_TOTAL = "mint_total";
  @SerializedName(SERIALIZED_NAME_MINT_TOTAL)
  private Integer mintTotal;

  public static final String SERIALIZED_NAME_XCH_COIN_LIST = "xch_coin_list";
  @SerializedName(SERIALIZED_NAME_XCH_COIN_LIST)
  private List<String> xchCoinList;

  public static final String SERIALIZED_NAME_XCH_CHANGE_TARGET = "xch_change_target";
  @SerializedName(SERIALIZED_NAME_XCH_CHANGE_TARGET)
  private String xchChangeTarget;

  public static final String SERIALIZED_NAME_NEW_INNERPUZHASH = "new_innerpuzhash";
  @SerializedName(SERIALIZED_NAME_NEW_INNERPUZHASH)
  private String newInnerpuzhash;

  public static final String SERIALIZED_NAME_NEW_P2_PUZHASH = "new_p2_puzhash";
  @SerializedName(SERIALIZED_NAME_NEW_P2_PUZHASH)
  private String newP2Puzhash;

  public static final String SERIALIZED_NAME_DID_COIN_DICT = "did_coin_dict";
  @SerializedName(SERIALIZED_NAME_DID_COIN_DICT)
  private Map<String, Object> didCoinDict = new HashMap<>();

  public static final String SERIALIZED_NAME_DID_LINEAGE_PARENT_HEX = "did_lineage_parent_hex";
  @SerializedName(SERIALIZED_NAME_DID_LINEAGE_PARENT_HEX)
  private String didLineageParentHex;

  public static final String SERIALIZED_NAME_MINT_FROM_DID = "mint_from_did";
  @SerializedName(SERIALIZED_NAME_MINT_FROM_DID)
  private Boolean mintFromDid = false;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public NftMintBulkRequest() {
  }

  public NftMintBulkRequest metadataList(List<NftMintBulkRequestMetadataListInner> metadataList) {
    
    this.metadataList = metadataList;
    return this;
  }

  public NftMintBulkRequest addMetadataListItem(NftMintBulkRequestMetadataListInner metadataListItem) {
    if (this.metadataList == null) {
      this.metadataList = new ArrayList<>();
    }
    this.metadataList.add(metadataListItem);
    return this;
  }

   /**
   * A list of dicts containing the metadata for each NFT to be minted
   * @return metadataList
  **/
  @javax.annotation.Nonnull

  public List<NftMintBulkRequestMetadataListInner> getMetadataList() {
    return metadataList;
  }


  public void setMetadataList(List<NftMintBulkRequestMetadataListInner> metadataList) {
    this.metadataList = metadataList;
  }


  public NftMintBulkRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftMintBulkRequest royaltyAddress(String royaltyAddress) {
    
    this.royaltyAddress = royaltyAddress;
    return this;
  }

   /**
   * Get royaltyAddress
   * @return royaltyAddress
  **/
  @javax.annotation.Nullable

  public String getRoyaltyAddress() {
    return royaltyAddress;
  }


  public void setRoyaltyAddress(String royaltyAddress) {
    this.royaltyAddress = royaltyAddress;
  }


  public NftMintBulkRequest royaltyPercentage(Integer royaltyPercentage) {
    
    this.royaltyPercentage = royaltyPercentage;
    return this;
  }

   /**
   * Get royaltyPercentage
   * @return royaltyPercentage
  **/
  @javax.annotation.Nullable

  public Integer getRoyaltyPercentage() {
    return royaltyPercentage;
  }


  public void setRoyaltyPercentage(Integer royaltyPercentage) {
    this.royaltyPercentage = royaltyPercentage;
  }


  public NftMintBulkRequest targetList(List<String> targetList) {
    
    this.targetList = targetList;
    return this;
  }

  public NftMintBulkRequest addTargetListItem(String targetListItem) {
    if (this.targetList == null) {
      this.targetList = new ArrayList<>();
    }
    this.targetList.add(targetListItem);
    return this;
  }

   /**
   * a list of targets for transfering minted NFTs (aka airdrop)
   * @return targetList
  **/
  @javax.annotation.Nullable

  public List<String> getTargetList() {
    return targetList;
  }


  public void setTargetList(List<String> targetList) {
    this.targetList = targetList;
  }


  public NftMintBulkRequest mintNumberStart(Integer mintNumberStart) {
    
    this.mintNumberStart = mintNumberStart;
    return this;
  }

   /**
   * The starting point for mint number used in intermediate launcher puzzle
   * @return mintNumberStart
  **/
  @javax.annotation.Nullable

  public Integer getMintNumberStart() {
    return mintNumberStart;
  }


  public void setMintNumberStart(Integer mintNumberStart) {
    this.mintNumberStart = mintNumberStart;
  }


  public NftMintBulkRequest mintTotal(Integer mintTotal) {
    
    this.mintTotal = mintTotal;
    return this;
  }

   /**
   * The total number of NFTs being minted
   * @return mintTotal
  **/
  @javax.annotation.Nullable

  public Integer getMintTotal() {
    return mintTotal;
  }


  public void setMintTotal(Integer mintTotal) {
    this.mintTotal = mintTotal;
  }


  public NftMintBulkRequest xchCoinList(List<String> xchCoinList) {
    
    this.xchCoinList = xchCoinList;
    return this;
  }

  public NftMintBulkRequest addXchCoinListItem(String xchCoinListItem) {
    if (this.xchCoinList == null) {
      this.xchCoinList = new ArrayList<>();
    }
    this.xchCoinList.add(xchCoinListItem);
    return this;
  }

   /**
   * For use with bulk minting to provide the coin used for funding the minting spend. This coin can be one that will be created in the future
   * @return xchCoinList
  **/
  @javax.annotation.Nullable

  public List<String> getXchCoinList() {
    return xchCoinList;
  }


  public void setXchCoinList(List<String> xchCoinList) {
    this.xchCoinList = xchCoinList;
  }


  public NftMintBulkRequest xchChangeTarget(String xchChangeTarget) {
    
    this.xchChangeTarget = xchChangeTarget;
    return this;
  }

   /**
   * For use with bulk minting, so we can specify the puzzle hash that the change from the funding transaction goes to.
   * @return xchChangeTarget
  **/
  @javax.annotation.Nullable

  public String getXchChangeTarget() {
    return xchChangeTarget;
  }


  public void setXchChangeTarget(String xchChangeTarget) {
    this.xchChangeTarget = xchChangeTarget;
  }


  public NftMintBulkRequest newInnerpuzhash(String newInnerpuzhash) {
    
    this.newInnerpuzhash = newInnerpuzhash;
    return this;
  }

   /**
   * Get newInnerpuzhash
   * @return newInnerpuzhash
  **/
  @javax.annotation.Nullable

  public String getNewInnerpuzhash() {
    return newInnerpuzhash;
  }


  public void setNewInnerpuzhash(String newInnerpuzhash) {
    this.newInnerpuzhash = newInnerpuzhash;
  }


  public NftMintBulkRequest newP2Puzhash(String newP2Puzhash) {
    
    this.newP2Puzhash = newP2Puzhash;
    return this;
  }

   /**
   * Get newP2Puzhash
   * @return newP2Puzhash
  **/
  @javax.annotation.Nullable

  public String getNewP2Puzhash() {
    return newP2Puzhash;
  }


  public void setNewP2Puzhash(String newP2Puzhash) {
    this.newP2Puzhash = newP2Puzhash;
  }


  public NftMintBulkRequest didCoinDict(Map<String, Object> didCoinDict) {
    
    this.didCoinDict = didCoinDict;
    return this;
  }

  public NftMintBulkRequest putDidCoinDictItem(String key, Object didCoinDictItem) {
    if (this.didCoinDict == null) {
      this.didCoinDict = new HashMap<>();
    }
    this.didCoinDict.put(key, didCoinDictItem);
    return this;
  }

   /**
   * Get didCoinDict
   * @return didCoinDict
  **/
  @javax.annotation.Nullable

  public Map<String, Object> getDidCoinDict() {
    return didCoinDict;
  }


  public void setDidCoinDict(Map<String, Object> didCoinDict) {
    this.didCoinDict = didCoinDict;
  }


  public NftMintBulkRequest didLineageParentHex(String didLineageParentHex) {
    
    this.didLineageParentHex = didLineageParentHex;
    return this;
  }

   /**
   * Get didLineageParentHex
   * @return didLineageParentHex
  **/
  @javax.annotation.Nullable

  public String getDidLineageParentHex() {
    return didLineageParentHex;
  }


  public void setDidLineageParentHex(String didLineageParentHex) {
    this.didLineageParentHex = didLineageParentHex;
  }


  public NftMintBulkRequest mintFromDid(Boolean mintFromDid) {
    
    this.mintFromDid = mintFromDid;
    return this;
  }

   /**
   * Get mintFromDid
   * @return mintFromDid
  **/
  @javax.annotation.Nullable

  public Boolean getMintFromDid() {
    return mintFromDid;
  }


  public void setMintFromDid(Boolean mintFromDid) {
    this.mintFromDid = mintFromDid;
  }


  public NftMintBulkRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public NftMintBulkRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftMintBulkRequest nftMintBulkRequest = (NftMintBulkRequest) o;
    return Objects.equals(this.metadataList, nftMintBulkRequest.metadataList) &&
        Objects.equals(this.walletId, nftMintBulkRequest.walletId) &&
        Objects.equals(this.royaltyAddress, nftMintBulkRequest.royaltyAddress) &&
        Objects.equals(this.royaltyPercentage, nftMintBulkRequest.royaltyPercentage) &&
        Objects.equals(this.targetList, nftMintBulkRequest.targetList) &&
        Objects.equals(this.mintNumberStart, nftMintBulkRequest.mintNumberStart) &&
        Objects.equals(this.mintTotal, nftMintBulkRequest.mintTotal) &&
        Objects.equals(this.xchCoinList, nftMintBulkRequest.xchCoinList) &&
        Objects.equals(this.xchChangeTarget, nftMintBulkRequest.xchChangeTarget) &&
        Objects.equals(this.newInnerpuzhash, nftMintBulkRequest.newInnerpuzhash) &&
        Objects.equals(this.newP2Puzhash, nftMintBulkRequest.newP2Puzhash) &&
        Objects.equals(this.didCoinDict, nftMintBulkRequest.didCoinDict) &&
        Objects.equals(this.didLineageParentHex, nftMintBulkRequest.didLineageParentHex) &&
        Objects.equals(this.mintFromDid, nftMintBulkRequest.mintFromDid) &&
        Objects.equals(this.fee, nftMintBulkRequest.fee) &&
        Objects.equals(this.reusePuzhash, nftMintBulkRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(metadataList, walletId, royaltyAddress, royaltyPercentage, targetList, mintNumberStart, mintTotal, xchCoinList, xchChangeTarget, newInnerpuzhash, newP2Puzhash, didCoinDict, didLineageParentHex, mintFromDid, fee, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftMintBulkRequest {\n");
    sb.append("    metadataList: ").append(toIndentedString(metadataList)).append("\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    royaltyAddress: ").append(toIndentedString(royaltyAddress)).append("\n");
    sb.append("    royaltyPercentage: ").append(toIndentedString(royaltyPercentage)).append("\n");
    sb.append("    targetList: ").append(toIndentedString(targetList)).append("\n");
    sb.append("    mintNumberStart: ").append(toIndentedString(mintNumberStart)).append("\n");
    sb.append("    mintTotal: ").append(toIndentedString(mintTotal)).append("\n");
    sb.append("    xchCoinList: ").append(toIndentedString(xchCoinList)).append("\n");
    sb.append("    xchChangeTarget: ").append(toIndentedString(xchChangeTarget)).append("\n");
    sb.append("    newInnerpuzhash: ").append(toIndentedString(newInnerpuzhash)).append("\n");
    sb.append("    newP2Puzhash: ").append(toIndentedString(newP2Puzhash)).append("\n");
    sb.append("    didCoinDict: ").append(toIndentedString(didCoinDict)).append("\n");
    sb.append("    didLineageParentHex: ").append(toIndentedString(didLineageParentHex)).append("\n");
    sb.append("    mintFromDid: ").append(toIndentedString(mintFromDid)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("metadata_list");
    openapiFields.add("wallet_id");
    openapiFields.add("royalty_address");
    openapiFields.add("royalty_percentage");
    openapiFields.add("target_list");
    openapiFields.add("mint_number_start");
    openapiFields.add("mint_total");
    openapiFields.add("xch_coin_list");
    openapiFields.add("xch_change_target");
    openapiFields.add("new_innerpuzhash");
    openapiFields.add("new_p2_puzhash");
    openapiFields.add("did_coin_dict");
    openapiFields.add("did_lineage_parent_hex");
    openapiFields.add("mint_from_did");
    openapiFields.add("fee");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("metadata_list");
    openapiRequiredFields.add("wallet_id");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftMintBulkRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftMintBulkRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftMintBulkRequest is not found in the empty JSON string", NftMintBulkRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftMintBulkRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftMintBulkRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : NftMintBulkRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the json data is an array
      if (!jsonObj.get("metadata_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `metadata_list` to be an array in the JSON string but got `%s`", jsonObj.get("metadata_list").toString()));
      }

      JsonArray jsonArraymetadataList = jsonObj.getAsJsonArray("metadata_list");
      // validate the required field `metadata_list` (array)
      for (int i = 0; i < jsonArraymetadataList.size(); i++) {
        NftMintBulkRequestMetadataListInner.validateJsonObject(jsonArraymetadataList.get(i).getAsJsonObject());
      };
      if ((jsonObj.get("royalty_address") != null && !jsonObj.get("royalty_address").isJsonNull()) && !jsonObj.get("royalty_address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `royalty_address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("royalty_address").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("target_list") != null && !jsonObj.get("target_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_list` to be an array in the JSON string but got `%s`", jsonObj.get("target_list").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("xch_coin_list") != null && !jsonObj.get("xch_coin_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `xch_coin_list` to be an array in the JSON string but got `%s`", jsonObj.get("xch_coin_list").toString()));
      }
      if ((jsonObj.get("xch_change_target") != null && !jsonObj.get("xch_change_target").isJsonNull()) && !jsonObj.get("xch_change_target").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `xch_change_target` to be a primitive type in the JSON string but got `%s`", jsonObj.get("xch_change_target").toString()));
      }
      if ((jsonObj.get("new_innerpuzhash") != null && !jsonObj.get("new_innerpuzhash").isJsonNull()) && !jsonObj.get("new_innerpuzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `new_innerpuzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("new_innerpuzhash").toString()));
      }
      if ((jsonObj.get("new_p2_puzhash") != null && !jsonObj.get("new_p2_puzhash").isJsonNull()) && !jsonObj.get("new_p2_puzhash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `new_p2_puzhash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("new_p2_puzhash").toString()));
      }
      if ((jsonObj.get("did_lineage_parent_hex") != null && !jsonObj.get("did_lineage_parent_hex").isJsonNull()) && !jsonObj.get("did_lineage_parent_hex").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `did_lineage_parent_hex` to be a primitive type in the JSON string but got `%s`", jsonObj.get("did_lineage_parent_hex").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftMintBulkRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftMintBulkRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftMintBulkRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftMintBulkRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<NftMintBulkRequest>() {
           @Override
           public void write(JsonWriter out, NftMintBulkRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftMintBulkRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftMintBulkRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftMintBulkRequest
  * @throws IOException if the JSON string is invalid with respect to NftMintBulkRequest
  */
  public static NftMintBulkRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftMintBulkRequest.class);
  }

 /**
  * Convert an instance of NftMintBulkRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

