/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.net.URI;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftMintBulkRequestMetadataListInner
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftMintBulkRequestMetadataListInner {
  public static final String SERIALIZED_NAME_URIS = "uris";
  @SerializedName(SERIALIZED_NAME_URIS)
  private List<URI> uris = new ArrayList<>();

  public static final String SERIALIZED_NAME_META_URIS = "meta_uris";
  @SerializedName(SERIALIZED_NAME_META_URIS)
  private List<URI> metaUris = new ArrayList<>();

  public static final String SERIALIZED_NAME_LICENSE_URIS = "license_uris";
  @SerializedName(SERIALIZED_NAME_LICENSE_URIS)
  private List<URI> licenseUris;

  public static final String SERIALIZED_NAME_HASH = "hash";
  @SerializedName(SERIALIZED_NAME_HASH)
  private String hash;

  public static final String SERIALIZED_NAME_META_HASH = "meta_hash";
  @SerializedName(SERIALIZED_NAME_META_HASH)
  private String metaHash;

  public static final String SERIALIZED_NAME_LICENSE_HASH = "license_hash";
  @SerializedName(SERIALIZED_NAME_LICENSE_HASH)
  private String licenseHash;

  public static final String SERIALIZED_NAME_EDITION_NUMBER = "edition_number";
  @SerializedName(SERIALIZED_NAME_EDITION_NUMBER)
  private Integer editionNumber = 1;

  public static final String SERIALIZED_NAME_EDITION_TOTAL = "edition_total";
  @SerializedName(SERIALIZED_NAME_EDITION_TOTAL)
  private Integer editionTotal = 1;

  public NftMintBulkRequestMetadataListInner() {
  }

  public NftMintBulkRequestMetadataListInner uris(List<URI> uris) {
    
    this.uris = uris;
    return this;
  }

  public NftMintBulkRequestMetadataListInner addUrisItem(URI urisItem) {
    if (this.uris == null) {
      this.uris = new ArrayList<>();
    }
    this.uris.add(urisItem);
    return this;
  }

   /**
   * Get uris
   * @return uris
  **/
  @javax.annotation.Nonnull

  public List<URI> getUris() {
    return uris;
  }


  public void setUris(List<URI> uris) {
    this.uris = uris;
  }


  public NftMintBulkRequestMetadataListInner metaUris(List<URI> metaUris) {
    
    this.metaUris = metaUris;
    return this;
  }

  public NftMintBulkRequestMetadataListInner addMetaUrisItem(URI metaUrisItem) {
    if (this.metaUris == null) {
      this.metaUris = new ArrayList<>();
    }
    this.metaUris.add(metaUrisItem);
    return this;
  }

   /**
   * Get metaUris
   * @return metaUris
  **/
  @javax.annotation.Nonnull

  public List<URI> getMetaUris() {
    return metaUris;
  }


  public void setMetaUris(List<URI> metaUris) {
    this.metaUris = metaUris;
  }


  public NftMintBulkRequestMetadataListInner licenseUris(List<URI> licenseUris) {
    
    this.licenseUris = licenseUris;
    return this;
  }

  public NftMintBulkRequestMetadataListInner addLicenseUrisItem(URI licenseUrisItem) {
    if (this.licenseUris == null) {
      this.licenseUris = new ArrayList<>();
    }
    this.licenseUris.add(licenseUrisItem);
    return this;
  }

   /**
   * Get licenseUris
   * @return licenseUris
  **/
  @javax.annotation.Nullable

  public List<URI> getLicenseUris() {
    return licenseUris;
  }


  public void setLicenseUris(List<URI> licenseUris) {
    this.licenseUris = licenseUris;
  }


  public NftMintBulkRequestMetadataListInner hash(String hash) {
    
    this.hash = hash;
    return this;
  }

   /**
   * Get hash
   * @return hash
  **/
  @javax.annotation.Nullable

  public String getHash() {
    return hash;
  }


  public void setHash(String hash) {
    this.hash = hash;
  }


  public NftMintBulkRequestMetadataListInner metaHash(String metaHash) {
    
    this.metaHash = metaHash;
    return this;
  }

   /**
   * Get metaHash
   * @return metaHash
  **/
  @javax.annotation.Nullable

  public String getMetaHash() {
    return metaHash;
  }


  public void setMetaHash(String metaHash) {
    this.metaHash = metaHash;
  }


  public NftMintBulkRequestMetadataListInner licenseHash(String licenseHash) {
    
    this.licenseHash = licenseHash;
    return this;
  }

   /**
   * Get licenseHash
   * @return licenseHash
  **/
  @javax.annotation.Nullable

  public String getLicenseHash() {
    return licenseHash;
  }


  public void setLicenseHash(String licenseHash) {
    this.licenseHash = licenseHash;
  }


  public NftMintBulkRequestMetadataListInner editionNumber(Integer editionNumber) {
    
    this.editionNumber = editionNumber;
    return this;
  }

   /**
   * Get editionNumber
   * @return editionNumber
  **/
  @javax.annotation.Nullable

  public Integer getEditionNumber() {
    return editionNumber;
  }


  public void setEditionNumber(Integer editionNumber) {
    this.editionNumber = editionNumber;
  }


  public NftMintBulkRequestMetadataListInner editionTotal(Integer editionTotal) {
    
    this.editionTotal = editionTotal;
    return this;
  }

   /**
   * Get editionTotal
   * @return editionTotal
  **/
  @javax.annotation.Nullable

  public Integer getEditionTotal() {
    return editionTotal;
  }


  public void setEditionTotal(Integer editionTotal) {
    this.editionTotal = editionTotal;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftMintBulkRequestMetadataListInner nftMintBulkRequestMetadataListInner = (NftMintBulkRequestMetadataListInner) o;
    return Objects.equals(this.uris, nftMintBulkRequestMetadataListInner.uris) &&
        Objects.equals(this.metaUris, nftMintBulkRequestMetadataListInner.metaUris) &&
        Objects.equals(this.licenseUris, nftMintBulkRequestMetadataListInner.licenseUris) &&
        Objects.equals(this.hash, nftMintBulkRequestMetadataListInner.hash) &&
        Objects.equals(this.metaHash, nftMintBulkRequestMetadataListInner.metaHash) &&
        Objects.equals(this.licenseHash, nftMintBulkRequestMetadataListInner.licenseHash) &&
        Objects.equals(this.editionNumber, nftMintBulkRequestMetadataListInner.editionNumber) &&
        Objects.equals(this.editionTotal, nftMintBulkRequestMetadataListInner.editionTotal);
  }

  @Override
  public int hashCode() {
    return Objects.hash(uris, metaUris, licenseUris, hash, metaHash, licenseHash, editionNumber, editionTotal);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftMintBulkRequestMetadataListInner {\n");
    sb.append("    uris: ").append(toIndentedString(uris)).append("\n");
    sb.append("    metaUris: ").append(toIndentedString(metaUris)).append("\n");
    sb.append("    licenseUris: ").append(toIndentedString(licenseUris)).append("\n");
    sb.append("    hash: ").append(toIndentedString(hash)).append("\n");
    sb.append("    metaHash: ").append(toIndentedString(metaHash)).append("\n");
    sb.append("    licenseHash: ").append(toIndentedString(licenseHash)).append("\n");
    sb.append("    editionNumber: ").append(toIndentedString(editionNumber)).append("\n");
    sb.append("    editionTotal: ").append(toIndentedString(editionTotal)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("uris");
    openapiFields.add("meta_uris");
    openapiFields.add("license_uris");
    openapiFields.add("hash");
    openapiFields.add("meta_hash");
    openapiFields.add("license_hash");
    openapiFields.add("edition_number");
    openapiFields.add("edition_total");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("uris");
    openapiRequiredFields.add("meta_uris");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftMintBulkRequestMetadataListInner
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftMintBulkRequestMetadataListInner.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftMintBulkRequestMetadataListInner is not found in the empty JSON string", NftMintBulkRequestMetadataListInner.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftMintBulkRequestMetadataListInner.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftMintBulkRequestMetadataListInner` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : NftMintBulkRequestMetadataListInner.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the required json array is present
      if (jsonObj.get("uris") == null) {
        throw new IllegalArgumentException("Expected the field `linkedContent` to be an array in the JSON string but got `null`");
      } else if (!jsonObj.get("uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `uris` to be an array in the JSON string but got `%s`", jsonObj.get("uris").toString()));
      }
      // ensure the required json array is present
      if (jsonObj.get("meta_uris") == null) {
        throw new IllegalArgumentException("Expected the field `linkedContent` to be an array in the JSON string but got `null`");
      } else if (!jsonObj.get("meta_uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `meta_uris` to be an array in the JSON string but got `%s`", jsonObj.get("meta_uris").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("license_uris") != null && !jsonObj.get("license_uris").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `license_uris` to be an array in the JSON string but got `%s`", jsonObj.get("license_uris").toString()));
      }
      if ((jsonObj.get("hash") != null && !jsonObj.get("hash").isJsonNull()) && !jsonObj.get("hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("hash").toString()));
      }
      if ((jsonObj.get("meta_hash") != null && !jsonObj.get("meta_hash").isJsonNull()) && !jsonObj.get("meta_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `meta_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("meta_hash").toString()));
      }
      if ((jsonObj.get("license_hash") != null && !jsonObj.get("license_hash").isJsonNull()) && !jsonObj.get("license_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `license_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("license_hash").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftMintBulkRequestMetadataListInner.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftMintBulkRequestMetadataListInner' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftMintBulkRequestMetadataListInner> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftMintBulkRequestMetadataListInner.class));

       return (TypeAdapter<T>) new TypeAdapter<NftMintBulkRequestMetadataListInner>() {
           @Override
           public void write(JsonWriter out, NftMintBulkRequestMetadataListInner value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftMintBulkRequestMetadataListInner read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftMintBulkRequestMetadataListInner given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftMintBulkRequestMetadataListInner
  * @throws IOException if the JSON string is invalid with respect to NftMintBulkRequestMetadataListInner
  */
  public static NftMintBulkRequestMetadataListInner fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftMintBulkRequestMetadataListInner.class);
  }

 /**
  * Convert an instance of NftMintBulkRequestMetadataListInner to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

