/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.SpendBundle;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftMintNft200Response
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftMintNft200Response {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public static final String SERIALIZED_NAME_NFT_ID = "nft_id";
  @SerializedName(SERIALIZED_NAME_NFT_ID)
  private String nftId;

  public static final String SERIALIZED_NAME_SUCCESS = "success";
  @SerializedName(SERIALIZED_NAME_SUCCESS)
  private Boolean success;

  public static final String SERIALIZED_NAME_ERROR = "error";
  @SerializedName(SERIALIZED_NAME_ERROR)
  private String error;

  public NftMintNft200Response() {
  }

  public NftMintNft200Response walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftMintNft200Response spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }


  public NftMintNft200Response nftId(String nftId) {
    
    this.nftId = nftId;
    return this;
  }

   /**
   * Get nftId
   * @return nftId
  **/
  @javax.annotation.Nullable

  public String getNftId() {
    return nftId;
  }


  public void setNftId(String nftId) {
    this.nftId = nftId;
  }


  public NftMintNft200Response success(Boolean success) {
    
    this.success = success;
    return this;
  }

   /**
   * Success/failure indicator
   * @return success
  **/
  @javax.annotation.Nonnull

  public Boolean getSuccess() {
    return success;
  }


  public void setSuccess(Boolean success) {
    this.success = success;
  }


  public NftMintNft200Response error(String error) {
    
    this.error = error;
    return this;
  }

   /**
   * Only present when success is false
   * @return error
  **/
  @javax.annotation.Nullable

  public String getError() {
    return error;
  }


  public void setError(String error) {
    this.error = error;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftMintNft200Response nftMintNft200Response = (NftMintNft200Response) o;
    return Objects.equals(this.walletId, nftMintNft200Response.walletId) &&
        Objects.equals(this.spendBundle, nftMintNft200Response.spendBundle) &&
        Objects.equals(this.nftId, nftMintNft200Response.nftId) &&
        Objects.equals(this.success, nftMintNft200Response.success) &&
        Objects.equals(this.error, nftMintNft200Response.error);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, spendBundle, nftId, success, error);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftMintNft200Response {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("    nftId: ").append(toIndentedString(nftId)).append("\n");
    sb.append("    success: ").append(toIndentedString(success)).append("\n");
    sb.append("    error: ").append(toIndentedString(error)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("spend_bundle");
    openapiFields.add("nft_id");
    openapiFields.add("success");
    openapiFields.add("error");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("success");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftMintNft200Response
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftMintNft200Response.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftMintNft200Response is not found in the empty JSON string", NftMintNft200Response.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftMintNft200Response.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftMintNft200Response` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : NftMintNft200Response.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
      if ((jsonObj.get("nft_id") != null && !jsonObj.get("nft_id").isJsonNull()) && !jsonObj.get("nft_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `nft_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("nft_id").toString()));
      }
      if ((jsonObj.get("error") != null && !jsonObj.get("error").isJsonNull()) && !jsonObj.get("error").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `error` to be a primitive type in the JSON string but got `%s`", jsonObj.get("error").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftMintNft200Response.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftMintNft200Response' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftMintNft200Response> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftMintNft200Response.class));

       return (TypeAdapter<T>) new TypeAdapter<NftMintNft200Response>() {
           @Override
           public void write(JsonWriter out, NftMintNft200Response value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftMintNft200Response read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftMintNft200Response given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftMintNft200Response
  * @throws IOException if the JSON string is invalid with respect to NftMintNft200Response
  */
  public static NftMintNft200Response fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftMintNft200Response.class);
  }

 /**
  * Convert an instance of NftMintNft200Response to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

