/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.SpendBundle;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftSetDidBulk200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftSetDidBulk200ResponseAllOf {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_TX_NUM = "tx_num";
  @SerializedName(SERIALIZED_NAME_TX_NUM)
  private Integer txNum;

  public static final String SERIALIZED_NAME_SPEND_BUNDLE = "spend_bundle";
  @SerializedName(SERIALIZED_NAME_SPEND_BUNDLE)
  private SpendBundle spendBundle;

  public NftSetDidBulk200ResponseAllOf() {
  }

  public NftSetDidBulk200ResponseAllOf walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nullable

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public NftSetDidBulk200ResponseAllOf txNum(Integer txNum) {
    
    this.txNum = txNum;
    return this;
  }

   /**
   * Get txNum
   * @return txNum
  **/
  @javax.annotation.Nullable

  public Integer getTxNum() {
    return txNum;
  }


  public void setTxNum(Integer txNum) {
    this.txNum = txNum;
  }


  public NftSetDidBulk200ResponseAllOf spendBundle(SpendBundle spendBundle) {
    
    this.spendBundle = spendBundle;
    return this;
  }

   /**
   * Get spendBundle
   * @return spendBundle
  **/
  @javax.annotation.Nullable

  public SpendBundle getSpendBundle() {
    return spendBundle;
  }


  public void setSpendBundle(SpendBundle spendBundle) {
    this.spendBundle = spendBundle;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftSetDidBulk200ResponseAllOf nftSetDidBulk200ResponseAllOf = (NftSetDidBulk200ResponseAllOf) o;
    return Objects.equals(this.walletId, nftSetDidBulk200ResponseAllOf.walletId) &&
        Objects.equals(this.txNum, nftSetDidBulk200ResponseAllOf.txNum) &&
        Objects.equals(this.spendBundle, nftSetDidBulk200ResponseAllOf.spendBundle);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, txNum, spendBundle);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftSetDidBulk200ResponseAllOf {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    txNum: ").append(toIndentedString(txNum)).append("\n");
    sb.append("    spendBundle: ").append(toIndentedString(spendBundle)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("tx_num");
    openapiFields.add("spend_bundle");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftSetDidBulk200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftSetDidBulk200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftSetDidBulk200ResponseAllOf is not found in the empty JSON string", NftSetDidBulk200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftSetDidBulk200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftSetDidBulk200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `spend_bundle`
      if (jsonObj.get("spend_bundle") != null && !jsonObj.get("spend_bundle").isJsonNull()) {
        SpendBundle.validateJsonObject(jsonObj.getAsJsonObject("spend_bundle"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftSetDidBulk200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftSetDidBulk200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftSetDidBulk200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftSetDidBulk200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<NftSetDidBulk200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, NftSetDidBulk200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftSetDidBulk200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftSetDidBulk200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftSetDidBulk200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to NftSetDidBulk200ResponseAllOf
  */
  public static NftSetDidBulk200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftSetDidBulk200ResponseAllOf.class);
  }

 /**
  * Convert an instance of NftSetDidBulk200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

