/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.NftSetDidBulkRequestNftCoinListInner;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * NftTransferBulkRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class NftTransferBulkRequest {
  public static final String SERIALIZED_NAME_NFT_COIN_LIST = "nft_coin_list";
  @SerializedName(SERIALIZED_NAME_NFT_COIN_LIST)
  private List<NftSetDidBulkRequestNftCoinListInner> nftCoinList = new ArrayList<>();

  public static final String SERIALIZED_NAME_TARGET_ADDRESS = "target_address";
  @SerializedName(SERIALIZED_NAME_TARGET_ADDRESS)
  private String targetAddress;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public NftTransferBulkRequest() {
  }

  public NftTransferBulkRequest nftCoinList(List<NftSetDidBulkRequestNftCoinListInner> nftCoinList) {
    
    this.nftCoinList = nftCoinList;
    return this;
  }

  public NftTransferBulkRequest addNftCoinListItem(NftSetDidBulkRequestNftCoinListInner nftCoinListItem) {
    if (this.nftCoinList == null) {
      this.nftCoinList = new ArrayList<>();
    }
    this.nftCoinList.add(nftCoinListItem);
    return this;
  }

   /**
   * Get nftCoinList
   * @return nftCoinList
  **/
  @javax.annotation.Nonnull

  public List<NftSetDidBulkRequestNftCoinListInner> getNftCoinList() {
    return nftCoinList;
  }


  public void setNftCoinList(List<NftSetDidBulkRequestNftCoinListInner> nftCoinList) {
    this.nftCoinList = nftCoinList;
  }


  public NftTransferBulkRequest targetAddress(String targetAddress) {
    
    this.targetAddress = targetAddress;
    return this;
  }

   /**
   * Get targetAddress
   * @return targetAddress
  **/
  @javax.annotation.Nullable

  public String getTargetAddress() {
    return targetAddress;
  }


  public void setTargetAddress(String targetAddress) {
    this.targetAddress = targetAddress;
  }


  public NftTransferBulkRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public NftTransferBulkRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NftTransferBulkRequest nftTransferBulkRequest = (NftTransferBulkRequest) o;
    return Objects.equals(this.nftCoinList, nftTransferBulkRequest.nftCoinList) &&
        Objects.equals(this.targetAddress, nftTransferBulkRequest.targetAddress) &&
        Objects.equals(this.fee, nftTransferBulkRequest.fee) &&
        Objects.equals(this.reusePuzhash, nftTransferBulkRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(nftCoinList, targetAddress, fee, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NftTransferBulkRequest {\n");
    sb.append("    nftCoinList: ").append(toIndentedString(nftCoinList)).append("\n");
    sb.append("    targetAddress: ").append(toIndentedString(targetAddress)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("nft_coin_list");
    openapiFields.add("target_address");
    openapiFields.add("fee");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("nft_coin_list");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to NftTransferBulkRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!NftTransferBulkRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in NftTransferBulkRequest is not found in the empty JSON string", NftTransferBulkRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!NftTransferBulkRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `NftTransferBulkRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : NftTransferBulkRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the json data is an array
      if (!jsonObj.get("nft_coin_list").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `nft_coin_list` to be an array in the JSON string but got `%s`", jsonObj.get("nft_coin_list").toString()));
      }

      JsonArray jsonArraynftCoinList = jsonObj.getAsJsonArray("nft_coin_list");
      // validate the required field `nft_coin_list` (array)
      for (int i = 0; i < jsonArraynftCoinList.size(); i++) {
        NftSetDidBulkRequestNftCoinListInner.validateJsonObject(jsonArraynftCoinList.get(i).getAsJsonObject());
      };
      if ((jsonObj.get("target_address") != null && !jsonObj.get("target_address").isJsonNull()) && !jsonObj.get("target_address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("target_address").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!NftTransferBulkRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'NftTransferBulkRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<NftTransferBulkRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(NftTransferBulkRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<NftTransferBulkRequest>() {
           @Override
           public void write(JsonWriter out, NftTransferBulkRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public NftTransferBulkRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of NftTransferBulkRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of NftTransferBulkRequest
  * @throws IOException if the JSON string is invalid with respect to NftTransferBulkRequest
  */
  public static NftTransferBulkRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, NftTransferBulkRequest.class);
  }

 /**
  * Convert an instance of NftTransferBulkRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

