/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.annotations.SerializedName;

import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * \&quot;From the user&#39;s point of view, a pool group can be in these states:   &#x60;1 SELF_POOLING&#x60;: The singleton exists on the blockchain, and we are farming       block rewards to a wallet address controlled by the user   &#x60;2 LEAVING_POOL&#x60;: The singleton exists, and we have entered the \&quot;escaping\&quot; state, which       means we are waiting for a number of blocks &#x3D; &#x60;relative_lock_height&#x60; to pass, so we can leave.   &#x60;3 FARMING_TO_POOL&#x60;: The singleton exists, and it is assigned to a pool.   &#x60;CLAIMING_SELF_POOLED_REWARDS&#x60;: We have submitted a transaction to sweep our       self-pooled funds.\&quot;
 */
@JsonAdapter(PoolSingletonState.Adapter.class)
public enum PoolSingletonState {
  
  NUMBER_1(1),
  
  NUMBER_2(2),
  
  NUMBER_3(3);

  private Integer value;

  PoolSingletonState(Integer value) {
    this.value = value;
  }

  public Integer getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static PoolSingletonState fromValue(Integer value) {
    for (PoolSingletonState b : PoolSingletonState.values()) {
      if (b.value.equals(value)) {
        return b;
      }
    }
    throw new IllegalArgumentException("Unexpected value '" + value + "'");
  }

  public static class Adapter extends TypeAdapter<PoolSingletonState> {
    @Override
    public void write(final JsonWriter jsonWriter, final PoolSingletonState enumeration) throws IOException {
      jsonWriter.value(enumeration.getValue());
    }

    @Override
    public PoolSingletonState read(final JsonReader jsonReader) throws IOException {
      Integer value = jsonReader.nextInt();
      return PoolSingletonState.fromValue(value);
    }
  }
}

