/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.PoolSingletonState;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * &#x60;PoolState&#x60; is a type that is serialized to the blockchain to track the state of the user&#39;s pool singleton &#x60;target_puzzle_hash&#x60; is either the pool address, or the self-pooling address that pool rewards will be paid to. &#x60;target_puzzle_hash&#x60; is NOT the p2_singleton puzzle that block rewards are sent to. The &#x60;p2_singleton&#x60; address is the initial address, and the &#x60;target_puzzle_hash&#x60; is the final destination. &#x60;relative_lock_height&#x60; is zero when in SELF_POOLING state
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class PoolState {
  public static final String SERIALIZED_NAME_VERSION = "version";
  @SerializedName(SERIALIZED_NAME_VERSION)
  private Integer version;

  public static final String SERIALIZED_NAME_STATE = "state";
  @SerializedName(SERIALIZED_NAME_STATE)
  private PoolSingletonState state;

  public static final String SERIALIZED_NAME_TARGET_PUZZLE_HASH = "target_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_TARGET_PUZZLE_HASH)
  private String targetPuzzleHash;

  public static final String SERIALIZED_NAME_OWNER_PUBKEY = "owner_pubkey";
  @SerializedName(SERIALIZED_NAME_OWNER_PUBKEY)
  private String ownerPubkey;

  public static final String SERIALIZED_NAME_POOL_URL = "pool_url";
  @SerializedName(SERIALIZED_NAME_POOL_URL)
  private String poolUrl;

  public static final String SERIALIZED_NAME_RELATIVE_LOCK_HEIGHT = "relative_lock_height";
  @SerializedName(SERIALIZED_NAME_RELATIVE_LOCK_HEIGHT)
  private Integer relativeLockHeight;

  public PoolState() {
  }

  public PoolState version(Integer version) {
    
    this.version = version;
    return this;
  }

   /**
   * Get version
   * @return version
  **/
  @javax.annotation.Nullable

  public Integer getVersion() {
    return version;
  }


  public void setVersion(Integer version) {
    this.version = version;
  }


  public PoolState state(PoolSingletonState state) {
    
    this.state = state;
    return this;
  }

   /**
   * Get state
   * @return state
  **/
  @javax.annotation.Nullable

  public PoolSingletonState getState() {
    return state;
  }


  public void setState(PoolSingletonState state) {
    this.state = state;
  }


  public PoolState targetPuzzleHash(String targetPuzzleHash) {
    
    this.targetPuzzleHash = targetPuzzleHash;
    return this;
  }

   /**
   * -&gt; A puzzle_hash we pay to. When self-farming, this is a main wallet address When farming-to-pool, the pool sends this to the farmer during pool protocol setup
   * @return targetPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getTargetPuzzleHash() {
    return targetPuzzleHash;
  }


  public void setTargetPuzzleHash(String targetPuzzleHash) {
    this.targetPuzzleHash = targetPuzzleHash;
  }


  public PoolState ownerPubkey(String ownerPubkey) {
    
    this.ownerPubkey = ownerPubkey;
    return this;
  }

   /**
   * Get ownerPubkey
   * @return ownerPubkey
  **/
  @javax.annotation.Nullable

  public String getOwnerPubkey() {
    return ownerPubkey;
  }


  public void setOwnerPubkey(String ownerPubkey) {
    this.ownerPubkey = ownerPubkey;
  }


  public PoolState poolUrl(String poolUrl) {
    
    this.poolUrl = poolUrl;
    return this;
  }

   /**
   * Get poolUrl
   * @return poolUrl
  **/
  @javax.annotation.Nullable

  public String getPoolUrl() {
    return poolUrl;
  }


  public void setPoolUrl(String poolUrl) {
    this.poolUrl = poolUrl;
  }


  public PoolState relativeLockHeight(Integer relativeLockHeight) {
    
    this.relativeLockHeight = relativeLockHeight;
    return this;
  }

   /**
   * Get relativeLockHeight
   * @return relativeLockHeight
  **/
  @javax.annotation.Nullable

  public Integer getRelativeLockHeight() {
    return relativeLockHeight;
  }


  public void setRelativeLockHeight(Integer relativeLockHeight) {
    this.relativeLockHeight = relativeLockHeight;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PoolState poolState = (PoolState) o;
    return Objects.equals(this.version, poolState.version) &&
        Objects.equals(this.state, poolState.state) &&
        Objects.equals(this.targetPuzzleHash, poolState.targetPuzzleHash) &&
        Objects.equals(this.ownerPubkey, poolState.ownerPubkey) &&
        Objects.equals(this.poolUrl, poolState.poolUrl) &&
        Objects.equals(this.relativeLockHeight, poolState.relativeLockHeight);
  }

  @Override
  public int hashCode() {
    return Objects.hash(version, state, targetPuzzleHash, ownerPubkey, poolUrl, relativeLockHeight);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PoolState {\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("    targetPuzzleHash: ").append(toIndentedString(targetPuzzleHash)).append("\n");
    sb.append("    ownerPubkey: ").append(toIndentedString(ownerPubkey)).append("\n");
    sb.append("    poolUrl: ").append(toIndentedString(poolUrl)).append("\n");
    sb.append("    relativeLockHeight: ").append(toIndentedString(relativeLockHeight)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("version");
    openapiFields.add("state");
    openapiFields.add("target_puzzle_hash");
    openapiFields.add("owner_pubkey");
    openapiFields.add("pool_url");
    openapiFields.add("relative_lock_height");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PoolState
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PoolState.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PoolState is not found in the empty JSON string", PoolState.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PoolState.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PoolState` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("target_puzzle_hash") != null && !jsonObj.get("target_puzzle_hash").isJsonNull()) && !jsonObj.get("target_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("target_puzzle_hash").toString()));
      }
      if ((jsonObj.get("owner_pubkey") != null && !jsonObj.get("owner_pubkey").isJsonNull()) && !jsonObj.get("owner_pubkey").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `owner_pubkey` to be a primitive type in the JSON string but got `%s`", jsonObj.get("owner_pubkey").toString()));
      }
      if ((jsonObj.get("pool_url") != null && !jsonObj.get("pool_url").isJsonNull()) && !jsonObj.get("pool_url").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_url` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_url").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PoolState.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PoolState' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PoolState> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PoolState.class));

       return (TypeAdapter<T>) new TypeAdapter<PoolState>() {
           @Override
           public void write(JsonWriter out, PoolState value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PoolState read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PoolState given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PoolState
  * @throws IOException if the JSON string is invalid with respect to PoolState
  */
  public static PoolState fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PoolState.class);
  }

 /**
  * Convert an instance of PoolState to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

