/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.PoolState;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Internal Pool Wallet state, not destined for the blockchain. This can be completely derived with the Singleton&#39;s CoinSpends list, or with the information from the WalletPoolStore.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class PoolWalletInfo {
  public static final String SERIALIZED_NAME_CURRENT = "current";
  @SerializedName(SERIALIZED_NAME_CURRENT)
  private PoolState current;

  public static final String SERIALIZED_NAME_TARGET = "target";
  @SerializedName(SERIALIZED_NAME_TARGET)
  private PoolState target;

  public static final String SERIALIZED_NAME_LAUNCHER_COIN = "launcher_coin";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_COIN)
  private Coin launcherCoin;

  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH = "p2_singleton_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_P2_SINGLETON_PUZZLE_HASH)
  private String p2SingletonPuzzleHash;

  public static final String SERIALIZED_NAME_CURRENT_INNER = "current_inner";
  @SerializedName(SERIALIZED_NAME_CURRENT_INNER)
  private String currentInner;

  public static final String SERIALIZED_NAME_TIP_SINGLETON_COIN_ID = "tip_singleton_coin_id";
  @SerializedName(SERIALIZED_NAME_TIP_SINGLETON_COIN_ID)
  private String tipSingletonCoinId;

  public static final String SERIALIZED_NAME_SINGLETON_BLOCK_HEIGHT = "singleton_block_height";
  @SerializedName(SERIALIZED_NAME_SINGLETON_BLOCK_HEIGHT)
  private Integer singletonBlockHeight;

  public PoolWalletInfo() {
  }

  public PoolWalletInfo current(PoolState current) {
    
    this.current = current;
    return this;
  }

   /**
   * Get current
   * @return current
  **/
  @javax.annotation.Nullable

  public PoolState getCurrent() {
    return current;
  }


  public void setCurrent(PoolState current) {
    this.current = current;
  }


  public PoolWalletInfo target(PoolState target) {
    
    this.target = target;
    return this;
  }

   /**
   * Get target
   * @return target
  **/
  @javax.annotation.Nullable

  public PoolState getTarget() {
    return target;
  }


  public void setTarget(PoolState target) {
    this.target = target;
  }


  public PoolWalletInfo launcherCoin(Coin launcherCoin) {
    
    this.launcherCoin = launcherCoin;
    return this;
  }

   /**
   * Get launcherCoin
   * @return launcherCoin
  **/
  @javax.annotation.Nullable

  public Coin getLauncherCoin() {
    return launcherCoin;
  }


  public void setLauncherCoin(Coin launcherCoin) {
    this.launcherCoin = launcherCoin;
  }


  public PoolWalletInfo launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public PoolWalletInfo p2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
    return this;
  }

   /**
   * Get p2SingletonPuzzleHash
   * @return p2SingletonPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getP2SingletonPuzzleHash() {
    return p2SingletonPuzzleHash;
  }


  public void setP2SingletonPuzzleHash(String p2SingletonPuzzleHash) {
    this.p2SingletonPuzzleHash = p2SingletonPuzzleHash;
  }


  public PoolWalletInfo currentInner(String currentInner) {
    
    this.currentInner = currentInner;
    return this;
  }

   /**
   * inner puzzle in current singleton, not revealed yet
   * @return currentInner
  **/
  @javax.annotation.Nullable

  public String getCurrentInner() {
    return currentInner;
  }


  public void setCurrentInner(String currentInner) {
    this.currentInner = currentInner;
  }


  public PoolWalletInfo tipSingletonCoinId(String tipSingletonCoinId) {
    
    this.tipSingletonCoinId = tipSingletonCoinId;
    return this;
  }

   /**
   * Get tipSingletonCoinId
   * @return tipSingletonCoinId
  **/
  @javax.annotation.Nullable

  public String getTipSingletonCoinId() {
    return tipSingletonCoinId;
  }


  public void setTipSingletonCoinId(String tipSingletonCoinId) {
    this.tipSingletonCoinId = tipSingletonCoinId;
  }


  public PoolWalletInfo singletonBlockHeight(Integer singletonBlockHeight) {
    
    this.singletonBlockHeight = singletonBlockHeight;
    return this;
  }

   /**
   * Block height that current PoolState is from
   * @return singletonBlockHeight
  **/
  @javax.annotation.Nullable

  public Integer getSingletonBlockHeight() {
    return singletonBlockHeight;
  }


  public void setSingletonBlockHeight(Integer singletonBlockHeight) {
    this.singletonBlockHeight = singletonBlockHeight;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PoolWalletInfo poolWalletInfo = (PoolWalletInfo) o;
    return Objects.equals(this.current, poolWalletInfo.current) &&
        Objects.equals(this.target, poolWalletInfo.target) &&
        Objects.equals(this.launcherCoin, poolWalletInfo.launcherCoin) &&
        Objects.equals(this.launcherId, poolWalletInfo.launcherId) &&
        Objects.equals(this.p2SingletonPuzzleHash, poolWalletInfo.p2SingletonPuzzleHash) &&
        Objects.equals(this.currentInner, poolWalletInfo.currentInner) &&
        Objects.equals(this.tipSingletonCoinId, poolWalletInfo.tipSingletonCoinId) &&
        Objects.equals(this.singletonBlockHeight, poolWalletInfo.singletonBlockHeight);
  }

  @Override
  public int hashCode() {
    return Objects.hash(current, target, launcherCoin, launcherId, p2SingletonPuzzleHash, currentInner, tipSingletonCoinId, singletonBlockHeight);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PoolWalletInfo {\n");
    sb.append("    current: ").append(toIndentedString(current)).append("\n");
    sb.append("    target: ").append(toIndentedString(target)).append("\n");
    sb.append("    launcherCoin: ").append(toIndentedString(launcherCoin)).append("\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    p2SingletonPuzzleHash: ").append(toIndentedString(p2SingletonPuzzleHash)).append("\n");
    sb.append("    currentInner: ").append(toIndentedString(currentInner)).append("\n");
    sb.append("    tipSingletonCoinId: ").append(toIndentedString(tipSingletonCoinId)).append("\n");
    sb.append("    singletonBlockHeight: ").append(toIndentedString(singletonBlockHeight)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("current");
    openapiFields.add("target");
    openapiFields.add("launcher_coin");
    openapiFields.add("launcher_id");
    openapiFields.add("p2_singleton_puzzle_hash");
    openapiFields.add("current_inner");
    openapiFields.add("tip_singleton_coin_id");
    openapiFields.add("singleton_block_height");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PoolWalletInfo
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PoolWalletInfo.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PoolWalletInfo is not found in the empty JSON string", PoolWalletInfo.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PoolWalletInfo.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PoolWalletInfo` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      // validate the optional field `current`
      if (jsonObj.get("current") != null && !jsonObj.get("current").isJsonNull()) {
        PoolState.validateJsonObject(jsonObj.getAsJsonObject("current"));
      }
      // validate the optional field `target`
      if (jsonObj.get("target") != null && !jsonObj.get("target").isJsonNull()) {
        PoolState.validateJsonObject(jsonObj.getAsJsonObject("target"));
      }
      // validate the optional field `launcher_coin`
      if (jsonObj.get("launcher_coin") != null && !jsonObj.get("launcher_coin").isJsonNull()) {
        Coin.validateJsonObject(jsonObj.getAsJsonObject("launcher_coin"));
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("p2_singleton_puzzle_hash") != null && !jsonObj.get("p2_singleton_puzzle_hash").isJsonNull()) && !jsonObj.get("p2_singleton_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `p2_singleton_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("p2_singleton_puzzle_hash").toString()));
      }
      if ((jsonObj.get("current_inner") != null && !jsonObj.get("current_inner").isJsonNull()) && !jsonObj.get("current_inner").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `current_inner` to be a primitive type in the JSON string but got `%s`", jsonObj.get("current_inner").toString()));
      }
      if ((jsonObj.get("tip_singleton_coin_id") != null && !jsonObj.get("tip_singleton_coin_id").isJsonNull()) && !jsonObj.get("tip_singleton_coin_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `tip_singleton_coin_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("tip_singleton_coin_id").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PoolWalletInfo.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PoolWalletInfo' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PoolWalletInfo> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PoolWalletInfo.class));

       return (TypeAdapter<T>) new TypeAdapter<PoolWalletInfo>() {
           @Override
           public void write(JsonWriter out, PoolWalletInfo value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PoolWalletInfo read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PoolWalletInfo given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PoolWalletInfo
  * @throws IOException if the JSON string is invalid with respect to PoolWalletInfo
  */
  public static PoolWalletInfo fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PoolWalletInfo.class);
  }

 /**
  * Convert an instance of PoolWalletInfo to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

