/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PrivateKey
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class PrivateKey {
  public static final String SERIALIZED_NAME_FINGERPRINT = "fingerprint";
  @SerializedName(SERIALIZED_NAME_FINGERPRINT)
  private Integer fingerprint;

  public static final String SERIALIZED_NAME_SK = "sk";
  @SerializedName(SERIALIZED_NAME_SK)
  private String sk;

  public static final String SERIALIZED_NAME_PK = "pk";
  @SerializedName(SERIALIZED_NAME_PK)
  private String pk;

  public static final String SERIALIZED_NAME_FARMER_PK = "farmer_pk";
  @SerializedName(SERIALIZED_NAME_FARMER_PK)
  private String farmerPk;

  public static final String SERIALIZED_NAME_POOL_PK = "pool_pk";
  @SerializedName(SERIALIZED_NAME_POOL_PK)
  private String poolPk;

  public static final String SERIALIZED_NAME_SEED = "seed";
  @SerializedName(SERIALIZED_NAME_SEED)
  private String seed;

  public PrivateKey() {
  }

  public PrivateKey fingerprint(Integer fingerprint) {
    
    this.fingerprint = fingerprint;
    return this;
  }

   /**
   * Get fingerprint
   * @return fingerprint
  **/
  @javax.annotation.Nullable

  public Integer getFingerprint() {
    return fingerprint;
  }


  public void setFingerprint(Integer fingerprint) {
    this.fingerprint = fingerprint;
  }


  public PrivateKey sk(String sk) {
    
    this.sk = sk;
    return this;
  }

   /**
   * Get sk
   * @return sk
  **/
  @javax.annotation.Nullable

  public String getSk() {
    return sk;
  }


  public void setSk(String sk) {
    this.sk = sk;
  }


  public PrivateKey pk(String pk) {
    
    this.pk = pk;
    return this;
  }

   /**
   * Get pk
   * @return pk
  **/
  @javax.annotation.Nullable

  public String getPk() {
    return pk;
  }


  public void setPk(String pk) {
    this.pk = pk;
  }


  public PrivateKey farmerPk(String farmerPk) {
    
    this.farmerPk = farmerPk;
    return this;
  }

   /**
   * Get farmerPk
   * @return farmerPk
  **/
  @javax.annotation.Nullable

  public String getFarmerPk() {
    return farmerPk;
  }


  public void setFarmerPk(String farmerPk) {
    this.farmerPk = farmerPk;
  }


  public PrivateKey poolPk(String poolPk) {
    
    this.poolPk = poolPk;
    return this;
  }

   /**
   * Get poolPk
   * @return poolPk
  **/
  @javax.annotation.Nullable

  public String getPoolPk() {
    return poolPk;
  }


  public void setPoolPk(String poolPk) {
    this.poolPk = poolPk;
  }


  public PrivateKey seed(String seed) {
    
    this.seed = seed;
    return this;
  }

   /**
   * Get seed
   * @return seed
  **/
  @javax.annotation.Nullable

  public String getSeed() {
    return seed;
  }


  public void setSeed(String seed) {
    this.seed = seed;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PrivateKey privateKey = (PrivateKey) o;
    return Objects.equals(this.fingerprint, privateKey.fingerprint) &&
        Objects.equals(this.sk, privateKey.sk) &&
        Objects.equals(this.pk, privateKey.pk) &&
        Objects.equals(this.farmerPk, privateKey.farmerPk) &&
        Objects.equals(this.poolPk, privateKey.poolPk) &&
        Objects.equals(this.seed, privateKey.seed);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fingerprint, sk, pk, farmerPk, poolPk, seed);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PrivateKey {\n");
    sb.append("    fingerprint: ").append(toIndentedString(fingerprint)).append("\n");
    sb.append("    sk: ").append(toIndentedString(sk)).append("\n");
    sb.append("    pk: ").append(toIndentedString(pk)).append("\n");
    sb.append("    farmerPk: ").append(toIndentedString(farmerPk)).append("\n");
    sb.append("    poolPk: ").append(toIndentedString(poolPk)).append("\n");
    sb.append("    seed: ").append(toIndentedString(seed)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("fingerprint");
    openapiFields.add("sk");
    openapiFields.add("pk");
    openapiFields.add("farmer_pk");
    openapiFields.add("pool_pk");
    openapiFields.add("seed");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PrivateKey
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PrivateKey.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PrivateKey is not found in the empty JSON string", PrivateKey.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PrivateKey.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PrivateKey` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("sk") != null && !jsonObj.get("sk").isJsonNull()) && !jsonObj.get("sk").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `sk` to be a primitive type in the JSON string but got `%s`", jsonObj.get("sk").toString()));
      }
      if ((jsonObj.get("pk") != null && !jsonObj.get("pk").isJsonNull()) && !jsonObj.get("pk").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pk` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pk").toString()));
      }
      if ((jsonObj.get("farmer_pk") != null && !jsonObj.get("farmer_pk").isJsonNull()) && !jsonObj.get("farmer_pk").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `farmer_pk` to be a primitive type in the JSON string but got `%s`", jsonObj.get("farmer_pk").toString()));
      }
      if ((jsonObj.get("pool_pk") != null && !jsonObj.get("pool_pk").isJsonNull()) && !jsonObj.get("pool_pk").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_pk` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_pk").toString()));
      }
      if ((jsonObj.get("seed") != null && !jsonObj.get("seed").isJsonNull()) && !jsonObj.get("seed").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `seed` to be a primitive type in the JSON string but got `%s`", jsonObj.get("seed").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PrivateKey.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PrivateKey' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PrivateKey> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PrivateKey.class));

       return (TypeAdapter<T>) new TypeAdapter<PrivateKey>() {
           @Override
           public void write(JsonWriter out, PrivateKey value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PrivateKey read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PrivateKey given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PrivateKey
  * @throws IOException if the JSON string is invalid with respect to PrivateKey
  */
  public static PrivateKey fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PrivateKey.class);
  }

 /**
  * Convert an instance of PrivateKey to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

