/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PwJoinPoolRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class PwJoinPoolRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_TARGET_PUZZLEHASH = "target_puzzlehash";
  @SerializedName(SERIALIZED_NAME_TARGET_PUZZLEHASH)
  private String targetPuzzlehash;

  public static final String SERIALIZED_NAME_POOL_URL = "pool_url";
  @SerializedName(SERIALIZED_NAME_POOL_URL)
  private String poolUrl;

  public static final String SERIALIZED_NAME_RELATIVE_LOCK_HEIGHT = "relative_lock_height";
  @SerializedName(SERIALIZED_NAME_RELATIVE_LOCK_HEIGHT)
  private Integer relativeLockHeight;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee;

  public PwJoinPoolRequest() {
  }

  public PwJoinPoolRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public PwJoinPoolRequest targetPuzzlehash(String targetPuzzlehash) {
    
    this.targetPuzzlehash = targetPuzzlehash;
    return this;
  }

   /**
   * Get targetPuzzlehash
   * @return targetPuzzlehash
  **/
  @javax.annotation.Nullable

  public String getTargetPuzzlehash() {
    return targetPuzzlehash;
  }


  public void setTargetPuzzlehash(String targetPuzzlehash) {
    this.targetPuzzlehash = targetPuzzlehash;
  }


  public PwJoinPoolRequest poolUrl(String poolUrl) {
    
    this.poolUrl = poolUrl;
    return this;
  }

   /**
   * Get poolUrl
   * @return poolUrl
  **/
  @javax.annotation.Nonnull

  public String getPoolUrl() {
    return poolUrl;
  }


  public void setPoolUrl(String poolUrl) {
    this.poolUrl = poolUrl;
  }


  public PwJoinPoolRequest relativeLockHeight(Integer relativeLockHeight) {
    
    this.relativeLockHeight = relativeLockHeight;
    return this;
  }

   /**
   * Get relativeLockHeight
   * @return relativeLockHeight
  **/
  @javax.annotation.Nonnull

  public Integer getRelativeLockHeight() {
    return relativeLockHeight;
  }


  public void setRelativeLockHeight(Integer relativeLockHeight) {
    this.relativeLockHeight = relativeLockHeight;
  }


  public PwJoinPoolRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PwJoinPoolRequest pwJoinPoolRequest = (PwJoinPoolRequest) o;
    return Objects.equals(this.walletId, pwJoinPoolRequest.walletId) &&
        Objects.equals(this.targetPuzzlehash, pwJoinPoolRequest.targetPuzzlehash) &&
        Objects.equals(this.poolUrl, pwJoinPoolRequest.poolUrl) &&
        Objects.equals(this.relativeLockHeight, pwJoinPoolRequest.relativeLockHeight) &&
        Objects.equals(this.fee, pwJoinPoolRequest.fee);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, targetPuzzlehash, poolUrl, relativeLockHeight, fee);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PwJoinPoolRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    targetPuzzlehash: ").append(toIndentedString(targetPuzzlehash)).append("\n");
    sb.append("    poolUrl: ").append(toIndentedString(poolUrl)).append("\n");
    sb.append("    relativeLockHeight: ").append(toIndentedString(relativeLockHeight)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("target_puzzlehash");
    openapiFields.add("pool_url");
    openapiFields.add("relative_lock_height");
    openapiFields.add("fee");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("pool_url");
    openapiRequiredFields.add("relative_lock_height");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PwJoinPoolRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PwJoinPoolRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PwJoinPoolRequest is not found in the empty JSON string", PwJoinPoolRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PwJoinPoolRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PwJoinPoolRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : PwJoinPoolRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if ((jsonObj.get("target_puzzlehash") != null && !jsonObj.get("target_puzzlehash").isJsonNull()) && !jsonObj.get("target_puzzlehash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `target_puzzlehash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("target_puzzlehash").toString()));
      }
      if (!jsonObj.get("pool_url").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `pool_url` to be a primitive type in the JSON string but got `%s`", jsonObj.get("pool_url").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PwJoinPoolRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PwJoinPoolRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PwJoinPoolRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PwJoinPoolRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<PwJoinPoolRequest>() {
           @Override
           public void write(JsonWriter out, PwJoinPoolRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PwJoinPoolRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PwJoinPoolRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PwJoinPoolRequest
  * @throws IOException if the JSON string is invalid with respect to PwJoinPoolRequest
  */
  public static PwJoinPoolRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PwJoinPoolRequest.class);
  }

 /**
  * Convert an instance of PwJoinPoolRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

