/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.PoolWalletInfo;
import org.openapitools.client.model.TransactionRecord;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * PwStatus200ResponseAllOf
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class PwStatus200ResponseAllOf {
  public static final String SERIALIZED_NAME_UNCONFIRMED_TRANSACTIONS = "unconfirmed_transactions";
  @SerializedName(SERIALIZED_NAME_UNCONFIRMED_TRANSACTIONS)
  private List<TransactionRecord> unconfirmedTransactions;

  public static final String SERIALIZED_NAME_STATE = "state";
  @SerializedName(SERIALIZED_NAME_STATE)
  private PoolWalletInfo state;

  public PwStatus200ResponseAllOf() {
  }

  public PwStatus200ResponseAllOf unconfirmedTransactions(List<TransactionRecord> unconfirmedTransactions) {
    
    this.unconfirmedTransactions = unconfirmedTransactions;
    return this;
  }

  public PwStatus200ResponseAllOf addUnconfirmedTransactionsItem(TransactionRecord unconfirmedTransactionsItem) {
    if (this.unconfirmedTransactions == null) {
      this.unconfirmedTransactions = new ArrayList<>();
    }
    this.unconfirmedTransactions.add(unconfirmedTransactionsItem);
    return this;
  }

   /**
   * Get unconfirmedTransactions
   * @return unconfirmedTransactions
  **/
  @javax.annotation.Nullable

  public List<TransactionRecord> getUnconfirmedTransactions() {
    return unconfirmedTransactions;
  }


  public void setUnconfirmedTransactions(List<TransactionRecord> unconfirmedTransactions) {
    this.unconfirmedTransactions = unconfirmedTransactions;
  }


  public PwStatus200ResponseAllOf state(PoolWalletInfo state) {
    
    this.state = state;
    return this;
  }

   /**
   * Get state
   * @return state
  **/
  @javax.annotation.Nullable

  public PoolWalletInfo getState() {
    return state;
  }


  public void setState(PoolWalletInfo state) {
    this.state = state;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PwStatus200ResponseAllOf pwStatus200ResponseAllOf = (PwStatus200ResponseAllOf) o;
    return Objects.equals(this.unconfirmedTransactions, pwStatus200ResponseAllOf.unconfirmedTransactions) &&
        Objects.equals(this.state, pwStatus200ResponseAllOf.state);
  }

  @Override
  public int hashCode() {
    return Objects.hash(unconfirmedTransactions, state);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PwStatus200ResponseAllOf {\n");
    sb.append("    unconfirmedTransactions: ").append(toIndentedString(unconfirmedTransactions)).append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("unconfirmed_transactions");
    openapiFields.add("state");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to PwStatus200ResponseAllOf
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!PwStatus200ResponseAllOf.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in PwStatus200ResponseAllOf is not found in the empty JSON string", PwStatus200ResponseAllOf.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!PwStatus200ResponseAllOf.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `PwStatus200ResponseAllOf` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if (jsonObj.get("unconfirmed_transactions") != null && !jsonObj.get("unconfirmed_transactions").isJsonNull()) {
        JsonArray jsonArrayunconfirmedTransactions = jsonObj.getAsJsonArray("unconfirmed_transactions");
        if (jsonArrayunconfirmedTransactions != null) {
          // ensure the json data is an array
          if (!jsonObj.get("unconfirmed_transactions").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `unconfirmed_transactions` to be an array in the JSON string but got `%s`", jsonObj.get("unconfirmed_transactions").toString()));
          }

          // validate the optional field `unconfirmed_transactions` (array)
          for (int i = 0; i < jsonArrayunconfirmedTransactions.size(); i++) {
            TransactionRecord.validateJsonObject(jsonArrayunconfirmedTransactions.get(i).getAsJsonObject());
          };
        }
      }
      // validate the optional field `state`
      if (jsonObj.get("state") != null && !jsonObj.get("state").isJsonNull()) {
        PoolWalletInfo.validateJsonObject(jsonObj.getAsJsonObject("state"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!PwStatus200ResponseAllOf.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'PwStatus200ResponseAllOf' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<PwStatus200ResponseAllOf> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(PwStatus200ResponseAllOf.class));

       return (TypeAdapter<T>) new TypeAdapter<PwStatus200ResponseAllOf>() {
           @Override
           public void write(JsonWriter out, PwStatus200ResponseAllOf value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public PwStatus200ResponseAllOf read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of PwStatus200ResponseAllOf given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of PwStatus200ResponseAllOf
  * @throws IOException if the JSON string is invalid with respect to PwStatus200ResponseAllOf
  */
  public static PwStatus200ResponseAllOf fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, PwStatus200ResponseAllOf.class);
  }

 /**
  * Convert an instance of PwStatus200ResponseAllOf to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

