/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.AmountWithPuzzlehash;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.CoinAnnouncement;
import org.openapitools.client.model.PuzzleAnnouncement;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SendTransactionMultiRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class SendTransactionMultiRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_ADDITIONS = "additions";
  @SerializedName(SERIALIZED_NAME_ADDITIONS)
  private List<AmountWithPuzzlehash> additions = new ArrayList<>();

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_COINS = "coins";
  @SerializedName(SERIALIZED_NAME_COINS)
  private List<Coin> coins;

  public static final String SERIALIZED_NAME_COIN_ANNOUNCEMENTS = "coin_announcements";
  @SerializedName(SERIALIZED_NAME_COIN_ANNOUNCEMENTS)
  private List<CoinAnnouncement> coinAnnouncements;

  public static final String SERIALIZED_NAME_PUZZLE_ANNOUNCEMENTS = "puzzle_announcements";
  @SerializedName(SERIALIZED_NAME_PUZZLE_ANNOUNCEMENTS)
  private List<PuzzleAnnouncement> puzzleAnnouncements;

  public SendTransactionMultiRequest() {
  }

  public SendTransactionMultiRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public SendTransactionMultiRequest additions(List<AmountWithPuzzlehash> additions) {
    
    this.additions = additions;
    return this;
  }

  public SendTransactionMultiRequest addAdditionsItem(AmountWithPuzzlehash additionsItem) {
    if (this.additions == null) {
      this.additions = new ArrayList<>();
    }
    this.additions.add(additionsItem);
    return this;
  }

   /**
   * Get additions
   * @return additions
  **/
  @javax.annotation.Nonnull

  public List<AmountWithPuzzlehash> getAdditions() {
    return additions;
  }


  public void setAdditions(List<AmountWithPuzzlehash> additions) {
    this.additions = additions;
  }


  public SendTransactionMultiRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public SendTransactionMultiRequest coins(List<Coin> coins) {
    
    this.coins = coins;
    return this;
  }

  public SendTransactionMultiRequest addCoinsItem(Coin coinsItem) {
    if (this.coins == null) {
      this.coins = new ArrayList<>();
    }
    this.coins.add(coinsItem);
    return this;
  }

   /**
   * Get coins
   * @return coins
  **/
  @javax.annotation.Nullable

  public List<Coin> getCoins() {
    return coins;
  }


  public void setCoins(List<Coin> coins) {
    this.coins = coins;
  }


  public SendTransactionMultiRequest coinAnnouncements(List<CoinAnnouncement> coinAnnouncements) {
    
    this.coinAnnouncements = coinAnnouncements;
    return this;
  }

  public SendTransactionMultiRequest addCoinAnnouncementsItem(CoinAnnouncement coinAnnouncementsItem) {
    if (this.coinAnnouncements == null) {
      this.coinAnnouncements = new ArrayList<>();
    }
    this.coinAnnouncements.add(coinAnnouncementsItem);
    return this;
  }

   /**
   * Get coinAnnouncements
   * @return coinAnnouncements
  **/
  @javax.annotation.Nullable

  public List<CoinAnnouncement> getCoinAnnouncements() {
    return coinAnnouncements;
  }


  public void setCoinAnnouncements(List<CoinAnnouncement> coinAnnouncements) {
    this.coinAnnouncements = coinAnnouncements;
  }


  public SendTransactionMultiRequest puzzleAnnouncements(List<PuzzleAnnouncement> puzzleAnnouncements) {
    
    this.puzzleAnnouncements = puzzleAnnouncements;
    return this;
  }

  public SendTransactionMultiRequest addPuzzleAnnouncementsItem(PuzzleAnnouncement puzzleAnnouncementsItem) {
    if (this.puzzleAnnouncements == null) {
      this.puzzleAnnouncements = new ArrayList<>();
    }
    this.puzzleAnnouncements.add(puzzleAnnouncementsItem);
    return this;
  }

   /**
   * Get puzzleAnnouncements
   * @return puzzleAnnouncements
  **/
  @javax.annotation.Nullable

  public List<PuzzleAnnouncement> getPuzzleAnnouncements() {
    return puzzleAnnouncements;
  }


  public void setPuzzleAnnouncements(List<PuzzleAnnouncement> puzzleAnnouncements) {
    this.puzzleAnnouncements = puzzleAnnouncements;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SendTransactionMultiRequest sendTransactionMultiRequest = (SendTransactionMultiRequest) o;
    return Objects.equals(this.walletId, sendTransactionMultiRequest.walletId) &&
        Objects.equals(this.additions, sendTransactionMultiRequest.additions) &&
        Objects.equals(this.fee, sendTransactionMultiRequest.fee) &&
        Objects.equals(this.coins, sendTransactionMultiRequest.coins) &&
        Objects.equals(this.coinAnnouncements, sendTransactionMultiRequest.coinAnnouncements) &&
        Objects.equals(this.puzzleAnnouncements, sendTransactionMultiRequest.puzzleAnnouncements);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, additions, fee, coins, coinAnnouncements, puzzleAnnouncements);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SendTransactionMultiRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    additions: ").append(toIndentedString(additions)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    coins: ").append(toIndentedString(coins)).append("\n");
    sb.append("    coinAnnouncements: ").append(toIndentedString(coinAnnouncements)).append("\n");
    sb.append("    puzzleAnnouncements: ").append(toIndentedString(puzzleAnnouncements)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("additions");
    openapiFields.add("fee");
    openapiFields.add("coins");
    openapiFields.add("coin_announcements");
    openapiFields.add("puzzle_announcements");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("additions");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SendTransactionMultiRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SendTransactionMultiRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SendTransactionMultiRequest is not found in the empty JSON string", SendTransactionMultiRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SendTransactionMultiRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SendTransactionMultiRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : SendTransactionMultiRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      // ensure the json data is an array
      if (!jsonObj.get("additions").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `additions` to be an array in the JSON string but got `%s`", jsonObj.get("additions").toString()));
      }

      JsonArray jsonArrayadditions = jsonObj.getAsJsonArray("additions");
      // validate the required field `additions` (array)
      for (int i = 0; i < jsonArrayadditions.size(); i++) {
        AmountWithPuzzlehash.validateJsonObject(jsonArrayadditions.get(i).getAsJsonObject());
      };
      if (jsonObj.get("coins") != null && !jsonObj.get("coins").isJsonNull()) {
        JsonArray jsonArraycoins = jsonObj.getAsJsonArray("coins");
        if (jsonArraycoins != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coins").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coins` to be an array in the JSON string but got `%s`", jsonObj.get("coins").toString()));
          }

          // validate the optional field `coins` (array)
          for (int i = 0; i < jsonArraycoins.size(); i++) {
            Coin.validateJsonObject(jsonArraycoins.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("coin_announcements") != null && !jsonObj.get("coin_announcements").isJsonNull()) {
        JsonArray jsonArraycoinAnnouncements = jsonObj.getAsJsonArray("coin_announcements");
        if (jsonArraycoinAnnouncements != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coin_announcements").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coin_announcements` to be an array in the JSON string but got `%s`", jsonObj.get("coin_announcements").toString()));
          }

          // validate the optional field `coin_announcements` (array)
          for (int i = 0; i < jsonArraycoinAnnouncements.size(); i++) {
            CoinAnnouncement.validateJsonObject(jsonArraycoinAnnouncements.get(i).getAsJsonObject());
          };
        }
      }
      if (jsonObj.get("puzzle_announcements") != null && !jsonObj.get("puzzle_announcements").isJsonNull()) {
        JsonArray jsonArraypuzzleAnnouncements = jsonObj.getAsJsonArray("puzzle_announcements");
        if (jsonArraypuzzleAnnouncements != null) {
          // ensure the json data is an array
          if (!jsonObj.get("puzzle_announcements").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `puzzle_announcements` to be an array in the JSON string but got `%s`", jsonObj.get("puzzle_announcements").toString()));
          }

          // validate the optional field `puzzle_announcements` (array)
          for (int i = 0; i < jsonArraypuzzleAnnouncements.size(); i++) {
            PuzzleAnnouncement.validateJsonObject(jsonArraypuzzleAnnouncements.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SendTransactionMultiRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SendTransactionMultiRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SendTransactionMultiRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SendTransactionMultiRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<SendTransactionMultiRequest>() {
           @Override
           public void write(JsonWriter out, SendTransactionMultiRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SendTransactionMultiRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SendTransactionMultiRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SendTransactionMultiRequest
  * @throws IOException if the JSON string is invalid with respect to SendTransactionMultiRequest
  */
  public static SendTransactionMultiRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SendTransactionMultiRequest.class);
  }

 /**
  * Convert an instance of SendTransactionMultiRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

