/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SendTransactionRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class SendTransactionRequest {
  public static final String SERIALIZED_NAME_WALLET_ID = "wallet_id";
  @SerializedName(SERIALIZED_NAME_WALLET_ID)
  private Integer walletId;

  public static final String SERIALIZED_NAME_AMOUNT = "amount";
  @SerializedName(SERIALIZED_NAME_AMOUNT)
  private Integer amount;

  public static final String SERIALIZED_NAME_ADDRESS = "address";
  @SerializedName(SERIALIZED_NAME_ADDRESS)
  private String address;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee;

  public static final String SERIALIZED_NAME_MEMOS = "memos";
  @SerializedName(SERIALIZED_NAME_MEMOS)
  private List<String> memos;

  public static final String SERIALIZED_NAME_MIN_COIN_AMOUNT = "min_coin_amount";
  @SerializedName(SERIALIZED_NAME_MIN_COIN_AMOUNT)
  private Integer minCoinAmount = 0;

  public static final String SERIALIZED_NAME_MAX_COIN_AMOUNT = "max_coin_amount";
  @SerializedName(SERIALIZED_NAME_MAX_COIN_AMOUNT)
  private Integer maxCoinAmount = 0;

  public static final String SERIALIZED_NAME_EXCLUDE_COIN_AMOUNTS = "exclude_coin_amounts";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_COIN_AMOUNTS)
  private List<Integer> excludeCoinAmounts;

  public static final String SERIALIZED_NAME_EXCLUDE_COIN_IDS = "exclude_coin_ids";
  @SerializedName(SERIALIZED_NAME_EXCLUDE_COIN_IDS)
  private List<String> excludeCoinIds;

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public SendTransactionRequest() {
  }

  public SendTransactionRequest walletId(Integer walletId) {
    
    this.walletId = walletId;
    return this;
  }

   /**
   * Get walletId
   * @return walletId
  **/
  @javax.annotation.Nonnull

  public Integer getWalletId() {
    return walletId;
  }


  public void setWalletId(Integer walletId) {
    this.walletId = walletId;
  }


  public SendTransactionRequest amount(Integer amount) {
    
    this.amount = amount;
    return this;
  }

   /**
   * Get amount
   * @return amount
  **/
  @javax.annotation.Nonnull

  public Integer getAmount() {
    return amount;
  }


  public void setAmount(Integer amount) {
    this.amount = amount;
  }


  public SendTransactionRequest address(String address) {
    
    this.address = address;
    return this;
  }

   /**
   * Get address
   * @return address
  **/
  @javax.annotation.Nonnull

  public String getAddress() {
    return address;
  }


  public void setAddress(String address) {
    this.address = address;
  }


  public SendTransactionRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public SendTransactionRequest memos(List<String> memos) {
    
    this.memos = memos;
    return this;
  }

  public SendTransactionRequest addMemosItem(String memosItem) {
    if (this.memos == null) {
      this.memos = new ArrayList<>();
    }
    this.memos.add(memosItem);
    return this;
  }

   /**
   * Get memos
   * @return memos
  **/
  @javax.annotation.Nullable

  public List<String> getMemos() {
    return memos;
  }


  public void setMemos(List<String> memos) {
    this.memos = memos;
  }


  public SendTransactionRequest minCoinAmount(Integer minCoinAmount) {
    
    this.minCoinAmount = minCoinAmount;
    return this;
  }

   /**
   * Get minCoinAmount
   * @return minCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMinCoinAmount() {
    return minCoinAmount;
  }


  public void setMinCoinAmount(Integer minCoinAmount) {
    this.minCoinAmount = minCoinAmount;
  }


  public SendTransactionRequest maxCoinAmount(Integer maxCoinAmount) {
    
    this.maxCoinAmount = maxCoinAmount;
    return this;
  }

   /**
   * Get maxCoinAmount
   * @return maxCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMaxCoinAmount() {
    return maxCoinAmount;
  }


  public void setMaxCoinAmount(Integer maxCoinAmount) {
    this.maxCoinAmount = maxCoinAmount;
  }


  public SendTransactionRequest excludeCoinAmounts(List<Integer> excludeCoinAmounts) {
    
    this.excludeCoinAmounts = excludeCoinAmounts;
    return this;
  }

  public SendTransactionRequest addExcludeCoinAmountsItem(Integer excludeCoinAmountsItem) {
    if (this.excludeCoinAmounts == null) {
      this.excludeCoinAmounts = new ArrayList<>();
    }
    this.excludeCoinAmounts.add(excludeCoinAmountsItem);
    return this;
  }

   /**
   * Get excludeCoinAmounts
   * @return excludeCoinAmounts
  **/
  @javax.annotation.Nullable

  public List<Integer> getExcludeCoinAmounts() {
    return excludeCoinAmounts;
  }


  public void setExcludeCoinAmounts(List<Integer> excludeCoinAmounts) {
    this.excludeCoinAmounts = excludeCoinAmounts;
  }


  public SendTransactionRequest excludeCoinIds(List<String> excludeCoinIds) {
    
    this.excludeCoinIds = excludeCoinIds;
    return this;
  }

  public SendTransactionRequest addExcludeCoinIdsItem(String excludeCoinIdsItem) {
    if (this.excludeCoinIds == null) {
      this.excludeCoinIds = new ArrayList<>();
    }
    this.excludeCoinIds.add(excludeCoinIdsItem);
    return this;
  }

   /**
   * Get excludeCoinIds
   * @return excludeCoinIds
  **/
  @javax.annotation.Nullable

  public List<String> getExcludeCoinIds() {
    return excludeCoinIds;
  }


  public void setExcludeCoinIds(List<String> excludeCoinIds) {
    this.excludeCoinIds = excludeCoinIds;
  }


  public SendTransactionRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SendTransactionRequest sendTransactionRequest = (SendTransactionRequest) o;
    return Objects.equals(this.walletId, sendTransactionRequest.walletId) &&
        Objects.equals(this.amount, sendTransactionRequest.amount) &&
        Objects.equals(this.address, sendTransactionRequest.address) &&
        Objects.equals(this.fee, sendTransactionRequest.fee) &&
        Objects.equals(this.memos, sendTransactionRequest.memos) &&
        Objects.equals(this.minCoinAmount, sendTransactionRequest.minCoinAmount) &&
        Objects.equals(this.maxCoinAmount, sendTransactionRequest.maxCoinAmount) &&
        Objects.equals(this.excludeCoinAmounts, sendTransactionRequest.excludeCoinAmounts) &&
        Objects.equals(this.excludeCoinIds, sendTransactionRequest.excludeCoinIds) &&
        Objects.equals(this.reusePuzhash, sendTransactionRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(walletId, amount, address, fee, memos, minCoinAmount, maxCoinAmount, excludeCoinAmounts, excludeCoinIds, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SendTransactionRequest {\n");
    sb.append("    walletId: ").append(toIndentedString(walletId)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    address: ").append(toIndentedString(address)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    memos: ").append(toIndentedString(memos)).append("\n");
    sb.append("    minCoinAmount: ").append(toIndentedString(minCoinAmount)).append("\n");
    sb.append("    maxCoinAmount: ").append(toIndentedString(maxCoinAmount)).append("\n");
    sb.append("    excludeCoinAmounts: ").append(toIndentedString(excludeCoinAmounts)).append("\n");
    sb.append("    excludeCoinIds: ").append(toIndentedString(excludeCoinIds)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("wallet_id");
    openapiFields.add("amount");
    openapiFields.add("address");
    openapiFields.add("fee");
    openapiFields.add("memos");
    openapiFields.add("min_coin_amount");
    openapiFields.add("max_coin_amount");
    openapiFields.add("exclude_coin_amounts");
    openapiFields.add("exclude_coin_ids");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("wallet_id");
    openapiRequiredFields.add("amount");
    openapiRequiredFields.add("address");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SendTransactionRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SendTransactionRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SendTransactionRequest is not found in the empty JSON string", SendTransactionRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SendTransactionRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SendTransactionRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : SendTransactionRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("address").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `address` to be a primitive type in the JSON string but got `%s`", jsonObj.get("address").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("memos") != null && !jsonObj.get("memos").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `memos` to be an array in the JSON string but got `%s`", jsonObj.get("memos").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("exclude_coin_amounts") != null && !jsonObj.get("exclude_coin_amounts").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `exclude_coin_amounts` to be an array in the JSON string but got `%s`", jsonObj.get("exclude_coin_amounts").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("exclude_coin_ids") != null && !jsonObj.get("exclude_coin_ids").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `exclude_coin_ids` to be an array in the JSON string but got `%s`", jsonObj.get("exclude_coin_ids").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SendTransactionRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SendTransactionRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SendTransactionRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SendTransactionRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<SendTransactionRequest>() {
           @Override
           public void write(JsonWriter out, SendTransactionRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SendTransactionRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SendTransactionRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SendTransactionRequest
  * @throws IOException if the JSON string is invalid with respect to SendTransactionRequest
  */
  public static SendTransactionRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SendTransactionRequest.class);
  }

 /**
  * Convert an instance of SendTransactionRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

