/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.LineageProof;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SingletonRecord
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class SingletonRecord {
  public static final String SERIALIZED_NAME_COIN_ID = "coin_id";
  @SerializedName(SERIALIZED_NAME_COIN_ID)
  private String coinId;

  public static final String SERIALIZED_NAME_LAUNCHER_ID = "launcher_id";
  @SerializedName(SERIALIZED_NAME_LAUNCHER_ID)
  private String launcherId;

  public static final String SERIALIZED_NAME_ROOT = "root";
  @SerializedName(SERIALIZED_NAME_ROOT)
  private String root;

  public static final String SERIALIZED_NAME_INNER_PUZZLE_HASH = "inner_puzzle_hash";
  @SerializedName(SERIALIZED_NAME_INNER_PUZZLE_HASH)
  private String innerPuzzleHash;

  public static final String SERIALIZED_NAME_CONFIRMED = "confirmed";
  @SerializedName(SERIALIZED_NAME_CONFIRMED)
  private Boolean confirmed;

  public static final String SERIALIZED_NAME_CONFIRMED_AT_HEIGHT = "confirmed_at_height";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_AT_HEIGHT)
  private Integer confirmedAtHeight;

  public static final String SERIALIZED_NAME_LINEAGE_PROOF = "lineage_proof";
  @SerializedName(SERIALIZED_NAME_LINEAGE_PROOF)
  private LineageProof lineageProof;

  public static final String SERIALIZED_NAME_GENERATION = "generation";
  @SerializedName(SERIALIZED_NAME_GENERATION)
  private Integer generation;

  public static final String SERIALIZED_NAME_TIMESTAMP = "timestamp";
  @SerializedName(SERIALIZED_NAME_TIMESTAMP)
  private Integer timestamp;

  public SingletonRecord() {
  }

  public SingletonRecord coinId(String coinId) {
    
    this.coinId = coinId;
    return this;
  }

   /**
   * Get coinId
   * @return coinId
  **/
  @javax.annotation.Nullable

  public String getCoinId() {
    return coinId;
  }


  public void setCoinId(String coinId) {
    this.coinId = coinId;
  }


  public SingletonRecord launcherId(String launcherId) {
    
    this.launcherId = launcherId;
    return this;
  }

   /**
   * Get launcherId
   * @return launcherId
  **/
  @javax.annotation.Nullable

  public String getLauncherId() {
    return launcherId;
  }


  public void setLauncherId(String launcherId) {
    this.launcherId = launcherId;
  }


  public SingletonRecord root(String root) {
    
    this.root = root;
    return this;
  }

   /**
   * Get root
   * @return root
  **/
  @javax.annotation.Nullable

  public String getRoot() {
    return root;
  }


  public void setRoot(String root) {
    this.root = root;
  }


  public SingletonRecord innerPuzzleHash(String innerPuzzleHash) {
    
    this.innerPuzzleHash = innerPuzzleHash;
    return this;
  }

   /**
   * Get innerPuzzleHash
   * @return innerPuzzleHash
  **/
  @javax.annotation.Nullable

  public String getInnerPuzzleHash() {
    return innerPuzzleHash;
  }


  public void setInnerPuzzleHash(String innerPuzzleHash) {
    this.innerPuzzleHash = innerPuzzleHash;
  }


  public SingletonRecord confirmed(Boolean confirmed) {
    
    this.confirmed = confirmed;
    return this;
  }

   /**
   * Get confirmed
   * @return confirmed
  **/
  @javax.annotation.Nullable

  public Boolean getConfirmed() {
    return confirmed;
  }


  public void setConfirmed(Boolean confirmed) {
    this.confirmed = confirmed;
  }


  public SingletonRecord confirmedAtHeight(Integer confirmedAtHeight) {
    
    this.confirmedAtHeight = confirmedAtHeight;
    return this;
  }

   /**
   * Get confirmedAtHeight
   * @return confirmedAtHeight
  **/
  @javax.annotation.Nullable

  public Integer getConfirmedAtHeight() {
    return confirmedAtHeight;
  }


  public void setConfirmedAtHeight(Integer confirmedAtHeight) {
    this.confirmedAtHeight = confirmedAtHeight;
  }


  public SingletonRecord lineageProof(LineageProof lineageProof) {
    
    this.lineageProof = lineageProof;
    return this;
  }

   /**
   * Get lineageProof
   * @return lineageProof
  **/
  @javax.annotation.Nullable

  public LineageProof getLineageProof() {
    return lineageProof;
  }


  public void setLineageProof(LineageProof lineageProof) {
    this.lineageProof = lineageProof;
  }


  public SingletonRecord generation(Integer generation) {
    
    this.generation = generation;
    return this;
  }

   /**
   * Get generation
   * @return generation
  **/
  @javax.annotation.Nullable

  public Integer getGeneration() {
    return generation;
  }


  public void setGeneration(Integer generation) {
    this.generation = generation;
  }


  public SingletonRecord timestamp(Integer timestamp) {
    
    this.timestamp = timestamp;
    return this;
  }

   /**
   * Get timestamp
   * @return timestamp
  **/
  @javax.annotation.Nullable

  public Integer getTimestamp() {
    return timestamp;
  }


  public void setTimestamp(Integer timestamp) {
    this.timestamp = timestamp;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SingletonRecord singletonRecord = (SingletonRecord) o;
    return Objects.equals(this.coinId, singletonRecord.coinId) &&
        Objects.equals(this.launcherId, singletonRecord.launcherId) &&
        Objects.equals(this.root, singletonRecord.root) &&
        Objects.equals(this.innerPuzzleHash, singletonRecord.innerPuzzleHash) &&
        Objects.equals(this.confirmed, singletonRecord.confirmed) &&
        Objects.equals(this.confirmedAtHeight, singletonRecord.confirmedAtHeight) &&
        Objects.equals(this.lineageProof, singletonRecord.lineageProof) &&
        Objects.equals(this.generation, singletonRecord.generation) &&
        Objects.equals(this.timestamp, singletonRecord.timestamp);
  }

  @Override
  public int hashCode() {
    return Objects.hash(coinId, launcherId, root, innerPuzzleHash, confirmed, confirmedAtHeight, lineageProof, generation, timestamp);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SingletonRecord {\n");
    sb.append("    coinId: ").append(toIndentedString(coinId)).append("\n");
    sb.append("    launcherId: ").append(toIndentedString(launcherId)).append("\n");
    sb.append("    root: ").append(toIndentedString(root)).append("\n");
    sb.append("    innerPuzzleHash: ").append(toIndentedString(innerPuzzleHash)).append("\n");
    sb.append("    confirmed: ").append(toIndentedString(confirmed)).append("\n");
    sb.append("    confirmedAtHeight: ").append(toIndentedString(confirmedAtHeight)).append("\n");
    sb.append("    lineageProof: ").append(toIndentedString(lineageProof)).append("\n");
    sb.append("    generation: ").append(toIndentedString(generation)).append("\n");
    sb.append("    timestamp: ").append(toIndentedString(timestamp)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("coin_id");
    openapiFields.add("launcher_id");
    openapiFields.add("root");
    openapiFields.add("inner_puzzle_hash");
    openapiFields.add("confirmed");
    openapiFields.add("confirmed_at_height");
    openapiFields.add("lineage_proof");
    openapiFields.add("generation");
    openapiFields.add("timestamp");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SingletonRecord
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SingletonRecord.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SingletonRecord is not found in the empty JSON string", SingletonRecord.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SingletonRecord.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SingletonRecord` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("coin_id") != null && !jsonObj.get("coin_id").isJsonNull()) && !jsonObj.get("coin_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `coin_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("coin_id").toString()));
      }
      if ((jsonObj.get("launcher_id") != null && !jsonObj.get("launcher_id").isJsonNull()) && !jsonObj.get("launcher_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `launcher_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("launcher_id").toString()));
      }
      if ((jsonObj.get("root") != null && !jsonObj.get("root").isJsonNull()) && !jsonObj.get("root").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `root` to be a primitive type in the JSON string but got `%s`", jsonObj.get("root").toString()));
      }
      if ((jsonObj.get("inner_puzzle_hash") != null && !jsonObj.get("inner_puzzle_hash").isJsonNull()) && !jsonObj.get("inner_puzzle_hash").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `inner_puzzle_hash` to be a primitive type in the JSON string but got `%s`", jsonObj.get("inner_puzzle_hash").toString()));
      }
      // validate the optional field `lineage_proof`
      if (jsonObj.get("lineage_proof") != null && !jsonObj.get("lineage_proof").isJsonNull()) {
        LineageProof.validateJsonObject(jsonObj.getAsJsonObject("lineage_proof"));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SingletonRecord.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SingletonRecord' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SingletonRecord> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SingletonRecord.class));

       return (TypeAdapter<T>) new TypeAdapter<SingletonRecord>() {
           @Override
           public void write(JsonWriter out, SingletonRecord value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SingletonRecord read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SingletonRecord given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SingletonRecord
  * @throws IOException if the JSON string is invalid with respect to SingletonRecord
  */
  public static SingletonRecord fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SingletonRecord.class);
  }

 /**
  * Convert an instance of SingletonRecord to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

