/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.CoinSpend;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * SpendBundle
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class SpendBundle {
  public static final String SERIALIZED_NAME_AGGREGATED_SIGNATURE = "aggregated_signature";
  @SerializedName(SERIALIZED_NAME_AGGREGATED_SIGNATURE)
  private String aggregatedSignature;

  public static final String SERIALIZED_NAME_COIN_SPENDS = "coin_spends";
  @SerializedName(SERIALIZED_NAME_COIN_SPENDS)
  private List<CoinSpend> coinSpends;

  public SpendBundle() {
  }

  public SpendBundle aggregatedSignature(String aggregatedSignature) {
    
    this.aggregatedSignature = aggregatedSignature;
    return this;
  }

   /**
   * Get aggregatedSignature
   * @return aggregatedSignature
  **/
  @javax.annotation.Nullable

  public String getAggregatedSignature() {
    return aggregatedSignature;
  }


  public void setAggregatedSignature(String aggregatedSignature) {
    this.aggregatedSignature = aggregatedSignature;
  }


  public SpendBundle coinSpends(List<CoinSpend> coinSpends) {
    
    this.coinSpends = coinSpends;
    return this;
  }

  public SpendBundle addCoinSpendsItem(CoinSpend coinSpendsItem) {
    if (this.coinSpends == null) {
      this.coinSpends = new ArrayList<>();
    }
    this.coinSpends.add(coinSpendsItem);
    return this;
  }

   /**
   * Get coinSpends
   * @return coinSpends
  **/
  @javax.annotation.Nullable

  public List<CoinSpend> getCoinSpends() {
    return coinSpends;
  }


  public void setCoinSpends(List<CoinSpend> coinSpends) {
    this.coinSpends = coinSpends;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SpendBundle spendBundle = (SpendBundle) o;
    return Objects.equals(this.aggregatedSignature, spendBundle.aggregatedSignature) &&
        Objects.equals(this.coinSpends, spendBundle.coinSpends);
  }

  @Override
  public int hashCode() {
    return Objects.hash(aggregatedSignature, coinSpends);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SpendBundle {\n");
    sb.append("    aggregatedSignature: ").append(toIndentedString(aggregatedSignature)).append("\n");
    sb.append("    coinSpends: ").append(toIndentedString(coinSpends)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("aggregated_signature");
    openapiFields.add("coin_spends");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to SpendBundle
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!SpendBundle.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in SpendBundle is not found in the empty JSON string", SpendBundle.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!SpendBundle.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `SpendBundle` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("aggregated_signature") != null && !jsonObj.get("aggregated_signature").isJsonNull()) && !jsonObj.get("aggregated_signature").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `aggregated_signature` to be a primitive type in the JSON string but got `%s`", jsonObj.get("aggregated_signature").toString()));
      }
      if (jsonObj.get("coin_spends") != null && !jsonObj.get("coin_spends").isJsonNull()) {
        JsonArray jsonArraycoinSpends = jsonObj.getAsJsonArray("coin_spends");
        if (jsonArraycoinSpends != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coin_spends").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coin_spends` to be an array in the JSON string but got `%s`", jsonObj.get("coin_spends").toString()));
          }

          // validate the optional field `coin_spends` (array)
          for (int i = 0; i < jsonArraycoinSpends.size(); i++) {
            CoinSpend.validateJsonObject(jsonArraycoinSpends.get(i).getAsJsonObject());
          };
        }
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!SpendBundle.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'SpendBundle' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<SpendBundle> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(SpendBundle.class));

       return (TypeAdapter<T>) new TypeAdapter<SpendBundle>() {
           @Override
           public void write(JsonWriter out, SpendBundle value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public SpendBundle read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of SpendBundle given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of SpendBundle
  * @throws IOException if the JSON string is invalid with respect to SpendBundle
  */
  public static SpendBundle fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, SpendBundle.class);
  }

 /**
  * Convert an instance of SpendBundle to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

