/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * TakeOfferRequest
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class TakeOfferRequest {
  public static final String SERIALIZED_NAME_OFFER = "offer";
  @SerializedName(SERIALIZED_NAME_OFFER)
  private String offer;

  public static final String SERIALIZED_NAME_FEE = "fee";
  @SerializedName(SERIALIZED_NAME_FEE)
  private Integer fee = 0;

  public static final String SERIALIZED_NAME_MIN_COIN_AMOUNT = "min_coin_amount";
  @SerializedName(SERIALIZED_NAME_MIN_COIN_AMOUNT)
  private Integer minCoinAmount = 0;

  public static final String SERIALIZED_NAME_MAX_COIN_AMOUNT = "max_coin_amount";
  @SerializedName(SERIALIZED_NAME_MAX_COIN_AMOUNT)
  private Integer maxCoinAmount = 0;

  public static final String SERIALIZED_NAME_SOLVER = "solver";
  @SerializedName(SERIALIZED_NAME_SOLVER)
  private Map<String, Object> solver = new HashMap<>();

  public static final String SERIALIZED_NAME_REUSE_PUZHASH = "reuse_puzhash";
  @SerializedName(SERIALIZED_NAME_REUSE_PUZHASH)
  private Boolean reusePuzhash;

  public TakeOfferRequest() {
  }

  public TakeOfferRequest offer(String offer) {
    
    this.offer = offer;
    return this;
  }

   /**
   * Get offer
   * @return offer
  **/
  @javax.annotation.Nonnull

  public String getOffer() {
    return offer;
  }


  public void setOffer(String offer) {
    this.offer = offer;
  }


  public TakeOfferRequest fee(Integer fee) {
    
    this.fee = fee;
    return this;
  }

   /**
   * Get fee
   * @return fee
  **/
  @javax.annotation.Nullable

  public Integer getFee() {
    return fee;
  }


  public void setFee(Integer fee) {
    this.fee = fee;
  }


  public TakeOfferRequest minCoinAmount(Integer minCoinAmount) {
    
    this.minCoinAmount = minCoinAmount;
    return this;
  }

   /**
   * Get minCoinAmount
   * @return minCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMinCoinAmount() {
    return minCoinAmount;
  }


  public void setMinCoinAmount(Integer minCoinAmount) {
    this.minCoinAmount = minCoinAmount;
  }


  public TakeOfferRequest maxCoinAmount(Integer maxCoinAmount) {
    
    this.maxCoinAmount = maxCoinAmount;
    return this;
  }

   /**
   * Get maxCoinAmount
   * @return maxCoinAmount
  **/
  @javax.annotation.Nullable

  public Integer getMaxCoinAmount() {
    return maxCoinAmount;
  }


  public void setMaxCoinAmount(Integer maxCoinAmount) {
    this.maxCoinAmount = maxCoinAmount;
  }


  public TakeOfferRequest solver(Map<String, Object> solver) {
    
    this.solver = solver;
    return this;
  }

  public TakeOfferRequest putSolverItem(String key, Object solverItem) {
    if (this.solver == null) {
      this.solver = new HashMap<>();
    }
    this.solver.put(key, solverItem);
    return this;
  }

   /**
   * Get solver
   * @return solver
  **/
  @javax.annotation.Nullable

  public Map<String, Object> getSolver() {
    return solver;
  }


  public void setSolver(Map<String, Object> solver) {
    this.solver = solver;
  }


  public TakeOfferRequest reusePuzhash(Boolean reusePuzhash) {
    
    this.reusePuzhash = reusePuzhash;
    return this;
  }

   /**
   * Get reusePuzhash
   * @return reusePuzhash
  **/
  @javax.annotation.Nullable

  public Boolean getReusePuzhash() {
    return reusePuzhash;
  }


  public void setReusePuzhash(Boolean reusePuzhash) {
    this.reusePuzhash = reusePuzhash;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TakeOfferRequest takeOfferRequest = (TakeOfferRequest) o;
    return Objects.equals(this.offer, takeOfferRequest.offer) &&
        Objects.equals(this.fee, takeOfferRequest.fee) &&
        Objects.equals(this.minCoinAmount, takeOfferRequest.minCoinAmount) &&
        Objects.equals(this.maxCoinAmount, takeOfferRequest.maxCoinAmount) &&
        Objects.equals(this.solver, takeOfferRequest.solver) &&
        Objects.equals(this.reusePuzhash, takeOfferRequest.reusePuzhash);
  }

  @Override
  public int hashCode() {
    return Objects.hash(offer, fee, minCoinAmount, maxCoinAmount, solver, reusePuzhash);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TakeOfferRequest {\n");
    sb.append("    offer: ").append(toIndentedString(offer)).append("\n");
    sb.append("    fee: ").append(toIndentedString(fee)).append("\n");
    sb.append("    minCoinAmount: ").append(toIndentedString(minCoinAmount)).append("\n");
    sb.append("    maxCoinAmount: ").append(toIndentedString(maxCoinAmount)).append("\n");
    sb.append("    solver: ").append(toIndentedString(solver)).append("\n");
    sb.append("    reusePuzhash: ").append(toIndentedString(reusePuzhash)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("offer");
    openapiFields.add("fee");
    openapiFields.add("min_coin_amount");
    openapiFields.add("max_coin_amount");
    openapiFields.add("solver");
    openapiFields.add("reuse_puzhash");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
    openapiRequiredFields.add("offer");
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to TakeOfferRequest
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!TakeOfferRequest.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in TakeOfferRequest is not found in the empty JSON string", TakeOfferRequest.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!TakeOfferRequest.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `TakeOfferRequest` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }

      // check to make sure all required properties/fields are present in the JSON string
      for (String requiredField : TakeOfferRequest.openapiRequiredFields) {
        if (jsonObj.get(requiredField) == null) {
          throw new IllegalArgumentException(String.format("The required field `%s` is not found in the JSON string: %s", requiredField, jsonObj.toString()));
        }
      }
      if (!jsonObj.get("offer").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `offer` to be a primitive type in the JSON string but got `%s`", jsonObj.get("offer").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!TakeOfferRequest.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'TakeOfferRequest' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<TakeOfferRequest> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(TakeOfferRequest.class));

       return (TypeAdapter<T>) new TypeAdapter<TakeOfferRequest>() {
           @Override
           public void write(JsonWriter out, TakeOfferRequest value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public TakeOfferRequest read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of TakeOfferRequest given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of TakeOfferRequest
  * @throws IOException if the JSON string is invalid with respect to TakeOfferRequest
  */
  public static TakeOfferRequest fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, TakeOfferRequest.class);
  }

 /**
  * Convert an instance of TakeOfferRequest to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

