/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.Coin;
import org.openapitools.client.model.TradeStatus;
import org.openapitools.jackson.nullable.JsonNullable;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * Used for storing transaction data and status in wallets.
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class TradeRecord {
  public static final String SERIALIZED_NAME_CONFIRMED_AT_HEIGHT = "confirmed_at_height";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_AT_HEIGHT)
  private Integer confirmedAtHeight;

  public static final String SERIALIZED_NAME_ACCEPTED_AT_TIME = "accepted_at_time";
  @SerializedName(SERIALIZED_NAME_ACCEPTED_AT_TIME)
  private Integer acceptedAtTime;

  public static final String SERIALIZED_NAME_CREATED_AT_TIME = "created_at_time";
  @SerializedName(SERIALIZED_NAME_CREATED_AT_TIME)
  private Integer createdAtTime;

  public static final String SERIALIZED_NAME_IS_MY_OFFER = "is_my_offer";
  @SerializedName(SERIALIZED_NAME_IS_MY_OFFER)
  private Boolean isMyOffer;

  public static final String SERIALIZED_NAME_SENT = "sent";
  @SerializedName(SERIALIZED_NAME_SENT)
  private Integer sent;

  public static final String SERIALIZED_NAME_OFFER = "offer";
  @SerializedName(SERIALIZED_NAME_OFFER)
  private String offer;

  public static final String SERIALIZED_NAME_TAKEN_OFFER = "taken_offer";
  @SerializedName(SERIALIZED_NAME_TAKEN_OFFER)
  private String takenOffer;

  public static final String SERIALIZED_NAME_COINS_OF_INTEREST = "coins_of_interest";
  @SerializedName(SERIALIZED_NAME_COINS_OF_INTEREST)
  private List<Coin> coinsOfInterest;

  public static final String SERIALIZED_NAME_TRADE_ID = "trade_id";
  @SerializedName(SERIALIZED_NAME_TRADE_ID)
  private String tradeId;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private TradeStatus status;

  public static final String SERIALIZED_NAME_SENT_TO = "sent_to";
  @SerializedName(SERIALIZED_NAME_SENT_TO)
  private List<List<String>> sentTo;

  public TradeRecord() {
  }

  public TradeRecord confirmedAtHeight(Integer confirmedAtHeight) {
    
    this.confirmedAtHeight = confirmedAtHeight;
    return this;
  }

   /**
   * Get confirmedAtHeight
   * @return confirmedAtHeight
  **/
  @javax.annotation.Nullable

  public Integer getConfirmedAtHeight() {
    return confirmedAtHeight;
  }


  public void setConfirmedAtHeight(Integer confirmedAtHeight) {
    this.confirmedAtHeight = confirmedAtHeight;
  }


  public TradeRecord acceptedAtTime(Integer acceptedAtTime) {
    
    this.acceptedAtTime = acceptedAtTime;
    return this;
  }

   /**
   * Get acceptedAtTime
   * @return acceptedAtTime
  **/
  @javax.annotation.Nullable

  public Integer getAcceptedAtTime() {
    return acceptedAtTime;
  }


  public void setAcceptedAtTime(Integer acceptedAtTime) {
    this.acceptedAtTime = acceptedAtTime;
  }


  public TradeRecord createdAtTime(Integer createdAtTime) {
    
    this.createdAtTime = createdAtTime;
    return this;
  }

   /**
   * Get createdAtTime
   * @return createdAtTime
  **/
  @javax.annotation.Nullable

  public Integer getCreatedAtTime() {
    return createdAtTime;
  }


  public void setCreatedAtTime(Integer createdAtTime) {
    this.createdAtTime = createdAtTime;
  }


  public TradeRecord isMyOffer(Boolean isMyOffer) {
    
    this.isMyOffer = isMyOffer;
    return this;
  }

   /**
   * Get isMyOffer
   * @return isMyOffer
  **/
  @javax.annotation.Nullable

  public Boolean getIsMyOffer() {
    return isMyOffer;
  }


  public void setIsMyOffer(Boolean isMyOffer) {
    this.isMyOffer = isMyOffer;
  }


  public TradeRecord sent(Integer sent) {
    
    this.sent = sent;
    return this;
  }

   /**
   * Get sent
   * @return sent
  **/
  @javax.annotation.Nullable

  public Integer getSent() {
    return sent;
  }


  public void setSent(Integer sent) {
    this.sent = sent;
  }


  public TradeRecord offer(String offer) {
    
    this.offer = offer;
    return this;
  }

   /**
   * Get offer
   * @return offer
  **/
  @javax.annotation.Nullable

  public String getOffer() {
    return offer;
  }


  public void setOffer(String offer) {
    this.offer = offer;
  }


  public TradeRecord takenOffer(String takenOffer) {
    
    this.takenOffer = takenOffer;
    return this;
  }

   /**
   * Get takenOffer
   * @return takenOffer
  **/
  @javax.annotation.Nullable

  public String getTakenOffer() {
    return takenOffer;
  }


  public void setTakenOffer(String takenOffer) {
    this.takenOffer = takenOffer;
  }


  public TradeRecord coinsOfInterest(List<Coin> coinsOfInterest) {
    
    this.coinsOfInterest = coinsOfInterest;
    return this;
  }

  public TradeRecord addCoinsOfInterestItem(Coin coinsOfInterestItem) {
    if (this.coinsOfInterest == null) {
      this.coinsOfInterest = new ArrayList<>();
    }
    this.coinsOfInterest.add(coinsOfInterestItem);
    return this;
  }

   /**
   * Get coinsOfInterest
   * @return coinsOfInterest
  **/
  @javax.annotation.Nullable

  public List<Coin> getCoinsOfInterest() {
    return coinsOfInterest;
  }


  public void setCoinsOfInterest(List<Coin> coinsOfInterest) {
    this.coinsOfInterest = coinsOfInterest;
  }


  public TradeRecord tradeId(String tradeId) {
    
    this.tradeId = tradeId;
    return this;
  }

   /**
   * Get tradeId
   * @return tradeId
  **/
  @javax.annotation.Nullable

  public String getTradeId() {
    return tradeId;
  }


  public void setTradeId(String tradeId) {
    this.tradeId = tradeId;
  }


  public TradeRecord status(TradeStatus status) {
    
    this.status = status;
    return this;
  }

   /**
   * Get status
   * @return status
  **/
  @javax.annotation.Nullable

  public TradeStatus getStatus() {
    return status;
  }


  public void setStatus(TradeStatus status) {
    this.status = status;
  }


  public TradeRecord sentTo(List<List<String>> sentTo) {
    
    this.sentTo = sentTo;
    return this;
  }

  public TradeRecord addSentToItem(List<String> sentToItem) {
    if (this.sentTo == null) {
      this.sentTo = new ArrayList<>();
    }
    this.sentTo.add(sentToItem);
    return this;
  }

   /**
   * Represents the list of peers that we sent the transaction to, whether each one included it in the mempool, and what the error message (if any) was. List[Tuple[str, uint8, Optional[str]]]
   * @return sentTo
  **/
  @javax.annotation.Nullable

  public List<List<String>> getSentTo() {
    return sentTo;
  }


  public void setSentTo(List<List<String>> sentTo) {
    this.sentTo = sentTo;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TradeRecord tradeRecord = (TradeRecord) o;
    return Objects.equals(this.confirmedAtHeight, tradeRecord.confirmedAtHeight) &&
        Objects.equals(this.acceptedAtTime, tradeRecord.acceptedAtTime) &&
        Objects.equals(this.createdAtTime, tradeRecord.createdAtTime) &&
        Objects.equals(this.isMyOffer, tradeRecord.isMyOffer) &&
        Objects.equals(this.sent, tradeRecord.sent) &&
        Objects.equals(this.offer, tradeRecord.offer) &&
        Objects.equals(this.takenOffer, tradeRecord.takenOffer) &&
        Objects.equals(this.coinsOfInterest, tradeRecord.coinsOfInterest) &&
        Objects.equals(this.tradeId, tradeRecord.tradeId) &&
        Objects.equals(this.status, tradeRecord.status) &&
        Objects.equals(this.sentTo, tradeRecord.sentTo);
  }

  private static <T> boolean equalsNullable(JsonNullable<T> a, JsonNullable<T> b) {
    return a == b || (a != null && b != null && a.isPresent() && b.isPresent() && Objects.deepEquals(a.get(), b.get()));
  }

  @Override
  public int hashCode() {
    return Objects.hash(confirmedAtHeight, acceptedAtTime, createdAtTime, isMyOffer, sent, offer, takenOffer, coinsOfInterest, tradeId, status, sentTo);
  }

  private static <T> int hashCodeNullable(JsonNullable<T> a) {
    if (a == null) {
      return 1;
    }
    return a.isPresent() ? Arrays.deepHashCode(new Object[]{a.get()}) : 31;
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TradeRecord {\n");
    sb.append("    confirmedAtHeight: ").append(toIndentedString(confirmedAtHeight)).append("\n");
    sb.append("    acceptedAtTime: ").append(toIndentedString(acceptedAtTime)).append("\n");
    sb.append("    createdAtTime: ").append(toIndentedString(createdAtTime)).append("\n");
    sb.append("    isMyOffer: ").append(toIndentedString(isMyOffer)).append("\n");
    sb.append("    sent: ").append(toIndentedString(sent)).append("\n");
    sb.append("    offer: ").append(toIndentedString(offer)).append("\n");
    sb.append("    takenOffer: ").append(toIndentedString(takenOffer)).append("\n");
    sb.append("    coinsOfInterest: ").append(toIndentedString(coinsOfInterest)).append("\n");
    sb.append("    tradeId: ").append(toIndentedString(tradeId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    sentTo: ").append(toIndentedString(sentTo)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("confirmed_at_height");
    openapiFields.add("accepted_at_time");
    openapiFields.add("created_at_time");
    openapiFields.add("is_my_offer");
    openapiFields.add("sent");
    openapiFields.add("offer");
    openapiFields.add("taken_offer");
    openapiFields.add("coins_of_interest");
    openapiFields.add("trade_id");
    openapiFields.add("status");
    openapiFields.add("sent_to");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to TradeRecord
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!TradeRecord.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in TradeRecord is not found in the empty JSON string", TradeRecord.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!TradeRecord.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `TradeRecord` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("offer") != null && !jsonObj.get("offer").isJsonNull()) && !jsonObj.get("offer").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `offer` to be a primitive type in the JSON string but got `%s`", jsonObj.get("offer").toString()));
      }
      if ((jsonObj.get("taken_offer") != null && !jsonObj.get("taken_offer").isJsonNull()) && !jsonObj.get("taken_offer").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `taken_offer` to be a primitive type in the JSON string but got `%s`", jsonObj.get("taken_offer").toString()));
      }
      if (jsonObj.get("coins_of_interest") != null && !jsonObj.get("coins_of_interest").isJsonNull()) {
        JsonArray jsonArraycoinsOfInterest = jsonObj.getAsJsonArray("coins_of_interest");
        if (jsonArraycoinsOfInterest != null) {
          // ensure the json data is an array
          if (!jsonObj.get("coins_of_interest").isJsonArray()) {
            throw new IllegalArgumentException(String.format("Expected the field `coins_of_interest` to be an array in the JSON string but got `%s`", jsonObj.get("coins_of_interest").toString()));
          }

          // validate the optional field `coins_of_interest` (array)
          for (int i = 0; i < jsonArraycoinsOfInterest.size(); i++) {
            Coin.validateJsonObject(jsonArraycoinsOfInterest.get(i).getAsJsonObject());
          };
        }
      }
      if ((jsonObj.get("trade_id") != null && !jsonObj.get("trade_id").isJsonNull()) && !jsonObj.get("trade_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `trade_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("trade_id").toString()));
      }
      // ensure the optional json data is an array if present
      if (jsonObj.get("sent_to") != null && !jsonObj.get("sent_to").isJsonArray()) {
        throw new IllegalArgumentException(String.format("Expected the field `sent_to` to be an array in the JSON string but got `%s`", jsonObj.get("sent_to").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!TradeRecord.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'TradeRecord' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<TradeRecord> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(TradeRecord.class));

       return (TypeAdapter<T>) new TypeAdapter<TradeRecord>() {
           @Override
           public void write(JsonWriter out, TradeRecord value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public TradeRecord read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of TradeRecord given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of TradeRecord
  * @throws IOException if the JSON string is invalid with respect to TradeRecord
  */
  public static TradeRecord fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, TradeRecord.class);
  }

 /**
  * Convert an instance of TradeRecord to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

