/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import java.io.IOException;
import org.openapitools.client.model.WalletType;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonArray;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParseException;
import com.google.gson.TypeAdapterFactory;
import com.google.gson.reflect.TypeToken;

import java.lang.reflect.Type;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.openapitools.client.JSON;

/**
 * WalletBalance
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2023-05-11T12:44:31.667508-04:00[America/New_York]")
public class WalletBalance {
  public static final String SERIALIZED_NAME_CONFIRMED_WALLET_BALANCE = "confirmed_wallet_balance";
  @SerializedName(SERIALIZED_NAME_CONFIRMED_WALLET_BALANCE)
  private Integer confirmedWalletBalance;

  public static final String SERIALIZED_NAME_UNCONFIRMED_WALLET_BALANCE = "unconfirmed_wallet_balance";
  @SerializedName(SERIALIZED_NAME_UNCONFIRMED_WALLET_BALANCE)
  private Integer unconfirmedWalletBalance;

  public static final String SERIALIZED_NAME_SPENDABLE_BALANCE = "spendable_balance";
  @SerializedName(SERIALIZED_NAME_SPENDABLE_BALANCE)
  private Integer spendableBalance;

  public static final String SERIALIZED_NAME_PENDING_CHANGE = "pending_change";
  @SerializedName(SERIALIZED_NAME_PENDING_CHANGE)
  private Integer pendingChange;

  public static final String SERIALIZED_NAME_MAX_SEND_AMOUNT = "max_send_amount";
  @SerializedName(SERIALIZED_NAME_MAX_SEND_AMOUNT)
  private Integer maxSendAmount;

  public static final String SERIALIZED_NAME_UNSPENT_COIN_COUNT = "unspent_coin_count";
  @SerializedName(SERIALIZED_NAME_UNSPENT_COIN_COUNT)
  private Integer unspentCoinCount;

  public static final String SERIALIZED_NAME_PENDING_COIN_REMOVAL_COUNT = "pending_coin_removal_count";
  @SerializedName(SERIALIZED_NAME_PENDING_COIN_REMOVAL_COUNT)
  private Integer pendingCoinRemovalCount;

  public static final String SERIALIZED_NAME_WALLET_TYPE = "wallet_type";
  @SerializedName(SERIALIZED_NAME_WALLET_TYPE)
  private WalletType walletType;

  public static final String SERIALIZED_NAME_ASSET_ID = "asset_id";
  @SerializedName(SERIALIZED_NAME_ASSET_ID)
  private String assetId;

  public WalletBalance() {
  }

  public WalletBalance confirmedWalletBalance(Integer confirmedWalletBalance) {
    
    this.confirmedWalletBalance = confirmedWalletBalance;
    return this;
  }

   /**
   * Get confirmedWalletBalance
   * @return confirmedWalletBalance
  **/
  @javax.annotation.Nullable

  public Integer getConfirmedWalletBalance() {
    return confirmedWalletBalance;
  }


  public void setConfirmedWalletBalance(Integer confirmedWalletBalance) {
    this.confirmedWalletBalance = confirmedWalletBalance;
  }


  public WalletBalance unconfirmedWalletBalance(Integer unconfirmedWalletBalance) {
    
    this.unconfirmedWalletBalance = unconfirmedWalletBalance;
    return this;
  }

   /**
   * Get unconfirmedWalletBalance
   * @return unconfirmedWalletBalance
  **/
  @javax.annotation.Nullable

  public Integer getUnconfirmedWalletBalance() {
    return unconfirmedWalletBalance;
  }


  public void setUnconfirmedWalletBalance(Integer unconfirmedWalletBalance) {
    this.unconfirmedWalletBalance = unconfirmedWalletBalance;
  }


  public WalletBalance spendableBalance(Integer spendableBalance) {
    
    this.spendableBalance = spendableBalance;
    return this;
  }

   /**
   * Get spendableBalance
   * @return spendableBalance
  **/
  @javax.annotation.Nullable

  public Integer getSpendableBalance() {
    return spendableBalance;
  }


  public void setSpendableBalance(Integer spendableBalance) {
    this.spendableBalance = spendableBalance;
  }


  public WalletBalance pendingChange(Integer pendingChange) {
    
    this.pendingChange = pendingChange;
    return this;
  }

   /**
   * Get pendingChange
   * @return pendingChange
  **/
  @javax.annotation.Nullable

  public Integer getPendingChange() {
    return pendingChange;
  }


  public void setPendingChange(Integer pendingChange) {
    this.pendingChange = pendingChange;
  }


  public WalletBalance maxSendAmount(Integer maxSendAmount) {
    
    this.maxSendAmount = maxSendAmount;
    return this;
  }

   /**
   * Get maxSendAmount
   * @return maxSendAmount
  **/
  @javax.annotation.Nullable

  public Integer getMaxSendAmount() {
    return maxSendAmount;
  }


  public void setMaxSendAmount(Integer maxSendAmount) {
    this.maxSendAmount = maxSendAmount;
  }


  public WalletBalance unspentCoinCount(Integer unspentCoinCount) {
    
    this.unspentCoinCount = unspentCoinCount;
    return this;
  }

   /**
   * Get unspentCoinCount
   * @return unspentCoinCount
  **/
  @javax.annotation.Nullable

  public Integer getUnspentCoinCount() {
    return unspentCoinCount;
  }


  public void setUnspentCoinCount(Integer unspentCoinCount) {
    this.unspentCoinCount = unspentCoinCount;
  }


  public WalletBalance pendingCoinRemovalCount(Integer pendingCoinRemovalCount) {
    
    this.pendingCoinRemovalCount = pendingCoinRemovalCount;
    return this;
  }

   /**
   * Get pendingCoinRemovalCount
   * @return pendingCoinRemovalCount
  **/
  @javax.annotation.Nullable

  public Integer getPendingCoinRemovalCount() {
    return pendingCoinRemovalCount;
  }


  public void setPendingCoinRemovalCount(Integer pendingCoinRemovalCount) {
    this.pendingCoinRemovalCount = pendingCoinRemovalCount;
  }


  public WalletBalance walletType(WalletType walletType) {
    
    this.walletType = walletType;
    return this;
  }

   /**
   * Get walletType
   * @return walletType
  **/
  @javax.annotation.Nullable

  public WalletType getWalletType() {
    return walletType;
  }


  public void setWalletType(WalletType walletType) {
    this.walletType = walletType;
  }


  public WalletBalance assetId(String assetId) {
    
    this.assetId = assetId;
    return this;
  }

   /**
   * Get assetId
   * @return assetId
  **/
  @javax.annotation.Nullable

  public String getAssetId() {
    return assetId;
  }


  public void setAssetId(String assetId) {
    this.assetId = assetId;
  }



  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    WalletBalance walletBalance = (WalletBalance) o;
    return Objects.equals(this.confirmedWalletBalance, walletBalance.confirmedWalletBalance) &&
        Objects.equals(this.unconfirmedWalletBalance, walletBalance.unconfirmedWalletBalance) &&
        Objects.equals(this.spendableBalance, walletBalance.spendableBalance) &&
        Objects.equals(this.pendingChange, walletBalance.pendingChange) &&
        Objects.equals(this.maxSendAmount, walletBalance.maxSendAmount) &&
        Objects.equals(this.unspentCoinCount, walletBalance.unspentCoinCount) &&
        Objects.equals(this.pendingCoinRemovalCount, walletBalance.pendingCoinRemovalCount) &&
        Objects.equals(this.walletType, walletBalance.walletType) &&
        Objects.equals(this.assetId, walletBalance.assetId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(confirmedWalletBalance, unconfirmedWalletBalance, spendableBalance, pendingChange, maxSendAmount, unspentCoinCount, pendingCoinRemovalCount, walletType, assetId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class WalletBalance {\n");
    sb.append("    confirmedWalletBalance: ").append(toIndentedString(confirmedWalletBalance)).append("\n");
    sb.append("    unconfirmedWalletBalance: ").append(toIndentedString(unconfirmedWalletBalance)).append("\n");
    sb.append("    spendableBalance: ").append(toIndentedString(spendableBalance)).append("\n");
    sb.append("    pendingChange: ").append(toIndentedString(pendingChange)).append("\n");
    sb.append("    maxSendAmount: ").append(toIndentedString(maxSendAmount)).append("\n");
    sb.append("    unspentCoinCount: ").append(toIndentedString(unspentCoinCount)).append("\n");
    sb.append("    pendingCoinRemovalCount: ").append(toIndentedString(pendingCoinRemovalCount)).append("\n");
    sb.append("    walletType: ").append(toIndentedString(walletType)).append("\n");
    sb.append("    assetId: ").append(toIndentedString(assetId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }


  public static HashSet<String> openapiFields;
  public static HashSet<String> openapiRequiredFields;

  static {
    // a set of all properties/fields (JSON key names)
    openapiFields = new HashSet<String>();
    openapiFields.add("confirmed_wallet_balance");
    openapiFields.add("unconfirmed_wallet_balance");
    openapiFields.add("spendable_balance");
    openapiFields.add("pending_change");
    openapiFields.add("max_send_amount");
    openapiFields.add("unspent_coin_count");
    openapiFields.add("pending_coin_removal_count");
    openapiFields.add("wallet_type");
    openapiFields.add("asset_id");

    // a set of required properties/fields (JSON key names)
    openapiRequiredFields = new HashSet<String>();
  }

 /**
  * Validates the JSON Object and throws an exception if issues found
  *
  * @param jsonObj JSON Object
  * @throws IOException if the JSON Object is invalid with respect to WalletBalance
  */
  public static void validateJsonObject(JsonObject jsonObj) throws IOException {
      if (jsonObj == null) {
        if (!WalletBalance.openapiRequiredFields.isEmpty()) { // has required fields but JSON object is null
          throw new IllegalArgumentException(String.format("The required field(s) %s in WalletBalance is not found in the empty JSON string", WalletBalance.openapiRequiredFields.toString()));
        }
      }

      Set<Entry<String, JsonElement>> entries = jsonObj.entrySet();
      // check to see if the JSON string contains additional fields
      for (Entry<String, JsonElement> entry : entries) {
        if (!WalletBalance.openapiFields.contains(entry.getKey())) {
          throw new IllegalArgumentException(String.format("The field `%s` in the JSON string is not defined in the `WalletBalance` properties. JSON: %s", entry.getKey(), jsonObj.toString()));
        }
      }
      if ((jsonObj.get("asset_id") != null && !jsonObj.get("asset_id").isJsonNull()) && !jsonObj.get("asset_id").isJsonPrimitive()) {
        throw new IllegalArgumentException(String.format("Expected the field `asset_id` to be a primitive type in the JSON string but got `%s`", jsonObj.get("asset_id").toString()));
      }
  }

  public static class CustomTypeAdapterFactory implements TypeAdapterFactory {
    @SuppressWarnings("unchecked")
    @Override
    public <T> TypeAdapter<T> create(Gson gson, TypeToken<T> type) {
       if (!WalletBalance.class.isAssignableFrom(type.getRawType())) {
         return null; // this class only serializes 'WalletBalance' and its subtypes
       }
       final TypeAdapter<JsonElement> elementAdapter = gson.getAdapter(JsonElement.class);
       final TypeAdapter<WalletBalance> thisAdapter
                        = gson.getDelegateAdapter(this, TypeToken.get(WalletBalance.class));

       return (TypeAdapter<T>) new TypeAdapter<WalletBalance>() {
           @Override
           public void write(JsonWriter out, WalletBalance value) throws IOException {
             JsonObject obj = thisAdapter.toJsonTree(value).getAsJsonObject();
             elementAdapter.write(out, obj);
           }

           @Override
           public WalletBalance read(JsonReader in) throws IOException {
             JsonObject jsonObj = elementAdapter.read(in).getAsJsonObject();
             validateJsonObject(jsonObj);
             return thisAdapter.fromJsonTree(jsonObj);
           }

       }.nullSafe();
    }
  }

 /**
  * Create an instance of WalletBalance given an JSON string
  *
  * @param jsonString JSON string
  * @return An instance of WalletBalance
  * @throws IOException if the JSON string is invalid with respect to WalletBalance
  */
  public static WalletBalance fromJson(String jsonString) throws IOException {
    return JSON.getGson().fromJson(jsonString, WalletBalance.class);
  }

 /**
  * Convert an instance of WalletBalance to an JSON string
  *
  * @return JSON string
  */
  public String toJson() {
    return JSON.getGson().toJson(this);
  }
}

