/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CancelOfferRequest;
import org.openapitools.client.model.CancelOffersRequest;
import org.openapitools.client.model.CatAssetIdToName200Response;
import org.openapitools.client.model.CatAssetIdToNameRequest;
import org.openapitools.client.model.CatGetAssetId200Response;
import org.openapitools.client.model.CatSpendRequest;
import org.openapitools.client.model.CheckOfferValidity200Response;
import org.openapitools.client.model.CheckOfferValidityRequest;
import org.openapitools.client.model.CreateOfferForIds200Response;
import org.openapitools.client.model.CreateOfferForIdsRequest;
import org.openapitools.client.model.DidSetWalletNameRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.GetAllOffers200Response;
import org.openapitools.client.model.GetAllOffersRequest;
import org.openapitools.client.model.GetCatList200Response;
import org.openapitools.client.model.GetOffer200Response;
import org.openapitools.client.model.GetOfferRequest;
import org.openapitools.client.model.GetOfferSummary200Response;
import org.openapitools.client.model.GetOfferSummaryRequest;
import org.openapitools.client.model.GetOffersCount200Response;
import org.openapitools.client.model.GetStrayCats200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetByDid200Response;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.SelectCoins200Response;
import org.openapitools.client.model.SelectCoinsRequest;
import org.openapitools.client.model.TakeOffer200Response;
import org.openapitools.client.model.TakeOfferRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for CatWalletApi
 */
@Disabled
public class CatWalletApiTest {

    private final CatWalletApi api = new CatWalletApi();

    /**
     * Cancels an offer.
     *
     * Cancels an offer.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void cancelOfferTest() throws ApiException {
        CancelOfferRequest cancelOfferRequest = null;
        ModelApiResponse response = api.cancelOffer(cancelOfferRequest);
        // TODO: test validations
    }

    /**
     * Cancels multiple offers.
     *
     * Cancels multiple offers.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void cancelOffersTest() throws ApiException {
        CancelOffersRequest cancelOffersRequest = null;
        ModelApiResponse response = api.cancelOffers(cancelOffersRequest);
        // TODO: test validations
    }

    /**
     * Gets the name and wallet id associated with an asset id.
     *
     * Gets the name and wallet id associated with an asset id.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void catAssetIdToNameTest() throws ApiException {
        CatAssetIdToNameRequest catAssetIdToNameRequest = null;
        CatAssetIdToName200Response response = api.catAssetIdToName(catAssetIdToNameRequest);
        // TODO: test validations
    }

    /**
     * Gets the asset id of the CAT wallet.
     *
     * Gets the asset id of the CAT wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void catGetAssetIdTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        CatGetAssetId200Response response = api.catGetAssetId(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Gets the name of the CAT wallet.
     *
     * Gets the name of the CAT wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void catGetNameTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        CatAssetIdToName200Response response = api.catGetName(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Sets the name of the CAT wallet.
     *
     * Sets the name of the CAT wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void catSetNameTest() throws ApiException {
        DidSetWalletNameRequest didSetWalletNameRequest = null;
        NftGetByDid200Response response = api.catSetName(didSetWalletNameRequest);
        // TODO: test validations
    }

    /**
     * Spends an amount from the given wallet.
     *
     * Spends an amount from the given wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void catSpendTest() throws ApiException {
        CatSpendRequest catSpendRequest = null;
        DidTransferDid200Response response = api.catSpend(catSpendRequest);
        // TODO: test validations
    }

    /**
     * Checks the validity of an offer.
     *
     * Checks the validity of an offer.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void checkOfferValidityTest() throws ApiException {
        CheckOfferValidityRequest checkOfferValidityRequest = null;
        CheckOfferValidity200Response response = api.checkOfferValidity(checkOfferValidityRequest);
        // TODO: test validations
    }

    /**
     * Creates an offer.
     *
     * Creates an offer for the given set of wallet id and amount pairs.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void createOfferForIdsTest() throws ApiException {
        CreateOfferForIdsRequest createOfferForIdsRequest = null;
        CreateOfferForIds200Response response = api.createOfferForIds(createOfferForIdsRequest);
        // TODO: test validations
    }

    /**
     * Retrieves offers.
     *
     * Retrieves offers.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getAllOffersTest() throws ApiException {
        GetAllOffersRequest getAllOffersRequest = null;
        GetAllOffers200Response response = api.getAllOffers(getAllOffersRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the list of CATs.
     *
     * Retrieves the list of CATs.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCatListTest() throws ApiException {
        Object body = null;
        GetCatList200Response response = api.getCatList(body);
        // TODO: test validations
    }

    /**
     * Retrieves an offer.
     *
     * Retrieves an offer.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getOfferTest() throws ApiException {
        GetOfferRequest getOfferRequest = null;
        GetOffer200Response response = api.getOffer(getOfferRequest);
        // TODO: test validations
    }

    /**
     * Get the summary of a given offer.
     *
     * Get the summary of a given offer.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getOfferSummaryTest() throws ApiException {
        GetOfferSummaryRequest getOfferSummaryRequest = null;
        GetOfferSummary200Response response = api.getOfferSummary(getOfferSummaryRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the number of offers.
     *
     * Retrieves the number of offers.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getOffersCountTest() throws ApiException {
        Object body = null;
        GetOffersCount200Response response = api.getOffersCount(body);
        // TODO: test validations
    }

    /**
     * Get a list of all unacknowledged CATs.
     *
     * Get a list of all unacknowledged CATs.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getStrayCatsTest() throws ApiException {
        Object body = null;
        GetStrayCats200Response response = api.getStrayCats(body);
        // TODO: test validations
    }

    /**
     * Returns a set of coins that can be used for generating a new transaction.
     *
     * Returns a set of coins that can be used for generating a new transaction.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void selectCoinsTest() throws ApiException {
        SelectCoinsRequest selectCoinsRequest = null;
        SelectCoins200Response response = api.selectCoins(selectCoinsRequest);
        // TODO: test validations
    }

    /**
     * Takes an offer.
     *
     * Takes an offer.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void takeOfferTest() throws ApiException {
        TakeOfferRequest takeOfferRequest = null;
        TakeOffer200Response response = api.takeOffer(takeOfferRequest);
        // TODO: test validations
    }

}
