/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CreateNewDl200Response;
import org.openapitools.client.model.CreateNewDlRequest;
import org.openapitools.client.model.DlDeleteMirrorRequest;
import org.openapitools.client.model.DlGetMirrors200Response;
import org.openapitools.client.model.DlHistory200Response;
import org.openapitools.client.model.DlHistoryRequest;
import org.openapitools.client.model.DlLatestSingleton200Response;
import org.openapitools.client.model.DlLatestSingletonRequest;
import org.openapitools.client.model.DlNewMirror200Response;
import org.openapitools.client.model.DlNewMirrorRequest;
import org.openapitools.client.model.DlOwnedSingletons200Response;
import org.openapitools.client.model.DlSingletonsByRoot200Response;
import org.openapitools.client.model.DlTrackNewRequest;
import org.openapitools.client.model.DlUpdateMultiple200Response;
import org.openapitools.client.model.DlUpdateMultipleRequest;
import org.openapitools.client.model.DlUpdateRoot200Response;
import org.openapitools.client.model.DlUpdateRootRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for DataLayerWalletApi
 */
@Disabled
public class DataLayerWalletApiTest {

    private final DataLayerWalletApi api = new DataLayerWalletApi();

    /**
     * Initialize the new data layer wallets.
     *
     * Initialize the DataLayer Wallet (only one can exist).
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void createNewDlTest() throws ApiException {
        CreateNewDlRequest createNewDlRequest = null;
        CreateNewDl200Response response = api.createNewDl(createNewDlRequest);
        // TODO: test validations
    }

    /**
     * Remove an existing mirror for a specific singleton.
     *
     * Remove an existing mirror for a specific singleton.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlDeleteMirrorTest() throws ApiException {
        DlDeleteMirrorRequest dlDeleteMirrorRequest = null;
        DlNewMirror200Response response = api.dlDeleteMirror(dlDeleteMirrorRequest);
        // TODO: test validations
    }

    /**
     * Get all of the mirrors for a specific singleton.
     *
     * Get all of the mirrors for a specific singleton.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlGetMirrorsTest() throws ApiException {
        DlTrackNewRequest dlTrackNewRequest = null;
        DlGetMirrors200Response response = api.dlGetMirrors(dlTrackNewRequest);
        // TODO: test validations
    }

    /**
     * Get the singleton record for the latest singleton of a launcher ID.
     *
     * Get the singleton record for the latest singleton of a launcher ID.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlHistoryTest() throws ApiException {
        DlHistoryRequest dlHistoryRequest = null;
        DlHistory200Response response = api.dlHistory(dlHistoryRequest);
        // TODO: test validations
    }

    /**
     * Get the singleton records that contain the specified root.
     *
     * Get the singleton records that contain the specified root.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlLatestSingletonTest() throws ApiException {
        DlLatestSingletonRequest dlLatestSingletonRequest = null;
        DlLatestSingleton200Response response = api.dlLatestSingleton(dlLatestSingletonRequest);
        // TODO: test validations
    }

    /**
     * Add a new on chain message for a specific singleton.
     *
     * Add a new on chain message for a specific singleton
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlNewMirrorTest() throws ApiException {
        DlNewMirrorRequest dlNewMirrorRequest = null;
        DlNewMirror200Response response = api.dlNewMirror(dlNewMirrorRequest);
        // TODO: test validations
    }

    /**
     * Get all owned singleton records.
     *
     * Get all owned singleton records.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlOwnedSingletonsTest() throws ApiException {
        Object body = null;
        DlOwnedSingletons200Response response = api.dlOwnedSingletons(body);
        // TODO: test validations
    }

    /**
     * Get the singleton records that contain the specified root.
     *
     * Get the singleton records that contain the specified root.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlSingletonsByRootTest() throws ApiException {
        DlLatestSingletonRequest dlLatestSingletonRequest = null;
        DlSingletonsByRoot200Response response = api.dlSingletonsByRoot(dlLatestSingletonRequest);
        // TODO: test validations
    }

    /**
     * Stop tracking the data layer wallets.
     *
     * Stop tracking the data layer wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlStopTrackingTest() throws ApiException {
        DlTrackNewRequest dlTrackNewRequest = null;
        ModelApiResponse response = api.dlStopTracking(dlTrackNewRequest);
        // TODO: test validations
    }

    /**
     * Track the new data layer wallet
     *
     * Track the new data layer wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlTrackNewTest() throws ApiException {
        DlTrackNewRequest dlTrackNewRequest = null;
        ModelApiResponse response = api.dlTrackNew(dlTrackNewRequest);
        // TODO: test validations
    }

    /**
     * Stop the node.
     *
     * Stop the node.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlUpdateMultipleTest() throws ApiException {
        DlUpdateMultipleRequest dlUpdateMultipleRequest = null;
        DlUpdateMultiple200Response response = api.dlUpdateMultiple(dlUpdateMultipleRequest);
        // TODO: test validations
    }

    /**
     * Stop the node.
     *
     * Stop the node.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void dlUpdateRootTest() throws ApiException {
        DlUpdateRootRequest dlUpdateRootRequest = null;
        DlUpdateRoot200Response response = api.dlUpdateRoot(dlUpdateRootRequest);
        // TODO: test validations
    }

}
