/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.DidCreateAttest200Response;
import org.openapitools.client.model.DidCreateAttestRequest;
import org.openapitools.client.model.DidCreateBackupFile200Response;
import org.openapitools.client.model.DidFindLostDid200Response;
import org.openapitools.client.model.DidFindLostDidRequest;
import org.openapitools.client.model.DidGetCurrentCoinInfo200Response;
import org.openapitools.client.model.DidGetDid200Response;
import org.openapitools.client.model.DidGetInfo200Response;
import org.openapitools.client.model.DidGetInfoRequest;
import org.openapitools.client.model.DidGetInformationNeededForRecovery200Response;
import org.openapitools.client.model.DidGetMetadata200Response;
import org.openapitools.client.model.DidGetPubkey200Response;
import org.openapitools.client.model.DidGetRecoveryList200Response;
import org.openapitools.client.model.DidGetWalletName200Response;
import org.openapitools.client.model.DidMessageSpendRequest;
import org.openapitools.client.model.DidRecoverySpend200Response;
import org.openapitools.client.model.DidRecoverySpendRequest;
import org.openapitools.client.model.DidSetWalletName200Response;
import org.openapitools.client.model.DidSetWalletNameRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.DidTransferDidRequest;
import org.openapitools.client.model.DidUpdateMetadata200Response;
import org.openapitools.client.model.DidUpdateMetadataRequest;
import org.openapitools.client.model.DidUpdateRecoveryIdsRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for DidWalletApi
 */
@Disabled
public class DidWalletApiTest {

    private final DidWalletApi api = new DidWalletApi();

    /**
     * Creates an attestment for the given DID wallet.
     *
     * Creates an attestment for the given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didCreateAttestTest() throws ApiException {
        DidCreateAttestRequest didCreateAttestRequest = null;
        DidCreateAttest200Response response = api.didCreateAttest(didCreateAttestRequest);
        // TODO: test validations
    }

    /**
     * Creates a backup file for the given DID wallet.
     *
     * Creates a backup file for the given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didCreateBackupFileTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidCreateBackupFile200Response response = api.didCreateBackupFile(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Recover a missing or unspendable DID wallet by a coin id of the DID.
     *
     * Recover a missing or unspendable DID wallet by a coin id of the DID
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didFindLostDidTest() throws ApiException {
        DidFindLostDidRequest didFindLostDidRequest = null;
        DidFindLostDid200Response response = api.didFindLostDid(didFindLostDidRequest);
        // TODO: test validations
    }

    /**
     * Gets information about the DID wallets current coin.
     *
     * Gets information about the DID wallets current coin.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetCurrentCoinInfoTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetCurrentCoinInfo200Response response = api.didGetCurrentCoinInfo(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the distributed identity for a given wallet.
     *
     * Retrieves the distributed identity for a given wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetDidTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetDid200Response response = api.didGetDid(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Retreives information about a DID.
     *
     * Retreives information about a DID
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetInfoTest() throws ApiException {
        DidGetInfoRequest didGetInfoRequest = null;
        DidGetInfo200Response response = api.didGetInfo(didGetInfoRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the recovery information needed for the given DID wallet.
     *
     * Retrieves the recovery information needed for the given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetInformationNeededForRecoveryTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetInformationNeededForRecovery200Response response = api.didGetInformationNeededForRecovery(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Gets the metadata of a DID wallet.
     *
     * Gets the metadata of a DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetMetadataTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetMetadata200Response response = api.didGetMetadata(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the public key for the given DID wallet.
     *
     * Retrieves the public key for the given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetPubkeyTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetPubkey200Response response = api.didGetPubkey(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the recovery list for a given DID wallet.
     *
     * Retrieves the recovery list for a given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetRecoveryListTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetRecoveryList200Response response = api.didGetRecoveryList(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Gets the name of a DID wallet.
     *
     * Gets the name of a DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didGetWalletNameTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        DidGetWalletName200Response response = api.didGetWalletName(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Spends a DID message.
     *
     * Spends a DID message
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didMessageSpendTest() throws ApiException {
        DidMessageSpendRequest didMessageSpendRequest = null;
        DidRecoverySpend200Response response = api.didMessageSpend(didMessageSpendRequest);
        // TODO: test validations
    }

    /**
     * Spend from the given DID wallet.
     *
     * Spend from the given DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didRecoverySpendTest() throws ApiException {
        DidRecoverySpendRequest didRecoverySpendRequest = null;
        DidRecoverySpend200Response response = api.didRecoverySpend(didRecoverySpendRequest);
        // TODO: test validations
    }

    /**
     * Sets the name of a DID wallet.
     *
     * Sets the name of a DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didSetWalletNameTest() throws ApiException {
        DidSetWalletNameRequest didSetWalletNameRequest = null;
        DidSetWalletName200Response response = api.didSetWalletName(didSetWalletNameRequest);
        // TODO: test validations
    }

    /**
     * Transfer a DID to another owner.
     *
     * Transfer the given DID wallet to another owner.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didTransferDidTest() throws ApiException {
        DidTransferDidRequest didTransferDidRequest = null;
        DidTransferDid200Response response = api.didTransferDid(didTransferDidRequest);
        // TODO: test validations
    }

    /**
     * Updates the metadata for a DID wallet.
     *
     * Updates the metadata for a DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didUpdateMetadataTest() throws ApiException {
        DidUpdateMetadataRequest didUpdateMetadataRequest = null;
        DidUpdateMetadata200Response response = api.didUpdateMetadata(didUpdateMetadataRequest);
        // TODO: test validations
    }

    /**
     * Updates the recovery ids for a DID wallet.
     *
     * Updates the recovery ids for a DID wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void didUpdateRecoveryIdsTest() throws ApiException {
        DidUpdateRecoveryIdsRequest didUpdateRecoveryIdsRequest = null;
        ModelApiResponse response = api.didUpdateRecoveryIds(didUpdateRecoveryIdsRequest);
        // TODO: test validations
    }

}
