/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.AddKey200Response;
import org.openapitools.client.model.CheckDeleteKey200Response;
import org.openapitools.client.model.GetPrivateKey200Response;
import org.openapitools.client.model.GetPublicKeys200Response;
import org.openapitools.client.model.LogIn200Response;
import org.openapitools.client.model.LogInRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.VerifySignature200Response;
import org.openapitools.client.model.VerifySignatureRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for KeyManagementApi
 */
@Disabled
public class KeyManagementApiTest {

    private final KeyManagementApi api = new KeyManagementApi();

    /**
     * Generates a new mnemonic phrase.
     *
     * Generates a new mnemonic phrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void addKeyTest() throws ApiException {
        List<String> requestBody = null;
        AddKey200Response response = api.addKey(requestBody);
        // TODO: test validations
    }

    /**
     * Determines if it is safe to delete a private key.
     *
     * Determines if it is safe to delete a private key. Returns whether it is used for farming, pooling, or has a balance.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void checkDeleteKeyTest() throws ApiException {
        LogInRequest logInRequest = null;
        CheckDeleteKey200Response response = api.checkDeleteKey(logInRequest);
        // TODO: test validations
    }

    /**
     * Deletes all keys which have the given public key fingerprint.
     *
     * Deletes all keys which have the given public key fingerprint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteKeyTest() throws ApiException {
        LogInRequest logInRequest = null;
        ModelApiResponse response = api.deleteKey(logInRequest);
        // TODO: test validations
    }

    /**
     * Generates a new mnemonic phrase.
     *
     * Generates a new mnemonic phrase.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void generateMnemonicTest() throws ApiException {
        Object body = null;
        List<String> response = api.generateMnemonic(body);
        // TODO: test validations
    }

    /**
     * Retrieves the logged in fingerprint.
     *
     * Retrieves the logged in fingerprint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getLoggedInFingerprintTest() throws ApiException {
        Object body = null;
        LogIn200Response response = api.getLoggedInFingerprint(body);
        // TODO: test validations
    }

    /**
     * Retrieves the private key by fingerprint.
     *
     * Retrieves the private key by fingerprint.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPrivateKeyTest() throws ApiException {
        LogInRequest logInRequest = null;
        GetPrivateKey200Response response = api.getPrivateKey(logInRequest);
        // TODO: test validations
    }

    /**
     * Retrieves all public keys on the node.
     *
     * Retrieves all public keys on the node.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getPublicKeysTest() throws ApiException {
        Object body = null;
        GetPublicKeys200Response response = api.getPublicKeys(body);
        // TODO: test validations
    }

    /**
     * Logs in the wallet with a specific key.
     *
     * Logs in the wallet with a specific key.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void logInTest() throws ApiException {
        LogInRequest logInRequest = null;
        LogIn200Response response = api.logIn(logInRequest);
        // TODO: test validations
    }

    /**
     * Given a public key, message and signature, verify if it is valid.
     *
     * Given a public key, message and signature, verify if it is valid.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void verifySignatureTest() throws ApiException {
        VerifySignatureRequest verifySignatureRequest = null;
        VerifySignature200Response response = api.verifySignature(verifySignatureRequest);
        // TODO: test validations
    }

    /**
     * Deletes all keys from the keychain.
     *
     * Deletes all keys from the keychain.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void walletDeleteAllKeysTest() throws ApiException {
        Object body = null;
        ModelApiResponse response = api.walletDeleteAllKeys(body);
        // TODO: test validations
    }

}
