/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftAddUriRequest;
import org.openapitools.client.model.NftCalculateRoyalties200Response;
import org.openapitools.client.model.NftCalculateRoyaltiesRequest;
import org.openapitools.client.model.NftCountNfts200Response;
import org.openapitools.client.model.NftGetByDid200Response;
import org.openapitools.client.model.NftGetByDidRequest;
import org.openapitools.client.model.NftGetInfo200Response;
import org.openapitools.client.model.NftGetInfoRequest;
import org.openapitools.client.model.NftGetNfts200Response;
import org.openapitools.client.model.NftGetNftsRequest;
import org.openapitools.client.model.NftGetWalletDid200Response;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.NftGetWalletsWithDids200Response;
import org.openapitools.client.model.NftMintBulk200Response;
import org.openapitools.client.model.NftMintBulkRequest;
import org.openapitools.client.model.NftMintNft200Response;
import org.openapitools.client.model.NftMintNftRequest;
import org.openapitools.client.model.NftSetDidBulk200Response;
import org.openapitools.client.model.NftSetDidBulkRequest;
import org.openapitools.client.model.NftSetNftDid200Response;
import org.openapitools.client.model.NftSetNftDidRequest;
import org.openapitools.client.model.NftSetNftStatusRequest;
import org.openapitools.client.model.NftTransferBulkRequest;
import org.openapitools.client.model.NftTransferNftRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for NftWalletApi
 */
@Disabled
public class NftWalletApiTest {

    private final NftWalletApi api = new NftWalletApi();

    /**
     * Adds an Uri to an NFT.
     *
     * Adds a Uri to an NFT.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftAddUriTest() throws ApiException {
        NftAddUriRequest nftAddUriRequest = null;
        NftSetNftDid200Response response = api.nftAddUri(nftAddUriRequest);
        // TODO: test validations
    }

    /**
     * Transfers an NFT to another address.
     *
     * Transfers an NFT to another address.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftCalculateRoyaltiesTest() throws ApiException {
        NftCalculateRoyaltiesRequest nftCalculateRoyaltiesRequest = null;
        NftCalculateRoyalties200Response response = api.nftCalculateRoyalties(nftCalculateRoyaltiesRequest);
        // TODO: test validations
    }

    /**
     * Retreives the number of NFTs in a wallet.
     *
     * Retreives the number of NFTs in a wallet
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftCountNftsTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        NftCountNfts200Response response = api.nftCountNfts(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Gets an NFT wallet by its DID.
     *
     * Gets an NFT wallet by its DID.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftGetByDidTest() throws ApiException {
        NftGetByDidRequest nftGetByDidRequest = null;
        NftGetByDid200Response response = api.nftGetByDid(nftGetByDidRequest);
        // TODO: test validations
    }

    /**
     * Gets info about an NFT.
     *
     * Gets info about an NFT.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftGetInfoTest() throws ApiException {
        NftGetInfoRequest nftGetInfoRequest = null;
        NftGetInfo200Response response = api.nftGetInfo(nftGetInfoRequest);
        // TODO: test validations
    }

    /**
     * Gets NFTs from a wallet.
     *
     * Gets NFTs from a wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftGetNftsTest() throws ApiException {
        NftGetNftsRequest nftGetNftsRequest = null;
        NftGetNfts200Response response = api.nftGetNfts(nftGetNftsRequest);
        // TODO: test validations
    }

    /**
     * Gets the DID for an NFT wallet.
     *
     * Gets the DID for an NFT wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftGetWalletDidTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        NftGetWalletDid200Response response = api.nftGetWalletDid(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Gets all the wallets with a DID.
     *
     * Gets all the wallets with a DID.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftGetWalletsWithDidsTest() throws ApiException {
        Object body = null;
        NftGetWalletsWithDids200Response response = api.nftGetWalletsWithDids(body);
        // TODO: test validations
    }

    /**
     * Mints NFTs in bulk.
     *
     * Mints NFTs in bulk.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftMintBulkTest() throws ApiException {
        NftMintBulkRequest nftMintBulkRequest = null;
        NftMintBulk200Response response = api.nftMintBulk(nftMintBulkRequest);
        // TODO: test validations
    }

    /**
     * Mints an NFT.
     *
     * Mints an NFT.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftMintNftTest() throws ApiException {
        NftMintNftRequest nftMintNftRequest = null;
        NftMintNft200Response response = api.nftMintNft(nftMintNftRequest);
        // TODO: test validations
    }

    /**
     * Bulk set DID for NFTs across different wallets.
     *
     * Bulk set DID for NFTs across different wallets
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftSetDidBulkTest() throws ApiException {
        NftSetDidBulkRequest nftSetDidBulkRequest = null;
        NftSetDidBulk200Response response = api.nftSetDidBulk(nftSetDidBulkRequest);
        // TODO: test validations
    }

    /**
     * Sets the DID of an NFT.
     *
     * Sets the DID of an NFT.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftSetNftDidTest() throws ApiException {
        NftSetNftDidRequest nftSetNftDidRequest = null;
        NftSetNftDid200Response response = api.nftSetNftDid(nftSetNftDidRequest);
        // TODO: test validations
    }

    /**
     * Sets the status of an NFT.
     *
     * Sets the status of an NFT.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftSetNftStatusTest() throws ApiException {
        NftSetNftStatusRequest nftSetNftStatusRequest = null;
        ModelApiResponse response = api.nftSetNftStatus(nftSetNftStatusRequest);
        // TODO: test validations
    }

    /**
     * Bulk transfer NFTs to an address.
     *
     * Bulk transfer NFTs to an address
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftTransferBulkTest() throws ApiException {
        NftTransferBulkRequest nftTransferBulkRequest = null;
        NftSetDidBulk200Response response = api.nftTransferBulk(nftTransferBulkRequest);
        // TODO: test validations
    }

    /**
     * Transfers an NFT to another address.
     *
     * Transfers an NFT to another address.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void nftTransferNftTest() throws ApiException {
        NftTransferNftRequest nftTransferNftRequest = null;
        NftSetNftDid200Response response = api.nftTransferNft(nftTransferNftRequest);
        // TODO: test validations
    }

}
