/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.DeleteNotificationsRequest;
import org.openapitools.client.model.GetNotifications200Response;
import org.openapitools.client.model.GetNotificationsRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.SendNotification200Response;
import org.openapitools.client.model.SendNotificationRequest;
import org.openapitools.client.model.SignMessageByAddress200Response;
import org.openapitools.client.model.SignMessageByAddressRequest;
import org.openapitools.client.model.SignMessageById200Response;
import org.openapitools.client.model.SignMessageByIdRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for NotificationsApi
 */
@Disabled
public class NotificationsApiTest {

    private final NotificationsApi api = new NotificationsApi();

    /**
     * Deletes notifications.
     *
     * Deletes notifications.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteNotificationsTest() throws ApiException {
        DeleteNotificationsRequest deleteNotificationsRequest = null;
        ModelApiResponse response = api.deleteNotifications(deleteNotificationsRequest);
        // TODO: test validations
    }

    /**
     * Retreives notifications.
     *
     * Retreives notifications.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getNotificationsTest() throws ApiException {
        GetNotificationsRequest getNotificationsRequest = null;
        GetNotifications200Response response = api.getNotifications(getNotificationsRequest);
        // TODO: test validations
    }

    /**
     * Sends a notification.
     *
     * Sends a notification.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void sendNotificationTest() throws ApiException {
        SendNotificationRequest sendNotificationRequest = null;
        SendNotification200Response response = api.sendNotification(sendNotificationRequest);
        // TODO: test validations
    }

    /**
     * Given a derived P2 address, sign the message by its private key.
     *
     * Given a derived P2 address, sign the message by its private key.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void signMessageByAddressTest() throws ApiException {
        SignMessageByAddressRequest signMessageByAddressRequest = null;
        SignMessageByAddress200Response response = api.signMessageByAddress(signMessageByAddressRequest);
        // TODO: test validations
    }

    /**
     * Given a NFT/DID ID, sign the message by the P2 private key.
     *
     * Given a NFT/DID ID, sign the message by the P2 private key.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void signMessageByIdTest() throws ApiException {
        SignMessageByIdRequest signMessageByIdRequest = null;
        SignMessageById200Response response = api.signMessageById(signMessageByIdRequest);
        // TODO: test validations
    }

}
