/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.PwAbsorbRewards200Response;
import org.openapitools.client.model.PwJoinPool200Response;
import org.openapitools.client.model.PwJoinPoolRequest;
import org.openapitools.client.model.PwSelfPoolRequest;
import org.openapitools.client.model.PwStatus200Response;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for PoolWalletApi
 */
@Disabled
public class PoolWalletApiTest {

    private final PoolWalletApi api = new PoolWalletApi();

    /**
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     *
     * Perform a sweep of the p2_singleton rewards controlled by the pool wallet singleton.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pwAbsorbRewardsTest() throws ApiException {
        PwSelfPoolRequest pwSelfPoolRequest = null;
        PwAbsorbRewards200Response response = api.pwAbsorbRewards(pwSelfPoolRequest);
        // TODO: test validations
    }

    /**
     * Joins the given wallet to a pool.
     *
     * Joins the given wallet to a pool.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pwJoinPoolTest() throws ApiException {
        PwJoinPoolRequest pwJoinPoolRequest = null;
        PwJoinPool200Response response = api.pwJoinPool(pwJoinPoolRequest);
        // TODO: test validations
    }

    /**
     * Removes the given wallet to a pool.
     *
     * Removes the given wallet to a pool.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pwSelfPoolTest() throws ApiException {
        PwSelfPoolRequest pwSelfPoolRequest = null;
        PwJoinPool200Response response = api.pwSelfPool(pwSelfPoolRequest);
        // TODO: test validations
    }

    /**
     * Return the complete state of the given Pool wallet.
     *
     * Return the complete state of the given Pool wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pwStatusTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        PwStatus200Response response = api.pwStatus(nftGetWalletDidRequest);
        // TODO: test validations
    }

}
