/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CreateSignedTransaction200Response;
import org.openapitools.client.model.CreateSignedTransactionRequest;
import org.openapitools.client.model.DidTransferDid200Response;
import org.openapitools.client.model.ExtendDerivationIndexRequest;
import org.openapitools.client.model.GetCurrentDerivationIndex200Response;
import org.openapitools.client.model.GetFarmedAmount200Response;
import org.openapitools.client.model.GetNextAddress200Response;
import org.openapitools.client.model.GetNextAddressRequest;
import org.openapitools.client.model.GetSpendableCoins200Response;
import org.openapitools.client.model.GetSpendableCoinsRequest;
import org.openapitools.client.model.GetTransactionCount200Response;
import org.openapitools.client.model.GetTransactionMemo200Response;
import org.openapitools.client.model.GetTransactionRequest;
import org.openapitools.client.model.GetTransactions200Response;
import org.openapitools.client.model.GetTransactionsRequest;
import org.openapitools.client.model.GetWalletBalance200Response;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.NftGetWalletDidRequest;
import org.openapitools.client.model.SendTransactionMultiRequest;
import org.openapitools.client.model.SendTransactionRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for WalletApi
 */
@Disabled
public class WalletApiTest {

    private final WalletApi api = new WalletApi();

    /**
     * Creates and signs a transaction.
     *
     * Creates and signs a transaction.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void createSignedTransactionTest() throws ApiException {
        CreateSignedTransactionRequest createSignedTransactionRequest = null;
        CreateSignedTransaction200Response response = api.createSignedTransaction(createSignedTransactionRequest);
        // TODO: test validations
    }

    /**
     * Delete all unconfirmed transactions for a given wallet.
     *
     * Delete all unconfirmed transactions for a given wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void deleteUnconfirmedTransactionsTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        ModelApiResponse response = api.deleteUnconfirmedTransactions(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Extends the current derivation index.
     *
     * Extends the current derivation index.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void extendDerivationIndexTest() throws ApiException {
        ExtendDerivationIndexRequest extendDerivationIndexRequest = null;
        GetCurrentDerivationIndex200Response response = api.extendDerivationIndex(extendDerivationIndexRequest);
        // TODO: test validations
    }

    /**
     * Gets the current derivation index.
     *
     * Gets the current derivation index.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getCurrentDerivationIndexTest() throws ApiException {
        Object body = null;
        GetCurrentDerivationIndex200Response response = api.getCurrentDerivationIndex(body);
        // TODO: test validations
    }

    /**
     * Retrieves the amount farmed.
     *
     * Retrieves the amount farmed.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getFarmedAmountTest() throws ApiException {
        Object body = null;
        GetFarmedAmount200Response response = api.getFarmedAmount(body);
        // TODO: test validations
    }

    /**
     * Returns a new address.
     *
     * Returns a new address.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getNextAddressTest() throws ApiException {
        GetNextAddressRequest getNextAddressRequest = null;
        GetNextAddress200Response response = api.getNextAddress(getNextAddressRequest);
        // TODO: test validations
    }

    /**
     * Retrieves all spendable coins in a wallet.
     *
     * Retrieves all spendable coins in a wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getSpendableCoinsTest() throws ApiException {
        GetSpendableCoinsRequest getSpendableCoinsRequest = null;
        GetSpendableCoins200Response response = api.getSpendableCoins(getSpendableCoinsRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a specific transaction.
     *
     * Retrieves a specific transaction.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getTransactionTest() throws ApiException {
        GetTransactionRequest getTransactionRequest = null;
        DidTransferDid200Response response = api.getTransaction(getTransactionRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the number of transactions for a wallet.
     *
     * Retrieves the number of transactions for a wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getTransactionCountTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        GetTransactionCount200Response response = api.getTransactionCount(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Retreives the memo from a transaction.
     *
     * Retreives the memo from a transaction
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getTransactionMemoTest() throws ApiException {
        GetTransactionRequest getTransactionRequest = null;
        GetTransactionMemo200Response response = api.getTransactionMemo(getTransactionRequest);
        // TODO: test validations
    }

    /**
     * Retrieves a list of trnsactions from a wallet.
     *
     * Retrieves a list of trnsactions from a wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getTransactionsTest() throws ApiException {
        GetTransactionsRequest getTransactionsRequest = null;
        GetTransactions200Response response = api.getTransactions(getTransactionsRequest);
        // TODO: test validations
    }

    /**
     * Retrieves the balance of a specific wallet.
     *
     * Retrieves the balance of a specific wallet (in units of mojos).
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getWalletBalanceTest() throws ApiException {
        NftGetWalletDidRequest nftGetWalletDidRequest = null;
        GetWalletBalance200Response response = api.getWalletBalance(nftGetWalletDidRequest);
        // TODO: test validations
    }

    /**
     * Sends an amount of mojo from the given wallet to the given address.
     *
     * Sends an amount of mojo from the given wallet to the given address.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void sendTransactionTest() throws ApiException {
        SendTransactionRequest sendTransactionRequest = null;
        DidTransferDid200Response response = api.sendTransaction(sendTransactionRequest);
        // TODO: test validations
    }

    /**
     * Sends multiple transactions from then given wallet.
     *
     * Sends multiple transactions from then given wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void sendTransactionMultiTest() throws ApiException {
        SendTransactionMultiRequest sendTransactionMultiRequest = null;
        DidTransferDid200Response response = api.sendTransactionMulti(sendTransactionMultiRequest);
        // TODO: test validations
    }

}
