/*
 * Chia RPC
 * The Chia node and services come with a JSON RPC API server that allows you to access information and control the services.  These are accessible via HTTPS, WebSockets, or via client SDKs. The ports can be configured in `~/.chia/mainnet/config/config.yaml`.  The RPC ports should not be exposed to the internet. TLS certificates are used to secure the communication  [using mutualTLS](https://github.com/dkackman/chia-api/wiki/Mutual-TLS). The wallet uses port 9256 by default.
 *
 * The version of the OpenAPI document: 1.7.1
 * Contact: hello@chia.net
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GetHeightInfo200Response;
import org.openapitools.client.model.GetSyncStatus200Response;
import org.openapitools.client.model.GetTimestampForHeight200Response;
import org.openapitools.client.model.GetTimestampForHeightRequest;
import org.openapitools.client.model.ModelApiResponse;
import org.openapitools.client.model.PushTransactionsRequest;
import org.openapitools.client.model.SetWalletResyncOnStartupRequest;
import org.openapitools.client.model.WalletGetNetworkInfo200Response;
import org.openapitools.client.model.WalletPushTxRequest;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for WalletNodeApi
 */
@Disabled
public class WalletNodeApiTest {

    private final WalletNodeApi api = new WalletNodeApi();

    /**
     * Retrieves the sync height of the wallet.
     *
     * Retrieves the sync height of the wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getHeightInfoTest() throws ApiException {
        Object body = null;
        GetHeightInfo200Response response = api.getHeightInfo(body);
        // TODO: test validations
    }

    /**
     * Retrieves the sync status of the wallet.
     *
     * Retrieves the sync status of the wallet.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getSyncStatusTest() throws ApiException {
        Object body = null;
        GetSyncStatus200Response response = api.getSyncStatus(body);
        // TODO: test validations
    }

    /**
     * Retreive the timestamp for a given block height.
     *
     * Retreive the timestamp for a given block height
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void getTimestampForHeightTest() throws ApiException {
        GetTimestampForHeightRequest getTimestampForHeightRequest = null;
        GetTimestampForHeight200Response response = api.getTimestampForHeight(getTimestampForHeightRequest);
        // TODO: test validations
    }

    /**
     * Pushes multiple transactions spend bundle to the mempool and blockchain.
     *
     * Pushes multiple transactions spend bundle to the mempool and blockchain.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void pushTransactionsTest() throws ApiException {
        PushTransactionsRequest pushTransactionsRequest = null;
        ModelApiResponse response = api.pushTransactions(pushTransactionsRequest);
        // TODO: test validations
    }

    /**
     * Resync the current logged in wallet. The transaction and offer records will be kept.
     *
     * Resync the current logged in wallet
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void setWalletResyncOnStartupTest() throws ApiException {
        SetWalletResyncOnStartupRequest setWalletResyncOnStartupRequest = null;
        ModelApiResponse response = api.setWalletResyncOnStartup(setWalletResyncOnStartupRequest);
        // TODO: test validations
    }

    /**
     * Retrieves some information about the current network.
     *
     * Retrieves some information about the current network.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void walletGetNetworkInfoTest() throws ApiException {
        Object body = null;
        WalletGetNetworkInfo200Response response = api.walletGetNetworkInfo(body);
        // TODO: test validations
    }

    /**
     * Pushes a transaction/spend bundle to the mempool and blockchain.
     *
     * Pushes a transaction/spend bundle to the mempool and blockchain. Returns whether the spend bundle was successfully included into the mempool.
     *
     * @throws ApiException if the Api call fails
     */
    @Test
    public void walletPushTxTest() throws ApiException {
        WalletPushTxRequest walletPushTxRequest = null;
        ModelApiResponse response = api.walletPushTx(walletPushTxRequest);
        // TODO: test validations
    }

}
